// DO NOT EDIT. Generated by tensorflow-op-codegen/src/main.rs.

/// Abort
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Abort>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Abort {
    error_msg: ::std::option::Option<::std::string::String>,
    exit_without_error: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Abort {
    fn default() -> Self {
        Self {
            error_msg: None,
            exit_without_error: Some(false),
            target_device_name: None,
        }
    }
}
impl Abort {
    /// Creates a new `Abort`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `error_msg` attribute.
    pub fn error_msg<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.error_msg = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `exit_without_error` attribute.
    pub fn exit_without_error<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.exit_without_error = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute abort.
    pub fn call<'a>(&self, ctx: &'a crate::eager::Context) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "Abort")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.error_msg {
            op.set_attr_string("error_msg", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.exit_without_error {
            op.set_attr_bool("exit_without_error", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `Abort::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Abort>
pub fn abort<'a>(ctx: &'a crate::eager::Context) -> crate::Result<()> {
    let op = Abort::new();
    op.call(ctx)
}

/// Abs
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Abs>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Abs {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Abs {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Abs {
    /// Creates a new `Abs`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute abs.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Abs")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Abs::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Abs>
pub fn abs<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Abs::new();
    op.call(ctx, x)
}

/// AccumulateNV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AccumulateNV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AccumulateNV2 {
    shape: ::std::option::Option<crate::Shape>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AccumulateNV2 {
    fn default() -> Self {
        Self {
            shape: None,
            target_device_name: None,
        }
    }
}
impl AccumulateNV2 {
    /// Creates a new `AccumulateNV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `shape` attribute.
    pub fn shape<ArgType: ::std::convert::Into<crate::Shape>>(mut self, value: ArgType) -> Self {
        self.shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute accumulate_nv2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        inputs: &[&T0],
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "AccumulateNV2")?;

        // Required input arguments
        let mut inputs_list = Vec::new();

        for t in inputs {
            inputs_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&inputs_list)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.shape {
            op.set_attr_shape("shape", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `AccumulateNV2::new().call(&ctx, &inputs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AccumulateNV2>
pub fn accumulate_nv2<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    inputs: &[&T0],
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = AccumulateNV2::new();
    op.call(ctx, inputs)
}

/// AccumulatorApplyGradient
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AccumulatorApplyGradient>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AccumulatorApplyGradient {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AccumulatorApplyGradient {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl AccumulatorApplyGradient {
    /// Creates a new `AccumulatorApplyGradient`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute accumulator_apply_gradient.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        local_step: &T1,
        gradient: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "AccumulatorApplyGradient")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&local_step.to_handle(ctx)?)?;
        op.add_input(&gradient.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `AccumulatorApplyGradient::new().call(&ctx, &handle, &local_step, &gradient)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AccumulatorApplyGradient>
pub fn accumulator_apply_gradient<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    local_step: &T1,
    gradient: &T2,
) -> crate::Result<()> {
    let op = AccumulatorApplyGradient::new();
    op.call(ctx, handle, local_step, gradient)
}

/// AccumulatorNumAccumulated
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AccumulatorNumAccumulated>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AccumulatorNumAccumulated {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AccumulatorNumAccumulated {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl AccumulatorNumAccumulated {
    /// Creates a new `AccumulatorNumAccumulated`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute accumulator_num_accumulated.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "AccumulatorNumAccumulated")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `AccumulatorNumAccumulated::new().call(&ctx, &handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AccumulatorNumAccumulated>
pub fn accumulator_num_accumulated<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = AccumulatorNumAccumulated::new();
    op.call(ctx, handle)
}

/// AccumulatorSetGlobalStep
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AccumulatorSetGlobalStep>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AccumulatorSetGlobalStep {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AccumulatorSetGlobalStep {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl AccumulatorSetGlobalStep {
    /// Creates a new `AccumulatorSetGlobalStep`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute accumulator_set_global_step.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        new_global_step: &T1,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "AccumulatorSetGlobalStep")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&new_global_step.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `AccumulatorSetGlobalStep::new().call(&ctx, &handle, &new_global_step)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AccumulatorSetGlobalStep>
pub fn accumulator_set_global_step<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    new_global_step: &T1,
) -> crate::Result<()> {
    let op = AccumulatorSetGlobalStep::new();
    op.call(ctx, handle, new_global_step)
}

/// AccumulatorTakeGradient
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AccumulatorTakeGradient>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AccumulatorTakeGradient {
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AccumulatorTakeGradient {
    fn default() -> Self {
        Self {
            dtype: None,
            target_device_name: None,
        }
    }
}
impl AccumulatorTakeGradient {
    /// Creates a new `AccumulatorTakeGradient`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute accumulator_take_gradient.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        num_required: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "AccumulatorTakeGradient")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&num_required.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `AccumulatorTakeGradient::new().call(&ctx, &handle, &num_required)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AccumulatorTakeGradient>
pub fn accumulator_take_gradient<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    num_required: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = AccumulatorTakeGradient::new();
    op.call(ctx, handle, num_required)
}

/// Acos
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Acos>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Acos {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Acos {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Acos {
    /// Creates a new `Acos`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute acos.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Acos")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Acos::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Acos>
pub fn acos<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Acos::new();
    op.call(ctx, x)
}

/// Acosh
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Acosh>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Acosh {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Acosh {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Acosh {
    /// Creates a new `Acosh`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute acosh.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Acosh")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Acosh::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Acosh>
pub fn acosh<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Acosh::new();
    op.call(ctx, x)
}

/// Add
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Add>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Add {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Add {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Add {
    /// Creates a new `Add`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute add.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Add")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Add::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Add>
pub fn add<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Add::new();
    op.call(ctx, x, y)
}

/// AddManySparseToTensorsMap
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AddManySparseToTensorsMap>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AddManySparseToTensorsMap {
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AddManySparseToTensorsMap {
    fn default() -> Self {
        Self {
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl AddManySparseToTensorsMap {
    /// Creates a new `AddManySparseToTensorsMap`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute add_many_sparse_to_tensors_map.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        sparse_indices: &T0,
        sparse_values: &T1,
        sparse_shape: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "AddManySparseToTensorsMap")?;

        // Required input arguments
        op.add_input(&sparse_indices.to_handle(ctx)?)?;
        op.add_input(&sparse_values.to_handle(ctx)?)?;
        op.add_input(&sparse_shape.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `AddManySparseToTensorsMap::new().call(&ctx, &sparse_indices, &sparse_values, &sparse_shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AddManySparseToTensorsMap>
pub fn add_many_sparse_to_tensors_map<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    sparse_indices: &T0,
    sparse_values: &T1,
    sparse_shape: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = AddManySparseToTensorsMap::new();
    op.call(ctx, sparse_indices, sparse_values, sparse_shape)
}

/// AddN
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AddN>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AddN {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AddN {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl AddN {
    /// Creates a new `AddN`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute add_n.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        inputs: &[&T0],
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "AddN")?;

        // Required input arguments
        let mut inputs_list = Vec::new();

        for t in inputs {
            inputs_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&inputs_list)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `AddN::new().call(&ctx, &inputs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AddN>
pub fn add_n<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    inputs: &[&T0],
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = AddN::new();
    op.call(ctx, inputs)
}

/// AddSparseToTensorsMap
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AddSparseToTensorsMap>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AddSparseToTensorsMap {
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AddSparseToTensorsMap {
    fn default() -> Self {
        Self {
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl AddSparseToTensorsMap {
    /// Creates a new `AddSparseToTensorsMap`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute add_sparse_to_tensors_map.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        sparse_indices: &T0,
        sparse_values: &T1,
        sparse_shape: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "AddSparseToTensorsMap")?;

        // Required input arguments
        op.add_input(&sparse_indices.to_handle(ctx)?)?;
        op.add_input(&sparse_values.to_handle(ctx)?)?;
        op.add_input(&sparse_shape.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `AddSparseToTensorsMap::new().call(&ctx, &sparse_indices, &sparse_values, &sparse_shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AddSparseToTensorsMap>
pub fn add_sparse_to_tensors_map<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    sparse_indices: &T0,
    sparse_values: &T1,
    sparse_shape: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = AddSparseToTensorsMap::new();
    op.call(ctx, sparse_indices, sparse_values, sparse_shape)
}

/// AddV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AddV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AddV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AddV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl AddV2 {
    /// Creates a new `AddV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute add_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "AddV2")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `AddV2::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AddV2>
pub fn add_v2<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = AddV2::new();
    op.call(ctx, x, y)
}

/// AdjustContrast
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AdjustContrast>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AdjustContrast {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AdjustContrast {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl AdjustContrast {
    /// Creates a new `AdjustContrast`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute adjust_contrast.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        images: &T0,
        contrast_factor: &T1,
        min_value: &T2,
        max_value: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "AdjustContrast")?;

        // Required input arguments
        op.add_input(&images.to_handle(ctx)?)?;
        op.add_input(&contrast_factor.to_handle(ctx)?)?;
        op.add_input(&min_value.to_handle(ctx)?)?;
        op.add_input(&max_value.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `AdjustContrast::new().call(&ctx, &images, &contrast_factor, &min_value, &max_value)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AdjustContrast>
pub fn adjust_contrast<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    images: &T0,
    contrast_factor: &T1,
    min_value: &T2,
    max_value: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = AdjustContrast::new();
    op.call(ctx, images, contrast_factor, min_value, max_value)
}

/// AdjustContrastv2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AdjustContrastv2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AdjustContrastv2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AdjustContrastv2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl AdjustContrastv2 {
    /// Creates a new `AdjustContrastv2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute adjust_contrastv2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        images: &T0,
        contrast_factor: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "AdjustContrastv2")?;

        // Required input arguments
        op.add_input(&images.to_handle(ctx)?)?;
        op.add_input(&contrast_factor.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `AdjustContrastv2::new().call(&ctx, &images, &contrast_factor)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AdjustContrastv2>
pub fn adjust_contrastv2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    images: &T0,
    contrast_factor: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = AdjustContrastv2::new();
    op.call(ctx, images, contrast_factor)
}

/// AdjustHue
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AdjustHue>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AdjustHue {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AdjustHue {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl AdjustHue {
    /// Creates a new `AdjustHue`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute adjust_hue.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        images: &T0,
        delta: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "AdjustHue")?;

        // Required input arguments
        op.add_input(&images.to_handle(ctx)?)?;
        op.add_input(&delta.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `AdjustHue::new().call(&ctx, &images, &delta)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AdjustHue>
pub fn adjust_hue<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    images: &T0,
    delta: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = AdjustHue::new();
    op.call(ctx, images, delta)
}

/// AdjustSaturation
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AdjustSaturation>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AdjustSaturation {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AdjustSaturation {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl AdjustSaturation {
    /// Creates a new `AdjustSaturation`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute adjust_saturation.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        images: &T0,
        scale: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "AdjustSaturation")?;

        // Required input arguments
        op.add_input(&images.to_handle(ctx)?)?;
        op.add_input(&scale.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `AdjustSaturation::new().call(&ctx, &images, &scale)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AdjustSaturation>
pub fn adjust_saturation<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    images: &T0,
    scale: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = AdjustSaturation::new();
    op.call(ctx, images, scale)
}

/// All
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/All>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct All {
    keep_dims: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for All {
    fn default() -> Self {
        Self {
            keep_dims: Some(false),
            target_device_name: None,
        }
    }
}
impl All {
    /// Creates a new `All`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `keep_dims` attribute.
    pub fn keep_dims<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.keep_dims = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute all.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        reduction_indices: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "All")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&reduction_indices.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.keep_dims {
            op.set_attr_bool("keep_dims", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `All::new().call(&ctx, &input, &reduction_indices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/All>
pub fn all<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    reduction_indices: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = All::new();
    op.call(ctx, input, reduction_indices)
}

/// AllCandidateSampler
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AllCandidateSampler>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AllCandidateSampler {
    num_true: ::std::option::Option<i64>,
    num_sampled: ::std::option::Option<i64>,
    unique: ::std::option::Option<bool>,
    seed: ::std::option::Option<i64>,
    seed2: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AllCandidateSampler {
    fn default() -> Self {
        Self {
            num_true: None,
            num_sampled: None,
            unique: None,
            seed: Some(0i64),
            seed2: Some(0i64),
            target_device_name: None,
        }
    }
}
impl AllCandidateSampler {
    /// Creates a new `AllCandidateSampler`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_true` attribute.
    pub fn num_true<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_true = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_sampled` attribute.
    pub fn num_sampled<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_sampled = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `unique` attribute.
    pub fn unique<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.unique = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed` attribute.
    pub fn seed<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed2` attribute.
    pub fn seed2<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute all_candidate_sampler.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        true_classes: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "AllCandidateSampler")?;

        // Required input arguments
        op.add_input(&true_classes.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_true {
            op.set_attr_int("num_true", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_sampled {
            op.set_attr_int("num_sampled", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.unique {
            op.set_attr_bool("unique", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed {
            op.set_attr_int("seed", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed2 {
            op.set_attr_int("seed2", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `AllCandidateSampler::new().call(&ctx, &true_classes)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AllCandidateSampler>
pub fn all_candidate_sampler<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    true_classes: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = AllCandidateSampler::new();
    op.call(ctx, true_classes)
}

/// AllToAll
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AllToAll>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AllToAll {
    concat_dimension: ::std::option::Option<i64>,
    split_dimension: ::std::option::Option<i64>,
    split_count: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AllToAll {
    fn default() -> Self {
        Self {
            concat_dimension: None,
            split_dimension: None,
            split_count: None,
            target_device_name: None,
        }
    }
}
impl AllToAll {
    /// Creates a new `AllToAll`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `concat_dimension` attribute.
    pub fn concat_dimension<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.concat_dimension = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `split_dimension` attribute.
    pub fn split_dimension<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.split_dimension = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `split_count` attribute.
    pub fn split_count<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.split_count = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute all_to_all.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        group_assignment: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "AllToAll")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&group_assignment.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.concat_dimension {
            op.set_attr_int("concat_dimension", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.split_dimension {
            op.set_attr_int("split_dimension", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.split_count {
            op.set_attr_int("split_count", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `AllToAll::new().call(&ctx, &input, &group_assignment)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AllToAll>
pub fn all_to_all<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    group_assignment: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = AllToAll::new();
    op.call(ctx, input, group_assignment)
}

/// Angle
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Angle>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Angle {
    Tout: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Angle {
    fn default() -> Self {
        Self {
            Tout: Some(crate::DataType::Float),
            target_device_name: None,
        }
    }
}
impl Angle {
    /// Creates a new `Angle`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Tout` attribute.
    pub fn Tout<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.Tout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute angle.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Angle")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Tout {
            op.set_attr_type("Tout", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Angle::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Angle>
pub fn angle<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Angle::new();
    op.call(ctx, input)
}

/// AnonymousHashTable
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AnonymousHashTable>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AnonymousHashTable {
    key_dtype: ::std::option::Option<crate::DataType>,
    value_dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AnonymousHashTable {
    fn default() -> Self {
        Self {
            key_dtype: None,
            value_dtype: None,
            target_device_name: None,
        }
    }
}
impl AnonymousHashTable {
    /// Creates a new `AnonymousHashTable`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `key_dtype` attribute.
    pub fn key_dtype<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.key_dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `value_dtype` attribute.
    pub fn value_dtype<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.value_dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute anonymous_hash_table.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "AnonymousHashTable")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.key_dtype {
            op.set_attr_type("key_dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.value_dtype {
            op.set_attr_type("value_dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `AnonymousHashTable::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AnonymousHashTable>
pub fn anonymous_hash_table<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = AnonymousHashTable::new();
    op.call(ctx)
}

/// AnonymousIterator
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AnonymousIterator>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AnonymousIterator {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AnonymousIterator {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl AnonymousIterator {
    /// Creates a new `AnonymousIterator`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute anonymous_iterator.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "AnonymousIterator")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `AnonymousIterator::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AnonymousIterator>
pub fn anonymous_iterator<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = AnonymousIterator::new();
    op.call(ctx)
}

/// AnonymousIteratorV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AnonymousIteratorV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AnonymousIteratorV2 {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AnonymousIteratorV2 {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl AnonymousIteratorV2 {
    /// Creates a new `AnonymousIteratorV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute anonymous_iterator_v2.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "AnonymousIteratorV2")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `AnonymousIteratorV2::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AnonymousIteratorV2>
pub fn anonymous_iterator_v2<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = AnonymousIteratorV2::new();
    op.call(ctx)
}

/// AnonymousIteratorV3
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AnonymousIteratorV3>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AnonymousIteratorV3 {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AnonymousIteratorV3 {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl AnonymousIteratorV3 {
    /// Creates a new `AnonymousIteratorV3`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute anonymous_iterator_v3.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "AnonymousIteratorV3")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `AnonymousIteratorV3::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AnonymousIteratorV3>
pub fn anonymous_iterator_v3<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = AnonymousIteratorV3::new();
    op.call(ctx)
}

/// AnonymousMemoryCache
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AnonymousMemoryCache>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AnonymousMemoryCache {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AnonymousMemoryCache {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl AnonymousMemoryCache {
    /// Creates a new `AnonymousMemoryCache`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute anonymous_memory_cache.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "AnonymousMemoryCache")?;

        // Required input arguments

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `AnonymousMemoryCache::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AnonymousMemoryCache>
pub fn anonymous_memory_cache<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = AnonymousMemoryCache::new();
    op.call(ctx)
}

/// AnonymousMultiDeviceIterator
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AnonymousMultiDeviceIterator>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AnonymousMultiDeviceIterator {
    devices: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AnonymousMultiDeviceIterator {
    fn default() -> Self {
        Self {
            devices: None,
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl AnonymousMultiDeviceIterator {
    /// Creates a new `AnonymousMultiDeviceIterator`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `devices` attribute.
    pub fn devices<ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.devices = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute anonymous_multi_device_iterator.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "AnonymousMultiDeviceIterator")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.devices {
            op.set_attr_string_list("devices", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `AnonymousMultiDeviceIterator::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AnonymousMultiDeviceIterator>
pub fn anonymous_multi_device_iterator<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = AnonymousMultiDeviceIterator::new();
    op.call(ctx)
}

/// AnonymousMultiDeviceIteratorV3
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AnonymousMultiDeviceIteratorV3>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AnonymousMultiDeviceIteratorV3 {
    devices: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AnonymousMultiDeviceIteratorV3 {
    fn default() -> Self {
        Self {
            devices: None,
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl AnonymousMultiDeviceIteratorV3 {
    /// Creates a new `AnonymousMultiDeviceIteratorV3`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `devices` attribute.
    pub fn devices<ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.devices = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute anonymous_multi_device_iterator_v3.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "AnonymousMultiDeviceIteratorV3")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.devices {
            op.set_attr_string_list("devices", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `AnonymousMultiDeviceIteratorV3::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AnonymousMultiDeviceIteratorV3>
pub fn anonymous_multi_device_iterator_v3<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = AnonymousMultiDeviceIteratorV3::new();
    op.call(ctx)
}

/// AnonymousMutableDenseHashTable
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AnonymousMutableDenseHashTable>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AnonymousMutableDenseHashTable {
    value_dtype: ::std::option::Option<crate::DataType>,
    value_shape: ::std::option::Option<crate::Shape>,
    initial_num_buckets: ::std::option::Option<i64>,
    max_load_factor: ::std::option::Option<f32>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AnonymousMutableDenseHashTable {
    fn default() -> Self {
        Self {
            value_dtype: None,
            value_shape: None,
            initial_num_buckets: Some(131072i64),
            max_load_factor: Some(0.8f32),
            target_device_name: None,
        }
    }
}
impl AnonymousMutableDenseHashTable {
    /// Creates a new `AnonymousMutableDenseHashTable`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `value_dtype` attribute.
    pub fn value_dtype<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.value_dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `value_shape` attribute.
    pub fn value_shape<ArgType: ::std::convert::Into<crate::Shape>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.value_shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `initial_num_buckets` attribute.
    pub fn initial_num_buckets<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.initial_num_buckets = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `max_load_factor` attribute.
    pub fn max_load_factor<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.max_load_factor = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute anonymous_mutable_dense_hash_table.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        empty_key: &T0,
        deleted_key: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "AnonymousMutableDenseHashTable")?;

        // Required input arguments
        op.add_input(&empty_key.to_handle(ctx)?)?;
        op.add_input(&deleted_key.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.value_dtype {
            op.set_attr_type("value_dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.value_shape {
            op.set_attr_shape("value_shape", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.initial_num_buckets {
            op.set_attr_int("initial_num_buckets", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.max_load_factor {
            op.set_attr_float("max_load_factor", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `AnonymousMutableDenseHashTable::new().call(&ctx, &empty_key, &deleted_key)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AnonymousMutableDenseHashTable>
pub fn anonymous_mutable_dense_hash_table<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    empty_key: &T0,
    deleted_key: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = AnonymousMutableDenseHashTable::new();
    op.call(ctx, empty_key, deleted_key)
}

/// AnonymousMutableHashTable
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AnonymousMutableHashTable>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AnonymousMutableHashTable {
    key_dtype: ::std::option::Option<crate::DataType>,
    value_dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AnonymousMutableHashTable {
    fn default() -> Self {
        Self {
            key_dtype: None,
            value_dtype: None,
            target_device_name: None,
        }
    }
}
impl AnonymousMutableHashTable {
    /// Creates a new `AnonymousMutableHashTable`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `key_dtype` attribute.
    pub fn key_dtype<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.key_dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `value_dtype` attribute.
    pub fn value_dtype<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.value_dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute anonymous_mutable_hash_table.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "AnonymousMutableHashTable")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.key_dtype {
            op.set_attr_type("key_dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.value_dtype {
            op.set_attr_type("value_dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `AnonymousMutableHashTable::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AnonymousMutableHashTable>
pub fn anonymous_mutable_hash_table<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = AnonymousMutableHashTable::new();
    op.call(ctx)
}

/// AnonymousMutableHashTableOfTensors
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AnonymousMutableHashTableOfTensors>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AnonymousMutableHashTableOfTensors {
    key_dtype: ::std::option::Option<crate::DataType>,
    value_dtype: ::std::option::Option<crate::DataType>,
    value_shape: ::std::option::Option<crate::Shape>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AnonymousMutableHashTableOfTensors {
    fn default() -> Self {
        Self {
            key_dtype: None,
            value_dtype: None,
            value_shape: None,
            target_device_name: None,
        }
    }
}
impl AnonymousMutableHashTableOfTensors {
    /// Creates a new `AnonymousMutableHashTableOfTensors`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `key_dtype` attribute.
    pub fn key_dtype<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.key_dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `value_dtype` attribute.
    pub fn value_dtype<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.value_dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `value_shape` attribute.
    pub fn value_shape<ArgType: ::std::convert::Into<crate::Shape>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.value_shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute anonymous_mutable_hash_table_of_tensors.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "AnonymousMutableHashTableOfTensors")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.key_dtype {
            op.set_attr_type("key_dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.value_dtype {
            op.set_attr_type("value_dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.value_shape {
            op.set_attr_shape("value_shape", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `AnonymousMutableHashTableOfTensors::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AnonymousMutableHashTableOfTensors>
pub fn anonymous_mutable_hash_table_of_tensors<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = AnonymousMutableHashTableOfTensors::new();
    op.call(ctx)
}

/// AnonymousRandomSeedGenerator
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AnonymousRandomSeedGenerator>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AnonymousRandomSeedGenerator {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AnonymousRandomSeedGenerator {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl AnonymousRandomSeedGenerator {
    /// Creates a new `AnonymousRandomSeedGenerator`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute anonymous_random_seed_generator.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        seed: &T0,
        seed2: &T1,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "AnonymousRandomSeedGenerator")?;

        // Required input arguments
        op.add_input(&seed.to_handle(ctx)?)?;
        op.add_input(&seed2.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `AnonymousRandomSeedGenerator::new().call(&ctx, &seed, &seed2)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AnonymousRandomSeedGenerator>
pub fn anonymous_random_seed_generator<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    seed: &T0,
    seed2: &T1,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = AnonymousRandomSeedGenerator::new();
    op.call(ctx, seed, seed2)
}

/// AnonymousSeedGenerator
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AnonymousSeedGenerator>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AnonymousSeedGenerator {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AnonymousSeedGenerator {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl AnonymousSeedGenerator {
    /// Creates a new `AnonymousSeedGenerator`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute anonymous_seed_generator.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        seed: &T0,
        seed2: &T1,
        reshuffle: &T2,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "AnonymousSeedGenerator")?;

        // Required input arguments
        op.add_input(&seed.to_handle(ctx)?)?;
        op.add_input(&seed2.to_handle(ctx)?)?;
        op.add_input(&reshuffle.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `AnonymousSeedGenerator::new().call(&ctx, &seed, &seed2, &reshuffle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AnonymousSeedGenerator>
pub fn anonymous_seed_generator<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    seed: &T0,
    seed2: &T1,
    reshuffle: &T2,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = AnonymousSeedGenerator::new();
    op.call(ctx, seed, seed2, reshuffle)
}

/// Any
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Any>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Any {
    keep_dims: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Any {
    fn default() -> Self {
        Self {
            keep_dims: Some(false),
            target_device_name: None,
        }
    }
}
impl Any {
    /// Creates a new `Any`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `keep_dims` attribute.
    pub fn keep_dims<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.keep_dims = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute any.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        reduction_indices: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Any")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&reduction_indices.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.keep_dims {
            op.set_attr_bool("keep_dims", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Any::new().call(&ctx, &input, &reduction_indices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Any>
pub fn any<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    reduction_indices: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Any::new();
    op.call(ctx, input, reduction_indices)
}

/// ApplyAdaMax
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ApplyAdaMax>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ApplyAdaMax {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ApplyAdaMax {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl ApplyAdaMax {
    /// Creates a new `ApplyAdaMax`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute apply_ada_max.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        m: &T1,
        v: &T2,
        beta1_power: &T3,
        lr: &T4,
        beta1: &T5,
        beta2: &T6,
        epsilon: &T7,
        grad: &T8,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ApplyAdaMax")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&m.to_handle(ctx)?)?;
        op.add_input(&v.to_handle(ctx)?)?;
        op.add_input(&beta1_power.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&beta1.to_handle(ctx)?)?;
        op.add_input(&beta2.to_handle(ctx)?)?;
        op.add_input(&epsilon.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ApplyAdaMax::new().call(&ctx, &var, &m, &v, &beta1_power, &lr, &beta1, &beta2, &epsilon, &grad)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ApplyAdaMax>
pub fn apply_ada_max<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    m: &T1,
    v: &T2,
    beta1_power: &T3,
    lr: &T4,
    beta1: &T5,
    beta2: &T6,
    epsilon: &T7,
    grad: &T8,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ApplyAdaMax::new();
    op.call(ctx, var, m, v, beta1_power, lr, beta1, beta2, epsilon, grad)
}

/// ApplyAdadelta
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ApplyAdadelta>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ApplyAdadelta {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ApplyAdadelta {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl ApplyAdadelta {
    /// Creates a new `ApplyAdadelta`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute apply_adadelta.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        accum: &T1,
        accum_update: &T2,
        lr: &T3,
        rho: &T4,
        epsilon: &T5,
        grad: &T6,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ApplyAdadelta")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&accum.to_handle(ctx)?)?;
        op.add_input(&accum_update.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&rho.to_handle(ctx)?)?;
        op.add_input(&epsilon.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ApplyAdadelta::new().call(&ctx, &var, &accum, &accum_update, &lr, &rho, &epsilon, &grad)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ApplyAdadelta>
pub fn apply_adadelta<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    accum: &T1,
    accum_update: &T2,
    lr: &T3,
    rho: &T4,
    epsilon: &T5,
    grad: &T6,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ApplyAdadelta::new();
    op.call(ctx, var, accum, accum_update, lr, rho, epsilon, grad)
}

/// ApplyAdagrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ApplyAdagrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ApplyAdagrad {
    use_locking: ::std::option::Option<bool>,
    update_slots: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ApplyAdagrad {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            update_slots: Some(true),
            target_device_name: None,
        }
    }
}
impl ApplyAdagrad {
    /// Creates a new `ApplyAdagrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `update_slots` attribute.
    pub fn update_slots<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.update_slots = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute apply_adagrad.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        accum: &T1,
        lr: &T2,
        grad: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ApplyAdagrad")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&accum.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.update_slots {
            op.set_attr_bool("update_slots", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ApplyAdagrad::new().call(&ctx, &var, &accum, &lr, &grad)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ApplyAdagrad>
pub fn apply_adagrad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    accum: &T1,
    lr: &T2,
    grad: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ApplyAdagrad::new();
    op.call(ctx, var, accum, lr, grad)
}

/// ApplyAdagradDA
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ApplyAdagradDA>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ApplyAdagradDA {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ApplyAdagradDA {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl ApplyAdagradDA {
    /// Creates a new `ApplyAdagradDA`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute apply_adagrad_da.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        gradient_accumulator: &T1,
        gradient_squared_accumulator: &T2,
        grad: &T3,
        lr: &T4,
        l1: &T5,
        l2: &T6,
        global_step: &T7,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ApplyAdagradDA")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&gradient_accumulator.to_handle(ctx)?)?;
        op.add_input(&gradient_squared_accumulator.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&l1.to_handle(ctx)?)?;
        op.add_input(&l2.to_handle(ctx)?)?;
        op.add_input(&global_step.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ApplyAdagradDA::new().call(&ctx, &var, &gradient_accumulator, &gradient_squared_accumulator, &grad, &lr, &l1, &l2, &global_step)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ApplyAdagradDA>
pub fn apply_adagrad_da<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    gradient_accumulator: &T1,
    gradient_squared_accumulator: &T2,
    grad: &T3,
    lr: &T4,
    l1: &T5,
    l2: &T6,
    global_step: &T7,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ApplyAdagradDA::new();
    op.call(
        ctx,
        var,
        gradient_accumulator,
        gradient_squared_accumulator,
        grad,
        lr,
        l1,
        l2,
        global_step,
    )
}

/// ApplyAdagradV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ApplyAdagradV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ApplyAdagradV2 {
    use_locking: ::std::option::Option<bool>,
    update_slots: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ApplyAdagradV2 {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            update_slots: Some(true),
            target_device_name: None,
        }
    }
}
impl ApplyAdagradV2 {
    /// Creates a new `ApplyAdagradV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `update_slots` attribute.
    pub fn update_slots<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.update_slots = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute apply_adagrad_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        accum: &T1,
        lr: &T2,
        epsilon: &T3,
        grad: &T4,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ApplyAdagradV2")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&accum.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&epsilon.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.update_slots {
            op.set_attr_bool("update_slots", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ApplyAdagradV2::new().call(&ctx, &var, &accum, &lr, &epsilon, &grad)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ApplyAdagradV2>
pub fn apply_adagrad_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    accum: &T1,
    lr: &T2,
    epsilon: &T3,
    grad: &T4,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ApplyAdagradV2::new();
    op.call(ctx, var, accum, lr, epsilon, grad)
}

/// ApplyAdam
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ApplyAdam>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ApplyAdam {
    use_locking: ::std::option::Option<bool>,
    use_nesterov: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ApplyAdam {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            use_nesterov: Some(false),
            target_device_name: None,
        }
    }
}
impl ApplyAdam {
    /// Creates a new `ApplyAdam`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_nesterov` attribute.
    pub fn use_nesterov<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_nesterov = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute apply_adam.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
        T9: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        m: &T1,
        v: &T2,
        beta1_power: &T3,
        beta2_power: &T4,
        lr: &T5,
        beta1: &T6,
        beta2: &T7,
        epsilon: &T8,
        grad: &T9,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ApplyAdam")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&m.to_handle(ctx)?)?;
        op.add_input(&v.to_handle(ctx)?)?;
        op.add_input(&beta1_power.to_handle(ctx)?)?;
        op.add_input(&beta2_power.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&beta1.to_handle(ctx)?)?;
        op.add_input(&beta2.to_handle(ctx)?)?;
        op.add_input(&epsilon.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_nesterov {
            op.set_attr_bool("use_nesterov", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ApplyAdam::new().call(&ctx, &var, &m, &v, &beta1_power, &beta2_power, &lr, &beta1, &beta2, &epsilon, &grad)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ApplyAdam>
pub fn apply_adam<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
    T9: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    m: &T1,
    v: &T2,
    beta1_power: &T3,
    beta2_power: &T4,
    lr: &T5,
    beta1: &T6,
    beta2: &T7,
    epsilon: &T8,
    grad: &T9,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ApplyAdam::new();
    op.call(
        ctx,
        var,
        m,
        v,
        beta1_power,
        beta2_power,
        lr,
        beta1,
        beta2,
        epsilon,
        grad,
    )
}

/// ApplyAddSign
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ApplyAddSign>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ApplyAddSign {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ApplyAddSign {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl ApplyAddSign {
    /// Creates a new `ApplyAddSign`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute apply_add_sign.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        m: &T1,
        lr: &T2,
        alpha: &T3,
        sign_decay: &T4,
        beta: &T5,
        grad: &T6,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ApplyAddSign")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&m.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&alpha.to_handle(ctx)?)?;
        op.add_input(&sign_decay.to_handle(ctx)?)?;
        op.add_input(&beta.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ApplyAddSign::new().call(&ctx, &var, &m, &lr, &alpha, &sign_decay, &beta, &grad)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ApplyAddSign>
pub fn apply_add_sign<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    m: &T1,
    lr: &T2,
    alpha: &T3,
    sign_decay: &T4,
    beta: &T5,
    grad: &T6,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ApplyAddSign::new();
    op.call(ctx, var, m, lr, alpha, sign_decay, beta, grad)
}

/// ApplyCenteredRMSProp
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ApplyCenteredRMSProp>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ApplyCenteredRMSProp {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ApplyCenteredRMSProp {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl ApplyCenteredRMSProp {
    /// Creates a new `ApplyCenteredRMSProp`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute apply_centered_rmsprop.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        mg: &T1,
        ms: &T2,
        mom: &T3,
        lr: &T4,
        rho: &T5,
        momentum: &T6,
        epsilon: &T7,
        grad: &T8,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ApplyCenteredRMSProp")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&mg.to_handle(ctx)?)?;
        op.add_input(&ms.to_handle(ctx)?)?;
        op.add_input(&mom.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&rho.to_handle(ctx)?)?;
        op.add_input(&momentum.to_handle(ctx)?)?;
        op.add_input(&epsilon.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ApplyCenteredRMSProp::new().call(&ctx, &var, &mg, &ms, &mom, &lr, &rho, &momentum, &epsilon, &grad)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ApplyCenteredRMSProp>
pub fn apply_centered_rmsprop<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    mg: &T1,
    ms: &T2,
    mom: &T3,
    lr: &T4,
    rho: &T5,
    momentum: &T6,
    epsilon: &T7,
    grad: &T8,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ApplyCenteredRMSProp::new();
    op.call(ctx, var, mg, ms, mom, lr, rho, momentum, epsilon, grad)
}

/// ApplyFtrl
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ApplyFtrl>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ApplyFtrl {
    use_locking: ::std::option::Option<bool>,
    multiply_linear_by_lr: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ApplyFtrl {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            multiply_linear_by_lr: Some(false),
            target_device_name: None,
        }
    }
}
impl ApplyFtrl {
    /// Creates a new `ApplyFtrl`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `multiply_linear_by_lr` attribute.
    pub fn multiply_linear_by_lr<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.multiply_linear_by_lr = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute apply_ftrl.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        accum: &T1,
        linear: &T2,
        grad: &T3,
        lr: &T4,
        l1: &T5,
        l2: &T6,
        lr_power: &T7,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ApplyFtrl")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&accum.to_handle(ctx)?)?;
        op.add_input(&linear.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&l1.to_handle(ctx)?)?;
        op.add_input(&l2.to_handle(ctx)?)?;
        op.add_input(&lr_power.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.multiply_linear_by_lr {
            op.set_attr_bool("multiply_linear_by_lr", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ApplyFtrl::new().call(&ctx, &var, &accum, &linear, &grad, &lr, &l1, &l2, &lr_power)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ApplyFtrl>
pub fn apply_ftrl<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    accum: &T1,
    linear: &T2,
    grad: &T3,
    lr: &T4,
    l1: &T5,
    l2: &T6,
    lr_power: &T7,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ApplyFtrl::new();
    op.call(ctx, var, accum, linear, grad, lr, l1, l2, lr_power)
}

/// ApplyFtrlV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ApplyFtrlV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ApplyFtrlV2 {
    use_locking: ::std::option::Option<bool>,
    multiply_linear_by_lr: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ApplyFtrlV2 {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            multiply_linear_by_lr: Some(false),
            target_device_name: None,
        }
    }
}
impl ApplyFtrlV2 {
    /// Creates a new `ApplyFtrlV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `multiply_linear_by_lr` attribute.
    pub fn multiply_linear_by_lr<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.multiply_linear_by_lr = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute apply_ftrl_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        accum: &T1,
        linear: &T2,
        grad: &T3,
        lr: &T4,
        l1: &T5,
        l2: &T6,
        l2_shrinkage: &T7,
        lr_power: &T8,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ApplyFtrlV2")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&accum.to_handle(ctx)?)?;
        op.add_input(&linear.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&l1.to_handle(ctx)?)?;
        op.add_input(&l2.to_handle(ctx)?)?;
        op.add_input(&l2_shrinkage.to_handle(ctx)?)?;
        op.add_input(&lr_power.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.multiply_linear_by_lr {
            op.set_attr_bool("multiply_linear_by_lr", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ApplyFtrlV2::new().call(&ctx, &var, &accum, &linear, &grad, &lr, &l1, &l2, &l2_shrinkage, &lr_power)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ApplyFtrlV2>
pub fn apply_ftrl_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    accum: &T1,
    linear: &T2,
    grad: &T3,
    lr: &T4,
    l1: &T5,
    l2: &T6,
    l2_shrinkage: &T7,
    lr_power: &T8,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ApplyFtrlV2::new();
    op.call(
        ctx,
        var,
        accum,
        linear,
        grad,
        lr,
        l1,
        l2,
        l2_shrinkage,
        lr_power,
    )
}

/// ApplyGradientDescent
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ApplyGradientDescent>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ApplyGradientDescent {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ApplyGradientDescent {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl ApplyGradientDescent {
    /// Creates a new `ApplyGradientDescent`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute apply_gradient_descent.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        alpha: &T1,
        delta: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ApplyGradientDescent")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&alpha.to_handle(ctx)?)?;
        op.add_input(&delta.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ApplyGradientDescent::new().call(&ctx, &var, &alpha, &delta)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ApplyGradientDescent>
pub fn apply_gradient_descent<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    alpha: &T1,
    delta: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ApplyGradientDescent::new();
    op.call(ctx, var, alpha, delta)
}

/// ApplyMomentum
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ApplyMomentum>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ApplyMomentum {
    use_locking: ::std::option::Option<bool>,
    use_nesterov: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ApplyMomentum {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            use_nesterov: Some(false),
            target_device_name: None,
        }
    }
}
impl ApplyMomentum {
    /// Creates a new `ApplyMomentum`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_nesterov` attribute.
    pub fn use_nesterov<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_nesterov = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute apply_momentum.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        accum: &T1,
        lr: &T2,
        grad: &T3,
        momentum: &T4,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ApplyMomentum")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&accum.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&momentum.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_nesterov {
            op.set_attr_bool("use_nesterov", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ApplyMomentum::new().call(&ctx, &var, &accum, &lr, &grad, &momentum)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ApplyMomentum>
pub fn apply_momentum<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    accum: &T1,
    lr: &T2,
    grad: &T3,
    momentum: &T4,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ApplyMomentum::new();
    op.call(ctx, var, accum, lr, grad, momentum)
}

/// ApplyPowerSign
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ApplyPowerSign>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ApplyPowerSign {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ApplyPowerSign {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl ApplyPowerSign {
    /// Creates a new `ApplyPowerSign`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute apply_power_sign.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        m: &T1,
        lr: &T2,
        logbase: &T3,
        sign_decay: &T4,
        beta: &T5,
        grad: &T6,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ApplyPowerSign")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&m.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&logbase.to_handle(ctx)?)?;
        op.add_input(&sign_decay.to_handle(ctx)?)?;
        op.add_input(&beta.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ApplyPowerSign::new().call(&ctx, &var, &m, &lr, &logbase, &sign_decay, &beta, &grad)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ApplyPowerSign>
pub fn apply_power_sign<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    m: &T1,
    lr: &T2,
    logbase: &T3,
    sign_decay: &T4,
    beta: &T5,
    grad: &T6,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ApplyPowerSign::new();
    op.call(ctx, var, m, lr, logbase, sign_decay, beta, grad)
}

/// ApplyProximalAdagrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ApplyProximalAdagrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ApplyProximalAdagrad {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ApplyProximalAdagrad {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl ApplyProximalAdagrad {
    /// Creates a new `ApplyProximalAdagrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute apply_proximal_adagrad.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        accum: &T1,
        lr: &T2,
        l1: &T3,
        l2: &T4,
        grad: &T5,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ApplyProximalAdagrad")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&accum.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&l1.to_handle(ctx)?)?;
        op.add_input(&l2.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ApplyProximalAdagrad::new().call(&ctx, &var, &accum, &lr, &l1, &l2, &grad)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ApplyProximalAdagrad>
pub fn apply_proximal_adagrad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    accum: &T1,
    lr: &T2,
    l1: &T3,
    l2: &T4,
    grad: &T5,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ApplyProximalAdagrad::new();
    op.call(ctx, var, accum, lr, l1, l2, grad)
}

/// ApplyProximalGradientDescent
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ApplyProximalGradientDescent>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ApplyProximalGradientDescent {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ApplyProximalGradientDescent {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl ApplyProximalGradientDescent {
    /// Creates a new `ApplyProximalGradientDescent`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute apply_proximal_gradient_descent.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        alpha: &T1,
        l1: &T2,
        l2: &T3,
        delta: &T4,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ApplyProximalGradientDescent")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&alpha.to_handle(ctx)?)?;
        op.add_input(&l1.to_handle(ctx)?)?;
        op.add_input(&l2.to_handle(ctx)?)?;
        op.add_input(&delta.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ApplyProximalGradientDescent::new().call(&ctx, &var, &alpha, &l1, &l2, &delta)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ApplyProximalGradientDescent>
pub fn apply_proximal_gradient_descent<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    alpha: &T1,
    l1: &T2,
    l2: &T3,
    delta: &T4,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ApplyProximalGradientDescent::new();
    op.call(ctx, var, alpha, l1, l2, delta)
}

/// ApplyRMSProp
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ApplyRMSProp>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ApplyRMSProp {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ApplyRMSProp {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl ApplyRMSProp {
    /// Creates a new `ApplyRMSProp`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute apply_rmsprop.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        ms: &T1,
        mom: &T2,
        lr: &T3,
        rho: &T4,
        momentum: &T5,
        epsilon: &T6,
        grad: &T7,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ApplyRMSProp")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&ms.to_handle(ctx)?)?;
        op.add_input(&mom.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&rho.to_handle(ctx)?)?;
        op.add_input(&momentum.to_handle(ctx)?)?;
        op.add_input(&epsilon.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ApplyRMSProp::new().call(&ctx, &var, &ms, &mom, &lr, &rho, &momentum, &epsilon, &grad)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ApplyRMSProp>
pub fn apply_rmsprop<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    ms: &T1,
    mom: &T2,
    lr: &T3,
    rho: &T4,
    momentum: &T5,
    epsilon: &T6,
    grad: &T7,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ApplyRMSProp::new();
    op.call(ctx, var, ms, mom, lr, rho, momentum, epsilon, grad)
}

/// ApproxTopK
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ApproxTopK>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ApproxTopK {
    k: ::std::option::Option<i64>,
    reduction_dimension: ::std::option::Option<i64>,
    recall_target: ::std::option::Option<f32>,
    is_max_k: ::std::option::Option<bool>,
    reduction_input_size_override: ::std::option::Option<i64>,
    aggregate_to_topk: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ApproxTopK {
    fn default() -> Self {
        Self {
            k: None,
            reduction_dimension: Some(-1i64),
            recall_target: Some(0.95f32),
            is_max_k: Some(true),
            reduction_input_size_override: Some(-1i64),
            aggregate_to_topk: Some(true),
            target_device_name: None,
        }
    }
}
impl ApproxTopK {
    /// Creates a new `ApproxTopK`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `k` attribute.
    pub fn k<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.k = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `reduction_dimension` attribute.
    pub fn reduction_dimension<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.reduction_dimension = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `recall_target` attribute.
    pub fn recall_target<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.recall_target = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `is_max_k` attribute.
    pub fn is_max_k<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.is_max_k = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `reduction_input_size_override` attribute.
    pub fn reduction_input_size_override<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.reduction_input_size_override = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `aggregate_to_topk` attribute.
    pub fn aggregate_to_topk<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.aggregate_to_topk = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute approx_top_k.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "ApproxTopK")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.k {
            op.set_attr_int("k", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.reduction_dimension {
            op.set_attr_int("reduction_dimension", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.recall_target {
            op.set_attr_float("recall_target", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.is_max_k {
            op.set_attr_bool("is_max_k", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.reduction_input_size_override {
            op.set_attr_int("reduction_input_size_override", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.aggregate_to_topk {
            op.set_attr_bool("aggregate_to_topk", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `ApproxTopK::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ApproxTopK>
pub fn approx_top_k<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = ApproxTopK::new();
    op.call(ctx, input)
}

/// ApproximateEqual
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ApproximateEqual>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ApproximateEqual {
    tolerance: ::std::option::Option<f32>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ApproximateEqual {
    fn default() -> Self {
        Self {
            tolerance: Some(0.00001f32),
            target_device_name: None,
        }
    }
}
impl ApproximateEqual {
    /// Creates a new `ApproximateEqual`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `tolerance` attribute.
    pub fn tolerance<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.tolerance = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute approximate_equal.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ApproximateEqual")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.tolerance {
            op.set_attr_float("tolerance", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ApproximateEqual::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ApproximateEqual>
pub fn approximate_equal<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ApproximateEqual::new();
    op.call(ctx, x, y)
}

/// ArgMax
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ArgMax>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ArgMax {
    output_type: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ArgMax {
    fn default() -> Self {
        Self {
            output_type: Some(crate::DataType::Int64),
            target_device_name: None,
        }
    }
}
impl ArgMax {
    /// Creates a new `ArgMax`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_type` attribute.
    pub fn output_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute arg_max.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        dimension: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ArgMax")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&dimension.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_type {
            op.set_attr_type("output_type", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ArgMax::new().call(&ctx, &input, &dimension)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ArgMax>
pub fn arg_max<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    dimension: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ArgMax::new();
    op.call(ctx, input, dimension)
}

/// ArgMin
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ArgMin>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ArgMin {
    output_type: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ArgMin {
    fn default() -> Self {
        Self {
            output_type: Some(crate::DataType::Int64),
            target_device_name: None,
        }
    }
}
impl ArgMin {
    /// Creates a new `ArgMin`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_type` attribute.
    pub fn output_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute arg_min.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        dimension: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ArgMin")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&dimension.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_type {
            op.set_attr_type("output_type", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ArgMin::new().call(&ctx, &input, &dimension)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ArgMin>
pub fn arg_min<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    dimension: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ArgMin::new();
    op.call(ctx, input, dimension)
}

/// AsString
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AsString>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AsString {
    precision: ::std::option::Option<i64>,
    scientific: ::std::option::Option<bool>,
    shortest: ::std::option::Option<bool>,
    width: ::std::option::Option<i64>,
    fill: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AsString {
    fn default() -> Self {
        Self {
            precision: Some(-1i64),
            scientific: Some(false),
            shortest: Some(false),
            width: Some(-1i64),
            fill: None,
            target_device_name: None,
        }
    }
}
impl AsString {
    /// Creates a new `AsString`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `precision` attribute.
    pub fn precision<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.precision = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `scientific` attribute.
    pub fn scientific<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.scientific = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shortest` attribute.
    pub fn shortest<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.shortest = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `width` attribute.
    pub fn width<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.width = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `fill` attribute.
    pub fn fill<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.fill = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute as_string.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "AsString")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.precision {
            op.set_attr_int("precision", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.scientific {
            op.set_attr_bool("scientific", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shortest {
            op.set_attr_bool("shortest", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.width {
            op.set_attr_int("width", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.fill {
            op.set_attr_string("fill", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `AsString::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AsString>
pub fn as_string<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = AsString::new();
    op.call(ctx, input)
}

/// Asin
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Asin>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Asin {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Asin {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Asin {
    /// Creates a new `Asin`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute asin.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Asin")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Asin::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Asin>
pub fn asin<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Asin::new();
    op.call(ctx, x)
}

/// Asinh
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Asinh>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Asinh {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Asinh {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Asinh {
    /// Creates a new `Asinh`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute asinh.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Asinh")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Asinh::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Asinh>
pub fn asinh<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Asinh::new();
    op.call(ctx, x)
}

/// Assert
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Assert>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Assert {
    summarize: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Assert {
    fn default() -> Self {
        Self {
            summarize: Some(3i64),
            target_device_name: None,
        }
    }
}
impl Assert {
    /// Creates a new `Assert`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `summarize` attribute.
    pub fn summarize<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.summarize = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute assert.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        condition: &T0,
        data: &T1,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "Assert")?;

        // Required input arguments
        op.add_input(&condition.to_handle(ctx)?)?;
        op.add_input(&data.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.summarize {
            op.set_attr_int("summarize", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `Assert::new().call(&ctx, &condition, &data)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Assert>
pub fn assert<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    condition: &T0,
    data: &T1,
) -> crate::Result<()> {
    let op = Assert::new();
    op.call(ctx, condition, data)
}

/// AssertCardinalityDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AssertCardinalityDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AssertCardinalityDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AssertCardinalityDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl AssertCardinalityDataset {
    /// Creates a new `AssertCardinalityDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute assert_cardinality_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        cardinality: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "AssertCardinalityDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&cardinality.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `AssertCardinalityDataset::new().call(&ctx, &input_dataset, &cardinality)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AssertCardinalityDataset>
pub fn assert_cardinality_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    cardinality: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = AssertCardinalityDataset::new();
    op.call(ctx, input_dataset, cardinality)
}

/// AssertNextDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AssertNextDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AssertNextDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AssertNextDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl AssertNextDataset {
    /// Creates a new `AssertNextDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute assert_next_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        transformations: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "AssertNextDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&transformations.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `AssertNextDataset::new().call(&ctx, &input_dataset, &transformations)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AssertNextDataset>
pub fn assert_next_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    transformations: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = AssertNextDataset::new();
    op.call(ctx, input_dataset, transformations)
}

/// AssertPrevDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AssertPrevDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AssertPrevDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AssertPrevDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl AssertPrevDataset {
    /// Creates a new `AssertPrevDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute assert_prev_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        transformations: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "AssertPrevDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&transformations.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `AssertPrevDataset::new().call(&ctx, &input_dataset, &transformations)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AssertPrevDataset>
pub fn assert_prev_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    transformations: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = AssertPrevDataset::new();
    op.call(ctx, input_dataset, transformations)
}

/// Assign
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Assign>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Assign {
    validate_shape: ::std::option::Option<bool>,
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Assign {
    fn default() -> Self {
        Self {
            validate_shape: Some(true),
            use_locking: Some(true),
            target_device_name: None,
        }
    }
}
impl Assign {
    /// Creates a new `Assign`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `validate_shape` attribute.
    pub fn validate_shape<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.validate_shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute assign.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        ref_: &T0,
        value: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Assign")?;

        // Required input arguments
        op.add_input(&ref_.to_handle(ctx)?)?;
        op.add_input(&value.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.validate_shape {
            op.set_attr_bool("validate_shape", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Assign::new().call(&ctx, &ref_, &value)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Assign>
pub fn assign<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    ref_: &T0,
    value: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Assign::new();
    op.call(ctx, ref_, value)
}

/// AssignAdd
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AssignAdd>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AssignAdd {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AssignAdd {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl AssignAdd {
    /// Creates a new `AssignAdd`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute assign_add.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        ref_: &T0,
        value: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "AssignAdd")?;

        // Required input arguments
        op.add_input(&ref_.to_handle(ctx)?)?;
        op.add_input(&value.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `AssignAdd::new().call(&ctx, &ref_, &value)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AssignAdd>
pub fn assign_add<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    ref_: &T0,
    value: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = AssignAdd::new();
    op.call(ctx, ref_, value)
}

/// AssignAddVariableOp
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AssignAddVariableOp>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AssignAddVariableOp {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AssignAddVariableOp {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl AssignAddVariableOp {
    /// Creates a new `AssignAddVariableOp`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute assign_add_variable_op.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        resource: &T0,
        value: &T1,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "AssignAddVariableOp")?;

        // Required input arguments
        op.add_input(&resource.to_handle(ctx)?)?;
        op.add_input(&value.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `AssignAddVariableOp::new().call(&ctx, &resource, &value)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AssignAddVariableOp>
pub fn assign_add_variable_op<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    resource: &T0,
    value: &T1,
) -> crate::Result<()> {
    let op = AssignAddVariableOp::new();
    op.call(ctx, resource, value)
}

/// AssignSub
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AssignSub>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AssignSub {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AssignSub {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl AssignSub {
    /// Creates a new `AssignSub`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute assign_sub.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        ref_: &T0,
        value: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "AssignSub")?;

        // Required input arguments
        op.add_input(&ref_.to_handle(ctx)?)?;
        op.add_input(&value.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `AssignSub::new().call(&ctx, &ref_, &value)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AssignSub>
pub fn assign_sub<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    ref_: &T0,
    value: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = AssignSub::new();
    op.call(ctx, ref_, value)
}

/// AssignSubVariableOp
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AssignSubVariableOp>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AssignSubVariableOp {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AssignSubVariableOp {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl AssignSubVariableOp {
    /// Creates a new `AssignSubVariableOp`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute assign_sub_variable_op.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        resource: &T0,
        value: &T1,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "AssignSubVariableOp")?;

        // Required input arguments
        op.add_input(&resource.to_handle(ctx)?)?;
        op.add_input(&value.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `AssignSubVariableOp::new().call(&ctx, &resource, &value)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AssignSubVariableOp>
pub fn assign_sub_variable_op<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    resource: &T0,
    value: &T1,
) -> crate::Result<()> {
    let op = AssignSubVariableOp::new();
    op.call(ctx, resource, value)
}

/// AssignVariableOp
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AssignVariableOp>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AssignVariableOp {
    validate_shape: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AssignVariableOp {
    fn default() -> Self {
        Self {
            validate_shape: Some(false),
            target_device_name: None,
        }
    }
}
impl AssignVariableOp {
    /// Creates a new `AssignVariableOp`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `validate_shape` attribute.
    pub fn validate_shape<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.validate_shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute assign_variable_op.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        resource: &T0,
        value: &T1,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "AssignVariableOp")?;

        // Required input arguments
        op.add_input(&resource.to_handle(ctx)?)?;
        op.add_input(&value.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.validate_shape {
            op.set_attr_bool("validate_shape", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `AssignVariableOp::new().call(&ctx, &resource, &value)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AssignVariableOp>
pub fn assign_variable_op<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    resource: &T0,
    value: &T1,
) -> crate::Result<()> {
    let op = AssignVariableOp::new();
    op.call(ctx, resource, value)
}

/// AssignVariableXlaConcatND
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AssignVariableXlaConcatND>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AssignVariableXlaConcatND {
    num_concats: ::std::option::Option<::std::vec::Vec<i64>>,
    paddings: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AssignVariableXlaConcatND {
    fn default() -> Self {
        Self {
            num_concats: None,
            paddings: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl AssignVariableXlaConcatND {
    /// Creates a new `AssignVariableXlaConcatND`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_concats` attribute.
    pub fn num_concats<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.num_concats = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `paddings` attribute.
    pub fn paddings<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.paddings = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute assign_variable_xla_concat_nd.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        resource: &T0,
        inputs: &[&T1],
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "AssignVariableXlaConcatND")?;

        // Required input arguments
        op.add_input(&resource.to_handle(ctx)?)?;
        let mut inputs_list = Vec::new();

        for t in inputs {
            inputs_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&inputs_list)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_concats {
            op.set_attr_int_list("num_concats", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.paddings {
            op.set_attr_int_list("paddings", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `AssignVariableXlaConcatND::new().call(&ctx, &resource, &inputs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AssignVariableXlaConcatND>
pub fn assign_variable_xla_concat_nd<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    resource: &T0,
    inputs: &[&T1],
) -> crate::Result<()> {
    let op = AssignVariableXlaConcatND::new();
    op.call(ctx, resource, inputs)
}

/// Atan
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Atan>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Atan {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Atan {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Atan {
    /// Creates a new `Atan`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute atan.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Atan")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Atan::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Atan>
pub fn atan<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Atan::new();
    op.call(ctx, x)
}

/// Atan2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Atan2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Atan2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Atan2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Atan2 {
    /// Creates a new `Atan2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute atan2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        y: &T0,
        x: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Atan2")?;

        // Required input arguments
        op.add_input(&y.to_handle(ctx)?)?;
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Atan2::new().call(&ctx, &y, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Atan2>
pub fn atan2<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    y: &T0,
    x: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Atan2::new();
    op.call(ctx, y, x)
}

/// Atanh
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Atanh>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Atanh {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Atanh {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Atanh {
    /// Creates a new `Atanh`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute atanh.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Atanh")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Atanh::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Atanh>
pub fn atanh<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Atanh::new();
    op.call(ctx, x)
}

/// AudioSpectrogram
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AudioSpectrogram>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AudioSpectrogram {
    window_size: ::std::option::Option<i64>,
    stride: ::std::option::Option<i64>,
    magnitude_squared: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AudioSpectrogram {
    fn default() -> Self {
        Self {
            window_size: None,
            stride: None,
            magnitude_squared: Some(false),
            target_device_name: None,
        }
    }
}
impl AudioSpectrogram {
    /// Creates a new `AudioSpectrogram`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `window_size` attribute.
    pub fn window_size<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.window_size = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `stride` attribute.
    pub fn stride<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.stride = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `magnitude_squared` attribute.
    pub fn magnitude_squared<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.magnitude_squared = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute audio_spectrogram.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "AudioSpectrogram")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.window_size {
            op.set_attr_int("window_size", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.stride {
            op.set_attr_int("stride", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.magnitude_squared {
            op.set_attr_bool("magnitude_squared", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `AudioSpectrogram::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AudioSpectrogram>
pub fn audio_spectrogram<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = AudioSpectrogram::new();
    op.call(ctx, input)
}

/// AudioSummary
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AudioSummary>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AudioSummary {
    sample_rate: ::std::option::Option<f32>,
    max_outputs: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AudioSummary {
    fn default() -> Self {
        Self {
            sample_rate: None,
            max_outputs: Some(3i64),
            target_device_name: None,
        }
    }
}
impl AudioSummary {
    /// Creates a new `AudioSummary`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `sample_rate` attribute.
    pub fn sample_rate<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.sample_rate = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `max_outputs` attribute.
    pub fn max_outputs<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.max_outputs = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute audio_summary.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        tag: &T0,
        tensor: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "AudioSummary")?;

        // Required input arguments
        op.add_input(&tag.to_handle(ctx)?)?;
        op.add_input(&tensor.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.sample_rate {
            op.set_attr_float("sample_rate", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.max_outputs {
            op.set_attr_int("max_outputs", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `AudioSummary::new().call(&ctx, &tag, &tensor)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AudioSummary>
pub fn audio_summary<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    tag: &T0,
    tensor: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = AudioSummary::new();
    op.call(ctx, tag, tensor)
}

/// AudioSummaryV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AudioSummaryV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AudioSummaryV2 {
    max_outputs: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AudioSummaryV2 {
    fn default() -> Self {
        Self {
            max_outputs: Some(3i64),
            target_device_name: None,
        }
    }
}
impl AudioSummaryV2 {
    /// Creates a new `AudioSummaryV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `max_outputs` attribute.
    pub fn max_outputs<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.max_outputs = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute audio_summary_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        tag: &T0,
        tensor: &T1,
        sample_rate: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "AudioSummaryV2")?;

        // Required input arguments
        op.add_input(&tag.to_handle(ctx)?)?;
        op.add_input(&tensor.to_handle(ctx)?)?;
        op.add_input(&sample_rate.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.max_outputs {
            op.set_attr_int("max_outputs", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `AudioSummaryV2::new().call(&ctx, &tag, &tensor, &sample_rate)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AudioSummaryV2>
pub fn audio_summary_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    tag: &T0,
    tensor: &T1,
    sample_rate: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = AudioSummaryV2::new();
    op.call(ctx, tag, tensor, sample_rate)
}

/// AutoShardDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AutoShardDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AutoShardDataset {
    auto_shard_policy: ::std::option::Option<i64>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    num_replicas: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AutoShardDataset {
    fn default() -> Self {
        Self {
            auto_shard_policy: Some(0i64),
            output_types: None,
            output_shapes: None,
            num_replicas: Some(0i64),
            target_device_name: None,
        }
    }
}
impl AutoShardDataset {
    /// Creates a new `AutoShardDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `auto_shard_policy` attribute.
    pub fn auto_shard_policy<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.auto_shard_policy = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_replicas` attribute.
    pub fn num_replicas<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_replicas = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute auto_shard_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        num_workers: &T1,
        index: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "AutoShardDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&num_workers.to_handle(ctx)?)?;
        op.add_input(&index.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.auto_shard_policy {
            op.set_attr_int("auto_shard_policy", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_replicas {
            op.set_attr_int("num_replicas", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `AutoShardDataset::new().call(&ctx, &input_dataset, &num_workers, &index)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AutoShardDataset>
pub fn auto_shard_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    num_workers: &T1,
    index: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = AutoShardDataset::new();
    op.call(ctx, input_dataset, num_workers, index)
}

/// AvgPool
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AvgPool>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AvgPool {
    ksize: ::std::option::Option<::std::vec::Vec<i64>>,
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    data_format: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AvgPool {
    fn default() -> Self {
        Self {
            ksize: None,
            strides: None,
            padding: None,
            data_format: Some(::std::string::String::from("NHWC")),
            target_device_name: None,
        }
    }
}
impl AvgPool {
    /// Creates a new `AvgPool`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `ksize` attribute.
    pub fn ksize<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.ksize = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `data_format` attribute.
    pub fn data_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.data_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute avg_pool.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        value: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "AvgPool")?;

        // Required input arguments
        op.add_input(&value.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.ksize {
            op.set_attr_int_list("ksize", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.data_format {
            op.set_attr_string("data_format", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `AvgPool::new().call(&ctx, &value)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AvgPool>
pub fn avg_pool<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    value: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = AvgPool::new();
    op.call(ctx, value)
}

/// AvgPool3D
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AvgPool3D>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AvgPool3D {
    ksize: ::std::option::Option<::std::vec::Vec<i64>>,
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    data_format: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AvgPool3D {
    fn default() -> Self {
        Self {
            ksize: None,
            strides: None,
            padding: None,
            data_format: Some(::std::string::String::from("NDHWC")),
            target_device_name: None,
        }
    }
}
impl AvgPool3D {
    /// Creates a new `AvgPool3D`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `ksize` attribute.
    pub fn ksize<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.ksize = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `data_format` attribute.
    pub fn data_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.data_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute avg_pool3_d.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "AvgPool3D")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.ksize {
            op.set_attr_int_list("ksize", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.data_format {
            op.set_attr_string("data_format", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `AvgPool3D::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AvgPool3D>
pub fn avg_pool3_d<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = AvgPool3D::new();
    op.call(ctx, input)
}

/// AvgPool3DGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AvgPool3DGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AvgPool3DGrad {
    ksize: ::std::option::Option<::std::vec::Vec<i64>>,
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    data_format: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AvgPool3DGrad {
    fn default() -> Self {
        Self {
            ksize: None,
            strides: None,
            padding: None,
            data_format: Some(::std::string::String::from("NDHWC")),
            target_device_name: None,
        }
    }
}
impl AvgPool3DGrad {
    /// Creates a new `AvgPool3DGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `ksize` attribute.
    pub fn ksize<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.ksize = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `data_format` attribute.
    pub fn data_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.data_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute avg_pool3_dgrad.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        orig_input_shape: &T0,
        grad: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "AvgPool3DGrad")?;

        // Required input arguments
        op.add_input(&orig_input_shape.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.ksize {
            op.set_attr_int_list("ksize", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.data_format {
            op.set_attr_string("data_format", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `AvgPool3DGrad::new().call(&ctx, &orig_input_shape, &grad)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AvgPool3DGrad>
pub fn avg_pool3_dgrad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    orig_input_shape: &T0,
    grad: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = AvgPool3DGrad::new();
    op.call(ctx, orig_input_shape, grad)
}

/// AvgPoolGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AvgPoolGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct AvgPoolGrad {
    ksize: ::std::option::Option<::std::vec::Vec<i64>>,
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    data_format: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for AvgPoolGrad {
    fn default() -> Self {
        Self {
            ksize: None,
            strides: None,
            padding: None,
            data_format: Some(::std::string::String::from("NHWC")),
            target_device_name: None,
        }
    }
}
impl AvgPoolGrad {
    /// Creates a new `AvgPoolGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `ksize` attribute.
    pub fn ksize<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.ksize = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `data_format` attribute.
    pub fn data_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.data_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute avg_pool_grad.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        orig_input_shape: &T0,
        grad: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "AvgPoolGrad")?;

        // Required input arguments
        op.add_input(&orig_input_shape.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.ksize {
            op.set_attr_int_list("ksize", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.data_format {
            op.set_attr_string("data_format", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `AvgPoolGrad::new().call(&ctx, &orig_input_shape, &grad)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/AvgPoolGrad>
pub fn avg_pool_grad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    orig_input_shape: &T0,
    grad: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = AvgPoolGrad::new();
    op.call(ctx, orig_input_shape, grad)
}

/// BandedTriangularSolve
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BandedTriangularSolve>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BandedTriangularSolve {
    lower: ::std::option::Option<bool>,
    adjoint: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BandedTriangularSolve {
    fn default() -> Self {
        Self {
            lower: Some(true),
            adjoint: Some(false),
            target_device_name: None,
        }
    }
}
impl BandedTriangularSolve {
    /// Creates a new `BandedTriangularSolve`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `lower` attribute.
    pub fn lower<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.lower = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `adjoint` attribute.
    pub fn adjoint<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.adjoint = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute banded_triangular_solve.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        matrix: &T0,
        rhs: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BandedTriangularSolve")?;

        // Required input arguments
        op.add_input(&matrix.to_handle(ctx)?)?;
        op.add_input(&rhs.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.lower {
            op.set_attr_bool("lower", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.adjoint {
            op.set_attr_bool("adjoint", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BandedTriangularSolve::new().call(&ctx, &matrix, &rhs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BandedTriangularSolve>
pub fn banded_triangular_solve<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    matrix: &T0,
    rhs: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BandedTriangularSolve::new();
    op.call(ctx, matrix, rhs)
}

/// Barrier
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Barrier>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Barrier {
    component_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    capacity: ::std::option::Option<i64>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Barrier {
    fn default() -> Self {
        Self {
            component_types: None,
            shapes: Some(vec![]),
            capacity: Some(-1i64),
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl Barrier {
    /// Creates a new `Barrier`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `component_types` attribute.
    pub fn component_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.component_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shapes` attribute.
    pub fn shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `capacity` attribute.
    pub fn capacity<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.capacity = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute barrier.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Barrier")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.component_types {
            op.set_attr_type_list("component_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shapes {
            op.set_attr_shape_list("shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.capacity {
            op.set_attr_int("capacity", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Barrier::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Barrier>
pub fn barrier<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Barrier::new();
    op.call(ctx)
}

/// BarrierClose
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BarrierClose>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BarrierClose {
    cancel_pending_enqueues: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BarrierClose {
    fn default() -> Self {
        Self {
            cancel_pending_enqueues: Some(false),
            target_device_name: None,
        }
    }
}
impl BarrierClose {
    /// Creates a new `BarrierClose`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `cancel_pending_enqueues` attribute.
    pub fn cancel_pending_enqueues<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.cancel_pending_enqueues = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute barrier_close.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "BarrierClose")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.cancel_pending_enqueues {
            op.set_attr_bool("cancel_pending_enqueues", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `BarrierClose::new().call(&ctx, &handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BarrierClose>
pub fn barrier_close<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
) -> crate::Result<()> {
    let op = BarrierClose::new();
    op.call(ctx, handle)
}

/// BarrierIncompleteSize
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BarrierIncompleteSize>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BarrierIncompleteSize {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BarrierIncompleteSize {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BarrierIncompleteSize {
    /// Creates a new `BarrierIncompleteSize`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute barrier_incomplete_size.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BarrierIncompleteSize")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BarrierIncompleteSize::new().call(&ctx, &handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BarrierIncompleteSize>
pub fn barrier_incomplete_size<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BarrierIncompleteSize::new();
    op.call(ctx, handle)
}

/// BarrierInsertMany
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BarrierInsertMany>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BarrierInsertMany {
    component_index: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BarrierInsertMany {
    fn default() -> Self {
        Self {
            component_index: None,
            target_device_name: None,
        }
    }
}
impl BarrierInsertMany {
    /// Creates a new `BarrierInsertMany`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `component_index` attribute.
    pub fn component_index<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.component_index = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute barrier_insert_many.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        keys: &T1,
        values: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "BarrierInsertMany")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&keys.to_handle(ctx)?)?;
        op.add_input(&values.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.component_index {
            op.set_attr_int("component_index", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `BarrierInsertMany::new().call(&ctx, &handle, &keys, &values)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BarrierInsertMany>
pub fn barrier_insert_many<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    keys: &T1,
    values: &T2,
) -> crate::Result<()> {
    let op = BarrierInsertMany::new();
    op.call(ctx, handle, keys, values)
}

/// BarrierReadySize
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BarrierReadySize>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BarrierReadySize {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BarrierReadySize {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BarrierReadySize {
    /// Creates a new `BarrierReadySize`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute barrier_ready_size.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BarrierReadySize")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BarrierReadySize::new().call(&ctx, &handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BarrierReadySize>
pub fn barrier_ready_size<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BarrierReadySize::new();
    op.call(ctx, handle)
}

/// BarrierTakeMany
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BarrierTakeMany>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BarrierTakeMany {
    component_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    allow_small_batch: ::std::option::Option<bool>,
    wait_for_incomplete: ::std::option::Option<bool>,
    timeout_ms: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BarrierTakeMany {
    fn default() -> Self {
        Self {
            component_types: None,
            allow_small_batch: Some(false),
            wait_for_incomplete: Some(false),
            timeout_ms: Some(-1i64),
            target_device_name: None,
        }
    }
}
impl BarrierTakeMany {
    /// Creates a new `BarrierTakeMany`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `component_types` attribute.
    pub fn component_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.component_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `allow_small_batch` attribute.
    pub fn allow_small_batch<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.allow_small_batch = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `wait_for_incomplete` attribute.
    pub fn wait_for_incomplete<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.wait_for_incomplete = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `timeout_ms` attribute.
    pub fn timeout_ms<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.timeout_ms = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute barrier_take_many.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        num_elements: &T1,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "BarrierTakeMany")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&num_elements.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.component_types {
            op.set_attr_type_list("component_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.allow_small_batch {
            op.set_attr_bool("allow_small_batch", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.wait_for_incomplete {
            op.set_attr_bool("wait_for_incomplete", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.timeout_ms {
            op.set_attr_int("timeout_ms", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `BarrierTakeMany::new().call(&ctx, &handle, &num_elements)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BarrierTakeMany>
pub fn barrier_take_many<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    num_elements: &T1,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = BarrierTakeMany::new();
    op.call(ctx, handle, num_elements)
}

/// Batch
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Batch>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Batch {
    num_batch_threads: ::std::option::Option<i64>,
    max_batch_size: ::std::option::Option<i64>,
    max_enqueued_batches: ::std::option::Option<i64>,
    batch_timeout_micros: ::std::option::Option<i64>,
    allowed_batch_sizes: ::std::option::Option<::std::vec::Vec<i64>>,
    grad_timeout_micros: ::std::option::Option<i64>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    batching_queue: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Batch {
    fn default() -> Self {
        Self {
            num_batch_threads: None,
            max_batch_size: None,
            max_enqueued_batches: Some(10i64),
            batch_timeout_micros: None,
            allowed_batch_sizes: Some(vec![]),
            grad_timeout_micros: None,
            container: None,
            shared_name: None,
            batching_queue: None,
            target_device_name: None,
        }
    }
}
impl Batch {
    /// Creates a new `Batch`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_batch_threads` attribute.
    pub fn num_batch_threads<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_batch_threads = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `max_batch_size` attribute.
    pub fn max_batch_size<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.max_batch_size = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `max_enqueued_batches` attribute.
    pub fn max_enqueued_batches<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.max_enqueued_batches = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `batch_timeout_micros` attribute.
    pub fn batch_timeout_micros<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.batch_timeout_micros = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `allowed_batch_sizes` attribute.
    pub fn allowed_batch_sizes<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.allowed_batch_sizes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `grad_timeout_micros` attribute.
    pub fn grad_timeout_micros<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.grad_timeout_micros = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `batching_queue` attribute.
    pub fn batching_queue<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.batching_queue = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute batch.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        in_tensors: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "Batch")?;

        // Required input arguments
        op.add_input(&in_tensors.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_batch_threads {
            op.set_attr_int("num_batch_threads", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.max_batch_size {
            op.set_attr_int("max_batch_size", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.max_enqueued_batches {
            op.set_attr_int("max_enqueued_batches", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.batch_timeout_micros {
            op.set_attr_int("batch_timeout_micros", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.allowed_batch_sizes {
            op.set_attr_int_list("allowed_batch_sizes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.grad_timeout_micros {
            op.set_attr_int("grad_timeout_micros", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.batching_queue {
            op.set_attr_string("batching_queue", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `Batch::new().call(&ctx, &in_tensors)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Batch>
pub fn batch<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    in_tensors: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = Batch::new();
    op.call(ctx, in_tensors)
}

/// BatchCholesky
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchCholesky>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BatchCholesky {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BatchCholesky {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BatchCholesky {
    /// Creates a new `BatchCholesky`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute batch_cholesky.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BatchCholesky")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BatchCholesky::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchCholesky>
pub fn batch_cholesky<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BatchCholesky::new();
    op.call(ctx, input)
}

/// BatchCholeskyGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchCholeskyGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BatchCholeskyGrad {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BatchCholeskyGrad {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BatchCholeskyGrad {
    /// Creates a new `BatchCholeskyGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute batch_cholesky_grad.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        l: &T0,
        grad: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BatchCholeskyGrad")?;

        // Required input arguments
        op.add_input(&l.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BatchCholeskyGrad::new().call(&ctx, &l, &grad)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchCholeskyGrad>
pub fn batch_cholesky_grad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    l: &T0,
    grad: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BatchCholeskyGrad::new();
    op.call(ctx, l, grad)
}

/// BatchDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BatchDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BatchDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl BatchDataset {
    /// Creates a new `BatchDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute batch_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        batch_size: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BatchDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&batch_size.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BatchDataset::new().call(&ctx, &input_dataset, &batch_size)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchDataset>
pub fn batch_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    batch_size: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BatchDataset::new();
    op.call(ctx, input_dataset, batch_size)
}

/// BatchDatasetV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchDatasetV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BatchDatasetV2 {
    parallel_copy: ::std::option::Option<bool>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BatchDatasetV2 {
    fn default() -> Self {
        Self {
            parallel_copy: Some(false),
            output_types: None,
            output_shapes: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl BatchDatasetV2 {
    /// Creates a new `BatchDatasetV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `parallel_copy` attribute.
    pub fn parallel_copy<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.parallel_copy = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute batch_dataset_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        batch_size: &T1,
        drop_remainder: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BatchDatasetV2")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&batch_size.to_handle(ctx)?)?;
        op.add_input(&drop_remainder.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.parallel_copy {
            op.set_attr_bool("parallel_copy", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BatchDatasetV2::new().call(&ctx, &input_dataset, &batch_size, &drop_remainder)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchDatasetV2>
pub fn batch_dataset_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    batch_size: &T1,
    drop_remainder: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BatchDatasetV2::new();
    op.call(ctx, input_dataset, batch_size, drop_remainder)
}

/// BatchFFT
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchFFT>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BatchFFT {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BatchFFT {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BatchFFT {
    /// Creates a new `BatchFFT`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute batch_fft.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BatchFFT")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BatchFFT::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchFFT>
pub fn batch_fft<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BatchFFT::new();
    op.call(ctx, input)
}

/// BatchFFT2D
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchFFT2D>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BatchFFT2D {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BatchFFT2D {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BatchFFT2D {
    /// Creates a new `BatchFFT2D`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute batch_fft2_d.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BatchFFT2D")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BatchFFT2D::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchFFT2D>
pub fn batch_fft2_d<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BatchFFT2D::new();
    op.call(ctx, input)
}

/// BatchFFT3D
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchFFT3D>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BatchFFT3D {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BatchFFT3D {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BatchFFT3D {
    /// Creates a new `BatchFFT3D`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute batch_fft3_d.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BatchFFT3D")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BatchFFT3D::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchFFT3D>
pub fn batch_fft3_d<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BatchFFT3D::new();
    op.call(ctx, input)
}

/// BatchFunction
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchFunction>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BatchFunction {
    f: ::std::option::Option<::std::string::String>,
    num_batch_threads: ::std::option::Option<i64>,
    max_batch_size: ::std::option::Option<i64>,
    batch_timeout_micros: ::std::option::Option<i64>,
    max_enqueued_batches: ::std::option::Option<i64>,
    allowed_batch_sizes: ::std::option::Option<::std::vec::Vec<i64>>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    batching_queue: ::std::option::Option<::std::string::String>,
    Tout: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    enable_large_batch_splitting: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BatchFunction {
    fn default() -> Self {
        Self {
            f: None,
            num_batch_threads: None,
            max_batch_size: None,
            batch_timeout_micros: None,
            max_enqueued_batches: Some(10i64),
            allowed_batch_sizes: Some(vec![]),
            container: None,
            shared_name: None,
            batching_queue: None,
            Tout: None,
            enable_large_batch_splitting: Some(false),
            target_device_name: None,
        }
    }
}
impl BatchFunction {
    /// Creates a new `BatchFunction`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `f` attribute.
    pub fn f<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.f = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_batch_threads` attribute.
    pub fn num_batch_threads<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_batch_threads = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `max_batch_size` attribute.
    pub fn max_batch_size<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.max_batch_size = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `batch_timeout_micros` attribute.
    pub fn batch_timeout_micros<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.batch_timeout_micros = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `max_enqueued_batches` attribute.
    pub fn max_enqueued_batches<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.max_enqueued_batches = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `allowed_batch_sizes` attribute.
    pub fn allowed_batch_sizes<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.allowed_batch_sizes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `batching_queue` attribute.
    pub fn batching_queue<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.batching_queue = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `Tout` attribute.
    pub fn Tout<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Tout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `enable_large_batch_splitting` attribute.
    pub fn enable_large_batch_splitting<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.enable_large_batch_splitting = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute batch_function.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        in_tensors: &T0,
        captured_tensors: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BatchFunction")?;

        // Required input arguments
        op.add_input(&in_tensors.to_handle(ctx)?)?;
        op.add_input(&captured_tensors.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.f {
            op.set_attr_string("f", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_batch_threads {
            op.set_attr_int("num_batch_threads", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.max_batch_size {
            op.set_attr_int("max_batch_size", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.batch_timeout_micros {
            op.set_attr_int("batch_timeout_micros", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.max_enqueued_batches {
            op.set_attr_int("max_enqueued_batches", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.allowed_batch_sizes {
            op.set_attr_int_list("allowed_batch_sizes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.batching_queue {
            op.set_attr_string("batching_queue", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.Tout {
            op.set_attr_type_list("Tout", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.enable_large_batch_splitting {
            op.set_attr_bool("enable_large_batch_splitting", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BatchFunction::new().call(&ctx, &in_tensors, &captured_tensors)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchFunction>
pub fn batch_function<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    in_tensors: &T0,
    captured_tensors: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BatchFunction::new();
    op.call(ctx, in_tensors, captured_tensors)
}

/// BatchIFFT
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchIFFT>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BatchIFFT {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BatchIFFT {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BatchIFFT {
    /// Creates a new `BatchIFFT`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute batch_ifft.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BatchIFFT")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BatchIFFT::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchIFFT>
pub fn batch_ifft<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BatchIFFT::new();
    op.call(ctx, input)
}

/// BatchIFFT2D
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchIFFT2D>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BatchIFFT2D {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BatchIFFT2D {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BatchIFFT2D {
    /// Creates a new `BatchIFFT2D`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute batch_ifft2_d.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BatchIFFT2D")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BatchIFFT2D::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchIFFT2D>
pub fn batch_ifft2_d<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BatchIFFT2D::new();
    op.call(ctx, input)
}

/// BatchIFFT3D
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchIFFT3D>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BatchIFFT3D {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BatchIFFT3D {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BatchIFFT3D {
    /// Creates a new `BatchIFFT3D`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute batch_ifft3_d.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BatchIFFT3D")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BatchIFFT3D::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchIFFT3D>
pub fn batch_ifft3_d<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BatchIFFT3D::new();
    op.call(ctx, input)
}

/// BatchMatMul
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchMatMul>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BatchMatMul {
    adj_x: ::std::option::Option<bool>,
    adj_y: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BatchMatMul {
    fn default() -> Self {
        Self {
            adj_x: Some(false),
            adj_y: Some(false),
            target_device_name: None,
        }
    }
}
impl BatchMatMul {
    /// Creates a new `BatchMatMul`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `adj_x` attribute.
    pub fn adj_x<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.adj_x = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `adj_y` attribute.
    pub fn adj_y<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.adj_y = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute batch_mat_mul.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BatchMatMul")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.adj_x {
            op.set_attr_bool("adj_x", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.adj_y {
            op.set_attr_bool("adj_y", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BatchMatMul::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchMatMul>
pub fn batch_mat_mul<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BatchMatMul::new();
    op.call(ctx, x, y)
}

/// BatchMatMulV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchMatMulV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BatchMatMulV2 {
    adj_x: ::std::option::Option<bool>,
    adj_y: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BatchMatMulV2 {
    fn default() -> Self {
        Self {
            adj_x: Some(false),
            adj_y: Some(false),
            target_device_name: None,
        }
    }
}
impl BatchMatMulV2 {
    /// Creates a new `BatchMatMulV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `adj_x` attribute.
    pub fn adj_x<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.adj_x = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `adj_y` attribute.
    pub fn adj_y<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.adj_y = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute batch_mat_mul_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BatchMatMulV2")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.adj_x {
            op.set_attr_bool("adj_x", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.adj_y {
            op.set_attr_bool("adj_y", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BatchMatMulV2::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchMatMulV2>
pub fn batch_mat_mul_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BatchMatMulV2::new();
    op.call(ctx, x, y)
}

/// BatchMatMulV3
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchMatMulV3>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BatchMatMulV3 {
    Tout: ::std::option::Option<crate::DataType>,
    adj_x: ::std::option::Option<bool>,
    adj_y: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BatchMatMulV3 {
    fn default() -> Self {
        Self {
            Tout: None,
            adj_x: Some(false),
            adj_y: Some(false),
            target_device_name: None,
        }
    }
}
impl BatchMatMulV3 {
    /// Creates a new `BatchMatMulV3`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Tout` attribute.
    pub fn Tout<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.Tout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `adj_x` attribute.
    pub fn adj_x<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.adj_x = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `adj_y` attribute.
    pub fn adj_y<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.adj_y = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute batch_mat_mul_v3.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BatchMatMulV3")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Tout {
            op.set_attr_type("Tout", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.adj_x {
            op.set_attr_bool("adj_x", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.adj_y {
            op.set_attr_bool("adj_y", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BatchMatMulV3::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchMatMulV3>
pub fn batch_mat_mul_v3<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BatchMatMulV3::new();
    op.call(ctx, x, y)
}

/// BatchMatrixBandPart
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchMatrixBandPart>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BatchMatrixBandPart {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BatchMatrixBandPart {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BatchMatrixBandPart {
    /// Creates a new `BatchMatrixBandPart`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute batch_matrix_band_part.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        num_lower: &T1,
        num_upper: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BatchMatrixBandPart")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&num_lower.to_handle(ctx)?)?;
        op.add_input(&num_upper.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BatchMatrixBandPart::new().call(&ctx, &input, &num_lower, &num_upper)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchMatrixBandPart>
pub fn batch_matrix_band_part<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    num_lower: &T1,
    num_upper: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BatchMatrixBandPart::new();
    op.call(ctx, input, num_lower, num_upper)
}

/// BatchMatrixDeterminant
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchMatrixDeterminant>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BatchMatrixDeterminant {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BatchMatrixDeterminant {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BatchMatrixDeterminant {
    /// Creates a new `BatchMatrixDeterminant`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute batch_matrix_determinant.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BatchMatrixDeterminant")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BatchMatrixDeterminant::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchMatrixDeterminant>
pub fn batch_matrix_determinant<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BatchMatrixDeterminant::new();
    op.call(ctx, input)
}

/// BatchMatrixDiag
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchMatrixDiag>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BatchMatrixDiag {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BatchMatrixDiag {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BatchMatrixDiag {
    /// Creates a new `BatchMatrixDiag`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute batch_matrix_diag.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        diagonal: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BatchMatrixDiag")?;

        // Required input arguments
        op.add_input(&diagonal.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BatchMatrixDiag::new().call(&ctx, &diagonal)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchMatrixDiag>
pub fn batch_matrix_diag<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    diagonal: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BatchMatrixDiag::new();
    op.call(ctx, diagonal)
}

/// BatchMatrixDiagPart
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchMatrixDiagPart>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BatchMatrixDiagPart {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BatchMatrixDiagPart {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BatchMatrixDiagPart {
    /// Creates a new `BatchMatrixDiagPart`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute batch_matrix_diag_part.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BatchMatrixDiagPart")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BatchMatrixDiagPart::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchMatrixDiagPart>
pub fn batch_matrix_diag_part<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BatchMatrixDiagPart::new();
    op.call(ctx, input)
}

/// BatchMatrixInverse
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchMatrixInverse>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BatchMatrixInverse {
    adjoint: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BatchMatrixInverse {
    fn default() -> Self {
        Self {
            adjoint: Some(false),
            target_device_name: None,
        }
    }
}
impl BatchMatrixInverse {
    /// Creates a new `BatchMatrixInverse`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `adjoint` attribute.
    pub fn adjoint<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.adjoint = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute batch_matrix_inverse.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BatchMatrixInverse")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.adjoint {
            op.set_attr_bool("adjoint", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BatchMatrixInverse::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchMatrixInverse>
pub fn batch_matrix_inverse<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BatchMatrixInverse::new();
    op.call(ctx, input)
}

/// BatchMatrixSetDiag
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchMatrixSetDiag>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BatchMatrixSetDiag {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BatchMatrixSetDiag {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BatchMatrixSetDiag {
    /// Creates a new `BatchMatrixSetDiag`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute batch_matrix_set_diag.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        diagonal: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BatchMatrixSetDiag")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&diagonal.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BatchMatrixSetDiag::new().call(&ctx, &input, &diagonal)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchMatrixSetDiag>
pub fn batch_matrix_set_diag<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    diagonal: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BatchMatrixSetDiag::new();
    op.call(ctx, input, diagonal)
}

/// BatchMatrixSolve
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchMatrixSolve>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BatchMatrixSolve {
    adjoint: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BatchMatrixSolve {
    fn default() -> Self {
        Self {
            adjoint: Some(false),
            target_device_name: None,
        }
    }
}
impl BatchMatrixSolve {
    /// Creates a new `BatchMatrixSolve`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `adjoint` attribute.
    pub fn adjoint<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.adjoint = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute batch_matrix_solve.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        matrix: &T0,
        rhs: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BatchMatrixSolve")?;

        // Required input arguments
        op.add_input(&matrix.to_handle(ctx)?)?;
        op.add_input(&rhs.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.adjoint {
            op.set_attr_bool("adjoint", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BatchMatrixSolve::new().call(&ctx, &matrix, &rhs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchMatrixSolve>
pub fn batch_matrix_solve<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    matrix: &T0,
    rhs: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BatchMatrixSolve::new();
    op.call(ctx, matrix, rhs)
}

/// BatchMatrixSolveLs
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchMatrixSolveLs>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BatchMatrixSolveLs {
    fast: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BatchMatrixSolveLs {
    fn default() -> Self {
        Self {
            fast: Some(true),
            target_device_name: None,
        }
    }
}
impl BatchMatrixSolveLs {
    /// Creates a new `BatchMatrixSolveLs`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `fast` attribute.
    pub fn fast<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.fast = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute batch_matrix_solve_ls.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        matrix: &T0,
        rhs: &T1,
        l2_regularizer: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BatchMatrixSolveLs")?;

        // Required input arguments
        op.add_input(&matrix.to_handle(ctx)?)?;
        op.add_input(&rhs.to_handle(ctx)?)?;
        op.add_input(&l2_regularizer.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.fast {
            op.set_attr_bool("fast", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BatchMatrixSolveLs::new().call(&ctx, &matrix, &rhs, &l2_regularizer)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchMatrixSolveLs>
pub fn batch_matrix_solve_ls<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    matrix: &T0,
    rhs: &T1,
    l2_regularizer: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BatchMatrixSolveLs::new();
    op.call(ctx, matrix, rhs, l2_regularizer)
}

/// BatchMatrixTriangularSolve
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchMatrixTriangularSolve>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BatchMatrixTriangularSolve {
    lower: ::std::option::Option<bool>,
    adjoint: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BatchMatrixTriangularSolve {
    fn default() -> Self {
        Self {
            lower: Some(true),
            adjoint: Some(false),
            target_device_name: None,
        }
    }
}
impl BatchMatrixTriangularSolve {
    /// Creates a new `BatchMatrixTriangularSolve`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `lower` attribute.
    pub fn lower<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.lower = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `adjoint` attribute.
    pub fn adjoint<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.adjoint = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute batch_matrix_triangular_solve.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        matrix: &T0,
        rhs: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BatchMatrixTriangularSolve")?;

        // Required input arguments
        op.add_input(&matrix.to_handle(ctx)?)?;
        op.add_input(&rhs.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.lower {
            op.set_attr_bool("lower", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.adjoint {
            op.set_attr_bool("adjoint", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BatchMatrixTriangularSolve::new().call(&ctx, &matrix, &rhs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchMatrixTriangularSolve>
pub fn batch_matrix_triangular_solve<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    matrix: &T0,
    rhs: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BatchMatrixTriangularSolve::new();
    op.call(ctx, matrix, rhs)
}

/// BatchNormWithGlobalNormalization
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchNormWithGlobalNormalization>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BatchNormWithGlobalNormalization {
    variance_epsilon: ::std::option::Option<f32>,
    scale_after_normalization: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BatchNormWithGlobalNormalization {
    fn default() -> Self {
        Self {
            variance_epsilon: None,
            scale_after_normalization: None,
            target_device_name: None,
        }
    }
}
impl BatchNormWithGlobalNormalization {
    /// Creates a new `BatchNormWithGlobalNormalization`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `variance_epsilon` attribute.
    pub fn variance_epsilon<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.variance_epsilon = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `scale_after_normalization` attribute.
    pub fn scale_after_normalization<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.scale_after_normalization = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute batch_norm_with_global_normalization.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        t: &T0,
        m: &T1,
        v: &T2,
        beta: &T3,
        gamma: &T4,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BatchNormWithGlobalNormalization")?;

        // Required input arguments
        op.add_input(&t.to_handle(ctx)?)?;
        op.add_input(&m.to_handle(ctx)?)?;
        op.add_input(&v.to_handle(ctx)?)?;
        op.add_input(&beta.to_handle(ctx)?)?;
        op.add_input(&gamma.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.variance_epsilon {
            op.set_attr_float("variance_epsilon", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.scale_after_normalization {
            op.set_attr_bool("scale_after_normalization", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BatchNormWithGlobalNormalization::new().call(&ctx, &t, &m, &v, &beta, &gamma)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchNormWithGlobalNormalization>
pub fn batch_norm_with_global_normalization<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    t: &T0,
    m: &T1,
    v: &T2,
    beta: &T3,
    gamma: &T4,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BatchNormWithGlobalNormalization::new();
    op.call(ctx, t, m, v, beta, gamma)
}

/// BatchNormWithGlobalNormalizationGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchNormWithGlobalNormalizationGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BatchNormWithGlobalNormalizationGrad {
    variance_epsilon: ::std::option::Option<f32>,
    scale_after_normalization: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BatchNormWithGlobalNormalizationGrad {
    fn default() -> Self {
        Self {
            variance_epsilon: None,
            scale_after_normalization: None,
            target_device_name: None,
        }
    }
}
impl BatchNormWithGlobalNormalizationGrad {
    /// Creates a new `BatchNormWithGlobalNormalizationGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `variance_epsilon` attribute.
    pub fn variance_epsilon<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.variance_epsilon = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `scale_after_normalization` attribute.
    pub fn scale_after_normalization<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.scale_after_normalization = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute batch_norm_with_global_normalization_grad.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        t: &T0,
        m: &T1,
        v: &T2,
        gamma: &T3,
        backprop: &T4,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 5]> {
        // Define Op
        let mut op = super::Op::new(ctx, "BatchNormWithGlobalNormalizationGrad")?;

        // Required input arguments
        op.add_input(&t.to_handle(ctx)?)?;
        op.add_input(&m.to_handle(ctx)?)?;
        op.add_input(&v.to_handle(ctx)?)?;
        op.add_input(&gamma.to_handle(ctx)?)?;
        op.add_input(&backprop.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.variance_epsilon {
            op.set_attr_float("variance_epsilon", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.scale_after_normalization {
            op.set_attr_bool("scale_after_normalization", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<5>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `BatchNormWithGlobalNormalizationGrad::new().call(&ctx, &t, &m, &v, &gamma, &backprop)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchNormWithGlobalNormalizationGrad>
pub fn batch_norm_with_global_normalization_grad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    t: &T0,
    m: &T1,
    v: &T2,
    gamma: &T3,
    backprop: &T4,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 5]> {
    let op = BatchNormWithGlobalNormalizationGrad::new();
    op.call(ctx, t, m, v, gamma, backprop)
}

/// BatchSelfAdjointEig
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchSelfAdjointEig>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BatchSelfAdjointEig {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BatchSelfAdjointEig {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BatchSelfAdjointEig {
    /// Creates a new `BatchSelfAdjointEig`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute batch_self_adjoint_eig.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BatchSelfAdjointEig")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BatchSelfAdjointEig::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchSelfAdjointEig>
pub fn batch_self_adjoint_eig<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BatchSelfAdjointEig::new();
    op.call(ctx, input)
}

/// BatchSelfAdjointEigV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchSelfAdjointEigV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BatchSelfAdjointEigV2 {
    compute_v: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BatchSelfAdjointEigV2 {
    fn default() -> Self {
        Self {
            compute_v: Some(true),
            target_device_name: None,
        }
    }
}
impl BatchSelfAdjointEigV2 {
    /// Creates a new `BatchSelfAdjointEigV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `compute_v` attribute.
    pub fn compute_v<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.compute_v = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute batch_self_adjoint_eig_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "BatchSelfAdjointEigV2")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.compute_v {
            op.set_attr_bool("compute_v", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `BatchSelfAdjointEigV2::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchSelfAdjointEigV2>
pub fn batch_self_adjoint_eig_v2<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = BatchSelfAdjointEigV2::new();
    op.call(ctx, input)
}

/// BatchSvd
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchSvd>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BatchSvd {
    compute_uv: ::std::option::Option<bool>,
    full_matrices: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BatchSvd {
    fn default() -> Self {
        Self {
            compute_uv: Some(true),
            full_matrices: Some(false),
            target_device_name: None,
        }
    }
}
impl BatchSvd {
    /// Creates a new `BatchSvd`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `compute_uv` attribute.
    pub fn compute_uv<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.compute_uv = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `full_matrices` attribute.
    pub fn full_matrices<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.full_matrices = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute batch_svd.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "BatchSvd")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.compute_uv {
            op.set_attr_bool("compute_uv", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.full_matrices {
            op.set_attr_bool("full_matrices", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `BatchSvd::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchSvd>
pub fn batch_svd<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = BatchSvd::new();
    op.call(ctx, input)
}

/// BatchToSpace
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchToSpace>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BatchToSpace {
    block_size: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BatchToSpace {
    fn default() -> Self {
        Self {
            block_size: None,
            target_device_name: None,
        }
    }
}
impl BatchToSpace {
    /// Creates a new `BatchToSpace`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `block_size` attribute.
    pub fn block_size<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.block_size = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute batch_to_space.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        crops: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BatchToSpace")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&crops.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.block_size {
            op.set_attr_int("block_size", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BatchToSpace::new().call(&ctx, &input, &crops)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchToSpace>
pub fn batch_to_space<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    crops: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BatchToSpace::new();
    op.call(ctx, input, crops)
}

/// BatchToSpaceND
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchToSpaceND>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BatchToSpaceND {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BatchToSpaceND {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BatchToSpaceND {
    /// Creates a new `BatchToSpaceND`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute batch_to_space_nd.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        block_shape: &T1,
        crops: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BatchToSpaceND")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&block_shape.to_handle(ctx)?)?;
        op.add_input(&crops.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BatchToSpaceND::new().call(&ctx, &input, &block_shape, &crops)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BatchToSpaceND>
pub fn batch_to_space_nd<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    block_shape: &T1,
    crops: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BatchToSpaceND::new();
    op.call(ctx, input, block_shape, crops)
}

/// BesselI0
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BesselI0>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BesselI0 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BesselI0 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BesselI0 {
    /// Creates a new `BesselI0`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute bessel_i0.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BesselI0")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BesselI0::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BesselI0>
pub fn bessel_i0<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BesselI0::new();
    op.call(ctx, x)
}

/// BesselI0e
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BesselI0e>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BesselI0e {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BesselI0e {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BesselI0e {
    /// Creates a new `BesselI0e`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute bessel_i0e.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BesselI0e")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BesselI0e::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BesselI0e>
pub fn bessel_i0e<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BesselI0e::new();
    op.call(ctx, x)
}

/// BesselI1
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BesselI1>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BesselI1 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BesselI1 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BesselI1 {
    /// Creates a new `BesselI1`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute bessel_i1.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BesselI1")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BesselI1::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BesselI1>
pub fn bessel_i1<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BesselI1::new();
    op.call(ctx, x)
}

/// BesselI1e
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BesselI1e>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BesselI1e {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BesselI1e {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BesselI1e {
    /// Creates a new `BesselI1e`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute bessel_i1e.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BesselI1e")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BesselI1e::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BesselI1e>
pub fn bessel_i1e<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BesselI1e::new();
    op.call(ctx, x)
}

/// BesselJ0
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BesselJ0>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BesselJ0 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BesselJ0 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BesselJ0 {
    /// Creates a new `BesselJ0`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute bessel_j0.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BesselJ0")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BesselJ0::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BesselJ0>
pub fn bessel_j0<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BesselJ0::new();
    op.call(ctx, x)
}

/// BesselJ1
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BesselJ1>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BesselJ1 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BesselJ1 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BesselJ1 {
    /// Creates a new `BesselJ1`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute bessel_j1.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BesselJ1")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BesselJ1::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BesselJ1>
pub fn bessel_j1<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BesselJ1::new();
    op.call(ctx, x)
}

/// BesselK0
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BesselK0>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BesselK0 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BesselK0 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BesselK0 {
    /// Creates a new `BesselK0`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute bessel_k0.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BesselK0")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BesselK0::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BesselK0>
pub fn bessel_k0<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BesselK0::new();
    op.call(ctx, x)
}

/// BesselK0e
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BesselK0e>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BesselK0e {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BesselK0e {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BesselK0e {
    /// Creates a new `BesselK0e`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute bessel_k0e.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BesselK0e")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BesselK0e::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BesselK0e>
pub fn bessel_k0e<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BesselK0e::new();
    op.call(ctx, x)
}

/// BesselK1
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BesselK1>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BesselK1 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BesselK1 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BesselK1 {
    /// Creates a new `BesselK1`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute bessel_k1.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BesselK1")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BesselK1::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BesselK1>
pub fn bessel_k1<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BesselK1::new();
    op.call(ctx, x)
}

/// BesselK1e
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BesselK1e>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BesselK1e {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BesselK1e {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BesselK1e {
    /// Creates a new `BesselK1e`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute bessel_k1e.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BesselK1e")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BesselK1e::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BesselK1e>
pub fn bessel_k1e<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BesselK1e::new();
    op.call(ctx, x)
}

/// BesselY0
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BesselY0>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BesselY0 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BesselY0 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BesselY0 {
    /// Creates a new `BesselY0`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute bessel_y0.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BesselY0")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BesselY0::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BesselY0>
pub fn bessel_y0<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BesselY0::new();
    op.call(ctx, x)
}

/// BesselY1
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BesselY1>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BesselY1 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BesselY1 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BesselY1 {
    /// Creates a new `BesselY1`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute bessel_y1.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BesselY1")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BesselY1::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BesselY1>
pub fn bessel_y1<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BesselY1::new();
    op.call(ctx, x)
}

/// Betainc
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Betainc>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Betainc {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Betainc {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Betainc {
    /// Creates a new `Betainc`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute betainc.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        a: &T0,
        b: &T1,
        x: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Betainc")?;

        // Required input arguments
        op.add_input(&a.to_handle(ctx)?)?;
        op.add_input(&b.to_handle(ctx)?)?;
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Betainc::new().call(&ctx, &a, &b, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Betainc>
pub fn betainc<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    a: &T0,
    b: &T1,
    x: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Betainc::new();
    op.call(ctx, a, b, x)
}

/// BiasAdd
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BiasAdd>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BiasAdd {
    data_format: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BiasAdd {
    fn default() -> Self {
        Self {
            data_format: Some(::std::string::String::from("NHWC")),
            target_device_name: None,
        }
    }
}
impl BiasAdd {
    /// Creates a new `BiasAdd`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `data_format` attribute.
    pub fn data_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.data_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute bias_add.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        value: &T0,
        bias: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BiasAdd")?;

        // Required input arguments
        op.add_input(&value.to_handle(ctx)?)?;
        op.add_input(&bias.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.data_format {
            op.set_attr_string("data_format", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BiasAdd::new().call(&ctx, &value, &bias)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BiasAdd>
pub fn bias_add<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    value: &T0,
    bias: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BiasAdd::new();
    op.call(ctx, value, bias)
}

/// BiasAddGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BiasAddGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BiasAddGrad {
    data_format: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BiasAddGrad {
    fn default() -> Self {
        Self {
            data_format: Some(::std::string::String::from("NHWC")),
            target_device_name: None,
        }
    }
}
impl BiasAddGrad {
    /// Creates a new `BiasAddGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `data_format` attribute.
    pub fn data_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.data_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute bias_add_grad.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        out_backprop: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BiasAddGrad")?;

        // Required input arguments
        op.add_input(&out_backprop.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.data_format {
            op.set_attr_string("data_format", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BiasAddGrad::new().call(&ctx, &out_backprop)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BiasAddGrad>
pub fn bias_add_grad<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    out_backprop: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BiasAddGrad::new();
    op.call(ctx, out_backprop)
}

/// BiasAddV1
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BiasAddV1>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BiasAddV1 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BiasAddV1 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BiasAddV1 {
    /// Creates a new `BiasAddV1`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute bias_add_v1.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        value: &T0,
        bias: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BiasAddV1")?;

        // Required input arguments
        op.add_input(&value.to_handle(ctx)?)?;
        op.add_input(&bias.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BiasAddV1::new().call(&ctx, &value, &bias)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BiasAddV1>
pub fn bias_add_v1<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    value: &T0,
    bias: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BiasAddV1::new();
    op.call(ctx, value, bias)
}

/// Bincount
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Bincount>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Bincount {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Bincount {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Bincount {
    /// Creates a new `Bincount`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute bincount.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        arr: &T0,
        size: &T1,
        weights: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Bincount")?;

        // Required input arguments
        op.add_input(&arr.to_handle(ctx)?)?;
        op.add_input(&size.to_handle(ctx)?)?;
        op.add_input(&weights.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Bincount::new().call(&ctx, &arr, &size, &weights)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Bincount>
pub fn bincount<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    arr: &T0,
    size: &T1,
    weights: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Bincount::new();
    op.call(ctx, arr, size, weights)
}

/// Bitcast
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Bitcast>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Bitcast {
    type_: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Bitcast {
    fn default() -> Self {
        Self {
            type_: None,
            target_device_name: None,
        }
    }
}
impl Bitcast {
    /// Creates a new `Bitcast`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `type` attribute.
    pub fn type_<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.type_ = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute bitcast.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Bitcast")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.type_ {
            op.set_attr_type("type", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Bitcast::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Bitcast>
pub fn bitcast<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Bitcast::new();
    op.call(ctx, input)
}

/// BitwiseAnd
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BitwiseAnd>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BitwiseAnd {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BitwiseAnd {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BitwiseAnd {
    /// Creates a new `BitwiseAnd`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute bitwise_and.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BitwiseAnd")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BitwiseAnd::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BitwiseAnd>
pub fn bitwise_and<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BitwiseAnd::new();
    op.call(ctx, x, y)
}

/// BitwiseOr
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BitwiseOr>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BitwiseOr {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BitwiseOr {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BitwiseOr {
    /// Creates a new `BitwiseOr`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute bitwise_or.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BitwiseOr")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BitwiseOr::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BitwiseOr>
pub fn bitwise_or<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BitwiseOr::new();
    op.call(ctx, x, y)
}

/// BitwiseXor
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BitwiseXor>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BitwiseXor {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BitwiseXor {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BitwiseXor {
    /// Creates a new `BitwiseXor`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute bitwise_xor.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BitwiseXor")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BitwiseXor::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BitwiseXor>
pub fn bitwise_xor<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BitwiseXor::new();
    op.call(ctx, x, y)
}

/// BlockLSTM
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BlockLSTM>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BlockLSTM {
    forget_bias: ::std::option::Option<f32>,
    cell_clip: ::std::option::Option<f32>,
    use_peephole: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BlockLSTM {
    fn default() -> Self {
        Self {
            forget_bias: Some(1f32),
            cell_clip: Some(3f32),
            use_peephole: Some(false),
            target_device_name: None,
        }
    }
}
impl BlockLSTM {
    /// Creates a new `BlockLSTM`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `forget_bias` attribute.
    pub fn forget_bias<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.forget_bias = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `cell_clip` attribute.
    pub fn cell_clip<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.cell_clip = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_peephole` attribute.
    pub fn use_peephole<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_peephole = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute block_lstm.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        seq_len_max: &T0,
        x: &T1,
        cs_prev: &T2,
        h_prev: &T3,
        w: &T4,
        wci: &T5,
        wcf: &T6,
        wco: &T7,
        b: &T8,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 7]> {
        // Define Op
        let mut op = super::Op::new(ctx, "BlockLSTM")?;

        // Required input arguments
        op.add_input(&seq_len_max.to_handle(ctx)?)?;
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&cs_prev.to_handle(ctx)?)?;
        op.add_input(&h_prev.to_handle(ctx)?)?;
        op.add_input(&w.to_handle(ctx)?)?;
        op.add_input(&wci.to_handle(ctx)?)?;
        op.add_input(&wcf.to_handle(ctx)?)?;
        op.add_input(&wco.to_handle(ctx)?)?;
        op.add_input(&b.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.forget_bias {
            op.set_attr_float("forget_bias", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.cell_clip {
            op.set_attr_float("cell_clip", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_peephole {
            op.set_attr_bool("use_peephole", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<7>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `BlockLSTM::new().call(&ctx, &seq_len_max, &x, &cs_prev, &h_prev, &w, &wci, &wcf, &wco, &b)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BlockLSTM>
pub fn block_lstm<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    seq_len_max: &T0,
    x: &T1,
    cs_prev: &T2,
    h_prev: &T3,
    w: &T4,
    wci: &T5,
    wcf: &T6,
    wco: &T7,
    b: &T8,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 7]> {
    let op = BlockLSTM::new();
    op.call(ctx, seq_len_max, x, cs_prev, h_prev, w, wci, wcf, wco, b)
}

/// BlockLSTMGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BlockLSTMGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BlockLSTMGrad {
    use_peephole: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BlockLSTMGrad {
    fn default() -> Self {
        Self {
            use_peephole: None,
            target_device_name: None,
        }
    }
}
impl BlockLSTMGrad {
    /// Creates a new `BlockLSTMGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_peephole` attribute.
    pub fn use_peephole<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_peephole = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute block_lstmgrad.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
        T9: crate::eager::ToTensorHandle<'a>,
        T10: crate::eager::ToTensorHandle<'a>,
        T11: crate::eager::ToTensorHandle<'a>,
        T12: crate::eager::ToTensorHandle<'a>,
        T13: crate::eager::ToTensorHandle<'a>,
        T14: crate::eager::ToTensorHandle<'a>,
        T15: crate::eager::ToTensorHandle<'a>,
        T16: crate::eager::ToTensorHandle<'a>,
        T17: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        seq_len_max: &T0,
        x: &T1,
        cs_prev: &T2,
        h_prev: &T3,
        w: &T4,
        wci: &T5,
        wcf: &T6,
        wco: &T7,
        b: &T8,
        i: &T9,
        cs: &T10,
        f: &T11,
        o: &T12,
        ci: &T13,
        co: &T14,
        h: &T15,
        cs_grad: &T16,
        h_grad: &T17,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 8]> {
        // Define Op
        let mut op = super::Op::new(ctx, "BlockLSTMGrad")?;

        // Required input arguments
        op.add_input(&seq_len_max.to_handle(ctx)?)?;
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&cs_prev.to_handle(ctx)?)?;
        op.add_input(&h_prev.to_handle(ctx)?)?;
        op.add_input(&w.to_handle(ctx)?)?;
        op.add_input(&wci.to_handle(ctx)?)?;
        op.add_input(&wcf.to_handle(ctx)?)?;
        op.add_input(&wco.to_handle(ctx)?)?;
        op.add_input(&b.to_handle(ctx)?)?;
        op.add_input(&i.to_handle(ctx)?)?;
        op.add_input(&cs.to_handle(ctx)?)?;
        op.add_input(&f.to_handle(ctx)?)?;
        op.add_input(&o.to_handle(ctx)?)?;
        op.add_input(&ci.to_handle(ctx)?)?;
        op.add_input(&co.to_handle(ctx)?)?;
        op.add_input(&h.to_handle(ctx)?)?;
        op.add_input(&cs_grad.to_handle(ctx)?)?;
        op.add_input(&h_grad.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_peephole {
            op.set_attr_bool("use_peephole", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<8>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `BlockLSTMGrad::new().call(&ctx, &seq_len_max, &x, &cs_prev, &h_prev, &w, &wci, &wcf, &wco, &b, &i, &cs, &f, &o, &ci, &co, &h, &cs_grad, &h_grad)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BlockLSTMGrad>
pub fn block_lstmgrad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
    T9: crate::eager::ToTensorHandle<'a>,
    T10: crate::eager::ToTensorHandle<'a>,
    T11: crate::eager::ToTensorHandle<'a>,
    T12: crate::eager::ToTensorHandle<'a>,
    T13: crate::eager::ToTensorHandle<'a>,
    T14: crate::eager::ToTensorHandle<'a>,
    T15: crate::eager::ToTensorHandle<'a>,
    T16: crate::eager::ToTensorHandle<'a>,
    T17: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    seq_len_max: &T0,
    x: &T1,
    cs_prev: &T2,
    h_prev: &T3,
    w: &T4,
    wci: &T5,
    wcf: &T6,
    wco: &T7,
    b: &T8,
    i: &T9,
    cs: &T10,
    f: &T11,
    o: &T12,
    ci: &T13,
    co: &T14,
    h: &T15,
    cs_grad: &T16,
    h_grad: &T17,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 8]> {
    let op = BlockLSTMGrad::new();
    op.call(
        ctx,
        seq_len_max,
        x,
        cs_prev,
        h_prev,
        w,
        wci,
        wcf,
        wco,
        b,
        i,
        cs,
        f,
        o,
        ci,
        co,
        h,
        cs_grad,
        h_grad,
    )
}

/// BlockLSTMGradV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BlockLSTMGradV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BlockLSTMGradV2 {
    use_peephole: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BlockLSTMGradV2 {
    fn default() -> Self {
        Self {
            use_peephole: None,
            target_device_name: None,
        }
    }
}
impl BlockLSTMGradV2 {
    /// Creates a new `BlockLSTMGradV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_peephole` attribute.
    pub fn use_peephole<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_peephole = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute block_lstmgrad_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
        T9: crate::eager::ToTensorHandle<'a>,
        T10: crate::eager::ToTensorHandle<'a>,
        T11: crate::eager::ToTensorHandle<'a>,
        T12: crate::eager::ToTensorHandle<'a>,
        T13: crate::eager::ToTensorHandle<'a>,
        T14: crate::eager::ToTensorHandle<'a>,
        T15: crate::eager::ToTensorHandle<'a>,
        T16: crate::eager::ToTensorHandle<'a>,
        T17: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        seq_len_max: &T0,
        x: &T1,
        cs_prev: &T2,
        h_prev: &T3,
        w: &T4,
        wci: &T5,
        wcf: &T6,
        wco: &T7,
        b: &T8,
        i: &T9,
        cs: &T10,
        f: &T11,
        o: &T12,
        ci: &T13,
        co: &T14,
        h: &T15,
        cs_grad: &T16,
        h_grad: &T17,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 8]> {
        // Define Op
        let mut op = super::Op::new(ctx, "BlockLSTMGradV2")?;

        // Required input arguments
        op.add_input(&seq_len_max.to_handle(ctx)?)?;
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&cs_prev.to_handle(ctx)?)?;
        op.add_input(&h_prev.to_handle(ctx)?)?;
        op.add_input(&w.to_handle(ctx)?)?;
        op.add_input(&wci.to_handle(ctx)?)?;
        op.add_input(&wcf.to_handle(ctx)?)?;
        op.add_input(&wco.to_handle(ctx)?)?;
        op.add_input(&b.to_handle(ctx)?)?;
        op.add_input(&i.to_handle(ctx)?)?;
        op.add_input(&cs.to_handle(ctx)?)?;
        op.add_input(&f.to_handle(ctx)?)?;
        op.add_input(&o.to_handle(ctx)?)?;
        op.add_input(&ci.to_handle(ctx)?)?;
        op.add_input(&co.to_handle(ctx)?)?;
        op.add_input(&h.to_handle(ctx)?)?;
        op.add_input(&cs_grad.to_handle(ctx)?)?;
        op.add_input(&h_grad.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_peephole {
            op.set_attr_bool("use_peephole", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<8>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `BlockLSTMGradV2::new().call(&ctx, &seq_len_max, &x, &cs_prev, &h_prev, &w, &wci, &wcf, &wco, &b, &i, &cs, &f, &o, &ci, &co, &h, &cs_grad, &h_grad)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BlockLSTMGradV2>
pub fn block_lstmgrad_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
    T9: crate::eager::ToTensorHandle<'a>,
    T10: crate::eager::ToTensorHandle<'a>,
    T11: crate::eager::ToTensorHandle<'a>,
    T12: crate::eager::ToTensorHandle<'a>,
    T13: crate::eager::ToTensorHandle<'a>,
    T14: crate::eager::ToTensorHandle<'a>,
    T15: crate::eager::ToTensorHandle<'a>,
    T16: crate::eager::ToTensorHandle<'a>,
    T17: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    seq_len_max: &T0,
    x: &T1,
    cs_prev: &T2,
    h_prev: &T3,
    w: &T4,
    wci: &T5,
    wcf: &T6,
    wco: &T7,
    b: &T8,
    i: &T9,
    cs: &T10,
    f: &T11,
    o: &T12,
    ci: &T13,
    co: &T14,
    h: &T15,
    cs_grad: &T16,
    h_grad: &T17,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 8]> {
    let op = BlockLSTMGradV2::new();
    op.call(
        ctx,
        seq_len_max,
        x,
        cs_prev,
        h_prev,
        w,
        wci,
        wcf,
        wco,
        b,
        i,
        cs,
        f,
        o,
        ci,
        co,
        h,
        cs_grad,
        h_grad,
    )
}

/// BlockLSTMV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BlockLSTMV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BlockLSTMV2 {
    cell_clip: ::std::option::Option<f32>,
    use_peephole: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BlockLSTMV2 {
    fn default() -> Self {
        Self {
            cell_clip: Some(0f32),
            use_peephole: Some(false),
            target_device_name: None,
        }
    }
}
impl BlockLSTMV2 {
    /// Creates a new `BlockLSTMV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `cell_clip` attribute.
    pub fn cell_clip<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.cell_clip = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_peephole` attribute.
    pub fn use_peephole<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_peephole = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute block_lstmv2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        seq_len_max: &T0,
        x: &T1,
        cs_prev: &T2,
        h_prev: &T3,
        w: &T4,
        wci: &T5,
        wcf: &T6,
        wco: &T7,
        b: &T8,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 7]> {
        // Define Op
        let mut op = super::Op::new(ctx, "BlockLSTMV2")?;

        // Required input arguments
        op.add_input(&seq_len_max.to_handle(ctx)?)?;
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&cs_prev.to_handle(ctx)?)?;
        op.add_input(&h_prev.to_handle(ctx)?)?;
        op.add_input(&w.to_handle(ctx)?)?;
        op.add_input(&wci.to_handle(ctx)?)?;
        op.add_input(&wcf.to_handle(ctx)?)?;
        op.add_input(&wco.to_handle(ctx)?)?;
        op.add_input(&b.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.cell_clip {
            op.set_attr_float("cell_clip", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_peephole {
            op.set_attr_bool("use_peephole", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<7>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `BlockLSTMV2::new().call(&ctx, &seq_len_max, &x, &cs_prev, &h_prev, &w, &wci, &wcf, &wco, &b)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BlockLSTMV2>
pub fn block_lstmv2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    seq_len_max: &T0,
    x: &T1,
    cs_prev: &T2,
    h_prev: &T3,
    w: &T4,
    wci: &T5,
    wcf: &T6,
    wco: &T7,
    b: &T8,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 7]> {
    let op = BlockLSTMV2::new();
    op.call(ctx, seq_len_max, x, cs_prev, h_prev, w, wci, wcf, wco, b)
}

/// BoostedTreesAggregateStats
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesAggregateStats>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BoostedTreesAggregateStats {
    max_splits: ::std::option::Option<i64>,
    num_buckets: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BoostedTreesAggregateStats {
    fn default() -> Self {
        Self {
            max_splits: None,
            num_buckets: None,
            target_device_name: None,
        }
    }
}
impl BoostedTreesAggregateStats {
    /// Creates a new `BoostedTreesAggregateStats`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `max_splits` attribute.
    pub fn max_splits<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.max_splits = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_buckets` attribute.
    pub fn num_buckets<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_buckets = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute boosted_trees_aggregate_stats.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        node_ids: &T0,
        gradients: &T1,
        hessians: &T2,
        feature: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BoostedTreesAggregateStats")?;

        // Required input arguments
        op.add_input(&node_ids.to_handle(ctx)?)?;
        op.add_input(&gradients.to_handle(ctx)?)?;
        op.add_input(&hessians.to_handle(ctx)?)?;
        op.add_input(&feature.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.max_splits {
            op.set_attr_int("max_splits", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_buckets {
            op.set_attr_int("num_buckets", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BoostedTreesAggregateStats::new().call(&ctx, &node_ids, &gradients, &hessians, &feature)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesAggregateStats>
pub fn boosted_trees_aggregate_stats<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    node_ids: &T0,
    gradients: &T1,
    hessians: &T2,
    feature: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BoostedTreesAggregateStats::new();
    op.call(ctx, node_ids, gradients, hessians, feature)
}

/// BoostedTreesBucketize
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesBucketize>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BoostedTreesBucketize {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BoostedTreesBucketize {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BoostedTreesBucketize {
    /// Creates a new `BoostedTreesBucketize`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute boosted_trees_bucketize.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        float_values: &[&T0],
        bucket_boundaries: &[&T1],
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BoostedTreesBucketize")?;

        // Required input arguments
        let mut float_values_list = Vec::new();

        for t in float_values {
            float_values_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&float_values_list)?;
        let mut bucket_boundaries_list = Vec::new();

        for t in bucket_boundaries {
            bucket_boundaries_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&bucket_boundaries_list)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BoostedTreesBucketize::new().call(&ctx, &float_values, &bucket_boundaries)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesBucketize>
pub fn boosted_trees_bucketize<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    float_values: &[&T0],
    bucket_boundaries: &[&T1],
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BoostedTreesBucketize::new();
    op.call(ctx, float_values, bucket_boundaries)
}

/// BoostedTreesCalculateBestFeatureSplit
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesCalculateBestFeatureSplit>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BoostedTreesCalculateBestFeatureSplit {
    logits_dimension: ::std::option::Option<i64>,
    split_type: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BoostedTreesCalculateBestFeatureSplit {
    fn default() -> Self {
        Self {
            logits_dimension: None,
            split_type: Some(::std::string::String::from("inequality")),
            target_device_name: None,
        }
    }
}
impl BoostedTreesCalculateBestFeatureSplit {
    /// Creates a new `BoostedTreesCalculateBestFeatureSplit`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `logits_dimension` attribute.
    pub fn logits_dimension<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.logits_dimension = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `split_type` attribute.
    pub fn split_type<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.split_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute boosted_trees_calculate_best_feature_split.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        node_id_range: &T0,
        stats_summary: &T1,
        l1: &T2,
        l2: &T3,
        tree_complexity: &T4,
        min_node_weight: &T5,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 7]> {
        // Define Op
        let mut op = super::Op::new(ctx, "BoostedTreesCalculateBestFeatureSplit")?;

        // Required input arguments
        op.add_input(&node_id_range.to_handle(ctx)?)?;
        op.add_input(&stats_summary.to_handle(ctx)?)?;
        op.add_input(&l1.to_handle(ctx)?)?;
        op.add_input(&l2.to_handle(ctx)?)?;
        op.add_input(&tree_complexity.to_handle(ctx)?)?;
        op.add_input(&min_node_weight.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.logits_dimension {
            op.set_attr_int("logits_dimension", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.split_type {
            op.set_attr_string("split_type", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<7>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `BoostedTreesCalculateBestFeatureSplit::new().call(&ctx, &node_id_range, &stats_summary, &l1, &l2, &tree_complexity, &min_node_weight)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesCalculateBestFeatureSplit>
pub fn boosted_trees_calculate_best_feature_split<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    node_id_range: &T0,
    stats_summary: &T1,
    l1: &T2,
    l2: &T3,
    tree_complexity: &T4,
    min_node_weight: &T5,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 7]> {
    let op = BoostedTreesCalculateBestFeatureSplit::new();
    op.call(
        ctx,
        node_id_range,
        stats_summary,
        l1,
        l2,
        tree_complexity,
        min_node_weight,
    )
}

/// BoostedTreesCalculateBestFeatureSplitV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesCalculateBestFeatureSplitV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BoostedTreesCalculateBestFeatureSplitV2 {
    logits_dimension: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BoostedTreesCalculateBestFeatureSplitV2 {
    fn default() -> Self {
        Self {
            logits_dimension: None,
            target_device_name: None,
        }
    }
}
impl BoostedTreesCalculateBestFeatureSplitV2 {
    /// Creates a new `BoostedTreesCalculateBestFeatureSplitV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `logits_dimension` attribute.
    pub fn logits_dimension<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.logits_dimension = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute boosted_trees_calculate_best_feature_split_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        node_id_range: &T0,
        stats_summaries_list: &[&T1],
        split_types: &T2,
        candidate_feature_ids: &T3,
        l1: &T4,
        l2: &T5,
        tree_complexity: &T6,
        min_node_weight: &T7,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 8]> {
        // Define Op
        let mut op = super::Op::new(ctx, "BoostedTreesCalculateBestFeatureSplitV2")?;

        // Required input arguments
        op.add_input(&node_id_range.to_handle(ctx)?)?;
        let mut stats_summaries_list_list = Vec::new();

        for t in stats_summaries_list {
            stats_summaries_list_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&stats_summaries_list_list)?;
        op.add_input(&split_types.to_handle(ctx)?)?;
        op.add_input(&candidate_feature_ids.to_handle(ctx)?)?;
        op.add_input(&l1.to_handle(ctx)?)?;
        op.add_input(&l2.to_handle(ctx)?)?;
        op.add_input(&tree_complexity.to_handle(ctx)?)?;
        op.add_input(&min_node_weight.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.logits_dimension {
            op.set_attr_int("logits_dimension", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<8>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `BoostedTreesCalculateBestFeatureSplitV2::new().call(&ctx, &node_id_range, &stats_summaries_list, &split_types, &candidate_feature_ids, &l1, &l2, &tree_complexity, &min_node_weight)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesCalculateBestFeatureSplitV2>
pub fn boosted_trees_calculate_best_feature_split_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    node_id_range: &T0,
    stats_summaries_list: &[&T1],
    split_types: &T2,
    candidate_feature_ids: &T3,
    l1: &T4,
    l2: &T5,
    tree_complexity: &T6,
    min_node_weight: &T7,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 8]> {
    let op = BoostedTreesCalculateBestFeatureSplitV2::new();
    op.call(
        ctx,
        node_id_range,
        stats_summaries_list,
        split_types,
        candidate_feature_ids,
        l1,
        l2,
        tree_complexity,
        min_node_weight,
    )
}

/// BoostedTreesCalculateBestGainsPerFeature
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesCalculateBestGainsPerFeature>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BoostedTreesCalculateBestGainsPerFeature {
    max_splits: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BoostedTreesCalculateBestGainsPerFeature {
    fn default() -> Self {
        Self {
            max_splits: None,
            target_device_name: None,
        }
    }
}
impl BoostedTreesCalculateBestGainsPerFeature {
    /// Creates a new `BoostedTreesCalculateBestGainsPerFeature`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `max_splits` attribute.
    pub fn max_splits<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.max_splits = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute boosted_trees_calculate_best_gains_per_feature.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        node_id_range: &T0,
        stats_summary_list: &[&T1],
        l1: &T2,
        l2: &T3,
        tree_complexity: &T4,
        min_node_weight: &T5,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 5]> {
        // Define Op
        let mut op = super::Op::new(ctx, "BoostedTreesCalculateBestGainsPerFeature")?;

        // Required input arguments
        op.add_input(&node_id_range.to_handle(ctx)?)?;
        let mut stats_summary_list_list = Vec::new();

        for t in stats_summary_list {
            stats_summary_list_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&stats_summary_list_list)?;
        op.add_input(&l1.to_handle(ctx)?)?;
        op.add_input(&l2.to_handle(ctx)?)?;
        op.add_input(&tree_complexity.to_handle(ctx)?)?;
        op.add_input(&min_node_weight.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.max_splits {
            op.set_attr_int("max_splits", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<5>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `BoostedTreesCalculateBestGainsPerFeature::new().call(&ctx, &node_id_range, &stats_summary_list, &l1, &l2, &tree_complexity, &min_node_weight)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesCalculateBestGainsPerFeature>
pub fn boosted_trees_calculate_best_gains_per_feature<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    node_id_range: &T0,
    stats_summary_list: &[&T1],
    l1: &T2,
    l2: &T3,
    tree_complexity: &T4,
    min_node_weight: &T5,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 5]> {
    let op = BoostedTreesCalculateBestGainsPerFeature::new();
    op.call(
        ctx,
        node_id_range,
        stats_summary_list,
        l1,
        l2,
        tree_complexity,
        min_node_weight,
    )
}

/// BoostedTreesCenterBias
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesCenterBias>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BoostedTreesCenterBias {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BoostedTreesCenterBias {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BoostedTreesCenterBias {
    /// Creates a new `BoostedTreesCenterBias`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute boosted_trees_center_bias.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        tree_ensemble_handle: &T0,
        mean_gradients: &T1,
        mean_hessians: &T2,
        l1: &T3,
        l2: &T4,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BoostedTreesCenterBias")?;

        // Required input arguments
        op.add_input(&tree_ensemble_handle.to_handle(ctx)?)?;
        op.add_input(&mean_gradients.to_handle(ctx)?)?;
        op.add_input(&mean_hessians.to_handle(ctx)?)?;
        op.add_input(&l1.to_handle(ctx)?)?;
        op.add_input(&l2.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BoostedTreesCenterBias::new().call(&ctx, &tree_ensemble_handle, &mean_gradients, &mean_hessians, &l1, &l2)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesCenterBias>
pub fn boosted_trees_center_bias<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    tree_ensemble_handle: &T0,
    mean_gradients: &T1,
    mean_hessians: &T2,
    l1: &T3,
    l2: &T4,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BoostedTreesCenterBias::new();
    op.call(
        ctx,
        tree_ensemble_handle,
        mean_gradients,
        mean_hessians,
        l1,
        l2,
    )
}

/// BoostedTreesCreateEnsemble
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesCreateEnsemble>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BoostedTreesCreateEnsemble {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BoostedTreesCreateEnsemble {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BoostedTreesCreateEnsemble {
    /// Creates a new `BoostedTreesCreateEnsemble`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute boosted_trees_create_ensemble.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        tree_ensemble_handle: &T0,
        stamp_token: &T1,
        tree_ensemble_serialized: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "BoostedTreesCreateEnsemble")?;

        // Required input arguments
        op.add_input(&tree_ensemble_handle.to_handle(ctx)?)?;
        op.add_input(&stamp_token.to_handle(ctx)?)?;
        op.add_input(&tree_ensemble_serialized.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `BoostedTreesCreateEnsemble::new().call(&ctx, &tree_ensemble_handle, &stamp_token, &tree_ensemble_serialized)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesCreateEnsemble>
pub fn boosted_trees_create_ensemble<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    tree_ensemble_handle: &T0,
    stamp_token: &T1,
    tree_ensemble_serialized: &T2,
) -> crate::Result<()> {
    let op = BoostedTreesCreateEnsemble::new();
    op.call(
        ctx,
        tree_ensemble_handle,
        stamp_token,
        tree_ensemble_serialized,
    )
}

/// BoostedTreesCreateQuantileStreamResource
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesCreateQuantileStreamResource>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BoostedTreesCreateQuantileStreamResource {
    max_elements: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BoostedTreesCreateQuantileStreamResource {
    fn default() -> Self {
        Self {
            max_elements: Some(1099511627776i64),
            target_device_name: None,
        }
    }
}
impl BoostedTreesCreateQuantileStreamResource {
    /// Creates a new `BoostedTreesCreateQuantileStreamResource`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `max_elements` attribute.
    pub fn max_elements<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.max_elements = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute boosted_trees_create_quantile_stream_resource.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        quantile_stream_resource_handle: &T0,
        epsilon: &T1,
        num_streams: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "BoostedTreesCreateQuantileStreamResource")?;

        // Required input arguments
        op.add_input(&quantile_stream_resource_handle.to_handle(ctx)?)?;
        op.add_input(&epsilon.to_handle(ctx)?)?;
        op.add_input(&num_streams.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.max_elements {
            op.set_attr_int("max_elements", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `BoostedTreesCreateQuantileStreamResource::new().call(&ctx, &quantile_stream_resource_handle, &epsilon, &num_streams)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesCreateQuantileStreamResource>
pub fn boosted_trees_create_quantile_stream_resource<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    quantile_stream_resource_handle: &T0,
    epsilon: &T1,
    num_streams: &T2,
) -> crate::Result<()> {
    let op = BoostedTreesCreateQuantileStreamResource::new();
    op.call(ctx, quantile_stream_resource_handle, epsilon, num_streams)
}

/// BoostedTreesDeserializeEnsemble
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesDeserializeEnsemble>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BoostedTreesDeserializeEnsemble {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BoostedTreesDeserializeEnsemble {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BoostedTreesDeserializeEnsemble {
    /// Creates a new `BoostedTreesDeserializeEnsemble`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute boosted_trees_deserialize_ensemble.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        tree_ensemble_handle: &T0,
        stamp_token: &T1,
        tree_ensemble_serialized: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "BoostedTreesDeserializeEnsemble")?;

        // Required input arguments
        op.add_input(&tree_ensemble_handle.to_handle(ctx)?)?;
        op.add_input(&stamp_token.to_handle(ctx)?)?;
        op.add_input(&tree_ensemble_serialized.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `BoostedTreesDeserializeEnsemble::new().call(&ctx, &tree_ensemble_handle, &stamp_token, &tree_ensemble_serialized)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesDeserializeEnsemble>
pub fn boosted_trees_deserialize_ensemble<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    tree_ensemble_handle: &T0,
    stamp_token: &T1,
    tree_ensemble_serialized: &T2,
) -> crate::Result<()> {
    let op = BoostedTreesDeserializeEnsemble::new();
    op.call(
        ctx,
        tree_ensemble_handle,
        stamp_token,
        tree_ensemble_serialized,
    )
}

/// BoostedTreesEnsembleResourceHandleOp
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesEnsembleResourceHandleOp>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BoostedTreesEnsembleResourceHandleOp {
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BoostedTreesEnsembleResourceHandleOp {
    fn default() -> Self {
        Self {
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl BoostedTreesEnsembleResourceHandleOp {
    /// Creates a new `BoostedTreesEnsembleResourceHandleOp`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute boosted_trees_ensemble_resource_handle_op.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BoostedTreesEnsembleResourceHandleOp")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BoostedTreesEnsembleResourceHandleOp::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesEnsembleResourceHandleOp>
pub fn boosted_trees_ensemble_resource_handle_op<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BoostedTreesEnsembleResourceHandleOp::new();
    op.call(ctx)
}

/// BoostedTreesExampleDebugOutputs
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesExampleDebugOutputs>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BoostedTreesExampleDebugOutputs {
    logits_dimension: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BoostedTreesExampleDebugOutputs {
    fn default() -> Self {
        Self {
            logits_dimension: None,
            target_device_name: None,
        }
    }
}
impl BoostedTreesExampleDebugOutputs {
    /// Creates a new `BoostedTreesExampleDebugOutputs`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `logits_dimension` attribute.
    pub fn logits_dimension<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.logits_dimension = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute boosted_trees_example_debug_outputs.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        tree_ensemble_handle: &T0,
        bucketized_features: &[&T1],
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BoostedTreesExampleDebugOutputs")?;

        // Required input arguments
        op.add_input(&tree_ensemble_handle.to_handle(ctx)?)?;
        let mut bucketized_features_list = Vec::new();

        for t in bucketized_features {
            bucketized_features_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&bucketized_features_list)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.logits_dimension {
            op.set_attr_int("logits_dimension", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BoostedTreesExampleDebugOutputs::new().call(&ctx, &tree_ensemble_handle, &bucketized_features)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesExampleDebugOutputs>
pub fn boosted_trees_example_debug_outputs<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    tree_ensemble_handle: &T0,
    bucketized_features: &[&T1],
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BoostedTreesExampleDebugOutputs::new();
    op.call(ctx, tree_ensemble_handle, bucketized_features)
}

/// BoostedTreesFlushQuantileSummaries
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesFlushQuantileSummaries>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BoostedTreesFlushQuantileSummaries {
    num_features: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BoostedTreesFlushQuantileSummaries {
    fn default() -> Self {
        Self {
            num_features: None,
            target_device_name: None,
        }
    }
}
impl BoostedTreesFlushQuantileSummaries {
    /// Creates a new `BoostedTreesFlushQuantileSummaries`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_features` attribute.
    pub fn num_features<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_features = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute boosted_trees_flush_quantile_summaries.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        quantile_stream_resource_handle: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BoostedTreesFlushQuantileSummaries")?;

        // Required input arguments
        op.add_input(&quantile_stream_resource_handle.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_features {
            op.set_attr_int("num_features", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BoostedTreesFlushQuantileSummaries::new().call(&ctx, &quantile_stream_resource_handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesFlushQuantileSummaries>
pub fn boosted_trees_flush_quantile_summaries<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    quantile_stream_resource_handle: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BoostedTreesFlushQuantileSummaries::new();
    op.call(ctx, quantile_stream_resource_handle)
}

/// BoostedTreesGetEnsembleStates
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesGetEnsembleStates>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BoostedTreesGetEnsembleStates {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BoostedTreesGetEnsembleStates {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BoostedTreesGetEnsembleStates {
    /// Creates a new `BoostedTreesGetEnsembleStates`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute boosted_trees_get_ensemble_states.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        tree_ensemble_handle: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 5]> {
        // Define Op
        let mut op = super::Op::new(ctx, "BoostedTreesGetEnsembleStates")?;

        // Required input arguments
        op.add_input(&tree_ensemble_handle.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<5>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `BoostedTreesGetEnsembleStates::new().call(&ctx, &tree_ensemble_handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesGetEnsembleStates>
pub fn boosted_trees_get_ensemble_states<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    tree_ensemble_handle: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 5]> {
    let op = BoostedTreesGetEnsembleStates::new();
    op.call(ctx, tree_ensemble_handle)
}

/// BoostedTreesMakeQuantileSummaries
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesMakeQuantileSummaries>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BoostedTreesMakeQuantileSummaries {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BoostedTreesMakeQuantileSummaries {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BoostedTreesMakeQuantileSummaries {
    /// Creates a new `BoostedTreesMakeQuantileSummaries`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute boosted_trees_make_quantile_summaries.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        float_values: &[&T0],
        example_weights: &T1,
        epsilon: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BoostedTreesMakeQuantileSummaries")?;

        // Required input arguments
        let mut float_values_list = Vec::new();

        for t in float_values {
            float_values_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&float_values_list)?;
        op.add_input(&example_weights.to_handle(ctx)?)?;
        op.add_input(&epsilon.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BoostedTreesMakeQuantileSummaries::new().call(&ctx, &float_values, &example_weights, &epsilon)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesMakeQuantileSummaries>
pub fn boosted_trees_make_quantile_summaries<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    float_values: &[&T0],
    example_weights: &T1,
    epsilon: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BoostedTreesMakeQuantileSummaries::new();
    op.call(ctx, float_values, example_weights, epsilon)
}

/// BoostedTreesMakeStatsSummary
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesMakeStatsSummary>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BoostedTreesMakeStatsSummary {
    max_splits: ::std::option::Option<i64>,
    num_buckets: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BoostedTreesMakeStatsSummary {
    fn default() -> Self {
        Self {
            max_splits: None,
            num_buckets: None,
            target_device_name: None,
        }
    }
}
impl BoostedTreesMakeStatsSummary {
    /// Creates a new `BoostedTreesMakeStatsSummary`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `max_splits` attribute.
    pub fn max_splits<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.max_splits = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_buckets` attribute.
    pub fn num_buckets<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_buckets = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute boosted_trees_make_stats_summary.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        node_ids: &T0,
        gradients: &T1,
        hessians: &T2,
        bucketized_features_list: &[&T3],
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BoostedTreesMakeStatsSummary")?;

        // Required input arguments
        op.add_input(&node_ids.to_handle(ctx)?)?;
        op.add_input(&gradients.to_handle(ctx)?)?;
        op.add_input(&hessians.to_handle(ctx)?)?;
        let mut bucketized_features_list_list = Vec::new();

        for t in bucketized_features_list {
            bucketized_features_list_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&bucketized_features_list_list)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.max_splits {
            op.set_attr_int("max_splits", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_buckets {
            op.set_attr_int("num_buckets", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BoostedTreesMakeStatsSummary::new().call(&ctx, &node_ids, &gradients, &hessians, &bucketized_features_list)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesMakeStatsSummary>
pub fn boosted_trees_make_stats_summary<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    node_ids: &T0,
    gradients: &T1,
    hessians: &T2,
    bucketized_features_list: &[&T3],
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BoostedTreesMakeStatsSummary::new();
    op.call(ctx, node_ids, gradients, hessians, bucketized_features_list)
}

/// BoostedTreesPredict
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesPredict>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BoostedTreesPredict {
    logits_dimension: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BoostedTreesPredict {
    fn default() -> Self {
        Self {
            logits_dimension: None,
            target_device_name: None,
        }
    }
}
impl BoostedTreesPredict {
    /// Creates a new `BoostedTreesPredict`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `logits_dimension` attribute.
    pub fn logits_dimension<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.logits_dimension = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute boosted_trees_predict.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        tree_ensemble_handle: &T0,
        bucketized_features: &[&T1],
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BoostedTreesPredict")?;

        // Required input arguments
        op.add_input(&tree_ensemble_handle.to_handle(ctx)?)?;
        let mut bucketized_features_list = Vec::new();

        for t in bucketized_features {
            bucketized_features_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&bucketized_features_list)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.logits_dimension {
            op.set_attr_int("logits_dimension", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BoostedTreesPredict::new().call(&ctx, &tree_ensemble_handle, &bucketized_features)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesPredict>
pub fn boosted_trees_predict<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    tree_ensemble_handle: &T0,
    bucketized_features: &[&T1],
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BoostedTreesPredict::new();
    op.call(ctx, tree_ensemble_handle, bucketized_features)
}

/// BoostedTreesQuantileStreamResourceAddSummaries
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesQuantileStreamResourceAddSummaries>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BoostedTreesQuantileStreamResourceAddSummaries {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BoostedTreesQuantileStreamResourceAddSummaries {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BoostedTreesQuantileStreamResourceAddSummaries {
    /// Creates a new `BoostedTreesQuantileStreamResourceAddSummaries`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute boosted_trees_quantile_stream_resource_add_summaries.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        quantile_stream_resource_handle: &T0,
        summaries: &[&T1],
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "BoostedTreesQuantileStreamResourceAddSummaries")?;

        // Required input arguments
        op.add_input(&quantile_stream_resource_handle.to_handle(ctx)?)?;
        let mut summaries_list = Vec::new();

        for t in summaries {
            summaries_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&summaries_list)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `BoostedTreesQuantileStreamResourceAddSummaries::new().call(&ctx, &quantile_stream_resource_handle, &summaries)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesQuantileStreamResourceAddSummaries>
pub fn boosted_trees_quantile_stream_resource_add_summaries<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    quantile_stream_resource_handle: &T0,
    summaries: &[&T1],
) -> crate::Result<()> {
    let op = BoostedTreesQuantileStreamResourceAddSummaries::new();
    op.call(ctx, quantile_stream_resource_handle, summaries)
}

/// BoostedTreesQuantileStreamResourceDeserialize
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesQuantileStreamResourceDeserialize>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BoostedTreesQuantileStreamResourceDeserialize {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BoostedTreesQuantileStreamResourceDeserialize {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BoostedTreesQuantileStreamResourceDeserialize {
    /// Creates a new `BoostedTreesQuantileStreamResourceDeserialize`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute boosted_trees_quantile_stream_resource_deserialize.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        quantile_stream_resource_handle: &T0,
        bucket_boundaries: &[&T1],
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "BoostedTreesQuantileStreamResourceDeserialize")?;

        // Required input arguments
        op.add_input(&quantile_stream_resource_handle.to_handle(ctx)?)?;
        let mut bucket_boundaries_list = Vec::new();

        for t in bucket_boundaries {
            bucket_boundaries_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&bucket_boundaries_list)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `BoostedTreesQuantileStreamResourceDeserialize::new().call(&ctx, &quantile_stream_resource_handle, &bucket_boundaries)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesQuantileStreamResourceDeserialize>
pub fn boosted_trees_quantile_stream_resource_deserialize<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    quantile_stream_resource_handle: &T0,
    bucket_boundaries: &[&T1],
) -> crate::Result<()> {
    let op = BoostedTreesQuantileStreamResourceDeserialize::new();
    op.call(ctx, quantile_stream_resource_handle, bucket_boundaries)
}

/// BoostedTreesQuantileStreamResourceFlush
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesQuantileStreamResourceFlush>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BoostedTreesQuantileStreamResourceFlush {
    generate_quantiles: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BoostedTreesQuantileStreamResourceFlush {
    fn default() -> Self {
        Self {
            generate_quantiles: Some(false),
            target_device_name: None,
        }
    }
}
impl BoostedTreesQuantileStreamResourceFlush {
    /// Creates a new `BoostedTreesQuantileStreamResourceFlush`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `generate_quantiles` attribute.
    pub fn generate_quantiles<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.generate_quantiles = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute boosted_trees_quantile_stream_resource_flush.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        quantile_stream_resource_handle: &T0,
        num_buckets: &T1,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "BoostedTreesQuantileStreamResourceFlush")?;

        // Required input arguments
        op.add_input(&quantile_stream_resource_handle.to_handle(ctx)?)?;
        op.add_input(&num_buckets.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.generate_quantiles {
            op.set_attr_bool("generate_quantiles", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `BoostedTreesQuantileStreamResourceFlush::new().call(&ctx, &quantile_stream_resource_handle, &num_buckets)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesQuantileStreamResourceFlush>
pub fn boosted_trees_quantile_stream_resource_flush<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    quantile_stream_resource_handle: &T0,
    num_buckets: &T1,
) -> crate::Result<()> {
    let op = BoostedTreesQuantileStreamResourceFlush::new();
    op.call(ctx, quantile_stream_resource_handle, num_buckets)
}

/// BoostedTreesQuantileStreamResourceGetBucketBoundaries
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesQuantileStreamResourceGetBucketBoundaries>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BoostedTreesQuantileStreamResourceGetBucketBoundaries {
    num_features: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BoostedTreesQuantileStreamResourceGetBucketBoundaries {
    fn default() -> Self {
        Self {
            num_features: None,
            target_device_name: None,
        }
    }
}
impl BoostedTreesQuantileStreamResourceGetBucketBoundaries {
    /// Creates a new `BoostedTreesQuantileStreamResourceGetBucketBoundaries`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_features` attribute.
    pub fn num_features<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_features = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute boosted_trees_quantile_stream_resource_get_bucket_boundaries.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        quantile_stream_resource_handle: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BoostedTreesQuantileStreamResourceGetBucketBoundaries")?;

        // Required input arguments
        op.add_input(&quantile_stream_resource_handle.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_features {
            op.set_attr_int("num_features", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BoostedTreesQuantileStreamResourceGetBucketBoundaries::new().call(&ctx, &quantile_stream_resource_handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesQuantileStreamResourceGetBucketBoundaries>
pub fn boosted_trees_quantile_stream_resource_get_bucket_boundaries<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    quantile_stream_resource_handle: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BoostedTreesQuantileStreamResourceGetBucketBoundaries::new();
    op.call(ctx, quantile_stream_resource_handle)
}

/// BoostedTreesQuantileStreamResourceHandleOp
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesQuantileStreamResourceHandleOp>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BoostedTreesQuantileStreamResourceHandleOp {
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BoostedTreesQuantileStreamResourceHandleOp {
    fn default() -> Self {
        Self {
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl BoostedTreesQuantileStreamResourceHandleOp {
    /// Creates a new `BoostedTreesQuantileStreamResourceHandleOp`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute boosted_trees_quantile_stream_resource_handle_op.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BoostedTreesQuantileStreamResourceHandleOp")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BoostedTreesQuantileStreamResourceHandleOp::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesQuantileStreamResourceHandleOp>
pub fn boosted_trees_quantile_stream_resource_handle_op<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BoostedTreesQuantileStreamResourceHandleOp::new();
    op.call(ctx)
}

/// BoostedTreesSerializeEnsemble
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesSerializeEnsemble>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BoostedTreesSerializeEnsemble {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BoostedTreesSerializeEnsemble {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BoostedTreesSerializeEnsemble {
    /// Creates a new `BoostedTreesSerializeEnsemble`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute boosted_trees_serialize_ensemble.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        tree_ensemble_handle: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "BoostedTreesSerializeEnsemble")?;

        // Required input arguments
        op.add_input(&tree_ensemble_handle.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `BoostedTreesSerializeEnsemble::new().call(&ctx, &tree_ensemble_handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesSerializeEnsemble>
pub fn boosted_trees_serialize_ensemble<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    tree_ensemble_handle: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = BoostedTreesSerializeEnsemble::new();
    op.call(ctx, tree_ensemble_handle)
}

/// BoostedTreesSparseAggregateStats
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesSparseAggregateStats>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BoostedTreesSparseAggregateStats {
    max_splits: ::std::option::Option<i64>,
    num_buckets: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BoostedTreesSparseAggregateStats {
    fn default() -> Self {
        Self {
            max_splits: None,
            num_buckets: None,
            target_device_name: None,
        }
    }
}
impl BoostedTreesSparseAggregateStats {
    /// Creates a new `BoostedTreesSparseAggregateStats`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `max_splits` attribute.
    pub fn max_splits<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.max_splits = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_buckets` attribute.
    pub fn num_buckets<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_buckets = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute boosted_trees_sparse_aggregate_stats.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        node_ids: &T0,
        gradients: &T1,
        hessians: &T2,
        feature_indices: &T3,
        feature_values: &T4,
        feature_shape: &T5,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "BoostedTreesSparseAggregateStats")?;

        // Required input arguments
        op.add_input(&node_ids.to_handle(ctx)?)?;
        op.add_input(&gradients.to_handle(ctx)?)?;
        op.add_input(&hessians.to_handle(ctx)?)?;
        op.add_input(&feature_indices.to_handle(ctx)?)?;
        op.add_input(&feature_values.to_handle(ctx)?)?;
        op.add_input(&feature_shape.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.max_splits {
            op.set_attr_int("max_splits", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_buckets {
            op.set_attr_int("num_buckets", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `BoostedTreesSparseAggregateStats::new().call(&ctx, &node_ids, &gradients, &hessians, &feature_indices, &feature_values, &feature_shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesSparseAggregateStats>
pub fn boosted_trees_sparse_aggregate_stats<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    node_ids: &T0,
    gradients: &T1,
    hessians: &T2,
    feature_indices: &T3,
    feature_values: &T4,
    feature_shape: &T5,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = BoostedTreesSparseAggregateStats::new();
    op.call(
        ctx,
        node_ids,
        gradients,
        hessians,
        feature_indices,
        feature_values,
        feature_shape,
    )
}

/// BoostedTreesSparseCalculateBestFeatureSplit
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesSparseCalculateBestFeatureSplit>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BoostedTreesSparseCalculateBestFeatureSplit {
    logits_dimension: ::std::option::Option<i64>,
    split_type: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BoostedTreesSparseCalculateBestFeatureSplit {
    fn default() -> Self {
        Self {
            logits_dimension: None,
            split_type: Some(::std::string::String::from("inequality")),
            target_device_name: None,
        }
    }
}
impl BoostedTreesSparseCalculateBestFeatureSplit {
    /// Creates a new `BoostedTreesSparseCalculateBestFeatureSplit`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `logits_dimension` attribute.
    pub fn logits_dimension<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.logits_dimension = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `split_type` attribute.
    pub fn split_type<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.split_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute boosted_trees_sparse_calculate_best_feature_split.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        node_id_range: &T0,
        stats_summary_indices: &T1,
        stats_summary_values: &T2,
        stats_summary_shape: &T3,
        l1: &T4,
        l2: &T5,
        tree_complexity: &T6,
        min_node_weight: &T7,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 7]> {
        // Define Op
        let mut op = super::Op::new(ctx, "BoostedTreesSparseCalculateBestFeatureSplit")?;

        // Required input arguments
        op.add_input(&node_id_range.to_handle(ctx)?)?;
        op.add_input(&stats_summary_indices.to_handle(ctx)?)?;
        op.add_input(&stats_summary_values.to_handle(ctx)?)?;
        op.add_input(&stats_summary_shape.to_handle(ctx)?)?;
        op.add_input(&l1.to_handle(ctx)?)?;
        op.add_input(&l2.to_handle(ctx)?)?;
        op.add_input(&tree_complexity.to_handle(ctx)?)?;
        op.add_input(&min_node_weight.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.logits_dimension {
            op.set_attr_int("logits_dimension", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.split_type {
            op.set_attr_string("split_type", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<7>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `BoostedTreesSparseCalculateBestFeatureSplit::new().call(&ctx, &node_id_range, &stats_summary_indices, &stats_summary_values, &stats_summary_shape, &l1, &l2, &tree_complexity, &min_node_weight)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesSparseCalculateBestFeatureSplit>
pub fn boosted_trees_sparse_calculate_best_feature_split<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    node_id_range: &T0,
    stats_summary_indices: &T1,
    stats_summary_values: &T2,
    stats_summary_shape: &T3,
    l1: &T4,
    l2: &T5,
    tree_complexity: &T6,
    min_node_weight: &T7,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 7]> {
    let op = BoostedTreesSparseCalculateBestFeatureSplit::new();
    op.call(
        ctx,
        node_id_range,
        stats_summary_indices,
        stats_summary_values,
        stats_summary_shape,
        l1,
        l2,
        tree_complexity,
        min_node_weight,
    )
}

/// BoostedTreesTrainingPredict
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesTrainingPredict>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BoostedTreesTrainingPredict {
    logits_dimension: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BoostedTreesTrainingPredict {
    fn default() -> Self {
        Self {
            logits_dimension: None,
            target_device_name: None,
        }
    }
}
impl BoostedTreesTrainingPredict {
    /// Creates a new `BoostedTreesTrainingPredict`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `logits_dimension` attribute.
    pub fn logits_dimension<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.logits_dimension = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute boosted_trees_training_predict.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        tree_ensemble_handle: &T0,
        cached_tree_ids: &T1,
        cached_node_ids: &T2,
        bucketized_features: &[&T3],
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "BoostedTreesTrainingPredict")?;

        // Required input arguments
        op.add_input(&tree_ensemble_handle.to_handle(ctx)?)?;
        op.add_input(&cached_tree_ids.to_handle(ctx)?)?;
        op.add_input(&cached_node_ids.to_handle(ctx)?)?;
        let mut bucketized_features_list = Vec::new();

        for t in bucketized_features {
            bucketized_features_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&bucketized_features_list)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.logits_dimension {
            op.set_attr_int("logits_dimension", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `BoostedTreesTrainingPredict::new().call(&ctx, &tree_ensemble_handle, &cached_tree_ids, &cached_node_ids, &bucketized_features)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesTrainingPredict>
pub fn boosted_trees_training_predict<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    tree_ensemble_handle: &T0,
    cached_tree_ids: &T1,
    cached_node_ids: &T2,
    bucketized_features: &[&T3],
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = BoostedTreesTrainingPredict::new();
    op.call(
        ctx,
        tree_ensemble_handle,
        cached_tree_ids,
        cached_node_ids,
        bucketized_features,
    )
}

/// BoostedTreesUpdateEnsemble
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesUpdateEnsemble>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BoostedTreesUpdateEnsemble {
    pruning_mode: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BoostedTreesUpdateEnsemble {
    fn default() -> Self {
        Self {
            pruning_mode: None,
            target_device_name: None,
        }
    }
}
impl BoostedTreesUpdateEnsemble {
    /// Creates a new `BoostedTreesUpdateEnsemble`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `pruning_mode` attribute.
    pub fn pruning_mode<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.pruning_mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute boosted_trees_update_ensemble.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        tree_ensemble_handle: &T0,
        feature_ids: &T1,
        node_ids: &[&T2],
        gains: &[&T3],
        thresholds: &[&T4],
        left_node_contribs: &[&T5],
        right_node_contribs: &[&T6],
        max_depth: &T7,
        learning_rate: &T8,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "BoostedTreesUpdateEnsemble")?;

        // Required input arguments
        op.add_input(&tree_ensemble_handle.to_handle(ctx)?)?;
        op.add_input(&feature_ids.to_handle(ctx)?)?;
        let mut node_ids_list = Vec::new();

        for t in node_ids {
            node_ids_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&node_ids_list)?;
        let mut gains_list = Vec::new();

        for t in gains {
            gains_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&gains_list)?;
        let mut thresholds_list = Vec::new();

        for t in thresholds {
            thresholds_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&thresholds_list)?;
        let mut left_node_contribs_list = Vec::new();

        for t in left_node_contribs {
            left_node_contribs_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&left_node_contribs_list)?;
        let mut right_node_contribs_list = Vec::new();

        for t in right_node_contribs {
            right_node_contribs_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&right_node_contribs_list)?;
        op.add_input(&max_depth.to_handle(ctx)?)?;
        op.add_input(&learning_rate.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.pruning_mode {
            op.set_attr_int("pruning_mode", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `BoostedTreesUpdateEnsemble::new().call(&ctx, &tree_ensemble_handle, &feature_ids, &node_ids, &gains, &thresholds, &left_node_contribs, &right_node_contribs, &max_depth, &learning_rate)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesUpdateEnsemble>
pub fn boosted_trees_update_ensemble<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    tree_ensemble_handle: &T0,
    feature_ids: &T1,
    node_ids: &[&T2],
    gains: &[&T3],
    thresholds: &[&T4],
    left_node_contribs: &[&T5],
    right_node_contribs: &[&T6],
    max_depth: &T7,
    learning_rate: &T8,
) -> crate::Result<()> {
    let op = BoostedTreesUpdateEnsemble::new();
    op.call(
        ctx,
        tree_ensemble_handle,
        feature_ids,
        node_ids,
        gains,
        thresholds,
        left_node_contribs,
        right_node_contribs,
        max_depth,
        learning_rate,
    )
}

/// BoostedTreesUpdateEnsembleV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesUpdateEnsembleV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BoostedTreesUpdateEnsembleV2 {
    logits_dimension: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BoostedTreesUpdateEnsembleV2 {
    fn default() -> Self {
        Self {
            logits_dimension: Some(1i64),
            target_device_name: None,
        }
    }
}
impl BoostedTreesUpdateEnsembleV2 {
    /// Creates a new `BoostedTreesUpdateEnsembleV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `logits_dimension` attribute.
    pub fn logits_dimension<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.logits_dimension = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute boosted_trees_update_ensemble_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
        T9: crate::eager::ToTensorHandle<'a>,
        T10: crate::eager::ToTensorHandle<'a>,
        T11: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        tree_ensemble_handle: &T0,
        feature_ids: &[&T1],
        dimension_ids: &[&T2],
        node_ids: &[&T3],
        gains: &[&T4],
        thresholds: &[&T5],
        left_node_contribs: &[&T6],
        right_node_contribs: &[&T7],
        split_types: &[&T8],
        max_depth: &T9,
        learning_rate: &T10,
        pruning_mode: &T11,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "BoostedTreesUpdateEnsembleV2")?;

        // Required input arguments
        op.add_input(&tree_ensemble_handle.to_handle(ctx)?)?;
        let mut feature_ids_list = Vec::new();

        for t in feature_ids {
            feature_ids_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&feature_ids_list)?;
        let mut dimension_ids_list = Vec::new();

        for t in dimension_ids {
            dimension_ids_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&dimension_ids_list)?;
        let mut node_ids_list = Vec::new();

        for t in node_ids {
            node_ids_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&node_ids_list)?;
        let mut gains_list = Vec::new();

        for t in gains {
            gains_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&gains_list)?;
        let mut thresholds_list = Vec::new();

        for t in thresholds {
            thresholds_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&thresholds_list)?;
        let mut left_node_contribs_list = Vec::new();

        for t in left_node_contribs {
            left_node_contribs_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&left_node_contribs_list)?;
        let mut right_node_contribs_list = Vec::new();

        for t in right_node_contribs {
            right_node_contribs_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&right_node_contribs_list)?;
        let mut split_types_list = Vec::new();

        for t in split_types {
            split_types_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&split_types_list)?;
        op.add_input(&max_depth.to_handle(ctx)?)?;
        op.add_input(&learning_rate.to_handle(ctx)?)?;
        op.add_input(&pruning_mode.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.logits_dimension {
            op.set_attr_int("logits_dimension", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `BoostedTreesUpdateEnsembleV2::new().call(&ctx, &tree_ensemble_handle, &feature_ids, &dimension_ids, &node_ids, &gains, &thresholds, &left_node_contribs, &right_node_contribs, &split_types, &max_depth, &learning_rate, &pruning_mode)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BoostedTreesUpdateEnsembleV2>
pub fn boosted_trees_update_ensemble_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
    T9: crate::eager::ToTensorHandle<'a>,
    T10: crate::eager::ToTensorHandle<'a>,
    T11: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    tree_ensemble_handle: &T0,
    feature_ids: &[&T1],
    dimension_ids: &[&T2],
    node_ids: &[&T3],
    gains: &[&T4],
    thresholds: &[&T5],
    left_node_contribs: &[&T6],
    right_node_contribs: &[&T7],
    split_types: &[&T8],
    max_depth: &T9,
    learning_rate: &T10,
    pruning_mode: &T11,
) -> crate::Result<()> {
    let op = BoostedTreesUpdateEnsembleV2::new();
    op.call(
        ctx,
        tree_ensemble_handle,
        feature_ids,
        dimension_ids,
        node_ids,
        gains,
        thresholds,
        left_node_contribs,
        right_node_contribs,
        split_types,
        max_depth,
        learning_rate,
        pruning_mode,
    )
}

/// BroadcastArgs
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BroadcastArgs>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BroadcastArgs {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BroadcastArgs {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BroadcastArgs {
    /// Creates a new `BroadcastArgs`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute broadcast_args.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        s0: &T0,
        s1: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BroadcastArgs")?;

        // Required input arguments
        op.add_input(&s0.to_handle(ctx)?)?;
        op.add_input(&s1.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BroadcastArgs::new().call(&ctx, &s0, &s1)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BroadcastArgs>
pub fn broadcast_args<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    s0: &T0,
    s1: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BroadcastArgs::new();
    op.call(ctx, s0, s1)
}

/// BroadcastGradientArgs
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BroadcastGradientArgs>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BroadcastGradientArgs {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BroadcastGradientArgs {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BroadcastGradientArgs {
    /// Creates a new `BroadcastGradientArgs`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute broadcast_gradient_args.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        s0: &T0,
        s1: &T1,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "BroadcastGradientArgs")?;

        // Required input arguments
        op.add_input(&s0.to_handle(ctx)?)?;
        op.add_input(&s1.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `BroadcastGradientArgs::new().call(&ctx, &s0, &s1)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BroadcastGradientArgs>
pub fn broadcast_gradient_args<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    s0: &T0,
    s1: &T1,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = BroadcastGradientArgs::new();
    op.call(ctx, s0, s1)
}

/// BroadcastTo
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BroadcastTo>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BroadcastTo {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BroadcastTo {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl BroadcastTo {
    /// Creates a new `BroadcastTo`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute broadcast_to.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        shape: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BroadcastTo")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&shape.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BroadcastTo::new().call(&ctx, &input, &shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BroadcastTo>
pub fn broadcast_to<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    shape: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BroadcastTo::new();
    op.call(ctx, input, shape)
}

/// Bucketize
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Bucketize>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Bucketize {
    boundaries: ::std::option::Option<::std::vec::Vec<f32>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Bucketize {
    fn default() -> Self {
        Self {
            boundaries: None,
            target_device_name: None,
        }
    }
}
impl Bucketize {
    /// Creates a new `Bucketize`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `boundaries` attribute.
    pub fn boundaries<ArgType: ::std::convert::Into<::std::vec::Vec<f32>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.boundaries = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute bucketize.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Bucketize")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.boundaries {
            op.set_attr_float_list("boundaries", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Bucketize::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Bucketize>
pub fn bucketize<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Bucketize::new();
    op.call(ctx, input)
}

/// BytesProducedStatsDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BytesProducedStatsDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct BytesProducedStatsDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for BytesProducedStatsDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl BytesProducedStatsDataset {
    /// Creates a new `BytesProducedStatsDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute bytes_produced_stats_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        tag: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "BytesProducedStatsDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&tag.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `BytesProducedStatsDataset::new().call(&ctx, &input_dataset, &tag)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/BytesProducedStatsDataset>
pub fn bytes_produced_stats_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    tag: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = BytesProducedStatsDataset::new();
    op.call(ctx, input_dataset, tag)
}

/// CSRSparseMatrixComponents
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CSRSparseMatrixComponents>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CSRSparseMatrixComponents {
    type_: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CSRSparseMatrixComponents {
    fn default() -> Self {
        Self {
            type_: None,
            target_device_name: None,
        }
    }
}
impl CSRSparseMatrixComponents {
    /// Creates a new `CSRSparseMatrixComponents`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `type` attribute.
    pub fn type_<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.type_ = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute csrsparse_matrix_components.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        csr_sparse_matrix: &T0,
        index: &T1,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "CSRSparseMatrixComponents")?;

        // Required input arguments
        op.add_input(&csr_sparse_matrix.to_handle(ctx)?)?;
        op.add_input(&index.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.type_ {
            op.set_attr_type("type", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `CSRSparseMatrixComponents::new().call(&ctx, &csr_sparse_matrix, &index)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CSRSparseMatrixComponents>
pub fn csrsparse_matrix_components<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    csr_sparse_matrix: &T0,
    index: &T1,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = CSRSparseMatrixComponents::new();
    op.call(ctx, csr_sparse_matrix, index)
}

/// CSRSparseMatrixToDense
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CSRSparseMatrixToDense>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CSRSparseMatrixToDense {
    type_: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CSRSparseMatrixToDense {
    fn default() -> Self {
        Self {
            type_: None,
            target_device_name: None,
        }
    }
}
impl CSRSparseMatrixToDense {
    /// Creates a new `CSRSparseMatrixToDense`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `type` attribute.
    pub fn type_<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.type_ = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute csrsparse_matrix_to_dense.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        sparse_input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "CSRSparseMatrixToDense")?;

        // Required input arguments
        op.add_input(&sparse_input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.type_ {
            op.set_attr_type("type", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `CSRSparseMatrixToDense::new().call(&ctx, &sparse_input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CSRSparseMatrixToDense>
pub fn csrsparse_matrix_to_dense<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    sparse_input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = CSRSparseMatrixToDense::new();
    op.call(ctx, sparse_input)
}

/// CSRSparseMatrixToSparseTensor
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CSRSparseMatrixToSparseTensor>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CSRSparseMatrixToSparseTensor {
    type_: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CSRSparseMatrixToSparseTensor {
    fn default() -> Self {
        Self {
            type_: None,
            target_device_name: None,
        }
    }
}
impl CSRSparseMatrixToSparseTensor {
    /// Creates a new `CSRSparseMatrixToSparseTensor`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `type` attribute.
    pub fn type_<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.type_ = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute csrsparse_matrix_to_sparse_tensor.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        sparse_matrix: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "CSRSparseMatrixToSparseTensor")?;

        // Required input arguments
        op.add_input(&sparse_matrix.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.type_ {
            op.set_attr_type("type", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `CSRSparseMatrixToSparseTensor::new().call(&ctx, &sparse_matrix)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CSRSparseMatrixToSparseTensor>
pub fn csrsparse_matrix_to_sparse_tensor<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    sparse_matrix: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = CSRSparseMatrixToSparseTensor::new();
    op.call(ctx, sparse_matrix)
}

/// CSVDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CSVDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CSVDataset {
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CSVDataset {
    fn default() -> Self {
        Self {
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl CSVDataset {
    /// Creates a new `CSVDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute csvdataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        filenames: &T0,
        compression_type: &T1,
        buffer_size: &T2,
        header: &T3,
        field_delim: &T4,
        use_quote_delim: &T5,
        na_value: &T6,
        select_cols: &T7,
        record_defaults: &T8,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "CSVDataset")?;

        // Required input arguments
        op.add_input(&filenames.to_handle(ctx)?)?;
        op.add_input(&compression_type.to_handle(ctx)?)?;
        op.add_input(&buffer_size.to_handle(ctx)?)?;
        op.add_input(&header.to_handle(ctx)?)?;
        op.add_input(&field_delim.to_handle(ctx)?)?;
        op.add_input(&use_quote_delim.to_handle(ctx)?)?;
        op.add_input(&na_value.to_handle(ctx)?)?;
        op.add_input(&select_cols.to_handle(ctx)?)?;
        op.add_input(&record_defaults.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `CSVDataset::new().call(&ctx, &filenames, &compression_type, &buffer_size, &header, &field_delim, &use_quote_delim, &na_value, &select_cols, &record_defaults)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CSVDataset>
pub fn csvdataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    filenames: &T0,
    compression_type: &T1,
    buffer_size: &T2,
    header: &T3,
    field_delim: &T4,
    use_quote_delim: &T5,
    na_value: &T6,
    select_cols: &T7,
    record_defaults: &T8,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = CSVDataset::new();
    op.call(
        ctx,
        filenames,
        compression_type,
        buffer_size,
        header,
        field_delim,
        use_quote_delim,
        na_value,
        select_cols,
        record_defaults,
    )
}

/// CSVDatasetV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CSVDatasetV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CSVDatasetV2 {
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CSVDatasetV2 {
    fn default() -> Self {
        Self {
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl CSVDatasetV2 {
    /// Creates a new `CSVDatasetV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute csvdataset_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
        T9: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        filenames: &T0,
        compression_type: &T1,
        buffer_size: &T2,
        header: &T3,
        field_delim: &T4,
        use_quote_delim: &T5,
        na_value: &T6,
        select_cols: &T7,
        record_defaults: &T8,
        exclude_cols: &T9,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "CSVDatasetV2")?;

        // Required input arguments
        op.add_input(&filenames.to_handle(ctx)?)?;
        op.add_input(&compression_type.to_handle(ctx)?)?;
        op.add_input(&buffer_size.to_handle(ctx)?)?;
        op.add_input(&header.to_handle(ctx)?)?;
        op.add_input(&field_delim.to_handle(ctx)?)?;
        op.add_input(&use_quote_delim.to_handle(ctx)?)?;
        op.add_input(&na_value.to_handle(ctx)?)?;
        op.add_input(&select_cols.to_handle(ctx)?)?;
        op.add_input(&record_defaults.to_handle(ctx)?)?;
        op.add_input(&exclude_cols.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `CSVDatasetV2::new().call(&ctx, &filenames, &compression_type, &buffer_size, &header, &field_delim, &use_quote_delim, &na_value, &select_cols, &record_defaults, &exclude_cols)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CSVDatasetV2>
pub fn csvdataset_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
    T9: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    filenames: &T0,
    compression_type: &T1,
    buffer_size: &T2,
    header: &T3,
    field_delim: &T4,
    use_quote_delim: &T5,
    na_value: &T6,
    select_cols: &T7,
    record_defaults: &T8,
    exclude_cols: &T9,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = CSVDatasetV2::new();
    op.call(
        ctx,
        filenames,
        compression_type,
        buffer_size,
        header,
        field_delim,
        use_quote_delim,
        na_value,
        select_cols,
        record_defaults,
        exclude_cols,
    )
}

/// CTCBeamSearchDecoder
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CTCBeamSearchDecoder>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CTCBeamSearchDecoder {
    beam_width: ::std::option::Option<i64>,
    top_paths: ::std::option::Option<i64>,
    merge_repeated: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CTCBeamSearchDecoder {
    fn default() -> Self {
        Self {
            beam_width: None,
            top_paths: None,
            merge_repeated: Some(true),
            target_device_name: None,
        }
    }
}
impl CTCBeamSearchDecoder {
    /// Creates a new `CTCBeamSearchDecoder`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `beam_width` attribute.
    pub fn beam_width<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.beam_width = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `top_paths` attribute.
    pub fn top_paths<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.top_paths = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `merge_repeated` attribute.
    pub fn merge_repeated<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.merge_repeated = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute ctcbeam_search_decoder.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        inputs: &T0,
        sequence_length: &T1,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 4]> {
        // Define Op
        let mut op = super::Op::new(ctx, "CTCBeamSearchDecoder")?;

        // Required input arguments
        op.add_input(&inputs.to_handle(ctx)?)?;
        op.add_input(&sequence_length.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.beam_width {
            op.set_attr_int("beam_width", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.top_paths {
            op.set_attr_int("top_paths", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.merge_repeated {
            op.set_attr_bool("merge_repeated", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<4>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `CTCBeamSearchDecoder::new().call(&ctx, &inputs, &sequence_length)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CTCBeamSearchDecoder>
pub fn ctcbeam_search_decoder<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    inputs: &T0,
    sequence_length: &T1,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 4]> {
    let op = CTCBeamSearchDecoder::new();
    op.call(ctx, inputs, sequence_length)
}

/// CTCGreedyDecoder
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CTCGreedyDecoder>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CTCGreedyDecoder {
    merge_repeated: ::std::option::Option<bool>,
    blank_index: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CTCGreedyDecoder {
    fn default() -> Self {
        Self {
            merge_repeated: Some(false),
            blank_index: Some(-1i64),
            target_device_name: None,
        }
    }
}
impl CTCGreedyDecoder {
    /// Creates a new `CTCGreedyDecoder`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `merge_repeated` attribute.
    pub fn merge_repeated<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.merge_repeated = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `blank_index` attribute.
    pub fn blank_index<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.blank_index = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute ctcgreedy_decoder.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        inputs: &T0,
        sequence_length: &T1,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 4]> {
        // Define Op
        let mut op = super::Op::new(ctx, "CTCGreedyDecoder")?;

        // Required input arguments
        op.add_input(&inputs.to_handle(ctx)?)?;
        op.add_input(&sequence_length.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.merge_repeated {
            op.set_attr_bool("merge_repeated", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.blank_index {
            op.set_attr_int("blank_index", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<4>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `CTCGreedyDecoder::new().call(&ctx, &inputs, &sequence_length)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CTCGreedyDecoder>
pub fn ctcgreedy_decoder<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    inputs: &T0,
    sequence_length: &T1,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 4]> {
    let op = CTCGreedyDecoder::new();
    op.call(ctx, inputs, sequence_length)
}

/// CTCLoss
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CTCLoss>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CTCLoss {
    preprocess_collapse_repeated: ::std::option::Option<bool>,
    ctc_merge_repeated: ::std::option::Option<bool>,
    ignore_longer_outputs_than_inputs: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CTCLoss {
    fn default() -> Self {
        Self {
            preprocess_collapse_repeated: Some(false),
            ctc_merge_repeated: Some(true),
            ignore_longer_outputs_than_inputs: Some(false),
            target_device_name: None,
        }
    }
}
impl CTCLoss {
    /// Creates a new `CTCLoss`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `preprocess_collapse_repeated` attribute.
    pub fn preprocess_collapse_repeated<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.preprocess_collapse_repeated = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `ctc_merge_repeated` attribute.
    pub fn ctc_merge_repeated<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.ctc_merge_repeated = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `ignore_longer_outputs_than_inputs` attribute.
    pub fn ignore_longer_outputs_than_inputs<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.ignore_longer_outputs_than_inputs = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute ctcloss.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        inputs: &T0,
        labels_indices: &T1,
        labels_values: &T2,
        sequence_length: &T3,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "CTCLoss")?;

        // Required input arguments
        op.add_input(&inputs.to_handle(ctx)?)?;
        op.add_input(&labels_indices.to_handle(ctx)?)?;
        op.add_input(&labels_values.to_handle(ctx)?)?;
        op.add_input(&sequence_length.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.preprocess_collapse_repeated {
            op.set_attr_bool("preprocess_collapse_repeated", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.ctc_merge_repeated {
            op.set_attr_bool("ctc_merge_repeated", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.ignore_longer_outputs_than_inputs {
            op.set_attr_bool("ignore_longer_outputs_than_inputs", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `CTCLoss::new().call(&ctx, &inputs, &labels_indices, &labels_values, &sequence_length)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CTCLoss>
pub fn ctcloss<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    inputs: &T0,
    labels_indices: &T1,
    labels_values: &T2,
    sequence_length: &T3,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = CTCLoss::new();
    op.call(ctx, inputs, labels_indices, labels_values, sequence_length)
}

/// CTCLossV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CTCLossV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CTCLossV2 {
    preprocess_collapse_repeated: ::std::option::Option<bool>,
    ctc_merge_repeated: ::std::option::Option<bool>,
    ignore_longer_outputs_than_inputs: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CTCLossV2 {
    fn default() -> Self {
        Self {
            preprocess_collapse_repeated: Some(false),
            ctc_merge_repeated: Some(true),
            ignore_longer_outputs_than_inputs: Some(false),
            target_device_name: None,
        }
    }
}
impl CTCLossV2 {
    /// Creates a new `CTCLossV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `preprocess_collapse_repeated` attribute.
    pub fn preprocess_collapse_repeated<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.preprocess_collapse_repeated = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `ctc_merge_repeated` attribute.
    pub fn ctc_merge_repeated<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.ctc_merge_repeated = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `ignore_longer_outputs_than_inputs` attribute.
    pub fn ignore_longer_outputs_than_inputs<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.ignore_longer_outputs_than_inputs = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute ctcloss_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        inputs: &T0,
        labels_indices: &T1,
        labels_values: &T2,
        sequence_length: &T3,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "CTCLossV2")?;

        // Required input arguments
        op.add_input(&inputs.to_handle(ctx)?)?;
        op.add_input(&labels_indices.to_handle(ctx)?)?;
        op.add_input(&labels_values.to_handle(ctx)?)?;
        op.add_input(&sequence_length.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.preprocess_collapse_repeated {
            op.set_attr_bool("preprocess_collapse_repeated", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.ctc_merge_repeated {
            op.set_attr_bool("ctc_merge_repeated", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.ignore_longer_outputs_than_inputs {
            op.set_attr_bool("ignore_longer_outputs_than_inputs", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `CTCLossV2::new().call(&ctx, &inputs, &labels_indices, &labels_values, &sequence_length)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CTCLossV2>
pub fn ctcloss_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    inputs: &T0,
    labels_indices: &T1,
    labels_values: &T2,
    sequence_length: &T3,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = CTCLossV2::new();
    op.call(ctx, inputs, labels_indices, labels_values, sequence_length)
}

/// CacheDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CacheDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CacheDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CacheDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl CacheDataset {
    /// Creates a new `CacheDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute cache_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        filename: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "CacheDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&filename.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `CacheDataset::new().call(&ctx, &input_dataset, &filename)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CacheDataset>
pub fn cache_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    filename: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = CacheDataset::new();
    op.call(ctx, input_dataset, filename)
}

/// CacheDatasetV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CacheDatasetV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CacheDatasetV2 {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CacheDatasetV2 {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl CacheDatasetV2 {
    /// Creates a new `CacheDatasetV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute cache_dataset_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        filename: &T1,
        cache: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "CacheDatasetV2")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&filename.to_handle(ctx)?)?;
        op.add_input(&cache.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `CacheDatasetV2::new().call(&ctx, &input_dataset, &filename, &cache)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CacheDatasetV2>
pub fn cache_dataset_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    filename: &T1,
    cache: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = CacheDatasetV2::new();
    op.call(ctx, input_dataset, filename, cache)
}

/// Case
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Case>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Case {
    Tout: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    branches: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Case {
    fn default() -> Self {
        Self {
            Tout: None,
            branches: None,
            output_shapes: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl Case {
    /// Creates a new `Case`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Tout` attribute.
    pub fn Tout<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Tout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `branches` attribute.
    pub fn branches<ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.branches = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute case.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        branch_index: &T0,
        input: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Case")?;

        // Required input arguments
        op.add_input(&branch_index.to_handle(ctx)?)?;
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Tout {
            op.set_attr_type_list("Tout", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.branches {
            op.set_attr_string_list("branches", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Case::new().call(&ctx, &branch_index, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Case>
pub fn case<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    branch_index: &T0,
    input: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Case::new();
    op.call(ctx, branch_index, input)
}

/// Cast
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Cast>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Cast {
    DstT: ::std::option::Option<crate::DataType>,
    Truncate: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Cast {
    fn default() -> Self {
        Self {
            DstT: None,
            Truncate: Some(false),
            target_device_name: None,
        }
    }
}
impl Cast {
    /// Creates a new `Cast`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `DstT` attribute.
    pub fn DstT<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.DstT = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `Truncate` attribute.
    pub fn Truncate<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.Truncate = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute cast.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Cast")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.DstT {
            op.set_attr_type("DstT", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.Truncate {
            op.set_attr_bool("Truncate", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Cast::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Cast>
pub fn cast<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Cast::new();
    op.call(ctx, x)
}

/// Ceil
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Ceil>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Ceil {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Ceil {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Ceil {
    /// Creates a new `Ceil`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute ceil.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Ceil")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Ceil::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Ceil>
pub fn ceil<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Ceil::new();
    op.call(ctx, x)
}

/// CheckNumerics
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CheckNumerics>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CheckNumerics {
    message: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CheckNumerics {
    fn default() -> Self {
        Self {
            message: None,
            target_device_name: None,
        }
    }
}
impl CheckNumerics {
    /// Creates a new `CheckNumerics`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `message` attribute.
    pub fn message<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.message = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute check_numerics.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        tensor: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "CheckNumerics")?;

        // Required input arguments
        op.add_input(&tensor.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.message {
            op.set_attr_string("message", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `CheckNumerics::new().call(&ctx, &tensor)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CheckNumerics>
pub fn check_numerics<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    tensor: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = CheckNumerics::new();
    op.call(ctx, tensor)
}

/// CheckNumericsV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CheckNumericsV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CheckNumericsV2 {
    message: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CheckNumericsV2 {
    fn default() -> Self {
        Self {
            message: None,
            target_device_name: None,
        }
    }
}
impl CheckNumericsV2 {
    /// Creates a new `CheckNumericsV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `message` attribute.
    pub fn message<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.message = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute check_numerics_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        tensor: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "CheckNumericsV2")?;

        // Required input arguments
        op.add_input(&tensor.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.message {
            op.set_attr_string("message", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `CheckNumericsV2::new().call(&ctx, &tensor)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CheckNumericsV2>
pub fn check_numerics_v2<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    tensor: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = CheckNumericsV2::new();
    op.call(ctx, tensor)
}

/// Cholesky
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Cholesky>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Cholesky {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Cholesky {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Cholesky {
    /// Creates a new `Cholesky`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute cholesky.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Cholesky")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Cholesky::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Cholesky>
pub fn cholesky<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Cholesky::new();
    op.call(ctx, input)
}

/// CholeskyGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CholeskyGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CholeskyGrad {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CholeskyGrad {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl CholeskyGrad {
    /// Creates a new `CholeskyGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute cholesky_grad.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        l: &T0,
        grad: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "CholeskyGrad")?;

        // Required input arguments
        op.add_input(&l.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `CholeskyGrad::new().call(&ctx, &l, &grad)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CholeskyGrad>
pub fn cholesky_grad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    l: &T0,
    grad: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = CholeskyGrad::new();
    op.call(ctx, l, grad)
}

/// ChooseFastestBranchDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ChooseFastestBranchDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ChooseFastestBranchDataset {
    num_elements_per_branch: ::std::option::Option<i64>,
    branches: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    other_arguments_lengths: ::std::option::Option<::std::vec::Vec<i64>>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ChooseFastestBranchDataset {
    fn default() -> Self {
        Self {
            num_elements_per_branch: None,
            branches: None,
            other_arguments_lengths: None,
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl ChooseFastestBranchDataset {
    /// Creates a new `ChooseFastestBranchDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_elements_per_branch` attribute.
    pub fn num_elements_per_branch<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.num_elements_per_branch = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `branches` attribute.
    pub fn branches<ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.branches = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `other_arguments_lengths` attribute.
    pub fn other_arguments_lengths<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.other_arguments_lengths = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute choose_fastest_branch_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        ratio_numerator: &T1,
        ratio_denominator: &T2,
        other_arguments: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ChooseFastestBranchDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&ratio_numerator.to_handle(ctx)?)?;
        op.add_input(&ratio_denominator.to_handle(ctx)?)?;
        op.add_input(&other_arguments.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_elements_per_branch {
            op.set_attr_int("num_elements_per_branch", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.branches {
            op.set_attr_string_list("branches", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.other_arguments_lengths {
            op.set_attr_int_list("other_arguments_lengths", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ChooseFastestBranchDataset::new().call(&ctx, &input_dataset, &ratio_numerator, &ratio_denominator, &other_arguments)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ChooseFastestBranchDataset>
pub fn choose_fastest_branch_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    ratio_numerator: &T1,
    ratio_denominator: &T2,
    other_arguments: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ChooseFastestBranchDataset::new();
    op.call(
        ctx,
        input_dataset,
        ratio_numerator,
        ratio_denominator,
        other_arguments,
    )
}

/// ChooseFastestDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ChooseFastestDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ChooseFastestDataset {
    num_experiments: ::std::option::Option<i64>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ChooseFastestDataset {
    fn default() -> Self {
        Self {
            num_experiments: None,
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl ChooseFastestDataset {
    /// Creates a new `ChooseFastestDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_experiments` attribute.
    pub fn num_experiments<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_experiments = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute choose_fastest_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_datasets: &[&T0],
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ChooseFastestDataset")?;

        // Required input arguments
        let mut input_datasets_list = Vec::new();

        for t in input_datasets {
            input_datasets_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&input_datasets_list)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_experiments {
            op.set_attr_int("num_experiments", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ChooseFastestDataset::new().call(&ctx, &input_datasets)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ChooseFastestDataset>
pub fn choose_fastest_dataset<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input_datasets: &[&T0],
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ChooseFastestDataset::new();
    op.call(ctx, input_datasets)
}

/// ClipByValue
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ClipByValue>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ClipByValue {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ClipByValue {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ClipByValue {
    /// Creates a new `ClipByValue`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute clip_by_value.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        t: &T0,
        clip_value_min: &T1,
        clip_value_max: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ClipByValue")?;

        // Required input arguments
        op.add_input(&t.to_handle(ctx)?)?;
        op.add_input(&clip_value_min.to_handle(ctx)?)?;
        op.add_input(&clip_value_max.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ClipByValue::new().call(&ctx, &t, &clip_value_min, &clip_value_max)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ClipByValue>
pub fn clip_by_value<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    t: &T0,
    clip_value_min: &T1,
    clip_value_max: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ClipByValue::new();
    op.call(ctx, t, clip_value_min, clip_value_max)
}

/// CloseSummaryWriter
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CloseSummaryWriter>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CloseSummaryWriter {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CloseSummaryWriter {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl CloseSummaryWriter {
    /// Creates a new `CloseSummaryWriter`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute close_summary_writer.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        writer: &T0,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "CloseSummaryWriter")?;

        // Required input arguments
        op.add_input(&writer.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `CloseSummaryWriter::new().call(&ctx, &writer)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CloseSummaryWriter>
pub fn close_summary_writer<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    writer: &T0,
) -> crate::Result<()> {
    let op = CloseSummaryWriter::new();
    op.call(ctx, writer)
}

/// CollateTPUEmbeddingMemory
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CollateTPUEmbeddingMemory>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CollateTPUEmbeddingMemory {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CollateTPUEmbeddingMemory {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl CollateTPUEmbeddingMemory {
    /// Creates a new `CollateTPUEmbeddingMemory`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute collate_tpuembedding_memory.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        memory_configs: &[&T0],
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "CollateTPUEmbeddingMemory")?;

        // Required input arguments
        let mut memory_configs_list = Vec::new();

        for t in memory_configs {
            memory_configs_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&memory_configs_list)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `CollateTPUEmbeddingMemory::new().call(&ctx, &memory_configs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CollateTPUEmbeddingMemory>
pub fn collate_tpuembedding_memory<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    memory_configs: &[&T0],
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = CollateTPUEmbeddingMemory::new();
    op.call(ctx, memory_configs)
}

/// CollectiveAllToAllV3
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CollectiveAllToAllV3>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CollectiveAllToAllV3 {
    timeout_seconds: ::std::option::Option<f32>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CollectiveAllToAllV3 {
    fn default() -> Self {
        Self {
            timeout_seconds: Some(0f32),
            target_device_name: None,
        }
    }
}
impl CollectiveAllToAllV3 {
    /// Creates a new `CollectiveAllToAllV3`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `timeout_seconds` attribute.
    pub fn timeout_seconds<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.timeout_seconds = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute collective_all_to_all_v3.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        communicator: &T1,
        group_assignment: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "CollectiveAllToAllV3")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&communicator.to_handle(ctx)?)?;
        op.add_input(&group_assignment.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.timeout_seconds {
            op.set_attr_float("timeout_seconds", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `CollectiveAllToAllV3::new().call(&ctx, &input, &communicator, &group_assignment)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CollectiveAllToAllV3>
pub fn collective_all_to_all_v3<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    communicator: &T1,
    group_assignment: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = CollectiveAllToAllV3::new();
    op.call(ctx, input, communicator, group_assignment)
}

/// CollectiveAssignGroupV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CollectiveAssignGroupV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CollectiveAssignGroupV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CollectiveAssignGroupV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl CollectiveAssignGroupV2 {
    /// Creates a new `CollectiveAssignGroupV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute collective_assign_group_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        group_assignment: &T0,
        device_index: &T1,
        base_key: &T2,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "CollectiveAssignGroupV2")?;

        // Required input arguments
        op.add_input(&group_assignment.to_handle(ctx)?)?;
        op.add_input(&device_index.to_handle(ctx)?)?;
        op.add_input(&base_key.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `CollectiveAssignGroupV2::new().call(&ctx, &group_assignment, &device_index, &base_key)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CollectiveAssignGroupV2>
pub fn collective_assign_group_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    group_assignment: &T0,
    device_index: &T1,
    base_key: &T2,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = CollectiveAssignGroupV2::new();
    op.call(ctx, group_assignment, device_index, base_key)
}

/// CollectiveBcastRecv
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CollectiveBcastRecv>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CollectiveBcastRecv {
    T: ::std::option::Option<crate::DataType>,
    group_size: ::std::option::Option<i64>,
    group_key: ::std::option::Option<i64>,
    instance_key: ::std::option::Option<i64>,
    shape: ::std::option::Option<crate::Shape>,
    communication_hint: ::std::option::Option<::std::string::String>,
    timeout_seconds: ::std::option::Option<f32>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CollectiveBcastRecv {
    fn default() -> Self {
        Self {
            T: None,
            group_size: None,
            group_key: None,
            instance_key: None,
            shape: None,
            communication_hint: Some(::std::string::String::from("auto")),
            timeout_seconds: Some(0f32),
            target_device_name: None,
        }
    }
}
impl CollectiveBcastRecv {
    /// Creates a new `CollectiveBcastRecv`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `T` attribute.
    pub fn T<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.T = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `group_size` attribute.
    pub fn group_size<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.group_size = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `group_key` attribute.
    pub fn group_key<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.group_key = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `instance_key` attribute.
    pub fn instance_key<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.instance_key = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shape` attribute.
    pub fn shape<ArgType: ::std::convert::Into<crate::Shape>>(mut self, value: ArgType) -> Self {
        self.shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `communication_hint` attribute.
    pub fn communication_hint<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.communication_hint = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `timeout_seconds` attribute.
    pub fn timeout_seconds<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.timeout_seconds = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute collective_bcast_recv.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "CollectiveBcastRecv")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.T {
            op.set_attr_type("T", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.group_size {
            op.set_attr_int("group_size", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.group_key {
            op.set_attr_int("group_key", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.instance_key {
            op.set_attr_int("instance_key", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shape {
            op.set_attr_shape("shape", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.communication_hint {
            op.set_attr_string("communication_hint", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.timeout_seconds {
            op.set_attr_float("timeout_seconds", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `CollectiveBcastRecv::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CollectiveBcastRecv>
pub fn collective_bcast_recv<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = CollectiveBcastRecv::new();
    op.call(ctx)
}

/// CollectiveBcastRecvV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CollectiveBcastRecvV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CollectiveBcastRecvV2 {
    T: ::std::option::Option<crate::DataType>,
    communication_hint: ::std::option::Option<::std::string::String>,
    timeout_seconds: ::std::option::Option<f32>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CollectiveBcastRecvV2 {
    fn default() -> Self {
        Self {
            T: None,
            communication_hint: Some(::std::string::String::from("auto")),
            timeout_seconds: Some(0f32),
            target_device_name: None,
        }
    }
}
impl CollectiveBcastRecvV2 {
    /// Creates a new `CollectiveBcastRecvV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `T` attribute.
    pub fn T<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.T = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `communication_hint` attribute.
    pub fn communication_hint<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.communication_hint = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `timeout_seconds` attribute.
    pub fn timeout_seconds<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.timeout_seconds = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute collective_bcast_recv_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        group_size: &T0,
        group_key: &T1,
        instance_key: &T2,
        shape: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "CollectiveBcastRecvV2")?;

        // Required input arguments
        op.add_input(&group_size.to_handle(ctx)?)?;
        op.add_input(&group_key.to_handle(ctx)?)?;
        op.add_input(&instance_key.to_handle(ctx)?)?;
        op.add_input(&shape.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.T {
            op.set_attr_type("T", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.communication_hint {
            op.set_attr_string("communication_hint", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.timeout_seconds {
            op.set_attr_float("timeout_seconds", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `CollectiveBcastRecvV2::new().call(&ctx, &group_size, &group_key, &instance_key, &shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CollectiveBcastRecvV2>
pub fn collective_bcast_recv_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    group_size: &T0,
    group_key: &T1,
    instance_key: &T2,
    shape: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = CollectiveBcastRecvV2::new();
    op.call(ctx, group_size, group_key, instance_key, shape)
}

/// CollectiveBcastSend
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CollectiveBcastSend>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CollectiveBcastSend {
    group_size: ::std::option::Option<i64>,
    group_key: ::std::option::Option<i64>,
    instance_key: ::std::option::Option<i64>,
    shape: ::std::option::Option<crate::Shape>,
    communication_hint: ::std::option::Option<::std::string::String>,
    timeout_seconds: ::std::option::Option<f32>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CollectiveBcastSend {
    fn default() -> Self {
        Self {
            group_size: None,
            group_key: None,
            instance_key: None,
            shape: None,
            communication_hint: Some(::std::string::String::from("auto")),
            timeout_seconds: Some(0f32),
            target_device_name: None,
        }
    }
}
impl CollectiveBcastSend {
    /// Creates a new `CollectiveBcastSend`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `group_size` attribute.
    pub fn group_size<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.group_size = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `group_key` attribute.
    pub fn group_key<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.group_key = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `instance_key` attribute.
    pub fn instance_key<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.instance_key = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shape` attribute.
    pub fn shape<ArgType: ::std::convert::Into<crate::Shape>>(mut self, value: ArgType) -> Self {
        self.shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `communication_hint` attribute.
    pub fn communication_hint<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.communication_hint = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `timeout_seconds` attribute.
    pub fn timeout_seconds<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.timeout_seconds = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute collective_bcast_send.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "CollectiveBcastSend")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.group_size {
            op.set_attr_int("group_size", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.group_key {
            op.set_attr_int("group_key", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.instance_key {
            op.set_attr_int("instance_key", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shape {
            op.set_attr_shape("shape", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.communication_hint {
            op.set_attr_string("communication_hint", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.timeout_seconds {
            op.set_attr_float("timeout_seconds", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `CollectiveBcastSend::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CollectiveBcastSend>
pub fn collective_bcast_send<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = CollectiveBcastSend::new();
    op.call(ctx, input)
}

/// CollectiveBcastSendV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CollectiveBcastSendV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CollectiveBcastSendV2 {
    communication_hint: ::std::option::Option<::std::string::String>,
    timeout_seconds: ::std::option::Option<f32>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CollectiveBcastSendV2 {
    fn default() -> Self {
        Self {
            communication_hint: Some(::std::string::String::from("auto")),
            timeout_seconds: Some(0f32),
            target_device_name: None,
        }
    }
}
impl CollectiveBcastSendV2 {
    /// Creates a new `CollectiveBcastSendV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `communication_hint` attribute.
    pub fn communication_hint<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.communication_hint = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `timeout_seconds` attribute.
    pub fn timeout_seconds<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.timeout_seconds = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute collective_bcast_send_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        group_size: &T1,
        group_key: &T2,
        instance_key: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "CollectiveBcastSendV2")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&group_size.to_handle(ctx)?)?;
        op.add_input(&group_key.to_handle(ctx)?)?;
        op.add_input(&instance_key.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.communication_hint {
            op.set_attr_string("communication_hint", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.timeout_seconds {
            op.set_attr_float("timeout_seconds", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `CollectiveBcastSendV2::new().call(&ctx, &input, &group_size, &group_key, &instance_key)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CollectiveBcastSendV2>
pub fn collective_bcast_send_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    group_size: &T1,
    group_key: &T2,
    instance_key: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = CollectiveBcastSendV2::new();
    op.call(ctx, input, group_size, group_key, instance_key)
}

/// CollectiveGather
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CollectiveGather>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CollectiveGather {
    group_size: ::std::option::Option<i64>,
    group_key: ::std::option::Option<i64>,
    instance_key: ::std::option::Option<i64>,
    shape: ::std::option::Option<crate::Shape>,
    communication_hint: ::std::option::Option<::std::string::String>,
    timeout_seconds: ::std::option::Option<f32>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CollectiveGather {
    fn default() -> Self {
        Self {
            group_size: None,
            group_key: None,
            instance_key: None,
            shape: None,
            communication_hint: Some(::std::string::String::from("auto")),
            timeout_seconds: Some(0f32),
            target_device_name: None,
        }
    }
}
impl CollectiveGather {
    /// Creates a new `CollectiveGather`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `group_size` attribute.
    pub fn group_size<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.group_size = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `group_key` attribute.
    pub fn group_key<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.group_key = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `instance_key` attribute.
    pub fn instance_key<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.instance_key = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shape` attribute.
    pub fn shape<ArgType: ::std::convert::Into<crate::Shape>>(mut self, value: ArgType) -> Self {
        self.shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `communication_hint` attribute.
    pub fn communication_hint<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.communication_hint = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `timeout_seconds` attribute.
    pub fn timeout_seconds<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.timeout_seconds = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute collective_gather.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "CollectiveGather")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.group_size {
            op.set_attr_int("group_size", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.group_key {
            op.set_attr_int("group_key", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.instance_key {
            op.set_attr_int("instance_key", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shape {
            op.set_attr_shape("shape", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.communication_hint {
            op.set_attr_string("communication_hint", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.timeout_seconds {
            op.set_attr_float("timeout_seconds", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `CollectiveGather::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CollectiveGather>
pub fn collective_gather<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = CollectiveGather::new();
    op.call(ctx, input)
}

/// CollectiveGatherV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CollectiveGatherV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CollectiveGatherV2 {
    communication_hint: ::std::option::Option<::std::string::String>,
    timeout_seconds: ::std::option::Option<f32>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CollectiveGatherV2 {
    fn default() -> Self {
        Self {
            communication_hint: Some(::std::string::String::from("auto")),
            timeout_seconds: Some(0f32),
            target_device_name: None,
        }
    }
}
impl CollectiveGatherV2 {
    /// Creates a new `CollectiveGatherV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `communication_hint` attribute.
    pub fn communication_hint<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.communication_hint = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `timeout_seconds` attribute.
    pub fn timeout_seconds<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.timeout_seconds = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute collective_gather_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        group_size: &T1,
        group_key: &T2,
        instance_key: &T3,
        ordering_token: &[&T4],
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "CollectiveGatherV2")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&group_size.to_handle(ctx)?)?;
        op.add_input(&group_key.to_handle(ctx)?)?;
        op.add_input(&instance_key.to_handle(ctx)?)?;
        let mut ordering_token_list = Vec::new();

        for t in ordering_token {
            ordering_token_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&ordering_token_list)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.communication_hint {
            op.set_attr_string("communication_hint", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.timeout_seconds {
            op.set_attr_float("timeout_seconds", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `CollectiveGatherV2::new().call(&ctx, &input, &group_size, &group_key, &instance_key, &ordering_token)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CollectiveGatherV2>
pub fn collective_gather_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    group_size: &T1,
    group_key: &T2,
    instance_key: &T3,
    ordering_token: &[&T4],
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = CollectiveGatherV2::new();
    op.call(
        ctx,
        input,
        group_size,
        group_key,
        instance_key,
        ordering_token,
    )
}

/// CollectiveInitializeCommunicator
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CollectiveInitializeCommunicator>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CollectiveInitializeCommunicator {
    communication_hint: ::std::option::Option<::std::string::String>,
    timeout_seconds: ::std::option::Option<f32>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CollectiveInitializeCommunicator {
    fn default() -> Self {
        Self {
            communication_hint: Some(::std::string::String::from("auto")),
            timeout_seconds: Some(0f32),
            target_device_name: None,
        }
    }
}
impl CollectiveInitializeCommunicator {
    /// Creates a new `CollectiveInitializeCommunicator`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `communication_hint` attribute.
    pub fn communication_hint<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.communication_hint = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `timeout_seconds` attribute.
    pub fn timeout_seconds<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.timeout_seconds = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute collective_initialize_communicator.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        group_key: &T0,
        rank: &T1,
        group_size: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "CollectiveInitializeCommunicator")?;

        // Required input arguments
        op.add_input(&group_key.to_handle(ctx)?)?;
        op.add_input(&rank.to_handle(ctx)?)?;
        op.add_input(&group_size.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.communication_hint {
            op.set_attr_string("communication_hint", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.timeout_seconds {
            op.set_attr_float("timeout_seconds", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `CollectiveInitializeCommunicator::new().call(&ctx, &group_key, &rank, &group_size)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CollectiveInitializeCommunicator>
pub fn collective_initialize_communicator<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    group_key: &T0,
    rank: &T1,
    group_size: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = CollectiveInitializeCommunicator::new();
    op.call(ctx, group_key, rank, group_size)
}

/// CollectivePermute
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CollectivePermute>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CollectivePermute {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CollectivePermute {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl CollectivePermute {
    /// Creates a new `CollectivePermute`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute collective_permute.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        source_target_pairs: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "CollectivePermute")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&source_target_pairs.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `CollectivePermute::new().call(&ctx, &input, &source_target_pairs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CollectivePermute>
pub fn collective_permute<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    source_target_pairs: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = CollectivePermute::new();
    op.call(ctx, input, source_target_pairs)
}

/// CollectiveReduce
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CollectiveReduce>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CollectiveReduce {
    group_size: ::std::option::Option<i64>,
    group_key: ::std::option::Option<i64>,
    instance_key: ::std::option::Option<i64>,
    merge_op: ::std::option::Option<::std::string::String>,
    final_op: ::std::option::Option<::std::string::String>,
    subdiv_offsets: ::std::option::Option<::std::vec::Vec<i64>>,
    wait_for: ::std::option::Option<::std::vec::Vec<i64>>,
    communication_hint: ::std::option::Option<::std::string::String>,
    timeout_seconds: ::std::option::Option<f32>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CollectiveReduce {
    fn default() -> Self {
        Self {
            group_size: None,
            group_key: None,
            instance_key: None,
            merge_op: None,
            final_op: None,
            subdiv_offsets: None,
            wait_for: Some(vec![]),
            communication_hint: Some(::std::string::String::from("auto")),
            timeout_seconds: Some(0f32),
            target_device_name: None,
        }
    }
}
impl CollectiveReduce {
    /// Creates a new `CollectiveReduce`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `group_size` attribute.
    pub fn group_size<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.group_size = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `group_key` attribute.
    pub fn group_key<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.group_key = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `instance_key` attribute.
    pub fn instance_key<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.instance_key = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `merge_op` attribute.
    pub fn merge_op<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.merge_op = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `final_op` attribute.
    pub fn final_op<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.final_op = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `subdiv_offsets` attribute.
    pub fn subdiv_offsets<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.subdiv_offsets = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `wait_for` attribute.
    pub fn wait_for<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.wait_for = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `communication_hint` attribute.
    pub fn communication_hint<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.communication_hint = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `timeout_seconds` attribute.
    pub fn timeout_seconds<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.timeout_seconds = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute collective_reduce.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "CollectiveReduce")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.group_size {
            op.set_attr_int("group_size", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.group_key {
            op.set_attr_int("group_key", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.instance_key {
            op.set_attr_int("instance_key", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.merge_op {
            op.set_attr_string("merge_op", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.final_op {
            op.set_attr_string("final_op", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.subdiv_offsets {
            op.set_attr_int_list("subdiv_offsets", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.wait_for {
            op.set_attr_int_list("wait_for", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.communication_hint {
            op.set_attr_string("communication_hint", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.timeout_seconds {
            op.set_attr_float("timeout_seconds", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `CollectiveReduce::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CollectiveReduce>
pub fn collective_reduce<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = CollectiveReduce::new();
    op.call(ctx, input)
}

/// CollectiveReduceV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CollectiveReduceV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CollectiveReduceV2 {
    merge_op: ::std::option::Option<::std::string::String>,
    final_op: ::std::option::Option<::std::string::String>,
    communication_hint: ::std::option::Option<::std::string::String>,
    timeout_seconds: ::std::option::Option<f32>,
    max_subdivs_per_device: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CollectiveReduceV2 {
    fn default() -> Self {
        Self {
            merge_op: None,
            final_op: None,
            communication_hint: Some(::std::string::String::from("auto")),
            timeout_seconds: Some(0f32),
            max_subdivs_per_device: Some(-1i64),
            target_device_name: None,
        }
    }
}
impl CollectiveReduceV2 {
    /// Creates a new `CollectiveReduceV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `merge_op` attribute.
    pub fn merge_op<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.merge_op = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `final_op` attribute.
    pub fn final_op<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.final_op = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `communication_hint` attribute.
    pub fn communication_hint<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.communication_hint = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `timeout_seconds` attribute.
    pub fn timeout_seconds<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.timeout_seconds = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `max_subdivs_per_device` attribute.
    pub fn max_subdivs_per_device<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.max_subdivs_per_device = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute collective_reduce_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        group_size: &T1,
        group_key: &T2,
        instance_key: &T3,
        ordering_token: &[&T4],
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "CollectiveReduceV2")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&group_size.to_handle(ctx)?)?;
        op.add_input(&group_key.to_handle(ctx)?)?;
        op.add_input(&instance_key.to_handle(ctx)?)?;
        let mut ordering_token_list = Vec::new();

        for t in ordering_token {
            ordering_token_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&ordering_token_list)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.merge_op {
            op.set_attr_string("merge_op", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.final_op {
            op.set_attr_string("final_op", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.communication_hint {
            op.set_attr_string("communication_hint", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.timeout_seconds {
            op.set_attr_float("timeout_seconds", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.max_subdivs_per_device {
            op.set_attr_int("max_subdivs_per_device", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `CollectiveReduceV2::new().call(&ctx, &input, &group_size, &group_key, &instance_key, &ordering_token)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CollectiveReduceV2>
pub fn collective_reduce_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    group_size: &T1,
    group_key: &T2,
    instance_key: &T3,
    ordering_token: &[&T4],
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = CollectiveReduceV2::new();
    op.call(
        ctx,
        input,
        group_size,
        group_key,
        instance_key,
        ordering_token,
    )
}

/// CollectiveReduceV3
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CollectiveReduceV3>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CollectiveReduceV3 {
    reduction: ::std::option::Option<::std::string::String>,
    timeout_seconds: ::std::option::Option<f32>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CollectiveReduceV3 {
    fn default() -> Self {
        Self {
            reduction: None,
            timeout_seconds: Some(0f32),
            target_device_name: None,
        }
    }
}
impl CollectiveReduceV3 {
    /// Creates a new `CollectiveReduceV3`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `reduction` attribute.
    pub fn reduction<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.reduction = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `timeout_seconds` attribute.
    pub fn timeout_seconds<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.timeout_seconds = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute collective_reduce_v3.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        communicator: &T1,
        group_assignment: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "CollectiveReduceV3")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&communicator.to_handle(ctx)?)?;
        op.add_input(&group_assignment.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.reduction {
            op.set_attr_string("reduction", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.timeout_seconds {
            op.set_attr_float("timeout_seconds", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `CollectiveReduceV3::new().call(&ctx, &input, &communicator, &group_assignment)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CollectiveReduceV3>
pub fn collective_reduce_v3<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    communicator: &T1,
    group_assignment: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = CollectiveReduceV3::new();
    op.call(ctx, input, communicator, group_assignment)
}

/// CombinedNonMaxSuppression
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CombinedNonMaxSuppression>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CombinedNonMaxSuppression {
    pad_per_class: ::std::option::Option<bool>,
    clip_boxes: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CombinedNonMaxSuppression {
    fn default() -> Self {
        Self {
            pad_per_class: Some(false),
            clip_boxes: Some(true),
            target_device_name: None,
        }
    }
}
impl CombinedNonMaxSuppression {
    /// Creates a new `CombinedNonMaxSuppression`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `pad_per_class` attribute.
    pub fn pad_per_class<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.pad_per_class = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `clip_boxes` attribute.
    pub fn clip_boxes<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.clip_boxes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute combined_non_max_suppression.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        boxes: &T0,
        scores: &T1,
        max_output_size_per_class: &T2,
        max_total_size: &T3,
        iou_threshold: &T4,
        score_threshold: &T5,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 4]> {
        // Define Op
        let mut op = super::Op::new(ctx, "CombinedNonMaxSuppression")?;

        // Required input arguments
        op.add_input(&boxes.to_handle(ctx)?)?;
        op.add_input(&scores.to_handle(ctx)?)?;
        op.add_input(&max_output_size_per_class.to_handle(ctx)?)?;
        op.add_input(&max_total_size.to_handle(ctx)?)?;
        op.add_input(&iou_threshold.to_handle(ctx)?)?;
        op.add_input(&score_threshold.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.pad_per_class {
            op.set_attr_bool("pad_per_class", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.clip_boxes {
            op.set_attr_bool("clip_boxes", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<4>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `CombinedNonMaxSuppression::new().call(&ctx, &boxes, &scores, &max_output_size_per_class, &max_total_size, &iou_threshold, &score_threshold)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CombinedNonMaxSuppression>
pub fn combined_non_max_suppression<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    boxes: &T0,
    scores: &T1,
    max_output_size_per_class: &T2,
    max_total_size: &T3,
    iou_threshold: &T4,
    score_threshold: &T5,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 4]> {
    let op = CombinedNonMaxSuppression::new();
    op.call(
        ctx,
        boxes,
        scores,
        max_output_size_per_class,
        max_total_size,
        iou_threshold,
        score_threshold,
    )
}

/// Complex
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Complex>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Complex {
    Tout: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Complex {
    fn default() -> Self {
        Self {
            Tout: Some(crate::DataType::Complex64),
            target_device_name: None,
        }
    }
}
impl Complex {
    /// Creates a new `Complex`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Tout` attribute.
    pub fn Tout<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.Tout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute complex.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        real: &T0,
        imag: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Complex")?;

        // Required input arguments
        op.add_input(&real.to_handle(ctx)?)?;
        op.add_input(&imag.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Tout {
            op.set_attr_type("Tout", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Complex::new().call(&ctx, &real, &imag)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Complex>
pub fn complex<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    real: &T0,
    imag: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Complex::new();
    op.call(ctx, real, imag)
}

/// ComplexAbs
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ComplexAbs>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ComplexAbs {
    Tout: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ComplexAbs {
    fn default() -> Self {
        Self {
            Tout: Some(crate::DataType::Float),
            target_device_name: None,
        }
    }
}
impl ComplexAbs {
    /// Creates a new `ComplexAbs`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Tout` attribute.
    pub fn Tout<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.Tout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute complex_abs.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ComplexAbs")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Tout {
            op.set_attr_type("Tout", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ComplexAbs::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ComplexAbs>
pub fn complex_abs<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ComplexAbs::new();
    op.call(ctx, x)
}

/// CompositeTensorVariantFromComponents
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CompositeTensorVariantFromComponents>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CompositeTensorVariantFromComponents {
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CompositeTensorVariantFromComponents {
    fn default() -> Self {
        Self {
            metadata: None,
            target_device_name: None,
        }
    }
}
impl CompositeTensorVariantFromComponents {
    /// Creates a new `CompositeTensorVariantFromComponents`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute composite_tensor_variant_from_components.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        components: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "CompositeTensorVariantFromComponents")?;

        // Required input arguments
        op.add_input(&components.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `CompositeTensorVariantFromComponents::new().call(&ctx, &components)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CompositeTensorVariantFromComponents>
pub fn composite_tensor_variant_from_components<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    components: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = CompositeTensorVariantFromComponents::new();
    op.call(ctx, components)
}

/// CompositeTensorVariantToComponents
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CompositeTensorVariantToComponents>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CompositeTensorVariantToComponents {
    metadata: ::std::option::Option<::std::string::String>,
    Tcomponents: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CompositeTensorVariantToComponents {
    fn default() -> Self {
        Self {
            metadata: None,
            Tcomponents: None,
            target_device_name: None,
        }
    }
}
impl CompositeTensorVariantToComponents {
    /// Creates a new `CompositeTensorVariantToComponents`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `Tcomponents` attribute.
    pub fn Tcomponents<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Tcomponents = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute composite_tensor_variant_to_components.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        encoded: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "CompositeTensorVariantToComponents")?;

        // Required input arguments
        op.add_input(&encoded.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.Tcomponents {
            op.set_attr_type_list("Tcomponents", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `CompositeTensorVariantToComponents::new().call(&ctx, &encoded)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CompositeTensorVariantToComponents>
pub fn composite_tensor_variant_to_components<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    encoded: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = CompositeTensorVariantToComponents::new();
    op.call(ctx, encoded)
}

/// CompressElement
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CompressElement>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CompressElement {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CompressElement {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl CompressElement {
    /// Creates a new `CompressElement`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute compress_element.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        components: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "CompressElement")?;

        // Required input arguments
        op.add_input(&components.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `CompressElement::new().call(&ctx, &components)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CompressElement>
pub fn compress_element<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    components: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = CompressElement::new();
    op.call(ctx, components)
}

/// ComputeAccidentalHits
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ComputeAccidentalHits>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ComputeAccidentalHits {
    num_true: ::std::option::Option<i64>,
    seed: ::std::option::Option<i64>,
    seed2: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ComputeAccidentalHits {
    fn default() -> Self {
        Self {
            num_true: None,
            seed: Some(0i64),
            seed2: Some(0i64),
            target_device_name: None,
        }
    }
}
impl ComputeAccidentalHits {
    /// Creates a new `ComputeAccidentalHits`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_true` attribute.
    pub fn num_true<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_true = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed` attribute.
    pub fn seed<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed2` attribute.
    pub fn seed2<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute compute_accidental_hits.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        true_classes: &T0,
        sampled_candidates: &T1,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "ComputeAccidentalHits")?;

        // Required input arguments
        op.add_input(&true_classes.to_handle(ctx)?)?;
        op.add_input(&sampled_candidates.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_true {
            op.set_attr_int("num_true", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed {
            op.set_attr_int("seed", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed2 {
            op.set_attr_int("seed2", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `ComputeAccidentalHits::new().call(&ctx, &true_classes, &sampled_candidates)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ComputeAccidentalHits>
pub fn compute_accidental_hits<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    true_classes: &T0,
    sampled_candidates: &T1,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = ComputeAccidentalHits::new();
    op.call(ctx, true_classes, sampled_candidates)
}

/// ComputeBatchSize
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ComputeBatchSize>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ComputeBatchSize {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ComputeBatchSize {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ComputeBatchSize {
    /// Creates a new `ComputeBatchSize`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute compute_batch_size.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ComputeBatchSize")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ComputeBatchSize::new().call(&ctx, &input_dataset)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ComputeBatchSize>
pub fn compute_batch_size<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ComputeBatchSize::new();
    op.call(ctx, input_dataset)
}

/// Concat
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Concat>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Concat {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Concat {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Concat {
    /// Creates a new `Concat`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute concat.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        concat_dim: &T0,
        values: &[&T1],
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Concat")?;

        // Required input arguments
        op.add_input(&concat_dim.to_handle(ctx)?)?;
        let mut values_list = Vec::new();

        for t in values {
            values_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&values_list)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Concat::new().call(&ctx, &concat_dim, &values)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Concat>
pub fn concat<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    concat_dim: &T0,
    values: &[&T1],
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Concat::new();
    op.call(ctx, concat_dim, values)
}

/// ConcatOffset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ConcatOffset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ConcatOffset {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ConcatOffset {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ConcatOffset {
    /// Creates a new `ConcatOffset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute concat_offset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        concat_dim: &T0,
        shape: &[&T1],
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ConcatOffset")?;

        // Required input arguments
        op.add_input(&concat_dim.to_handle(ctx)?)?;
        let mut shape_list = Vec::new();

        for t in shape {
            shape_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&shape_list)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ConcatOffset::new().call(&ctx, &concat_dim, &shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ConcatOffset>
pub fn concat_offset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    concat_dim: &T0,
    shape: &[&T1],
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ConcatOffset::new();
    op.call(ctx, concat_dim, shape)
}

/// ConcatV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ConcatV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ConcatV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ConcatV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ConcatV2 {
    /// Creates a new `ConcatV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute concat_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        values: &[&T0],
        axis: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ConcatV2")?;

        // Required input arguments
        let mut values_list = Vec::new();

        for t in values {
            values_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&values_list)?;
        op.add_input(&axis.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ConcatV2::new().call(&ctx, &values, &axis)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ConcatV2>
pub fn concat_v2<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    values: &[&T0],
    axis: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ConcatV2::new();
    op.call(ctx, values, axis)
}

/// ConcatenateDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ConcatenateDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ConcatenateDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ConcatenateDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl ConcatenateDataset {
    /// Creates a new `ConcatenateDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute concatenate_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        another_dataset: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ConcatenateDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&another_dataset.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ConcatenateDataset::new().call(&ctx, &input_dataset, &another_dataset)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ConcatenateDataset>
pub fn concatenate_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    another_dataset: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ConcatenateDataset::new();
    op.call(ctx, input_dataset, another_dataset)
}

/// ConditionalAccumulator
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ConditionalAccumulator>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ConditionalAccumulator {
    dtype: ::std::option::Option<crate::DataType>,
    shape: ::std::option::Option<crate::Shape>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    reduction_type: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ConditionalAccumulator {
    fn default() -> Self {
        Self {
            dtype: None,
            shape: None,
            container: None,
            shared_name: None,
            reduction_type: Some(::std::string::String::from("MEAN")),
            target_device_name: None,
        }
    }
}
impl ConditionalAccumulator {
    /// Creates a new `ConditionalAccumulator`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shape` attribute.
    pub fn shape<ArgType: ::std::convert::Into<crate::Shape>>(mut self, value: ArgType) -> Self {
        self.shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `reduction_type` attribute.
    pub fn reduction_type<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.reduction_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute conditional_accumulator.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ConditionalAccumulator")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shape {
            op.set_attr_shape("shape", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.reduction_type {
            op.set_attr_string("reduction_type", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ConditionalAccumulator::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ConditionalAccumulator>
pub fn conditional_accumulator<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ConditionalAccumulator::new();
    op.call(ctx)
}

/// ConfigureAndInitializeGlobalTPU
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ConfigureAndInitializeGlobalTPU>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ConfigureAndInitializeGlobalTPU {
    use_tfrt_host_runtime: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ConfigureAndInitializeGlobalTPU {
    fn default() -> Self {
        Self {
            use_tfrt_host_runtime: Some(true),
            target_device_name: None,
        }
    }
}
impl ConfigureAndInitializeGlobalTPU {
    /// Creates a new `ConfigureAndInitializeGlobalTPU`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_tfrt_host_runtime` attribute.
    pub fn use_tfrt_host_runtime<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.use_tfrt_host_runtime = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute configure_and_initialize_global_tpu.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ConfigureAndInitializeGlobalTPU")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_tfrt_host_runtime {
            op.set_attr_bool("use_tfrt_host_runtime", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ConfigureAndInitializeGlobalTPU::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ConfigureAndInitializeGlobalTPU>
pub fn configure_and_initialize_global_tpu<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ConfigureAndInitializeGlobalTPU::new();
    op.call(ctx)
}

/// ConfigureDistributedTPU
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ConfigureDistributedTPU>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ConfigureDistributedTPU {
    embedding_config: ::std::option::Option<::std::string::String>,
    tpu_embedding_config: ::std::option::Option<::std::string::String>,
    is_global_init: ::std::option::Option<bool>,
    enable_whole_mesh_compilations: ::std::option::Option<bool>,
    compilation_failure_closes_chips: ::std::option::Option<bool>,
    tpu_cancellation_closes_chips: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ConfigureDistributedTPU {
    fn default() -> Self {
        Self {
            embedding_config: None,
            tpu_embedding_config: None,
            is_global_init: Some(false),
            enable_whole_mesh_compilations: Some(false),
            compilation_failure_closes_chips: Some(true),
            tpu_cancellation_closes_chips: Some(0i64),
            target_device_name: None,
        }
    }
}
impl ConfigureDistributedTPU {
    /// Creates a new `ConfigureDistributedTPU`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `embedding_config` attribute.
    pub fn embedding_config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.embedding_config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `tpu_embedding_config` attribute.
    pub fn tpu_embedding_config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.tpu_embedding_config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `is_global_init` attribute.
    pub fn is_global_init<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.is_global_init = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `enable_whole_mesh_compilations` attribute.
    pub fn enable_whole_mesh_compilations<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.enable_whole_mesh_compilations = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `compilation_failure_closes_chips` attribute.
    pub fn compilation_failure_closes_chips<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.compilation_failure_closes_chips = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `tpu_cancellation_closes_chips` attribute.
    pub fn tpu_cancellation_closes_chips<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.tpu_cancellation_closes_chips = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute configure_distributed_tpu.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ConfigureDistributedTPU")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.embedding_config {
            op.set_attr_string("embedding_config", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.tpu_embedding_config {
            op.set_attr_string("tpu_embedding_config", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.is_global_init {
            op.set_attr_bool("is_global_init", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.enable_whole_mesh_compilations {
            op.set_attr_bool("enable_whole_mesh_compilations", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.compilation_failure_closes_chips {
            op.set_attr_bool("compilation_failure_closes_chips", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.tpu_cancellation_closes_chips {
            op.set_attr_int("tpu_cancellation_closes_chips", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ConfigureDistributedTPU::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ConfigureDistributedTPU>
pub fn configure_distributed_tpu<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ConfigureDistributedTPU::new();
    op.call(ctx)
}

/// ConfigureTPUEmbedding
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ConfigureTPUEmbedding>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ConfigureTPUEmbedding {
    config: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ConfigureTPUEmbedding {
    fn default() -> Self {
        Self {
            config: None,
            target_device_name: None,
        }
    }
}
impl ConfigureTPUEmbedding {
    /// Creates a new `ConfigureTPUEmbedding`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute configure_tpuembedding.
    pub fn call<'a>(&self, ctx: &'a crate::eager::Context) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ConfigureTPUEmbedding")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ConfigureTPUEmbedding::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ConfigureTPUEmbedding>
pub fn configure_tpuembedding<'a>(ctx: &'a crate::eager::Context) -> crate::Result<()> {
    let op = ConfigureTPUEmbedding::new();
    op.call(ctx)
}

/// ConfigureTPUEmbeddingHost
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ConfigureTPUEmbeddingHost>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ConfigureTPUEmbeddingHost {
    config: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ConfigureTPUEmbeddingHost {
    fn default() -> Self {
        Self {
            config: None,
            target_device_name: None,
        }
    }
}
impl ConfigureTPUEmbeddingHost {
    /// Creates a new `ConfigureTPUEmbeddingHost`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute configure_tpuembedding_host.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        common_config: &T0,
        memory_config: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ConfigureTPUEmbeddingHost")?;

        // Required input arguments
        op.add_input(&common_config.to_handle(ctx)?)?;
        op.add_input(&memory_config.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ConfigureTPUEmbeddingHost::new().call(&ctx, &common_config, &memory_config)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ConfigureTPUEmbeddingHost>
pub fn configure_tpuembedding_host<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    common_config: &T0,
    memory_config: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ConfigureTPUEmbeddingHost::new();
    op.call(ctx, common_config, memory_config)
}

/// ConfigureTPUEmbeddingMemory
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ConfigureTPUEmbeddingMemory>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ConfigureTPUEmbeddingMemory {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ConfigureTPUEmbeddingMemory {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ConfigureTPUEmbeddingMemory {
    /// Creates a new `ConfigureTPUEmbeddingMemory`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute configure_tpuembedding_memory.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        common_config: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ConfigureTPUEmbeddingMemory")?;

        // Required input arguments
        op.add_input(&common_config.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ConfigureTPUEmbeddingMemory::new().call(&ctx, &common_config)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ConfigureTPUEmbeddingMemory>
pub fn configure_tpuembedding_memory<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    common_config: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ConfigureTPUEmbeddingMemory::new();
    op.call(ctx, common_config)
}

/// Conj
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Conj>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Conj {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Conj {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Conj {
    /// Creates a new `Conj`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute conj.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Conj")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Conj::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Conj>
pub fn conj<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Conj::new();
    op.call(ctx, input)
}

/// ConjugateTranspose
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ConjugateTranspose>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ConjugateTranspose {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ConjugateTranspose {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ConjugateTranspose {
    /// Creates a new `ConjugateTranspose`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute conjugate_transpose.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        perm: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ConjugateTranspose")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&perm.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ConjugateTranspose::new().call(&ctx, &x, &perm)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ConjugateTranspose>
pub fn conjugate_transpose<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    perm: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ConjugateTranspose::new();
    op.call(ctx, x, perm)
}

/// ConnectTPUEmbeddingHosts
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ConnectTPUEmbeddingHosts>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ConnectTPUEmbeddingHosts {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ConnectTPUEmbeddingHosts {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ConnectTPUEmbeddingHosts {
    /// Creates a new `ConnectTPUEmbeddingHosts`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute connect_tpuembedding_hosts.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        network_configs: &[&T0],
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ConnectTPUEmbeddingHosts")?;

        // Required input arguments
        let mut network_configs_list = Vec::new();

        for t in network_configs {
            network_configs_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&network_configs_list)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ConnectTPUEmbeddingHosts::new().call(&ctx, &network_configs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ConnectTPUEmbeddingHosts>
pub fn connect_tpuembedding_hosts<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    network_configs: &[&T0],
) -> crate::Result<()> {
    let op = ConnectTPUEmbeddingHosts::new();
    op.call(ctx, network_configs)
}

/// Const
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Const>
#[derive(::std::fmt::Debug)]
pub struct Const {
    value: ::std::option::Option<::std::boxed::Box<dyn crate::AnyTensor>>,
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Const {
    fn default() -> Self {
        Self {
            value: None,
            dtype: None,
            target_device_name: None,
        }
    }
}
impl Const {
    /// Creates a new `Const`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `value` attribute.
    pub fn value<T: crate::TensorType, ArgType: ::std::convert::Into<crate::Tensor<T>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.value = ::std::option::Option::Some(
            ::std::boxed::Box::new(value.into()) as ::std::boxed::Box<dyn crate::AnyTensor>
        );
        self
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute const_.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Const")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.value {
            op.set_attr_any_tensor("value", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Const::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Const>
pub fn const_<'a>(ctx: &'a crate::eager::Context) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Const::new();
    op.call(ctx)
}

/// ConsumeMutexLock
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ConsumeMutexLock>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ConsumeMutexLock {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ConsumeMutexLock {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ConsumeMutexLock {
    /// Creates a new `ConsumeMutexLock`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute consume_mutex_lock.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        mutex_lock: &T0,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ConsumeMutexLock")?;

        // Required input arguments
        op.add_input(&mutex_lock.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ConsumeMutexLock::new().call(&ctx, &mutex_lock)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ConsumeMutexLock>
pub fn consume_mutex_lock<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    mutex_lock: &T0,
) -> crate::Result<()> {
    let op = ConsumeMutexLock::new();
    op.call(ctx, mutex_lock)
}

/// ControlTrigger
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ControlTrigger>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ControlTrigger {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ControlTrigger {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ControlTrigger {
    /// Creates a new `ControlTrigger`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute control_trigger.
    pub fn call<'a>(&self, ctx: &'a crate::eager::Context) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ControlTrigger")?;

        // Required input arguments

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ControlTrigger::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ControlTrigger>
pub fn control_trigger<'a>(ctx: &'a crate::eager::Context) -> crate::Result<()> {
    let op = ControlTrigger::new();
    op.call(ctx)
}

/// Conv2D
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Conv2D>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Conv2D {
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    use_cudnn_on_gpu: ::std::option::Option<bool>,
    padding: ::std::option::Option<::std::string::String>,
    explicit_paddings: ::std::option::Option<::std::vec::Vec<i64>>,
    data_format: ::std::option::Option<::std::string::String>,
    dilations: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Conv2D {
    fn default() -> Self {
        Self {
            strides: None,
            use_cudnn_on_gpu: Some(true),
            padding: None,
            explicit_paddings: Some(vec![]),
            data_format: Some(::std::string::String::from("NHWC")),
            dilations: Some(vec![1, 1, 1, 1]),
            target_device_name: None,
        }
    }
}
impl Conv2D {
    /// Creates a new `Conv2D`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_cudnn_on_gpu` attribute.
    pub fn use_cudnn_on_gpu<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_cudnn_on_gpu = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `explicit_paddings` attribute.
    pub fn explicit_paddings<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.explicit_paddings = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `data_format` attribute.
    pub fn data_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.data_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dilations` attribute.
    pub fn dilations<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dilations = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute conv2_d.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        filter: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Conv2D")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&filter.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_cudnn_on_gpu {
            op.set_attr_bool("use_cudnn_on_gpu", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.explicit_paddings {
            op.set_attr_int_list("explicit_paddings", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.data_format {
            op.set_attr_string("data_format", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dilations {
            op.set_attr_int_list("dilations", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Conv2D::new().call(&ctx, &input, &filter)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Conv2D>
pub fn conv2_d<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    filter: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Conv2D::new();
    op.call(ctx, input, filter)
}

/// Conv2DBackpropFilter
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Conv2DBackpropFilter>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Conv2DBackpropFilter {
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    use_cudnn_on_gpu: ::std::option::Option<bool>,
    padding: ::std::option::Option<::std::string::String>,
    explicit_paddings: ::std::option::Option<::std::vec::Vec<i64>>,
    data_format: ::std::option::Option<::std::string::String>,
    dilations: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Conv2DBackpropFilter {
    fn default() -> Self {
        Self {
            strides: None,
            use_cudnn_on_gpu: Some(true),
            padding: None,
            explicit_paddings: Some(vec![]),
            data_format: Some(::std::string::String::from("NHWC")),
            dilations: Some(vec![1, 1, 1, 1]),
            target_device_name: None,
        }
    }
}
impl Conv2DBackpropFilter {
    /// Creates a new `Conv2DBackpropFilter`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_cudnn_on_gpu` attribute.
    pub fn use_cudnn_on_gpu<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_cudnn_on_gpu = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `explicit_paddings` attribute.
    pub fn explicit_paddings<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.explicit_paddings = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `data_format` attribute.
    pub fn data_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.data_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dilations` attribute.
    pub fn dilations<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dilations = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute conv2_dbackprop_filter.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        filter_sizes: &T1,
        out_backprop: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Conv2DBackpropFilter")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&filter_sizes.to_handle(ctx)?)?;
        op.add_input(&out_backprop.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_cudnn_on_gpu {
            op.set_attr_bool("use_cudnn_on_gpu", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.explicit_paddings {
            op.set_attr_int_list("explicit_paddings", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.data_format {
            op.set_attr_string("data_format", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dilations {
            op.set_attr_int_list("dilations", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Conv2DBackpropFilter::new().call(&ctx, &input, &filter_sizes, &out_backprop)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Conv2DBackpropFilter>
pub fn conv2_dbackprop_filter<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    filter_sizes: &T1,
    out_backprop: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Conv2DBackpropFilter::new();
    op.call(ctx, input, filter_sizes, out_backprop)
}

/// Conv2DBackpropInput
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Conv2DBackpropInput>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Conv2DBackpropInput {
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    use_cudnn_on_gpu: ::std::option::Option<bool>,
    padding: ::std::option::Option<::std::string::String>,
    explicit_paddings: ::std::option::Option<::std::vec::Vec<i64>>,
    data_format: ::std::option::Option<::std::string::String>,
    dilations: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Conv2DBackpropInput {
    fn default() -> Self {
        Self {
            strides: None,
            use_cudnn_on_gpu: Some(true),
            padding: None,
            explicit_paddings: Some(vec![]),
            data_format: Some(::std::string::String::from("NHWC")),
            dilations: Some(vec![1, 1, 1, 1]),
            target_device_name: None,
        }
    }
}
impl Conv2DBackpropInput {
    /// Creates a new `Conv2DBackpropInput`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_cudnn_on_gpu` attribute.
    pub fn use_cudnn_on_gpu<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_cudnn_on_gpu = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `explicit_paddings` attribute.
    pub fn explicit_paddings<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.explicit_paddings = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `data_format` attribute.
    pub fn data_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.data_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dilations` attribute.
    pub fn dilations<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dilations = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute conv2_dbackprop_input.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_sizes: &T0,
        filter: &T1,
        out_backprop: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Conv2DBackpropInput")?;

        // Required input arguments
        op.add_input(&input_sizes.to_handle(ctx)?)?;
        op.add_input(&filter.to_handle(ctx)?)?;
        op.add_input(&out_backprop.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_cudnn_on_gpu {
            op.set_attr_bool("use_cudnn_on_gpu", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.explicit_paddings {
            op.set_attr_int_list("explicit_paddings", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.data_format {
            op.set_attr_string("data_format", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dilations {
            op.set_attr_int_list("dilations", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Conv2DBackpropInput::new().call(&ctx, &input_sizes, &filter, &out_backprop)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Conv2DBackpropInput>
pub fn conv2_dbackprop_input<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_sizes: &T0,
    filter: &T1,
    out_backprop: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Conv2DBackpropInput::new();
    op.call(ctx, input_sizes, filter, out_backprop)
}

/// Conv3D
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Conv3D>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Conv3D {
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    data_format: ::std::option::Option<::std::string::String>,
    dilations: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Conv3D {
    fn default() -> Self {
        Self {
            strides: None,
            padding: None,
            data_format: Some(::std::string::String::from("NDHWC")),
            dilations: Some(vec![1, 1, 1, 1, 1]),
            target_device_name: None,
        }
    }
}
impl Conv3D {
    /// Creates a new `Conv3D`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `data_format` attribute.
    pub fn data_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.data_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dilations` attribute.
    pub fn dilations<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dilations = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute conv3_d.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        filter: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Conv3D")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&filter.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.data_format {
            op.set_attr_string("data_format", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dilations {
            op.set_attr_int_list("dilations", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Conv3D::new().call(&ctx, &input, &filter)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Conv3D>
pub fn conv3_d<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    filter: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Conv3D::new();
    op.call(ctx, input, filter)
}

/// Conv3DBackpropFilter
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Conv3DBackpropFilter>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Conv3DBackpropFilter {
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    dilations: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Conv3DBackpropFilter {
    fn default() -> Self {
        Self {
            strides: None,
            padding: None,
            dilations: Some(vec![1, 1, 1, 1, 1]),
            target_device_name: None,
        }
    }
}
impl Conv3DBackpropFilter {
    /// Creates a new `Conv3DBackpropFilter`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dilations` attribute.
    pub fn dilations<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dilations = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute conv3_dbackprop_filter.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        filter: &T1,
        out_backprop: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Conv3DBackpropFilter")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&filter.to_handle(ctx)?)?;
        op.add_input(&out_backprop.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dilations {
            op.set_attr_int_list("dilations", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Conv3DBackpropFilter::new().call(&ctx, &input, &filter, &out_backprop)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Conv3DBackpropFilter>
pub fn conv3_dbackprop_filter<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    filter: &T1,
    out_backprop: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Conv3DBackpropFilter::new();
    op.call(ctx, input, filter, out_backprop)
}

/// Conv3DBackpropFilterV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Conv3DBackpropFilterV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Conv3DBackpropFilterV2 {
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    data_format: ::std::option::Option<::std::string::String>,
    dilations: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Conv3DBackpropFilterV2 {
    fn default() -> Self {
        Self {
            strides: None,
            padding: None,
            data_format: Some(::std::string::String::from("NDHWC")),
            dilations: Some(vec![1, 1, 1, 1, 1]),
            target_device_name: None,
        }
    }
}
impl Conv3DBackpropFilterV2 {
    /// Creates a new `Conv3DBackpropFilterV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `data_format` attribute.
    pub fn data_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.data_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dilations` attribute.
    pub fn dilations<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dilations = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute conv3_dbackprop_filter_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        filter_sizes: &T1,
        out_backprop: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Conv3DBackpropFilterV2")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&filter_sizes.to_handle(ctx)?)?;
        op.add_input(&out_backprop.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.data_format {
            op.set_attr_string("data_format", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dilations {
            op.set_attr_int_list("dilations", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Conv3DBackpropFilterV2::new().call(&ctx, &input, &filter_sizes, &out_backprop)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Conv3DBackpropFilterV2>
pub fn conv3_dbackprop_filter_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    filter_sizes: &T1,
    out_backprop: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Conv3DBackpropFilterV2::new();
    op.call(ctx, input, filter_sizes, out_backprop)
}

/// Conv3DBackpropInput
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Conv3DBackpropInput>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Conv3DBackpropInput {
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    dilations: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Conv3DBackpropInput {
    fn default() -> Self {
        Self {
            strides: None,
            padding: None,
            dilations: Some(vec![1, 1, 1, 1, 1]),
            target_device_name: None,
        }
    }
}
impl Conv3DBackpropInput {
    /// Creates a new `Conv3DBackpropInput`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dilations` attribute.
    pub fn dilations<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dilations = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute conv3_dbackprop_input.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        filter: &T1,
        out_backprop: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Conv3DBackpropInput")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&filter.to_handle(ctx)?)?;
        op.add_input(&out_backprop.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dilations {
            op.set_attr_int_list("dilations", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Conv3DBackpropInput::new().call(&ctx, &input, &filter, &out_backprop)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Conv3DBackpropInput>
pub fn conv3_dbackprop_input<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    filter: &T1,
    out_backprop: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Conv3DBackpropInput::new();
    op.call(ctx, input, filter, out_backprop)
}

/// Conv3DBackpropInputV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Conv3DBackpropInputV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Conv3DBackpropInputV2 {
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    data_format: ::std::option::Option<::std::string::String>,
    dilations: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Conv3DBackpropInputV2 {
    fn default() -> Self {
        Self {
            strides: None,
            padding: None,
            data_format: Some(::std::string::String::from("NDHWC")),
            dilations: Some(vec![1, 1, 1, 1, 1]),
            target_device_name: None,
        }
    }
}
impl Conv3DBackpropInputV2 {
    /// Creates a new `Conv3DBackpropInputV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `data_format` attribute.
    pub fn data_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.data_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dilations` attribute.
    pub fn dilations<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dilations = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute conv3_dbackprop_input_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_sizes: &T0,
        filter: &T1,
        out_backprop: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Conv3DBackpropInputV2")?;

        // Required input arguments
        op.add_input(&input_sizes.to_handle(ctx)?)?;
        op.add_input(&filter.to_handle(ctx)?)?;
        op.add_input(&out_backprop.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.data_format {
            op.set_attr_string("data_format", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dilations {
            op.set_attr_int_list("dilations", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Conv3DBackpropInputV2::new().call(&ctx, &input_sizes, &filter, &out_backprop)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Conv3DBackpropInputV2>
pub fn conv3_dbackprop_input_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_sizes: &T0,
    filter: &T1,
    out_backprop: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Conv3DBackpropInputV2::new();
    op.call(ctx, input_sizes, filter, out_backprop)
}

/// Copy
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Copy>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Copy {
    tensor_name: ::std::option::Option<::std::string::String>,
    debug_ops_spec: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Copy {
    fn default() -> Self {
        Self {
            tensor_name: None,
            debug_ops_spec: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl Copy {
    /// Creates a new `Copy`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `tensor_name` attribute.
    pub fn tensor_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.tensor_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `debug_ops_spec` attribute.
    pub fn debug_ops_spec<ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.debug_ops_spec = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute copy.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Copy")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.tensor_name {
            op.set_attr_string("tensor_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.debug_ops_spec {
            op.set_attr_string_list("debug_ops_spec", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Copy::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Copy>
pub fn copy<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Copy::new();
    op.call(ctx, input)
}

/// CopyHost
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CopyHost>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CopyHost {
    tensor_name: ::std::option::Option<::std::string::String>,
    debug_ops_spec: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CopyHost {
    fn default() -> Self {
        Self {
            tensor_name: None,
            debug_ops_spec: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl CopyHost {
    /// Creates a new `CopyHost`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `tensor_name` attribute.
    pub fn tensor_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.tensor_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `debug_ops_spec` attribute.
    pub fn debug_ops_spec<ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.debug_ops_spec = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute copy_host.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "CopyHost")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.tensor_name {
            op.set_attr_string("tensor_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.debug_ops_spec {
            op.set_attr_string_list("debug_ops_spec", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `CopyHost::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CopyHost>
pub fn copy_host<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = CopyHost::new();
    op.call(ctx, input)
}

/// CopyToMesh
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CopyToMesh>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CopyToMesh {
    layout: ::std::option::Option<::std::string::String>,
    source_layout: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CopyToMesh {
    fn default() -> Self {
        Self {
            layout: None,
            source_layout: None,
            target_device_name: None,
        }
    }
}
impl CopyToMesh {
    /// Creates a new `CopyToMesh`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `layout` attribute.
    pub fn layout<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.layout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `source_layout` attribute.
    pub fn source_layout<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.source_layout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute copy_to_mesh.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "CopyToMesh")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.layout {
            op.set_attr_string("layout", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.source_layout {
            op.set_attr_string("source_layout", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `CopyToMesh::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CopyToMesh>
pub fn copy_to_mesh<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = CopyToMesh::new();
    op.call(ctx, input)
}

/// Cos
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Cos>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Cos {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Cos {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Cos {
    /// Creates a new `Cos`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute cos.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Cos")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Cos::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Cos>
pub fn cos<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Cos::new();
    op.call(ctx, x)
}

/// Cosh
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Cosh>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Cosh {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Cosh {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Cosh {
    /// Creates a new `Cosh`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute cosh.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Cosh")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Cosh::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Cosh>
pub fn cosh<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Cosh::new();
    op.call(ctx, x)
}

/// CountUpTo
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CountUpTo>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CountUpTo {
    limit: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CountUpTo {
    fn default() -> Self {
        Self {
            limit: None,
            target_device_name: None,
        }
    }
}
impl CountUpTo {
    /// Creates a new `CountUpTo`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `limit` attribute.
    pub fn limit<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.limit = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute count_up_to.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        ref_: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "CountUpTo")?;

        // Required input arguments
        op.add_input(&ref_.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.limit {
            op.set_attr_int("limit", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `CountUpTo::new().call(&ctx, &ref_)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CountUpTo>
pub fn count_up_to<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    ref_: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = CountUpTo::new();
    op.call(ctx, ref_)
}

/// CreateSummaryDbWriter
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CreateSummaryDbWriter>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CreateSummaryDbWriter {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CreateSummaryDbWriter {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl CreateSummaryDbWriter {
    /// Creates a new `CreateSummaryDbWriter`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute create_summary_db_writer.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        writer: &T0,
        db_uri: &T1,
        experiment_name: &T2,
        run_name: &T3,
        user_name: &T4,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "CreateSummaryDbWriter")?;

        // Required input arguments
        op.add_input(&writer.to_handle(ctx)?)?;
        op.add_input(&db_uri.to_handle(ctx)?)?;
        op.add_input(&experiment_name.to_handle(ctx)?)?;
        op.add_input(&run_name.to_handle(ctx)?)?;
        op.add_input(&user_name.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `CreateSummaryDbWriter::new().call(&ctx, &writer, &db_uri, &experiment_name, &run_name, &user_name)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CreateSummaryDbWriter>
pub fn create_summary_db_writer<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    writer: &T0,
    db_uri: &T1,
    experiment_name: &T2,
    run_name: &T3,
    user_name: &T4,
) -> crate::Result<()> {
    let op = CreateSummaryDbWriter::new();
    op.call(ctx, writer, db_uri, experiment_name, run_name, user_name)
}

/// CreateSummaryFileWriter
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CreateSummaryFileWriter>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CreateSummaryFileWriter {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CreateSummaryFileWriter {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl CreateSummaryFileWriter {
    /// Creates a new `CreateSummaryFileWriter`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute create_summary_file_writer.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        writer: &T0,
        logdir: &T1,
        max_queue: &T2,
        flush_millis: &T3,
        filename_suffix: &T4,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "CreateSummaryFileWriter")?;

        // Required input arguments
        op.add_input(&writer.to_handle(ctx)?)?;
        op.add_input(&logdir.to_handle(ctx)?)?;
        op.add_input(&max_queue.to_handle(ctx)?)?;
        op.add_input(&flush_millis.to_handle(ctx)?)?;
        op.add_input(&filename_suffix.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `CreateSummaryFileWriter::new().call(&ctx, &writer, &logdir, &max_queue, &flush_millis, &filename_suffix)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CreateSummaryFileWriter>
pub fn create_summary_file_writer<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    writer: &T0,
    logdir: &T1,
    max_queue: &T2,
    flush_millis: &T3,
    filename_suffix: &T4,
) -> crate::Result<()> {
    let op = CreateSummaryFileWriter::new();
    op.call(
        ctx,
        writer,
        logdir,
        max_queue,
        flush_millis,
        filename_suffix,
    )
}

/// CropAndResize
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CropAndResize>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CropAndResize {
    method: ::std::option::Option<::std::string::String>,
    extrapolation_value: ::std::option::Option<f32>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CropAndResize {
    fn default() -> Self {
        Self {
            method: Some(::std::string::String::from("bilinear")),
            extrapolation_value: Some(0f32),
            target_device_name: None,
        }
    }
}
impl CropAndResize {
    /// Creates a new `CropAndResize`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `method` attribute.
    pub fn method<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.method = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `extrapolation_value` attribute.
    pub fn extrapolation_value<ArgType: ::std::convert::Into<f32>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.extrapolation_value = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute crop_and_resize.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        image: &T0,
        boxes: &T1,
        box_ind: &T2,
        crop_size: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "CropAndResize")?;

        // Required input arguments
        op.add_input(&image.to_handle(ctx)?)?;
        op.add_input(&boxes.to_handle(ctx)?)?;
        op.add_input(&box_ind.to_handle(ctx)?)?;
        op.add_input(&crop_size.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.method {
            op.set_attr_string("method", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.extrapolation_value {
            op.set_attr_float("extrapolation_value", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `CropAndResize::new().call(&ctx, &image, &boxes, &box_ind, &crop_size)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CropAndResize>
pub fn crop_and_resize<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    image: &T0,
    boxes: &T1,
    box_ind: &T2,
    crop_size: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = CropAndResize::new();
    op.call(ctx, image, boxes, box_ind, crop_size)
}

/// CropAndResizeGradBoxes
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CropAndResizeGradBoxes>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CropAndResizeGradBoxes {
    method: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CropAndResizeGradBoxes {
    fn default() -> Self {
        Self {
            method: Some(::std::string::String::from("bilinear")),
            target_device_name: None,
        }
    }
}
impl CropAndResizeGradBoxes {
    /// Creates a new `CropAndResizeGradBoxes`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `method` attribute.
    pub fn method<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.method = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute crop_and_resize_grad_boxes.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        grads: &T0,
        image: &T1,
        boxes: &T2,
        box_ind: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "CropAndResizeGradBoxes")?;

        // Required input arguments
        op.add_input(&grads.to_handle(ctx)?)?;
        op.add_input(&image.to_handle(ctx)?)?;
        op.add_input(&boxes.to_handle(ctx)?)?;
        op.add_input(&box_ind.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.method {
            op.set_attr_string("method", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `CropAndResizeGradBoxes::new().call(&ctx, &grads, &image, &boxes, &box_ind)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CropAndResizeGradBoxes>
pub fn crop_and_resize_grad_boxes<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    grads: &T0,
    image: &T1,
    boxes: &T2,
    box_ind: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = CropAndResizeGradBoxes::new();
    op.call(ctx, grads, image, boxes, box_ind)
}

/// CropAndResizeGradImage
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CropAndResizeGradImage>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CropAndResizeGradImage {
    T: ::std::option::Option<crate::DataType>,
    method: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CropAndResizeGradImage {
    fn default() -> Self {
        Self {
            T: None,
            method: Some(::std::string::String::from("bilinear")),
            target_device_name: None,
        }
    }
}
impl CropAndResizeGradImage {
    /// Creates a new `CropAndResizeGradImage`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `T` attribute.
    pub fn T<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.T = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `method` attribute.
    pub fn method<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.method = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute crop_and_resize_grad_image.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        grads: &T0,
        boxes: &T1,
        box_ind: &T2,
        image_size: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "CropAndResizeGradImage")?;

        // Required input arguments
        op.add_input(&grads.to_handle(ctx)?)?;
        op.add_input(&boxes.to_handle(ctx)?)?;
        op.add_input(&box_ind.to_handle(ctx)?)?;
        op.add_input(&image_size.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.T {
            op.set_attr_type("T", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.method {
            op.set_attr_string("method", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `CropAndResizeGradImage::new().call(&ctx, &grads, &boxes, &box_ind, &image_size)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CropAndResizeGradImage>
pub fn crop_and_resize_grad_image<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    grads: &T0,
    boxes: &T1,
    box_ind: &T2,
    image_size: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = CropAndResizeGradImage::new();
    op.call(ctx, grads, boxes, box_ind, image_size)
}

/// Cross
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Cross>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Cross {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Cross {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Cross {
    /// Creates a new `Cross`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute cross.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        a: &T0,
        b: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Cross")?;

        // Required input arguments
        op.add_input(&a.to_handle(ctx)?)?;
        op.add_input(&b.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Cross::new().call(&ctx, &a, &b)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Cross>
pub fn cross<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    a: &T0,
    b: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Cross::new();
    op.call(ctx, a, b)
}

/// CrossReplicaSum
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CrossReplicaSum>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CrossReplicaSum {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CrossReplicaSum {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl CrossReplicaSum {
    /// Creates a new `CrossReplicaSum`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute cross_replica_sum.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        group_assignment: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "CrossReplicaSum")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&group_assignment.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `CrossReplicaSum::new().call(&ctx, &input, &group_assignment)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CrossReplicaSum>
pub fn cross_replica_sum<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    group_assignment: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = CrossReplicaSum::new();
    op.call(ctx, input, group_assignment)
}

/// CudnnRNN
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CudnnRNN>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CudnnRNN {
    rnn_mode: ::std::option::Option<::std::string::String>,
    input_mode: ::std::option::Option<::std::string::String>,
    direction: ::std::option::Option<::std::string::String>,
    dropout: ::std::option::Option<f32>,
    seed: ::std::option::Option<i64>,
    seed2: ::std::option::Option<i64>,
    is_training: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CudnnRNN {
    fn default() -> Self {
        Self {
            rnn_mode: Some(::std::string::String::from("lstm")),
            input_mode: Some(::std::string::String::from("linear_input")),
            direction: Some(::std::string::String::from("unidirectional")),
            dropout: Some(0f32),
            seed: Some(0i64),
            seed2: Some(0i64),
            is_training: Some(true),
            target_device_name: None,
        }
    }
}
impl CudnnRNN {
    /// Creates a new `CudnnRNN`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `rnn_mode` attribute.
    pub fn rnn_mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.rnn_mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `input_mode` attribute.
    pub fn input_mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.input_mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `direction` attribute.
    pub fn direction<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.direction = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dropout` attribute.
    pub fn dropout<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.dropout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed` attribute.
    pub fn seed<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed2` attribute.
    pub fn seed2<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `is_training` attribute.
    pub fn is_training<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.is_training = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute cudnn_rnn.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        input_h: &T1,
        input_c: &T2,
        params: &T3,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 4]> {
        // Define Op
        let mut op = super::Op::new(ctx, "CudnnRNN")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&input_h.to_handle(ctx)?)?;
        op.add_input(&input_c.to_handle(ctx)?)?;
        op.add_input(&params.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.rnn_mode {
            op.set_attr_string("rnn_mode", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.input_mode {
            op.set_attr_string("input_mode", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.direction {
            op.set_attr_string("direction", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dropout {
            op.set_attr_float("dropout", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed {
            op.set_attr_int("seed", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed2 {
            op.set_attr_int("seed2", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.is_training {
            op.set_attr_bool("is_training", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<4>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `CudnnRNN::new().call(&ctx, &input, &input_h, &input_c, &params)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CudnnRNN>
pub fn cudnn_rnn<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    input_h: &T1,
    input_c: &T2,
    params: &T3,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 4]> {
    let op = CudnnRNN::new();
    op.call(ctx, input, input_h, input_c, params)
}

/// CudnnRNNBackprop
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CudnnRNNBackprop>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CudnnRNNBackprop {
    rnn_mode: ::std::option::Option<::std::string::String>,
    input_mode: ::std::option::Option<::std::string::String>,
    direction: ::std::option::Option<::std::string::String>,
    dropout: ::std::option::Option<f32>,
    seed: ::std::option::Option<i64>,
    seed2: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CudnnRNNBackprop {
    fn default() -> Self {
        Self {
            rnn_mode: Some(::std::string::String::from("lstm")),
            input_mode: Some(::std::string::String::from("linear_input")),
            direction: Some(::std::string::String::from("unidirectional")),
            dropout: Some(0f32),
            seed: Some(0i64),
            seed2: Some(0i64),
            target_device_name: None,
        }
    }
}
impl CudnnRNNBackprop {
    /// Creates a new `CudnnRNNBackprop`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `rnn_mode` attribute.
    pub fn rnn_mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.rnn_mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `input_mode` attribute.
    pub fn input_mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.input_mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `direction` attribute.
    pub fn direction<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.direction = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dropout` attribute.
    pub fn dropout<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.dropout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed` attribute.
    pub fn seed<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed2` attribute.
    pub fn seed2<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute cudnn_rnnbackprop.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
        T9: crate::eager::ToTensorHandle<'a>,
        T10: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        input_h: &T1,
        input_c: &T2,
        params: &T3,
        output: &T4,
        output_h: &T5,
        output_c: &T6,
        output_backprop: &T7,
        output_h_backprop: &T8,
        output_c_backprop: &T9,
        reserve_space: &T10,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 4]> {
        // Define Op
        let mut op = super::Op::new(ctx, "CudnnRNNBackprop")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&input_h.to_handle(ctx)?)?;
        op.add_input(&input_c.to_handle(ctx)?)?;
        op.add_input(&params.to_handle(ctx)?)?;
        op.add_input(&output.to_handle(ctx)?)?;
        op.add_input(&output_h.to_handle(ctx)?)?;
        op.add_input(&output_c.to_handle(ctx)?)?;
        op.add_input(&output_backprop.to_handle(ctx)?)?;
        op.add_input(&output_h_backprop.to_handle(ctx)?)?;
        op.add_input(&output_c_backprop.to_handle(ctx)?)?;
        op.add_input(&reserve_space.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.rnn_mode {
            op.set_attr_string("rnn_mode", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.input_mode {
            op.set_attr_string("input_mode", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.direction {
            op.set_attr_string("direction", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dropout {
            op.set_attr_float("dropout", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed {
            op.set_attr_int("seed", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed2 {
            op.set_attr_int("seed2", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<4>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `CudnnRNNBackprop::new().call(&ctx, &input, &input_h, &input_c, &params, &output, &output_h, &output_c, &output_backprop, &output_h_backprop, &output_c_backprop, &reserve_space)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CudnnRNNBackprop>
pub fn cudnn_rnnbackprop<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
    T9: crate::eager::ToTensorHandle<'a>,
    T10: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    input_h: &T1,
    input_c: &T2,
    params: &T3,
    output: &T4,
    output_h: &T5,
    output_c: &T6,
    output_backprop: &T7,
    output_h_backprop: &T8,
    output_c_backprop: &T9,
    reserve_space: &T10,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 4]> {
    let op = CudnnRNNBackprop::new();
    op.call(
        ctx,
        input,
        input_h,
        input_c,
        params,
        output,
        output_h,
        output_c,
        output_backprop,
        output_h_backprop,
        output_c_backprop,
        reserve_space,
    )
}

/// CudnnRNNBackpropV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CudnnRNNBackpropV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CudnnRNNBackpropV2 {
    rnn_mode: ::std::option::Option<::std::string::String>,
    input_mode: ::std::option::Option<::std::string::String>,
    direction: ::std::option::Option<::std::string::String>,
    dropout: ::std::option::Option<f32>,
    seed: ::std::option::Option<i64>,
    seed2: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CudnnRNNBackpropV2 {
    fn default() -> Self {
        Self {
            rnn_mode: Some(::std::string::String::from("lstm")),
            input_mode: Some(::std::string::String::from("linear_input")),
            direction: Some(::std::string::String::from("unidirectional")),
            dropout: Some(0f32),
            seed: Some(0i64),
            seed2: Some(0i64),
            target_device_name: None,
        }
    }
}
impl CudnnRNNBackpropV2 {
    /// Creates a new `CudnnRNNBackpropV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `rnn_mode` attribute.
    pub fn rnn_mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.rnn_mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `input_mode` attribute.
    pub fn input_mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.input_mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `direction` attribute.
    pub fn direction<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.direction = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dropout` attribute.
    pub fn dropout<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.dropout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed` attribute.
    pub fn seed<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed2` attribute.
    pub fn seed2<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute cudnn_rnnbackprop_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
        T9: crate::eager::ToTensorHandle<'a>,
        T10: crate::eager::ToTensorHandle<'a>,
        T11: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        input_h: &T1,
        input_c: &T2,
        params: &T3,
        output: &T4,
        output_h: &T5,
        output_c: &T6,
        output_backprop: &T7,
        output_h_backprop: &T8,
        output_c_backprop: &T9,
        reserve_space: &T10,
        host_reserved: &T11,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 4]> {
        // Define Op
        let mut op = super::Op::new(ctx, "CudnnRNNBackpropV2")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&input_h.to_handle(ctx)?)?;
        op.add_input(&input_c.to_handle(ctx)?)?;
        op.add_input(&params.to_handle(ctx)?)?;
        op.add_input(&output.to_handle(ctx)?)?;
        op.add_input(&output_h.to_handle(ctx)?)?;
        op.add_input(&output_c.to_handle(ctx)?)?;
        op.add_input(&output_backprop.to_handle(ctx)?)?;
        op.add_input(&output_h_backprop.to_handle(ctx)?)?;
        op.add_input(&output_c_backprop.to_handle(ctx)?)?;
        op.add_input(&reserve_space.to_handle(ctx)?)?;
        op.add_input(&host_reserved.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.rnn_mode {
            op.set_attr_string("rnn_mode", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.input_mode {
            op.set_attr_string("input_mode", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.direction {
            op.set_attr_string("direction", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dropout {
            op.set_attr_float("dropout", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed {
            op.set_attr_int("seed", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed2 {
            op.set_attr_int("seed2", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<4>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `CudnnRNNBackpropV2::new().call(&ctx, &input, &input_h, &input_c, &params, &output, &output_h, &output_c, &output_backprop, &output_h_backprop, &output_c_backprop, &reserve_space, &host_reserved)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CudnnRNNBackpropV2>
pub fn cudnn_rnnbackprop_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
    T9: crate::eager::ToTensorHandle<'a>,
    T10: crate::eager::ToTensorHandle<'a>,
    T11: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    input_h: &T1,
    input_c: &T2,
    params: &T3,
    output: &T4,
    output_h: &T5,
    output_c: &T6,
    output_backprop: &T7,
    output_h_backprop: &T8,
    output_c_backprop: &T9,
    reserve_space: &T10,
    host_reserved: &T11,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 4]> {
    let op = CudnnRNNBackpropV2::new();
    op.call(
        ctx,
        input,
        input_h,
        input_c,
        params,
        output,
        output_h,
        output_c,
        output_backprop,
        output_h_backprop,
        output_c_backprop,
        reserve_space,
        host_reserved,
    )
}

/// CudnnRNNBackpropV3
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CudnnRNNBackpropV3>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CudnnRNNBackpropV3 {
    rnn_mode: ::std::option::Option<::std::string::String>,
    input_mode: ::std::option::Option<::std::string::String>,
    direction: ::std::option::Option<::std::string::String>,
    dropout: ::std::option::Option<f32>,
    seed: ::std::option::Option<i64>,
    seed2: ::std::option::Option<i64>,
    num_proj: ::std::option::Option<i64>,
    time_major: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CudnnRNNBackpropV3 {
    fn default() -> Self {
        Self {
            rnn_mode: Some(::std::string::String::from("lstm")),
            input_mode: Some(::std::string::String::from("linear_input")),
            direction: Some(::std::string::String::from("unidirectional")),
            dropout: Some(0f32),
            seed: Some(0i64),
            seed2: Some(0i64),
            num_proj: Some(0i64),
            time_major: Some(true),
            target_device_name: None,
        }
    }
}
impl CudnnRNNBackpropV3 {
    /// Creates a new `CudnnRNNBackpropV3`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `rnn_mode` attribute.
    pub fn rnn_mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.rnn_mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `input_mode` attribute.
    pub fn input_mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.input_mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `direction` attribute.
    pub fn direction<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.direction = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dropout` attribute.
    pub fn dropout<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.dropout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed` attribute.
    pub fn seed<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed2` attribute.
    pub fn seed2<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_proj` attribute.
    pub fn num_proj<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_proj = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `time_major` attribute.
    pub fn time_major<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.time_major = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute cudnn_rnnbackprop_v3.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
        T9: crate::eager::ToTensorHandle<'a>,
        T10: crate::eager::ToTensorHandle<'a>,
        T11: crate::eager::ToTensorHandle<'a>,
        T12: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        input_h: &T1,
        input_c: &T2,
        params: &T3,
        sequence_lengths: &T4,
        output: &T5,
        output_h: &T6,
        output_c: &T7,
        output_backprop: &T8,
        output_h_backprop: &T9,
        output_c_backprop: &T10,
        reserve_space: &T11,
        host_reserved: &T12,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 4]> {
        // Define Op
        let mut op = super::Op::new(ctx, "CudnnRNNBackpropV3")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&input_h.to_handle(ctx)?)?;
        op.add_input(&input_c.to_handle(ctx)?)?;
        op.add_input(&params.to_handle(ctx)?)?;
        op.add_input(&sequence_lengths.to_handle(ctx)?)?;
        op.add_input(&output.to_handle(ctx)?)?;
        op.add_input(&output_h.to_handle(ctx)?)?;
        op.add_input(&output_c.to_handle(ctx)?)?;
        op.add_input(&output_backprop.to_handle(ctx)?)?;
        op.add_input(&output_h_backprop.to_handle(ctx)?)?;
        op.add_input(&output_c_backprop.to_handle(ctx)?)?;
        op.add_input(&reserve_space.to_handle(ctx)?)?;
        op.add_input(&host_reserved.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.rnn_mode {
            op.set_attr_string("rnn_mode", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.input_mode {
            op.set_attr_string("input_mode", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.direction {
            op.set_attr_string("direction", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dropout {
            op.set_attr_float("dropout", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed {
            op.set_attr_int("seed", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed2 {
            op.set_attr_int("seed2", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_proj {
            op.set_attr_int("num_proj", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.time_major {
            op.set_attr_bool("time_major", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<4>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `CudnnRNNBackpropV3::new().call(&ctx, &input, &input_h, &input_c, &params, &sequence_lengths, &output, &output_h, &output_c, &output_backprop, &output_h_backprop, &output_c_backprop, &reserve_space, &host_reserved)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CudnnRNNBackpropV3>
pub fn cudnn_rnnbackprop_v3<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
    T9: crate::eager::ToTensorHandle<'a>,
    T10: crate::eager::ToTensorHandle<'a>,
    T11: crate::eager::ToTensorHandle<'a>,
    T12: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    input_h: &T1,
    input_c: &T2,
    params: &T3,
    sequence_lengths: &T4,
    output: &T5,
    output_h: &T6,
    output_c: &T7,
    output_backprop: &T8,
    output_h_backprop: &T9,
    output_c_backprop: &T10,
    reserve_space: &T11,
    host_reserved: &T12,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 4]> {
    let op = CudnnRNNBackpropV3::new();
    op.call(
        ctx,
        input,
        input_h,
        input_c,
        params,
        sequence_lengths,
        output,
        output_h,
        output_c,
        output_backprop,
        output_h_backprop,
        output_c_backprop,
        reserve_space,
        host_reserved,
    )
}

/// CudnnRNNCanonicalToParams
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CudnnRNNCanonicalToParams>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CudnnRNNCanonicalToParams {
    rnn_mode: ::std::option::Option<::std::string::String>,
    input_mode: ::std::option::Option<::std::string::String>,
    direction: ::std::option::Option<::std::string::String>,
    dropout: ::std::option::Option<f32>,
    seed: ::std::option::Option<i64>,
    seed2: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CudnnRNNCanonicalToParams {
    fn default() -> Self {
        Self {
            rnn_mode: Some(::std::string::String::from("lstm")),
            input_mode: Some(::std::string::String::from("linear_input")),
            direction: Some(::std::string::String::from("unidirectional")),
            dropout: Some(0f32),
            seed: Some(0i64),
            seed2: Some(0i64),
            target_device_name: None,
        }
    }
}
impl CudnnRNNCanonicalToParams {
    /// Creates a new `CudnnRNNCanonicalToParams`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `rnn_mode` attribute.
    pub fn rnn_mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.rnn_mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `input_mode` attribute.
    pub fn input_mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.input_mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `direction` attribute.
    pub fn direction<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.direction = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dropout` attribute.
    pub fn dropout<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.dropout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed` attribute.
    pub fn seed<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed2` attribute.
    pub fn seed2<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute cudnn_rnncanonical_to_params.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        num_layers: &T0,
        num_units: &T1,
        input_size: &T2,
        weights: &[&T3],
        biases: &[&T4],
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "CudnnRNNCanonicalToParams")?;

        // Required input arguments
        op.add_input(&num_layers.to_handle(ctx)?)?;
        op.add_input(&num_units.to_handle(ctx)?)?;
        op.add_input(&input_size.to_handle(ctx)?)?;
        let mut weights_list = Vec::new();

        for t in weights {
            weights_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&weights_list)?;
        let mut biases_list = Vec::new();

        for t in biases {
            biases_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&biases_list)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.rnn_mode {
            op.set_attr_string("rnn_mode", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.input_mode {
            op.set_attr_string("input_mode", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.direction {
            op.set_attr_string("direction", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dropout {
            op.set_attr_float("dropout", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed {
            op.set_attr_int("seed", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed2 {
            op.set_attr_int("seed2", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `CudnnRNNCanonicalToParams::new().call(&ctx, &num_layers, &num_units, &input_size, &weights, &biases)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CudnnRNNCanonicalToParams>
pub fn cudnn_rnncanonical_to_params<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    num_layers: &T0,
    num_units: &T1,
    input_size: &T2,
    weights: &[&T3],
    biases: &[&T4],
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = CudnnRNNCanonicalToParams::new();
    op.call(ctx, num_layers, num_units, input_size, weights, biases)
}

/// CudnnRNNCanonicalToParamsV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CudnnRNNCanonicalToParamsV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CudnnRNNCanonicalToParamsV2 {
    rnn_mode: ::std::option::Option<::std::string::String>,
    input_mode: ::std::option::Option<::std::string::String>,
    direction: ::std::option::Option<::std::string::String>,
    dropout: ::std::option::Option<f32>,
    seed: ::std::option::Option<i64>,
    seed2: ::std::option::Option<i64>,
    num_proj: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CudnnRNNCanonicalToParamsV2 {
    fn default() -> Self {
        Self {
            rnn_mode: Some(::std::string::String::from("lstm")),
            input_mode: Some(::std::string::String::from("linear_input")),
            direction: Some(::std::string::String::from("unidirectional")),
            dropout: Some(0f32),
            seed: Some(0i64),
            seed2: Some(0i64),
            num_proj: Some(0i64),
            target_device_name: None,
        }
    }
}
impl CudnnRNNCanonicalToParamsV2 {
    /// Creates a new `CudnnRNNCanonicalToParamsV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `rnn_mode` attribute.
    pub fn rnn_mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.rnn_mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `input_mode` attribute.
    pub fn input_mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.input_mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `direction` attribute.
    pub fn direction<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.direction = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dropout` attribute.
    pub fn dropout<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.dropout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed` attribute.
    pub fn seed<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed2` attribute.
    pub fn seed2<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_proj` attribute.
    pub fn num_proj<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_proj = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute cudnn_rnncanonical_to_params_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        num_layers: &T0,
        num_units: &T1,
        input_size: &T2,
        weights: &[&T3],
        biases: &[&T4],
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "CudnnRNNCanonicalToParamsV2")?;

        // Required input arguments
        op.add_input(&num_layers.to_handle(ctx)?)?;
        op.add_input(&num_units.to_handle(ctx)?)?;
        op.add_input(&input_size.to_handle(ctx)?)?;
        let mut weights_list = Vec::new();

        for t in weights {
            weights_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&weights_list)?;
        let mut biases_list = Vec::new();

        for t in biases {
            biases_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&biases_list)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.rnn_mode {
            op.set_attr_string("rnn_mode", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.input_mode {
            op.set_attr_string("input_mode", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.direction {
            op.set_attr_string("direction", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dropout {
            op.set_attr_float("dropout", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed {
            op.set_attr_int("seed", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed2 {
            op.set_attr_int("seed2", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_proj {
            op.set_attr_int("num_proj", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `CudnnRNNCanonicalToParamsV2::new().call(&ctx, &num_layers, &num_units, &input_size, &weights, &biases)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CudnnRNNCanonicalToParamsV2>
pub fn cudnn_rnncanonical_to_params_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    num_layers: &T0,
    num_units: &T1,
    input_size: &T2,
    weights: &[&T3],
    biases: &[&T4],
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = CudnnRNNCanonicalToParamsV2::new();
    op.call(ctx, num_layers, num_units, input_size, weights, biases)
}

/// CudnnRNNParamsSize
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CudnnRNNParamsSize>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CudnnRNNParamsSize {
    T: ::std::option::Option<crate::DataType>,
    S: ::std::option::Option<crate::DataType>,
    rnn_mode: ::std::option::Option<::std::string::String>,
    input_mode: ::std::option::Option<::std::string::String>,
    direction: ::std::option::Option<::std::string::String>,
    dropout: ::std::option::Option<f32>,
    seed: ::std::option::Option<i64>,
    seed2: ::std::option::Option<i64>,
    num_proj: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CudnnRNNParamsSize {
    fn default() -> Self {
        Self {
            T: None,
            S: None,
            rnn_mode: Some(::std::string::String::from("lstm")),
            input_mode: Some(::std::string::String::from("linear_input")),
            direction: Some(::std::string::String::from("unidirectional")),
            dropout: Some(0f32),
            seed: Some(0i64),
            seed2: Some(0i64),
            num_proj: Some(0i64),
            target_device_name: None,
        }
    }
}
impl CudnnRNNParamsSize {
    /// Creates a new `CudnnRNNParamsSize`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `T` attribute.
    pub fn T<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.T = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `S` attribute.
    pub fn S<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.S = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `rnn_mode` attribute.
    pub fn rnn_mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.rnn_mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `input_mode` attribute.
    pub fn input_mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.input_mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `direction` attribute.
    pub fn direction<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.direction = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dropout` attribute.
    pub fn dropout<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.dropout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed` attribute.
    pub fn seed<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed2` attribute.
    pub fn seed2<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_proj` attribute.
    pub fn num_proj<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_proj = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute cudnn_rnnparams_size.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        num_layers: &T0,
        num_units: &T1,
        input_size: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "CudnnRNNParamsSize")?;

        // Required input arguments
        op.add_input(&num_layers.to_handle(ctx)?)?;
        op.add_input(&num_units.to_handle(ctx)?)?;
        op.add_input(&input_size.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.T {
            op.set_attr_type("T", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.S {
            op.set_attr_type("S", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.rnn_mode {
            op.set_attr_string("rnn_mode", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.input_mode {
            op.set_attr_string("input_mode", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.direction {
            op.set_attr_string("direction", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dropout {
            op.set_attr_float("dropout", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed {
            op.set_attr_int("seed", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed2 {
            op.set_attr_int("seed2", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_proj {
            op.set_attr_int("num_proj", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `CudnnRNNParamsSize::new().call(&ctx, &num_layers, &num_units, &input_size)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CudnnRNNParamsSize>
pub fn cudnn_rnnparams_size<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    num_layers: &T0,
    num_units: &T1,
    input_size: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = CudnnRNNParamsSize::new();
    op.call(ctx, num_layers, num_units, input_size)
}

/// CudnnRNNParamsToCanonical
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CudnnRNNParamsToCanonical>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CudnnRNNParamsToCanonical {
    num_params: ::std::option::Option<i64>,
    rnn_mode: ::std::option::Option<::std::string::String>,
    input_mode: ::std::option::Option<::std::string::String>,
    direction: ::std::option::Option<::std::string::String>,
    dropout: ::std::option::Option<f32>,
    seed: ::std::option::Option<i64>,
    seed2: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CudnnRNNParamsToCanonical {
    fn default() -> Self {
        Self {
            num_params: None,
            rnn_mode: Some(::std::string::String::from("lstm")),
            input_mode: Some(::std::string::String::from("linear_input")),
            direction: Some(::std::string::String::from("unidirectional")),
            dropout: Some(0f32),
            seed: Some(0i64),
            seed2: Some(0i64),
            target_device_name: None,
        }
    }
}
impl CudnnRNNParamsToCanonical {
    /// Creates a new `CudnnRNNParamsToCanonical`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_params` attribute.
    pub fn num_params<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_params = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `rnn_mode` attribute.
    pub fn rnn_mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.rnn_mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `input_mode` attribute.
    pub fn input_mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.input_mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `direction` attribute.
    pub fn direction<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.direction = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dropout` attribute.
    pub fn dropout<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.dropout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed` attribute.
    pub fn seed<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed2` attribute.
    pub fn seed2<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute cudnn_rnnparams_to_canonical.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        num_layers: &T0,
        num_units: &T1,
        input_size: &T2,
        params: &T3,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "CudnnRNNParamsToCanonical")?;

        // Required input arguments
        op.add_input(&num_layers.to_handle(ctx)?)?;
        op.add_input(&num_units.to_handle(ctx)?)?;
        op.add_input(&input_size.to_handle(ctx)?)?;
        op.add_input(&params.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_params {
            op.set_attr_int("num_params", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.rnn_mode {
            op.set_attr_string("rnn_mode", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.input_mode {
            op.set_attr_string("input_mode", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.direction {
            op.set_attr_string("direction", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dropout {
            op.set_attr_float("dropout", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed {
            op.set_attr_int("seed", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed2 {
            op.set_attr_int("seed2", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `CudnnRNNParamsToCanonical::new().call(&ctx, &num_layers, &num_units, &input_size, &params)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CudnnRNNParamsToCanonical>
pub fn cudnn_rnnparams_to_canonical<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    num_layers: &T0,
    num_units: &T1,
    input_size: &T2,
    params: &T3,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = CudnnRNNParamsToCanonical::new();
    op.call(ctx, num_layers, num_units, input_size, params)
}

/// CudnnRNNParamsToCanonicalV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CudnnRNNParamsToCanonicalV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CudnnRNNParamsToCanonicalV2 {
    num_params_weights: ::std::option::Option<i64>,
    num_params_biases: ::std::option::Option<i64>,
    rnn_mode: ::std::option::Option<::std::string::String>,
    input_mode: ::std::option::Option<::std::string::String>,
    direction: ::std::option::Option<::std::string::String>,
    dropout: ::std::option::Option<f32>,
    seed: ::std::option::Option<i64>,
    seed2: ::std::option::Option<i64>,
    num_proj: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CudnnRNNParamsToCanonicalV2 {
    fn default() -> Self {
        Self {
            num_params_weights: None,
            num_params_biases: None,
            rnn_mode: Some(::std::string::String::from("lstm")),
            input_mode: Some(::std::string::String::from("linear_input")),
            direction: Some(::std::string::String::from("unidirectional")),
            dropout: Some(0f32),
            seed: Some(0i64),
            seed2: Some(0i64),
            num_proj: Some(0i64),
            target_device_name: None,
        }
    }
}
impl CudnnRNNParamsToCanonicalV2 {
    /// Creates a new `CudnnRNNParamsToCanonicalV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_params_weights` attribute.
    pub fn num_params_weights<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.num_params_weights = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_params_biases` attribute.
    pub fn num_params_biases<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_params_biases = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `rnn_mode` attribute.
    pub fn rnn_mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.rnn_mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `input_mode` attribute.
    pub fn input_mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.input_mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `direction` attribute.
    pub fn direction<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.direction = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dropout` attribute.
    pub fn dropout<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.dropout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed` attribute.
    pub fn seed<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed2` attribute.
    pub fn seed2<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_proj` attribute.
    pub fn num_proj<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_proj = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute cudnn_rnnparams_to_canonical_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        num_layers: &T0,
        num_units: &T1,
        input_size: &T2,
        params: &T3,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "CudnnRNNParamsToCanonicalV2")?;

        // Required input arguments
        op.add_input(&num_layers.to_handle(ctx)?)?;
        op.add_input(&num_units.to_handle(ctx)?)?;
        op.add_input(&input_size.to_handle(ctx)?)?;
        op.add_input(&params.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_params_weights {
            op.set_attr_int("num_params_weights", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_params_biases {
            op.set_attr_int("num_params_biases", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.rnn_mode {
            op.set_attr_string("rnn_mode", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.input_mode {
            op.set_attr_string("input_mode", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.direction {
            op.set_attr_string("direction", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dropout {
            op.set_attr_float("dropout", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed {
            op.set_attr_int("seed", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed2 {
            op.set_attr_int("seed2", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_proj {
            op.set_attr_int("num_proj", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `CudnnRNNParamsToCanonicalV2::new().call(&ctx, &num_layers, &num_units, &input_size, &params)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CudnnRNNParamsToCanonicalV2>
pub fn cudnn_rnnparams_to_canonical_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    num_layers: &T0,
    num_units: &T1,
    input_size: &T2,
    params: &T3,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = CudnnRNNParamsToCanonicalV2::new();
    op.call(ctx, num_layers, num_units, input_size, params)
}

/// CudnnRNNV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CudnnRNNV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CudnnRNNV2 {
    rnn_mode: ::std::option::Option<::std::string::String>,
    input_mode: ::std::option::Option<::std::string::String>,
    direction: ::std::option::Option<::std::string::String>,
    dropout: ::std::option::Option<f32>,
    seed: ::std::option::Option<i64>,
    seed2: ::std::option::Option<i64>,
    is_training: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CudnnRNNV2 {
    fn default() -> Self {
        Self {
            rnn_mode: Some(::std::string::String::from("lstm")),
            input_mode: Some(::std::string::String::from("linear_input")),
            direction: Some(::std::string::String::from("unidirectional")),
            dropout: Some(0f32),
            seed: Some(0i64),
            seed2: Some(0i64),
            is_training: Some(true),
            target_device_name: None,
        }
    }
}
impl CudnnRNNV2 {
    /// Creates a new `CudnnRNNV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `rnn_mode` attribute.
    pub fn rnn_mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.rnn_mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `input_mode` attribute.
    pub fn input_mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.input_mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `direction` attribute.
    pub fn direction<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.direction = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dropout` attribute.
    pub fn dropout<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.dropout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed` attribute.
    pub fn seed<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed2` attribute.
    pub fn seed2<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `is_training` attribute.
    pub fn is_training<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.is_training = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute cudnn_rnnv2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        input_h: &T1,
        input_c: &T2,
        params: &T3,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 5]> {
        // Define Op
        let mut op = super::Op::new(ctx, "CudnnRNNV2")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&input_h.to_handle(ctx)?)?;
        op.add_input(&input_c.to_handle(ctx)?)?;
        op.add_input(&params.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.rnn_mode {
            op.set_attr_string("rnn_mode", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.input_mode {
            op.set_attr_string("input_mode", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.direction {
            op.set_attr_string("direction", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dropout {
            op.set_attr_float("dropout", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed {
            op.set_attr_int("seed", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed2 {
            op.set_attr_int("seed2", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.is_training {
            op.set_attr_bool("is_training", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<5>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `CudnnRNNV2::new().call(&ctx, &input, &input_h, &input_c, &params)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CudnnRNNV2>
pub fn cudnn_rnnv2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    input_h: &T1,
    input_c: &T2,
    params: &T3,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 5]> {
    let op = CudnnRNNV2::new();
    op.call(ctx, input, input_h, input_c, params)
}

/// CudnnRNNV3
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CudnnRNNV3>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CudnnRNNV3 {
    rnn_mode: ::std::option::Option<::std::string::String>,
    input_mode: ::std::option::Option<::std::string::String>,
    direction: ::std::option::Option<::std::string::String>,
    dropout: ::std::option::Option<f32>,
    seed: ::std::option::Option<i64>,
    seed2: ::std::option::Option<i64>,
    num_proj: ::std::option::Option<i64>,
    is_training: ::std::option::Option<bool>,
    time_major: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CudnnRNNV3 {
    fn default() -> Self {
        Self {
            rnn_mode: Some(::std::string::String::from("lstm")),
            input_mode: Some(::std::string::String::from("linear_input")),
            direction: Some(::std::string::String::from("unidirectional")),
            dropout: Some(0f32),
            seed: Some(0i64),
            seed2: Some(0i64),
            num_proj: Some(0i64),
            is_training: Some(true),
            time_major: Some(true),
            target_device_name: None,
        }
    }
}
impl CudnnRNNV3 {
    /// Creates a new `CudnnRNNV3`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `rnn_mode` attribute.
    pub fn rnn_mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.rnn_mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `input_mode` attribute.
    pub fn input_mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.input_mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `direction` attribute.
    pub fn direction<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.direction = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dropout` attribute.
    pub fn dropout<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.dropout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed` attribute.
    pub fn seed<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed2` attribute.
    pub fn seed2<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_proj` attribute.
    pub fn num_proj<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_proj = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `is_training` attribute.
    pub fn is_training<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.is_training = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `time_major` attribute.
    pub fn time_major<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.time_major = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute cudnn_rnnv3.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        input_h: &T1,
        input_c: &T2,
        params: &T3,
        sequence_lengths: &T4,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 5]> {
        // Define Op
        let mut op = super::Op::new(ctx, "CudnnRNNV3")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&input_h.to_handle(ctx)?)?;
        op.add_input(&input_c.to_handle(ctx)?)?;
        op.add_input(&params.to_handle(ctx)?)?;
        op.add_input(&sequence_lengths.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.rnn_mode {
            op.set_attr_string("rnn_mode", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.input_mode {
            op.set_attr_string("input_mode", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.direction {
            op.set_attr_string("direction", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dropout {
            op.set_attr_float("dropout", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed {
            op.set_attr_int("seed", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed2 {
            op.set_attr_int("seed2", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_proj {
            op.set_attr_int("num_proj", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.is_training {
            op.set_attr_bool("is_training", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.time_major {
            op.set_attr_bool("time_major", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<5>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `CudnnRNNV3::new().call(&ctx, &input, &input_h, &input_c, &params, &sequence_lengths)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CudnnRNNV3>
pub fn cudnn_rnnv3<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    input_h: &T1,
    input_c: &T2,
    params: &T3,
    sequence_lengths: &T4,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 5]> {
    let op = CudnnRNNV3::new();
    op.call(ctx, input, input_h, input_c, params, sequence_lengths)
}

/// Cumprod
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Cumprod>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Cumprod {
    exclusive: ::std::option::Option<bool>,
    reverse: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Cumprod {
    fn default() -> Self {
        Self {
            exclusive: Some(false),
            reverse: Some(false),
            target_device_name: None,
        }
    }
}
impl Cumprod {
    /// Creates a new `Cumprod`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `exclusive` attribute.
    pub fn exclusive<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.exclusive = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `reverse` attribute.
    pub fn reverse<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.reverse = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute cumprod.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        axis: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Cumprod")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&axis.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.exclusive {
            op.set_attr_bool("exclusive", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.reverse {
            op.set_attr_bool("reverse", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Cumprod::new().call(&ctx, &x, &axis)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Cumprod>
pub fn cumprod<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    axis: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Cumprod::new();
    op.call(ctx, x, axis)
}

/// Cumsum
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Cumsum>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Cumsum {
    exclusive: ::std::option::Option<bool>,
    reverse: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Cumsum {
    fn default() -> Self {
        Self {
            exclusive: Some(false),
            reverse: Some(false),
            target_device_name: None,
        }
    }
}
impl Cumsum {
    /// Creates a new `Cumsum`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `exclusive` attribute.
    pub fn exclusive<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.exclusive = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `reverse` attribute.
    pub fn reverse<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.reverse = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute cumsum.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        axis: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Cumsum")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&axis.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.exclusive {
            op.set_attr_bool("exclusive", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.reverse {
            op.set_attr_bool("reverse", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Cumsum::new().call(&ctx, &x, &axis)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Cumsum>
pub fn cumsum<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    axis: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Cumsum::new();
    op.call(ctx, x, axis)
}

/// CumulativeLogsumexp
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CumulativeLogsumexp>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct CumulativeLogsumexp {
    exclusive: ::std::option::Option<bool>,
    reverse: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for CumulativeLogsumexp {
    fn default() -> Self {
        Self {
            exclusive: Some(false),
            reverse: Some(false),
            target_device_name: None,
        }
    }
}
impl CumulativeLogsumexp {
    /// Creates a new `CumulativeLogsumexp`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `exclusive` attribute.
    pub fn exclusive<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.exclusive = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `reverse` attribute.
    pub fn reverse<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.reverse = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute cumulative_logsumexp.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        axis: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "CumulativeLogsumexp")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&axis.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.exclusive {
            op.set_attr_bool("exclusive", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.reverse {
            op.set_attr_bool("reverse", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `CumulativeLogsumexp::new().call(&ctx, &x, &axis)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/CumulativeLogsumexp>
pub fn cumulative_logsumexp<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    axis: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = CumulativeLogsumexp::new();
    op.call(ctx, x, axis)
}

/// DTensorRestoreV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DTensorRestoreV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DTensorRestoreV2 {
    input_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    input_layouts: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    dtypes: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DTensorRestoreV2 {
    fn default() -> Self {
        Self {
            input_shapes: None,
            input_layouts: None,
            dtypes: None,
            target_device_name: None,
        }
    }
}
impl DTensorRestoreV2 {
    /// Creates a new `DTensorRestoreV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `input_shapes` attribute.
    pub fn input_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.input_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `input_layouts` attribute.
    pub fn input_layouts<ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.input_layouts = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dtypes` attribute.
    pub fn dtypes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dtypes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute dtensor_restore_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        prefix: &T0,
        tensor_names: &T1,
        shape_and_slices: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DTensorRestoreV2")?;

        // Required input arguments
        op.add_input(&prefix.to_handle(ctx)?)?;
        op.add_input(&tensor_names.to_handle(ctx)?)?;
        op.add_input(&shape_and_slices.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.input_shapes {
            op.set_attr_shape_list("input_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.input_layouts {
            op.set_attr_string_list("input_layouts", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dtypes {
            op.set_attr_type_list("dtypes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DTensorRestoreV2::new().call(&ctx, &prefix, &tensor_names, &shape_and_slices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DTensorRestoreV2>
pub fn dtensor_restore_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    prefix: &T0,
    tensor_names: &T1,
    shape_and_slices: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DTensorRestoreV2::new();
    op.call(ctx, prefix, tensor_names, shape_and_slices)
}

/// DTensorSetGlobalTPUArray
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DTensorSetGlobalTPUArray>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DTensorSetGlobalTPUArray {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DTensorSetGlobalTPUArray {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl DTensorSetGlobalTPUArray {
    /// Creates a new `DTensorSetGlobalTPUArray`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute dtensor_set_global_tpuarray.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        topology: &T0,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "DTensorSetGlobalTPUArray")?;

        // Required input arguments
        op.add_input(&topology.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `DTensorSetGlobalTPUArray::new().call(&ctx, &topology)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DTensorSetGlobalTPUArray>
pub fn dtensor_set_global_tpuarray<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    topology: &T0,
) -> crate::Result<()> {
    let op = DTensorSetGlobalTPUArray::new();
    op.call(ctx, topology)
}

/// DataFormatDimMap
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DataFormatDimMap>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DataFormatDimMap {
    src_format: ::std::option::Option<::std::string::String>,
    dst_format: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DataFormatDimMap {
    fn default() -> Self {
        Self {
            src_format: Some(::std::string::String::from("NHWC")),
            dst_format: Some(::std::string::String::from("NCHW")),
            target_device_name: None,
        }
    }
}
impl DataFormatDimMap {
    /// Creates a new `DataFormatDimMap`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `src_format` attribute.
    pub fn src_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.src_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dst_format` attribute.
    pub fn dst_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dst_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute data_format_dim_map.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DataFormatDimMap")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.src_format {
            op.set_attr_string("src_format", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dst_format {
            op.set_attr_string("dst_format", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DataFormatDimMap::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DataFormatDimMap>
pub fn data_format_dim_map<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DataFormatDimMap::new();
    op.call(ctx, x)
}

/// DataFormatVecPermute
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DataFormatVecPermute>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DataFormatVecPermute {
    src_format: ::std::option::Option<::std::string::String>,
    dst_format: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DataFormatVecPermute {
    fn default() -> Self {
        Self {
            src_format: Some(::std::string::String::from("NHWC")),
            dst_format: Some(::std::string::String::from("NCHW")),
            target_device_name: None,
        }
    }
}
impl DataFormatVecPermute {
    /// Creates a new `DataFormatVecPermute`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `src_format` attribute.
    pub fn src_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.src_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dst_format` attribute.
    pub fn dst_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dst_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute data_format_vec_permute.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DataFormatVecPermute")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.src_format {
            op.set_attr_string("src_format", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dst_format {
            op.set_attr_string("dst_format", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DataFormatVecPermute::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DataFormatVecPermute>
pub fn data_format_vec_permute<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DataFormatVecPermute::new();
    op.call(ctx, x)
}

/// DataServiceDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DataServiceDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DataServiceDataset {
    task_refresh_interval_hint_ms: ::std::option::Option<i64>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    data_transfer_protocol: ::std::option::Option<::std::string::String>,
    target_workers: ::std::option::Option<::std::string::String>,
    cross_trainer_cache_options: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DataServiceDataset {
    fn default() -> Self {
        Self {
            task_refresh_interval_hint_ms: Some(-1i64),
            output_types: None,
            output_shapes: None,
            data_transfer_protocol: None,
            target_workers: Some(::std::string::String::from("AUTO")),
            cross_trainer_cache_options: None,
            target_device_name: None,
        }
    }
}
impl DataServiceDataset {
    /// Creates a new `DataServiceDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `task_refresh_interval_hint_ms` attribute.
    pub fn task_refresh_interval_hint_ms<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.task_refresh_interval_hint_ms = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `data_transfer_protocol` attribute.
    pub fn data_transfer_protocol<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.data_transfer_protocol = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `target_workers` attribute.
    pub fn target_workers<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_workers = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `cross_trainer_cache_options` attribute.
    pub fn cross_trainer_cache_options<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.cross_trainer_cache_options = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute data_service_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        dataset_id: &T0,
        processing_mode: &T1,
        address: &T2,
        protocol: &T3,
        job_name: &T4,
        max_outstanding_requests: &T5,
        iteration_counter: &T6,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DataServiceDataset")?;

        // Required input arguments
        op.add_input(&dataset_id.to_handle(ctx)?)?;
        op.add_input(&processing_mode.to_handle(ctx)?)?;
        op.add_input(&address.to_handle(ctx)?)?;
        op.add_input(&protocol.to_handle(ctx)?)?;
        op.add_input(&job_name.to_handle(ctx)?)?;
        op.add_input(&max_outstanding_requests.to_handle(ctx)?)?;
        op.add_input(&iteration_counter.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.task_refresh_interval_hint_ms {
            op.set_attr_int("task_refresh_interval_hint_ms", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.data_transfer_protocol {
            op.set_attr_string("data_transfer_protocol", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.target_workers {
            op.set_attr_string("target_workers", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.cross_trainer_cache_options {
            op.set_attr_string("cross_trainer_cache_options", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DataServiceDataset::new().call(&ctx, &dataset_id, &processing_mode, &address, &protocol, &job_name, &max_outstanding_requests, &iteration_counter)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DataServiceDataset>
pub fn data_service_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    dataset_id: &T0,
    processing_mode: &T1,
    address: &T2,
    protocol: &T3,
    job_name: &T4,
    max_outstanding_requests: &T5,
    iteration_counter: &T6,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DataServiceDataset::new();
    op.call(
        ctx,
        dataset_id,
        processing_mode,
        address,
        protocol,
        job_name,
        max_outstanding_requests,
        iteration_counter,
    )
}

/// DataServiceDatasetV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DataServiceDatasetV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DataServiceDatasetV2 {
    task_refresh_interval_hint_ms: ::std::option::Option<i64>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    data_transfer_protocol: ::std::option::Option<::std::string::String>,
    target_workers: ::std::option::Option<::std::string::String>,
    cross_trainer_cache_options: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DataServiceDatasetV2 {
    fn default() -> Self {
        Self {
            task_refresh_interval_hint_ms: Some(-1i64),
            output_types: None,
            output_shapes: None,
            data_transfer_protocol: None,
            target_workers: Some(::std::string::String::from("AUTO")),
            cross_trainer_cache_options: None,
            target_device_name: None,
        }
    }
}
impl DataServiceDatasetV2 {
    /// Creates a new `DataServiceDatasetV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `task_refresh_interval_hint_ms` attribute.
    pub fn task_refresh_interval_hint_ms<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.task_refresh_interval_hint_ms = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `data_transfer_protocol` attribute.
    pub fn data_transfer_protocol<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.data_transfer_protocol = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `target_workers` attribute.
    pub fn target_workers<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_workers = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `cross_trainer_cache_options` attribute.
    pub fn cross_trainer_cache_options<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.cross_trainer_cache_options = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute data_service_dataset_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        dataset_id: &T0,
        processing_mode: &T1,
        address: &T2,
        protocol: &T3,
        job_name: &T4,
        consumer_index: &T5,
        num_consumers: &T6,
        max_outstanding_requests: &T7,
        iteration_counter: &T8,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DataServiceDatasetV2")?;

        // Required input arguments
        op.add_input(&dataset_id.to_handle(ctx)?)?;
        op.add_input(&processing_mode.to_handle(ctx)?)?;
        op.add_input(&address.to_handle(ctx)?)?;
        op.add_input(&protocol.to_handle(ctx)?)?;
        op.add_input(&job_name.to_handle(ctx)?)?;
        op.add_input(&consumer_index.to_handle(ctx)?)?;
        op.add_input(&num_consumers.to_handle(ctx)?)?;
        op.add_input(&max_outstanding_requests.to_handle(ctx)?)?;
        op.add_input(&iteration_counter.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.task_refresh_interval_hint_ms {
            op.set_attr_int("task_refresh_interval_hint_ms", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.data_transfer_protocol {
            op.set_attr_string("data_transfer_protocol", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.target_workers {
            op.set_attr_string("target_workers", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.cross_trainer_cache_options {
            op.set_attr_string("cross_trainer_cache_options", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DataServiceDatasetV2::new().call(&ctx, &dataset_id, &processing_mode, &address, &protocol, &job_name, &consumer_index, &num_consumers, &max_outstanding_requests, &iteration_counter)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DataServiceDatasetV2>
pub fn data_service_dataset_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    dataset_id: &T0,
    processing_mode: &T1,
    address: &T2,
    protocol: &T3,
    job_name: &T4,
    consumer_index: &T5,
    num_consumers: &T6,
    max_outstanding_requests: &T7,
    iteration_counter: &T8,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DataServiceDatasetV2::new();
    op.call(
        ctx,
        dataset_id,
        processing_mode,
        address,
        protocol,
        job_name,
        consumer_index,
        num_consumers,
        max_outstanding_requests,
        iteration_counter,
    )
}

/// DataServiceDatasetV3
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DataServiceDatasetV3>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DataServiceDatasetV3 {
    task_refresh_interval_hint_ms: ::std::option::Option<i64>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    data_transfer_protocol: ::std::option::Option<::std::string::String>,
    target_workers: ::std::option::Option<::std::string::String>,
    uncompress: ::std::option::Option<bool>,
    uncompress_fn: ::std::option::Option<::std::string::String>,
    cross_trainer_cache_options: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DataServiceDatasetV3 {
    fn default() -> Self {
        Self {
            task_refresh_interval_hint_ms: Some(-1i64),
            output_types: None,
            output_shapes: None,
            data_transfer_protocol: None,
            target_workers: Some(::std::string::String::from("AUTO")),
            uncompress: Some(false),
            uncompress_fn: None,
            cross_trainer_cache_options: None,
            target_device_name: None,
        }
    }
}
impl DataServiceDatasetV3 {
    /// Creates a new `DataServiceDatasetV3`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `task_refresh_interval_hint_ms` attribute.
    pub fn task_refresh_interval_hint_ms<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.task_refresh_interval_hint_ms = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `data_transfer_protocol` attribute.
    pub fn data_transfer_protocol<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.data_transfer_protocol = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `target_workers` attribute.
    pub fn target_workers<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_workers = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `uncompress` attribute.
    pub fn uncompress<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.uncompress = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `uncompress_fn` attribute.
    pub fn uncompress_fn<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.uncompress_fn = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `cross_trainer_cache_options` attribute.
    pub fn cross_trainer_cache_options<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.cross_trainer_cache_options = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute data_service_dataset_v3.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        dataset_id: &T0,
        processing_mode: &T1,
        address: &T2,
        protocol: &T3,
        job_name: &T4,
        consumer_index: &T5,
        num_consumers: &T6,
        max_outstanding_requests: &T7,
        iteration_counter: &T8,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DataServiceDatasetV3")?;

        // Required input arguments
        op.add_input(&dataset_id.to_handle(ctx)?)?;
        op.add_input(&processing_mode.to_handle(ctx)?)?;
        op.add_input(&address.to_handle(ctx)?)?;
        op.add_input(&protocol.to_handle(ctx)?)?;
        op.add_input(&job_name.to_handle(ctx)?)?;
        op.add_input(&consumer_index.to_handle(ctx)?)?;
        op.add_input(&num_consumers.to_handle(ctx)?)?;
        op.add_input(&max_outstanding_requests.to_handle(ctx)?)?;
        op.add_input(&iteration_counter.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.task_refresh_interval_hint_ms {
            op.set_attr_int("task_refresh_interval_hint_ms", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.data_transfer_protocol {
            op.set_attr_string("data_transfer_protocol", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.target_workers {
            op.set_attr_string("target_workers", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.uncompress {
            op.set_attr_bool("uncompress", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.uncompress_fn {
            op.set_attr_string("uncompress_fn", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.cross_trainer_cache_options {
            op.set_attr_string("cross_trainer_cache_options", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DataServiceDatasetV3::new().call(&ctx, &dataset_id, &processing_mode, &address, &protocol, &job_name, &consumer_index, &num_consumers, &max_outstanding_requests, &iteration_counter)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DataServiceDatasetV3>
pub fn data_service_dataset_v3<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    dataset_id: &T0,
    processing_mode: &T1,
    address: &T2,
    protocol: &T3,
    job_name: &T4,
    consumer_index: &T5,
    num_consumers: &T6,
    max_outstanding_requests: &T7,
    iteration_counter: &T8,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DataServiceDatasetV3::new();
    op.call(
        ctx,
        dataset_id,
        processing_mode,
        address,
        protocol,
        job_name,
        consumer_index,
        num_consumers,
        max_outstanding_requests,
        iteration_counter,
    )
}

/// DataServiceDatasetV4
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DataServiceDatasetV4>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DataServiceDatasetV4 {
    task_refresh_interval_hint_ms: ::std::option::Option<i64>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    data_transfer_protocol: ::std::option::Option<::std::string::String>,
    target_workers: ::std::option::Option<::std::string::String>,
    uncompress: ::std::option::Option<bool>,
    uncompress_fn: ::std::option::Option<::std::string::String>,
    cross_trainer_cache_options: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DataServiceDatasetV4 {
    fn default() -> Self {
        Self {
            task_refresh_interval_hint_ms: Some(-1i64),
            output_types: None,
            output_shapes: None,
            data_transfer_protocol: None,
            target_workers: Some(::std::string::String::from("AUTO")),
            uncompress: Some(false),
            uncompress_fn: None,
            cross_trainer_cache_options: None,
            target_device_name: None,
        }
    }
}
impl DataServiceDatasetV4 {
    /// Creates a new `DataServiceDatasetV4`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `task_refresh_interval_hint_ms` attribute.
    pub fn task_refresh_interval_hint_ms<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.task_refresh_interval_hint_ms = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `data_transfer_protocol` attribute.
    pub fn data_transfer_protocol<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.data_transfer_protocol = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `target_workers` attribute.
    pub fn target_workers<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_workers = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `uncompress` attribute.
    pub fn uncompress<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.uncompress = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `uncompress_fn` attribute.
    pub fn uncompress_fn<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.uncompress_fn = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `cross_trainer_cache_options` attribute.
    pub fn cross_trainer_cache_options<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.cross_trainer_cache_options = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute data_service_dataset_v4.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        dataset_id: &T0,
        processing_mode: &T1,
        address: &T2,
        protocol: &T3,
        job_name: &T4,
        consumer_index: &T5,
        num_consumers: &T6,
        max_outstanding_requests: &T7,
        iteration_counter: &T8,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DataServiceDatasetV4")?;

        // Required input arguments
        op.add_input(&dataset_id.to_handle(ctx)?)?;
        op.add_input(&processing_mode.to_handle(ctx)?)?;
        op.add_input(&address.to_handle(ctx)?)?;
        op.add_input(&protocol.to_handle(ctx)?)?;
        op.add_input(&job_name.to_handle(ctx)?)?;
        op.add_input(&consumer_index.to_handle(ctx)?)?;
        op.add_input(&num_consumers.to_handle(ctx)?)?;
        op.add_input(&max_outstanding_requests.to_handle(ctx)?)?;
        op.add_input(&iteration_counter.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.task_refresh_interval_hint_ms {
            op.set_attr_int("task_refresh_interval_hint_ms", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.data_transfer_protocol {
            op.set_attr_string("data_transfer_protocol", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.target_workers {
            op.set_attr_string("target_workers", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.uncompress {
            op.set_attr_bool("uncompress", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.uncompress_fn {
            op.set_attr_string("uncompress_fn", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.cross_trainer_cache_options {
            op.set_attr_string("cross_trainer_cache_options", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DataServiceDatasetV4::new().call(&ctx, &dataset_id, &processing_mode, &address, &protocol, &job_name, &consumer_index, &num_consumers, &max_outstanding_requests, &iteration_counter)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DataServiceDatasetV4>
pub fn data_service_dataset_v4<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    dataset_id: &T0,
    processing_mode: &T1,
    address: &T2,
    protocol: &T3,
    job_name: &T4,
    consumer_index: &T5,
    num_consumers: &T6,
    max_outstanding_requests: &T7,
    iteration_counter: &T8,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DataServiceDatasetV4::new();
    op.call(
        ctx,
        dataset_id,
        processing_mode,
        address,
        protocol,
        job_name,
        consumer_index,
        num_consumers,
        max_outstanding_requests,
        iteration_counter,
    )
}

/// DatasetCardinality
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DatasetCardinality>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DatasetCardinality {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DatasetCardinality {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl DatasetCardinality {
    /// Creates a new `DatasetCardinality`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute dataset_cardinality.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DatasetCardinality")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DatasetCardinality::new().call(&ctx, &input_dataset)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DatasetCardinality>
pub fn dataset_cardinality<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DatasetCardinality::new();
    op.call(ctx, input_dataset)
}

/// DatasetFromGraph
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DatasetFromGraph>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DatasetFromGraph {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DatasetFromGraph {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl DatasetFromGraph {
    /// Creates a new `DatasetFromGraph`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute dataset_from_graph.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        graph_def: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DatasetFromGraph")?;

        // Required input arguments
        op.add_input(&graph_def.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DatasetFromGraph::new().call(&ctx, &graph_def)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DatasetFromGraph>
pub fn dataset_from_graph<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    graph_def: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DatasetFromGraph::new();
    op.call(ctx, graph_def)
}

/// DatasetToGraph
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DatasetToGraph>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DatasetToGraph {
    stateful_whitelist: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    allow_stateful: ::std::option::Option<bool>,
    strip_device_assignment: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DatasetToGraph {
    fn default() -> Self {
        Self {
            stateful_whitelist: Some(vec![]),
            allow_stateful: Some(false),
            strip_device_assignment: Some(false),
            target_device_name: None,
        }
    }
}
impl DatasetToGraph {
    /// Creates a new `DatasetToGraph`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `stateful_whitelist` attribute.
    pub fn stateful_whitelist<
        ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>,
    >(
        mut self,
        value: ArgType,
    ) -> Self {
        self.stateful_whitelist = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `allow_stateful` attribute.
    pub fn allow_stateful<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.allow_stateful = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `strip_device_assignment` attribute.
    pub fn strip_device_assignment<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strip_device_assignment = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute dataset_to_graph.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DatasetToGraph")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.stateful_whitelist {
            op.set_attr_string_list("stateful_whitelist", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.allow_stateful {
            op.set_attr_bool("allow_stateful", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.strip_device_assignment {
            op.set_attr_bool("strip_device_assignment", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DatasetToGraph::new().call(&ctx, &input_dataset)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DatasetToGraph>
pub fn dataset_to_graph<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DatasetToGraph::new();
    op.call(ctx, input_dataset)
}

/// DatasetToGraphV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DatasetToGraphV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DatasetToGraphV2 {
    external_state_policy: ::std::option::Option<i64>,
    strip_device_assignment: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DatasetToGraphV2 {
    fn default() -> Self {
        Self {
            external_state_policy: Some(0i64),
            strip_device_assignment: Some(false),
            target_device_name: None,
        }
    }
}
impl DatasetToGraphV2 {
    /// Creates a new `DatasetToGraphV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `external_state_policy` attribute.
    pub fn external_state_policy<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.external_state_policy = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `strip_device_assignment` attribute.
    pub fn strip_device_assignment<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strip_device_assignment = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute dataset_to_graph_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DatasetToGraphV2")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.external_state_policy {
            op.set_attr_int("external_state_policy", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.strip_device_assignment {
            op.set_attr_bool("strip_device_assignment", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DatasetToGraphV2::new().call(&ctx, &input_dataset)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DatasetToGraphV2>
pub fn dataset_to_graph_v2<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DatasetToGraphV2::new();
    op.call(ctx, input_dataset)
}

/// DatasetToSingleElement
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DatasetToSingleElement>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DatasetToSingleElement {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DatasetToSingleElement {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl DatasetToSingleElement {
    /// Creates a new `DatasetToSingleElement`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute dataset_to_single_element.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        dataset: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DatasetToSingleElement")?;

        // Required input arguments
        op.add_input(&dataset.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DatasetToSingleElement::new().call(&ctx, &dataset)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DatasetToSingleElement>
pub fn dataset_to_single_element<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    dataset: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DatasetToSingleElement::new();
    op.call(ctx, dataset)
}

/// DatasetToTFRecord
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DatasetToTFRecord>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DatasetToTFRecord {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DatasetToTFRecord {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl DatasetToTFRecord {
    /// Creates a new `DatasetToTFRecord`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute dataset_to_tfrecord.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        filename: &T1,
        compression_type: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "DatasetToTFRecord")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&filename.to_handle(ctx)?)?;
        op.add_input(&compression_type.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `DatasetToTFRecord::new().call(&ctx, &input_dataset, &filename, &compression_type)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DatasetToTFRecord>
pub fn dataset_to_tfrecord<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    filename: &T1,
    compression_type: &T2,
) -> crate::Result<()> {
    let op = DatasetToTFRecord::new();
    op.call(ctx, input_dataset, filename, compression_type)
}

/// Dawsn
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Dawsn>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Dawsn {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Dawsn {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Dawsn {
    /// Creates a new `Dawsn`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute dawsn.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Dawsn")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Dawsn::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Dawsn>
pub fn dawsn<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Dawsn::new();
    op.call(ctx, x)
}

/// DebugGradientIdentity
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DebugGradientIdentity>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DebugGradientIdentity {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DebugGradientIdentity {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl DebugGradientIdentity {
    /// Creates a new `DebugGradientIdentity`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute debug_gradient_identity.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DebugGradientIdentity")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DebugGradientIdentity::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DebugGradientIdentity>
pub fn debug_gradient_identity<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DebugGradientIdentity::new();
    op.call(ctx, input)
}

/// DebugGradientRefIdentity
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DebugGradientRefIdentity>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DebugGradientRefIdentity {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DebugGradientRefIdentity {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl DebugGradientRefIdentity {
    /// Creates a new `DebugGradientRefIdentity`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute debug_gradient_ref_identity.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DebugGradientRefIdentity")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DebugGradientRefIdentity::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DebugGradientRefIdentity>
pub fn debug_gradient_ref_identity<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DebugGradientRefIdentity::new();
    op.call(ctx, input)
}

/// DebugIdentity
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DebugIdentity>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DebugIdentity {
    device_name: ::std::option::Option<::std::string::String>,
    tensor_name: ::std::option::Option<::std::string::String>,
    debug_urls: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    gated_grpc: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DebugIdentity {
    fn default() -> Self {
        Self {
            device_name: None,
            tensor_name: None,
            debug_urls: Some(vec![]),
            gated_grpc: Some(false),
            target_device_name: None,
        }
    }
}
impl DebugIdentity {
    /// Creates a new `DebugIdentity`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `device_name` attribute.
    pub fn device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `tensor_name` attribute.
    pub fn tensor_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.tensor_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `debug_urls` attribute.
    pub fn debug_urls<ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.debug_urls = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `gated_grpc` attribute.
    pub fn gated_grpc<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.gated_grpc = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute debug_identity.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DebugIdentity")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.device_name {
            op.set_attr_string("device_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.tensor_name {
            op.set_attr_string("tensor_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.debug_urls {
            op.set_attr_string_list("debug_urls", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.gated_grpc {
            op.set_attr_bool("gated_grpc", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DebugIdentity::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DebugIdentity>
pub fn debug_identity<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DebugIdentity::new();
    op.call(ctx, input)
}

/// DebugIdentityV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DebugIdentityV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DebugIdentityV2 {
    tfdbg_context_id: ::std::option::Option<::std::string::String>,
    op_name: ::std::option::Option<::std::string::String>,
    output_slot: ::std::option::Option<i64>,
    tensor_debug_mode: ::std::option::Option<i64>,
    debug_urls: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    circular_buffer_size: ::std::option::Option<i64>,
    tfdbg_run_id: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DebugIdentityV2 {
    fn default() -> Self {
        Self {
            tfdbg_context_id: None,
            op_name: None,
            output_slot: Some(-1i64),
            tensor_debug_mode: Some(-1i64),
            debug_urls: Some(vec![]),
            circular_buffer_size: Some(1000i64),
            tfdbg_run_id: None,
            target_device_name: None,
        }
    }
}
impl DebugIdentityV2 {
    /// Creates a new `DebugIdentityV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `tfdbg_context_id` attribute.
    pub fn tfdbg_context_id<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.tfdbg_context_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `op_name` attribute.
    pub fn op_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.op_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_slot` attribute.
    pub fn output_slot<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.output_slot = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `tensor_debug_mode` attribute.
    pub fn tensor_debug_mode<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.tensor_debug_mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `debug_urls` attribute.
    pub fn debug_urls<ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.debug_urls = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `circular_buffer_size` attribute.
    pub fn circular_buffer_size<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.circular_buffer_size = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `tfdbg_run_id` attribute.
    pub fn tfdbg_run_id<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.tfdbg_run_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute debug_identity_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DebugIdentityV2")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.tfdbg_context_id {
            op.set_attr_string("tfdbg_context_id", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.op_name {
            op.set_attr_string("op_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_slot {
            op.set_attr_int("output_slot", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.tensor_debug_mode {
            op.set_attr_int("tensor_debug_mode", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.debug_urls {
            op.set_attr_string_list("debug_urls", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.circular_buffer_size {
            op.set_attr_int("circular_buffer_size", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.tfdbg_run_id {
            op.set_attr_string("tfdbg_run_id", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DebugIdentityV2::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DebugIdentityV2>
pub fn debug_identity_v2<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DebugIdentityV2::new();
    op.call(ctx, input)
}

/// DebugNanCount
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DebugNanCount>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DebugNanCount {
    device_name: ::std::option::Option<::std::string::String>,
    tensor_name: ::std::option::Option<::std::string::String>,
    debug_urls: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    gated_grpc: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DebugNanCount {
    fn default() -> Self {
        Self {
            device_name: None,
            tensor_name: None,
            debug_urls: Some(vec![]),
            gated_grpc: Some(false),
            target_device_name: None,
        }
    }
}
impl DebugNanCount {
    /// Creates a new `DebugNanCount`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `device_name` attribute.
    pub fn device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `tensor_name` attribute.
    pub fn tensor_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.tensor_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `debug_urls` attribute.
    pub fn debug_urls<ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.debug_urls = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `gated_grpc` attribute.
    pub fn gated_grpc<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.gated_grpc = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute debug_nan_count.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DebugNanCount")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.device_name {
            op.set_attr_string("device_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.tensor_name {
            op.set_attr_string("tensor_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.debug_urls {
            op.set_attr_string_list("debug_urls", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.gated_grpc {
            op.set_attr_bool("gated_grpc", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DebugNanCount::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DebugNanCount>
pub fn debug_nan_count<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DebugNanCount::new();
    op.call(ctx, input)
}

/// DebugNumericSummary
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DebugNumericSummary>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DebugNumericSummary {
    device_name: ::std::option::Option<::std::string::String>,
    tensor_name: ::std::option::Option<::std::string::String>,
    debug_urls: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    lower_bound: ::std::option::Option<f32>,
    upper_bound: ::std::option::Option<f32>,
    mute_if_healthy: ::std::option::Option<bool>,
    gated_grpc: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DebugNumericSummary {
    fn default() -> Self {
        Self {
            device_name: None,
            tensor_name: None,
            debug_urls: Some(vec![]),
            lower_bound: Some(f32::NEG_INFINITY),
            upper_bound: Some(f32::INFINITY),
            mute_if_healthy: Some(false),
            gated_grpc: Some(false),
            target_device_name: None,
        }
    }
}
impl DebugNumericSummary {
    /// Creates a new `DebugNumericSummary`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `device_name` attribute.
    pub fn device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `tensor_name` attribute.
    pub fn tensor_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.tensor_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `debug_urls` attribute.
    pub fn debug_urls<ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.debug_urls = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `lower_bound` attribute.
    pub fn lower_bound<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.lower_bound = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `upper_bound` attribute.
    pub fn upper_bound<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.upper_bound = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `mute_if_healthy` attribute.
    pub fn mute_if_healthy<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.mute_if_healthy = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `gated_grpc` attribute.
    pub fn gated_grpc<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.gated_grpc = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute debug_numeric_summary.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DebugNumericSummary")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.device_name {
            op.set_attr_string("device_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.tensor_name {
            op.set_attr_string("tensor_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.debug_urls {
            op.set_attr_string_list("debug_urls", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.lower_bound {
            op.set_attr_float("lower_bound", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.upper_bound {
            op.set_attr_float("upper_bound", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.mute_if_healthy {
            op.set_attr_bool("mute_if_healthy", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.gated_grpc {
            op.set_attr_bool("gated_grpc", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DebugNumericSummary::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DebugNumericSummary>
pub fn debug_numeric_summary<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DebugNumericSummary::new();
    op.call(ctx, input)
}

/// DebugNumericSummaryV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DebugNumericSummaryV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DebugNumericSummaryV2 {
    output_dtype: ::std::option::Option<crate::DataType>,
    tensor_debug_mode: ::std::option::Option<i64>,
    tensor_id: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DebugNumericSummaryV2 {
    fn default() -> Self {
        Self {
            output_dtype: Some(crate::DataType::Float),
            tensor_debug_mode: Some(-1i64),
            tensor_id: Some(-1i64),
            target_device_name: None,
        }
    }
}
impl DebugNumericSummaryV2 {
    /// Creates a new `DebugNumericSummaryV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_dtype` attribute.
    pub fn output_dtype<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `tensor_debug_mode` attribute.
    pub fn tensor_debug_mode<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.tensor_debug_mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `tensor_id` attribute.
    pub fn tensor_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.tensor_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute debug_numeric_summary_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DebugNumericSummaryV2")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_dtype {
            op.set_attr_type("output_dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.tensor_debug_mode {
            op.set_attr_int("tensor_debug_mode", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.tensor_id {
            op.set_attr_int("tensor_id", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DebugNumericSummaryV2::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DebugNumericSummaryV2>
pub fn debug_numeric_summary_v2<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DebugNumericSummaryV2::new();
    op.call(ctx, input)
}

/// DecodeAndCropJpeg
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DecodeAndCropJpeg>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DecodeAndCropJpeg {
    channels: ::std::option::Option<i64>,
    ratio: ::std::option::Option<i64>,
    fancy_upscaling: ::std::option::Option<bool>,
    try_recover_truncated: ::std::option::Option<bool>,
    acceptable_fraction: ::std::option::Option<f32>,
    dct_method: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DecodeAndCropJpeg {
    fn default() -> Self {
        Self {
            channels: Some(0i64),
            ratio: Some(1i64),
            fancy_upscaling: Some(true),
            try_recover_truncated: Some(false),
            acceptable_fraction: Some(1f32),
            dct_method: None,
            target_device_name: None,
        }
    }
}
impl DecodeAndCropJpeg {
    /// Creates a new `DecodeAndCropJpeg`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `channels` attribute.
    pub fn channels<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.channels = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `ratio` attribute.
    pub fn ratio<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.ratio = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `fancy_upscaling` attribute.
    pub fn fancy_upscaling<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.fancy_upscaling = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `try_recover_truncated` attribute.
    pub fn try_recover_truncated<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.try_recover_truncated = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `acceptable_fraction` attribute.
    pub fn acceptable_fraction<ArgType: ::std::convert::Into<f32>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.acceptable_fraction = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dct_method` attribute.
    pub fn dct_method<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dct_method = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute decode_and_crop_jpeg.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        contents: &T0,
        crop_window: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DecodeAndCropJpeg")?;

        // Required input arguments
        op.add_input(&contents.to_handle(ctx)?)?;
        op.add_input(&crop_window.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.channels {
            op.set_attr_int("channels", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.ratio {
            op.set_attr_int("ratio", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.fancy_upscaling {
            op.set_attr_bool("fancy_upscaling", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.try_recover_truncated {
            op.set_attr_bool("try_recover_truncated", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.acceptable_fraction {
            op.set_attr_float("acceptable_fraction", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dct_method {
            op.set_attr_string("dct_method", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DecodeAndCropJpeg::new().call(&ctx, &contents, &crop_window)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DecodeAndCropJpeg>
pub fn decode_and_crop_jpeg<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    contents: &T0,
    crop_window: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DecodeAndCropJpeg::new();
    op.call(ctx, contents, crop_window)
}

/// DecodeBase64
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DecodeBase64>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DecodeBase64 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DecodeBase64 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl DecodeBase64 {
    /// Creates a new `DecodeBase64`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute decode_base64.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DecodeBase64")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DecodeBase64::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DecodeBase64>
pub fn decode_base64<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DecodeBase64::new();
    op.call(ctx, input)
}

/// DecodeBmp
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DecodeBmp>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DecodeBmp {
    channels: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DecodeBmp {
    fn default() -> Self {
        Self {
            channels: Some(0i64),
            target_device_name: None,
        }
    }
}
impl DecodeBmp {
    /// Creates a new `DecodeBmp`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `channels` attribute.
    pub fn channels<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.channels = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute decode_bmp.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        contents: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DecodeBmp")?;

        // Required input arguments
        op.add_input(&contents.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.channels {
            op.set_attr_int("channels", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DecodeBmp::new().call(&ctx, &contents)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DecodeBmp>
pub fn decode_bmp<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    contents: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DecodeBmp::new();
    op.call(ctx, contents)
}

/// DecodeCSV
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DecodeCSV>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DecodeCSV {
    field_delim: ::std::option::Option<::std::string::String>,
    use_quote_delim: ::std::option::Option<bool>,
    na_value: ::std::option::Option<::std::string::String>,
    select_cols: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DecodeCSV {
    fn default() -> Self {
        Self {
            field_delim: Some(::std::string::String::from(",")),
            use_quote_delim: Some(true),
            na_value: None,
            select_cols: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl DecodeCSV {
    /// Creates a new `DecodeCSV`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `field_delim` attribute.
    pub fn field_delim<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.field_delim = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_quote_delim` attribute.
    pub fn use_quote_delim<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_quote_delim = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `na_value` attribute.
    pub fn na_value<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.na_value = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `select_cols` attribute.
    pub fn select_cols<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.select_cols = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute decode_csv.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        records: &T0,
        record_defaults: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DecodeCSV")?;

        // Required input arguments
        op.add_input(&records.to_handle(ctx)?)?;
        op.add_input(&record_defaults.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.field_delim {
            op.set_attr_string("field_delim", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_quote_delim {
            op.set_attr_bool("use_quote_delim", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.na_value {
            op.set_attr_string("na_value", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.select_cols {
            op.set_attr_int_list("select_cols", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DecodeCSV::new().call(&ctx, &records, &record_defaults)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DecodeCSV>
pub fn decode_csv<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    records: &T0,
    record_defaults: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DecodeCSV::new();
    op.call(ctx, records, record_defaults)
}

/// DecodeCompressed
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DecodeCompressed>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DecodeCompressed {
    compression_type: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DecodeCompressed {
    fn default() -> Self {
        Self {
            compression_type: None,
            target_device_name: None,
        }
    }
}
impl DecodeCompressed {
    /// Creates a new `DecodeCompressed`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `compression_type` attribute.
    pub fn compression_type<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.compression_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute decode_compressed.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        bytes: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DecodeCompressed")?;

        // Required input arguments
        op.add_input(&bytes.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.compression_type {
            op.set_attr_string("compression_type", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DecodeCompressed::new().call(&ctx, &bytes)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DecodeCompressed>
pub fn decode_compressed<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    bytes: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DecodeCompressed::new();
    op.call(ctx, bytes)
}

/// DecodeGif
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DecodeGif>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DecodeGif {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DecodeGif {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl DecodeGif {
    /// Creates a new `DecodeGif`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute decode_gif.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        contents: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DecodeGif")?;

        // Required input arguments
        op.add_input(&contents.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DecodeGif::new().call(&ctx, &contents)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DecodeGif>
pub fn decode_gif<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    contents: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DecodeGif::new();
    op.call(ctx, contents)
}

/// DecodeImage
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DecodeImage>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DecodeImage {
    channels: ::std::option::Option<i64>,
    dtype: ::std::option::Option<crate::DataType>,
    expand_animations: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DecodeImage {
    fn default() -> Self {
        Self {
            channels: Some(0i64),
            dtype: Some(crate::DataType::UInt8),
            expand_animations: Some(true),
            target_device_name: None,
        }
    }
}
impl DecodeImage {
    /// Creates a new `DecodeImage`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `channels` attribute.
    pub fn channels<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.channels = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `expand_animations` attribute.
    pub fn expand_animations<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.expand_animations = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute decode_image.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        contents: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DecodeImage")?;

        // Required input arguments
        op.add_input(&contents.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.channels {
            op.set_attr_int("channels", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.expand_animations {
            op.set_attr_bool("expand_animations", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DecodeImage::new().call(&ctx, &contents)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DecodeImage>
pub fn decode_image<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    contents: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DecodeImage::new();
    op.call(ctx, contents)
}

/// DecodeJSONExample
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DecodeJSONExample>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DecodeJSONExample {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DecodeJSONExample {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl DecodeJSONExample {
    /// Creates a new `DecodeJSONExample`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute decode_jsonexample.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        json_examples: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DecodeJSONExample")?;

        // Required input arguments
        op.add_input(&json_examples.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DecodeJSONExample::new().call(&ctx, &json_examples)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DecodeJSONExample>
pub fn decode_jsonexample<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    json_examples: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DecodeJSONExample::new();
    op.call(ctx, json_examples)
}

/// DecodeJpeg
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DecodeJpeg>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DecodeJpeg {
    channels: ::std::option::Option<i64>,
    ratio: ::std::option::Option<i64>,
    fancy_upscaling: ::std::option::Option<bool>,
    try_recover_truncated: ::std::option::Option<bool>,
    acceptable_fraction: ::std::option::Option<f32>,
    dct_method: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DecodeJpeg {
    fn default() -> Self {
        Self {
            channels: Some(0i64),
            ratio: Some(1i64),
            fancy_upscaling: Some(true),
            try_recover_truncated: Some(false),
            acceptable_fraction: Some(1f32),
            dct_method: None,
            target_device_name: None,
        }
    }
}
impl DecodeJpeg {
    /// Creates a new `DecodeJpeg`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `channels` attribute.
    pub fn channels<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.channels = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `ratio` attribute.
    pub fn ratio<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.ratio = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `fancy_upscaling` attribute.
    pub fn fancy_upscaling<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.fancy_upscaling = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `try_recover_truncated` attribute.
    pub fn try_recover_truncated<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.try_recover_truncated = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `acceptable_fraction` attribute.
    pub fn acceptable_fraction<ArgType: ::std::convert::Into<f32>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.acceptable_fraction = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dct_method` attribute.
    pub fn dct_method<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dct_method = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute decode_jpeg.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        contents: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DecodeJpeg")?;

        // Required input arguments
        op.add_input(&contents.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.channels {
            op.set_attr_int("channels", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.ratio {
            op.set_attr_int("ratio", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.fancy_upscaling {
            op.set_attr_bool("fancy_upscaling", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.try_recover_truncated {
            op.set_attr_bool("try_recover_truncated", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.acceptable_fraction {
            op.set_attr_float("acceptable_fraction", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dct_method {
            op.set_attr_string("dct_method", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DecodeJpeg::new().call(&ctx, &contents)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DecodeJpeg>
pub fn decode_jpeg<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    contents: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DecodeJpeg::new();
    op.call(ctx, contents)
}

/// DecodePaddedRaw
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DecodePaddedRaw>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DecodePaddedRaw {
    out_type: ::std::option::Option<crate::DataType>,
    little_endian: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DecodePaddedRaw {
    fn default() -> Self {
        Self {
            out_type: None,
            little_endian: Some(true),
            target_device_name: None,
        }
    }
}
impl DecodePaddedRaw {
    /// Creates a new `DecodePaddedRaw`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_type` attribute.
    pub fn out_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `little_endian` attribute.
    pub fn little_endian<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.little_endian = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute decode_padded_raw.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_bytes: &T0,
        fixed_length: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DecodePaddedRaw")?;

        // Required input arguments
        op.add_input(&input_bytes.to_handle(ctx)?)?;
        op.add_input(&fixed_length.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_type {
            op.set_attr_type("out_type", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.little_endian {
            op.set_attr_bool("little_endian", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DecodePaddedRaw::new().call(&ctx, &input_bytes, &fixed_length)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DecodePaddedRaw>
pub fn decode_padded_raw<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_bytes: &T0,
    fixed_length: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DecodePaddedRaw::new();
    op.call(ctx, input_bytes, fixed_length)
}

/// DecodePng
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DecodePng>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DecodePng {
    channels: ::std::option::Option<i64>,
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DecodePng {
    fn default() -> Self {
        Self {
            channels: Some(0i64),
            dtype: Some(crate::DataType::UInt8),
            target_device_name: None,
        }
    }
}
impl DecodePng {
    /// Creates a new `DecodePng`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `channels` attribute.
    pub fn channels<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.channels = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute decode_png.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        contents: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DecodePng")?;

        // Required input arguments
        op.add_input(&contents.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.channels {
            op.set_attr_int("channels", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DecodePng::new().call(&ctx, &contents)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DecodePng>
pub fn decode_png<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    contents: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DecodePng::new();
    op.call(ctx, contents)
}

/// DecodeProtoV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DecodeProtoV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DecodeProtoV2 {
    message_type: ::std::option::Option<::std::string::String>,
    field_names: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    descriptor_source: ::std::option::Option<::std::string::String>,
    message_format: ::std::option::Option<::std::string::String>,
    sanitize: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DecodeProtoV2 {
    fn default() -> Self {
        Self {
            message_type: None,
            field_names: None,
            output_types: None,
            descriptor_source: Some(::std::string::String::from("local://")),
            message_format: Some(::std::string::String::from("binary")),
            sanitize: Some(false),
            target_device_name: None,
        }
    }
}
impl DecodeProtoV2 {
    /// Creates a new `DecodeProtoV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `message_type` attribute.
    pub fn message_type<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.message_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `field_names` attribute.
    pub fn field_names<ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.field_names = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `descriptor_source` attribute.
    pub fn descriptor_source<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.descriptor_source = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `message_format` attribute.
    pub fn message_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.message_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `sanitize` attribute.
    pub fn sanitize<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.sanitize = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute decode_proto_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        bytes: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "DecodeProtoV2")?;

        // Required input arguments
        op.add_input(&bytes.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.message_type {
            op.set_attr_string("message_type", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.field_names {
            op.set_attr_string_list("field_names", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.descriptor_source {
            op.set_attr_string("descriptor_source", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.message_format {
            op.set_attr_string("message_format", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.sanitize {
            op.set_attr_bool("sanitize", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `DecodeProtoV2::new().call(&ctx, &bytes)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DecodeProtoV2>
pub fn decode_proto_v2<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    bytes: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = DecodeProtoV2::new();
    op.call(ctx, bytes)
}

/// DecodeRaw
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DecodeRaw>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DecodeRaw {
    out_type: ::std::option::Option<crate::DataType>,
    little_endian: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DecodeRaw {
    fn default() -> Self {
        Self {
            out_type: None,
            little_endian: Some(true),
            target_device_name: None,
        }
    }
}
impl DecodeRaw {
    /// Creates a new `DecodeRaw`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_type` attribute.
    pub fn out_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `little_endian` attribute.
    pub fn little_endian<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.little_endian = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute decode_raw.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        bytes: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DecodeRaw")?;

        // Required input arguments
        op.add_input(&bytes.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_type {
            op.set_attr_type("out_type", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.little_endian {
            op.set_attr_bool("little_endian", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DecodeRaw::new().call(&ctx, &bytes)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DecodeRaw>
pub fn decode_raw<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    bytes: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DecodeRaw::new();
    op.call(ctx, bytes)
}

/// DecodeWav
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DecodeWav>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DecodeWav {
    desired_channels: ::std::option::Option<i64>,
    desired_samples: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DecodeWav {
    fn default() -> Self {
        Self {
            desired_channels: Some(-1i64),
            desired_samples: Some(-1i64),
            target_device_name: None,
        }
    }
}
impl DecodeWav {
    /// Creates a new `DecodeWav`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `desired_channels` attribute.
    pub fn desired_channels<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.desired_channels = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `desired_samples` attribute.
    pub fn desired_samples<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.desired_samples = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute decode_wav.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        contents: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "DecodeWav")?;

        // Required input arguments
        op.add_input(&contents.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.desired_channels {
            op.set_attr_int("desired_channels", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.desired_samples {
            op.set_attr_int("desired_samples", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `DecodeWav::new().call(&ctx, &contents)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DecodeWav>
pub fn decode_wav<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    contents: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = DecodeWav::new();
    op.call(ctx, contents)
}

/// DeepCopy
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DeepCopy>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DeepCopy {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DeepCopy {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl DeepCopy {
    /// Creates a new `DeepCopy`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute deep_copy.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DeepCopy")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DeepCopy::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DeepCopy>
pub fn deep_copy<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DeepCopy::new();
    op.call(ctx, x)
}

/// DeleteIterator
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DeleteIterator>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DeleteIterator {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DeleteIterator {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl DeleteIterator {
    /// Creates a new `DeleteIterator`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute delete_iterator.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        deleter: &T1,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "DeleteIterator")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&deleter.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `DeleteIterator::new().call(&ctx, &handle, &deleter)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DeleteIterator>
pub fn delete_iterator<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    deleter: &T1,
) -> crate::Result<()> {
    let op = DeleteIterator::new();
    op.call(ctx, handle, deleter)
}

/// DeleteMemoryCache
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DeleteMemoryCache>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DeleteMemoryCache {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DeleteMemoryCache {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl DeleteMemoryCache {
    /// Creates a new `DeleteMemoryCache`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute delete_memory_cache.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        deleter: &T1,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "DeleteMemoryCache")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&deleter.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `DeleteMemoryCache::new().call(&ctx, &handle, &deleter)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DeleteMemoryCache>
pub fn delete_memory_cache<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    deleter: &T1,
) -> crate::Result<()> {
    let op = DeleteMemoryCache::new();
    op.call(ctx, handle, deleter)
}

/// DeleteMultiDeviceIterator
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DeleteMultiDeviceIterator>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DeleteMultiDeviceIterator {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DeleteMultiDeviceIterator {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl DeleteMultiDeviceIterator {
    /// Creates a new `DeleteMultiDeviceIterator`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute delete_multi_device_iterator.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        multi_device_iterator: &T0,
        iterators: &[&T1],
        deleter: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "DeleteMultiDeviceIterator")?;

        // Required input arguments
        op.add_input(&multi_device_iterator.to_handle(ctx)?)?;
        let mut iterators_list = Vec::new();

        for t in iterators {
            iterators_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&iterators_list)?;
        op.add_input(&deleter.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `DeleteMultiDeviceIterator::new().call(&ctx, &multi_device_iterator, &iterators, &deleter)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DeleteMultiDeviceIterator>
pub fn delete_multi_device_iterator<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    multi_device_iterator: &T0,
    iterators: &[&T1],
    deleter: &T2,
) -> crate::Result<()> {
    let op = DeleteMultiDeviceIterator::new();
    op.call(ctx, multi_device_iterator, iterators, deleter)
}

/// DeleteRandomSeedGenerator
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DeleteRandomSeedGenerator>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DeleteRandomSeedGenerator {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DeleteRandomSeedGenerator {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl DeleteRandomSeedGenerator {
    /// Creates a new `DeleteRandomSeedGenerator`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute delete_random_seed_generator.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        deleter: &T1,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "DeleteRandomSeedGenerator")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&deleter.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `DeleteRandomSeedGenerator::new().call(&ctx, &handle, &deleter)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DeleteRandomSeedGenerator>
pub fn delete_random_seed_generator<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    deleter: &T1,
) -> crate::Result<()> {
    let op = DeleteRandomSeedGenerator::new();
    op.call(ctx, handle, deleter)
}

/// DeleteSeedGenerator
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DeleteSeedGenerator>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DeleteSeedGenerator {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DeleteSeedGenerator {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl DeleteSeedGenerator {
    /// Creates a new `DeleteSeedGenerator`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute delete_seed_generator.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        deleter: &T1,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "DeleteSeedGenerator")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&deleter.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `DeleteSeedGenerator::new().call(&ctx, &handle, &deleter)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DeleteSeedGenerator>
pub fn delete_seed_generator<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    deleter: &T1,
) -> crate::Result<()> {
    let op = DeleteSeedGenerator::new();
    op.call(ctx, handle, deleter)
}

/// DeleteSessionTensor
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DeleteSessionTensor>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DeleteSessionTensor {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DeleteSessionTensor {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl DeleteSessionTensor {
    /// Creates a new `DeleteSessionTensor`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute delete_session_tensor.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "DeleteSessionTensor")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `DeleteSessionTensor::new().call(&ctx, &handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DeleteSessionTensor>
pub fn delete_session_tensor<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
) -> crate::Result<()> {
    let op = DeleteSessionTensor::new();
    op.call(ctx, handle)
}

/// DenseBincount
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DenseBincount>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DenseBincount {
    binary_output: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DenseBincount {
    fn default() -> Self {
        Self {
            binary_output: Some(false),
            target_device_name: None,
        }
    }
}
impl DenseBincount {
    /// Creates a new `DenseBincount`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `binary_output` attribute.
    pub fn binary_output<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.binary_output = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute dense_bincount.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        size: &T1,
        weights: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DenseBincount")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&size.to_handle(ctx)?)?;
        op.add_input(&weights.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.binary_output {
            op.set_attr_bool("binary_output", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DenseBincount::new().call(&ctx, &input, &size, &weights)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DenseBincount>
pub fn dense_bincount<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    size: &T1,
    weights: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DenseBincount::new();
    op.call(ctx, input, size, weights)
}

/// DenseCountSparseOutput
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DenseCountSparseOutput>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DenseCountSparseOutput {
    minlength: ::std::option::Option<i64>,
    maxlength: ::std::option::Option<i64>,
    binary_output: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DenseCountSparseOutput {
    fn default() -> Self {
        Self {
            minlength: Some(-1i64),
            maxlength: Some(-1i64),
            binary_output: None,
            target_device_name: None,
        }
    }
}
impl DenseCountSparseOutput {
    /// Creates a new `DenseCountSparseOutput`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `minlength` attribute.
    pub fn minlength<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.minlength = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `maxlength` attribute.
    pub fn maxlength<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.maxlength = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `binary_output` attribute.
    pub fn binary_output<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.binary_output = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute dense_count_sparse_output.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        values: &T0,
        weights: &T1,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "DenseCountSparseOutput")?;

        // Required input arguments
        op.add_input(&values.to_handle(ctx)?)?;
        op.add_input(&weights.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.minlength {
            op.set_attr_int("minlength", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.maxlength {
            op.set_attr_int("maxlength", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.binary_output {
            op.set_attr_bool("binary_output", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `DenseCountSparseOutput::new().call(&ctx, &values, &weights)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DenseCountSparseOutput>
pub fn dense_count_sparse_output<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    values: &T0,
    weights: &T1,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = DenseCountSparseOutput::new();
    op.call(ctx, values, weights)
}

/// DenseToCSRSparseMatrix
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DenseToCSRSparseMatrix>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DenseToCSRSparseMatrix {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DenseToCSRSparseMatrix {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl DenseToCSRSparseMatrix {
    /// Creates a new `DenseToCSRSparseMatrix`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute dense_to_csrsparse_matrix.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        dense_input: &T0,
        indices: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DenseToCSRSparseMatrix")?;

        // Required input arguments
        op.add_input(&dense_input.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DenseToCSRSparseMatrix::new().call(&ctx, &dense_input, &indices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DenseToCSRSparseMatrix>
pub fn dense_to_csrsparse_matrix<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    dense_input: &T0,
    indices: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DenseToCSRSparseMatrix::new();
    op.call(ctx, dense_input, indices)
}

/// DenseToDenseSetOperation
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DenseToDenseSetOperation>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DenseToDenseSetOperation {
    set_operation: ::std::option::Option<::std::string::String>,
    validate_indices: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DenseToDenseSetOperation {
    fn default() -> Self {
        Self {
            set_operation: None,
            validate_indices: Some(true),
            target_device_name: None,
        }
    }
}
impl DenseToDenseSetOperation {
    /// Creates a new `DenseToDenseSetOperation`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `set_operation` attribute.
    pub fn set_operation<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.set_operation = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `validate_indices` attribute.
    pub fn validate_indices<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.validate_indices = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute dense_to_dense_set_operation.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        set1: &T0,
        set2: &T1,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "DenseToDenseSetOperation")?;

        // Required input arguments
        op.add_input(&set1.to_handle(ctx)?)?;
        op.add_input(&set2.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.set_operation {
            op.set_attr_string("set_operation", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.validate_indices {
            op.set_attr_bool("validate_indices", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `DenseToDenseSetOperation::new().call(&ctx, &set1, &set2)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DenseToDenseSetOperation>
pub fn dense_to_dense_set_operation<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    set1: &T0,
    set2: &T1,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = DenseToDenseSetOperation::new();
    op.call(ctx, set1, set2)
}

/// DenseToSparseBatchDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DenseToSparseBatchDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DenseToSparseBatchDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DenseToSparseBatchDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl DenseToSparseBatchDataset {
    /// Creates a new `DenseToSparseBatchDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute dense_to_sparse_batch_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        batch_size: &T1,
        row_shape: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DenseToSparseBatchDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&batch_size.to_handle(ctx)?)?;
        op.add_input(&row_shape.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DenseToSparseBatchDataset::new().call(&ctx, &input_dataset, &batch_size, &row_shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DenseToSparseBatchDataset>
pub fn dense_to_sparse_batch_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    batch_size: &T1,
    row_shape: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DenseToSparseBatchDataset::new();
    op.call(ctx, input_dataset, batch_size, row_shape)
}

/// DenseToSparseSetOperation
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DenseToSparseSetOperation>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DenseToSparseSetOperation {
    set_operation: ::std::option::Option<::std::string::String>,
    validate_indices: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DenseToSparseSetOperation {
    fn default() -> Self {
        Self {
            set_operation: None,
            validate_indices: Some(true),
            target_device_name: None,
        }
    }
}
impl DenseToSparseSetOperation {
    /// Creates a new `DenseToSparseSetOperation`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `set_operation` attribute.
    pub fn set_operation<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.set_operation = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `validate_indices` attribute.
    pub fn validate_indices<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.validate_indices = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute dense_to_sparse_set_operation.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        set1: &T0,
        set2_indices: &T1,
        set2_values: &T2,
        set2_shape: &T3,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "DenseToSparseSetOperation")?;

        // Required input arguments
        op.add_input(&set1.to_handle(ctx)?)?;
        op.add_input(&set2_indices.to_handle(ctx)?)?;
        op.add_input(&set2_values.to_handle(ctx)?)?;
        op.add_input(&set2_shape.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.set_operation {
            op.set_attr_string("set_operation", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.validate_indices {
            op.set_attr_bool("validate_indices", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `DenseToSparseSetOperation::new().call(&ctx, &set1, &set2_indices, &set2_values, &set2_shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DenseToSparseSetOperation>
pub fn dense_to_sparse_set_operation<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    set1: &T0,
    set2_indices: &T1,
    set2_values: &T2,
    set2_shape: &T3,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = DenseToSparseSetOperation::new();
    op.call(ctx, set1, set2_indices, set2_values, set2_shape)
}

/// DepthToSpace
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DepthToSpace>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DepthToSpace {
    block_size: ::std::option::Option<i64>,
    data_format: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DepthToSpace {
    fn default() -> Self {
        Self {
            block_size: None,
            data_format: Some(::std::string::String::from("NHWC")),
            target_device_name: None,
        }
    }
}
impl DepthToSpace {
    /// Creates a new `DepthToSpace`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `block_size` attribute.
    pub fn block_size<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.block_size = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `data_format` attribute.
    pub fn data_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.data_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute depth_to_space.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DepthToSpace")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.block_size {
            op.set_attr_int("block_size", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.data_format {
            op.set_attr_string("data_format", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DepthToSpace::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DepthToSpace>
pub fn depth_to_space<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DepthToSpace::new();
    op.call(ctx, input)
}

/// DepthwiseConv2dNative
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DepthwiseConv2dNative>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DepthwiseConv2dNative {
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    explicit_paddings: ::std::option::Option<::std::vec::Vec<i64>>,
    data_format: ::std::option::Option<::std::string::String>,
    dilations: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DepthwiseConv2dNative {
    fn default() -> Self {
        Self {
            strides: None,
            padding: None,
            explicit_paddings: Some(vec![]),
            data_format: Some(::std::string::String::from("NHWC")),
            dilations: Some(vec![1, 1, 1, 1]),
            target_device_name: None,
        }
    }
}
impl DepthwiseConv2dNative {
    /// Creates a new `DepthwiseConv2dNative`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `explicit_paddings` attribute.
    pub fn explicit_paddings<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.explicit_paddings = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `data_format` attribute.
    pub fn data_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.data_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dilations` attribute.
    pub fn dilations<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dilations = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute depthwise_conv2d_native.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        filter: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DepthwiseConv2dNative")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&filter.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.explicit_paddings {
            op.set_attr_int_list("explicit_paddings", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.data_format {
            op.set_attr_string("data_format", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dilations {
            op.set_attr_int_list("dilations", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DepthwiseConv2dNative::new().call(&ctx, &input, &filter)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DepthwiseConv2dNative>
pub fn depthwise_conv2d_native<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    filter: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DepthwiseConv2dNative::new();
    op.call(ctx, input, filter)
}

/// DepthwiseConv2dNativeBackpropFilter
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DepthwiseConv2dNativeBackpropFilter>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DepthwiseConv2dNativeBackpropFilter {
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    explicit_paddings: ::std::option::Option<::std::vec::Vec<i64>>,
    data_format: ::std::option::Option<::std::string::String>,
    dilations: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DepthwiseConv2dNativeBackpropFilter {
    fn default() -> Self {
        Self {
            strides: None,
            padding: None,
            explicit_paddings: Some(vec![]),
            data_format: Some(::std::string::String::from("NHWC")),
            dilations: Some(vec![1, 1, 1, 1]),
            target_device_name: None,
        }
    }
}
impl DepthwiseConv2dNativeBackpropFilter {
    /// Creates a new `DepthwiseConv2dNativeBackpropFilter`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `explicit_paddings` attribute.
    pub fn explicit_paddings<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.explicit_paddings = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `data_format` attribute.
    pub fn data_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.data_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dilations` attribute.
    pub fn dilations<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dilations = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute depthwise_conv2d_native_backprop_filter.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        filter_sizes: &T1,
        out_backprop: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DepthwiseConv2dNativeBackpropFilter")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&filter_sizes.to_handle(ctx)?)?;
        op.add_input(&out_backprop.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.explicit_paddings {
            op.set_attr_int_list("explicit_paddings", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.data_format {
            op.set_attr_string("data_format", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dilations {
            op.set_attr_int_list("dilations", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DepthwiseConv2dNativeBackpropFilter::new().call(&ctx, &input, &filter_sizes, &out_backprop)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DepthwiseConv2dNativeBackpropFilter>
pub fn depthwise_conv2d_native_backprop_filter<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    filter_sizes: &T1,
    out_backprop: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DepthwiseConv2dNativeBackpropFilter::new();
    op.call(ctx, input, filter_sizes, out_backprop)
}

/// DepthwiseConv2dNativeBackpropInput
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DepthwiseConv2dNativeBackpropInput>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DepthwiseConv2dNativeBackpropInput {
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    explicit_paddings: ::std::option::Option<::std::vec::Vec<i64>>,
    data_format: ::std::option::Option<::std::string::String>,
    dilations: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DepthwiseConv2dNativeBackpropInput {
    fn default() -> Self {
        Self {
            strides: None,
            padding: None,
            explicit_paddings: Some(vec![]),
            data_format: Some(::std::string::String::from("NHWC")),
            dilations: Some(vec![1, 1, 1, 1]),
            target_device_name: None,
        }
    }
}
impl DepthwiseConv2dNativeBackpropInput {
    /// Creates a new `DepthwiseConv2dNativeBackpropInput`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `explicit_paddings` attribute.
    pub fn explicit_paddings<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.explicit_paddings = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `data_format` attribute.
    pub fn data_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.data_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dilations` attribute.
    pub fn dilations<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dilations = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute depthwise_conv2d_native_backprop_input.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_sizes: &T0,
        filter: &T1,
        out_backprop: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DepthwiseConv2dNativeBackpropInput")?;

        // Required input arguments
        op.add_input(&input_sizes.to_handle(ctx)?)?;
        op.add_input(&filter.to_handle(ctx)?)?;
        op.add_input(&out_backprop.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.explicit_paddings {
            op.set_attr_int_list("explicit_paddings", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.data_format {
            op.set_attr_string("data_format", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dilations {
            op.set_attr_int_list("dilations", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DepthwiseConv2dNativeBackpropInput::new().call(&ctx, &input_sizes, &filter, &out_backprop)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DepthwiseConv2dNativeBackpropInput>
pub fn depthwise_conv2d_native_backprop_input<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_sizes: &T0,
    filter: &T1,
    out_backprop: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DepthwiseConv2dNativeBackpropInput::new();
    op.call(ctx, input_sizes, filter, out_backprop)
}

/// Dequantize
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Dequantize>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Dequantize {
    mode: ::std::option::Option<::std::string::String>,
    narrow_range: ::std::option::Option<bool>,
    axis: ::std::option::Option<i64>,
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Dequantize {
    fn default() -> Self {
        Self {
            mode: Some(::std::string::String::from("MIN_COMBINED")),
            narrow_range: Some(false),
            axis: Some(-1i64),
            dtype: Some(crate::DataType::Float),
            target_device_name: None,
        }
    }
}
impl Dequantize {
    /// Creates a new `Dequantize`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `mode` attribute.
    pub fn mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `narrow_range` attribute.
    pub fn narrow_range<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.narrow_range = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `axis` attribute.
    pub fn axis<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.axis = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute dequantize.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        min_range: &T1,
        max_range: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Dequantize")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&min_range.to_handle(ctx)?)?;
        op.add_input(&max_range.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.mode {
            op.set_attr_string("mode", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.narrow_range {
            op.set_attr_bool("narrow_range", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.axis {
            op.set_attr_int("axis", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Dequantize::new().call(&ctx, &input, &min_range, &max_range)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Dequantize>
pub fn dequantize<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    min_range: &T1,
    max_range: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Dequantize::new();
    op.call(ctx, input, min_range, max_range)
}

/// DeserializeIterator
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DeserializeIterator>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DeserializeIterator {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DeserializeIterator {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl DeserializeIterator {
    /// Creates a new `DeserializeIterator`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute deserialize_iterator.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        resource_handle: &T0,
        serialized: &T1,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "DeserializeIterator")?;

        // Required input arguments
        op.add_input(&resource_handle.to_handle(ctx)?)?;
        op.add_input(&serialized.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `DeserializeIterator::new().call(&ctx, &resource_handle, &serialized)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DeserializeIterator>
pub fn deserialize_iterator<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    resource_handle: &T0,
    serialized: &T1,
) -> crate::Result<()> {
    let op = DeserializeIterator::new();
    op.call(ctx, resource_handle, serialized)
}

/// DeserializeManySparse
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DeserializeManySparse>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DeserializeManySparse {
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DeserializeManySparse {
    fn default() -> Self {
        Self {
            dtype: None,
            target_device_name: None,
        }
    }
}
impl DeserializeManySparse {
    /// Creates a new `DeserializeManySparse`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute deserialize_many_sparse.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        serialized_sparse: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "DeserializeManySparse")?;

        // Required input arguments
        op.add_input(&serialized_sparse.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `DeserializeManySparse::new().call(&ctx, &serialized_sparse)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DeserializeManySparse>
pub fn deserialize_many_sparse<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    serialized_sparse: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = DeserializeManySparse::new();
    op.call(ctx, serialized_sparse)
}

/// DeserializeSparse
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DeserializeSparse>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DeserializeSparse {
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DeserializeSparse {
    fn default() -> Self {
        Self {
            dtype: None,
            target_device_name: None,
        }
    }
}
impl DeserializeSparse {
    /// Creates a new `DeserializeSparse`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute deserialize_sparse.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        serialized_sparse: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "DeserializeSparse")?;

        // Required input arguments
        op.add_input(&serialized_sparse.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `DeserializeSparse::new().call(&ctx, &serialized_sparse)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DeserializeSparse>
pub fn deserialize_sparse<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    serialized_sparse: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = DeserializeSparse::new();
    op.call(ctx, serialized_sparse)
}

/// DestroyResourceOp
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DestroyResourceOp>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DestroyResourceOp {
    ignore_lookup_error: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DestroyResourceOp {
    fn default() -> Self {
        Self {
            ignore_lookup_error: Some(true),
            target_device_name: None,
        }
    }
}
impl DestroyResourceOp {
    /// Creates a new `DestroyResourceOp`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `ignore_lookup_error` attribute.
    pub fn ignore_lookup_error<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.ignore_lookup_error = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute destroy_resource_op.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        resource: &T0,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "DestroyResourceOp")?;

        // Required input arguments
        op.add_input(&resource.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.ignore_lookup_error {
            op.set_attr_bool("ignore_lookup_error", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `DestroyResourceOp::new().call(&ctx, &resource)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DestroyResourceOp>
pub fn destroy_resource_op<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    resource: &T0,
) -> crate::Result<()> {
    let op = DestroyResourceOp::new();
    op.call(ctx, resource)
}

/// DestroyTemporaryVariable
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DestroyTemporaryVariable>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DestroyTemporaryVariable {
    var_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DestroyTemporaryVariable {
    fn default() -> Self {
        Self {
            var_name: None,
            target_device_name: None,
        }
    }
}
impl DestroyTemporaryVariable {
    /// Creates a new `DestroyTemporaryVariable`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `var_name` attribute.
    pub fn var_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.var_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute destroy_temporary_variable.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        ref_: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DestroyTemporaryVariable")?;

        // Required input arguments
        op.add_input(&ref_.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.var_name {
            op.set_attr_string("var_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DestroyTemporaryVariable::new().call(&ctx, &ref_)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DestroyTemporaryVariable>
pub fn destroy_temporary_variable<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    ref_: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DestroyTemporaryVariable::new();
    op.call(ctx, ref_)
}

/// DeviceIndex
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DeviceIndex>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DeviceIndex {
    device_names: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DeviceIndex {
    fn default() -> Self {
        Self {
            device_names: None,
            target_device_name: None,
        }
    }
}
impl DeviceIndex {
    /// Creates a new `DeviceIndex`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `device_names` attribute.
    pub fn device_names<ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.device_names = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute device_index.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DeviceIndex")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.device_names {
            op.set_attr_string_list("device_names", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DeviceIndex::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DeviceIndex>
pub fn device_index<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DeviceIndex::new();
    op.call(ctx)
}

/// Diag
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Diag>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Diag {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Diag {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Diag {
    /// Creates a new `Diag`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute diag.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        diagonal: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Diag")?;

        // Required input arguments
        op.add_input(&diagonal.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Diag::new().call(&ctx, &diagonal)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Diag>
pub fn diag<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    diagonal: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Diag::new();
    op.call(ctx, diagonal)
}

/// DiagPart
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DiagPart>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DiagPart {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DiagPart {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl DiagPart {
    /// Creates a new `DiagPart`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute diag_part.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DiagPart")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DiagPart::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DiagPart>
pub fn diag_part<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DiagPart::new();
    op.call(ctx, input)
}

/// Digamma
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Digamma>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Digamma {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Digamma {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Digamma {
    /// Creates a new `Digamma`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute digamma.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Digamma")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Digamma::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Digamma>
pub fn digamma<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Digamma::new();
    op.call(ctx, x)
}

/// Dilation2D
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Dilation2D>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Dilation2D {
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    rates: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Dilation2D {
    fn default() -> Self {
        Self {
            strides: None,
            rates: None,
            padding: None,
            target_device_name: None,
        }
    }
}
impl Dilation2D {
    /// Creates a new `Dilation2D`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `rates` attribute.
    pub fn rates<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.rates = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute dilation2_d.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        filter: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Dilation2D")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&filter.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.rates {
            op.set_attr_int_list("rates", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Dilation2D::new().call(&ctx, &input, &filter)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Dilation2D>
pub fn dilation2_d<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    filter: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Dilation2D::new();
    op.call(ctx, input, filter)
}

/// Dilation2DBackpropFilter
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Dilation2DBackpropFilter>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Dilation2DBackpropFilter {
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    rates: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Dilation2DBackpropFilter {
    fn default() -> Self {
        Self {
            strides: None,
            rates: None,
            padding: None,
            target_device_name: None,
        }
    }
}
impl Dilation2DBackpropFilter {
    /// Creates a new `Dilation2DBackpropFilter`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `rates` attribute.
    pub fn rates<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.rates = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute dilation2_dbackprop_filter.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        filter: &T1,
        out_backprop: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Dilation2DBackpropFilter")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&filter.to_handle(ctx)?)?;
        op.add_input(&out_backprop.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.rates {
            op.set_attr_int_list("rates", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Dilation2DBackpropFilter::new().call(&ctx, &input, &filter, &out_backprop)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Dilation2DBackpropFilter>
pub fn dilation2_dbackprop_filter<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    filter: &T1,
    out_backprop: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Dilation2DBackpropFilter::new();
    op.call(ctx, input, filter, out_backprop)
}

/// Dilation2DBackpropInput
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Dilation2DBackpropInput>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Dilation2DBackpropInput {
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    rates: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Dilation2DBackpropInput {
    fn default() -> Self {
        Self {
            strides: None,
            rates: None,
            padding: None,
            target_device_name: None,
        }
    }
}
impl Dilation2DBackpropInput {
    /// Creates a new `Dilation2DBackpropInput`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `rates` attribute.
    pub fn rates<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.rates = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute dilation2_dbackprop_input.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        filter: &T1,
        out_backprop: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Dilation2DBackpropInput")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&filter.to_handle(ctx)?)?;
        op.add_input(&out_backprop.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.rates {
            op.set_attr_int_list("rates", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Dilation2DBackpropInput::new().call(&ctx, &input, &filter, &out_backprop)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Dilation2DBackpropInput>
pub fn dilation2_dbackprop_input<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    filter: &T1,
    out_backprop: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Dilation2DBackpropInput::new();
    op.call(ctx, input, filter, out_backprop)
}

/// DirectedInterleaveDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DirectedInterleaveDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DirectedInterleaveDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    stop_on_empty_dataset: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DirectedInterleaveDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            stop_on_empty_dataset: Some(false),
            target_device_name: None,
        }
    }
}
impl DirectedInterleaveDataset {
    /// Creates a new `DirectedInterleaveDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `stop_on_empty_dataset` attribute.
    pub fn stop_on_empty_dataset<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.stop_on_empty_dataset = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute directed_interleave_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        selector_input_dataset: &T0,
        data_input_datasets: &[&T1],
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DirectedInterleaveDataset")?;

        // Required input arguments
        op.add_input(&selector_input_dataset.to_handle(ctx)?)?;
        let mut data_input_datasets_list = Vec::new();

        for t in data_input_datasets {
            data_input_datasets_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&data_input_datasets_list)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.stop_on_empty_dataset {
            op.set_attr_bool("stop_on_empty_dataset", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DirectedInterleaveDataset::new().call(&ctx, &selector_input_dataset, &data_input_datasets)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DirectedInterleaveDataset>
pub fn directed_interleave_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    selector_input_dataset: &T0,
    data_input_datasets: &[&T1],
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DirectedInterleaveDataset::new();
    op.call(ctx, selector_input_dataset, data_input_datasets)
}

/// DisableCopyOnRead
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DisableCopyOnRead>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DisableCopyOnRead {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DisableCopyOnRead {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl DisableCopyOnRead {
    /// Creates a new `DisableCopyOnRead`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute disable_copy_on_read.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        resource: &T0,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "DisableCopyOnRead")?;

        // Required input arguments
        op.add_input(&resource.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `DisableCopyOnRead::new().call(&ctx, &resource)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DisableCopyOnRead>
pub fn disable_copy_on_read<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    resource: &T0,
) -> crate::Result<()> {
    let op = DisableCopyOnRead::new();
    op.call(ctx, resource)
}

/// Div
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Div>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Div {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Div {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Div {
    /// Creates a new `Div`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute div.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Div")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Div::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Div>
pub fn div<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Div::new();
    op.call(ctx, x, y)
}

/// DivNoNan
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DivNoNan>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DivNoNan {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DivNoNan {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl DivNoNan {
    /// Creates a new `DivNoNan`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute div_no_nan.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DivNoNan")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DivNoNan::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DivNoNan>
pub fn div_no_nan<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DivNoNan::new();
    op.call(ctx, x, y)
}

/// DrawBoundingBoxes
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DrawBoundingBoxes>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DrawBoundingBoxes {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DrawBoundingBoxes {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl DrawBoundingBoxes {
    /// Creates a new `DrawBoundingBoxes`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute draw_bounding_boxes.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        images: &T0,
        boxes: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DrawBoundingBoxes")?;

        // Required input arguments
        op.add_input(&images.to_handle(ctx)?)?;
        op.add_input(&boxes.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DrawBoundingBoxes::new().call(&ctx, &images, &boxes)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DrawBoundingBoxes>
pub fn draw_bounding_boxes<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    images: &T0,
    boxes: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DrawBoundingBoxes::new();
    op.call(ctx, images, boxes)
}

/// DrawBoundingBoxesV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DrawBoundingBoxesV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DrawBoundingBoxesV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DrawBoundingBoxesV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl DrawBoundingBoxesV2 {
    /// Creates a new `DrawBoundingBoxesV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute draw_bounding_boxes_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        images: &T0,
        boxes: &T1,
        colors: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DrawBoundingBoxesV2")?;

        // Required input arguments
        op.add_input(&images.to_handle(ctx)?)?;
        op.add_input(&boxes.to_handle(ctx)?)?;
        op.add_input(&colors.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DrawBoundingBoxesV2::new().call(&ctx, &images, &boxes, &colors)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DrawBoundingBoxesV2>
pub fn draw_bounding_boxes_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    images: &T0,
    boxes: &T1,
    colors: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DrawBoundingBoxesV2::new();
    op.call(ctx, images, boxes, colors)
}

/// DummyIterationCounter
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DummyIterationCounter>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DummyIterationCounter {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DummyIterationCounter {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl DummyIterationCounter {
    /// Creates a new `DummyIterationCounter`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute dummy_iteration_counter.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DummyIterationCounter")?;

        // Required input arguments

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DummyIterationCounter::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DummyIterationCounter>
pub fn dummy_iteration_counter<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DummyIterationCounter::new();
    op.call(ctx)
}

/// DummyMemoryCache
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DummyMemoryCache>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DummyMemoryCache {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DummyMemoryCache {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl DummyMemoryCache {
    /// Creates a new `DummyMemoryCache`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute dummy_memory_cache.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DummyMemoryCache")?;

        // Required input arguments

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DummyMemoryCache::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DummyMemoryCache>
pub fn dummy_memory_cache<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DummyMemoryCache::new();
    op.call(ctx)
}

/// DummySeedGenerator
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DummySeedGenerator>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DummySeedGenerator {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DummySeedGenerator {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl DummySeedGenerator {
    /// Creates a new `DummySeedGenerator`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute dummy_seed_generator.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DummySeedGenerator")?;

        // Required input arguments

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DummySeedGenerator::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DummySeedGenerator>
pub fn dummy_seed_generator<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DummySeedGenerator::new();
    op.call(ctx)
}

/// DynamicEnqueueTPUEmbeddingArbitraryTensorBatch
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DynamicEnqueueTPUEmbeddingArbitraryTensorBatch>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DynamicEnqueueTPUEmbeddingArbitraryTensorBatch {
    combiners: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DynamicEnqueueTPUEmbeddingArbitraryTensorBatch {
    fn default() -> Self {
        Self {
            combiners: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl DynamicEnqueueTPUEmbeddingArbitraryTensorBatch {
    /// Creates a new `DynamicEnqueueTPUEmbeddingArbitraryTensorBatch`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `combiners` attribute.
    pub fn combiners<ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.combiners = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute dynamic_enqueue_tpuembedding_arbitrary_tensor_batch.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        sample_indices_or_row_splits: &[&T0],
        embedding_indices: &[&T1],
        aggregation_weights: &[&T2],
        mode_override: &T3,
        device_ordinal: &T4,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "DynamicEnqueueTPUEmbeddingArbitraryTensorBatch")?;

        // Required input arguments
        let mut sample_indices_or_row_splits_list = Vec::new();

        for t in sample_indices_or_row_splits {
            sample_indices_or_row_splits_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&sample_indices_or_row_splits_list)?;
        let mut embedding_indices_list = Vec::new();

        for t in embedding_indices {
            embedding_indices_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&embedding_indices_list)?;
        let mut aggregation_weights_list = Vec::new();

        for t in aggregation_weights {
            aggregation_weights_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&aggregation_weights_list)?;
        op.add_input(&mode_override.to_handle(ctx)?)?;
        op.add_input(&device_ordinal.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.combiners {
            op.set_attr_string_list("combiners", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `DynamicEnqueueTPUEmbeddingArbitraryTensorBatch::new().call(&ctx, &sample_indices_or_row_splits, &embedding_indices, &aggregation_weights, &mode_override, &device_ordinal)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DynamicEnqueueTPUEmbeddingArbitraryTensorBatch>
pub fn dynamic_enqueue_tpuembedding_arbitrary_tensor_batch<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    sample_indices_or_row_splits: &[&T0],
    embedding_indices: &[&T1],
    aggregation_weights: &[&T2],
    mode_override: &T3,
    device_ordinal: &T4,
) -> crate::Result<()> {
    let op = DynamicEnqueueTPUEmbeddingArbitraryTensorBatch::new();
    op.call(
        ctx,
        sample_indices_or_row_splits,
        embedding_indices,
        aggregation_weights,
        mode_override,
        device_ordinal,
    )
}

/// DynamicPartition
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DynamicPartition>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DynamicPartition {
    num_partitions: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DynamicPartition {
    fn default() -> Self {
        Self {
            num_partitions: None,
            target_device_name: None,
        }
    }
}
impl DynamicPartition {
    /// Creates a new `DynamicPartition`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_partitions` attribute.
    pub fn num_partitions<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_partitions = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute dynamic_partition.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        data: &T0,
        partitions: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DynamicPartition")?;

        // Required input arguments
        op.add_input(&data.to_handle(ctx)?)?;
        op.add_input(&partitions.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_partitions {
            op.set_attr_int("num_partitions", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DynamicPartition::new().call(&ctx, &data, &partitions)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DynamicPartition>
pub fn dynamic_partition<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    data: &T0,
    partitions: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DynamicPartition::new();
    op.call(ctx, data, partitions)
}

/// DynamicStitch
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DynamicStitch>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct DynamicStitch {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for DynamicStitch {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl DynamicStitch {
    /// Creates a new `DynamicStitch`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute dynamic_stitch.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        indices: &[&T0],
        data: &[&T1],
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "DynamicStitch")?;

        // Required input arguments
        let mut indices_list = Vec::new();

        for t in indices {
            indices_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&indices_list)?;
        let mut data_list = Vec::new();

        for t in data {
            data_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&data_list)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `DynamicStitch::new().call(&ctx, &indices, &data)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/DynamicStitch>
pub fn dynamic_stitch<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    indices: &[&T0],
    data: &[&T1],
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = DynamicStitch::new();
    op.call(ctx, indices, data)
}

/// EagerPyFunc
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/EagerPyFunc>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct EagerPyFunc {
    token: ::std::option::Option<::std::string::String>,
    is_async: ::std::option::Option<bool>,
    Tout: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for EagerPyFunc {
    fn default() -> Self {
        Self {
            token: None,
            is_async: Some(false),
            Tout: None,
            target_device_name: None,
        }
    }
}
impl EagerPyFunc {
    /// Creates a new `EagerPyFunc`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `token` attribute.
    pub fn token<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.token = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `is_async` attribute.
    pub fn is_async<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.is_async = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `Tout` attribute.
    pub fn Tout<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Tout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute eager_py_func.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "EagerPyFunc")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.token {
            op.set_attr_string("token", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.is_async {
            op.set_attr_bool("is_async", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.Tout {
            op.set_attr_type_list("Tout", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `EagerPyFunc::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/EagerPyFunc>
pub fn eager_py_func<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = EagerPyFunc::new();
    op.call(ctx, input)
}

/// EditDistance
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/EditDistance>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct EditDistance {
    normalize: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for EditDistance {
    fn default() -> Self {
        Self {
            normalize: Some(true),
            target_device_name: None,
        }
    }
}
impl EditDistance {
    /// Creates a new `EditDistance`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `normalize` attribute.
    pub fn normalize<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.normalize = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute edit_distance.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        hypothesis_indices: &T0,
        hypothesis_values: &T1,
        hypothesis_shape: &T2,
        truth_indices: &T3,
        truth_values: &T4,
        truth_shape: &T5,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "EditDistance")?;

        // Required input arguments
        op.add_input(&hypothesis_indices.to_handle(ctx)?)?;
        op.add_input(&hypothesis_values.to_handle(ctx)?)?;
        op.add_input(&hypothesis_shape.to_handle(ctx)?)?;
        op.add_input(&truth_indices.to_handle(ctx)?)?;
        op.add_input(&truth_values.to_handle(ctx)?)?;
        op.add_input(&truth_shape.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.normalize {
            op.set_attr_bool("normalize", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `EditDistance::new().call(&ctx, &hypothesis_indices, &hypothesis_values, &hypothesis_shape, &truth_indices, &truth_values, &truth_shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/EditDistance>
pub fn edit_distance<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    hypothesis_indices: &T0,
    hypothesis_values: &T1,
    hypothesis_shape: &T2,
    truth_indices: &T3,
    truth_values: &T4,
    truth_shape: &T5,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = EditDistance::new();
    op.call(
        ctx,
        hypothesis_indices,
        hypothesis_values,
        hypothesis_shape,
        truth_indices,
        truth_values,
        truth_shape,
    )
}

/// Eig
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Eig>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Eig {
    compute_v: ::std::option::Option<bool>,
    Tout: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Eig {
    fn default() -> Self {
        Self {
            compute_v: Some(true),
            Tout: None,
            target_device_name: None,
        }
    }
}
impl Eig {
    /// Creates a new `Eig`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `compute_v` attribute.
    pub fn compute_v<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.compute_v = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `Tout` attribute.
    pub fn Tout<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.Tout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute eig.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "Eig")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.compute_v {
            op.set_attr_bool("compute_v", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.Tout {
            op.set_attr_type("Tout", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `Eig::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Eig>
pub fn eig<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = Eig::new();
    op.call(ctx, input)
}

/// Einsum
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Einsum>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Einsum {
    equation: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Einsum {
    fn default() -> Self {
        Self {
            equation: None,
            target_device_name: None,
        }
    }
}
impl Einsum {
    /// Creates a new `Einsum`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `equation` attribute.
    pub fn equation<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.equation = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute einsum.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        inputs: &[&T0],
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Einsum")?;

        // Required input arguments
        let mut inputs_list = Vec::new();

        for t in inputs {
            inputs_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&inputs_list)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.equation {
            op.set_attr_string("equation", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Einsum::new().call(&ctx, &inputs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Einsum>
pub fn einsum<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    inputs: &[&T0],
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Einsum::new();
    op.call(ctx, inputs)
}

/// Elu
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Elu>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Elu {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Elu {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Elu {
    /// Creates a new `Elu`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute elu.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        features: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Elu")?;

        // Required input arguments
        op.add_input(&features.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Elu::new().call(&ctx, &features)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Elu>
pub fn elu<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    features: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Elu::new();
    op.call(ctx, features)
}

/// EluGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/EluGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct EluGrad {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for EluGrad {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl EluGrad {
    /// Creates a new `EluGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute elu_grad.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        gradients: &T0,
        outputs: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "EluGrad")?;

        // Required input arguments
        op.add_input(&gradients.to_handle(ctx)?)?;
        op.add_input(&outputs.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `EluGrad::new().call(&ctx, &gradients, &outputs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/EluGrad>
pub fn elu_grad<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    gradients: &T0,
    outputs: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = EluGrad::new();
    op.call(ctx, gradients, outputs)
}

/// Empty
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Empty>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Empty {
    dtype: ::std::option::Option<crate::DataType>,
    init: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Empty {
    fn default() -> Self {
        Self {
            dtype: None,
            init: Some(false),
            target_device_name: None,
        }
    }
}
impl Empty {
    /// Creates a new `Empty`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `init` attribute.
    pub fn init<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.init = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute empty.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        shape: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Empty")?;

        // Required input arguments
        op.add_input(&shape.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.init {
            op.set_attr_bool("init", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Empty::new().call(&ctx, &shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Empty>
pub fn empty<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    shape: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Empty::new();
    op.call(ctx, shape)
}

/// EmptyTensorList
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/EmptyTensorList>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct EmptyTensorList {
    element_dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for EmptyTensorList {
    fn default() -> Self {
        Self {
            element_dtype: None,
            target_device_name: None,
        }
    }
}
impl EmptyTensorList {
    /// Creates a new `EmptyTensorList`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `element_dtype` attribute.
    pub fn element_dtype<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.element_dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute empty_tensor_list.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        element_shape: &T0,
        max_num_elements: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "EmptyTensorList")?;

        // Required input arguments
        op.add_input(&element_shape.to_handle(ctx)?)?;
        op.add_input(&max_num_elements.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.element_dtype {
            op.set_attr_type("element_dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `EmptyTensorList::new().call(&ctx, &element_shape, &max_num_elements)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/EmptyTensorList>
pub fn empty_tensor_list<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    element_shape: &T0,
    max_num_elements: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = EmptyTensorList::new();
    op.call(ctx, element_shape, max_num_elements)
}

/// EmptyTensorMap
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/EmptyTensorMap>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct EmptyTensorMap {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for EmptyTensorMap {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl EmptyTensorMap {
    /// Creates a new `EmptyTensorMap`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute empty_tensor_map.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "EmptyTensorMap")?;

        // Required input arguments

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `EmptyTensorMap::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/EmptyTensorMap>
pub fn empty_tensor_map<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = EmptyTensorMap::new();
    op.call(ctx)
}

/// EncodeBase64
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/EncodeBase64>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct EncodeBase64 {
    pad: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for EncodeBase64 {
    fn default() -> Self {
        Self {
            pad: Some(false),
            target_device_name: None,
        }
    }
}
impl EncodeBase64 {
    /// Creates a new `EncodeBase64`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `pad` attribute.
    pub fn pad<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.pad = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute encode_base64.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "EncodeBase64")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.pad {
            op.set_attr_bool("pad", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `EncodeBase64::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/EncodeBase64>
pub fn encode_base64<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = EncodeBase64::new();
    op.call(ctx, input)
}

/// EncodeJpeg
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/EncodeJpeg>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct EncodeJpeg {
    format: ::std::option::Option<::std::string::String>,
    quality: ::std::option::Option<i64>,
    progressive: ::std::option::Option<bool>,
    optimize_size: ::std::option::Option<bool>,
    chroma_downsampling: ::std::option::Option<bool>,
    density_unit: ::std::option::Option<::std::string::String>,
    x_density: ::std::option::Option<i64>,
    y_density: ::std::option::Option<i64>,
    xmp_metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for EncodeJpeg {
    fn default() -> Self {
        Self {
            format: None,
            quality: Some(95i64),
            progressive: Some(false),
            optimize_size: Some(false),
            chroma_downsampling: Some(true),
            density_unit: Some(::std::string::String::from("in")),
            x_density: Some(300i64),
            y_density: Some(300i64),
            xmp_metadata: None,
            target_device_name: None,
        }
    }
}
impl EncodeJpeg {
    /// Creates a new `EncodeJpeg`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `format` attribute.
    pub fn format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `quality` attribute.
    pub fn quality<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.quality = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `progressive` attribute.
    pub fn progressive<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.progressive = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `optimize_size` attribute.
    pub fn optimize_size<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.optimize_size = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `chroma_downsampling` attribute.
    pub fn chroma_downsampling<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.chroma_downsampling = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `density_unit` attribute.
    pub fn density_unit<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.density_unit = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `x_density` attribute.
    pub fn x_density<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.x_density = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `y_density` attribute.
    pub fn y_density<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.y_density = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `xmp_metadata` attribute.
    pub fn xmp_metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.xmp_metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute encode_jpeg.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        image: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "EncodeJpeg")?;

        // Required input arguments
        op.add_input(&image.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.format {
            op.set_attr_string("format", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.quality {
            op.set_attr_int("quality", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.progressive {
            op.set_attr_bool("progressive", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.optimize_size {
            op.set_attr_bool("optimize_size", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.chroma_downsampling {
            op.set_attr_bool("chroma_downsampling", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.density_unit {
            op.set_attr_string("density_unit", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.x_density {
            op.set_attr_int("x_density", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.y_density {
            op.set_attr_int("y_density", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.xmp_metadata {
            op.set_attr_string("xmp_metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `EncodeJpeg::new().call(&ctx, &image)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/EncodeJpeg>
pub fn encode_jpeg<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    image: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = EncodeJpeg::new();
    op.call(ctx, image)
}

/// EncodeJpegVariableQuality
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/EncodeJpegVariableQuality>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct EncodeJpegVariableQuality {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for EncodeJpegVariableQuality {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl EncodeJpegVariableQuality {
    /// Creates a new `EncodeJpegVariableQuality`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute encode_jpeg_variable_quality.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        images: &T0,
        quality: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "EncodeJpegVariableQuality")?;

        // Required input arguments
        op.add_input(&images.to_handle(ctx)?)?;
        op.add_input(&quality.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `EncodeJpegVariableQuality::new().call(&ctx, &images, &quality)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/EncodeJpegVariableQuality>
pub fn encode_jpeg_variable_quality<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    images: &T0,
    quality: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = EncodeJpegVariableQuality::new();
    op.call(ctx, images, quality)
}

/// EncodePng
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/EncodePng>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct EncodePng {
    compression: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for EncodePng {
    fn default() -> Self {
        Self {
            compression: Some(-1i64),
            target_device_name: None,
        }
    }
}
impl EncodePng {
    /// Creates a new `EncodePng`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `compression` attribute.
    pub fn compression<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.compression = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute encode_png.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        image: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "EncodePng")?;

        // Required input arguments
        op.add_input(&image.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.compression {
            op.set_attr_int("compression", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `EncodePng::new().call(&ctx, &image)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/EncodePng>
pub fn encode_png<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    image: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = EncodePng::new();
    op.call(ctx, image)
}

/// EncodeProto
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/EncodeProto>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct EncodeProto {
    field_names: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    message_type: ::std::option::Option<::std::string::String>,
    descriptor_source: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for EncodeProto {
    fn default() -> Self {
        Self {
            field_names: None,
            message_type: None,
            descriptor_source: Some(::std::string::String::from("local://")),
            target_device_name: None,
        }
    }
}
impl EncodeProto {
    /// Creates a new `EncodeProto`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `field_names` attribute.
    pub fn field_names<ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.field_names = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `message_type` attribute.
    pub fn message_type<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.message_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `descriptor_source` attribute.
    pub fn descriptor_source<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.descriptor_source = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute encode_proto.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        sizes: &T0,
        values: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "EncodeProto")?;

        // Required input arguments
        op.add_input(&sizes.to_handle(ctx)?)?;
        op.add_input(&values.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.field_names {
            op.set_attr_string_list("field_names", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.message_type {
            op.set_attr_string("message_type", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.descriptor_source {
            op.set_attr_string("descriptor_source", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `EncodeProto::new().call(&ctx, &sizes, &values)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/EncodeProto>
pub fn encode_proto<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    sizes: &T0,
    values: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = EncodeProto::new();
    op.call(ctx, sizes, values)
}

/// EncodeWav
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/EncodeWav>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct EncodeWav {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for EncodeWav {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl EncodeWav {
    /// Creates a new `EncodeWav`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute encode_wav.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        audio: &T0,
        sample_rate: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "EncodeWav")?;

        // Required input arguments
        op.add_input(&audio.to_handle(ctx)?)?;
        op.add_input(&sample_rate.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `EncodeWav::new().call(&ctx, &audio, &sample_rate)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/EncodeWav>
pub fn encode_wav<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    audio: &T0,
    sample_rate: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = EncodeWav::new();
    op.call(ctx, audio, sample_rate)
}

/// EnqueueTPUEmbeddingArbitraryTensorBatch
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/EnqueueTPUEmbeddingArbitraryTensorBatch>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct EnqueueTPUEmbeddingArbitraryTensorBatch {
    device_ordinal: ::std::option::Option<i64>,
    combiners: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for EnqueueTPUEmbeddingArbitraryTensorBatch {
    fn default() -> Self {
        Self {
            device_ordinal: Some(-1i64),
            combiners: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl EnqueueTPUEmbeddingArbitraryTensorBatch {
    /// Creates a new `EnqueueTPUEmbeddingArbitraryTensorBatch`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `device_ordinal` attribute.
    pub fn device_ordinal<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.device_ordinal = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `combiners` attribute.
    pub fn combiners<ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.combiners = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute enqueue_tpuembedding_arbitrary_tensor_batch.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        sample_indices_or_row_splits: &[&T0],
        embedding_indices: &[&T1],
        aggregation_weights: &[&T2],
        mode_override: &T3,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "EnqueueTPUEmbeddingArbitraryTensorBatch")?;

        // Required input arguments
        let mut sample_indices_or_row_splits_list = Vec::new();

        for t in sample_indices_or_row_splits {
            sample_indices_or_row_splits_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&sample_indices_or_row_splits_list)?;
        let mut embedding_indices_list = Vec::new();

        for t in embedding_indices {
            embedding_indices_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&embedding_indices_list)?;
        let mut aggregation_weights_list = Vec::new();

        for t in aggregation_weights {
            aggregation_weights_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&aggregation_weights_list)?;
        op.add_input(&mode_override.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.device_ordinal {
            op.set_attr_int("device_ordinal", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.combiners {
            op.set_attr_string_list("combiners", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `EnqueueTPUEmbeddingArbitraryTensorBatch::new().call(&ctx, &sample_indices_or_row_splits, &embedding_indices, &aggregation_weights, &mode_override)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/EnqueueTPUEmbeddingArbitraryTensorBatch>
pub fn enqueue_tpuembedding_arbitrary_tensor_batch<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    sample_indices_or_row_splits: &[&T0],
    embedding_indices: &[&T1],
    aggregation_weights: &[&T2],
    mode_override: &T3,
) -> crate::Result<()> {
    let op = EnqueueTPUEmbeddingArbitraryTensorBatch::new();
    op.call(
        ctx,
        sample_indices_or_row_splits,
        embedding_indices,
        aggregation_weights,
        mode_override,
    )
}

/// EnqueueTPUEmbeddingBatch
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/EnqueueTPUEmbeddingBatch>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct EnqueueTPUEmbeddingBatch {
    device_ordinal: ::std::option::Option<i64>,
    combiners: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for EnqueueTPUEmbeddingBatch {
    fn default() -> Self {
        Self {
            device_ordinal: Some(-1i64),
            combiners: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl EnqueueTPUEmbeddingBatch {
    /// Creates a new `EnqueueTPUEmbeddingBatch`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `device_ordinal` attribute.
    pub fn device_ordinal<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.device_ordinal = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `combiners` attribute.
    pub fn combiners<ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.combiners = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute enqueue_tpuembedding_batch.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        batch: &[&T0],
        mode_override: &T1,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "EnqueueTPUEmbeddingBatch")?;

        // Required input arguments
        let mut batch_list = Vec::new();

        for t in batch {
            batch_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&batch_list)?;
        op.add_input(&mode_override.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.device_ordinal {
            op.set_attr_int("device_ordinal", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.combiners {
            op.set_attr_string_list("combiners", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `EnqueueTPUEmbeddingBatch::new().call(&ctx, &batch, &mode_override)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/EnqueueTPUEmbeddingBatch>
pub fn enqueue_tpuembedding_batch<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    batch: &[&T0],
    mode_override: &T1,
) -> crate::Result<()> {
    let op = EnqueueTPUEmbeddingBatch::new();
    op.call(ctx, batch, mode_override)
}

/// EnqueueTPUEmbeddingIntegerBatch
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/EnqueueTPUEmbeddingIntegerBatch>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct EnqueueTPUEmbeddingIntegerBatch {
    device_ordinal: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for EnqueueTPUEmbeddingIntegerBatch {
    fn default() -> Self {
        Self {
            device_ordinal: Some(-1i64),
            target_device_name: None,
        }
    }
}
impl EnqueueTPUEmbeddingIntegerBatch {
    /// Creates a new `EnqueueTPUEmbeddingIntegerBatch`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `device_ordinal` attribute.
    pub fn device_ordinal<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.device_ordinal = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute enqueue_tpuembedding_integer_batch.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        batch: &[&T0],
        mode_override: &T1,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "EnqueueTPUEmbeddingIntegerBatch")?;

        // Required input arguments
        let mut batch_list = Vec::new();

        for t in batch {
            batch_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&batch_list)?;
        op.add_input(&mode_override.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.device_ordinal {
            op.set_attr_int("device_ordinal", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `EnqueueTPUEmbeddingIntegerBatch::new().call(&ctx, &batch, &mode_override)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/EnqueueTPUEmbeddingIntegerBatch>
pub fn enqueue_tpuembedding_integer_batch<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    batch: &[&T0],
    mode_override: &T1,
) -> crate::Result<()> {
    let op = EnqueueTPUEmbeddingIntegerBatch::new();
    op.call(ctx, batch, mode_override)
}

/// EnqueueTPUEmbeddingRaggedTensorBatch
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/EnqueueTPUEmbeddingRaggedTensorBatch>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct EnqueueTPUEmbeddingRaggedTensorBatch {
    device_ordinal: ::std::option::Option<i64>,
    combiners: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    table_ids: ::std::option::Option<::std::vec::Vec<i64>>,
    max_sequence_lengths: ::std::option::Option<::std::vec::Vec<i64>>,
    num_features: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for EnqueueTPUEmbeddingRaggedTensorBatch {
    fn default() -> Self {
        Self {
            device_ordinal: Some(-1i64),
            combiners: Some(vec![]),
            table_ids: None,
            max_sequence_lengths: Some(vec![]),
            num_features: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl EnqueueTPUEmbeddingRaggedTensorBatch {
    /// Creates a new `EnqueueTPUEmbeddingRaggedTensorBatch`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `device_ordinal` attribute.
    pub fn device_ordinal<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.device_ordinal = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `combiners` attribute.
    pub fn combiners<ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.combiners = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `table_ids` attribute.
    pub fn table_ids<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.table_ids = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `max_sequence_lengths` attribute.
    pub fn max_sequence_lengths<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.max_sequence_lengths = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_features` attribute.
    pub fn num_features<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.num_features = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute enqueue_tpuembedding_ragged_tensor_batch.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        sample_splits: &[&T0],
        embedding_indices: &[&T1],
        aggregation_weights: &[&T2],
        mode_override: &T3,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "EnqueueTPUEmbeddingRaggedTensorBatch")?;

        // Required input arguments
        let mut sample_splits_list = Vec::new();

        for t in sample_splits {
            sample_splits_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&sample_splits_list)?;
        let mut embedding_indices_list = Vec::new();

        for t in embedding_indices {
            embedding_indices_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&embedding_indices_list)?;
        let mut aggregation_weights_list = Vec::new();

        for t in aggregation_weights {
            aggregation_weights_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&aggregation_weights_list)?;
        op.add_input(&mode_override.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.device_ordinal {
            op.set_attr_int("device_ordinal", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.combiners {
            op.set_attr_string_list("combiners", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.table_ids {
            op.set_attr_int_list("table_ids", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.max_sequence_lengths {
            op.set_attr_int_list("max_sequence_lengths", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_features {
            op.set_attr_int_list("num_features", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `EnqueueTPUEmbeddingRaggedTensorBatch::new().call(&ctx, &sample_splits, &embedding_indices, &aggregation_weights, &mode_override)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/EnqueueTPUEmbeddingRaggedTensorBatch>
pub fn enqueue_tpuembedding_ragged_tensor_batch<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    sample_splits: &[&T0],
    embedding_indices: &[&T1],
    aggregation_weights: &[&T2],
    mode_override: &T3,
) -> crate::Result<()> {
    let op = EnqueueTPUEmbeddingRaggedTensorBatch::new();
    op.call(
        ctx,
        sample_splits,
        embedding_indices,
        aggregation_weights,
        mode_override,
    )
}

/// EnqueueTPUEmbeddingSparseBatch
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/EnqueueTPUEmbeddingSparseBatch>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct EnqueueTPUEmbeddingSparseBatch {
    device_ordinal: ::std::option::Option<i64>,
    combiners: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for EnqueueTPUEmbeddingSparseBatch {
    fn default() -> Self {
        Self {
            device_ordinal: Some(-1i64),
            combiners: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl EnqueueTPUEmbeddingSparseBatch {
    /// Creates a new `EnqueueTPUEmbeddingSparseBatch`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `device_ordinal` attribute.
    pub fn device_ordinal<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.device_ordinal = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `combiners` attribute.
    pub fn combiners<ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.combiners = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute enqueue_tpuembedding_sparse_batch.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        sample_indices: &[&T0],
        embedding_indices: &[&T1],
        aggregation_weights: &[&T2],
        mode_override: &T3,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "EnqueueTPUEmbeddingSparseBatch")?;

        // Required input arguments
        let mut sample_indices_list = Vec::new();

        for t in sample_indices {
            sample_indices_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&sample_indices_list)?;
        let mut embedding_indices_list = Vec::new();

        for t in embedding_indices {
            embedding_indices_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&embedding_indices_list)?;
        let mut aggregation_weights_list = Vec::new();

        for t in aggregation_weights {
            aggregation_weights_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&aggregation_weights_list)?;
        op.add_input(&mode_override.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.device_ordinal {
            op.set_attr_int("device_ordinal", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.combiners {
            op.set_attr_string_list("combiners", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `EnqueueTPUEmbeddingSparseBatch::new().call(&ctx, &sample_indices, &embedding_indices, &aggregation_weights, &mode_override)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/EnqueueTPUEmbeddingSparseBatch>
pub fn enqueue_tpuembedding_sparse_batch<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    sample_indices: &[&T0],
    embedding_indices: &[&T1],
    aggregation_weights: &[&T2],
    mode_override: &T3,
) -> crate::Result<()> {
    let op = EnqueueTPUEmbeddingSparseBatch::new();
    op.call(
        ctx,
        sample_indices,
        embedding_indices,
        aggregation_weights,
        mode_override,
    )
}

/// EnqueueTPUEmbeddingSparseTensorBatch
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/EnqueueTPUEmbeddingSparseTensorBatch>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct EnqueueTPUEmbeddingSparseTensorBatch {
    device_ordinal: ::std::option::Option<i64>,
    combiners: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    table_ids: ::std::option::Option<::std::vec::Vec<i64>>,
    max_sequence_lengths: ::std::option::Option<::std::vec::Vec<i64>>,
    num_features: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for EnqueueTPUEmbeddingSparseTensorBatch {
    fn default() -> Self {
        Self {
            device_ordinal: Some(-1i64),
            combiners: Some(vec![]),
            table_ids: None,
            max_sequence_lengths: Some(vec![]),
            num_features: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl EnqueueTPUEmbeddingSparseTensorBatch {
    /// Creates a new `EnqueueTPUEmbeddingSparseTensorBatch`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `device_ordinal` attribute.
    pub fn device_ordinal<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.device_ordinal = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `combiners` attribute.
    pub fn combiners<ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.combiners = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `table_ids` attribute.
    pub fn table_ids<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.table_ids = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `max_sequence_lengths` attribute.
    pub fn max_sequence_lengths<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.max_sequence_lengths = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_features` attribute.
    pub fn num_features<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.num_features = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute enqueue_tpuembedding_sparse_tensor_batch.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        sample_indices: &[&T0],
        embedding_indices: &[&T1],
        aggregation_weights: &[&T2],
        mode_override: &T3,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "EnqueueTPUEmbeddingSparseTensorBatch")?;

        // Required input arguments
        let mut sample_indices_list = Vec::new();

        for t in sample_indices {
            sample_indices_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&sample_indices_list)?;
        let mut embedding_indices_list = Vec::new();

        for t in embedding_indices {
            embedding_indices_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&embedding_indices_list)?;
        let mut aggregation_weights_list = Vec::new();

        for t in aggregation_weights {
            aggregation_weights_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&aggregation_weights_list)?;
        op.add_input(&mode_override.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.device_ordinal {
            op.set_attr_int("device_ordinal", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.combiners {
            op.set_attr_string_list("combiners", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.table_ids {
            op.set_attr_int_list("table_ids", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.max_sequence_lengths {
            op.set_attr_int_list("max_sequence_lengths", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_features {
            op.set_attr_int_list("num_features", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `EnqueueTPUEmbeddingSparseTensorBatch::new().call(&ctx, &sample_indices, &embedding_indices, &aggregation_weights, &mode_override)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/EnqueueTPUEmbeddingSparseTensorBatch>
pub fn enqueue_tpuembedding_sparse_tensor_batch<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    sample_indices: &[&T0],
    embedding_indices: &[&T1],
    aggregation_weights: &[&T2],
    mode_override: &T3,
) -> crate::Result<()> {
    let op = EnqueueTPUEmbeddingSparseTensorBatch::new();
    op.call(
        ctx,
        sample_indices,
        embedding_indices,
        aggregation_weights,
        mode_override,
    )
}

/// EnsureShape
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/EnsureShape>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct EnsureShape {
    shape: ::std::option::Option<crate::Shape>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for EnsureShape {
    fn default() -> Self {
        Self {
            shape: None,
            target_device_name: None,
        }
    }
}
impl EnsureShape {
    /// Creates a new `EnsureShape`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `shape` attribute.
    pub fn shape<ArgType: ::std::convert::Into<crate::Shape>>(mut self, value: ArgType) -> Self {
        self.shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute ensure_shape.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "EnsureShape")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.shape {
            op.set_attr_shape("shape", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `EnsureShape::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/EnsureShape>
pub fn ensure_shape<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = EnsureShape::new();
    op.call(ctx, input)
}

/// Enter
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Enter>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Enter {
    frame_name: ::std::option::Option<::std::string::String>,
    is_constant: ::std::option::Option<bool>,
    parallel_iterations: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Enter {
    fn default() -> Self {
        Self {
            frame_name: None,
            is_constant: Some(false),
            parallel_iterations: Some(10i64),
            target_device_name: None,
        }
    }
}
impl Enter {
    /// Creates a new `Enter`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `frame_name` attribute.
    pub fn frame_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.frame_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `is_constant` attribute.
    pub fn is_constant<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.is_constant = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `parallel_iterations` attribute.
    pub fn parallel_iterations<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.parallel_iterations = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute enter.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        data: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Enter")?;

        // Required input arguments
        op.add_input(&data.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.frame_name {
            op.set_attr_string("frame_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.is_constant {
            op.set_attr_bool("is_constant", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.parallel_iterations {
            op.set_attr_int("parallel_iterations", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Enter::new().call(&ctx, &data)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Enter>
pub fn enter<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    data: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Enter::new();
    op.call(ctx, data)
}

/// Equal
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Equal>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Equal {
    incompatible_shape_error: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Equal {
    fn default() -> Self {
        Self {
            incompatible_shape_error: Some(true),
            target_device_name: None,
        }
    }
}
impl Equal {
    /// Creates a new `Equal`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `incompatible_shape_error` attribute.
    pub fn incompatible_shape_error<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.incompatible_shape_error = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute equal.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Equal")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.incompatible_shape_error {
            op.set_attr_bool("incompatible_shape_error", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Equal::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Equal>
pub fn equal<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Equal::new();
    op.call(ctx, x, y)
}

/// Erf
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Erf>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Erf {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Erf {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Erf {
    /// Creates a new `Erf`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute erf.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Erf")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Erf::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Erf>
pub fn erf<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Erf::new();
    op.call(ctx, x)
}

/// Erfc
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Erfc>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Erfc {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Erfc {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Erfc {
    /// Creates a new `Erfc`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute erfc.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Erfc")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Erfc::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Erfc>
pub fn erfc<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Erfc::new();
    op.call(ctx, x)
}

/// Erfinv
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Erfinv>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Erfinv {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Erfinv {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Erfinv {
    /// Creates a new `Erfinv`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute erfinv.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Erfinv")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Erfinv::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Erfinv>
pub fn erfinv<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Erfinv::new();
    op.call(ctx, x)
}

/// EuclideanNorm
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/EuclideanNorm>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct EuclideanNorm {
    keep_dims: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for EuclideanNorm {
    fn default() -> Self {
        Self {
            keep_dims: Some(false),
            target_device_name: None,
        }
    }
}
impl EuclideanNorm {
    /// Creates a new `EuclideanNorm`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `keep_dims` attribute.
    pub fn keep_dims<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.keep_dims = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute euclidean_norm.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        reduction_indices: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "EuclideanNorm")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&reduction_indices.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.keep_dims {
            op.set_attr_bool("keep_dims", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `EuclideanNorm::new().call(&ctx, &input, &reduction_indices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/EuclideanNorm>
pub fn euclidean_norm<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    reduction_indices: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = EuclideanNorm::new();
    op.call(ctx, input, reduction_indices)
}

/// ExecuteTPUEmbeddingPartitioner
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExecuteTPUEmbeddingPartitioner>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExecuteTPUEmbeddingPartitioner {
    config: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExecuteTPUEmbeddingPartitioner {
    fn default() -> Self {
        Self {
            config: None,
            target_device_name: None,
        }
    }
}
impl ExecuteTPUEmbeddingPartitioner {
    /// Creates a new `ExecuteTPUEmbeddingPartitioner`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute execute_tpuembedding_partitioner.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExecuteTPUEmbeddingPartitioner")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExecuteTPUEmbeddingPartitioner::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExecuteTPUEmbeddingPartitioner>
pub fn execute_tpuembedding_partitioner<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExecuteTPUEmbeddingPartitioner::new();
    op.call(ctx)
}

/// Exit
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Exit>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Exit {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Exit {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Exit {
    /// Creates a new `Exit`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute exit.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        data: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Exit")?;

        // Required input arguments
        op.add_input(&data.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Exit::new().call(&ctx, &data)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Exit>
pub fn exit<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    data: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Exit::new();
    op.call(ctx, data)
}

/// Exp
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Exp>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Exp {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Exp {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Exp {
    /// Creates a new `Exp`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute exp.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Exp")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Exp::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Exp>
pub fn exp<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Exp::new();
    op.call(ctx, x)
}

/// ExpandDims
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExpandDims>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExpandDims {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExpandDims {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ExpandDims {
    /// Creates a new `ExpandDims`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute expand_dims.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        dim: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExpandDims")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&dim.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExpandDims::new().call(&ctx, &input, &dim)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExpandDims>
pub fn expand_dims<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    dim: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExpandDims::new();
    op.call(ctx, input, dim)
}

/// ExperimentalAssertNextDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalAssertNextDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExperimentalAssertNextDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExperimentalAssertNextDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl ExperimentalAssertNextDataset {
    /// Creates a new `ExperimentalAssertNextDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute experimental_assert_next_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        transformations: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExperimentalAssertNextDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&transformations.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExperimentalAssertNextDataset::new().call(&ctx, &input_dataset, &transformations)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalAssertNextDataset>
pub fn experimental_assert_next_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    transformations: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExperimentalAssertNextDataset::new();
    op.call(ctx, input_dataset, transformations)
}

/// ExperimentalAutoShardDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalAutoShardDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExperimentalAutoShardDataset {
    auto_shard_policy: ::std::option::Option<i64>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExperimentalAutoShardDataset {
    fn default() -> Self {
        Self {
            auto_shard_policy: Some(0i64),
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl ExperimentalAutoShardDataset {
    /// Creates a new `ExperimentalAutoShardDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `auto_shard_policy` attribute.
    pub fn auto_shard_policy<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.auto_shard_policy = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute experimental_auto_shard_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        num_workers: &T1,
        index: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExperimentalAutoShardDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&num_workers.to_handle(ctx)?)?;
        op.add_input(&index.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.auto_shard_policy {
            op.set_attr_int("auto_shard_policy", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExperimentalAutoShardDataset::new().call(&ctx, &input_dataset, &num_workers, &index)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalAutoShardDataset>
pub fn experimental_auto_shard_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    num_workers: &T1,
    index: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExperimentalAutoShardDataset::new();
    op.call(ctx, input_dataset, num_workers, index)
}

/// ExperimentalBytesProducedStatsDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalBytesProducedStatsDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExperimentalBytesProducedStatsDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExperimentalBytesProducedStatsDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl ExperimentalBytesProducedStatsDataset {
    /// Creates a new `ExperimentalBytesProducedStatsDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute experimental_bytes_produced_stats_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        tag: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExperimentalBytesProducedStatsDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&tag.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExperimentalBytesProducedStatsDataset::new().call(&ctx, &input_dataset, &tag)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalBytesProducedStatsDataset>
pub fn experimental_bytes_produced_stats_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    tag: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExperimentalBytesProducedStatsDataset::new();
    op.call(ctx, input_dataset, tag)
}

/// ExperimentalCSVDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalCSVDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExperimentalCSVDataset {
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExperimentalCSVDataset {
    fn default() -> Self {
        Self {
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl ExperimentalCSVDataset {
    /// Creates a new `ExperimentalCSVDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute experimental_csvdataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        filenames: &T0,
        compression_type: &T1,
        buffer_size: &T2,
        header: &T3,
        field_delim: &T4,
        use_quote_delim: &T5,
        na_value: &T6,
        select_cols: &T7,
        record_defaults: &T8,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExperimentalCSVDataset")?;

        // Required input arguments
        op.add_input(&filenames.to_handle(ctx)?)?;
        op.add_input(&compression_type.to_handle(ctx)?)?;
        op.add_input(&buffer_size.to_handle(ctx)?)?;
        op.add_input(&header.to_handle(ctx)?)?;
        op.add_input(&field_delim.to_handle(ctx)?)?;
        op.add_input(&use_quote_delim.to_handle(ctx)?)?;
        op.add_input(&na_value.to_handle(ctx)?)?;
        op.add_input(&select_cols.to_handle(ctx)?)?;
        op.add_input(&record_defaults.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExperimentalCSVDataset::new().call(&ctx, &filenames, &compression_type, &buffer_size, &header, &field_delim, &use_quote_delim, &na_value, &select_cols, &record_defaults)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalCSVDataset>
pub fn experimental_csvdataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    filenames: &T0,
    compression_type: &T1,
    buffer_size: &T2,
    header: &T3,
    field_delim: &T4,
    use_quote_delim: &T5,
    na_value: &T6,
    select_cols: &T7,
    record_defaults: &T8,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExperimentalCSVDataset::new();
    op.call(
        ctx,
        filenames,
        compression_type,
        buffer_size,
        header,
        field_delim,
        use_quote_delim,
        na_value,
        select_cols,
        record_defaults,
    )
}

/// ExperimentalChooseFastestDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalChooseFastestDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExperimentalChooseFastestDataset {
    num_experiments: ::std::option::Option<i64>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExperimentalChooseFastestDataset {
    fn default() -> Self {
        Self {
            num_experiments: None,
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl ExperimentalChooseFastestDataset {
    /// Creates a new `ExperimentalChooseFastestDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_experiments` attribute.
    pub fn num_experiments<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_experiments = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute experimental_choose_fastest_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_datasets: &[&T0],
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExperimentalChooseFastestDataset")?;

        // Required input arguments
        let mut input_datasets_list = Vec::new();

        for t in input_datasets {
            input_datasets_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&input_datasets_list)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_experiments {
            op.set_attr_int("num_experiments", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExperimentalChooseFastestDataset::new().call(&ctx, &input_datasets)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalChooseFastestDataset>
pub fn experimental_choose_fastest_dataset<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input_datasets: &[&T0],
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExperimentalChooseFastestDataset::new();
    op.call(ctx, input_datasets)
}

/// ExperimentalDatasetCardinality
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalDatasetCardinality>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExperimentalDatasetCardinality {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExperimentalDatasetCardinality {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ExperimentalDatasetCardinality {
    /// Creates a new `ExperimentalDatasetCardinality`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute experimental_dataset_cardinality.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExperimentalDatasetCardinality")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExperimentalDatasetCardinality::new().call(&ctx, &input_dataset)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalDatasetCardinality>
pub fn experimental_dataset_cardinality<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExperimentalDatasetCardinality::new();
    op.call(ctx, input_dataset)
}

/// ExperimentalDatasetToTFRecord
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalDatasetToTFRecord>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExperimentalDatasetToTFRecord {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExperimentalDatasetToTFRecord {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ExperimentalDatasetToTFRecord {
    /// Creates a new `ExperimentalDatasetToTFRecord`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute experimental_dataset_to_tfrecord.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        filename: &T1,
        compression_type: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExperimentalDatasetToTFRecord")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&filename.to_handle(ctx)?)?;
        op.add_input(&compression_type.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ExperimentalDatasetToTFRecord::new().call(&ctx, &input_dataset, &filename, &compression_type)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalDatasetToTFRecord>
pub fn experimental_dataset_to_tfrecord<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    filename: &T1,
    compression_type: &T2,
) -> crate::Result<()> {
    let op = ExperimentalDatasetToTFRecord::new();
    op.call(ctx, input_dataset, filename, compression_type)
}

/// ExperimentalDenseToSparseBatchDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalDenseToSparseBatchDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExperimentalDenseToSparseBatchDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExperimentalDenseToSparseBatchDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl ExperimentalDenseToSparseBatchDataset {
    /// Creates a new `ExperimentalDenseToSparseBatchDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute experimental_dense_to_sparse_batch_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        batch_size: &T1,
        row_shape: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExperimentalDenseToSparseBatchDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&batch_size.to_handle(ctx)?)?;
        op.add_input(&row_shape.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExperimentalDenseToSparseBatchDataset::new().call(&ctx, &input_dataset, &batch_size, &row_shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalDenseToSparseBatchDataset>
pub fn experimental_dense_to_sparse_batch_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    batch_size: &T1,
    row_shape: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExperimentalDenseToSparseBatchDataset::new();
    op.call(ctx, input_dataset, batch_size, row_shape)
}

/// ExperimentalDirectedInterleaveDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalDirectedInterleaveDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExperimentalDirectedInterleaveDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExperimentalDirectedInterleaveDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl ExperimentalDirectedInterleaveDataset {
    /// Creates a new `ExperimentalDirectedInterleaveDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute experimental_directed_interleave_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        selector_input_dataset: &T0,
        data_input_datasets: &[&T1],
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExperimentalDirectedInterleaveDataset")?;

        // Required input arguments
        op.add_input(&selector_input_dataset.to_handle(ctx)?)?;
        let mut data_input_datasets_list = Vec::new();

        for t in data_input_datasets {
            data_input_datasets_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&data_input_datasets_list)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExperimentalDirectedInterleaveDataset::new().call(&ctx, &selector_input_dataset, &data_input_datasets)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalDirectedInterleaveDataset>
pub fn experimental_directed_interleave_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    selector_input_dataset: &T0,
    data_input_datasets: &[&T1],
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExperimentalDirectedInterleaveDataset::new();
    op.call(ctx, selector_input_dataset, data_input_datasets)
}

/// ExperimentalGroupByReducerDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalGroupByReducerDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExperimentalGroupByReducerDataset {
    key_func: ::std::option::Option<::std::string::String>,
    init_func: ::std::option::Option<::std::string::String>,
    reduce_func: ::std::option::Option<::std::string::String>,
    finalize_func: ::std::option::Option<::std::string::String>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExperimentalGroupByReducerDataset {
    fn default() -> Self {
        Self {
            key_func: None,
            init_func: None,
            reduce_func: None,
            finalize_func: None,
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl ExperimentalGroupByReducerDataset {
    /// Creates a new `ExperimentalGroupByReducerDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `key_func` attribute.
    pub fn key_func<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.key_func = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `init_func` attribute.
    pub fn init_func<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.init_func = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `reduce_func` attribute.
    pub fn reduce_func<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.reduce_func = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `finalize_func` attribute.
    pub fn finalize_func<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.finalize_func = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute experimental_group_by_reducer_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        key_func_other_arguments: &T1,
        init_func_other_arguments: &T2,
        reduce_func_other_arguments: &T3,
        finalize_func_other_arguments: &T4,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExperimentalGroupByReducerDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&key_func_other_arguments.to_handle(ctx)?)?;
        op.add_input(&init_func_other_arguments.to_handle(ctx)?)?;
        op.add_input(&reduce_func_other_arguments.to_handle(ctx)?)?;
        op.add_input(&finalize_func_other_arguments.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.key_func {
            op.set_attr_string("key_func", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.init_func {
            op.set_attr_string("init_func", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.reduce_func {
            op.set_attr_string("reduce_func", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.finalize_func {
            op.set_attr_string("finalize_func", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExperimentalGroupByReducerDataset::new().call(&ctx, &input_dataset, &key_func_other_arguments, &init_func_other_arguments, &reduce_func_other_arguments, &finalize_func_other_arguments)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalGroupByReducerDataset>
pub fn experimental_group_by_reducer_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    key_func_other_arguments: &T1,
    init_func_other_arguments: &T2,
    reduce_func_other_arguments: &T3,
    finalize_func_other_arguments: &T4,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExperimentalGroupByReducerDataset::new();
    op.call(
        ctx,
        input_dataset,
        key_func_other_arguments,
        init_func_other_arguments,
        reduce_func_other_arguments,
        finalize_func_other_arguments,
    )
}

/// ExperimentalGroupByWindowDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalGroupByWindowDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExperimentalGroupByWindowDataset {
    key_func: ::std::option::Option<::std::string::String>,
    reduce_func: ::std::option::Option<::std::string::String>,
    window_size_func: ::std::option::Option<::std::string::String>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExperimentalGroupByWindowDataset {
    fn default() -> Self {
        Self {
            key_func: None,
            reduce_func: None,
            window_size_func: None,
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl ExperimentalGroupByWindowDataset {
    /// Creates a new `ExperimentalGroupByWindowDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `key_func` attribute.
    pub fn key_func<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.key_func = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `reduce_func` attribute.
    pub fn reduce_func<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.reduce_func = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `window_size_func` attribute.
    pub fn window_size_func<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.window_size_func = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute experimental_group_by_window_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        key_func_other_arguments: &T1,
        reduce_func_other_arguments: &T2,
        window_size_func_other_arguments: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExperimentalGroupByWindowDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&key_func_other_arguments.to_handle(ctx)?)?;
        op.add_input(&reduce_func_other_arguments.to_handle(ctx)?)?;
        op.add_input(&window_size_func_other_arguments.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.key_func {
            op.set_attr_string("key_func", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.reduce_func {
            op.set_attr_string("reduce_func", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.window_size_func {
            op.set_attr_string("window_size_func", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExperimentalGroupByWindowDataset::new().call(&ctx, &input_dataset, &key_func_other_arguments, &reduce_func_other_arguments, &window_size_func_other_arguments)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalGroupByWindowDataset>
pub fn experimental_group_by_window_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    key_func_other_arguments: &T1,
    reduce_func_other_arguments: &T2,
    window_size_func_other_arguments: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExperimentalGroupByWindowDataset::new();
    op.call(
        ctx,
        input_dataset,
        key_func_other_arguments,
        reduce_func_other_arguments,
        window_size_func_other_arguments,
    )
}

/// ExperimentalIgnoreErrorsDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalIgnoreErrorsDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExperimentalIgnoreErrorsDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    log_warning: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExperimentalIgnoreErrorsDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            log_warning: Some(false),
            target_device_name: None,
        }
    }
}
impl ExperimentalIgnoreErrorsDataset {
    /// Creates a new `ExperimentalIgnoreErrorsDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `log_warning` attribute.
    pub fn log_warning<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.log_warning = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute experimental_ignore_errors_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExperimentalIgnoreErrorsDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.log_warning {
            op.set_attr_bool("log_warning", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExperimentalIgnoreErrorsDataset::new().call(&ctx, &input_dataset)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalIgnoreErrorsDataset>
pub fn experimental_ignore_errors_dataset<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExperimentalIgnoreErrorsDataset::new();
    op.call(ctx, input_dataset)
}

/// ExperimentalIteratorGetDevice
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalIteratorGetDevice>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExperimentalIteratorGetDevice {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExperimentalIteratorGetDevice {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ExperimentalIteratorGetDevice {
    /// Creates a new `ExperimentalIteratorGetDevice`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute experimental_iterator_get_device.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        resource: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExperimentalIteratorGetDevice")?;

        // Required input arguments
        op.add_input(&resource.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExperimentalIteratorGetDevice::new().call(&ctx, &resource)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalIteratorGetDevice>
pub fn experimental_iterator_get_device<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    resource: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExperimentalIteratorGetDevice::new();
    op.call(ctx, resource)
}

/// ExperimentalLMDBDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalLMDBDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExperimentalLMDBDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExperimentalLMDBDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl ExperimentalLMDBDataset {
    /// Creates a new `ExperimentalLMDBDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute experimental_lmdbdataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        filenames: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExperimentalLMDBDataset")?;

        // Required input arguments
        op.add_input(&filenames.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExperimentalLMDBDataset::new().call(&ctx, &filenames)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalLMDBDataset>
pub fn experimental_lmdbdataset<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    filenames: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExperimentalLMDBDataset::new();
    op.call(ctx, filenames)
}

/// ExperimentalLatencyStatsDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalLatencyStatsDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExperimentalLatencyStatsDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExperimentalLatencyStatsDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl ExperimentalLatencyStatsDataset {
    /// Creates a new `ExperimentalLatencyStatsDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute experimental_latency_stats_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        tag: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExperimentalLatencyStatsDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&tag.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExperimentalLatencyStatsDataset::new().call(&ctx, &input_dataset, &tag)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalLatencyStatsDataset>
pub fn experimental_latency_stats_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    tag: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExperimentalLatencyStatsDataset::new();
    op.call(ctx, input_dataset, tag)
}

/// ExperimentalMapAndBatchDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalMapAndBatchDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExperimentalMapAndBatchDataset {
    f: ::std::option::Option<::std::string::String>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    preserve_cardinality: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExperimentalMapAndBatchDataset {
    fn default() -> Self {
        Self {
            f: None,
            output_types: None,
            output_shapes: None,
            preserve_cardinality: Some(false),
            target_device_name: None,
        }
    }
}
impl ExperimentalMapAndBatchDataset {
    /// Creates a new `ExperimentalMapAndBatchDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `f` attribute.
    pub fn f<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.f = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `preserve_cardinality` attribute.
    pub fn preserve_cardinality<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.preserve_cardinality = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute experimental_map_and_batch_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        other_arguments: &T1,
        batch_size: &T2,
        num_parallel_calls: &T3,
        drop_remainder: &T4,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExperimentalMapAndBatchDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&other_arguments.to_handle(ctx)?)?;
        op.add_input(&batch_size.to_handle(ctx)?)?;
        op.add_input(&num_parallel_calls.to_handle(ctx)?)?;
        op.add_input(&drop_remainder.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.f {
            op.set_attr_string("f", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.preserve_cardinality {
            op.set_attr_bool("preserve_cardinality", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExperimentalMapAndBatchDataset::new().call(&ctx, &input_dataset, &other_arguments, &batch_size, &num_parallel_calls, &drop_remainder)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalMapAndBatchDataset>
pub fn experimental_map_and_batch_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    other_arguments: &T1,
    batch_size: &T2,
    num_parallel_calls: &T3,
    drop_remainder: &T4,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExperimentalMapAndBatchDataset::new();
    op.call(
        ctx,
        input_dataset,
        other_arguments,
        batch_size,
        num_parallel_calls,
        drop_remainder,
    )
}

/// ExperimentalMapDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalMapDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExperimentalMapDataset {
    f: ::std::option::Option<::std::string::String>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    use_inter_op_parallelism: ::std::option::Option<bool>,
    preserve_cardinality: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExperimentalMapDataset {
    fn default() -> Self {
        Self {
            f: None,
            output_types: None,
            output_shapes: None,
            use_inter_op_parallelism: Some(true),
            preserve_cardinality: Some(false),
            target_device_name: None,
        }
    }
}
impl ExperimentalMapDataset {
    /// Creates a new `ExperimentalMapDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `f` attribute.
    pub fn f<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.f = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_inter_op_parallelism` attribute.
    pub fn use_inter_op_parallelism<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.use_inter_op_parallelism = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `preserve_cardinality` attribute.
    pub fn preserve_cardinality<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.preserve_cardinality = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute experimental_map_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        other_arguments: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExperimentalMapDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&other_arguments.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.f {
            op.set_attr_string("f", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_inter_op_parallelism {
            op.set_attr_bool("use_inter_op_parallelism", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.preserve_cardinality {
            op.set_attr_bool("preserve_cardinality", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExperimentalMapDataset::new().call(&ctx, &input_dataset, &other_arguments)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalMapDataset>
pub fn experimental_map_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    other_arguments: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExperimentalMapDataset::new();
    op.call(ctx, input_dataset, other_arguments)
}

/// ExperimentalMatchingFilesDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalMatchingFilesDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExperimentalMatchingFilesDataset {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExperimentalMatchingFilesDataset {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ExperimentalMatchingFilesDataset {
    /// Creates a new `ExperimentalMatchingFilesDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute experimental_matching_files_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        patterns: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExperimentalMatchingFilesDataset")?;

        // Required input arguments
        op.add_input(&patterns.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExperimentalMatchingFilesDataset::new().call(&ctx, &patterns)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalMatchingFilesDataset>
pub fn experimental_matching_files_dataset<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    patterns: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExperimentalMatchingFilesDataset::new();
    op.call(ctx, patterns)
}

/// ExperimentalMaxIntraOpParallelismDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalMaxIntraOpParallelismDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExperimentalMaxIntraOpParallelismDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExperimentalMaxIntraOpParallelismDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl ExperimentalMaxIntraOpParallelismDataset {
    /// Creates a new `ExperimentalMaxIntraOpParallelismDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute experimental_max_intra_op_parallelism_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        max_intra_op_parallelism: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExperimentalMaxIntraOpParallelismDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&max_intra_op_parallelism.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExperimentalMaxIntraOpParallelismDataset::new().call(&ctx, &input_dataset, &max_intra_op_parallelism)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalMaxIntraOpParallelismDataset>
pub fn experimental_max_intra_op_parallelism_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    max_intra_op_parallelism: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExperimentalMaxIntraOpParallelismDataset::new();
    op.call(ctx, input_dataset, max_intra_op_parallelism)
}

/// ExperimentalNonSerializableDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalNonSerializableDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExperimentalNonSerializableDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExperimentalNonSerializableDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl ExperimentalNonSerializableDataset {
    /// Creates a new `ExperimentalNonSerializableDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute experimental_non_serializable_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExperimentalNonSerializableDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExperimentalNonSerializableDataset::new().call(&ctx, &input_dataset)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalNonSerializableDataset>
pub fn experimental_non_serializable_dataset<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExperimentalNonSerializableDataset::new();
    op.call(ctx, input_dataset)
}

/// ExperimentalParallelInterleaveDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalParallelInterleaveDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExperimentalParallelInterleaveDataset {
    f: ::std::option::Option<::std::string::String>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExperimentalParallelInterleaveDataset {
    fn default() -> Self {
        Self {
            f: None,
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl ExperimentalParallelInterleaveDataset {
    /// Creates a new `ExperimentalParallelInterleaveDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `f` attribute.
    pub fn f<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.f = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute experimental_parallel_interleave_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        other_arguments: &T1,
        cycle_length: &T2,
        block_length: &T3,
        sloppy: &T4,
        buffer_output_elements: &T5,
        prefetch_input_elements: &T6,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExperimentalParallelInterleaveDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&other_arguments.to_handle(ctx)?)?;
        op.add_input(&cycle_length.to_handle(ctx)?)?;
        op.add_input(&block_length.to_handle(ctx)?)?;
        op.add_input(&sloppy.to_handle(ctx)?)?;
        op.add_input(&buffer_output_elements.to_handle(ctx)?)?;
        op.add_input(&prefetch_input_elements.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.f {
            op.set_attr_string("f", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExperimentalParallelInterleaveDataset::new().call(&ctx, &input_dataset, &other_arguments, &cycle_length, &block_length, &sloppy, &buffer_output_elements, &prefetch_input_elements)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalParallelInterleaveDataset>
pub fn experimental_parallel_interleave_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    other_arguments: &T1,
    cycle_length: &T2,
    block_length: &T3,
    sloppy: &T4,
    buffer_output_elements: &T5,
    prefetch_input_elements: &T6,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExperimentalParallelInterleaveDataset::new();
    op.call(
        ctx,
        input_dataset,
        other_arguments,
        cycle_length,
        block_length,
        sloppy,
        buffer_output_elements,
        prefetch_input_elements,
    )
}

/// ExperimentalParseExampleDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalParseExampleDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExperimentalParseExampleDataset {
    sparse_keys: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    dense_keys: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    sparse_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    dense_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    sloppy: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExperimentalParseExampleDataset {
    fn default() -> Self {
        Self {
            sparse_keys: None,
            dense_keys: None,
            sparse_types: None,
            dense_shapes: None,
            output_types: None,
            output_shapes: None,
            sloppy: Some(false),
            target_device_name: None,
        }
    }
}
impl ExperimentalParseExampleDataset {
    /// Creates a new `ExperimentalParseExampleDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `sparse_keys` attribute.
    pub fn sparse_keys<ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.sparse_keys = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dense_keys` attribute.
    pub fn dense_keys<ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dense_keys = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `sparse_types` attribute.
    pub fn sparse_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.sparse_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dense_shapes` attribute.
    pub fn dense_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dense_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `sloppy` attribute.
    pub fn sloppy<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.sloppy = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute experimental_parse_example_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        num_parallel_calls: &T1,
        dense_defaults: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExperimentalParseExampleDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&num_parallel_calls.to_handle(ctx)?)?;
        op.add_input(&dense_defaults.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.sparse_keys {
            op.set_attr_string_list("sparse_keys", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dense_keys {
            op.set_attr_string_list("dense_keys", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.sparse_types {
            op.set_attr_type_list("sparse_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dense_shapes {
            op.set_attr_shape_list("dense_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.sloppy {
            op.set_attr_bool("sloppy", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExperimentalParseExampleDataset::new().call(&ctx, &input_dataset, &num_parallel_calls, &dense_defaults)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalParseExampleDataset>
pub fn experimental_parse_example_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    num_parallel_calls: &T1,
    dense_defaults: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExperimentalParseExampleDataset::new();
    op.call(ctx, input_dataset, num_parallel_calls, dense_defaults)
}

/// ExperimentalPrivateThreadPoolDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalPrivateThreadPoolDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExperimentalPrivateThreadPoolDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExperimentalPrivateThreadPoolDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl ExperimentalPrivateThreadPoolDataset {
    /// Creates a new `ExperimentalPrivateThreadPoolDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute experimental_private_thread_pool_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        num_threads: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExperimentalPrivateThreadPoolDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&num_threads.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExperimentalPrivateThreadPoolDataset::new().call(&ctx, &input_dataset, &num_threads)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalPrivateThreadPoolDataset>
pub fn experimental_private_thread_pool_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    num_threads: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExperimentalPrivateThreadPoolDataset::new();
    op.call(ctx, input_dataset, num_threads)
}

/// ExperimentalRandomDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalRandomDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExperimentalRandomDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExperimentalRandomDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl ExperimentalRandomDataset {
    /// Creates a new `ExperimentalRandomDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute experimental_random_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        seed: &T0,
        seed2: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExperimentalRandomDataset")?;

        // Required input arguments
        op.add_input(&seed.to_handle(ctx)?)?;
        op.add_input(&seed2.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExperimentalRandomDataset::new().call(&ctx, &seed, &seed2)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalRandomDataset>
pub fn experimental_random_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    seed: &T0,
    seed2: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExperimentalRandomDataset::new();
    op.call(ctx, seed, seed2)
}

/// ExperimentalRebatchDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalRebatchDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExperimentalRebatchDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    use_fallback: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExperimentalRebatchDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            use_fallback: Some(true),
            target_device_name: None,
        }
    }
}
impl ExperimentalRebatchDataset {
    /// Creates a new `ExperimentalRebatchDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_fallback` attribute.
    pub fn use_fallback<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_fallback = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute experimental_rebatch_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        num_replicas: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExperimentalRebatchDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&num_replicas.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_fallback {
            op.set_attr_bool("use_fallback", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExperimentalRebatchDataset::new().call(&ctx, &input_dataset, &num_replicas)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalRebatchDataset>
pub fn experimental_rebatch_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    num_replicas: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExperimentalRebatchDataset::new();
    op.call(ctx, input_dataset, num_replicas)
}

/// ExperimentalScanDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalScanDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExperimentalScanDataset {
    f: ::std::option::Option<::std::string::String>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    preserve_cardinality: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExperimentalScanDataset {
    fn default() -> Self {
        Self {
            f: None,
            output_types: None,
            output_shapes: None,
            preserve_cardinality: Some(false),
            target_device_name: None,
        }
    }
}
impl ExperimentalScanDataset {
    /// Creates a new `ExperimentalScanDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `f` attribute.
    pub fn f<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.f = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `preserve_cardinality` attribute.
    pub fn preserve_cardinality<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.preserve_cardinality = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute experimental_scan_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        initial_state: &T1,
        other_arguments: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExperimentalScanDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&initial_state.to_handle(ctx)?)?;
        op.add_input(&other_arguments.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.f {
            op.set_attr_string("f", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.preserve_cardinality {
            op.set_attr_bool("preserve_cardinality", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExperimentalScanDataset::new().call(&ctx, &input_dataset, &initial_state, &other_arguments)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalScanDataset>
pub fn experimental_scan_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    initial_state: &T1,
    other_arguments: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExperimentalScanDataset::new();
    op.call(ctx, input_dataset, initial_state, other_arguments)
}

/// ExperimentalSetStatsAggregatorDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalSetStatsAggregatorDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExperimentalSetStatsAggregatorDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExperimentalSetStatsAggregatorDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl ExperimentalSetStatsAggregatorDataset {
    /// Creates a new `ExperimentalSetStatsAggregatorDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute experimental_set_stats_aggregator_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        stats_aggregator: &T1,
        tag: &T2,
        counter_prefix: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExperimentalSetStatsAggregatorDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&stats_aggregator.to_handle(ctx)?)?;
        op.add_input(&tag.to_handle(ctx)?)?;
        op.add_input(&counter_prefix.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExperimentalSetStatsAggregatorDataset::new().call(&ctx, &input_dataset, &stats_aggregator, &tag, &counter_prefix)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalSetStatsAggregatorDataset>
pub fn experimental_set_stats_aggregator_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    stats_aggregator: &T1,
    tag: &T2,
    counter_prefix: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExperimentalSetStatsAggregatorDataset::new();
    op.call(ctx, input_dataset, stats_aggregator, tag, counter_prefix)
}

/// ExperimentalSleepDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalSleepDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExperimentalSleepDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExperimentalSleepDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl ExperimentalSleepDataset {
    /// Creates a new `ExperimentalSleepDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute experimental_sleep_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        sleep_microseconds: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExperimentalSleepDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&sleep_microseconds.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExperimentalSleepDataset::new().call(&ctx, &input_dataset, &sleep_microseconds)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalSleepDataset>
pub fn experimental_sleep_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    sleep_microseconds: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExperimentalSleepDataset::new();
    op.call(ctx, input_dataset, sleep_microseconds)
}

/// ExperimentalSlidingWindowDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalSlidingWindowDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExperimentalSlidingWindowDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExperimentalSlidingWindowDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl ExperimentalSlidingWindowDataset {
    /// Creates a new `ExperimentalSlidingWindowDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute experimental_sliding_window_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        window_size: &T1,
        window_shift: &T2,
        window_stride: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExperimentalSlidingWindowDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&window_size.to_handle(ctx)?)?;
        op.add_input(&window_shift.to_handle(ctx)?)?;
        op.add_input(&window_stride.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExperimentalSlidingWindowDataset::new().call(&ctx, &input_dataset, &window_size, &window_shift, &window_stride)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalSlidingWindowDataset>
pub fn experimental_sliding_window_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    window_size: &T1,
    window_shift: &T2,
    window_stride: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExperimentalSlidingWindowDataset::new();
    op.call(ctx, input_dataset, window_size, window_shift, window_stride)
}

/// ExperimentalSqlDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalSqlDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExperimentalSqlDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExperimentalSqlDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl ExperimentalSqlDataset {
    /// Creates a new `ExperimentalSqlDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute experimental_sql_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        driver_name: &T0,
        data_source_name: &T1,
        query: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExperimentalSqlDataset")?;

        // Required input arguments
        op.add_input(&driver_name.to_handle(ctx)?)?;
        op.add_input(&data_source_name.to_handle(ctx)?)?;
        op.add_input(&query.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExperimentalSqlDataset::new().call(&ctx, &driver_name, &data_source_name, &query)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalSqlDataset>
pub fn experimental_sql_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    driver_name: &T0,
    data_source_name: &T1,
    query: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExperimentalSqlDataset::new();
    op.call(ctx, driver_name, data_source_name, query)
}

/// ExperimentalStatsAggregatorHandle
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalStatsAggregatorHandle>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExperimentalStatsAggregatorHandle {
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExperimentalStatsAggregatorHandle {
    fn default() -> Self {
        Self {
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl ExperimentalStatsAggregatorHandle {
    /// Creates a new `ExperimentalStatsAggregatorHandle`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute experimental_stats_aggregator_handle.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExperimentalStatsAggregatorHandle")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExperimentalStatsAggregatorHandle::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalStatsAggregatorHandle>
pub fn experimental_stats_aggregator_handle<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExperimentalStatsAggregatorHandle::new();
    op.call(ctx)
}

/// ExperimentalStatsAggregatorSummary
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalStatsAggregatorSummary>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExperimentalStatsAggregatorSummary {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExperimentalStatsAggregatorSummary {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ExperimentalStatsAggregatorSummary {
    /// Creates a new `ExperimentalStatsAggregatorSummary`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute experimental_stats_aggregator_summary.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        iterator: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExperimentalStatsAggregatorSummary")?;

        // Required input arguments
        op.add_input(&iterator.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExperimentalStatsAggregatorSummary::new().call(&ctx, &iterator)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalStatsAggregatorSummary>
pub fn experimental_stats_aggregator_summary<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    iterator: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExperimentalStatsAggregatorSummary::new();
    op.call(ctx, iterator)
}

/// ExperimentalTakeWhileDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalTakeWhileDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExperimentalTakeWhileDataset {
    predicate: ::std::option::Option<::std::string::String>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExperimentalTakeWhileDataset {
    fn default() -> Self {
        Self {
            predicate: None,
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl ExperimentalTakeWhileDataset {
    /// Creates a new `ExperimentalTakeWhileDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `predicate` attribute.
    pub fn predicate<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.predicate = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute experimental_take_while_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        other_arguments: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExperimentalTakeWhileDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&other_arguments.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.predicate {
            op.set_attr_string("predicate", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExperimentalTakeWhileDataset::new().call(&ctx, &input_dataset, &other_arguments)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalTakeWhileDataset>
pub fn experimental_take_while_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    other_arguments: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExperimentalTakeWhileDataset::new();
    op.call(ctx, input_dataset, other_arguments)
}

/// ExperimentalThreadPoolDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalThreadPoolDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExperimentalThreadPoolDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExperimentalThreadPoolDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl ExperimentalThreadPoolDataset {
    /// Creates a new `ExperimentalThreadPoolDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute experimental_thread_pool_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        thread_pool: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExperimentalThreadPoolDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&thread_pool.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExperimentalThreadPoolDataset::new().call(&ctx, &input_dataset, &thread_pool)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalThreadPoolDataset>
pub fn experimental_thread_pool_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    thread_pool: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExperimentalThreadPoolDataset::new();
    op.call(ctx, input_dataset, thread_pool)
}

/// ExperimentalThreadPoolHandle
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalThreadPoolHandle>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExperimentalThreadPoolHandle {
    num_threads: ::std::option::Option<i64>,
    max_intra_op_parallelism: ::std::option::Option<i64>,
    display_name: ::std::option::Option<::std::string::String>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExperimentalThreadPoolHandle {
    fn default() -> Self {
        Self {
            num_threads: None,
            max_intra_op_parallelism: Some(1i64),
            display_name: None,
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl ExperimentalThreadPoolHandle {
    /// Creates a new `ExperimentalThreadPoolHandle`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_threads` attribute.
    pub fn num_threads<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_threads = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `max_intra_op_parallelism` attribute.
    pub fn max_intra_op_parallelism<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.max_intra_op_parallelism = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `display_name` attribute.
    pub fn display_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.display_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute experimental_thread_pool_handle.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExperimentalThreadPoolHandle")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_threads {
            op.set_attr_int("num_threads", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.max_intra_op_parallelism {
            op.set_attr_int("max_intra_op_parallelism", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.display_name {
            op.set_attr_string("display_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExperimentalThreadPoolHandle::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalThreadPoolHandle>
pub fn experimental_thread_pool_handle<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExperimentalThreadPoolHandle::new();
    op.call(ctx)
}

/// ExperimentalUnbatchDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalUnbatchDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExperimentalUnbatchDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExperimentalUnbatchDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl ExperimentalUnbatchDataset {
    /// Creates a new `ExperimentalUnbatchDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute experimental_unbatch_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExperimentalUnbatchDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExperimentalUnbatchDataset::new().call(&ctx, &input_dataset)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalUnbatchDataset>
pub fn experimental_unbatch_dataset<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExperimentalUnbatchDataset::new();
    op.call(ctx, input_dataset)
}

/// ExperimentalUniqueDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalUniqueDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExperimentalUniqueDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExperimentalUniqueDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl ExperimentalUniqueDataset {
    /// Creates a new `ExperimentalUniqueDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute experimental_unique_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExperimentalUniqueDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExperimentalUniqueDataset::new().call(&ctx, &input_dataset)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExperimentalUniqueDataset>
pub fn experimental_unique_dataset<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExperimentalUniqueDataset::new();
    op.call(ctx, input_dataset)
}

/// Expint
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Expint>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Expint {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Expint {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Expint {
    /// Creates a new `Expint`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute expint.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Expint")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Expint::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Expint>
pub fn expint<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Expint::new();
    op.call(ctx, x)
}

/// Expm1
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Expm1>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Expm1 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Expm1 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Expm1 {
    /// Creates a new `Expm1`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute expm1.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Expm1")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Expm1::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Expm1>
pub fn expm1<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Expm1::new();
    op.call(ctx, x)
}

/// ExtractGlimpse
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExtractGlimpse>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExtractGlimpse {
    centered: ::std::option::Option<bool>,
    normalized: ::std::option::Option<bool>,
    uniform_noise: ::std::option::Option<bool>,
    noise: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExtractGlimpse {
    fn default() -> Self {
        Self {
            centered: Some(true),
            normalized: Some(true),
            uniform_noise: Some(true),
            noise: Some(::std::string::String::from("uniform")),
            target_device_name: None,
        }
    }
}
impl ExtractGlimpse {
    /// Creates a new `ExtractGlimpse`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `centered` attribute.
    pub fn centered<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.centered = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `normalized` attribute.
    pub fn normalized<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.normalized = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `uniform_noise` attribute.
    pub fn uniform_noise<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.uniform_noise = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `noise` attribute.
    pub fn noise<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.noise = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute extract_glimpse.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        size: &T1,
        offsets: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExtractGlimpse")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&size.to_handle(ctx)?)?;
        op.add_input(&offsets.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.centered {
            op.set_attr_bool("centered", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.normalized {
            op.set_attr_bool("normalized", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.uniform_noise {
            op.set_attr_bool("uniform_noise", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.noise {
            op.set_attr_string("noise", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExtractGlimpse::new().call(&ctx, &input, &size, &offsets)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExtractGlimpse>
pub fn extract_glimpse<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    size: &T1,
    offsets: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExtractGlimpse::new();
    op.call(ctx, input, size, offsets)
}

/// ExtractGlimpseV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExtractGlimpseV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExtractGlimpseV2 {
    centered: ::std::option::Option<bool>,
    normalized: ::std::option::Option<bool>,
    uniform_noise: ::std::option::Option<bool>,
    noise: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExtractGlimpseV2 {
    fn default() -> Self {
        Self {
            centered: Some(true),
            normalized: Some(true),
            uniform_noise: Some(true),
            noise: Some(::std::string::String::from("uniform")),
            target_device_name: None,
        }
    }
}
impl ExtractGlimpseV2 {
    /// Creates a new `ExtractGlimpseV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `centered` attribute.
    pub fn centered<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.centered = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `normalized` attribute.
    pub fn normalized<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.normalized = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `uniform_noise` attribute.
    pub fn uniform_noise<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.uniform_noise = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `noise` attribute.
    pub fn noise<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.noise = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute extract_glimpse_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        size: &T1,
        offsets: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExtractGlimpseV2")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&size.to_handle(ctx)?)?;
        op.add_input(&offsets.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.centered {
            op.set_attr_bool("centered", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.normalized {
            op.set_attr_bool("normalized", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.uniform_noise {
            op.set_attr_bool("uniform_noise", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.noise {
            op.set_attr_string("noise", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExtractGlimpseV2::new().call(&ctx, &input, &size, &offsets)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExtractGlimpseV2>
pub fn extract_glimpse_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    size: &T1,
    offsets: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExtractGlimpseV2::new();
    op.call(ctx, input, size, offsets)
}

/// ExtractImagePatches
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExtractImagePatches>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExtractImagePatches {
    ksizes: ::std::option::Option<::std::vec::Vec<i64>>,
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    rates: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExtractImagePatches {
    fn default() -> Self {
        Self {
            ksizes: None,
            strides: None,
            rates: None,
            padding: None,
            target_device_name: None,
        }
    }
}
impl ExtractImagePatches {
    /// Creates a new `ExtractImagePatches`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `ksizes` attribute.
    pub fn ksizes<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.ksizes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `rates` attribute.
    pub fn rates<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.rates = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute extract_image_patches.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        images: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExtractImagePatches")?;

        // Required input arguments
        op.add_input(&images.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.ksizes {
            op.set_attr_int_list("ksizes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.rates {
            op.set_attr_int_list("rates", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExtractImagePatches::new().call(&ctx, &images)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExtractImagePatches>
pub fn extract_image_patches<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    images: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExtractImagePatches::new();
    op.call(ctx, images)
}

/// ExtractJpegShape
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExtractJpegShape>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExtractJpegShape {
    output_type: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExtractJpegShape {
    fn default() -> Self {
        Self {
            output_type: Some(crate::DataType::Int32),
            target_device_name: None,
        }
    }
}
impl ExtractJpegShape {
    /// Creates a new `ExtractJpegShape`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_type` attribute.
    pub fn output_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute extract_jpeg_shape.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        contents: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExtractJpegShape")?;

        // Required input arguments
        op.add_input(&contents.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_type {
            op.set_attr_type("output_type", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExtractJpegShape::new().call(&ctx, &contents)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExtractJpegShape>
pub fn extract_jpeg_shape<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    contents: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExtractJpegShape::new();
    op.call(ctx, contents)
}

/// ExtractVolumePatches
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExtractVolumePatches>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ExtractVolumePatches {
    ksizes: ::std::option::Option<::std::vec::Vec<i64>>,
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ExtractVolumePatches {
    fn default() -> Self {
        Self {
            ksizes: None,
            strides: None,
            padding: None,
            target_device_name: None,
        }
    }
}
impl ExtractVolumePatches {
    /// Creates a new `ExtractVolumePatches`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `ksizes` attribute.
    pub fn ksizes<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.ksizes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute extract_volume_patches.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ExtractVolumePatches")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.ksizes {
            op.set_attr_int_list("ksizes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ExtractVolumePatches::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ExtractVolumePatches>
pub fn extract_volume_patches<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ExtractVolumePatches::new();
    op.call(ctx, input)
}

/// FFT
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FFT>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FFT {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FFT {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl FFT {
    /// Creates a new `FFT`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute fft.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "FFT")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `FFT::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FFT>
pub fn fft<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = FFT::new();
    op.call(ctx, input)
}

/// FFT2D
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FFT2D>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FFT2D {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FFT2D {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl FFT2D {
    /// Creates a new `FFT2D`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute fft2_d.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "FFT2D")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `FFT2D::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FFT2D>
pub fn fft2_d<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = FFT2D::new();
    op.call(ctx, input)
}

/// FFT3D
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FFT3D>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FFT3D {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FFT3D {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl FFT3D {
    /// Creates a new `FFT3D`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute fft3_d.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "FFT3D")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `FFT3D::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FFT3D>
pub fn fft3_d<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = FFT3D::new();
    op.call(ctx, input)
}

/// FIFOQueue
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FIFOQueue>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FIFOQueue {
    component_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    capacity: ::std::option::Option<i64>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FIFOQueue {
    fn default() -> Self {
        Self {
            component_types: None,
            shapes: Some(vec![]),
            capacity: Some(-1i64),
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl FIFOQueue {
    /// Creates a new `FIFOQueue`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `component_types` attribute.
    pub fn component_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.component_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shapes` attribute.
    pub fn shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `capacity` attribute.
    pub fn capacity<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.capacity = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute fifoqueue.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "FIFOQueue")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.component_types {
            op.set_attr_type_list("component_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shapes {
            op.set_attr_shape_list("shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.capacity {
            op.set_attr_int("capacity", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `FIFOQueue::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FIFOQueue>
pub fn fifoqueue<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = FIFOQueue::new();
    op.call(ctx)
}

/// FIFOQueueV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FIFOQueueV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FIFOQueueV2 {
    component_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    capacity: ::std::option::Option<i64>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FIFOQueueV2 {
    fn default() -> Self {
        Self {
            component_types: None,
            shapes: Some(vec![]),
            capacity: Some(-1i64),
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl FIFOQueueV2 {
    /// Creates a new `FIFOQueueV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `component_types` attribute.
    pub fn component_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.component_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shapes` attribute.
    pub fn shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `capacity` attribute.
    pub fn capacity<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.capacity = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute fifoqueue_v2.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "FIFOQueueV2")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.component_types {
            op.set_attr_type_list("component_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shapes {
            op.set_attr_shape_list("shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.capacity {
            op.set_attr_int("capacity", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `FIFOQueueV2::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FIFOQueueV2>
pub fn fifoqueue_v2<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = FIFOQueueV2::new();
    op.call(ctx)
}

/// Fact
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Fact>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Fact {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Fact {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Fact {
    /// Creates a new `Fact`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute fact.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Fact")?;

        // Required input arguments

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Fact::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Fact>
pub fn fact<'a>(ctx: &'a crate::eager::Context) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Fact::new();
    op.call(ctx)
}

/// FakeParam
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FakeParam>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FakeParam {
    dtype: ::std::option::Option<crate::DataType>,
    shape: ::std::option::Option<crate::Shape>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FakeParam {
    fn default() -> Self {
        Self {
            dtype: None,
            shape: None,
            target_device_name: None,
        }
    }
}
impl FakeParam {
    /// Creates a new `FakeParam`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shape` attribute.
    pub fn shape<ArgType: ::std::convert::Into<crate::Shape>>(mut self, value: ArgType) -> Self {
        self.shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute fake_param.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "FakeParam")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shape {
            op.set_attr_shape("shape", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `FakeParam::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FakeParam>
pub fn fake_param<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = FakeParam::new();
    op.call(ctx)
}

/// FakeQuantWithMinMaxArgs
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FakeQuantWithMinMaxArgs>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FakeQuantWithMinMaxArgs {
    min: ::std::option::Option<f32>,
    max: ::std::option::Option<f32>,
    num_bits: ::std::option::Option<i64>,
    narrow_range: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FakeQuantWithMinMaxArgs {
    fn default() -> Self {
        Self {
            min: Some(-6f32),
            max: Some(6f32),
            num_bits: Some(8i64),
            narrow_range: Some(false),
            target_device_name: None,
        }
    }
}
impl FakeQuantWithMinMaxArgs {
    /// Creates a new `FakeQuantWithMinMaxArgs`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `min` attribute.
    pub fn min<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.min = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `max` attribute.
    pub fn max<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.max = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_bits` attribute.
    pub fn num_bits<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_bits = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `narrow_range` attribute.
    pub fn narrow_range<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.narrow_range = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute fake_quant_with_min_max_args.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        inputs: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "FakeQuantWithMinMaxArgs")?;

        // Required input arguments
        op.add_input(&inputs.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.min {
            op.set_attr_float("min", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.max {
            op.set_attr_float("max", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_bits {
            op.set_attr_int("num_bits", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.narrow_range {
            op.set_attr_bool("narrow_range", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `FakeQuantWithMinMaxArgs::new().call(&ctx, &inputs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FakeQuantWithMinMaxArgs>
pub fn fake_quant_with_min_max_args<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    inputs: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = FakeQuantWithMinMaxArgs::new();
    op.call(ctx, inputs)
}

/// FakeQuantWithMinMaxArgsGradient
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FakeQuantWithMinMaxArgsGradient>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FakeQuantWithMinMaxArgsGradient {
    min: ::std::option::Option<f32>,
    max: ::std::option::Option<f32>,
    num_bits: ::std::option::Option<i64>,
    narrow_range: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FakeQuantWithMinMaxArgsGradient {
    fn default() -> Self {
        Self {
            min: Some(-6f32),
            max: Some(6f32),
            num_bits: Some(8i64),
            narrow_range: Some(false),
            target_device_name: None,
        }
    }
}
impl FakeQuantWithMinMaxArgsGradient {
    /// Creates a new `FakeQuantWithMinMaxArgsGradient`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `min` attribute.
    pub fn min<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.min = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `max` attribute.
    pub fn max<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.max = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_bits` attribute.
    pub fn num_bits<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_bits = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `narrow_range` attribute.
    pub fn narrow_range<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.narrow_range = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute fake_quant_with_min_max_args_gradient.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        gradients: &T0,
        inputs: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "FakeQuantWithMinMaxArgsGradient")?;

        // Required input arguments
        op.add_input(&gradients.to_handle(ctx)?)?;
        op.add_input(&inputs.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.min {
            op.set_attr_float("min", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.max {
            op.set_attr_float("max", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_bits {
            op.set_attr_int("num_bits", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.narrow_range {
            op.set_attr_bool("narrow_range", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `FakeQuantWithMinMaxArgsGradient::new().call(&ctx, &gradients, &inputs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FakeQuantWithMinMaxArgsGradient>
pub fn fake_quant_with_min_max_args_gradient<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    gradients: &T0,
    inputs: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = FakeQuantWithMinMaxArgsGradient::new();
    op.call(ctx, gradients, inputs)
}

/// FakeQuantWithMinMaxVars
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FakeQuantWithMinMaxVars>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FakeQuantWithMinMaxVars {
    num_bits: ::std::option::Option<i64>,
    narrow_range: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FakeQuantWithMinMaxVars {
    fn default() -> Self {
        Self {
            num_bits: Some(8i64),
            narrow_range: Some(false),
            target_device_name: None,
        }
    }
}
impl FakeQuantWithMinMaxVars {
    /// Creates a new `FakeQuantWithMinMaxVars`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_bits` attribute.
    pub fn num_bits<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_bits = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `narrow_range` attribute.
    pub fn narrow_range<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.narrow_range = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute fake_quant_with_min_max_vars.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        inputs: &T0,
        min: &T1,
        max: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "FakeQuantWithMinMaxVars")?;

        // Required input arguments
        op.add_input(&inputs.to_handle(ctx)?)?;
        op.add_input(&min.to_handle(ctx)?)?;
        op.add_input(&max.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_bits {
            op.set_attr_int("num_bits", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.narrow_range {
            op.set_attr_bool("narrow_range", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `FakeQuantWithMinMaxVars::new().call(&ctx, &inputs, &min, &max)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FakeQuantWithMinMaxVars>
pub fn fake_quant_with_min_max_vars<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    inputs: &T0,
    min: &T1,
    max: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = FakeQuantWithMinMaxVars::new();
    op.call(ctx, inputs, min, max)
}

/// FakeQuantWithMinMaxVarsGradient
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FakeQuantWithMinMaxVarsGradient>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FakeQuantWithMinMaxVarsGradient {
    num_bits: ::std::option::Option<i64>,
    narrow_range: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FakeQuantWithMinMaxVarsGradient {
    fn default() -> Self {
        Self {
            num_bits: Some(8i64),
            narrow_range: Some(false),
            target_device_name: None,
        }
    }
}
impl FakeQuantWithMinMaxVarsGradient {
    /// Creates a new `FakeQuantWithMinMaxVarsGradient`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_bits` attribute.
    pub fn num_bits<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_bits = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `narrow_range` attribute.
    pub fn narrow_range<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.narrow_range = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute fake_quant_with_min_max_vars_gradient.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        gradients: &T0,
        inputs: &T1,
        min: &T2,
        max: &T3,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "FakeQuantWithMinMaxVarsGradient")?;

        // Required input arguments
        op.add_input(&gradients.to_handle(ctx)?)?;
        op.add_input(&inputs.to_handle(ctx)?)?;
        op.add_input(&min.to_handle(ctx)?)?;
        op.add_input(&max.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_bits {
            op.set_attr_int("num_bits", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.narrow_range {
            op.set_attr_bool("narrow_range", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `FakeQuantWithMinMaxVarsGradient::new().call(&ctx, &gradients, &inputs, &min, &max)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FakeQuantWithMinMaxVarsGradient>
pub fn fake_quant_with_min_max_vars_gradient<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    gradients: &T0,
    inputs: &T1,
    min: &T2,
    max: &T3,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = FakeQuantWithMinMaxVarsGradient::new();
    op.call(ctx, gradients, inputs, min, max)
}

/// FakeQuantWithMinMaxVarsPerChannel
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FakeQuantWithMinMaxVarsPerChannel>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FakeQuantWithMinMaxVarsPerChannel {
    num_bits: ::std::option::Option<i64>,
    narrow_range: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FakeQuantWithMinMaxVarsPerChannel {
    fn default() -> Self {
        Self {
            num_bits: Some(8i64),
            narrow_range: Some(false),
            target_device_name: None,
        }
    }
}
impl FakeQuantWithMinMaxVarsPerChannel {
    /// Creates a new `FakeQuantWithMinMaxVarsPerChannel`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_bits` attribute.
    pub fn num_bits<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_bits = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `narrow_range` attribute.
    pub fn narrow_range<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.narrow_range = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute fake_quant_with_min_max_vars_per_channel.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        inputs: &T0,
        min: &T1,
        max: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "FakeQuantWithMinMaxVarsPerChannel")?;

        // Required input arguments
        op.add_input(&inputs.to_handle(ctx)?)?;
        op.add_input(&min.to_handle(ctx)?)?;
        op.add_input(&max.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_bits {
            op.set_attr_int("num_bits", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.narrow_range {
            op.set_attr_bool("narrow_range", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `FakeQuantWithMinMaxVarsPerChannel::new().call(&ctx, &inputs, &min, &max)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FakeQuantWithMinMaxVarsPerChannel>
pub fn fake_quant_with_min_max_vars_per_channel<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    inputs: &T0,
    min: &T1,
    max: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = FakeQuantWithMinMaxVarsPerChannel::new();
    op.call(ctx, inputs, min, max)
}

/// FakeQuantWithMinMaxVarsPerChannelGradient
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FakeQuantWithMinMaxVarsPerChannelGradient>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FakeQuantWithMinMaxVarsPerChannelGradient {
    num_bits: ::std::option::Option<i64>,
    narrow_range: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FakeQuantWithMinMaxVarsPerChannelGradient {
    fn default() -> Self {
        Self {
            num_bits: Some(8i64),
            narrow_range: Some(false),
            target_device_name: None,
        }
    }
}
impl FakeQuantWithMinMaxVarsPerChannelGradient {
    /// Creates a new `FakeQuantWithMinMaxVarsPerChannelGradient`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_bits` attribute.
    pub fn num_bits<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_bits = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `narrow_range` attribute.
    pub fn narrow_range<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.narrow_range = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute fake_quant_with_min_max_vars_per_channel_gradient.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        gradients: &T0,
        inputs: &T1,
        min: &T2,
        max: &T3,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "FakeQuantWithMinMaxVarsPerChannelGradient")?;

        // Required input arguments
        op.add_input(&gradients.to_handle(ctx)?)?;
        op.add_input(&inputs.to_handle(ctx)?)?;
        op.add_input(&min.to_handle(ctx)?)?;
        op.add_input(&max.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_bits {
            op.set_attr_int("num_bits", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.narrow_range {
            op.set_attr_bool("narrow_range", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `FakeQuantWithMinMaxVarsPerChannelGradient::new().call(&ctx, &gradients, &inputs, &min, &max)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FakeQuantWithMinMaxVarsPerChannelGradient>
pub fn fake_quant_with_min_max_vars_per_channel_gradient<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    gradients: &T0,
    inputs: &T1,
    min: &T2,
    max: &T3,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = FakeQuantWithMinMaxVarsPerChannelGradient::new();
    op.call(ctx, gradients, inputs, min, max)
}

/// FakeQueue
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FakeQueue>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FakeQueue {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FakeQueue {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl FakeQueue {
    /// Creates a new `FakeQueue`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute fake_queue.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        resource: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "FakeQueue")?;

        // Required input arguments
        op.add_input(&resource.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `FakeQueue::new().call(&ctx, &resource)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FakeQueue>
pub fn fake_queue<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    resource: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = FakeQueue::new();
    op.call(ctx, resource)
}

/// FileSystemSetConfiguration
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FileSystemSetConfiguration>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FileSystemSetConfiguration {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FileSystemSetConfiguration {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl FileSystemSetConfiguration {
    /// Creates a new `FileSystemSetConfiguration`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute file_system_set_configuration.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        scheme: &T0,
        key: &T1,
        value: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "FileSystemSetConfiguration")?;

        // Required input arguments
        op.add_input(&scheme.to_handle(ctx)?)?;
        op.add_input(&key.to_handle(ctx)?)?;
        op.add_input(&value.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `FileSystemSetConfiguration::new().call(&ctx, &scheme, &key, &value)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FileSystemSetConfiguration>
pub fn file_system_set_configuration<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    scheme: &T0,
    key: &T1,
    value: &T2,
) -> crate::Result<()> {
    let op = FileSystemSetConfiguration::new();
    op.call(ctx, scheme, key, value)
}

/// Fill
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Fill>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Fill {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Fill {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Fill {
    /// Creates a new `Fill`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute fill.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        dims: &T0,
        value: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Fill")?;

        // Required input arguments
        op.add_input(&dims.to_handle(ctx)?)?;
        op.add_input(&value.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Fill::new().call(&ctx, &dims, &value)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Fill>
pub fn fill<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    dims: &T0,
    value: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Fill::new();
    op.call(ctx, dims, value)
}

/// FilterByLastComponentDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FilterByLastComponentDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FilterByLastComponentDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FilterByLastComponentDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl FilterByLastComponentDataset {
    /// Creates a new `FilterByLastComponentDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute filter_by_last_component_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "FilterByLastComponentDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `FilterByLastComponentDataset::new().call(&ctx, &input_dataset)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FilterByLastComponentDataset>
pub fn filter_by_last_component_dataset<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = FilterByLastComponentDataset::new();
    op.call(ctx, input_dataset)
}

/// FilterDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FilterDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FilterDataset {
    predicate: ::std::option::Option<::std::string::String>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FilterDataset {
    fn default() -> Self {
        Self {
            predicate: None,
            output_types: None,
            output_shapes: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl FilterDataset {
    /// Creates a new `FilterDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `predicate` attribute.
    pub fn predicate<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.predicate = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute filter_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        other_arguments: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "FilterDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&other_arguments.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.predicate {
            op.set_attr_string("predicate", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `FilterDataset::new().call(&ctx, &input_dataset, &other_arguments)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FilterDataset>
pub fn filter_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    other_arguments: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = FilterDataset::new();
    op.call(ctx, input_dataset, other_arguments)
}

/// FinalizeDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FinalizeDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FinalizeDataset {
    has_captured_ref: ::std::option::Option<bool>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FinalizeDataset {
    fn default() -> Self {
        Self {
            has_captured_ref: Some(false),
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl FinalizeDataset {
    /// Creates a new `FinalizeDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `has_captured_ref` attribute.
    pub fn has_captured_ref<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.has_captured_ref = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute finalize_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "FinalizeDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.has_captured_ref {
            op.set_attr_bool("has_captured_ref", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `FinalizeDataset::new().call(&ctx, &input_dataset)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FinalizeDataset>
pub fn finalize_dataset<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = FinalizeDataset::new();
    op.call(ctx, input_dataset)
}

/// FinalizeTPUEmbedding
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FinalizeTPUEmbedding>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FinalizeTPUEmbedding {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FinalizeTPUEmbedding {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl FinalizeTPUEmbedding {
    /// Creates a new `FinalizeTPUEmbedding`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute finalize_tpuembedding.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        common_config: &T0,
        memory_config: &T1,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "FinalizeTPUEmbedding")?;

        // Required input arguments
        op.add_input(&common_config.to_handle(ctx)?)?;
        op.add_input(&memory_config.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `FinalizeTPUEmbedding::new().call(&ctx, &common_config, &memory_config)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FinalizeTPUEmbedding>
pub fn finalize_tpuembedding<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    common_config: &T0,
    memory_config: &T1,
) -> crate::Result<()> {
    let op = FinalizeTPUEmbedding::new();
    op.call(ctx, common_config, memory_config)
}

/// Fingerprint
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Fingerprint>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Fingerprint {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Fingerprint {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Fingerprint {
    /// Creates a new `Fingerprint`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute fingerprint.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        data: &T0,
        method: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Fingerprint")?;

        // Required input arguments
        op.add_input(&data.to_handle(ctx)?)?;
        op.add_input(&method.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Fingerprint::new().call(&ctx, &data, &method)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Fingerprint>
pub fn fingerprint<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    data: &T0,
    method: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Fingerprint::new();
    op.call(ctx, data, method)
}

/// FixedLengthRecordDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FixedLengthRecordDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FixedLengthRecordDataset {
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FixedLengthRecordDataset {
    fn default() -> Self {
        Self {
            metadata: None,
            target_device_name: None,
        }
    }
}
impl FixedLengthRecordDataset {
    /// Creates a new `FixedLengthRecordDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute fixed_length_record_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        filenames: &T0,
        header_bytes: &T1,
        record_bytes: &T2,
        footer_bytes: &T3,
        buffer_size: &T4,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "FixedLengthRecordDataset")?;

        // Required input arguments
        op.add_input(&filenames.to_handle(ctx)?)?;
        op.add_input(&header_bytes.to_handle(ctx)?)?;
        op.add_input(&record_bytes.to_handle(ctx)?)?;
        op.add_input(&footer_bytes.to_handle(ctx)?)?;
        op.add_input(&buffer_size.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `FixedLengthRecordDataset::new().call(&ctx, &filenames, &header_bytes, &record_bytes, &footer_bytes, &buffer_size)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FixedLengthRecordDataset>
pub fn fixed_length_record_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    filenames: &T0,
    header_bytes: &T1,
    record_bytes: &T2,
    footer_bytes: &T3,
    buffer_size: &T4,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = FixedLengthRecordDataset::new();
    op.call(
        ctx,
        filenames,
        header_bytes,
        record_bytes,
        footer_bytes,
        buffer_size,
    )
}

/// FixedLengthRecordDatasetV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FixedLengthRecordDatasetV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FixedLengthRecordDatasetV2 {
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FixedLengthRecordDatasetV2 {
    fn default() -> Self {
        Self {
            metadata: None,
            target_device_name: None,
        }
    }
}
impl FixedLengthRecordDatasetV2 {
    /// Creates a new `FixedLengthRecordDatasetV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute fixed_length_record_dataset_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        filenames: &T0,
        header_bytes: &T1,
        record_bytes: &T2,
        footer_bytes: &T3,
        buffer_size: &T4,
        compression_type: &T5,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "FixedLengthRecordDatasetV2")?;

        // Required input arguments
        op.add_input(&filenames.to_handle(ctx)?)?;
        op.add_input(&header_bytes.to_handle(ctx)?)?;
        op.add_input(&record_bytes.to_handle(ctx)?)?;
        op.add_input(&footer_bytes.to_handle(ctx)?)?;
        op.add_input(&buffer_size.to_handle(ctx)?)?;
        op.add_input(&compression_type.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `FixedLengthRecordDatasetV2::new().call(&ctx, &filenames, &header_bytes, &record_bytes, &footer_bytes, &buffer_size, &compression_type)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FixedLengthRecordDatasetV2>
pub fn fixed_length_record_dataset_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    filenames: &T0,
    header_bytes: &T1,
    record_bytes: &T2,
    footer_bytes: &T3,
    buffer_size: &T4,
    compression_type: &T5,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = FixedLengthRecordDatasetV2::new();
    op.call(
        ctx,
        filenames,
        header_bytes,
        record_bytes,
        footer_bytes,
        buffer_size,
        compression_type,
    )
}

/// FixedLengthRecordReader
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FixedLengthRecordReader>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FixedLengthRecordReader {
    header_bytes: ::std::option::Option<i64>,
    record_bytes: ::std::option::Option<i64>,
    footer_bytes: ::std::option::Option<i64>,
    hop_bytes: ::std::option::Option<i64>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FixedLengthRecordReader {
    fn default() -> Self {
        Self {
            header_bytes: Some(0i64),
            record_bytes: None,
            footer_bytes: Some(0i64),
            hop_bytes: Some(0i64),
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl FixedLengthRecordReader {
    /// Creates a new `FixedLengthRecordReader`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `header_bytes` attribute.
    pub fn header_bytes<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.header_bytes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `record_bytes` attribute.
    pub fn record_bytes<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.record_bytes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `footer_bytes` attribute.
    pub fn footer_bytes<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.footer_bytes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `hop_bytes` attribute.
    pub fn hop_bytes<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.hop_bytes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute fixed_length_record_reader.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "FixedLengthRecordReader")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.header_bytes {
            op.set_attr_int("header_bytes", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.record_bytes {
            op.set_attr_int("record_bytes", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.footer_bytes {
            op.set_attr_int("footer_bytes", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.hop_bytes {
            op.set_attr_int("hop_bytes", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `FixedLengthRecordReader::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FixedLengthRecordReader>
pub fn fixed_length_record_reader<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = FixedLengthRecordReader::new();
    op.call(ctx)
}

/// FixedLengthRecordReaderV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FixedLengthRecordReaderV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FixedLengthRecordReaderV2 {
    header_bytes: ::std::option::Option<i64>,
    record_bytes: ::std::option::Option<i64>,
    footer_bytes: ::std::option::Option<i64>,
    hop_bytes: ::std::option::Option<i64>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    encoding: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FixedLengthRecordReaderV2 {
    fn default() -> Self {
        Self {
            header_bytes: Some(0i64),
            record_bytes: None,
            footer_bytes: Some(0i64),
            hop_bytes: Some(0i64),
            container: None,
            shared_name: None,
            encoding: None,
            target_device_name: None,
        }
    }
}
impl FixedLengthRecordReaderV2 {
    /// Creates a new `FixedLengthRecordReaderV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `header_bytes` attribute.
    pub fn header_bytes<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.header_bytes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `record_bytes` attribute.
    pub fn record_bytes<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.record_bytes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `footer_bytes` attribute.
    pub fn footer_bytes<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.footer_bytes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `hop_bytes` attribute.
    pub fn hop_bytes<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.hop_bytes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `encoding` attribute.
    pub fn encoding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.encoding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute fixed_length_record_reader_v2.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "FixedLengthRecordReaderV2")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.header_bytes {
            op.set_attr_int("header_bytes", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.record_bytes {
            op.set_attr_int("record_bytes", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.footer_bytes {
            op.set_attr_int("footer_bytes", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.hop_bytes {
            op.set_attr_int("hop_bytes", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.encoding {
            op.set_attr_string("encoding", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `FixedLengthRecordReaderV2::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FixedLengthRecordReaderV2>
pub fn fixed_length_record_reader_v2<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = FixedLengthRecordReaderV2::new();
    op.call(ctx)
}

/// FixedUnigramCandidateSampler
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FixedUnigramCandidateSampler>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FixedUnigramCandidateSampler {
    num_true: ::std::option::Option<i64>,
    num_sampled: ::std::option::Option<i64>,
    unique: ::std::option::Option<bool>,
    range_max: ::std::option::Option<i64>,
    vocab_file: ::std::option::Option<::std::string::String>,
    distortion: ::std::option::Option<f32>,
    num_reserved_ids: ::std::option::Option<i64>,
    num_shards: ::std::option::Option<i64>,
    shard: ::std::option::Option<i64>,
    unigrams: ::std::option::Option<::std::vec::Vec<f32>>,
    seed: ::std::option::Option<i64>,
    seed2: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FixedUnigramCandidateSampler {
    fn default() -> Self {
        Self {
            num_true: None,
            num_sampled: None,
            unique: None,
            range_max: None,
            vocab_file: None,
            distortion: Some(1f32),
            num_reserved_ids: Some(0i64),
            num_shards: Some(1i64),
            shard: Some(0i64),
            unigrams: Some(vec![]),
            seed: Some(0i64),
            seed2: Some(0i64),
            target_device_name: None,
        }
    }
}
impl FixedUnigramCandidateSampler {
    /// Creates a new `FixedUnigramCandidateSampler`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_true` attribute.
    pub fn num_true<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_true = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_sampled` attribute.
    pub fn num_sampled<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_sampled = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `unique` attribute.
    pub fn unique<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.unique = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `range_max` attribute.
    pub fn range_max<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.range_max = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `vocab_file` attribute.
    pub fn vocab_file<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.vocab_file = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `distortion` attribute.
    pub fn distortion<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.distortion = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_reserved_ids` attribute.
    pub fn num_reserved_ids<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_reserved_ids = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_shards` attribute.
    pub fn num_shards<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_shards = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shard` attribute.
    pub fn shard<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.shard = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `unigrams` attribute.
    pub fn unigrams<ArgType: ::std::convert::Into<::std::vec::Vec<f32>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.unigrams = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed` attribute.
    pub fn seed<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed2` attribute.
    pub fn seed2<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute fixed_unigram_candidate_sampler.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        true_classes: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "FixedUnigramCandidateSampler")?;

        // Required input arguments
        op.add_input(&true_classes.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_true {
            op.set_attr_int("num_true", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_sampled {
            op.set_attr_int("num_sampled", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.unique {
            op.set_attr_bool("unique", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.range_max {
            op.set_attr_int("range_max", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.vocab_file {
            op.set_attr_string("vocab_file", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.distortion {
            op.set_attr_float("distortion", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_reserved_ids {
            op.set_attr_int("num_reserved_ids", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_shards {
            op.set_attr_int("num_shards", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shard {
            op.set_attr_int("shard", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.unigrams {
            op.set_attr_float_list("unigrams", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed {
            op.set_attr_int("seed", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed2 {
            op.set_attr_int("seed2", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `FixedUnigramCandidateSampler::new().call(&ctx, &true_classes)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FixedUnigramCandidateSampler>
pub fn fixed_unigram_candidate_sampler<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    true_classes: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = FixedUnigramCandidateSampler::new();
    op.call(ctx, true_classes)
}

/// FlatMapDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FlatMapDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FlatMapDataset {
    f: ::std::option::Option<::std::string::String>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FlatMapDataset {
    fn default() -> Self {
        Self {
            f: None,
            output_types: None,
            output_shapes: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl FlatMapDataset {
    /// Creates a new `FlatMapDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `f` attribute.
    pub fn f<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.f = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute flat_map_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        other_arguments: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "FlatMapDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&other_arguments.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.f {
            op.set_attr_string("f", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `FlatMapDataset::new().call(&ctx, &input_dataset, &other_arguments)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FlatMapDataset>
pub fn flat_map_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    other_arguments: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = FlatMapDataset::new();
    op.call(ctx, input_dataset, other_arguments)
}

/// Floor
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Floor>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Floor {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Floor {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Floor {
    /// Creates a new `Floor`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute floor.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Floor")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Floor::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Floor>
pub fn floor<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Floor::new();
    op.call(ctx, x)
}

/// FloorDiv
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FloorDiv>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FloorDiv {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FloorDiv {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl FloorDiv {
    /// Creates a new `FloorDiv`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute floor_div.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "FloorDiv")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `FloorDiv::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FloorDiv>
pub fn floor_div<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = FloorDiv::new();
    op.call(ctx, x, y)
}

/// FloorMod
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FloorMod>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FloorMod {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FloorMod {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl FloorMod {
    /// Creates a new `FloorMod`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute floor_mod.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "FloorMod")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `FloorMod::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FloorMod>
pub fn floor_mod<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = FloorMod::new();
    op.call(ctx, x, y)
}

/// FlushSummaryWriter
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FlushSummaryWriter>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FlushSummaryWriter {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FlushSummaryWriter {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl FlushSummaryWriter {
    /// Creates a new `FlushSummaryWriter`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute flush_summary_writer.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        writer: &T0,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "FlushSummaryWriter")?;

        // Required input arguments
        op.add_input(&writer.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `FlushSummaryWriter::new().call(&ctx, &writer)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FlushSummaryWriter>
pub fn flush_summary_writer<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    writer: &T0,
) -> crate::Result<()> {
    let op = FlushSummaryWriter::new();
    op.call(ctx, writer)
}

/// For
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/For>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct For {
    body: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for For {
    fn default() -> Self {
        Self {
            body: None,
            target_device_name: None,
        }
    }
}
impl For {
    /// Creates a new `For`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `body` attribute.
    pub fn body<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.body = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute for_.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        start: &T0,
        limit: &T1,
        delta: &T2,
        input: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "For")?;

        // Required input arguments
        op.add_input(&start.to_handle(ctx)?)?;
        op.add_input(&limit.to_handle(ctx)?)?;
        op.add_input(&delta.to_handle(ctx)?)?;
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.body {
            op.set_attr_string("body", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `For::new().call(&ctx, &start, &limit, &delta, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/For>
pub fn for_<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    start: &T0,
    limit: &T1,
    delta: &T2,
    input: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = For::new();
    op.call(ctx, start, limit, delta, input)
}

/// FractionalAvgPool
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FractionalAvgPool>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FractionalAvgPool {
    pooling_ratio: ::std::option::Option<::std::vec::Vec<f32>>,
    pseudo_random: ::std::option::Option<bool>,
    overlapping: ::std::option::Option<bool>,
    deterministic: ::std::option::Option<bool>,
    seed: ::std::option::Option<i64>,
    seed2: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FractionalAvgPool {
    fn default() -> Self {
        Self {
            pooling_ratio: None,
            pseudo_random: Some(false),
            overlapping: Some(false),
            deterministic: Some(false),
            seed: Some(0i64),
            seed2: Some(0i64),
            target_device_name: None,
        }
    }
}
impl FractionalAvgPool {
    /// Creates a new `FractionalAvgPool`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `pooling_ratio` attribute.
    pub fn pooling_ratio<ArgType: ::std::convert::Into<::std::vec::Vec<f32>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.pooling_ratio = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `pseudo_random` attribute.
    pub fn pseudo_random<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.pseudo_random = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `overlapping` attribute.
    pub fn overlapping<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.overlapping = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `deterministic` attribute.
    pub fn deterministic<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.deterministic = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed` attribute.
    pub fn seed<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed2` attribute.
    pub fn seed2<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute fractional_avg_pool.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        value: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "FractionalAvgPool")?;

        // Required input arguments
        op.add_input(&value.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.pooling_ratio {
            op.set_attr_float_list("pooling_ratio", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.pseudo_random {
            op.set_attr_bool("pseudo_random", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.overlapping {
            op.set_attr_bool("overlapping", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.deterministic {
            op.set_attr_bool("deterministic", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed {
            op.set_attr_int("seed", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed2 {
            op.set_attr_int("seed2", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `FractionalAvgPool::new().call(&ctx, &value)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FractionalAvgPool>
pub fn fractional_avg_pool<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    value: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = FractionalAvgPool::new();
    op.call(ctx, value)
}

/// FractionalAvgPoolGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FractionalAvgPoolGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FractionalAvgPoolGrad {
    overlapping: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FractionalAvgPoolGrad {
    fn default() -> Self {
        Self {
            overlapping: Some(false),
            target_device_name: None,
        }
    }
}
impl FractionalAvgPoolGrad {
    /// Creates a new `FractionalAvgPoolGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `overlapping` attribute.
    pub fn overlapping<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.overlapping = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute fractional_avg_pool_grad.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        orig_input_tensor_shape: &T0,
        out_backprop: &T1,
        row_pooling_sequence: &T2,
        col_pooling_sequence: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "FractionalAvgPoolGrad")?;

        // Required input arguments
        op.add_input(&orig_input_tensor_shape.to_handle(ctx)?)?;
        op.add_input(&out_backprop.to_handle(ctx)?)?;
        op.add_input(&row_pooling_sequence.to_handle(ctx)?)?;
        op.add_input(&col_pooling_sequence.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.overlapping {
            op.set_attr_bool("overlapping", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `FractionalAvgPoolGrad::new().call(&ctx, &orig_input_tensor_shape, &out_backprop, &row_pooling_sequence, &col_pooling_sequence)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FractionalAvgPoolGrad>
pub fn fractional_avg_pool_grad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    orig_input_tensor_shape: &T0,
    out_backprop: &T1,
    row_pooling_sequence: &T2,
    col_pooling_sequence: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = FractionalAvgPoolGrad::new();
    op.call(
        ctx,
        orig_input_tensor_shape,
        out_backprop,
        row_pooling_sequence,
        col_pooling_sequence,
    )
}

/// FractionalMaxPool
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FractionalMaxPool>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FractionalMaxPool {
    pooling_ratio: ::std::option::Option<::std::vec::Vec<f32>>,
    pseudo_random: ::std::option::Option<bool>,
    overlapping: ::std::option::Option<bool>,
    deterministic: ::std::option::Option<bool>,
    seed: ::std::option::Option<i64>,
    seed2: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FractionalMaxPool {
    fn default() -> Self {
        Self {
            pooling_ratio: None,
            pseudo_random: Some(false),
            overlapping: Some(false),
            deterministic: Some(false),
            seed: Some(0i64),
            seed2: Some(0i64),
            target_device_name: None,
        }
    }
}
impl FractionalMaxPool {
    /// Creates a new `FractionalMaxPool`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `pooling_ratio` attribute.
    pub fn pooling_ratio<ArgType: ::std::convert::Into<::std::vec::Vec<f32>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.pooling_ratio = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `pseudo_random` attribute.
    pub fn pseudo_random<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.pseudo_random = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `overlapping` attribute.
    pub fn overlapping<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.overlapping = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `deterministic` attribute.
    pub fn deterministic<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.deterministic = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed` attribute.
    pub fn seed<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed2` attribute.
    pub fn seed2<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute fractional_max_pool.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        value: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "FractionalMaxPool")?;

        // Required input arguments
        op.add_input(&value.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.pooling_ratio {
            op.set_attr_float_list("pooling_ratio", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.pseudo_random {
            op.set_attr_bool("pseudo_random", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.overlapping {
            op.set_attr_bool("overlapping", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.deterministic {
            op.set_attr_bool("deterministic", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed {
            op.set_attr_int("seed", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed2 {
            op.set_attr_int("seed2", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `FractionalMaxPool::new().call(&ctx, &value)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FractionalMaxPool>
pub fn fractional_max_pool<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    value: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = FractionalMaxPool::new();
    op.call(ctx, value)
}

/// FractionalMaxPoolGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FractionalMaxPoolGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FractionalMaxPoolGrad {
    overlapping: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FractionalMaxPoolGrad {
    fn default() -> Self {
        Self {
            overlapping: Some(false),
            target_device_name: None,
        }
    }
}
impl FractionalMaxPoolGrad {
    /// Creates a new `FractionalMaxPoolGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `overlapping` attribute.
    pub fn overlapping<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.overlapping = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute fractional_max_pool_grad.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        orig_input: &T0,
        orig_output: &T1,
        out_backprop: &T2,
        row_pooling_sequence: &T3,
        col_pooling_sequence: &T4,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "FractionalMaxPoolGrad")?;

        // Required input arguments
        op.add_input(&orig_input.to_handle(ctx)?)?;
        op.add_input(&orig_output.to_handle(ctx)?)?;
        op.add_input(&out_backprop.to_handle(ctx)?)?;
        op.add_input(&row_pooling_sequence.to_handle(ctx)?)?;
        op.add_input(&col_pooling_sequence.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.overlapping {
            op.set_attr_bool("overlapping", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `FractionalMaxPoolGrad::new().call(&ctx, &orig_input, &orig_output, &out_backprop, &row_pooling_sequence, &col_pooling_sequence)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FractionalMaxPoolGrad>
pub fn fractional_max_pool_grad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    orig_input: &T0,
    orig_output: &T1,
    out_backprop: &T2,
    row_pooling_sequence: &T3,
    col_pooling_sequence: &T4,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = FractionalMaxPoolGrad::new();
    op.call(
        ctx,
        orig_input,
        orig_output,
        out_backprop,
        row_pooling_sequence,
        col_pooling_sequence,
    )
}

/// FresnelCos
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FresnelCos>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FresnelCos {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FresnelCos {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl FresnelCos {
    /// Creates a new `FresnelCos`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute fresnel_cos.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "FresnelCos")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `FresnelCos::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FresnelCos>
pub fn fresnel_cos<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = FresnelCos::new();
    op.call(ctx, x)
}

/// FresnelSin
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FresnelSin>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FresnelSin {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FresnelSin {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl FresnelSin {
    /// Creates a new `FresnelSin`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute fresnel_sin.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "FresnelSin")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `FresnelSin::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FresnelSin>
pub fn fresnel_sin<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = FresnelSin::new();
    op.call(ctx, x)
}

/// FusedBatchNorm
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FusedBatchNorm>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FusedBatchNorm {
    epsilon: ::std::option::Option<f32>,
    exponential_avg_factor: ::std::option::Option<f32>,
    data_format: ::std::option::Option<::std::string::String>,
    is_training: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FusedBatchNorm {
    fn default() -> Self {
        Self {
            epsilon: Some(0.0001f32),
            exponential_avg_factor: Some(1f32),
            data_format: Some(::std::string::String::from("NHWC")),
            is_training: Some(true),
            target_device_name: None,
        }
    }
}
impl FusedBatchNorm {
    /// Creates a new `FusedBatchNorm`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `epsilon` attribute.
    pub fn epsilon<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.epsilon = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `exponential_avg_factor` attribute.
    pub fn exponential_avg_factor<ArgType: ::std::convert::Into<f32>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.exponential_avg_factor = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `data_format` attribute.
    pub fn data_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.data_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `is_training` attribute.
    pub fn is_training<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.is_training = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute fused_batch_norm.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        scale: &T1,
        offset: &T2,
        mean: &T3,
        variance: &T4,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 5]> {
        // Define Op
        let mut op = super::Op::new(ctx, "FusedBatchNorm")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&scale.to_handle(ctx)?)?;
        op.add_input(&offset.to_handle(ctx)?)?;
        op.add_input(&mean.to_handle(ctx)?)?;
        op.add_input(&variance.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.epsilon {
            op.set_attr_float("epsilon", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.exponential_avg_factor {
            op.set_attr_float("exponential_avg_factor", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.data_format {
            op.set_attr_string("data_format", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.is_training {
            op.set_attr_bool("is_training", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<5>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `FusedBatchNorm::new().call(&ctx, &x, &scale, &offset, &mean, &variance)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FusedBatchNorm>
pub fn fused_batch_norm<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    scale: &T1,
    offset: &T2,
    mean: &T3,
    variance: &T4,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 5]> {
    let op = FusedBatchNorm::new();
    op.call(ctx, x, scale, offset, mean, variance)
}

/// FusedBatchNormGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FusedBatchNormGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FusedBatchNormGrad {
    epsilon: ::std::option::Option<f32>,
    data_format: ::std::option::Option<::std::string::String>,
    is_training: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FusedBatchNormGrad {
    fn default() -> Self {
        Self {
            epsilon: Some(0.0001f32),
            data_format: Some(::std::string::String::from("NHWC")),
            is_training: Some(true),
            target_device_name: None,
        }
    }
}
impl FusedBatchNormGrad {
    /// Creates a new `FusedBatchNormGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `epsilon` attribute.
    pub fn epsilon<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.epsilon = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `data_format` attribute.
    pub fn data_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.data_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `is_training` attribute.
    pub fn is_training<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.is_training = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute fused_batch_norm_grad.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        y_backprop: &T0,
        x: &T1,
        scale: &T2,
        reserve_space_1: &T3,
        reserve_space_2: &T4,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 5]> {
        // Define Op
        let mut op = super::Op::new(ctx, "FusedBatchNormGrad")?;

        // Required input arguments
        op.add_input(&y_backprop.to_handle(ctx)?)?;
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&scale.to_handle(ctx)?)?;
        op.add_input(&reserve_space_1.to_handle(ctx)?)?;
        op.add_input(&reserve_space_2.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.epsilon {
            op.set_attr_float("epsilon", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.data_format {
            op.set_attr_string("data_format", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.is_training {
            op.set_attr_bool("is_training", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<5>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `FusedBatchNormGrad::new().call(&ctx, &y_backprop, &x, &scale, &reserve_space_1, &reserve_space_2)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FusedBatchNormGrad>
pub fn fused_batch_norm_grad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    y_backprop: &T0,
    x: &T1,
    scale: &T2,
    reserve_space_1: &T3,
    reserve_space_2: &T4,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 5]> {
    let op = FusedBatchNormGrad::new();
    op.call(ctx, y_backprop, x, scale, reserve_space_1, reserve_space_2)
}

/// FusedBatchNormGradV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FusedBatchNormGradV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FusedBatchNormGradV2 {
    epsilon: ::std::option::Option<f32>,
    data_format: ::std::option::Option<::std::string::String>,
    is_training: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FusedBatchNormGradV2 {
    fn default() -> Self {
        Self {
            epsilon: Some(0.0001f32),
            data_format: Some(::std::string::String::from("NHWC")),
            is_training: Some(true),
            target_device_name: None,
        }
    }
}
impl FusedBatchNormGradV2 {
    /// Creates a new `FusedBatchNormGradV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `epsilon` attribute.
    pub fn epsilon<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.epsilon = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `data_format` attribute.
    pub fn data_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.data_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `is_training` attribute.
    pub fn is_training<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.is_training = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute fused_batch_norm_grad_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        y_backprop: &T0,
        x: &T1,
        scale: &T2,
        reserve_space_1: &T3,
        reserve_space_2: &T4,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 5]> {
        // Define Op
        let mut op = super::Op::new(ctx, "FusedBatchNormGradV2")?;

        // Required input arguments
        op.add_input(&y_backprop.to_handle(ctx)?)?;
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&scale.to_handle(ctx)?)?;
        op.add_input(&reserve_space_1.to_handle(ctx)?)?;
        op.add_input(&reserve_space_2.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.epsilon {
            op.set_attr_float("epsilon", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.data_format {
            op.set_attr_string("data_format", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.is_training {
            op.set_attr_bool("is_training", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<5>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `FusedBatchNormGradV2::new().call(&ctx, &y_backprop, &x, &scale, &reserve_space_1, &reserve_space_2)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FusedBatchNormGradV2>
pub fn fused_batch_norm_grad_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    y_backprop: &T0,
    x: &T1,
    scale: &T2,
    reserve_space_1: &T3,
    reserve_space_2: &T4,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 5]> {
    let op = FusedBatchNormGradV2::new();
    op.call(ctx, y_backprop, x, scale, reserve_space_1, reserve_space_2)
}

/// FusedBatchNormGradV3
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FusedBatchNormGradV3>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FusedBatchNormGradV3 {
    epsilon: ::std::option::Option<f32>,
    data_format: ::std::option::Option<::std::string::String>,
    is_training: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FusedBatchNormGradV3 {
    fn default() -> Self {
        Self {
            epsilon: Some(0.0001f32),
            data_format: Some(::std::string::String::from("NHWC")),
            is_training: Some(true),
            target_device_name: None,
        }
    }
}
impl FusedBatchNormGradV3 {
    /// Creates a new `FusedBatchNormGradV3`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `epsilon` attribute.
    pub fn epsilon<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.epsilon = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `data_format` attribute.
    pub fn data_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.data_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `is_training` attribute.
    pub fn is_training<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.is_training = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute fused_batch_norm_grad_v3.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        y_backprop: &T0,
        x: &T1,
        scale: &T2,
        reserve_space_1: &T3,
        reserve_space_2: &T4,
        reserve_space_3: &T5,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 5]> {
        // Define Op
        let mut op = super::Op::new(ctx, "FusedBatchNormGradV3")?;

        // Required input arguments
        op.add_input(&y_backprop.to_handle(ctx)?)?;
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&scale.to_handle(ctx)?)?;
        op.add_input(&reserve_space_1.to_handle(ctx)?)?;
        op.add_input(&reserve_space_2.to_handle(ctx)?)?;
        op.add_input(&reserve_space_3.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.epsilon {
            op.set_attr_float("epsilon", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.data_format {
            op.set_attr_string("data_format", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.is_training {
            op.set_attr_bool("is_training", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<5>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `FusedBatchNormGradV3::new().call(&ctx, &y_backprop, &x, &scale, &reserve_space_1, &reserve_space_2, &reserve_space_3)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FusedBatchNormGradV3>
pub fn fused_batch_norm_grad_v3<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    y_backprop: &T0,
    x: &T1,
    scale: &T2,
    reserve_space_1: &T3,
    reserve_space_2: &T4,
    reserve_space_3: &T5,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 5]> {
    let op = FusedBatchNormGradV3::new();
    op.call(
        ctx,
        y_backprop,
        x,
        scale,
        reserve_space_1,
        reserve_space_2,
        reserve_space_3,
    )
}

/// FusedBatchNormV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FusedBatchNormV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FusedBatchNormV2 {
    epsilon: ::std::option::Option<f32>,
    exponential_avg_factor: ::std::option::Option<f32>,
    data_format: ::std::option::Option<::std::string::String>,
    is_training: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FusedBatchNormV2 {
    fn default() -> Self {
        Self {
            epsilon: Some(0.0001f32),
            exponential_avg_factor: Some(1f32),
            data_format: Some(::std::string::String::from("NHWC")),
            is_training: Some(true),
            target_device_name: None,
        }
    }
}
impl FusedBatchNormV2 {
    /// Creates a new `FusedBatchNormV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `epsilon` attribute.
    pub fn epsilon<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.epsilon = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `exponential_avg_factor` attribute.
    pub fn exponential_avg_factor<ArgType: ::std::convert::Into<f32>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.exponential_avg_factor = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `data_format` attribute.
    pub fn data_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.data_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `is_training` attribute.
    pub fn is_training<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.is_training = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute fused_batch_norm_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        scale: &T1,
        offset: &T2,
        mean: &T3,
        variance: &T4,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 5]> {
        // Define Op
        let mut op = super::Op::new(ctx, "FusedBatchNormV2")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&scale.to_handle(ctx)?)?;
        op.add_input(&offset.to_handle(ctx)?)?;
        op.add_input(&mean.to_handle(ctx)?)?;
        op.add_input(&variance.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.epsilon {
            op.set_attr_float("epsilon", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.exponential_avg_factor {
            op.set_attr_float("exponential_avg_factor", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.data_format {
            op.set_attr_string("data_format", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.is_training {
            op.set_attr_bool("is_training", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<5>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `FusedBatchNormV2::new().call(&ctx, &x, &scale, &offset, &mean, &variance)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FusedBatchNormV2>
pub fn fused_batch_norm_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    scale: &T1,
    offset: &T2,
    mean: &T3,
    variance: &T4,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 5]> {
    let op = FusedBatchNormV2::new();
    op.call(ctx, x, scale, offset, mean, variance)
}

/// FusedBatchNormV3
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FusedBatchNormV3>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FusedBatchNormV3 {
    epsilon: ::std::option::Option<f32>,
    exponential_avg_factor: ::std::option::Option<f32>,
    data_format: ::std::option::Option<::std::string::String>,
    is_training: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FusedBatchNormV3 {
    fn default() -> Self {
        Self {
            epsilon: Some(0.0001f32),
            exponential_avg_factor: Some(1f32),
            data_format: Some(::std::string::String::from("NHWC")),
            is_training: Some(true),
            target_device_name: None,
        }
    }
}
impl FusedBatchNormV3 {
    /// Creates a new `FusedBatchNormV3`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `epsilon` attribute.
    pub fn epsilon<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.epsilon = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `exponential_avg_factor` attribute.
    pub fn exponential_avg_factor<ArgType: ::std::convert::Into<f32>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.exponential_avg_factor = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `data_format` attribute.
    pub fn data_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.data_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `is_training` attribute.
    pub fn is_training<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.is_training = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute fused_batch_norm_v3.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        scale: &T1,
        offset: &T2,
        mean: &T3,
        variance: &T4,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 6]> {
        // Define Op
        let mut op = super::Op::new(ctx, "FusedBatchNormV3")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&scale.to_handle(ctx)?)?;
        op.add_input(&offset.to_handle(ctx)?)?;
        op.add_input(&mean.to_handle(ctx)?)?;
        op.add_input(&variance.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.epsilon {
            op.set_attr_float("epsilon", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.exponential_avg_factor {
            op.set_attr_float("exponential_avg_factor", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.data_format {
            op.set_attr_string("data_format", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.is_training {
            op.set_attr_bool("is_training", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<6>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `FusedBatchNormV3::new().call(&ctx, &x, &scale, &offset, &mean, &variance)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FusedBatchNormV3>
pub fn fused_batch_norm_v3<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    scale: &T1,
    offset: &T2,
    mean: &T3,
    variance: &T4,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 6]> {
    let op = FusedBatchNormV3::new();
    op.call(ctx, x, scale, offset, mean, variance)
}

/// FusedPadConv2D
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FusedPadConv2D>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FusedPadConv2D {
    mode: ::std::option::Option<::std::string::String>,
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FusedPadConv2D {
    fn default() -> Self {
        Self {
            mode: None,
            strides: None,
            padding: None,
            target_device_name: None,
        }
    }
}
impl FusedPadConv2D {
    /// Creates a new `FusedPadConv2D`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `mode` attribute.
    pub fn mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute fused_pad_conv2_d.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        paddings: &T1,
        filter: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "FusedPadConv2D")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&paddings.to_handle(ctx)?)?;
        op.add_input(&filter.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.mode {
            op.set_attr_string("mode", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `FusedPadConv2D::new().call(&ctx, &input, &paddings, &filter)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FusedPadConv2D>
pub fn fused_pad_conv2_d<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    paddings: &T1,
    filter: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = FusedPadConv2D::new();
    op.call(ctx, input, paddings, filter)
}

/// FusedResizeAndPadConv2D
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FusedResizeAndPadConv2D>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct FusedResizeAndPadConv2D {
    resize_align_corners: ::std::option::Option<bool>,
    mode: ::std::option::Option<::std::string::String>,
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for FusedResizeAndPadConv2D {
    fn default() -> Self {
        Self {
            resize_align_corners: Some(false),
            mode: None,
            strides: None,
            padding: None,
            target_device_name: None,
        }
    }
}
impl FusedResizeAndPadConv2D {
    /// Creates a new `FusedResizeAndPadConv2D`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `resize_align_corners` attribute.
    pub fn resize_align_corners<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.resize_align_corners = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `mode` attribute.
    pub fn mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute fused_resize_and_pad_conv2_d.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        size: &T1,
        paddings: &T2,
        filter: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "FusedResizeAndPadConv2D")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&size.to_handle(ctx)?)?;
        op.add_input(&paddings.to_handle(ctx)?)?;
        op.add_input(&filter.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.resize_align_corners {
            op.set_attr_bool("resize_align_corners", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.mode {
            op.set_attr_string("mode", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `FusedResizeAndPadConv2D::new().call(&ctx, &input, &size, &paddings, &filter)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/FusedResizeAndPadConv2D>
pub fn fused_resize_and_pad_conv2_d<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    size: &T1,
    paddings: &T2,
    filter: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = FusedResizeAndPadConv2D::new();
    op.call(ctx, input, size, paddings, filter)
}

/// GRUBlockCell
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/GRUBlockCell>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct GRUBlockCell {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for GRUBlockCell {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl GRUBlockCell {
    /// Creates a new `GRUBlockCell`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute grublock_cell.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        h_prev: &T1,
        w_ru: &T2,
        w_c: &T3,
        b_ru: &T4,
        b_c: &T5,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 4]> {
        // Define Op
        let mut op = super::Op::new(ctx, "GRUBlockCell")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&h_prev.to_handle(ctx)?)?;
        op.add_input(&w_ru.to_handle(ctx)?)?;
        op.add_input(&w_c.to_handle(ctx)?)?;
        op.add_input(&b_ru.to_handle(ctx)?)?;
        op.add_input(&b_c.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<4>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `GRUBlockCell::new().call(&ctx, &x, &h_prev, &w_ru, &w_c, &b_ru, &b_c)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/GRUBlockCell>
pub fn grublock_cell<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    h_prev: &T1,
    w_ru: &T2,
    w_c: &T3,
    b_ru: &T4,
    b_c: &T5,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 4]> {
    let op = GRUBlockCell::new();
    op.call(ctx, x, h_prev, w_ru, w_c, b_ru, b_c)
}

/// GRUBlockCellGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/GRUBlockCellGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct GRUBlockCellGrad {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for GRUBlockCellGrad {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl GRUBlockCellGrad {
    /// Creates a new `GRUBlockCellGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute grublock_cell_grad.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
        T9: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        h_prev: &T1,
        w_ru: &T2,
        w_c: &T3,
        b_ru: &T4,
        b_c: &T5,
        r: &T6,
        u: &T7,
        c: &T8,
        d_h: &T9,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 4]> {
        // Define Op
        let mut op = super::Op::new(ctx, "GRUBlockCellGrad")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&h_prev.to_handle(ctx)?)?;
        op.add_input(&w_ru.to_handle(ctx)?)?;
        op.add_input(&w_c.to_handle(ctx)?)?;
        op.add_input(&b_ru.to_handle(ctx)?)?;
        op.add_input(&b_c.to_handle(ctx)?)?;
        op.add_input(&r.to_handle(ctx)?)?;
        op.add_input(&u.to_handle(ctx)?)?;
        op.add_input(&c.to_handle(ctx)?)?;
        op.add_input(&d_h.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<4>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `GRUBlockCellGrad::new().call(&ctx, &x, &h_prev, &w_ru, &w_c, &b_ru, &b_c, &r, &u, &c, &d_h)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/GRUBlockCellGrad>
pub fn grublock_cell_grad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
    T9: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    h_prev: &T1,
    w_ru: &T2,
    w_c: &T3,
    b_ru: &T4,
    b_c: &T5,
    r: &T6,
    u: &T7,
    c: &T8,
    d_h: &T9,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 4]> {
    let op = GRUBlockCellGrad::new();
    op.call(ctx, x, h_prev, w_ru, w_c, b_ru, b_c, r, u, c, d_h)
}

/// Gather
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Gather>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Gather {
    validate_indices: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Gather {
    fn default() -> Self {
        Self {
            validate_indices: Some(true),
            target_device_name: None,
        }
    }
}
impl Gather {
    /// Creates a new `Gather`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `validate_indices` attribute.
    pub fn validate_indices<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.validate_indices = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute gather.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        params: &T0,
        indices: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Gather")?;

        // Required input arguments
        op.add_input(&params.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.validate_indices {
            op.set_attr_bool("validate_indices", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Gather::new().call(&ctx, &params, &indices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Gather>
pub fn gather<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    params: &T0,
    indices: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Gather::new();
    op.call(ctx, params, indices)
}

/// GatherNd
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/GatherNd>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct GatherNd {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for GatherNd {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl GatherNd {
    /// Creates a new `GatherNd`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute gather_nd.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        params: &T0,
        indices: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "GatherNd")?;

        // Required input arguments
        op.add_input(&params.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `GatherNd::new().call(&ctx, &params, &indices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/GatherNd>
pub fn gather_nd<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    params: &T0,
    indices: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = GatherNd::new();
    op.call(ctx, params, indices)
}

/// GatherV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/GatherV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct GatherV2 {
    batch_dims: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for GatherV2 {
    fn default() -> Self {
        Self {
            batch_dims: Some(0i64),
            target_device_name: None,
        }
    }
}
impl GatherV2 {
    /// Creates a new `GatherV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `batch_dims` attribute.
    pub fn batch_dims<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.batch_dims = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute gather_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        params: &T0,
        indices: &T1,
        axis: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "GatherV2")?;

        // Required input arguments
        op.add_input(&params.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&axis.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.batch_dims {
            op.set_attr_int("batch_dims", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `GatherV2::new().call(&ctx, &params, &indices, &axis)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/GatherV2>
pub fn gather_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    params: &T0,
    indices: &T1,
    axis: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = GatherV2::new();
    op.call(ctx, params, indices, axis)
}

/// GenerateBoundingBoxProposals
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/GenerateBoundingBoxProposals>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct GenerateBoundingBoxProposals {
    post_nms_topn: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for GenerateBoundingBoxProposals {
    fn default() -> Self {
        Self {
            post_nms_topn: Some(300i64),
            target_device_name: None,
        }
    }
}
impl GenerateBoundingBoxProposals {
    /// Creates a new `GenerateBoundingBoxProposals`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `post_nms_topn` attribute.
    pub fn post_nms_topn<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.post_nms_topn = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute generate_bounding_box_proposals.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        scores: &T0,
        bbox_deltas: &T1,
        image_info: &T2,
        anchors: &T3,
        nms_threshold: &T4,
        pre_nms_topn: &T5,
        min_size: &T6,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "GenerateBoundingBoxProposals")?;

        // Required input arguments
        op.add_input(&scores.to_handle(ctx)?)?;
        op.add_input(&bbox_deltas.to_handle(ctx)?)?;
        op.add_input(&image_info.to_handle(ctx)?)?;
        op.add_input(&anchors.to_handle(ctx)?)?;
        op.add_input(&nms_threshold.to_handle(ctx)?)?;
        op.add_input(&pre_nms_topn.to_handle(ctx)?)?;
        op.add_input(&min_size.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.post_nms_topn {
            op.set_attr_int("post_nms_topn", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `GenerateBoundingBoxProposals::new().call(&ctx, &scores, &bbox_deltas, &image_info, &anchors, &nms_threshold, &pre_nms_topn, &min_size)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/GenerateBoundingBoxProposals>
pub fn generate_bounding_box_proposals<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    scores: &T0,
    bbox_deltas: &T1,
    image_info: &T2,
    anchors: &T3,
    nms_threshold: &T4,
    pre_nms_topn: &T5,
    min_size: &T6,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = GenerateBoundingBoxProposals::new();
    op.call(
        ctx,
        scores,
        bbox_deltas,
        image_info,
        anchors,
        nms_threshold,
        pre_nms_topn,
        min_size,
    )
}

/// GenerateVocabRemapping
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/GenerateVocabRemapping>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct GenerateVocabRemapping {
    new_vocab_offset: ::std::option::Option<i64>,
    num_new_vocab: ::std::option::Option<i64>,
    old_vocab_size: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for GenerateVocabRemapping {
    fn default() -> Self {
        Self {
            new_vocab_offset: None,
            num_new_vocab: None,
            old_vocab_size: Some(-1i64),
            target_device_name: None,
        }
    }
}
impl GenerateVocabRemapping {
    /// Creates a new `GenerateVocabRemapping`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `new_vocab_offset` attribute.
    pub fn new_vocab_offset<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.new_vocab_offset = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_new_vocab` attribute.
    pub fn num_new_vocab<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_new_vocab = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `old_vocab_size` attribute.
    pub fn old_vocab_size<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.old_vocab_size = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute generate_vocab_remapping.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        new_vocab_file: &T0,
        old_vocab_file: &T1,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "GenerateVocabRemapping")?;

        // Required input arguments
        op.add_input(&new_vocab_file.to_handle(ctx)?)?;
        op.add_input(&old_vocab_file.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.new_vocab_offset {
            op.set_attr_int("new_vocab_offset", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_new_vocab {
            op.set_attr_int("num_new_vocab", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.old_vocab_size {
            op.set_attr_int("old_vocab_size", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `GenerateVocabRemapping::new().call(&ctx, &new_vocab_file, &old_vocab_file)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/GenerateVocabRemapping>
pub fn generate_vocab_remapping<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    new_vocab_file: &T0,
    old_vocab_file: &T1,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = GenerateVocabRemapping::new();
    op.call(ctx, new_vocab_file, old_vocab_file)
}

/// GeneratorDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/GeneratorDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct GeneratorDataset {
    init_func: ::std::option::Option<::std::string::String>,
    next_func: ::std::option::Option<::std::string::String>,
    finalize_func: ::std::option::Option<::std::string::String>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for GeneratorDataset {
    fn default() -> Self {
        Self {
            init_func: None,
            next_func: None,
            finalize_func: None,
            output_types: None,
            output_shapes: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl GeneratorDataset {
    /// Creates a new `GeneratorDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `init_func` attribute.
    pub fn init_func<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.init_func = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `next_func` attribute.
    pub fn next_func<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.next_func = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `finalize_func` attribute.
    pub fn finalize_func<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.finalize_func = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute generator_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        init_func_other_args: &T0,
        next_func_other_args: &T1,
        finalize_func_other_args: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "GeneratorDataset")?;

        // Required input arguments
        op.add_input(&init_func_other_args.to_handle(ctx)?)?;
        op.add_input(&next_func_other_args.to_handle(ctx)?)?;
        op.add_input(&finalize_func_other_args.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.init_func {
            op.set_attr_string("init_func", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.next_func {
            op.set_attr_string("next_func", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.finalize_func {
            op.set_attr_string("finalize_func", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `GeneratorDataset::new().call(&ctx, &init_func_other_args, &next_func_other_args, &finalize_func_other_args)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/GeneratorDataset>
pub fn generator_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    init_func_other_args: &T0,
    next_func_other_args: &T1,
    finalize_func_other_args: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = GeneratorDataset::new();
    op.call(
        ctx,
        init_func_other_args,
        next_func_other_args,
        finalize_func_other_args,
    )
}

/// GetElementAtIndex
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/GetElementAtIndex>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct GetElementAtIndex {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for GetElementAtIndex {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl GetElementAtIndex {
    /// Creates a new `GetElementAtIndex`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute get_element_at_index.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        dataset: &T0,
        index: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "GetElementAtIndex")?;

        // Required input arguments
        op.add_input(&dataset.to_handle(ctx)?)?;
        op.add_input(&index.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `GetElementAtIndex::new().call(&ctx, &dataset, &index)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/GetElementAtIndex>
pub fn get_element_at_index<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    dataset: &T0,
    index: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = GetElementAtIndex::new();
    op.call(ctx, dataset, index)
}

/// GetOptions
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/GetOptions>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct GetOptions {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for GetOptions {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl GetOptions {
    /// Creates a new `GetOptions`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute get_options.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "GetOptions")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `GetOptions::new().call(&ctx, &input_dataset)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/GetOptions>
pub fn get_options<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = GetOptions::new();
    op.call(ctx, input_dataset)
}

/// GetSessionHandle
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/GetSessionHandle>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct GetSessionHandle {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for GetSessionHandle {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl GetSessionHandle {
    /// Creates a new `GetSessionHandle`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute get_session_handle.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        value: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "GetSessionHandle")?;

        // Required input arguments
        op.add_input(&value.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `GetSessionHandle::new().call(&ctx, &value)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/GetSessionHandle>
pub fn get_session_handle<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    value: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = GetSessionHandle::new();
    op.call(ctx, value)
}

/// GetSessionHandleV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/GetSessionHandleV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct GetSessionHandleV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for GetSessionHandleV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl GetSessionHandleV2 {
    /// Creates a new `GetSessionHandleV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute get_session_handle_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        value: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "GetSessionHandleV2")?;

        // Required input arguments
        op.add_input(&value.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `GetSessionHandleV2::new().call(&ctx, &value)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/GetSessionHandleV2>
pub fn get_session_handle_v2<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    value: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = GetSessionHandleV2::new();
    op.call(ctx, value)
}

/// GetSessionTensor
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/GetSessionTensor>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct GetSessionTensor {
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for GetSessionTensor {
    fn default() -> Self {
        Self {
            dtype: None,
            target_device_name: None,
        }
    }
}
impl GetSessionTensor {
    /// Creates a new `GetSessionTensor`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute get_session_tensor.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "GetSessionTensor")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `GetSessionTensor::new().call(&ctx, &handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/GetSessionTensor>
pub fn get_session_tensor<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = GetSessionTensor::new();
    op.call(ctx, handle)
}

/// Greater
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Greater>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Greater {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Greater {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Greater {
    /// Creates a new `Greater`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute greater.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Greater")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Greater::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Greater>
pub fn greater<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Greater::new();
    op.call(ctx, x, y)
}

/// GreaterEqual
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/GreaterEqual>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct GreaterEqual {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for GreaterEqual {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl GreaterEqual {
    /// Creates a new `GreaterEqual`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute greater_equal.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "GreaterEqual")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `GreaterEqual::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/GreaterEqual>
pub fn greater_equal<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = GreaterEqual::new();
    op.call(ctx, x, y)
}

/// GroupByReducerDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/GroupByReducerDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct GroupByReducerDataset {
    key_func: ::std::option::Option<::std::string::String>,
    init_func: ::std::option::Option<::std::string::String>,
    reduce_func: ::std::option::Option<::std::string::String>,
    finalize_func: ::std::option::Option<::std::string::String>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for GroupByReducerDataset {
    fn default() -> Self {
        Self {
            key_func: None,
            init_func: None,
            reduce_func: None,
            finalize_func: None,
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl GroupByReducerDataset {
    /// Creates a new `GroupByReducerDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `key_func` attribute.
    pub fn key_func<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.key_func = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `init_func` attribute.
    pub fn init_func<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.init_func = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `reduce_func` attribute.
    pub fn reduce_func<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.reduce_func = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `finalize_func` attribute.
    pub fn finalize_func<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.finalize_func = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute group_by_reducer_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        key_func_other_arguments: &T1,
        init_func_other_arguments: &T2,
        reduce_func_other_arguments: &T3,
        finalize_func_other_arguments: &T4,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "GroupByReducerDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&key_func_other_arguments.to_handle(ctx)?)?;
        op.add_input(&init_func_other_arguments.to_handle(ctx)?)?;
        op.add_input(&reduce_func_other_arguments.to_handle(ctx)?)?;
        op.add_input(&finalize_func_other_arguments.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.key_func {
            op.set_attr_string("key_func", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.init_func {
            op.set_attr_string("init_func", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.reduce_func {
            op.set_attr_string("reduce_func", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.finalize_func {
            op.set_attr_string("finalize_func", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `GroupByReducerDataset::new().call(&ctx, &input_dataset, &key_func_other_arguments, &init_func_other_arguments, &reduce_func_other_arguments, &finalize_func_other_arguments)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/GroupByReducerDataset>
pub fn group_by_reducer_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    key_func_other_arguments: &T1,
    init_func_other_arguments: &T2,
    reduce_func_other_arguments: &T3,
    finalize_func_other_arguments: &T4,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = GroupByReducerDataset::new();
    op.call(
        ctx,
        input_dataset,
        key_func_other_arguments,
        init_func_other_arguments,
        reduce_func_other_arguments,
        finalize_func_other_arguments,
    )
}

/// GroupByWindowDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/GroupByWindowDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct GroupByWindowDataset {
    key_func: ::std::option::Option<::std::string::String>,
    reduce_func: ::std::option::Option<::std::string::String>,
    window_size_func: ::std::option::Option<::std::string::String>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for GroupByWindowDataset {
    fn default() -> Self {
        Self {
            key_func: None,
            reduce_func: None,
            window_size_func: None,
            output_types: None,
            output_shapes: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl GroupByWindowDataset {
    /// Creates a new `GroupByWindowDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `key_func` attribute.
    pub fn key_func<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.key_func = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `reduce_func` attribute.
    pub fn reduce_func<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.reduce_func = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `window_size_func` attribute.
    pub fn window_size_func<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.window_size_func = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute group_by_window_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        key_func_other_arguments: &T1,
        reduce_func_other_arguments: &T2,
        window_size_func_other_arguments: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "GroupByWindowDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&key_func_other_arguments.to_handle(ctx)?)?;
        op.add_input(&reduce_func_other_arguments.to_handle(ctx)?)?;
        op.add_input(&window_size_func_other_arguments.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.key_func {
            op.set_attr_string("key_func", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.reduce_func {
            op.set_attr_string("reduce_func", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.window_size_func {
            op.set_attr_string("window_size_func", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `GroupByWindowDataset::new().call(&ctx, &input_dataset, &key_func_other_arguments, &reduce_func_other_arguments, &window_size_func_other_arguments)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/GroupByWindowDataset>
pub fn group_by_window_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    key_func_other_arguments: &T1,
    reduce_func_other_arguments: &T2,
    window_size_func_other_arguments: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = GroupByWindowDataset::new();
    op.call(
        ctx,
        input_dataset,
        key_func_other_arguments,
        reduce_func_other_arguments,
        window_size_func_other_arguments,
    )
}

/// GuaranteeConst
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/GuaranteeConst>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct GuaranteeConst {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for GuaranteeConst {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl GuaranteeConst {
    /// Creates a new `GuaranteeConst`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute guarantee_const.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "GuaranteeConst")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `GuaranteeConst::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/GuaranteeConst>
pub fn guarantee_const<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = GuaranteeConst::new();
    op.call(ctx, input)
}

/// HSVToRGB
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/HSVToRGB>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct HSVToRGB {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for HSVToRGB {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl HSVToRGB {
    /// Creates a new `HSVToRGB`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute hsvto_rgb.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        images: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "HSVToRGB")?;

        // Required input arguments
        op.add_input(&images.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `HSVToRGB::new().call(&ctx, &images)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/HSVToRGB>
pub fn hsvto_rgb<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    images: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = HSVToRGB::new();
    op.call(ctx, images)
}

/// HashTable
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/HashTable>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct HashTable {
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    use_node_name_sharing: ::std::option::Option<bool>,
    key_dtype: ::std::option::Option<crate::DataType>,
    value_dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for HashTable {
    fn default() -> Self {
        Self {
            container: None,
            shared_name: None,
            use_node_name_sharing: Some(false),
            key_dtype: None,
            value_dtype: None,
            target_device_name: None,
        }
    }
}
impl HashTable {
    /// Creates a new `HashTable`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_node_name_sharing` attribute.
    pub fn use_node_name_sharing<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.use_node_name_sharing = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `key_dtype` attribute.
    pub fn key_dtype<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.key_dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `value_dtype` attribute.
    pub fn value_dtype<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.value_dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute hash_table.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "HashTable")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_node_name_sharing {
            op.set_attr_bool("use_node_name_sharing", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.key_dtype {
            op.set_attr_type("key_dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.value_dtype {
            op.set_attr_type("value_dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `HashTable::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/HashTable>
pub fn hash_table<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = HashTable::new();
    op.call(ctx)
}

/// HashTableV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/HashTableV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct HashTableV2 {
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    use_node_name_sharing: ::std::option::Option<bool>,
    key_dtype: ::std::option::Option<crate::DataType>,
    value_dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for HashTableV2 {
    fn default() -> Self {
        Self {
            container: None,
            shared_name: None,
            use_node_name_sharing: Some(false),
            key_dtype: None,
            value_dtype: None,
            target_device_name: None,
        }
    }
}
impl HashTableV2 {
    /// Creates a new `HashTableV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_node_name_sharing` attribute.
    pub fn use_node_name_sharing<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.use_node_name_sharing = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `key_dtype` attribute.
    pub fn key_dtype<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.key_dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `value_dtype` attribute.
    pub fn value_dtype<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.value_dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute hash_table_v2.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "HashTableV2")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_node_name_sharing {
            op.set_attr_bool("use_node_name_sharing", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.key_dtype {
            op.set_attr_type("key_dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.value_dtype {
            op.set_attr_type("value_dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `HashTableV2::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/HashTableV2>
pub fn hash_table_v2<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = HashTableV2::new();
    op.call(ctx)
}

/// HistogramFixedWidth
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/HistogramFixedWidth>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct HistogramFixedWidth {
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for HistogramFixedWidth {
    fn default() -> Self {
        Self {
            dtype: Some(crate::DataType::Int32),
            target_device_name: None,
        }
    }
}
impl HistogramFixedWidth {
    /// Creates a new `HistogramFixedWidth`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute histogram_fixed_width.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        values: &T0,
        value_range: &T1,
        nbins: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "HistogramFixedWidth")?;

        // Required input arguments
        op.add_input(&values.to_handle(ctx)?)?;
        op.add_input(&value_range.to_handle(ctx)?)?;
        op.add_input(&nbins.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `HistogramFixedWidth::new().call(&ctx, &values, &value_range, &nbins)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/HistogramFixedWidth>
pub fn histogram_fixed_width<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    values: &T0,
    value_range: &T1,
    nbins: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = HistogramFixedWidth::new();
    op.call(ctx, values, value_range, nbins)
}

/// HistogramSummary
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/HistogramSummary>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct HistogramSummary {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for HistogramSummary {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl HistogramSummary {
    /// Creates a new `HistogramSummary`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute histogram_summary.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        tag: &T0,
        values: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "HistogramSummary")?;

        // Required input arguments
        op.add_input(&tag.to_handle(ctx)?)?;
        op.add_input(&values.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `HistogramSummary::new().call(&ctx, &tag, &values)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/HistogramSummary>
pub fn histogram_summary<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    tag: &T0,
    values: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = HistogramSummary::new();
    op.call(ctx, tag, values)
}

/// HostConst
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/HostConst>
#[derive(::std::fmt::Debug)]
pub struct HostConst {
    value: ::std::option::Option<::std::boxed::Box<dyn crate::AnyTensor>>,
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for HostConst {
    fn default() -> Self {
        Self {
            value: None,
            dtype: None,
            target_device_name: None,
        }
    }
}
impl HostConst {
    /// Creates a new `HostConst`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `value` attribute.
    pub fn value<T: crate::TensorType, ArgType: ::std::convert::Into<crate::Tensor<T>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.value = ::std::option::Option::Some(
            ::std::boxed::Box::new(value.into()) as ::std::boxed::Box<dyn crate::AnyTensor>
        );
        self
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute host_const.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "HostConst")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.value {
            op.set_attr_any_tensor("value", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `HostConst::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/HostConst>
pub fn host_const<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = HostConst::new();
    op.call(ctx)
}

/// IFFT
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IFFT>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct IFFT {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for IFFT {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl IFFT {
    /// Creates a new `IFFT`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute ifft.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "IFFT")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `IFFT::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IFFT>
pub fn ifft<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = IFFT::new();
    op.call(ctx, input)
}

/// IFFT2D
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IFFT2D>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct IFFT2D {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for IFFT2D {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl IFFT2D {
    /// Creates a new `IFFT2D`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute ifft2_d.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "IFFT2D")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `IFFT2D::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IFFT2D>
pub fn ifft2_d<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = IFFT2D::new();
    op.call(ctx, input)
}

/// IFFT3D
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IFFT3D>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct IFFT3D {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for IFFT3D {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl IFFT3D {
    /// Creates a new `IFFT3D`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute ifft3_d.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "IFFT3D")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `IFFT3D::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IFFT3D>
pub fn ifft3_d<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = IFFT3D::new();
    op.call(ctx, input)
}

/// IRFFT
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IRFFT>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct IRFFT {
    Treal: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for IRFFT {
    fn default() -> Self {
        Self {
            Treal: Some(crate::DataType::Float),
            target_device_name: None,
        }
    }
}
impl IRFFT {
    /// Creates a new `IRFFT`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Treal` attribute.
    pub fn Treal<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.Treal = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute irfft.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        fft_length: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "IRFFT")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&fft_length.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Treal {
            op.set_attr_type("Treal", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `IRFFT::new().call(&ctx, &input, &fft_length)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IRFFT>
pub fn irfft<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    fft_length: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = IRFFT::new();
    op.call(ctx, input, fft_length)
}

/// IRFFT2D
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IRFFT2D>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct IRFFT2D {
    Treal: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for IRFFT2D {
    fn default() -> Self {
        Self {
            Treal: Some(crate::DataType::Float),
            target_device_name: None,
        }
    }
}
impl IRFFT2D {
    /// Creates a new `IRFFT2D`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Treal` attribute.
    pub fn Treal<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.Treal = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute irfft2_d.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        fft_length: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "IRFFT2D")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&fft_length.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Treal {
            op.set_attr_type("Treal", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `IRFFT2D::new().call(&ctx, &input, &fft_length)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IRFFT2D>
pub fn irfft2_d<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    fft_length: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = IRFFT2D::new();
    op.call(ctx, input, fft_length)
}

/// IRFFT3D
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IRFFT3D>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct IRFFT3D {
    Treal: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for IRFFT3D {
    fn default() -> Self {
        Self {
            Treal: Some(crate::DataType::Float),
            target_device_name: None,
        }
    }
}
impl IRFFT3D {
    /// Creates a new `IRFFT3D`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Treal` attribute.
    pub fn Treal<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.Treal = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute irfft3_d.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        fft_length: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "IRFFT3D")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&fft_length.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Treal {
            op.set_attr_type("Treal", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `IRFFT3D::new().call(&ctx, &input, &fft_length)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IRFFT3D>
pub fn irfft3_d<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    fft_length: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = IRFFT3D::new();
    op.call(ctx, input, fft_length)
}

/// Identity
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Identity>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Identity {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Identity {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Identity {
    /// Creates a new `Identity`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute identity.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Identity")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Identity::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Identity>
pub fn identity<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Identity::new();
    op.call(ctx, input)
}

/// IdentityN
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IdentityN>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct IdentityN {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for IdentityN {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl IdentityN {
    /// Creates a new `IdentityN`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute identity_n.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "IdentityN")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `IdentityN::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IdentityN>
pub fn identity_n<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = IdentityN::new();
    op.call(ctx, input)
}

/// IdentityReader
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IdentityReader>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct IdentityReader {
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for IdentityReader {
    fn default() -> Self {
        Self {
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl IdentityReader {
    /// Creates a new `IdentityReader`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute identity_reader.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "IdentityReader")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `IdentityReader::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IdentityReader>
pub fn identity_reader<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = IdentityReader::new();
    op.call(ctx)
}

/// IdentityReaderV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IdentityReaderV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct IdentityReaderV2 {
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for IdentityReaderV2 {
    fn default() -> Self {
        Self {
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl IdentityReaderV2 {
    /// Creates a new `IdentityReaderV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute identity_reader_v2.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "IdentityReaderV2")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `IdentityReaderV2::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IdentityReaderV2>
pub fn identity_reader_v2<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = IdentityReaderV2::new();
    op.call(ctx)
}

/// If
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/If>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct If {
    Tout: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    then_branch: ::std::option::Option<::std::string::String>,
    else_branch: ::std::option::Option<::std::string::String>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for If {
    fn default() -> Self {
        Self {
            Tout: None,
            then_branch: None,
            else_branch: None,
            output_shapes: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl If {
    /// Creates a new `If`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Tout` attribute.
    pub fn Tout<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Tout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `then_branch` attribute.
    pub fn then_branch<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.then_branch = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `else_branch` attribute.
    pub fn else_branch<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.else_branch = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute if_.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        cond: &T0,
        input: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "If")?;

        // Required input arguments
        op.add_input(&cond.to_handle(ctx)?)?;
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Tout {
            op.set_attr_type_list("Tout", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.then_branch {
            op.set_attr_string("then_branch", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.else_branch {
            op.set_attr_string("else_branch", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `If::new().call(&ctx, &cond, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/If>
pub fn if_<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    cond: &T0,
    input: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = If::new();
    op.call(ctx, cond, input)
}

/// Igamma
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Igamma>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Igamma {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Igamma {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Igamma {
    /// Creates a new `Igamma`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute igamma.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        a: &T0,
        x: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Igamma")?;

        // Required input arguments
        op.add_input(&a.to_handle(ctx)?)?;
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Igamma::new().call(&ctx, &a, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Igamma>
pub fn igamma<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    a: &T0,
    x: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Igamma::new();
    op.call(ctx, a, x)
}

/// IgammaGradA
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IgammaGradA>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct IgammaGradA {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for IgammaGradA {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl IgammaGradA {
    /// Creates a new `IgammaGradA`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute igamma_grad_a.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        a: &T0,
        x: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "IgammaGradA")?;

        // Required input arguments
        op.add_input(&a.to_handle(ctx)?)?;
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `IgammaGradA::new().call(&ctx, &a, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IgammaGradA>
pub fn igamma_grad_a<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    a: &T0,
    x: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = IgammaGradA::new();
    op.call(ctx, a, x)
}

/// Igammac
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Igammac>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Igammac {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Igammac {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Igammac {
    /// Creates a new `Igammac`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute igammac.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        a: &T0,
        x: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Igammac")?;

        // Required input arguments
        op.add_input(&a.to_handle(ctx)?)?;
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Igammac::new().call(&ctx, &a, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Igammac>
pub fn igammac<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    a: &T0,
    x: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Igammac::new();
    op.call(ctx, a, x)
}

/// IgnoreErrorsDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IgnoreErrorsDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct IgnoreErrorsDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    log_warning: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for IgnoreErrorsDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            log_warning: Some(false),
            target_device_name: None,
        }
    }
}
impl IgnoreErrorsDataset {
    /// Creates a new `IgnoreErrorsDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `log_warning` attribute.
    pub fn log_warning<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.log_warning = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute ignore_errors_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "IgnoreErrorsDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.log_warning {
            op.set_attr_bool("log_warning", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `IgnoreErrorsDataset::new().call(&ctx, &input_dataset)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IgnoreErrorsDataset>
pub fn ignore_errors_dataset<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = IgnoreErrorsDataset::new();
    op.call(ctx, input_dataset)
}

/// Imag
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Imag>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Imag {
    Tout: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Imag {
    fn default() -> Self {
        Self {
            Tout: Some(crate::DataType::Float),
            target_device_name: None,
        }
    }
}
impl Imag {
    /// Creates a new `Imag`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Tout` attribute.
    pub fn Tout<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.Tout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute imag.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Imag")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Tout {
            op.set_attr_type("Tout", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Imag::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Imag>
pub fn imag<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Imag::new();
    op.call(ctx, input)
}

/// ImageProjectiveTransformV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ImageProjectiveTransformV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ImageProjectiveTransformV2 {
    interpolation: ::std::option::Option<::std::string::String>,
    fill_mode: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ImageProjectiveTransformV2 {
    fn default() -> Self {
        Self {
            interpolation: None,
            fill_mode: Some(::std::string::String::from("CONSTANT")),
            target_device_name: None,
        }
    }
}
impl ImageProjectiveTransformV2 {
    /// Creates a new `ImageProjectiveTransformV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `interpolation` attribute.
    pub fn interpolation<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.interpolation = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `fill_mode` attribute.
    pub fn fill_mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.fill_mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute image_projective_transform_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        images: &T0,
        transforms: &T1,
        output_shape: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ImageProjectiveTransformV2")?;

        // Required input arguments
        op.add_input(&images.to_handle(ctx)?)?;
        op.add_input(&transforms.to_handle(ctx)?)?;
        op.add_input(&output_shape.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.interpolation {
            op.set_attr_string("interpolation", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.fill_mode {
            op.set_attr_string("fill_mode", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ImageProjectiveTransformV2::new().call(&ctx, &images, &transforms, &output_shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ImageProjectiveTransformV2>
pub fn image_projective_transform_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    images: &T0,
    transforms: &T1,
    output_shape: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ImageProjectiveTransformV2::new();
    op.call(ctx, images, transforms, output_shape)
}

/// ImageProjectiveTransformV3
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ImageProjectiveTransformV3>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ImageProjectiveTransformV3 {
    interpolation: ::std::option::Option<::std::string::String>,
    fill_mode: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ImageProjectiveTransformV3 {
    fn default() -> Self {
        Self {
            interpolation: None,
            fill_mode: Some(::std::string::String::from("CONSTANT")),
            target_device_name: None,
        }
    }
}
impl ImageProjectiveTransformV3 {
    /// Creates a new `ImageProjectiveTransformV3`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `interpolation` attribute.
    pub fn interpolation<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.interpolation = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `fill_mode` attribute.
    pub fn fill_mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.fill_mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute image_projective_transform_v3.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        images: &T0,
        transforms: &T1,
        output_shape: &T2,
        fill_value: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ImageProjectiveTransformV3")?;

        // Required input arguments
        op.add_input(&images.to_handle(ctx)?)?;
        op.add_input(&transforms.to_handle(ctx)?)?;
        op.add_input(&output_shape.to_handle(ctx)?)?;
        op.add_input(&fill_value.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.interpolation {
            op.set_attr_string("interpolation", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.fill_mode {
            op.set_attr_string("fill_mode", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ImageProjectiveTransformV3::new().call(&ctx, &images, &transforms, &output_shape, &fill_value)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ImageProjectiveTransformV3>
pub fn image_projective_transform_v3<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    images: &T0,
    transforms: &T1,
    output_shape: &T2,
    fill_value: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ImageProjectiveTransformV3::new();
    op.call(ctx, images, transforms, output_shape, fill_value)
}

/// ImageSummary
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ImageSummary>
#[derive(::std::fmt::Debug)]
pub struct ImageSummary {
    max_images: ::std::option::Option<i64>,
    bad_color: ::std::option::Option<::std::boxed::Box<dyn crate::AnyTensor>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ImageSummary {
    fn default() -> Self {
        Self {
            max_images: Some(3i64),
            bad_color: None,
            target_device_name: None,
        }
    }
}
impl ImageSummary {
    /// Creates a new `ImageSummary`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `max_images` attribute.
    pub fn max_images<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.max_images = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `bad_color` attribute.
    pub fn bad_color<T: crate::TensorType, ArgType: ::std::convert::Into<crate::Tensor<T>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.bad_color = ::std::option::Option::Some(
            ::std::boxed::Box::new(value.into()) as ::std::boxed::Box<dyn crate::AnyTensor>
        );
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute image_summary.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        tag: &T0,
        tensor: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ImageSummary")?;

        // Required input arguments
        op.add_input(&tag.to_handle(ctx)?)?;
        op.add_input(&tensor.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.max_images {
            op.set_attr_int("max_images", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.bad_color {
            op.set_attr_any_tensor("bad_color", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ImageSummary::new().call(&ctx, &tag, &tensor)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ImageSummary>
pub fn image_summary<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    tag: &T0,
    tensor: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ImageSummary::new();
    op.call(ctx, tag, tensor)
}

/// ImmutableConst
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ImmutableConst>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ImmutableConst {
    dtype: ::std::option::Option<crate::DataType>,
    shape: ::std::option::Option<crate::Shape>,
    memory_region_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ImmutableConst {
    fn default() -> Self {
        Self {
            dtype: None,
            shape: None,
            memory_region_name: None,
            target_device_name: None,
        }
    }
}
impl ImmutableConst {
    /// Creates a new `ImmutableConst`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shape` attribute.
    pub fn shape<ArgType: ::std::convert::Into<crate::Shape>>(mut self, value: ArgType) -> Self {
        self.shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `memory_region_name` attribute.
    pub fn memory_region_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.memory_region_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute immutable_const.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ImmutableConst")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shape {
            op.set_attr_shape("shape", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.memory_region_name {
            op.set_attr_string("memory_region_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ImmutableConst::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ImmutableConst>
pub fn immutable_const<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ImmutableConst::new();
    op.call(ctx)
}

/// ImportEvent
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ImportEvent>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ImportEvent {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ImportEvent {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ImportEvent {
    /// Creates a new `ImportEvent`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute import_event.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        writer: &T0,
        event: &T1,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ImportEvent")?;

        // Required input arguments
        op.add_input(&writer.to_handle(ctx)?)?;
        op.add_input(&event.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ImportEvent::new().call(&ctx, &writer, &event)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ImportEvent>
pub fn import_event<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    writer: &T0,
    event: &T1,
) -> crate::Result<()> {
    let op = ImportEvent::new();
    op.call(ctx, writer, event)
}

/// InTopK
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/InTopK>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct InTopK {
    k: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for InTopK {
    fn default() -> Self {
        Self {
            k: None,
            target_device_name: None,
        }
    }
}
impl InTopK {
    /// Creates a new `InTopK`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `k` attribute.
    pub fn k<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.k = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute in_top_k.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        predictions: &T0,
        targets: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "InTopK")?;

        // Required input arguments
        op.add_input(&predictions.to_handle(ctx)?)?;
        op.add_input(&targets.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.k {
            op.set_attr_int("k", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `InTopK::new().call(&ctx, &predictions, &targets)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/InTopK>
pub fn in_top_k<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    predictions: &T0,
    targets: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = InTopK::new();
    op.call(ctx, predictions, targets)
}

/// InTopKV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/InTopKV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct InTopKV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for InTopKV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl InTopKV2 {
    /// Creates a new `InTopKV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute in_top_kv2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        predictions: &T0,
        targets: &T1,
        k: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "InTopKV2")?;

        // Required input arguments
        op.add_input(&predictions.to_handle(ctx)?)?;
        op.add_input(&targets.to_handle(ctx)?)?;
        op.add_input(&k.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `InTopKV2::new().call(&ctx, &predictions, &targets, &k)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/InTopKV2>
pub fn in_top_kv2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    predictions: &T0,
    targets: &T1,
    k: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = InTopKV2::new();
    op.call(ctx, predictions, targets, k)
}

/// InfeedDequeue
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/InfeedDequeue>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct InfeedDequeue {
    dtype: ::std::option::Option<crate::DataType>,
    shape: ::std::option::Option<crate::Shape>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for InfeedDequeue {
    fn default() -> Self {
        Self {
            dtype: None,
            shape: None,
            target_device_name: None,
        }
    }
}
impl InfeedDequeue {
    /// Creates a new `InfeedDequeue`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shape` attribute.
    pub fn shape<ArgType: ::std::convert::Into<crate::Shape>>(mut self, value: ArgType) -> Self {
        self.shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute infeed_dequeue.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "InfeedDequeue")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shape {
            op.set_attr_shape("shape", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `InfeedDequeue::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/InfeedDequeue>
pub fn infeed_dequeue<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = InfeedDequeue::new();
    op.call(ctx)
}

/// InfeedDequeueTuple
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/InfeedDequeueTuple>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct InfeedDequeueTuple {
    dtypes: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for InfeedDequeueTuple {
    fn default() -> Self {
        Self {
            dtypes: None,
            shapes: None,
            target_device_name: None,
        }
    }
}
impl InfeedDequeueTuple {
    /// Creates a new `InfeedDequeueTuple`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtypes` attribute.
    pub fn dtypes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dtypes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shapes` attribute.
    pub fn shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute infeed_dequeue_tuple.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "InfeedDequeueTuple")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtypes {
            op.set_attr_type_list("dtypes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shapes {
            op.set_attr_shape_list("shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `InfeedDequeueTuple::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/InfeedDequeueTuple>
pub fn infeed_dequeue_tuple<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = InfeedDequeueTuple::new();
    op.call(ctx)
}

/// InfeedEnqueue
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/InfeedEnqueue>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct InfeedEnqueue {
    shape: ::std::option::Option<crate::Shape>,
    layout: ::std::option::Option<::std::vec::Vec<i64>>,
    device_ordinal: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for InfeedEnqueue {
    fn default() -> Self {
        Self {
            shape: None,
            layout: Some(vec![]),
            device_ordinal: Some(-1i64),
            target_device_name: None,
        }
    }
}
impl InfeedEnqueue {
    /// Creates a new `InfeedEnqueue`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `shape` attribute.
    pub fn shape<ArgType: ::std::convert::Into<crate::Shape>>(mut self, value: ArgType) -> Self {
        self.shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `layout` attribute.
    pub fn layout<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.layout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `device_ordinal` attribute.
    pub fn device_ordinal<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.device_ordinal = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute infeed_enqueue.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "InfeedEnqueue")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.shape {
            op.set_attr_shape("shape", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.layout {
            op.set_attr_int_list("layout", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.device_ordinal {
            op.set_attr_int("device_ordinal", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `InfeedEnqueue::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/InfeedEnqueue>
pub fn infeed_enqueue<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<()> {
    let op = InfeedEnqueue::new();
    op.call(ctx, input)
}

/// InfeedEnqueuePrelinearizedBuffer
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/InfeedEnqueuePrelinearizedBuffer>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct InfeedEnqueuePrelinearizedBuffer {
    device_ordinal: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for InfeedEnqueuePrelinearizedBuffer {
    fn default() -> Self {
        Self {
            device_ordinal: Some(-1i64),
            target_device_name: None,
        }
    }
}
impl InfeedEnqueuePrelinearizedBuffer {
    /// Creates a new `InfeedEnqueuePrelinearizedBuffer`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `device_ordinal` attribute.
    pub fn device_ordinal<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.device_ordinal = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute infeed_enqueue_prelinearized_buffer.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "InfeedEnqueuePrelinearizedBuffer")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.device_ordinal {
            op.set_attr_int("device_ordinal", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `InfeedEnqueuePrelinearizedBuffer::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/InfeedEnqueuePrelinearizedBuffer>
pub fn infeed_enqueue_prelinearized_buffer<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<()> {
    let op = InfeedEnqueuePrelinearizedBuffer::new();
    op.call(ctx, input)
}

/// InfeedEnqueueTuple
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/InfeedEnqueueTuple>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct InfeedEnqueueTuple {
    shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    layouts: ::std::option::Option<::std::vec::Vec<i64>>,
    device_ordinal: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for InfeedEnqueueTuple {
    fn default() -> Self {
        Self {
            shapes: None,
            layouts: Some(vec![]),
            device_ordinal: Some(-1i64),
            target_device_name: None,
        }
    }
}
impl InfeedEnqueueTuple {
    /// Creates a new `InfeedEnqueueTuple`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `shapes` attribute.
    pub fn shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `layouts` attribute.
    pub fn layouts<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.layouts = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `device_ordinal` attribute.
    pub fn device_ordinal<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.device_ordinal = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute infeed_enqueue_tuple.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        inputs: &T0,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "InfeedEnqueueTuple")?;

        // Required input arguments
        op.add_input(&inputs.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.shapes {
            op.set_attr_shape_list("shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.layouts {
            op.set_attr_int_list("layouts", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.device_ordinal {
            op.set_attr_int("device_ordinal", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `InfeedEnqueueTuple::new().call(&ctx, &inputs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/InfeedEnqueueTuple>
pub fn infeed_enqueue_tuple<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    inputs: &T0,
) -> crate::Result<()> {
    let op = InfeedEnqueueTuple::new();
    op.call(ctx, inputs)
}

/// InitializeTable
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/InitializeTable>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct InitializeTable {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for InitializeTable {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl InitializeTable {
    /// Creates a new `InitializeTable`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute initialize_table.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        table_handle: &T0,
        keys: &T1,
        values: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "InitializeTable")?;

        // Required input arguments
        op.add_input(&table_handle.to_handle(ctx)?)?;
        op.add_input(&keys.to_handle(ctx)?)?;
        op.add_input(&values.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `InitializeTable::new().call(&ctx, &table_handle, &keys, &values)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/InitializeTable>
pub fn initialize_table<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    table_handle: &T0,
    keys: &T1,
    values: &T2,
) -> crate::Result<()> {
    let op = InitializeTable::new();
    op.call(ctx, table_handle, keys, values)
}

/// InitializeTableFromDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/InitializeTableFromDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct InitializeTableFromDataset {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for InitializeTableFromDataset {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl InitializeTableFromDataset {
    /// Creates a new `InitializeTableFromDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute initialize_table_from_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        table_handle: &T0,
        dataset: &T1,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "InitializeTableFromDataset")?;

        // Required input arguments
        op.add_input(&table_handle.to_handle(ctx)?)?;
        op.add_input(&dataset.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `InitializeTableFromDataset::new().call(&ctx, &table_handle, &dataset)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/InitializeTableFromDataset>
pub fn initialize_table_from_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    table_handle: &T0,
    dataset: &T1,
) -> crate::Result<()> {
    let op = InitializeTableFromDataset::new();
    op.call(ctx, table_handle, dataset)
}

/// InitializeTableFromTextFile
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/InitializeTableFromTextFile>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct InitializeTableFromTextFile {
    key_index: ::std::option::Option<i64>,
    value_index: ::std::option::Option<i64>,
    vocab_size: ::std::option::Option<i64>,
    delimiter: ::std::option::Option<::std::string::String>,
    offset: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for InitializeTableFromTextFile {
    fn default() -> Self {
        Self {
            key_index: None,
            value_index: None,
            vocab_size: Some(-1i64),
            delimiter: Some(::std::string::String::from("	")),
            offset: Some(0i64),
            target_device_name: None,
        }
    }
}
impl InitializeTableFromTextFile {
    /// Creates a new `InitializeTableFromTextFile`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `key_index` attribute.
    pub fn key_index<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.key_index = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `value_index` attribute.
    pub fn value_index<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.value_index = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `vocab_size` attribute.
    pub fn vocab_size<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.vocab_size = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `delimiter` attribute.
    pub fn delimiter<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.delimiter = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `offset` attribute.
    pub fn offset<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.offset = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute initialize_table_from_text_file.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        table_handle: &T0,
        filename: &T1,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "InitializeTableFromTextFile")?;

        // Required input arguments
        op.add_input(&table_handle.to_handle(ctx)?)?;
        op.add_input(&filename.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.key_index {
            op.set_attr_int("key_index", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.value_index {
            op.set_attr_int("value_index", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.vocab_size {
            op.set_attr_int("vocab_size", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.delimiter {
            op.set_attr_string("delimiter", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.offset {
            op.set_attr_int("offset", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `InitializeTableFromTextFile::new().call(&ctx, &table_handle, &filename)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/InitializeTableFromTextFile>
pub fn initialize_table_from_text_file<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    table_handle: &T0,
    filename: &T1,
) -> crate::Result<()> {
    let op = InitializeTableFromTextFile::new();
    op.call(ctx, table_handle, filename)
}

/// InitializeTableFromTextFileV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/InitializeTableFromTextFileV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct InitializeTableFromTextFileV2 {
    key_index: ::std::option::Option<i64>,
    value_index: ::std::option::Option<i64>,
    vocab_size: ::std::option::Option<i64>,
    delimiter: ::std::option::Option<::std::string::String>,
    offset: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for InitializeTableFromTextFileV2 {
    fn default() -> Self {
        Self {
            key_index: None,
            value_index: None,
            vocab_size: Some(-1i64),
            delimiter: Some(::std::string::String::from("	")),
            offset: Some(0i64),
            target_device_name: None,
        }
    }
}
impl InitializeTableFromTextFileV2 {
    /// Creates a new `InitializeTableFromTextFileV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `key_index` attribute.
    pub fn key_index<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.key_index = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `value_index` attribute.
    pub fn value_index<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.value_index = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `vocab_size` attribute.
    pub fn vocab_size<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.vocab_size = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `delimiter` attribute.
    pub fn delimiter<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.delimiter = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `offset` attribute.
    pub fn offset<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.offset = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute initialize_table_from_text_file_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        table_handle: &T0,
        filename: &T1,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "InitializeTableFromTextFileV2")?;

        // Required input arguments
        op.add_input(&table_handle.to_handle(ctx)?)?;
        op.add_input(&filename.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.key_index {
            op.set_attr_int("key_index", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.value_index {
            op.set_attr_int("value_index", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.vocab_size {
            op.set_attr_int("vocab_size", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.delimiter {
            op.set_attr_string("delimiter", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.offset {
            op.set_attr_int("offset", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `InitializeTableFromTextFileV2::new().call(&ctx, &table_handle, &filename)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/InitializeTableFromTextFileV2>
pub fn initialize_table_from_text_file_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    table_handle: &T0,
    filename: &T1,
) -> crate::Result<()> {
    let op = InitializeTableFromTextFileV2::new();
    op.call(ctx, table_handle, filename)
}

/// InitializeTableV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/InitializeTableV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct InitializeTableV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for InitializeTableV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl InitializeTableV2 {
    /// Creates a new `InitializeTableV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute initialize_table_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        table_handle: &T0,
        keys: &T1,
        values: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "InitializeTableV2")?;

        // Required input arguments
        op.add_input(&table_handle.to_handle(ctx)?)?;
        op.add_input(&keys.to_handle(ctx)?)?;
        op.add_input(&values.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `InitializeTableV2::new().call(&ctx, &table_handle, &keys, &values)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/InitializeTableV2>
pub fn initialize_table_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    table_handle: &T0,
    keys: &T1,
    values: &T2,
) -> crate::Result<()> {
    let op = InitializeTableV2::new();
    op.call(ctx, table_handle, keys, values)
}

/// InplaceAdd
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/InplaceAdd>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct InplaceAdd {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for InplaceAdd {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl InplaceAdd {
    /// Creates a new `InplaceAdd`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute inplace_add.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        i: &T1,
        v: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "InplaceAdd")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&i.to_handle(ctx)?)?;
        op.add_input(&v.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `InplaceAdd::new().call(&ctx, &x, &i, &v)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/InplaceAdd>
pub fn inplace_add<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    i: &T1,
    v: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = InplaceAdd::new();
    op.call(ctx, x, i, v)
}

/// InplaceSub
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/InplaceSub>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct InplaceSub {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for InplaceSub {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl InplaceSub {
    /// Creates a new `InplaceSub`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute inplace_sub.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        i: &T1,
        v: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "InplaceSub")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&i.to_handle(ctx)?)?;
        op.add_input(&v.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `InplaceSub::new().call(&ctx, &x, &i, &v)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/InplaceSub>
pub fn inplace_sub<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    i: &T1,
    v: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = InplaceSub::new();
    op.call(ctx, x, i, v)
}

/// InplaceUpdate
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/InplaceUpdate>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct InplaceUpdate {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for InplaceUpdate {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl InplaceUpdate {
    /// Creates a new `InplaceUpdate`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute inplace_update.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        i: &T1,
        v: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "InplaceUpdate")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&i.to_handle(ctx)?)?;
        op.add_input(&v.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `InplaceUpdate::new().call(&ctx, &x, &i, &v)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/InplaceUpdate>
pub fn inplace_update<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    i: &T1,
    v: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = InplaceUpdate::new();
    op.call(ctx, x, i, v)
}

/// InterleaveDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/InterleaveDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct InterleaveDataset {
    f: ::std::option::Option<::std::string::String>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for InterleaveDataset {
    fn default() -> Self {
        Self {
            f: None,
            output_types: None,
            output_shapes: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl InterleaveDataset {
    /// Creates a new `InterleaveDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `f` attribute.
    pub fn f<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.f = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute interleave_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        other_arguments: &T1,
        cycle_length: &T2,
        block_length: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "InterleaveDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&other_arguments.to_handle(ctx)?)?;
        op.add_input(&cycle_length.to_handle(ctx)?)?;
        op.add_input(&block_length.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.f {
            op.set_attr_string("f", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `InterleaveDataset::new().call(&ctx, &input_dataset, &other_arguments, &cycle_length, &block_length)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/InterleaveDataset>
pub fn interleave_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    other_arguments: &T1,
    cycle_length: &T2,
    block_length: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = InterleaveDataset::new();
    op.call(
        ctx,
        input_dataset,
        other_arguments,
        cycle_length,
        block_length,
    )
}

/// Inv
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Inv>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Inv {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Inv {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Inv {
    /// Creates a new `Inv`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute inv.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Inv")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Inv::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Inv>
pub fn inv<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Inv::new();
    op.call(ctx, x)
}

/// InvGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/InvGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct InvGrad {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for InvGrad {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl InvGrad {
    /// Creates a new `InvGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute inv_grad.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        y: &T0,
        dy: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "InvGrad")?;

        // Required input arguments
        op.add_input(&y.to_handle(ctx)?)?;
        op.add_input(&dy.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `InvGrad::new().call(&ctx, &y, &dy)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/InvGrad>
pub fn inv_grad<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    y: &T0,
    dy: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = InvGrad::new();
    op.call(ctx, y, dy)
}

/// Invert
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Invert>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Invert {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Invert {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Invert {
    /// Creates a new `Invert`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute invert.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Invert")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Invert::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Invert>
pub fn invert<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Invert::new();
    op.call(ctx, x)
}

/// InvertPermutation
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/InvertPermutation>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct InvertPermutation {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for InvertPermutation {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl InvertPermutation {
    /// Creates a new `InvertPermutation`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute invert_permutation.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "InvertPermutation")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `InvertPermutation::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/InvertPermutation>
pub fn invert_permutation<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = InvertPermutation::new();
    op.call(ctx, x)
}

/// IsBoostedTreesEnsembleInitialized
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IsBoostedTreesEnsembleInitialized>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct IsBoostedTreesEnsembleInitialized {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for IsBoostedTreesEnsembleInitialized {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl IsBoostedTreesEnsembleInitialized {
    /// Creates a new `IsBoostedTreesEnsembleInitialized`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute is_boosted_trees_ensemble_initialized.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        tree_ensemble_handle: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "IsBoostedTreesEnsembleInitialized")?;

        // Required input arguments
        op.add_input(&tree_ensemble_handle.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `IsBoostedTreesEnsembleInitialized::new().call(&ctx, &tree_ensemble_handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IsBoostedTreesEnsembleInitialized>
pub fn is_boosted_trees_ensemble_initialized<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    tree_ensemble_handle: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = IsBoostedTreesEnsembleInitialized::new();
    op.call(ctx, tree_ensemble_handle)
}

/// IsBoostedTreesQuantileStreamResourceInitialized
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IsBoostedTreesQuantileStreamResourceInitialized>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct IsBoostedTreesQuantileStreamResourceInitialized {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for IsBoostedTreesQuantileStreamResourceInitialized {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl IsBoostedTreesQuantileStreamResourceInitialized {
    /// Creates a new `IsBoostedTreesQuantileStreamResourceInitialized`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute is_boosted_trees_quantile_stream_resource_initialized.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        quantile_stream_resource_handle: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "IsBoostedTreesQuantileStreamResourceInitialized")?;

        // Required input arguments
        op.add_input(&quantile_stream_resource_handle.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `IsBoostedTreesQuantileStreamResourceInitialized::new().call(&ctx, &quantile_stream_resource_handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IsBoostedTreesQuantileStreamResourceInitialized>
pub fn is_boosted_trees_quantile_stream_resource_initialized<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    quantile_stream_resource_handle: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = IsBoostedTreesQuantileStreamResourceInitialized::new();
    op.call(ctx, quantile_stream_resource_handle)
}

/// IsFinite
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IsFinite>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct IsFinite {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for IsFinite {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl IsFinite {
    /// Creates a new `IsFinite`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute is_finite.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "IsFinite")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `IsFinite::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IsFinite>
pub fn is_finite<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = IsFinite::new();
    op.call(ctx, x)
}

/// IsInf
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IsInf>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct IsInf {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for IsInf {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl IsInf {
    /// Creates a new `IsInf`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute is_inf.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "IsInf")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `IsInf::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IsInf>
pub fn is_inf<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = IsInf::new();
    op.call(ctx, x)
}

/// IsNan
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IsNan>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct IsNan {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for IsNan {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl IsNan {
    /// Creates a new `IsNan`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute is_nan.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "IsNan")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `IsNan::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IsNan>
pub fn is_nan<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = IsNan::new();
    op.call(ctx, x)
}

/// IsTPUEmbeddingInitialized
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IsTPUEmbeddingInitialized>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct IsTPUEmbeddingInitialized {
    config: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for IsTPUEmbeddingInitialized {
    fn default() -> Self {
        Self {
            config: None,
            target_device_name: None,
        }
    }
}
impl IsTPUEmbeddingInitialized {
    /// Creates a new `IsTPUEmbeddingInitialized`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute is_tpuembedding_initialized.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "IsTPUEmbeddingInitialized")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `IsTPUEmbeddingInitialized::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IsTPUEmbeddingInitialized>
pub fn is_tpuembedding_initialized<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = IsTPUEmbeddingInitialized::new();
    op.call(ctx)
}

/// IsVariableInitialized
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IsVariableInitialized>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct IsVariableInitialized {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for IsVariableInitialized {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl IsVariableInitialized {
    /// Creates a new `IsVariableInitialized`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute is_variable_initialized.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        ref_: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "IsVariableInitialized")?;

        // Required input arguments
        op.add_input(&ref_.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `IsVariableInitialized::new().call(&ctx, &ref_)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IsVariableInitialized>
pub fn is_variable_initialized<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    ref_: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = IsVariableInitialized::new();
    op.call(ctx, ref_)
}

/// IsotonicRegression
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IsotonicRegression>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct IsotonicRegression {
    output_dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for IsotonicRegression {
    fn default() -> Self {
        Self {
            output_dtype: Some(crate::DataType::Float),
            target_device_name: None,
        }
    }
}
impl IsotonicRegression {
    /// Creates a new `IsotonicRegression`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_dtype` attribute.
    pub fn output_dtype<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute isotonic_regression.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "IsotonicRegression")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_dtype {
            op.set_attr_type("output_dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `IsotonicRegression::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IsotonicRegression>
pub fn isotonic_regression<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = IsotonicRegression::new();
    op.call(ctx, input)
}

/// Iterator
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Iterator>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Iterator {
    shared_name: ::std::option::Option<::std::string::String>,
    container: ::std::option::Option<::std::string::String>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Iterator {
    fn default() -> Self {
        Self {
            shared_name: None,
            container: None,
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl Iterator {
    /// Creates a new `Iterator`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute iterator.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Iterator")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Iterator::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Iterator>
pub fn iterator<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Iterator::new();
    op.call(ctx)
}

/// IteratorFromStringHandle
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IteratorFromStringHandle>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct IteratorFromStringHandle {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for IteratorFromStringHandle {
    fn default() -> Self {
        Self {
            output_types: Some(vec![]),
            output_shapes: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl IteratorFromStringHandle {
    /// Creates a new `IteratorFromStringHandle`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute iterator_from_string_handle.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        string_handle: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "IteratorFromStringHandle")?;

        // Required input arguments
        op.add_input(&string_handle.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `IteratorFromStringHandle::new().call(&ctx, &string_handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IteratorFromStringHandle>
pub fn iterator_from_string_handle<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    string_handle: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = IteratorFromStringHandle::new();
    op.call(ctx, string_handle)
}

/// IteratorFromStringHandleV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IteratorFromStringHandleV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct IteratorFromStringHandleV2 {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for IteratorFromStringHandleV2 {
    fn default() -> Self {
        Self {
            output_types: Some(vec![]),
            output_shapes: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl IteratorFromStringHandleV2 {
    /// Creates a new `IteratorFromStringHandleV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute iterator_from_string_handle_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        string_handle: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "IteratorFromStringHandleV2")?;

        // Required input arguments
        op.add_input(&string_handle.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `IteratorFromStringHandleV2::new().call(&ctx, &string_handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IteratorFromStringHandleV2>
pub fn iterator_from_string_handle_v2<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    string_handle: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = IteratorFromStringHandleV2::new();
    op.call(ctx, string_handle)
}

/// IteratorGetDevice
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IteratorGetDevice>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct IteratorGetDevice {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for IteratorGetDevice {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl IteratorGetDevice {
    /// Creates a new `IteratorGetDevice`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute iterator_get_device.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        resource: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "IteratorGetDevice")?;

        // Required input arguments
        op.add_input(&resource.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `IteratorGetDevice::new().call(&ctx, &resource)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IteratorGetDevice>
pub fn iterator_get_device<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    resource: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = IteratorGetDevice::new();
    op.call(ctx, resource)
}

/// IteratorGetNext
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IteratorGetNext>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct IteratorGetNext {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for IteratorGetNext {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl IteratorGetNext {
    /// Creates a new `IteratorGetNext`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute iterator_get_next.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        iterator: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "IteratorGetNext")?;

        // Required input arguments
        op.add_input(&iterator.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `IteratorGetNext::new().call(&ctx, &iterator)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IteratorGetNext>
pub fn iterator_get_next<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    iterator: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = IteratorGetNext::new();
    op.call(ctx, iterator)
}

/// IteratorGetNextAsOptional
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IteratorGetNextAsOptional>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct IteratorGetNextAsOptional {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for IteratorGetNextAsOptional {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl IteratorGetNextAsOptional {
    /// Creates a new `IteratorGetNextAsOptional`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute iterator_get_next_as_optional.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        iterator: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "IteratorGetNextAsOptional")?;

        // Required input arguments
        op.add_input(&iterator.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `IteratorGetNextAsOptional::new().call(&ctx, &iterator)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IteratorGetNextAsOptional>
pub fn iterator_get_next_as_optional<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    iterator: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = IteratorGetNextAsOptional::new();
    op.call(ctx, iterator)
}

/// IteratorGetNextSync
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IteratorGetNextSync>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct IteratorGetNextSync {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for IteratorGetNextSync {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl IteratorGetNextSync {
    /// Creates a new `IteratorGetNextSync`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute iterator_get_next_sync.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        iterator: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "IteratorGetNextSync")?;

        // Required input arguments
        op.add_input(&iterator.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `IteratorGetNextSync::new().call(&ctx, &iterator)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IteratorGetNextSync>
pub fn iterator_get_next_sync<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    iterator: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = IteratorGetNextSync::new();
    op.call(ctx, iterator)
}

/// IteratorToStringHandle
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IteratorToStringHandle>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct IteratorToStringHandle {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for IteratorToStringHandle {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl IteratorToStringHandle {
    /// Creates a new `IteratorToStringHandle`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute iterator_to_string_handle.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        resource_handle: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "IteratorToStringHandle")?;

        // Required input arguments
        op.add_input(&resource_handle.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `IteratorToStringHandle::new().call(&ctx, &resource_handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IteratorToStringHandle>
pub fn iterator_to_string_handle<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    resource_handle: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = IteratorToStringHandle::new();
    op.call(ctx, resource_handle)
}

/// IteratorV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IteratorV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct IteratorV2 {
    shared_name: ::std::option::Option<::std::string::String>,
    container: ::std::option::Option<::std::string::String>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for IteratorV2 {
    fn default() -> Self {
        Self {
            shared_name: None,
            container: None,
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl IteratorV2 {
    /// Creates a new `IteratorV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute iterator_v2.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "IteratorV2")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `IteratorV2::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/IteratorV2>
pub fn iterator_v2<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = IteratorV2::new();
    op.call(ctx)
}

/// KMC2ChainInitialization
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/KMC2ChainInitialization>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct KMC2ChainInitialization {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for KMC2ChainInitialization {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl KMC2ChainInitialization {
    /// Creates a new `KMC2ChainInitialization`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute kmc2_chain_initialization.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        distances: &T0,
        seed: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "KMC2ChainInitialization")?;

        // Required input arguments
        op.add_input(&distances.to_handle(ctx)?)?;
        op.add_input(&seed.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `KMC2ChainInitialization::new().call(&ctx, &distances, &seed)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/KMC2ChainInitialization>
pub fn kmc2_chain_initialization<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    distances: &T0,
    seed: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = KMC2ChainInitialization::new();
    op.call(ctx, distances, seed)
}

/// KmeansPlusPlusInitialization
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/KmeansPlusPlusInitialization>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct KmeansPlusPlusInitialization {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for KmeansPlusPlusInitialization {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl KmeansPlusPlusInitialization {
    /// Creates a new `KmeansPlusPlusInitialization`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute kmeans_plus_plus_initialization.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        points: &T0,
        num_to_sample: &T1,
        seed: &T2,
        num_retries_per_sample: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "KmeansPlusPlusInitialization")?;

        // Required input arguments
        op.add_input(&points.to_handle(ctx)?)?;
        op.add_input(&num_to_sample.to_handle(ctx)?)?;
        op.add_input(&seed.to_handle(ctx)?)?;
        op.add_input(&num_retries_per_sample.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `KmeansPlusPlusInitialization::new().call(&ctx, &points, &num_to_sample, &seed, &num_retries_per_sample)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/KmeansPlusPlusInitialization>
pub fn kmeans_plus_plus_initialization<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    points: &T0,
    num_to_sample: &T1,
    seed: &T2,
    num_retries_per_sample: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = KmeansPlusPlusInitialization::new();
    op.call(ctx, points, num_to_sample, seed, num_retries_per_sample)
}

/// KthOrderStatistic
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/KthOrderStatistic>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct KthOrderStatistic {
    k: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for KthOrderStatistic {
    fn default() -> Self {
        Self {
            k: None,
            target_device_name: None,
        }
    }
}
impl KthOrderStatistic {
    /// Creates a new `KthOrderStatistic`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `k` attribute.
    pub fn k<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.k = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute kth_order_statistic.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "KthOrderStatistic")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.k {
            op.set_attr_int("k", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `KthOrderStatistic::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/KthOrderStatistic>
pub fn kth_order_statistic<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = KthOrderStatistic::new();
    op.call(ctx, input)
}

/// L2Loss
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/L2Loss>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct L2Loss {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for L2Loss {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl L2Loss {
    /// Creates a new `L2Loss`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute l2_loss.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        t: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "L2Loss")?;

        // Required input arguments
        op.add_input(&t.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `L2Loss::new().call(&ctx, &t)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/L2Loss>
pub fn l2_loss<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    t: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = L2Loss::new();
    op.call(ctx, t)
}

/// LMDBDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LMDBDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LMDBDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LMDBDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl LMDBDataset {
    /// Creates a new `LMDBDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute lmdbdataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        filenames: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "LMDBDataset")?;

        // Required input arguments
        op.add_input(&filenames.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `LMDBDataset::new().call(&ctx, &filenames)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LMDBDataset>
pub fn lmdbdataset<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    filenames: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = LMDBDataset::new();
    op.call(ctx, filenames)
}

/// LMDBReader
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LMDBReader>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LMDBReader {
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LMDBReader {
    fn default() -> Self {
        Self {
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl LMDBReader {
    /// Creates a new `LMDBReader`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute lmdbreader.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "LMDBReader")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `LMDBReader::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LMDBReader>
pub fn lmdbreader<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = LMDBReader::new();
    op.call(ctx)
}

/// LRN
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LRN>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LRN {
    depth_radius: ::std::option::Option<i64>,
    bias: ::std::option::Option<f32>,
    alpha: ::std::option::Option<f32>,
    beta: ::std::option::Option<f32>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LRN {
    fn default() -> Self {
        Self {
            depth_radius: Some(5i64),
            bias: Some(1f32),
            alpha: Some(1f32),
            beta: Some(0.5f32),
            target_device_name: None,
        }
    }
}
impl LRN {
    /// Creates a new `LRN`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `depth_radius` attribute.
    pub fn depth_radius<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.depth_radius = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `bias` attribute.
    pub fn bias<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.bias = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `alpha` attribute.
    pub fn alpha<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.alpha = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `beta` attribute.
    pub fn beta<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.beta = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute lrn.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "LRN")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.depth_radius {
            op.set_attr_int("depth_radius", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.bias {
            op.set_attr_float("bias", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.alpha {
            op.set_attr_float("alpha", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.beta {
            op.set_attr_float("beta", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `LRN::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LRN>
pub fn lrn<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = LRN::new();
    op.call(ctx, input)
}

/// LRNGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LRNGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LRNGrad {
    depth_radius: ::std::option::Option<i64>,
    bias: ::std::option::Option<f32>,
    alpha: ::std::option::Option<f32>,
    beta: ::std::option::Option<f32>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LRNGrad {
    fn default() -> Self {
        Self {
            depth_radius: Some(5i64),
            bias: Some(1f32),
            alpha: Some(1f32),
            beta: Some(0.5f32),
            target_device_name: None,
        }
    }
}
impl LRNGrad {
    /// Creates a new `LRNGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `depth_radius` attribute.
    pub fn depth_radius<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.depth_radius = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `bias` attribute.
    pub fn bias<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.bias = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `alpha` attribute.
    pub fn alpha<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.alpha = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `beta` attribute.
    pub fn beta<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.beta = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute lrngrad.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_grads: &T0,
        input_image: &T1,
        output_image: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "LRNGrad")?;

        // Required input arguments
        op.add_input(&input_grads.to_handle(ctx)?)?;
        op.add_input(&input_image.to_handle(ctx)?)?;
        op.add_input(&output_image.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.depth_radius {
            op.set_attr_int("depth_radius", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.bias {
            op.set_attr_float("bias", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.alpha {
            op.set_attr_float("alpha", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.beta {
            op.set_attr_float("beta", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `LRNGrad::new().call(&ctx, &input_grads, &input_image, &output_image)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LRNGrad>
pub fn lrngrad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_grads: &T0,
    input_image: &T1,
    output_image: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = LRNGrad::new();
    op.call(ctx, input_grads, input_image, output_image)
}

/// LSTMBlockCell
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LSTMBlockCell>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LSTMBlockCell {
    forget_bias: ::std::option::Option<f32>,
    cell_clip: ::std::option::Option<f32>,
    use_peephole: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LSTMBlockCell {
    fn default() -> Self {
        Self {
            forget_bias: Some(1f32),
            cell_clip: Some(3f32),
            use_peephole: Some(false),
            target_device_name: None,
        }
    }
}
impl LSTMBlockCell {
    /// Creates a new `LSTMBlockCell`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `forget_bias` attribute.
    pub fn forget_bias<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.forget_bias = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `cell_clip` attribute.
    pub fn cell_clip<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.cell_clip = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_peephole` attribute.
    pub fn use_peephole<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_peephole = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute lstmblock_cell.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        cs_prev: &T1,
        h_prev: &T2,
        w: &T3,
        wci: &T4,
        wcf: &T5,
        wco: &T6,
        b: &T7,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 7]> {
        // Define Op
        let mut op = super::Op::new(ctx, "LSTMBlockCell")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&cs_prev.to_handle(ctx)?)?;
        op.add_input(&h_prev.to_handle(ctx)?)?;
        op.add_input(&w.to_handle(ctx)?)?;
        op.add_input(&wci.to_handle(ctx)?)?;
        op.add_input(&wcf.to_handle(ctx)?)?;
        op.add_input(&wco.to_handle(ctx)?)?;
        op.add_input(&b.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.forget_bias {
            op.set_attr_float("forget_bias", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.cell_clip {
            op.set_attr_float("cell_clip", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_peephole {
            op.set_attr_bool("use_peephole", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<7>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `LSTMBlockCell::new().call(&ctx, &x, &cs_prev, &h_prev, &w, &wci, &wcf, &wco, &b)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LSTMBlockCell>
pub fn lstmblock_cell<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    cs_prev: &T1,
    h_prev: &T2,
    w: &T3,
    wci: &T4,
    wcf: &T5,
    wco: &T6,
    b: &T7,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 7]> {
    let op = LSTMBlockCell::new();
    op.call(ctx, x, cs_prev, h_prev, w, wci, wcf, wco, b)
}

/// LSTMBlockCellGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LSTMBlockCellGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LSTMBlockCellGrad {
    use_peephole: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LSTMBlockCellGrad {
    fn default() -> Self {
        Self {
            use_peephole: None,
            target_device_name: None,
        }
    }
}
impl LSTMBlockCellGrad {
    /// Creates a new `LSTMBlockCellGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_peephole` attribute.
    pub fn use_peephole<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_peephole = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute lstmblock_cell_grad.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
        T9: crate::eager::ToTensorHandle<'a>,
        T10: crate::eager::ToTensorHandle<'a>,
        T11: crate::eager::ToTensorHandle<'a>,
        T12: crate::eager::ToTensorHandle<'a>,
        T13: crate::eager::ToTensorHandle<'a>,
        T14: crate::eager::ToTensorHandle<'a>,
        T15: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        cs_prev: &T1,
        h_prev: &T2,
        w: &T3,
        wci: &T4,
        wcf: &T5,
        wco: &T6,
        b: &T7,
        i: &T8,
        cs: &T9,
        f: &T10,
        o: &T11,
        ci: &T12,
        co: &T13,
        cs_grad: &T14,
        h_grad: &T15,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 5]> {
        // Define Op
        let mut op = super::Op::new(ctx, "LSTMBlockCellGrad")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&cs_prev.to_handle(ctx)?)?;
        op.add_input(&h_prev.to_handle(ctx)?)?;
        op.add_input(&w.to_handle(ctx)?)?;
        op.add_input(&wci.to_handle(ctx)?)?;
        op.add_input(&wcf.to_handle(ctx)?)?;
        op.add_input(&wco.to_handle(ctx)?)?;
        op.add_input(&b.to_handle(ctx)?)?;
        op.add_input(&i.to_handle(ctx)?)?;
        op.add_input(&cs.to_handle(ctx)?)?;
        op.add_input(&f.to_handle(ctx)?)?;
        op.add_input(&o.to_handle(ctx)?)?;
        op.add_input(&ci.to_handle(ctx)?)?;
        op.add_input(&co.to_handle(ctx)?)?;
        op.add_input(&cs_grad.to_handle(ctx)?)?;
        op.add_input(&h_grad.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_peephole {
            op.set_attr_bool("use_peephole", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<5>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `LSTMBlockCellGrad::new().call(&ctx, &x, &cs_prev, &h_prev, &w, &wci, &wcf, &wco, &b, &i, &cs, &f, &o, &ci, &co, &cs_grad, &h_grad)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LSTMBlockCellGrad>
pub fn lstmblock_cell_grad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
    T9: crate::eager::ToTensorHandle<'a>,
    T10: crate::eager::ToTensorHandle<'a>,
    T11: crate::eager::ToTensorHandle<'a>,
    T12: crate::eager::ToTensorHandle<'a>,
    T13: crate::eager::ToTensorHandle<'a>,
    T14: crate::eager::ToTensorHandle<'a>,
    T15: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    cs_prev: &T1,
    h_prev: &T2,
    w: &T3,
    wci: &T4,
    wcf: &T5,
    wco: &T6,
    b: &T7,
    i: &T8,
    cs: &T9,
    f: &T10,
    o: &T11,
    ci: &T12,
    co: &T13,
    cs_grad: &T14,
    h_grad: &T15,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 5]> {
    let op = LSTMBlockCellGrad::new();
    op.call(
        ctx, x, cs_prev, h_prev, w, wci, wcf, wco, b, i, cs, f, o, ci, co, cs_grad, h_grad,
    )
}

/// LatencyStatsDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LatencyStatsDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LatencyStatsDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LatencyStatsDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl LatencyStatsDataset {
    /// Creates a new `LatencyStatsDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute latency_stats_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        tag: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "LatencyStatsDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&tag.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `LatencyStatsDataset::new().call(&ctx, &input_dataset, &tag)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LatencyStatsDataset>
pub fn latency_stats_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    tag: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = LatencyStatsDataset::new();
    op.call(ctx, input_dataset, tag)
}

/// LeakyRelu
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LeakyRelu>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LeakyRelu {
    alpha: ::std::option::Option<f32>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LeakyRelu {
    fn default() -> Self {
        Self {
            alpha: Some(0.2f32),
            target_device_name: None,
        }
    }
}
impl LeakyRelu {
    /// Creates a new `LeakyRelu`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `alpha` attribute.
    pub fn alpha<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.alpha = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute leaky_relu.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        features: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "LeakyRelu")?;

        // Required input arguments
        op.add_input(&features.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.alpha {
            op.set_attr_float("alpha", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `LeakyRelu::new().call(&ctx, &features)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LeakyRelu>
pub fn leaky_relu<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    features: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = LeakyRelu::new();
    op.call(ctx, features)
}

/// LeakyReluGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LeakyReluGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LeakyReluGrad {
    alpha: ::std::option::Option<f32>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LeakyReluGrad {
    fn default() -> Self {
        Self {
            alpha: Some(0.2f32),
            target_device_name: None,
        }
    }
}
impl LeakyReluGrad {
    /// Creates a new `LeakyReluGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `alpha` attribute.
    pub fn alpha<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.alpha = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute leaky_relu_grad.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        gradients: &T0,
        features: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "LeakyReluGrad")?;

        // Required input arguments
        op.add_input(&gradients.to_handle(ctx)?)?;
        op.add_input(&features.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.alpha {
            op.set_attr_float("alpha", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `LeakyReluGrad::new().call(&ctx, &gradients, &features)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LeakyReluGrad>
pub fn leaky_relu_grad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    gradients: &T0,
    features: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = LeakyReluGrad::new();
    op.call(ctx, gradients, features)
}

/// LearnedUnigramCandidateSampler
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LearnedUnigramCandidateSampler>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LearnedUnigramCandidateSampler {
    num_true: ::std::option::Option<i64>,
    num_sampled: ::std::option::Option<i64>,
    unique: ::std::option::Option<bool>,
    range_max: ::std::option::Option<i64>,
    seed: ::std::option::Option<i64>,
    seed2: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LearnedUnigramCandidateSampler {
    fn default() -> Self {
        Self {
            num_true: None,
            num_sampled: None,
            unique: None,
            range_max: None,
            seed: Some(0i64),
            seed2: Some(0i64),
            target_device_name: None,
        }
    }
}
impl LearnedUnigramCandidateSampler {
    /// Creates a new `LearnedUnigramCandidateSampler`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_true` attribute.
    pub fn num_true<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_true = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_sampled` attribute.
    pub fn num_sampled<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_sampled = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `unique` attribute.
    pub fn unique<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.unique = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `range_max` attribute.
    pub fn range_max<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.range_max = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed` attribute.
    pub fn seed<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed2` attribute.
    pub fn seed2<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute learned_unigram_candidate_sampler.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        true_classes: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "LearnedUnigramCandidateSampler")?;

        // Required input arguments
        op.add_input(&true_classes.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_true {
            op.set_attr_int("num_true", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_sampled {
            op.set_attr_int("num_sampled", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.unique {
            op.set_attr_bool("unique", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.range_max {
            op.set_attr_int("range_max", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed {
            op.set_attr_int("seed", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed2 {
            op.set_attr_int("seed2", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `LearnedUnigramCandidateSampler::new().call(&ctx, &true_classes)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LearnedUnigramCandidateSampler>
pub fn learned_unigram_candidate_sampler<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    true_classes: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = LearnedUnigramCandidateSampler::new();
    op.call(ctx, true_classes)
}

/// LeftShift
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LeftShift>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LeftShift {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LeftShift {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl LeftShift {
    /// Creates a new `LeftShift`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute left_shift.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "LeftShift")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `LeftShift::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LeftShift>
pub fn left_shift<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = LeftShift::new();
    op.call(ctx, x, y)
}

/// LegacyParallelInterleaveDatasetV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LegacyParallelInterleaveDatasetV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LegacyParallelInterleaveDatasetV2 {
    f: ::std::option::Option<::std::string::String>,
    deterministic: ::std::option::Option<::std::string::String>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LegacyParallelInterleaveDatasetV2 {
    fn default() -> Self {
        Self {
            f: None,
            deterministic: Some(::std::string::String::from("default")),
            output_types: None,
            output_shapes: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl LegacyParallelInterleaveDatasetV2 {
    /// Creates a new `LegacyParallelInterleaveDatasetV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `f` attribute.
    pub fn f<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.f = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `deterministic` attribute.
    pub fn deterministic<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.deterministic = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute legacy_parallel_interleave_dataset_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        other_arguments: &T1,
        cycle_length: &T2,
        block_length: &T3,
        buffer_output_elements: &T4,
        prefetch_input_elements: &T5,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "LegacyParallelInterleaveDatasetV2")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&other_arguments.to_handle(ctx)?)?;
        op.add_input(&cycle_length.to_handle(ctx)?)?;
        op.add_input(&block_length.to_handle(ctx)?)?;
        op.add_input(&buffer_output_elements.to_handle(ctx)?)?;
        op.add_input(&prefetch_input_elements.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.f {
            op.set_attr_string("f", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.deterministic {
            op.set_attr_string("deterministic", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `LegacyParallelInterleaveDatasetV2::new().call(&ctx, &input_dataset, &other_arguments, &cycle_length, &block_length, &buffer_output_elements, &prefetch_input_elements)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LegacyParallelInterleaveDatasetV2>
pub fn legacy_parallel_interleave_dataset_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    other_arguments: &T1,
    cycle_length: &T2,
    block_length: &T3,
    buffer_output_elements: &T4,
    prefetch_input_elements: &T5,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = LegacyParallelInterleaveDatasetV2::new();
    op.call(
        ctx,
        input_dataset,
        other_arguments,
        cycle_length,
        block_length,
        buffer_output_elements,
        prefetch_input_elements,
    )
}

/// Less
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Less>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Less {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Less {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Less {
    /// Creates a new `Less`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute less.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Less")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Less::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Less>
pub fn less<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Less::new();
    op.call(ctx, x, y)
}

/// LessEqual
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LessEqual>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LessEqual {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LessEqual {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl LessEqual {
    /// Creates a new `LessEqual`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute less_equal.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "LessEqual")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `LessEqual::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LessEqual>
pub fn less_equal<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = LessEqual::new();
    op.call(ctx, x, y)
}

/// Lgamma
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Lgamma>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Lgamma {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Lgamma {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Lgamma {
    /// Creates a new `Lgamma`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute lgamma.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Lgamma")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Lgamma::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Lgamma>
pub fn lgamma<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Lgamma::new();
    op.call(ctx, x)
}

/// LinSpace
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LinSpace>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LinSpace {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LinSpace {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl LinSpace {
    /// Creates a new `LinSpace`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute lin_space.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        start: &T0,
        stop: &T1,
        num: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "LinSpace")?;

        // Required input arguments
        op.add_input(&start.to_handle(ctx)?)?;
        op.add_input(&stop.to_handle(ctx)?)?;
        op.add_input(&num.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `LinSpace::new().call(&ctx, &start, &stop, &num)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LinSpace>
pub fn lin_space<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    start: &T0,
    stop: &T1,
    num: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = LinSpace::new();
    op.call(ctx, start, stop, num)
}

/// ListDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ListDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ListDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ListDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl ListDataset {
    /// Creates a new `ListDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute list_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        tensors: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ListDataset")?;

        // Required input arguments
        op.add_input(&tensors.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ListDataset::new().call(&ctx, &tensors)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ListDataset>
pub fn list_dataset<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    tensors: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ListDataset::new();
    op.call(ctx, tensors)
}

/// ListDiff
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ListDiff>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ListDiff {
    out_idx: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ListDiff {
    fn default() -> Self {
        Self {
            out_idx: Some(crate::DataType::Int32),
            target_device_name: None,
        }
    }
}
impl ListDiff {
    /// Creates a new `ListDiff`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_idx` attribute.
    pub fn out_idx<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_idx = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute list_diff.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "ListDiff")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_idx {
            op.set_attr_type("out_idx", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `ListDiff::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ListDiff>
pub fn list_diff<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = ListDiff::new();
    op.call(ctx, x, y)
}

/// LoadAllTPUEmbeddingParameters
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LoadAllTPUEmbeddingParameters>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LoadAllTPUEmbeddingParameters {
    config: ::std::option::Option<::std::string::String>,
    num_shards: ::std::option::Option<i64>,
    shard_id: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LoadAllTPUEmbeddingParameters {
    fn default() -> Self {
        Self {
            config: None,
            num_shards: None,
            shard_id: None,
            target_device_name: None,
        }
    }
}
impl LoadAllTPUEmbeddingParameters {
    /// Creates a new `LoadAllTPUEmbeddingParameters`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_shards` attribute.
    pub fn num_shards<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_shards = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shard_id` attribute.
    pub fn shard_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.shard_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute load_all_tpuembedding_parameters.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        parameters: &[&T0],
        auxiliary1: &[&T1],
        auxiliary2: &[&T2],
        auxiliary3: &[&T3],
        auxiliary4: &[&T4],
        auxiliary5: &[&T5],
        auxiliary6: &[&T6],
        auxiliary7: &[&T7],
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "LoadAllTPUEmbeddingParameters")?;

        // Required input arguments
        let mut parameters_list = Vec::new();

        for t in parameters {
            parameters_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&parameters_list)?;
        let mut auxiliary1_list = Vec::new();

        for t in auxiliary1 {
            auxiliary1_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&auxiliary1_list)?;
        let mut auxiliary2_list = Vec::new();

        for t in auxiliary2 {
            auxiliary2_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&auxiliary2_list)?;
        let mut auxiliary3_list = Vec::new();

        for t in auxiliary3 {
            auxiliary3_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&auxiliary3_list)?;
        let mut auxiliary4_list = Vec::new();

        for t in auxiliary4 {
            auxiliary4_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&auxiliary4_list)?;
        let mut auxiliary5_list = Vec::new();

        for t in auxiliary5 {
            auxiliary5_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&auxiliary5_list)?;
        let mut auxiliary6_list = Vec::new();

        for t in auxiliary6 {
            auxiliary6_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&auxiliary6_list)?;
        let mut auxiliary7_list = Vec::new();

        for t in auxiliary7 {
            auxiliary7_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&auxiliary7_list)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_shards {
            op.set_attr_int("num_shards", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shard_id {
            op.set_attr_int("shard_id", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `LoadAllTPUEmbeddingParameters::new().call(&ctx, &parameters, &auxiliary1, &auxiliary2, &auxiliary3, &auxiliary4, &auxiliary5, &auxiliary6, &auxiliary7)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LoadAllTPUEmbeddingParameters>
pub fn load_all_tpuembedding_parameters<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    parameters: &[&T0],
    auxiliary1: &[&T1],
    auxiliary2: &[&T2],
    auxiliary3: &[&T3],
    auxiliary4: &[&T4],
    auxiliary5: &[&T5],
    auxiliary6: &[&T6],
    auxiliary7: &[&T7],
) -> crate::Result<()> {
    let op = LoadAllTPUEmbeddingParameters::new();
    op.call(
        ctx, parameters, auxiliary1, auxiliary2, auxiliary3, auxiliary4, auxiliary5, auxiliary6,
        auxiliary7,
    )
}

/// LoadAndRemapMatrix
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LoadAndRemapMatrix>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LoadAndRemapMatrix {
    num_rows: ::std::option::Option<i64>,
    num_cols: ::std::option::Option<i64>,
    max_rows_in_memory: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LoadAndRemapMatrix {
    fn default() -> Self {
        Self {
            num_rows: None,
            num_cols: None,
            max_rows_in_memory: Some(-1i64),
            target_device_name: None,
        }
    }
}
impl LoadAndRemapMatrix {
    /// Creates a new `LoadAndRemapMatrix`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_rows` attribute.
    pub fn num_rows<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_rows = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_cols` attribute.
    pub fn num_cols<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_cols = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `max_rows_in_memory` attribute.
    pub fn max_rows_in_memory<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.max_rows_in_memory = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute load_and_remap_matrix.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        ckpt_path: &T0,
        old_tensor_name: &T1,
        row_remapping: &T2,
        col_remapping: &T3,
        initializing_values: &T4,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "LoadAndRemapMatrix")?;

        // Required input arguments
        op.add_input(&ckpt_path.to_handle(ctx)?)?;
        op.add_input(&old_tensor_name.to_handle(ctx)?)?;
        op.add_input(&row_remapping.to_handle(ctx)?)?;
        op.add_input(&col_remapping.to_handle(ctx)?)?;
        op.add_input(&initializing_values.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_rows {
            op.set_attr_int("num_rows", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_cols {
            op.set_attr_int("num_cols", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.max_rows_in_memory {
            op.set_attr_int("max_rows_in_memory", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `LoadAndRemapMatrix::new().call(&ctx, &ckpt_path, &old_tensor_name, &row_remapping, &col_remapping, &initializing_values)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LoadAndRemapMatrix>
pub fn load_and_remap_matrix<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    ckpt_path: &T0,
    old_tensor_name: &T1,
    row_remapping: &T2,
    col_remapping: &T3,
    initializing_values: &T4,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = LoadAndRemapMatrix::new();
    op.call(
        ctx,
        ckpt_path,
        old_tensor_name,
        row_remapping,
        col_remapping,
        initializing_values,
    )
}

/// LoadDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LoadDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LoadDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    compression: ::std::option::Option<::std::string::String>,
    reader_func: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LoadDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            compression: None,
            reader_func: None,
            target_device_name: None,
        }
    }
}
impl LoadDataset {
    /// Creates a new `LoadDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `compression` attribute.
    pub fn compression<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.compression = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `reader_func` attribute.
    pub fn reader_func<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.reader_func = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute load_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        path: &T0,
        reader_func_other_args: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "LoadDataset")?;

        // Required input arguments
        op.add_input(&path.to_handle(ctx)?)?;
        op.add_input(&reader_func_other_args.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.compression {
            op.set_attr_string("compression", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.reader_func {
            op.set_attr_string("reader_func", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `LoadDataset::new().call(&ctx, &path, &reader_func_other_args)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LoadDataset>
pub fn load_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    path: &T0,
    reader_func_other_args: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = LoadDataset::new();
    op.call(ctx, path, reader_func_other_args)
}

/// LoadTPUEmbeddingADAMParameters
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LoadTPUEmbeddingADAMParameters>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LoadTPUEmbeddingADAMParameters {
    table_id: ::std::option::Option<i64>,
    table_name: ::std::option::Option<::std::string::String>,
    num_shards: ::std::option::Option<i64>,
    shard_id: ::std::option::Option<i64>,
    config: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LoadTPUEmbeddingADAMParameters {
    fn default() -> Self {
        Self {
            table_id: Some(-1i64),
            table_name: None,
            num_shards: None,
            shard_id: None,
            config: None,
            target_device_name: None,
        }
    }
}
impl LoadTPUEmbeddingADAMParameters {
    /// Creates a new `LoadTPUEmbeddingADAMParameters`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `table_id` attribute.
    pub fn table_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.table_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `table_name` attribute.
    pub fn table_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.table_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_shards` attribute.
    pub fn num_shards<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_shards = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shard_id` attribute.
    pub fn shard_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.shard_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute load_tpuembedding_adamparameters.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        parameters: &T0,
        momenta: &T1,
        velocities: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "LoadTPUEmbeddingADAMParameters")?;

        // Required input arguments
        op.add_input(&parameters.to_handle(ctx)?)?;
        op.add_input(&momenta.to_handle(ctx)?)?;
        op.add_input(&velocities.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.table_id {
            op.set_attr_int("table_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.table_name {
            op.set_attr_string("table_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_shards {
            op.set_attr_int("num_shards", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shard_id {
            op.set_attr_int("shard_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `LoadTPUEmbeddingADAMParameters::new().call(&ctx, &parameters, &momenta, &velocities)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LoadTPUEmbeddingADAMParameters>
pub fn load_tpuembedding_adamparameters<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    parameters: &T0,
    momenta: &T1,
    velocities: &T2,
) -> crate::Result<()> {
    let op = LoadTPUEmbeddingADAMParameters::new();
    op.call(ctx, parameters, momenta, velocities)
}

/// LoadTPUEmbeddingAdadeltaParameters
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LoadTPUEmbeddingAdadeltaParameters>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LoadTPUEmbeddingAdadeltaParameters {
    table_id: ::std::option::Option<i64>,
    table_name: ::std::option::Option<::std::string::String>,
    num_shards: ::std::option::Option<i64>,
    shard_id: ::std::option::Option<i64>,
    config: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LoadTPUEmbeddingAdadeltaParameters {
    fn default() -> Self {
        Self {
            table_id: Some(-1i64),
            table_name: None,
            num_shards: None,
            shard_id: None,
            config: None,
            target_device_name: None,
        }
    }
}
impl LoadTPUEmbeddingAdadeltaParameters {
    /// Creates a new `LoadTPUEmbeddingAdadeltaParameters`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `table_id` attribute.
    pub fn table_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.table_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `table_name` attribute.
    pub fn table_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.table_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_shards` attribute.
    pub fn num_shards<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_shards = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shard_id` attribute.
    pub fn shard_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.shard_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute load_tpuembedding_adadelta_parameters.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        parameters: &T0,
        accumulators: &T1,
        updates: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "LoadTPUEmbeddingAdadeltaParameters")?;

        // Required input arguments
        op.add_input(&parameters.to_handle(ctx)?)?;
        op.add_input(&accumulators.to_handle(ctx)?)?;
        op.add_input(&updates.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.table_id {
            op.set_attr_int("table_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.table_name {
            op.set_attr_string("table_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_shards {
            op.set_attr_int("num_shards", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shard_id {
            op.set_attr_int("shard_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `LoadTPUEmbeddingAdadeltaParameters::new().call(&ctx, &parameters, &accumulators, &updates)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LoadTPUEmbeddingAdadeltaParameters>
pub fn load_tpuembedding_adadelta_parameters<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    parameters: &T0,
    accumulators: &T1,
    updates: &T2,
) -> crate::Result<()> {
    let op = LoadTPUEmbeddingAdadeltaParameters::new();
    op.call(ctx, parameters, accumulators, updates)
}

/// LoadTPUEmbeddingAdagradMomentumParameters
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LoadTPUEmbeddingAdagradMomentumParameters>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LoadTPUEmbeddingAdagradMomentumParameters {
    table_id: ::std::option::Option<i64>,
    table_name: ::std::option::Option<::std::string::String>,
    num_shards: ::std::option::Option<i64>,
    shard_id: ::std::option::Option<i64>,
    config: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LoadTPUEmbeddingAdagradMomentumParameters {
    fn default() -> Self {
        Self {
            table_id: Some(-1i64),
            table_name: None,
            num_shards: None,
            shard_id: None,
            config: None,
            target_device_name: None,
        }
    }
}
impl LoadTPUEmbeddingAdagradMomentumParameters {
    /// Creates a new `LoadTPUEmbeddingAdagradMomentumParameters`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `table_id` attribute.
    pub fn table_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.table_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `table_name` attribute.
    pub fn table_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.table_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_shards` attribute.
    pub fn num_shards<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_shards = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shard_id` attribute.
    pub fn shard_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.shard_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute load_tpuembedding_adagrad_momentum_parameters.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        parameters: &T0,
        accumulators: &T1,
        momenta: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "LoadTPUEmbeddingAdagradMomentumParameters")?;

        // Required input arguments
        op.add_input(&parameters.to_handle(ctx)?)?;
        op.add_input(&accumulators.to_handle(ctx)?)?;
        op.add_input(&momenta.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.table_id {
            op.set_attr_int("table_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.table_name {
            op.set_attr_string("table_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_shards {
            op.set_attr_int("num_shards", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shard_id {
            op.set_attr_int("shard_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `LoadTPUEmbeddingAdagradMomentumParameters::new().call(&ctx, &parameters, &accumulators, &momenta)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LoadTPUEmbeddingAdagradMomentumParameters>
pub fn load_tpuembedding_adagrad_momentum_parameters<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    parameters: &T0,
    accumulators: &T1,
    momenta: &T2,
) -> crate::Result<()> {
    let op = LoadTPUEmbeddingAdagradMomentumParameters::new();
    op.call(ctx, parameters, accumulators, momenta)
}

/// LoadTPUEmbeddingAdagradParameters
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LoadTPUEmbeddingAdagradParameters>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LoadTPUEmbeddingAdagradParameters {
    table_id: ::std::option::Option<i64>,
    table_name: ::std::option::Option<::std::string::String>,
    num_shards: ::std::option::Option<i64>,
    shard_id: ::std::option::Option<i64>,
    config: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LoadTPUEmbeddingAdagradParameters {
    fn default() -> Self {
        Self {
            table_id: Some(-1i64),
            table_name: None,
            num_shards: None,
            shard_id: None,
            config: None,
            target_device_name: None,
        }
    }
}
impl LoadTPUEmbeddingAdagradParameters {
    /// Creates a new `LoadTPUEmbeddingAdagradParameters`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `table_id` attribute.
    pub fn table_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.table_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `table_name` attribute.
    pub fn table_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.table_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_shards` attribute.
    pub fn num_shards<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_shards = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shard_id` attribute.
    pub fn shard_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.shard_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute load_tpuembedding_adagrad_parameters.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        parameters: &T0,
        accumulators: &T1,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "LoadTPUEmbeddingAdagradParameters")?;

        // Required input arguments
        op.add_input(&parameters.to_handle(ctx)?)?;
        op.add_input(&accumulators.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.table_id {
            op.set_attr_int("table_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.table_name {
            op.set_attr_string("table_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_shards {
            op.set_attr_int("num_shards", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shard_id {
            op.set_attr_int("shard_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `LoadTPUEmbeddingAdagradParameters::new().call(&ctx, &parameters, &accumulators)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LoadTPUEmbeddingAdagradParameters>
pub fn load_tpuembedding_adagrad_parameters<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    parameters: &T0,
    accumulators: &T1,
) -> crate::Result<()> {
    let op = LoadTPUEmbeddingAdagradParameters::new();
    op.call(ctx, parameters, accumulators)
}

/// LoadTPUEmbeddingCenteredRMSPropParameters
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LoadTPUEmbeddingCenteredRMSPropParameters>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LoadTPUEmbeddingCenteredRMSPropParameters {
    table_id: ::std::option::Option<i64>,
    table_name: ::std::option::Option<::std::string::String>,
    num_shards: ::std::option::Option<i64>,
    shard_id: ::std::option::Option<i64>,
    config: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LoadTPUEmbeddingCenteredRMSPropParameters {
    fn default() -> Self {
        Self {
            table_id: Some(-1i64),
            table_name: None,
            num_shards: None,
            shard_id: None,
            config: None,
            target_device_name: None,
        }
    }
}
impl LoadTPUEmbeddingCenteredRMSPropParameters {
    /// Creates a new `LoadTPUEmbeddingCenteredRMSPropParameters`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `table_id` attribute.
    pub fn table_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.table_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `table_name` attribute.
    pub fn table_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.table_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_shards` attribute.
    pub fn num_shards<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_shards = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shard_id` attribute.
    pub fn shard_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.shard_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute load_tpuembedding_centered_rmsprop_parameters.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        parameters: &T0,
        ms: &T1,
        mom: &T2,
        mg: &T3,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "LoadTPUEmbeddingCenteredRMSPropParameters")?;

        // Required input arguments
        op.add_input(&parameters.to_handle(ctx)?)?;
        op.add_input(&ms.to_handle(ctx)?)?;
        op.add_input(&mom.to_handle(ctx)?)?;
        op.add_input(&mg.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.table_id {
            op.set_attr_int("table_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.table_name {
            op.set_attr_string("table_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_shards {
            op.set_attr_int("num_shards", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shard_id {
            op.set_attr_int("shard_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `LoadTPUEmbeddingCenteredRMSPropParameters::new().call(&ctx, &parameters, &ms, &mom, &mg)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LoadTPUEmbeddingCenteredRMSPropParameters>
pub fn load_tpuembedding_centered_rmsprop_parameters<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    parameters: &T0,
    ms: &T1,
    mom: &T2,
    mg: &T3,
) -> crate::Result<()> {
    let op = LoadTPUEmbeddingCenteredRMSPropParameters::new();
    op.call(ctx, parameters, ms, mom, mg)
}

/// LoadTPUEmbeddingFTRLParameters
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LoadTPUEmbeddingFTRLParameters>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LoadTPUEmbeddingFTRLParameters {
    table_id: ::std::option::Option<i64>,
    table_name: ::std::option::Option<::std::string::String>,
    num_shards: ::std::option::Option<i64>,
    shard_id: ::std::option::Option<i64>,
    config: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LoadTPUEmbeddingFTRLParameters {
    fn default() -> Self {
        Self {
            table_id: Some(-1i64),
            table_name: None,
            num_shards: None,
            shard_id: None,
            config: None,
            target_device_name: None,
        }
    }
}
impl LoadTPUEmbeddingFTRLParameters {
    /// Creates a new `LoadTPUEmbeddingFTRLParameters`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `table_id` attribute.
    pub fn table_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.table_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `table_name` attribute.
    pub fn table_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.table_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_shards` attribute.
    pub fn num_shards<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_shards = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shard_id` attribute.
    pub fn shard_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.shard_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute load_tpuembedding_ftrlparameters.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        parameters: &T0,
        accumulators: &T1,
        linears: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "LoadTPUEmbeddingFTRLParameters")?;

        // Required input arguments
        op.add_input(&parameters.to_handle(ctx)?)?;
        op.add_input(&accumulators.to_handle(ctx)?)?;
        op.add_input(&linears.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.table_id {
            op.set_attr_int("table_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.table_name {
            op.set_attr_string("table_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_shards {
            op.set_attr_int("num_shards", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shard_id {
            op.set_attr_int("shard_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `LoadTPUEmbeddingFTRLParameters::new().call(&ctx, &parameters, &accumulators, &linears)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LoadTPUEmbeddingFTRLParameters>
pub fn load_tpuembedding_ftrlparameters<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    parameters: &T0,
    accumulators: &T1,
    linears: &T2,
) -> crate::Result<()> {
    let op = LoadTPUEmbeddingFTRLParameters::new();
    op.call(ctx, parameters, accumulators, linears)
}

/// LoadTPUEmbeddingFrequencyEstimatorParameters
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LoadTPUEmbeddingFrequencyEstimatorParameters>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LoadTPUEmbeddingFrequencyEstimatorParameters {
    table_id: ::std::option::Option<i64>,
    table_name: ::std::option::Option<::std::string::String>,
    num_shards: ::std::option::Option<i64>,
    shard_id: ::std::option::Option<i64>,
    config: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LoadTPUEmbeddingFrequencyEstimatorParameters {
    fn default() -> Self {
        Self {
            table_id: Some(-1i64),
            table_name: None,
            num_shards: None,
            shard_id: None,
            config: None,
            target_device_name: None,
        }
    }
}
impl LoadTPUEmbeddingFrequencyEstimatorParameters {
    /// Creates a new `LoadTPUEmbeddingFrequencyEstimatorParameters`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `table_id` attribute.
    pub fn table_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.table_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `table_name` attribute.
    pub fn table_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.table_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_shards` attribute.
    pub fn num_shards<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_shards = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shard_id` attribute.
    pub fn shard_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.shard_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute load_tpuembedding_frequency_estimator_parameters.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        parameters: &T0,
        last_hit_step: &T1,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "LoadTPUEmbeddingFrequencyEstimatorParameters")?;

        // Required input arguments
        op.add_input(&parameters.to_handle(ctx)?)?;
        op.add_input(&last_hit_step.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.table_id {
            op.set_attr_int("table_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.table_name {
            op.set_attr_string("table_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_shards {
            op.set_attr_int("num_shards", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shard_id {
            op.set_attr_int("shard_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `LoadTPUEmbeddingFrequencyEstimatorParameters::new().call(&ctx, &parameters, &last_hit_step)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LoadTPUEmbeddingFrequencyEstimatorParameters>
pub fn load_tpuembedding_frequency_estimator_parameters<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    parameters: &T0,
    last_hit_step: &T1,
) -> crate::Result<()> {
    let op = LoadTPUEmbeddingFrequencyEstimatorParameters::new();
    op.call(ctx, parameters, last_hit_step)
}

/// LoadTPUEmbeddingMDLAdagradLightParameters
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LoadTPUEmbeddingMDLAdagradLightParameters>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LoadTPUEmbeddingMDLAdagradLightParameters {
    table_id: ::std::option::Option<i64>,
    table_name: ::std::option::Option<::std::string::String>,
    num_shards: ::std::option::Option<i64>,
    shard_id: ::std::option::Option<i64>,
    config: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LoadTPUEmbeddingMDLAdagradLightParameters {
    fn default() -> Self {
        Self {
            table_id: Some(-1i64),
            table_name: None,
            num_shards: None,
            shard_id: None,
            config: None,
            target_device_name: None,
        }
    }
}
impl LoadTPUEmbeddingMDLAdagradLightParameters {
    /// Creates a new `LoadTPUEmbeddingMDLAdagradLightParameters`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `table_id` attribute.
    pub fn table_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.table_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `table_name` attribute.
    pub fn table_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.table_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_shards` attribute.
    pub fn num_shards<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_shards = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shard_id` attribute.
    pub fn shard_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.shard_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute load_tpuembedding_mdladagrad_light_parameters.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        parameters: &T0,
        accumulators: &T1,
        weights: &T2,
        benefits: &T3,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "LoadTPUEmbeddingMDLAdagradLightParameters")?;

        // Required input arguments
        op.add_input(&parameters.to_handle(ctx)?)?;
        op.add_input(&accumulators.to_handle(ctx)?)?;
        op.add_input(&weights.to_handle(ctx)?)?;
        op.add_input(&benefits.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.table_id {
            op.set_attr_int("table_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.table_name {
            op.set_attr_string("table_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_shards {
            op.set_attr_int("num_shards", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shard_id {
            op.set_attr_int("shard_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `LoadTPUEmbeddingMDLAdagradLightParameters::new().call(&ctx, &parameters, &accumulators, &weights, &benefits)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LoadTPUEmbeddingMDLAdagradLightParameters>
pub fn load_tpuembedding_mdladagrad_light_parameters<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    parameters: &T0,
    accumulators: &T1,
    weights: &T2,
    benefits: &T3,
) -> crate::Result<()> {
    let op = LoadTPUEmbeddingMDLAdagradLightParameters::new();
    op.call(ctx, parameters, accumulators, weights, benefits)
}

/// LoadTPUEmbeddingMomentumParameters
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LoadTPUEmbeddingMomentumParameters>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LoadTPUEmbeddingMomentumParameters {
    table_id: ::std::option::Option<i64>,
    table_name: ::std::option::Option<::std::string::String>,
    num_shards: ::std::option::Option<i64>,
    shard_id: ::std::option::Option<i64>,
    config: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LoadTPUEmbeddingMomentumParameters {
    fn default() -> Self {
        Self {
            table_id: Some(-1i64),
            table_name: None,
            num_shards: None,
            shard_id: None,
            config: None,
            target_device_name: None,
        }
    }
}
impl LoadTPUEmbeddingMomentumParameters {
    /// Creates a new `LoadTPUEmbeddingMomentumParameters`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `table_id` attribute.
    pub fn table_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.table_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `table_name` attribute.
    pub fn table_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.table_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_shards` attribute.
    pub fn num_shards<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_shards = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shard_id` attribute.
    pub fn shard_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.shard_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute load_tpuembedding_momentum_parameters.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        parameters: &T0,
        momenta: &T1,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "LoadTPUEmbeddingMomentumParameters")?;

        // Required input arguments
        op.add_input(&parameters.to_handle(ctx)?)?;
        op.add_input(&momenta.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.table_id {
            op.set_attr_int("table_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.table_name {
            op.set_attr_string("table_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_shards {
            op.set_attr_int("num_shards", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shard_id {
            op.set_attr_int("shard_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `LoadTPUEmbeddingMomentumParameters::new().call(&ctx, &parameters, &momenta)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LoadTPUEmbeddingMomentumParameters>
pub fn load_tpuembedding_momentum_parameters<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    parameters: &T0,
    momenta: &T1,
) -> crate::Result<()> {
    let op = LoadTPUEmbeddingMomentumParameters::new();
    op.call(ctx, parameters, momenta)
}

/// LoadTPUEmbeddingProximalAdagradParameters
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LoadTPUEmbeddingProximalAdagradParameters>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LoadTPUEmbeddingProximalAdagradParameters {
    table_id: ::std::option::Option<i64>,
    table_name: ::std::option::Option<::std::string::String>,
    num_shards: ::std::option::Option<i64>,
    shard_id: ::std::option::Option<i64>,
    config: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LoadTPUEmbeddingProximalAdagradParameters {
    fn default() -> Self {
        Self {
            table_id: Some(-1i64),
            table_name: None,
            num_shards: None,
            shard_id: None,
            config: None,
            target_device_name: None,
        }
    }
}
impl LoadTPUEmbeddingProximalAdagradParameters {
    /// Creates a new `LoadTPUEmbeddingProximalAdagradParameters`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `table_id` attribute.
    pub fn table_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.table_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `table_name` attribute.
    pub fn table_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.table_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_shards` attribute.
    pub fn num_shards<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_shards = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shard_id` attribute.
    pub fn shard_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.shard_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute load_tpuembedding_proximal_adagrad_parameters.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        parameters: &T0,
        accumulators: &T1,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "LoadTPUEmbeddingProximalAdagradParameters")?;

        // Required input arguments
        op.add_input(&parameters.to_handle(ctx)?)?;
        op.add_input(&accumulators.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.table_id {
            op.set_attr_int("table_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.table_name {
            op.set_attr_string("table_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_shards {
            op.set_attr_int("num_shards", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shard_id {
            op.set_attr_int("shard_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `LoadTPUEmbeddingProximalAdagradParameters::new().call(&ctx, &parameters, &accumulators)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LoadTPUEmbeddingProximalAdagradParameters>
pub fn load_tpuembedding_proximal_adagrad_parameters<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    parameters: &T0,
    accumulators: &T1,
) -> crate::Result<()> {
    let op = LoadTPUEmbeddingProximalAdagradParameters::new();
    op.call(ctx, parameters, accumulators)
}

/// LoadTPUEmbeddingProximalYogiParameters
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LoadTPUEmbeddingProximalYogiParameters>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LoadTPUEmbeddingProximalYogiParameters {
    table_id: ::std::option::Option<i64>,
    table_name: ::std::option::Option<::std::string::String>,
    num_shards: ::std::option::Option<i64>,
    shard_id: ::std::option::Option<i64>,
    config: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LoadTPUEmbeddingProximalYogiParameters {
    fn default() -> Self {
        Self {
            table_id: Some(-1i64),
            table_name: None,
            num_shards: None,
            shard_id: None,
            config: None,
            target_device_name: None,
        }
    }
}
impl LoadTPUEmbeddingProximalYogiParameters {
    /// Creates a new `LoadTPUEmbeddingProximalYogiParameters`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `table_id` attribute.
    pub fn table_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.table_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `table_name` attribute.
    pub fn table_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.table_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_shards` attribute.
    pub fn num_shards<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_shards = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shard_id` attribute.
    pub fn shard_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.shard_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute load_tpuembedding_proximal_yogi_parameters.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        parameters: &T0,
        v: &T1,
        m: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "LoadTPUEmbeddingProximalYogiParameters")?;

        // Required input arguments
        op.add_input(&parameters.to_handle(ctx)?)?;
        op.add_input(&v.to_handle(ctx)?)?;
        op.add_input(&m.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.table_id {
            op.set_attr_int("table_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.table_name {
            op.set_attr_string("table_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_shards {
            op.set_attr_int("num_shards", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shard_id {
            op.set_attr_int("shard_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `LoadTPUEmbeddingProximalYogiParameters::new().call(&ctx, &parameters, &v, &m)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LoadTPUEmbeddingProximalYogiParameters>
pub fn load_tpuembedding_proximal_yogi_parameters<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    parameters: &T0,
    v: &T1,
    m: &T2,
) -> crate::Result<()> {
    let op = LoadTPUEmbeddingProximalYogiParameters::new();
    op.call(ctx, parameters, v, m)
}

/// LoadTPUEmbeddingRMSPropParameters
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LoadTPUEmbeddingRMSPropParameters>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LoadTPUEmbeddingRMSPropParameters {
    table_id: ::std::option::Option<i64>,
    table_name: ::std::option::Option<::std::string::String>,
    num_shards: ::std::option::Option<i64>,
    shard_id: ::std::option::Option<i64>,
    config: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LoadTPUEmbeddingRMSPropParameters {
    fn default() -> Self {
        Self {
            table_id: Some(-1i64),
            table_name: None,
            num_shards: None,
            shard_id: None,
            config: None,
            target_device_name: None,
        }
    }
}
impl LoadTPUEmbeddingRMSPropParameters {
    /// Creates a new `LoadTPUEmbeddingRMSPropParameters`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `table_id` attribute.
    pub fn table_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.table_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `table_name` attribute.
    pub fn table_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.table_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_shards` attribute.
    pub fn num_shards<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_shards = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shard_id` attribute.
    pub fn shard_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.shard_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute load_tpuembedding_rmsprop_parameters.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        parameters: &T0,
        ms: &T1,
        mom: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "LoadTPUEmbeddingRMSPropParameters")?;

        // Required input arguments
        op.add_input(&parameters.to_handle(ctx)?)?;
        op.add_input(&ms.to_handle(ctx)?)?;
        op.add_input(&mom.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.table_id {
            op.set_attr_int("table_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.table_name {
            op.set_attr_string("table_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_shards {
            op.set_attr_int("num_shards", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shard_id {
            op.set_attr_int("shard_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `LoadTPUEmbeddingRMSPropParameters::new().call(&ctx, &parameters, &ms, &mom)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LoadTPUEmbeddingRMSPropParameters>
pub fn load_tpuembedding_rmsprop_parameters<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    parameters: &T0,
    ms: &T1,
    mom: &T2,
) -> crate::Result<()> {
    let op = LoadTPUEmbeddingRMSPropParameters::new();
    op.call(ctx, parameters, ms, mom)
}

/// LoadTPUEmbeddingStochasticGradientDescentParameters
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LoadTPUEmbeddingStochasticGradientDescentParameters>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LoadTPUEmbeddingStochasticGradientDescentParameters {
    table_id: ::std::option::Option<i64>,
    table_name: ::std::option::Option<::std::string::String>,
    num_shards: ::std::option::Option<i64>,
    shard_id: ::std::option::Option<i64>,
    config: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LoadTPUEmbeddingStochasticGradientDescentParameters {
    fn default() -> Self {
        Self {
            table_id: Some(-1i64),
            table_name: None,
            num_shards: None,
            shard_id: None,
            config: None,
            target_device_name: None,
        }
    }
}
impl LoadTPUEmbeddingStochasticGradientDescentParameters {
    /// Creates a new `LoadTPUEmbeddingStochasticGradientDescentParameters`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `table_id` attribute.
    pub fn table_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.table_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `table_name` attribute.
    pub fn table_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.table_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_shards` attribute.
    pub fn num_shards<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_shards = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shard_id` attribute.
    pub fn shard_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.shard_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute load_tpuembedding_stochastic_gradient_descent_parameters.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        parameters: &T0,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "LoadTPUEmbeddingStochasticGradientDescentParameters")?;

        // Required input arguments
        op.add_input(&parameters.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.table_id {
            op.set_attr_int("table_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.table_name {
            op.set_attr_string("table_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_shards {
            op.set_attr_int("num_shards", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shard_id {
            op.set_attr_int("shard_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `LoadTPUEmbeddingStochasticGradientDescentParameters::new().call(&ctx, &parameters)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LoadTPUEmbeddingStochasticGradientDescentParameters>
pub fn load_tpuembedding_stochastic_gradient_descent_parameters<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    parameters: &T0,
) -> crate::Result<()> {
    let op = LoadTPUEmbeddingStochasticGradientDescentParameters::new();
    op.call(ctx, parameters)
}

/// Log
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Log>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Log {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Log {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Log {
    /// Creates a new `Log`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute log.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Log")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Log::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Log>
pub fn log<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Log::new();
    op.call(ctx, x)
}

/// Log1p
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Log1p>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Log1p {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Log1p {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Log1p {
    /// Creates a new `Log1p`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute log1p.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Log1p")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Log1p::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Log1p>
pub fn log1p<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Log1p::new();
    op.call(ctx, x)
}

/// LogMatrixDeterminant
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LogMatrixDeterminant>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LogMatrixDeterminant {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LogMatrixDeterminant {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl LogMatrixDeterminant {
    /// Creates a new `LogMatrixDeterminant`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute log_matrix_determinant.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "LogMatrixDeterminant")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `LogMatrixDeterminant::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LogMatrixDeterminant>
pub fn log_matrix_determinant<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = LogMatrixDeterminant::new();
    op.call(ctx, input)
}

/// LogSoftmax
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LogSoftmax>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LogSoftmax {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LogSoftmax {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl LogSoftmax {
    /// Creates a new `LogSoftmax`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute log_softmax.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        logits: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "LogSoftmax")?;

        // Required input arguments
        op.add_input(&logits.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `LogSoftmax::new().call(&ctx, &logits)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LogSoftmax>
pub fn log_softmax<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    logits: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = LogSoftmax::new();
    op.call(ctx, logits)
}

/// LogUniformCandidateSampler
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LogUniformCandidateSampler>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LogUniformCandidateSampler {
    num_true: ::std::option::Option<i64>,
    num_sampled: ::std::option::Option<i64>,
    unique: ::std::option::Option<bool>,
    range_max: ::std::option::Option<i64>,
    seed: ::std::option::Option<i64>,
    seed2: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LogUniformCandidateSampler {
    fn default() -> Self {
        Self {
            num_true: None,
            num_sampled: None,
            unique: None,
            range_max: None,
            seed: Some(0i64),
            seed2: Some(0i64),
            target_device_name: None,
        }
    }
}
impl LogUniformCandidateSampler {
    /// Creates a new `LogUniformCandidateSampler`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_true` attribute.
    pub fn num_true<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_true = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_sampled` attribute.
    pub fn num_sampled<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_sampled = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `unique` attribute.
    pub fn unique<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.unique = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `range_max` attribute.
    pub fn range_max<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.range_max = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed` attribute.
    pub fn seed<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed2` attribute.
    pub fn seed2<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute log_uniform_candidate_sampler.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        true_classes: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "LogUniformCandidateSampler")?;

        // Required input arguments
        op.add_input(&true_classes.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_true {
            op.set_attr_int("num_true", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_sampled {
            op.set_attr_int("num_sampled", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.unique {
            op.set_attr_bool("unique", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.range_max {
            op.set_attr_int("range_max", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed {
            op.set_attr_int("seed", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed2 {
            op.set_attr_int("seed2", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `LogUniformCandidateSampler::new().call(&ctx, &true_classes)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LogUniformCandidateSampler>
pub fn log_uniform_candidate_sampler<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    true_classes: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = LogUniformCandidateSampler::new();
    op.call(ctx, true_classes)
}

/// LogicalAnd
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LogicalAnd>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LogicalAnd {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LogicalAnd {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl LogicalAnd {
    /// Creates a new `LogicalAnd`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute logical_and.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "LogicalAnd")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `LogicalAnd::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LogicalAnd>
pub fn logical_and<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = LogicalAnd::new();
    op.call(ctx, x, y)
}

/// LogicalNot
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LogicalNot>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LogicalNot {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LogicalNot {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl LogicalNot {
    /// Creates a new `LogicalNot`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute logical_not.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "LogicalNot")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `LogicalNot::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LogicalNot>
pub fn logical_not<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = LogicalNot::new();
    op.call(ctx, x)
}

/// LogicalOr
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LogicalOr>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LogicalOr {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LogicalOr {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl LogicalOr {
    /// Creates a new `LogicalOr`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute logical_or.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "LogicalOr")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `LogicalOr::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LogicalOr>
pub fn logical_or<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = LogicalOr::new();
    op.call(ctx, x, y)
}

/// LookupTableExport
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LookupTableExport>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LookupTableExport {
    Tkeys: ::std::option::Option<crate::DataType>,
    Tvalues: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LookupTableExport {
    fn default() -> Self {
        Self {
            Tkeys: None,
            Tvalues: None,
            target_device_name: None,
        }
    }
}
impl LookupTableExport {
    /// Creates a new `LookupTableExport`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Tkeys` attribute.
    pub fn Tkeys<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.Tkeys = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `Tvalues` attribute.
    pub fn Tvalues<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Tvalues = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute lookup_table_export.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        table_handle: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "LookupTableExport")?;

        // Required input arguments
        op.add_input(&table_handle.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Tkeys {
            op.set_attr_type("Tkeys", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.Tvalues {
            op.set_attr_type("Tvalues", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `LookupTableExport::new().call(&ctx, &table_handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LookupTableExport>
pub fn lookup_table_export<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    table_handle: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = LookupTableExport::new();
    op.call(ctx, table_handle)
}

/// LookupTableExportV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LookupTableExportV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LookupTableExportV2 {
    Tkeys: ::std::option::Option<crate::DataType>,
    Tvalues: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LookupTableExportV2 {
    fn default() -> Self {
        Self {
            Tkeys: None,
            Tvalues: None,
            target_device_name: None,
        }
    }
}
impl LookupTableExportV2 {
    /// Creates a new `LookupTableExportV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Tkeys` attribute.
    pub fn Tkeys<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.Tkeys = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `Tvalues` attribute.
    pub fn Tvalues<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Tvalues = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute lookup_table_export_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        table_handle: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "LookupTableExportV2")?;

        // Required input arguments
        op.add_input(&table_handle.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Tkeys {
            op.set_attr_type("Tkeys", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.Tvalues {
            op.set_attr_type("Tvalues", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `LookupTableExportV2::new().call(&ctx, &table_handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LookupTableExportV2>
pub fn lookup_table_export_v2<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    table_handle: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = LookupTableExportV2::new();
    op.call(ctx, table_handle)
}

/// LookupTableFind
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LookupTableFind>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LookupTableFind {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LookupTableFind {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl LookupTableFind {
    /// Creates a new `LookupTableFind`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute lookup_table_find.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        table_handle: &T0,
        keys: &T1,
        default_value: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "LookupTableFind")?;

        // Required input arguments
        op.add_input(&table_handle.to_handle(ctx)?)?;
        op.add_input(&keys.to_handle(ctx)?)?;
        op.add_input(&default_value.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `LookupTableFind::new().call(&ctx, &table_handle, &keys, &default_value)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LookupTableFind>
pub fn lookup_table_find<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    table_handle: &T0,
    keys: &T1,
    default_value: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = LookupTableFind::new();
    op.call(ctx, table_handle, keys, default_value)
}

/// LookupTableFindV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LookupTableFindV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LookupTableFindV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LookupTableFindV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl LookupTableFindV2 {
    /// Creates a new `LookupTableFindV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute lookup_table_find_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        table_handle: &T0,
        keys: &T1,
        default_value: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "LookupTableFindV2")?;

        // Required input arguments
        op.add_input(&table_handle.to_handle(ctx)?)?;
        op.add_input(&keys.to_handle(ctx)?)?;
        op.add_input(&default_value.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `LookupTableFindV2::new().call(&ctx, &table_handle, &keys, &default_value)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LookupTableFindV2>
pub fn lookup_table_find_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    table_handle: &T0,
    keys: &T1,
    default_value: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = LookupTableFindV2::new();
    op.call(ctx, table_handle, keys, default_value)
}

/// LookupTableImport
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LookupTableImport>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LookupTableImport {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LookupTableImport {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl LookupTableImport {
    /// Creates a new `LookupTableImport`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute lookup_table_import.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        table_handle: &T0,
        keys: &T1,
        values: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "LookupTableImport")?;

        // Required input arguments
        op.add_input(&table_handle.to_handle(ctx)?)?;
        op.add_input(&keys.to_handle(ctx)?)?;
        op.add_input(&values.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `LookupTableImport::new().call(&ctx, &table_handle, &keys, &values)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LookupTableImport>
pub fn lookup_table_import<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    table_handle: &T0,
    keys: &T1,
    values: &T2,
) -> crate::Result<()> {
    let op = LookupTableImport::new();
    op.call(ctx, table_handle, keys, values)
}

/// LookupTableImportV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LookupTableImportV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LookupTableImportV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LookupTableImportV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl LookupTableImportV2 {
    /// Creates a new `LookupTableImportV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute lookup_table_import_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        table_handle: &T0,
        keys: &T1,
        values: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "LookupTableImportV2")?;

        // Required input arguments
        op.add_input(&table_handle.to_handle(ctx)?)?;
        op.add_input(&keys.to_handle(ctx)?)?;
        op.add_input(&values.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `LookupTableImportV2::new().call(&ctx, &table_handle, &keys, &values)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LookupTableImportV2>
pub fn lookup_table_import_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    table_handle: &T0,
    keys: &T1,
    values: &T2,
) -> crate::Result<()> {
    let op = LookupTableImportV2::new();
    op.call(ctx, table_handle, keys, values)
}

/// LookupTableInsert
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LookupTableInsert>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LookupTableInsert {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LookupTableInsert {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl LookupTableInsert {
    /// Creates a new `LookupTableInsert`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute lookup_table_insert.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        table_handle: &T0,
        keys: &T1,
        values: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "LookupTableInsert")?;

        // Required input arguments
        op.add_input(&table_handle.to_handle(ctx)?)?;
        op.add_input(&keys.to_handle(ctx)?)?;
        op.add_input(&values.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `LookupTableInsert::new().call(&ctx, &table_handle, &keys, &values)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LookupTableInsert>
pub fn lookup_table_insert<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    table_handle: &T0,
    keys: &T1,
    values: &T2,
) -> crate::Result<()> {
    let op = LookupTableInsert::new();
    op.call(ctx, table_handle, keys, values)
}

/// LookupTableInsertV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LookupTableInsertV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LookupTableInsertV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LookupTableInsertV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl LookupTableInsertV2 {
    /// Creates a new `LookupTableInsertV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute lookup_table_insert_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        table_handle: &T0,
        keys: &T1,
        values: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "LookupTableInsertV2")?;

        // Required input arguments
        op.add_input(&table_handle.to_handle(ctx)?)?;
        op.add_input(&keys.to_handle(ctx)?)?;
        op.add_input(&values.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `LookupTableInsertV2::new().call(&ctx, &table_handle, &keys, &values)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LookupTableInsertV2>
pub fn lookup_table_insert_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    table_handle: &T0,
    keys: &T1,
    values: &T2,
) -> crate::Result<()> {
    let op = LookupTableInsertV2::new();
    op.call(ctx, table_handle, keys, values)
}

/// LookupTableRemoveV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LookupTableRemoveV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LookupTableRemoveV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LookupTableRemoveV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl LookupTableRemoveV2 {
    /// Creates a new `LookupTableRemoveV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute lookup_table_remove_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        table_handle: &T0,
        keys: &T1,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "LookupTableRemoveV2")?;

        // Required input arguments
        op.add_input(&table_handle.to_handle(ctx)?)?;
        op.add_input(&keys.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `LookupTableRemoveV2::new().call(&ctx, &table_handle, &keys)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LookupTableRemoveV2>
pub fn lookup_table_remove_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    table_handle: &T0,
    keys: &T1,
) -> crate::Result<()> {
    let op = LookupTableRemoveV2::new();
    op.call(ctx, table_handle, keys)
}

/// LookupTableSize
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LookupTableSize>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LookupTableSize {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LookupTableSize {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl LookupTableSize {
    /// Creates a new `LookupTableSize`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute lookup_table_size.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        table_handle: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "LookupTableSize")?;

        // Required input arguments
        op.add_input(&table_handle.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `LookupTableSize::new().call(&ctx, &table_handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LookupTableSize>
pub fn lookup_table_size<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    table_handle: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = LookupTableSize::new();
    op.call(ctx, table_handle)
}

/// LookupTableSizeV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LookupTableSizeV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LookupTableSizeV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LookupTableSizeV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl LookupTableSizeV2 {
    /// Creates a new `LookupTableSizeV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute lookup_table_size_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        table_handle: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "LookupTableSizeV2")?;

        // Required input arguments
        op.add_input(&table_handle.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `LookupTableSizeV2::new().call(&ctx, &table_handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LookupTableSizeV2>
pub fn lookup_table_size_v2<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    table_handle: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = LookupTableSizeV2::new();
    op.call(ctx, table_handle)
}

/// LoopCond
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LoopCond>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LoopCond {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LoopCond {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl LoopCond {
    /// Creates a new `LoopCond`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute loop_cond.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "LoopCond")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `LoopCond::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LoopCond>
pub fn loop_cond<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = LoopCond::new();
    op.call(ctx, input)
}

/// LowerBound
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LowerBound>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct LowerBound {
    out_type: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for LowerBound {
    fn default() -> Self {
        Self {
            out_type: Some(crate::DataType::Int32),
            target_device_name: None,
        }
    }
}
impl LowerBound {
    /// Creates a new `LowerBound`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_type` attribute.
    pub fn out_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute lower_bound.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        sorted_inputs: &T0,
        values: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "LowerBound")?;

        // Required input arguments
        op.add_input(&sorted_inputs.to_handle(ctx)?)?;
        op.add_input(&values.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_type {
            op.set_attr_type("out_type", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `LowerBound::new().call(&ctx, &sorted_inputs, &values)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/LowerBound>
pub fn lower_bound<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    sorted_inputs: &T0,
    values: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = LowerBound::new();
    op.call(ctx, sorted_inputs, values)
}

/// Lu
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Lu>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Lu {
    output_idx_type: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Lu {
    fn default() -> Self {
        Self {
            output_idx_type: Some(crate::DataType::Int32),
            target_device_name: None,
        }
    }
}
impl Lu {
    /// Creates a new `Lu`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_idx_type` attribute.
    pub fn output_idx_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_idx_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute lu.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "Lu")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_idx_type {
            op.set_attr_type("output_idx_type", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `Lu::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Lu>
pub fn lu<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = Lu::new();
    op.call(ctx, input)
}

/// MakeIterator
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MakeIterator>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MakeIterator {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MakeIterator {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl MakeIterator {
    /// Creates a new `MakeIterator`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute make_iterator.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        dataset: &T0,
        iterator: &T1,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "MakeIterator")?;

        // Required input arguments
        op.add_input(&dataset.to_handle(ctx)?)?;
        op.add_input(&iterator.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `MakeIterator::new().call(&ctx, &dataset, &iterator)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MakeIterator>
pub fn make_iterator<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    dataset: &T0,
    iterator: &T1,
) -> crate::Result<()> {
    let op = MakeIterator::new();
    op.call(ctx, dataset, iterator)
}

/// MakeUnique
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MakeUnique>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MakeUnique {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MakeUnique {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl MakeUnique {
    /// Creates a new `MakeUnique`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute make_unique.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MakeUnique")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MakeUnique::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MakeUnique>
pub fn make_unique<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MakeUnique::new();
    op.call(ctx, input)
}

/// MapAndBatchDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MapAndBatchDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MapAndBatchDataset {
    f: ::std::option::Option<::std::string::String>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    preserve_cardinality: ::std::option::Option<bool>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MapAndBatchDataset {
    fn default() -> Self {
        Self {
            f: None,
            output_types: None,
            output_shapes: None,
            preserve_cardinality: Some(false),
            metadata: None,
            target_device_name: None,
        }
    }
}
impl MapAndBatchDataset {
    /// Creates a new `MapAndBatchDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `f` attribute.
    pub fn f<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.f = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `preserve_cardinality` attribute.
    pub fn preserve_cardinality<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.preserve_cardinality = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute map_and_batch_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        other_arguments: &T1,
        batch_size: &T2,
        num_parallel_calls: &T3,
        drop_remainder: &T4,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MapAndBatchDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&other_arguments.to_handle(ctx)?)?;
        op.add_input(&batch_size.to_handle(ctx)?)?;
        op.add_input(&num_parallel_calls.to_handle(ctx)?)?;
        op.add_input(&drop_remainder.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.f {
            op.set_attr_string("f", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.preserve_cardinality {
            op.set_attr_bool("preserve_cardinality", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MapAndBatchDataset::new().call(&ctx, &input_dataset, &other_arguments, &batch_size, &num_parallel_calls, &drop_remainder)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MapAndBatchDataset>
pub fn map_and_batch_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    other_arguments: &T1,
    batch_size: &T2,
    num_parallel_calls: &T3,
    drop_remainder: &T4,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MapAndBatchDataset::new();
    op.call(
        ctx,
        input_dataset,
        other_arguments,
        batch_size,
        num_parallel_calls,
        drop_remainder,
    )
}

/// MapClear
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MapClear>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MapClear {
    capacity: ::std::option::Option<i64>,
    memory_limit: ::std::option::Option<i64>,
    dtypes: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MapClear {
    fn default() -> Self {
        Self {
            capacity: Some(0i64),
            memory_limit: Some(0i64),
            dtypes: None,
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl MapClear {
    /// Creates a new `MapClear`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `capacity` attribute.
    pub fn capacity<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.capacity = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `memory_limit` attribute.
    pub fn memory_limit<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.memory_limit = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dtypes` attribute.
    pub fn dtypes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dtypes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute map_clear.
    pub fn call<'a>(&self, ctx: &'a crate::eager::Context) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "MapClear")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.capacity {
            op.set_attr_int("capacity", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.memory_limit {
            op.set_attr_int("memory_limit", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dtypes {
            op.set_attr_type_list("dtypes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `MapClear::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MapClear>
pub fn map_clear<'a>(ctx: &'a crate::eager::Context) -> crate::Result<()> {
    let op = MapClear::new();
    op.call(ctx)
}

/// MapDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MapDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MapDataset {
    f: ::std::option::Option<::std::string::String>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    use_inter_op_parallelism: ::std::option::Option<bool>,
    preserve_cardinality: ::std::option::Option<bool>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MapDataset {
    fn default() -> Self {
        Self {
            f: None,
            output_types: None,
            output_shapes: None,
            use_inter_op_parallelism: Some(true),
            preserve_cardinality: Some(false),
            metadata: None,
            target_device_name: None,
        }
    }
}
impl MapDataset {
    /// Creates a new `MapDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `f` attribute.
    pub fn f<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.f = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_inter_op_parallelism` attribute.
    pub fn use_inter_op_parallelism<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.use_inter_op_parallelism = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `preserve_cardinality` attribute.
    pub fn preserve_cardinality<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.preserve_cardinality = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute map_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        other_arguments: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MapDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&other_arguments.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.f {
            op.set_attr_string("f", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_inter_op_parallelism {
            op.set_attr_bool("use_inter_op_parallelism", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.preserve_cardinality {
            op.set_attr_bool("preserve_cardinality", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MapDataset::new().call(&ctx, &input_dataset, &other_arguments)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MapDataset>
pub fn map_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    other_arguments: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MapDataset::new();
    op.call(ctx, input_dataset, other_arguments)
}

/// MapDefun
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MapDefun>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MapDefun {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    f: ::std::option::Option<::std::string::String>,
    max_intra_op_parallelism: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MapDefun {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            f: None,
            max_intra_op_parallelism: Some(1i64),
            target_device_name: None,
        }
    }
}
impl MapDefun {
    /// Creates a new `MapDefun`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `f` attribute.
    pub fn f<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.f = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `max_intra_op_parallelism` attribute.
    pub fn max_intra_op_parallelism<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.max_intra_op_parallelism = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute map_defun.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        arguments: &T0,
        captured_inputs: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MapDefun")?;

        // Required input arguments
        op.add_input(&arguments.to_handle(ctx)?)?;
        op.add_input(&captured_inputs.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.f {
            op.set_attr_string("f", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.max_intra_op_parallelism {
            op.set_attr_int("max_intra_op_parallelism", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MapDefun::new().call(&ctx, &arguments, &captured_inputs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MapDefun>
pub fn map_defun<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    arguments: &T0,
    captured_inputs: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MapDefun::new();
    op.call(ctx, arguments, captured_inputs)
}

/// MapIncompleteSize
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MapIncompleteSize>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MapIncompleteSize {
    capacity: ::std::option::Option<i64>,
    memory_limit: ::std::option::Option<i64>,
    dtypes: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MapIncompleteSize {
    fn default() -> Self {
        Self {
            capacity: Some(0i64),
            memory_limit: Some(0i64),
            dtypes: None,
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl MapIncompleteSize {
    /// Creates a new `MapIncompleteSize`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `capacity` attribute.
    pub fn capacity<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.capacity = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `memory_limit` attribute.
    pub fn memory_limit<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.memory_limit = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dtypes` attribute.
    pub fn dtypes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dtypes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute map_incomplete_size.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MapIncompleteSize")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.capacity {
            op.set_attr_int("capacity", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.memory_limit {
            op.set_attr_int("memory_limit", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dtypes {
            op.set_attr_type_list("dtypes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MapIncompleteSize::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MapIncompleteSize>
pub fn map_incomplete_size<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MapIncompleteSize::new();
    op.call(ctx)
}

/// MapPeek
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MapPeek>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MapPeek {
    capacity: ::std::option::Option<i64>,
    memory_limit: ::std::option::Option<i64>,
    dtypes: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MapPeek {
    fn default() -> Self {
        Self {
            capacity: Some(0i64),
            memory_limit: Some(0i64),
            dtypes: None,
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl MapPeek {
    /// Creates a new `MapPeek`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `capacity` attribute.
    pub fn capacity<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.capacity = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `memory_limit` attribute.
    pub fn memory_limit<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.memory_limit = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dtypes` attribute.
    pub fn dtypes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dtypes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute map_peek.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        key: &T0,
        indices: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MapPeek")?;

        // Required input arguments
        op.add_input(&key.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.capacity {
            op.set_attr_int("capacity", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.memory_limit {
            op.set_attr_int("memory_limit", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dtypes {
            op.set_attr_type_list("dtypes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MapPeek::new().call(&ctx, &key, &indices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MapPeek>
pub fn map_peek<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    key: &T0,
    indices: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MapPeek::new();
    op.call(ctx, key, indices)
}

/// MapSize
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MapSize>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MapSize {
    capacity: ::std::option::Option<i64>,
    memory_limit: ::std::option::Option<i64>,
    dtypes: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MapSize {
    fn default() -> Self {
        Self {
            capacity: Some(0i64),
            memory_limit: Some(0i64),
            dtypes: None,
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl MapSize {
    /// Creates a new `MapSize`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `capacity` attribute.
    pub fn capacity<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.capacity = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `memory_limit` attribute.
    pub fn memory_limit<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.memory_limit = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dtypes` attribute.
    pub fn dtypes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dtypes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute map_size.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MapSize")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.capacity {
            op.set_attr_int("capacity", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.memory_limit {
            op.set_attr_int("memory_limit", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dtypes {
            op.set_attr_type_list("dtypes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MapSize::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MapSize>
pub fn map_size<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MapSize::new();
    op.call(ctx)
}

/// MapStage
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MapStage>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MapStage {
    capacity: ::std::option::Option<i64>,
    memory_limit: ::std::option::Option<i64>,
    dtypes: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MapStage {
    fn default() -> Self {
        Self {
            capacity: Some(0i64),
            memory_limit: Some(0i64),
            dtypes: None,
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl MapStage {
    /// Creates a new `MapStage`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `capacity` attribute.
    pub fn capacity<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.capacity = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `memory_limit` attribute.
    pub fn memory_limit<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.memory_limit = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dtypes` attribute.
    pub fn dtypes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dtypes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute map_stage.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        key: &T0,
        indices: &T1,
        values: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "MapStage")?;

        // Required input arguments
        op.add_input(&key.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&values.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.capacity {
            op.set_attr_int("capacity", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.memory_limit {
            op.set_attr_int("memory_limit", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dtypes {
            op.set_attr_type_list("dtypes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `MapStage::new().call(&ctx, &key, &indices, &values)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MapStage>
pub fn map_stage<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    key: &T0,
    indices: &T1,
    values: &T2,
) -> crate::Result<()> {
    let op = MapStage::new();
    op.call(ctx, key, indices, values)
}

/// MapUnstage
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MapUnstage>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MapUnstage {
    capacity: ::std::option::Option<i64>,
    memory_limit: ::std::option::Option<i64>,
    dtypes: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MapUnstage {
    fn default() -> Self {
        Self {
            capacity: Some(0i64),
            memory_limit: Some(0i64),
            dtypes: None,
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl MapUnstage {
    /// Creates a new `MapUnstage`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `capacity` attribute.
    pub fn capacity<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.capacity = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `memory_limit` attribute.
    pub fn memory_limit<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.memory_limit = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dtypes` attribute.
    pub fn dtypes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dtypes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute map_unstage.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        key: &T0,
        indices: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MapUnstage")?;

        // Required input arguments
        op.add_input(&key.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.capacity {
            op.set_attr_int("capacity", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.memory_limit {
            op.set_attr_int("memory_limit", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dtypes {
            op.set_attr_type_list("dtypes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MapUnstage::new().call(&ctx, &key, &indices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MapUnstage>
pub fn map_unstage<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    key: &T0,
    indices: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MapUnstage::new();
    op.call(ctx, key, indices)
}

/// MapUnstageNoKey
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MapUnstageNoKey>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MapUnstageNoKey {
    capacity: ::std::option::Option<i64>,
    memory_limit: ::std::option::Option<i64>,
    dtypes: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MapUnstageNoKey {
    fn default() -> Self {
        Self {
            capacity: Some(0i64),
            memory_limit: Some(0i64),
            dtypes: None,
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl MapUnstageNoKey {
    /// Creates a new `MapUnstageNoKey`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `capacity` attribute.
    pub fn capacity<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.capacity = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `memory_limit` attribute.
    pub fn memory_limit<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.memory_limit = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dtypes` attribute.
    pub fn dtypes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dtypes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute map_unstage_no_key.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        indices: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "MapUnstageNoKey")?;

        // Required input arguments
        op.add_input(&indices.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.capacity {
            op.set_attr_int("capacity", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.memory_limit {
            op.set_attr_int("memory_limit", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dtypes {
            op.set_attr_type_list("dtypes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `MapUnstageNoKey::new().call(&ctx, &indices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MapUnstageNoKey>
pub fn map_unstage_no_key<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    indices: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = MapUnstageNoKey::new();
    op.call(ctx, indices)
}

/// MatMul
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatMul>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MatMul {
    transpose_a: ::std::option::Option<bool>,
    transpose_b: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MatMul {
    fn default() -> Self {
        Self {
            transpose_a: Some(false),
            transpose_b: Some(false),
            target_device_name: None,
        }
    }
}
impl MatMul {
    /// Creates a new `MatMul`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `transpose_a` attribute.
    pub fn transpose_a<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.transpose_a = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `transpose_b` attribute.
    pub fn transpose_b<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.transpose_b = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute mat_mul.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        a: &T0,
        b: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MatMul")?;

        // Required input arguments
        op.add_input(&a.to_handle(ctx)?)?;
        op.add_input(&b.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.transpose_a {
            op.set_attr_bool("transpose_a", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.transpose_b {
            op.set_attr_bool("transpose_b", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MatMul::new().call(&ctx, &a, &b)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatMul>
pub fn mat_mul<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    a: &T0,
    b: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MatMul::new();
    op.call(ctx, a, b)
}

/// MatchingFiles
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatchingFiles>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MatchingFiles {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MatchingFiles {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl MatchingFiles {
    /// Creates a new `MatchingFiles`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute matching_files.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        pattern: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MatchingFiles")?;

        // Required input arguments
        op.add_input(&pattern.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MatchingFiles::new().call(&ctx, &pattern)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatchingFiles>
pub fn matching_files<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    pattern: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MatchingFiles::new();
    op.call(ctx, pattern)
}

/// MatchingFilesDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatchingFilesDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MatchingFilesDataset {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MatchingFilesDataset {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl MatchingFilesDataset {
    /// Creates a new `MatchingFilesDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute matching_files_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        patterns: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MatchingFilesDataset")?;

        // Required input arguments
        op.add_input(&patterns.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MatchingFilesDataset::new().call(&ctx, &patterns)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatchingFilesDataset>
pub fn matching_files_dataset<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    patterns: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MatchingFilesDataset::new();
    op.call(ctx, patterns)
}

/// MatrixBandPart
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatrixBandPart>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MatrixBandPart {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MatrixBandPart {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl MatrixBandPart {
    /// Creates a new `MatrixBandPart`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute matrix_band_part.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        num_lower: &T1,
        num_upper: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MatrixBandPart")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&num_lower.to_handle(ctx)?)?;
        op.add_input(&num_upper.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MatrixBandPart::new().call(&ctx, &input, &num_lower, &num_upper)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatrixBandPart>
pub fn matrix_band_part<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    num_lower: &T1,
    num_upper: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MatrixBandPart::new();
    op.call(ctx, input, num_lower, num_upper)
}

/// MatrixDeterminant
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatrixDeterminant>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MatrixDeterminant {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MatrixDeterminant {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl MatrixDeterminant {
    /// Creates a new `MatrixDeterminant`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute matrix_determinant.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MatrixDeterminant")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MatrixDeterminant::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatrixDeterminant>
pub fn matrix_determinant<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MatrixDeterminant::new();
    op.call(ctx, input)
}

/// MatrixDiag
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatrixDiag>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MatrixDiag {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MatrixDiag {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl MatrixDiag {
    /// Creates a new `MatrixDiag`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute matrix_diag.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        diagonal: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MatrixDiag")?;

        // Required input arguments
        op.add_input(&diagonal.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MatrixDiag::new().call(&ctx, &diagonal)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatrixDiag>
pub fn matrix_diag<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    diagonal: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MatrixDiag::new();
    op.call(ctx, diagonal)
}

/// MatrixDiagPart
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatrixDiagPart>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MatrixDiagPart {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MatrixDiagPart {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl MatrixDiagPart {
    /// Creates a new `MatrixDiagPart`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute matrix_diag_part.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MatrixDiagPart")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MatrixDiagPart::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatrixDiagPart>
pub fn matrix_diag_part<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MatrixDiagPart::new();
    op.call(ctx, input)
}

/// MatrixDiagPartV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatrixDiagPartV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MatrixDiagPartV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MatrixDiagPartV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl MatrixDiagPartV2 {
    /// Creates a new `MatrixDiagPartV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute matrix_diag_part_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        k: &T1,
        padding_value: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MatrixDiagPartV2")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&k.to_handle(ctx)?)?;
        op.add_input(&padding_value.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MatrixDiagPartV2::new().call(&ctx, &input, &k, &padding_value)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatrixDiagPartV2>
pub fn matrix_diag_part_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    k: &T1,
    padding_value: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MatrixDiagPartV2::new();
    op.call(ctx, input, k, padding_value)
}

/// MatrixDiagPartV3
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatrixDiagPartV3>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MatrixDiagPartV3 {
    align: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MatrixDiagPartV3 {
    fn default() -> Self {
        Self {
            align: Some(::std::string::String::from("RIGHT_LEFT")),
            target_device_name: None,
        }
    }
}
impl MatrixDiagPartV3 {
    /// Creates a new `MatrixDiagPartV3`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `align` attribute.
    pub fn align<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.align = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute matrix_diag_part_v3.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        k: &T1,
        padding_value: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MatrixDiagPartV3")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&k.to_handle(ctx)?)?;
        op.add_input(&padding_value.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.align {
            op.set_attr_string("align", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MatrixDiagPartV3::new().call(&ctx, &input, &k, &padding_value)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatrixDiagPartV3>
pub fn matrix_diag_part_v3<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    k: &T1,
    padding_value: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MatrixDiagPartV3::new();
    op.call(ctx, input, k, padding_value)
}

/// MatrixDiagV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatrixDiagV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MatrixDiagV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MatrixDiagV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl MatrixDiagV2 {
    /// Creates a new `MatrixDiagV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute matrix_diag_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        diagonal: &T0,
        k: &T1,
        num_rows: &T2,
        num_cols: &T3,
        padding_value: &T4,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MatrixDiagV2")?;

        // Required input arguments
        op.add_input(&diagonal.to_handle(ctx)?)?;
        op.add_input(&k.to_handle(ctx)?)?;
        op.add_input(&num_rows.to_handle(ctx)?)?;
        op.add_input(&num_cols.to_handle(ctx)?)?;
        op.add_input(&padding_value.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MatrixDiagV2::new().call(&ctx, &diagonal, &k, &num_rows, &num_cols, &padding_value)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatrixDiagV2>
pub fn matrix_diag_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    diagonal: &T0,
    k: &T1,
    num_rows: &T2,
    num_cols: &T3,
    padding_value: &T4,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MatrixDiagV2::new();
    op.call(ctx, diagonal, k, num_rows, num_cols, padding_value)
}

/// MatrixDiagV3
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatrixDiagV3>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MatrixDiagV3 {
    align: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MatrixDiagV3 {
    fn default() -> Self {
        Self {
            align: Some(::std::string::String::from("RIGHT_LEFT")),
            target_device_name: None,
        }
    }
}
impl MatrixDiagV3 {
    /// Creates a new `MatrixDiagV3`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `align` attribute.
    pub fn align<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.align = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute matrix_diag_v3.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        diagonal: &T0,
        k: &T1,
        num_rows: &T2,
        num_cols: &T3,
        padding_value: &T4,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MatrixDiagV3")?;

        // Required input arguments
        op.add_input(&diagonal.to_handle(ctx)?)?;
        op.add_input(&k.to_handle(ctx)?)?;
        op.add_input(&num_rows.to_handle(ctx)?)?;
        op.add_input(&num_cols.to_handle(ctx)?)?;
        op.add_input(&padding_value.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.align {
            op.set_attr_string("align", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MatrixDiagV3::new().call(&ctx, &diagonal, &k, &num_rows, &num_cols, &padding_value)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatrixDiagV3>
pub fn matrix_diag_v3<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    diagonal: &T0,
    k: &T1,
    num_rows: &T2,
    num_cols: &T3,
    padding_value: &T4,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MatrixDiagV3::new();
    op.call(ctx, diagonal, k, num_rows, num_cols, padding_value)
}

/// MatrixExponential
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatrixExponential>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MatrixExponential {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MatrixExponential {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl MatrixExponential {
    /// Creates a new `MatrixExponential`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute matrix_exponential.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MatrixExponential")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MatrixExponential::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatrixExponential>
pub fn matrix_exponential<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MatrixExponential::new();
    op.call(ctx, input)
}

/// MatrixInverse
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatrixInverse>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MatrixInverse {
    adjoint: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MatrixInverse {
    fn default() -> Self {
        Self {
            adjoint: Some(false),
            target_device_name: None,
        }
    }
}
impl MatrixInverse {
    /// Creates a new `MatrixInverse`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `adjoint` attribute.
    pub fn adjoint<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.adjoint = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute matrix_inverse.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MatrixInverse")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.adjoint {
            op.set_attr_bool("adjoint", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MatrixInverse::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatrixInverse>
pub fn matrix_inverse<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MatrixInverse::new();
    op.call(ctx, input)
}

/// MatrixLogarithm
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatrixLogarithm>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MatrixLogarithm {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MatrixLogarithm {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl MatrixLogarithm {
    /// Creates a new `MatrixLogarithm`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute matrix_logarithm.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MatrixLogarithm")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MatrixLogarithm::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatrixLogarithm>
pub fn matrix_logarithm<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MatrixLogarithm::new();
    op.call(ctx, input)
}

/// MatrixSetDiag
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatrixSetDiag>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MatrixSetDiag {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MatrixSetDiag {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl MatrixSetDiag {
    /// Creates a new `MatrixSetDiag`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute matrix_set_diag.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        diagonal: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MatrixSetDiag")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&diagonal.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MatrixSetDiag::new().call(&ctx, &input, &diagonal)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatrixSetDiag>
pub fn matrix_set_diag<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    diagonal: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MatrixSetDiag::new();
    op.call(ctx, input, diagonal)
}

/// MatrixSetDiagV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatrixSetDiagV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MatrixSetDiagV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MatrixSetDiagV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl MatrixSetDiagV2 {
    /// Creates a new `MatrixSetDiagV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute matrix_set_diag_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        diagonal: &T1,
        k: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MatrixSetDiagV2")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&diagonal.to_handle(ctx)?)?;
        op.add_input(&k.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MatrixSetDiagV2::new().call(&ctx, &input, &diagonal, &k)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatrixSetDiagV2>
pub fn matrix_set_diag_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    diagonal: &T1,
    k: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MatrixSetDiagV2::new();
    op.call(ctx, input, diagonal, k)
}

/// MatrixSetDiagV3
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatrixSetDiagV3>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MatrixSetDiagV3 {
    align: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MatrixSetDiagV3 {
    fn default() -> Self {
        Self {
            align: Some(::std::string::String::from("RIGHT_LEFT")),
            target_device_name: None,
        }
    }
}
impl MatrixSetDiagV3 {
    /// Creates a new `MatrixSetDiagV3`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `align` attribute.
    pub fn align<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.align = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute matrix_set_diag_v3.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        diagonal: &T1,
        k: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MatrixSetDiagV3")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&diagonal.to_handle(ctx)?)?;
        op.add_input(&k.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.align {
            op.set_attr_string("align", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MatrixSetDiagV3::new().call(&ctx, &input, &diagonal, &k)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatrixSetDiagV3>
pub fn matrix_set_diag_v3<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    diagonal: &T1,
    k: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MatrixSetDiagV3::new();
    op.call(ctx, input, diagonal, k)
}

/// MatrixSolve
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatrixSolve>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MatrixSolve {
    adjoint: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MatrixSolve {
    fn default() -> Self {
        Self {
            adjoint: Some(false),
            target_device_name: None,
        }
    }
}
impl MatrixSolve {
    /// Creates a new `MatrixSolve`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `adjoint` attribute.
    pub fn adjoint<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.adjoint = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute matrix_solve.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        matrix: &T0,
        rhs: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MatrixSolve")?;

        // Required input arguments
        op.add_input(&matrix.to_handle(ctx)?)?;
        op.add_input(&rhs.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.adjoint {
            op.set_attr_bool("adjoint", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MatrixSolve::new().call(&ctx, &matrix, &rhs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatrixSolve>
pub fn matrix_solve<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    matrix: &T0,
    rhs: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MatrixSolve::new();
    op.call(ctx, matrix, rhs)
}

/// MatrixSolveLs
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatrixSolveLs>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MatrixSolveLs {
    fast: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MatrixSolveLs {
    fn default() -> Self {
        Self {
            fast: Some(true),
            target_device_name: None,
        }
    }
}
impl MatrixSolveLs {
    /// Creates a new `MatrixSolveLs`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `fast` attribute.
    pub fn fast<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.fast = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute matrix_solve_ls.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        matrix: &T0,
        rhs: &T1,
        l2_regularizer: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MatrixSolveLs")?;

        // Required input arguments
        op.add_input(&matrix.to_handle(ctx)?)?;
        op.add_input(&rhs.to_handle(ctx)?)?;
        op.add_input(&l2_regularizer.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.fast {
            op.set_attr_bool("fast", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MatrixSolveLs::new().call(&ctx, &matrix, &rhs, &l2_regularizer)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatrixSolveLs>
pub fn matrix_solve_ls<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    matrix: &T0,
    rhs: &T1,
    l2_regularizer: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MatrixSolveLs::new();
    op.call(ctx, matrix, rhs, l2_regularizer)
}

/// MatrixSquareRoot
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatrixSquareRoot>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MatrixSquareRoot {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MatrixSquareRoot {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl MatrixSquareRoot {
    /// Creates a new `MatrixSquareRoot`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute matrix_square_root.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MatrixSquareRoot")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MatrixSquareRoot::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatrixSquareRoot>
pub fn matrix_square_root<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MatrixSquareRoot::new();
    op.call(ctx, input)
}

/// MatrixTriangularSolve
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatrixTriangularSolve>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MatrixTriangularSolve {
    lower: ::std::option::Option<bool>,
    adjoint: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MatrixTriangularSolve {
    fn default() -> Self {
        Self {
            lower: Some(true),
            adjoint: Some(false),
            target_device_name: None,
        }
    }
}
impl MatrixTriangularSolve {
    /// Creates a new `MatrixTriangularSolve`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `lower` attribute.
    pub fn lower<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.lower = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `adjoint` attribute.
    pub fn adjoint<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.adjoint = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute matrix_triangular_solve.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        matrix: &T0,
        rhs: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MatrixTriangularSolve")?;

        // Required input arguments
        op.add_input(&matrix.to_handle(ctx)?)?;
        op.add_input(&rhs.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.lower {
            op.set_attr_bool("lower", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.adjoint {
            op.set_attr_bool("adjoint", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MatrixTriangularSolve::new().call(&ctx, &matrix, &rhs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MatrixTriangularSolve>
pub fn matrix_triangular_solve<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    matrix: &T0,
    rhs: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MatrixTriangularSolve::new();
    op.call(ctx, matrix, rhs)
}

/// Max
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Max>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Max {
    keep_dims: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Max {
    fn default() -> Self {
        Self {
            keep_dims: Some(false),
            target_device_name: None,
        }
    }
}
impl Max {
    /// Creates a new `Max`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `keep_dims` attribute.
    pub fn keep_dims<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.keep_dims = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute max.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        reduction_indices: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Max")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&reduction_indices.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.keep_dims {
            op.set_attr_bool("keep_dims", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Max::new().call(&ctx, &input, &reduction_indices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Max>
pub fn max<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    reduction_indices: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Max::new();
    op.call(ctx, input, reduction_indices)
}

/// MaxIntraOpParallelismDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MaxIntraOpParallelismDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MaxIntraOpParallelismDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MaxIntraOpParallelismDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl MaxIntraOpParallelismDataset {
    /// Creates a new `MaxIntraOpParallelismDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute max_intra_op_parallelism_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        max_intra_op_parallelism: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MaxIntraOpParallelismDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&max_intra_op_parallelism.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MaxIntraOpParallelismDataset::new().call(&ctx, &input_dataset, &max_intra_op_parallelism)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MaxIntraOpParallelismDataset>
pub fn max_intra_op_parallelism_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    max_intra_op_parallelism: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MaxIntraOpParallelismDataset::new();
    op.call(ctx, input_dataset, max_intra_op_parallelism)
}

/// MaxPool
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MaxPool>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MaxPool {
    ksize: ::std::option::Option<::std::vec::Vec<i64>>,
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    explicit_paddings: ::std::option::Option<::std::vec::Vec<i64>>,
    data_format: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MaxPool {
    fn default() -> Self {
        Self {
            ksize: None,
            strides: None,
            padding: None,
            explicit_paddings: Some(vec![]),
            data_format: Some(::std::string::String::from("NHWC")),
            target_device_name: None,
        }
    }
}
impl MaxPool {
    /// Creates a new `MaxPool`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `ksize` attribute.
    pub fn ksize<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.ksize = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `explicit_paddings` attribute.
    pub fn explicit_paddings<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.explicit_paddings = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `data_format` attribute.
    pub fn data_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.data_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute max_pool.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MaxPool")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.ksize {
            op.set_attr_int_list("ksize", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.explicit_paddings {
            op.set_attr_int_list("explicit_paddings", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.data_format {
            op.set_attr_string("data_format", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MaxPool::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MaxPool>
pub fn max_pool<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MaxPool::new();
    op.call(ctx, input)
}

/// MaxPool3D
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MaxPool3D>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MaxPool3D {
    ksize: ::std::option::Option<::std::vec::Vec<i64>>,
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    data_format: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MaxPool3D {
    fn default() -> Self {
        Self {
            ksize: None,
            strides: None,
            padding: None,
            data_format: Some(::std::string::String::from("NDHWC")),
            target_device_name: None,
        }
    }
}
impl MaxPool3D {
    /// Creates a new `MaxPool3D`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `ksize` attribute.
    pub fn ksize<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.ksize = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `data_format` attribute.
    pub fn data_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.data_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute max_pool3_d.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MaxPool3D")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.ksize {
            op.set_attr_int_list("ksize", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.data_format {
            op.set_attr_string("data_format", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MaxPool3D::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MaxPool3D>
pub fn max_pool3_d<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MaxPool3D::new();
    op.call(ctx, input)
}

/// MaxPool3DGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MaxPool3DGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MaxPool3DGrad {
    ksize: ::std::option::Option<::std::vec::Vec<i64>>,
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    data_format: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MaxPool3DGrad {
    fn default() -> Self {
        Self {
            ksize: None,
            strides: None,
            padding: None,
            data_format: Some(::std::string::String::from("NDHWC")),
            target_device_name: None,
        }
    }
}
impl MaxPool3DGrad {
    /// Creates a new `MaxPool3DGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `ksize` attribute.
    pub fn ksize<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.ksize = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `data_format` attribute.
    pub fn data_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.data_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute max_pool3_dgrad.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        orig_input: &T0,
        orig_output: &T1,
        grad: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MaxPool3DGrad")?;

        // Required input arguments
        op.add_input(&orig_input.to_handle(ctx)?)?;
        op.add_input(&orig_output.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.ksize {
            op.set_attr_int_list("ksize", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.data_format {
            op.set_attr_string("data_format", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MaxPool3DGrad::new().call(&ctx, &orig_input, &orig_output, &grad)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MaxPool3DGrad>
pub fn max_pool3_dgrad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    orig_input: &T0,
    orig_output: &T1,
    grad: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MaxPool3DGrad::new();
    op.call(ctx, orig_input, orig_output, grad)
}

/// MaxPool3DGradGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MaxPool3DGradGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MaxPool3DGradGrad {
    ksize: ::std::option::Option<::std::vec::Vec<i64>>,
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    data_format: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MaxPool3DGradGrad {
    fn default() -> Self {
        Self {
            ksize: None,
            strides: None,
            padding: None,
            data_format: Some(::std::string::String::from("NDHWC")),
            target_device_name: None,
        }
    }
}
impl MaxPool3DGradGrad {
    /// Creates a new `MaxPool3DGradGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `ksize` attribute.
    pub fn ksize<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.ksize = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `data_format` attribute.
    pub fn data_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.data_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute max_pool3_dgrad_grad.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        orig_input: &T0,
        orig_output: &T1,
        grad: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MaxPool3DGradGrad")?;

        // Required input arguments
        op.add_input(&orig_input.to_handle(ctx)?)?;
        op.add_input(&orig_output.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.ksize {
            op.set_attr_int_list("ksize", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.data_format {
            op.set_attr_string("data_format", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MaxPool3DGradGrad::new().call(&ctx, &orig_input, &orig_output, &grad)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MaxPool3DGradGrad>
pub fn max_pool3_dgrad_grad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    orig_input: &T0,
    orig_output: &T1,
    grad: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MaxPool3DGradGrad::new();
    op.call(ctx, orig_input, orig_output, grad)
}

/// MaxPoolGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MaxPoolGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MaxPoolGrad {
    ksize: ::std::option::Option<::std::vec::Vec<i64>>,
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    explicit_paddings: ::std::option::Option<::std::vec::Vec<i64>>,
    data_format: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MaxPoolGrad {
    fn default() -> Self {
        Self {
            ksize: None,
            strides: None,
            padding: None,
            explicit_paddings: Some(vec![]),
            data_format: Some(::std::string::String::from("NHWC")),
            target_device_name: None,
        }
    }
}
impl MaxPoolGrad {
    /// Creates a new `MaxPoolGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `ksize` attribute.
    pub fn ksize<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.ksize = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `explicit_paddings` attribute.
    pub fn explicit_paddings<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.explicit_paddings = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `data_format` attribute.
    pub fn data_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.data_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute max_pool_grad.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        orig_input: &T0,
        orig_output: &T1,
        grad: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MaxPoolGrad")?;

        // Required input arguments
        op.add_input(&orig_input.to_handle(ctx)?)?;
        op.add_input(&orig_output.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.ksize {
            op.set_attr_int_list("ksize", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.explicit_paddings {
            op.set_attr_int_list("explicit_paddings", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.data_format {
            op.set_attr_string("data_format", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MaxPoolGrad::new().call(&ctx, &orig_input, &orig_output, &grad)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MaxPoolGrad>
pub fn max_pool_grad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    orig_input: &T0,
    orig_output: &T1,
    grad: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MaxPoolGrad::new();
    op.call(ctx, orig_input, orig_output, grad)
}

/// MaxPoolGradGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MaxPoolGradGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MaxPoolGradGrad {
    ksize: ::std::option::Option<::std::vec::Vec<i64>>,
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    data_format: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MaxPoolGradGrad {
    fn default() -> Self {
        Self {
            ksize: None,
            strides: None,
            padding: None,
            data_format: Some(::std::string::String::from("NHWC")),
            target_device_name: None,
        }
    }
}
impl MaxPoolGradGrad {
    /// Creates a new `MaxPoolGradGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `ksize` attribute.
    pub fn ksize<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.ksize = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `data_format` attribute.
    pub fn data_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.data_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute max_pool_grad_grad.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        orig_input: &T0,
        orig_output: &T1,
        grad: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MaxPoolGradGrad")?;

        // Required input arguments
        op.add_input(&orig_input.to_handle(ctx)?)?;
        op.add_input(&orig_output.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.ksize {
            op.set_attr_int_list("ksize", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.data_format {
            op.set_attr_string("data_format", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MaxPoolGradGrad::new().call(&ctx, &orig_input, &orig_output, &grad)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MaxPoolGradGrad>
pub fn max_pool_grad_grad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    orig_input: &T0,
    orig_output: &T1,
    grad: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MaxPoolGradGrad::new();
    op.call(ctx, orig_input, orig_output, grad)
}

/// MaxPoolGradGradV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MaxPoolGradGradV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MaxPoolGradGradV2 {
    padding: ::std::option::Option<::std::string::String>,
    data_format: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MaxPoolGradGradV2 {
    fn default() -> Self {
        Self {
            padding: None,
            data_format: Some(::std::string::String::from("NHWC")),
            target_device_name: None,
        }
    }
}
impl MaxPoolGradGradV2 {
    /// Creates a new `MaxPoolGradGradV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `data_format` attribute.
    pub fn data_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.data_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute max_pool_grad_grad_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        orig_input: &T0,
        orig_output: &T1,
        grad: &T2,
        ksize: &T3,
        strides: &T4,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MaxPoolGradGradV2")?;

        // Required input arguments
        op.add_input(&orig_input.to_handle(ctx)?)?;
        op.add_input(&orig_output.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&ksize.to_handle(ctx)?)?;
        op.add_input(&strides.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.data_format {
            op.set_attr_string("data_format", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MaxPoolGradGradV2::new().call(&ctx, &orig_input, &orig_output, &grad, &ksize, &strides)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MaxPoolGradGradV2>
pub fn max_pool_grad_grad_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    orig_input: &T0,
    orig_output: &T1,
    grad: &T2,
    ksize: &T3,
    strides: &T4,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MaxPoolGradGradV2::new();
    op.call(ctx, orig_input, orig_output, grad, ksize, strides)
}

/// MaxPoolGradGradWithArgmax
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MaxPoolGradGradWithArgmax>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MaxPoolGradGradWithArgmax {
    ksize: ::std::option::Option<::std::vec::Vec<i64>>,
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    include_batch_in_index: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MaxPoolGradGradWithArgmax {
    fn default() -> Self {
        Self {
            ksize: None,
            strides: None,
            padding: None,
            include_batch_in_index: Some(false),
            target_device_name: None,
        }
    }
}
impl MaxPoolGradGradWithArgmax {
    /// Creates a new `MaxPoolGradGradWithArgmax`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `ksize` attribute.
    pub fn ksize<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.ksize = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `include_batch_in_index` attribute.
    pub fn include_batch_in_index<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.include_batch_in_index = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute max_pool_grad_grad_with_argmax.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        grad: &T1,
        argmax: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MaxPoolGradGradWithArgmax")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&argmax.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.ksize {
            op.set_attr_int_list("ksize", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.include_batch_in_index {
            op.set_attr_bool("include_batch_in_index", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MaxPoolGradGradWithArgmax::new().call(&ctx, &input, &grad, &argmax)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MaxPoolGradGradWithArgmax>
pub fn max_pool_grad_grad_with_argmax<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    grad: &T1,
    argmax: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MaxPoolGradGradWithArgmax::new();
    op.call(ctx, input, grad, argmax)
}

/// MaxPoolGradV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MaxPoolGradV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MaxPoolGradV2 {
    padding: ::std::option::Option<::std::string::String>,
    data_format: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MaxPoolGradV2 {
    fn default() -> Self {
        Self {
            padding: None,
            data_format: Some(::std::string::String::from("NHWC")),
            target_device_name: None,
        }
    }
}
impl MaxPoolGradV2 {
    /// Creates a new `MaxPoolGradV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `data_format` attribute.
    pub fn data_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.data_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute max_pool_grad_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        orig_input: &T0,
        orig_output: &T1,
        grad: &T2,
        ksize: &T3,
        strides: &T4,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MaxPoolGradV2")?;

        // Required input arguments
        op.add_input(&orig_input.to_handle(ctx)?)?;
        op.add_input(&orig_output.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&ksize.to_handle(ctx)?)?;
        op.add_input(&strides.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.data_format {
            op.set_attr_string("data_format", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MaxPoolGradV2::new().call(&ctx, &orig_input, &orig_output, &grad, &ksize, &strides)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MaxPoolGradV2>
pub fn max_pool_grad_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    orig_input: &T0,
    orig_output: &T1,
    grad: &T2,
    ksize: &T3,
    strides: &T4,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MaxPoolGradV2::new();
    op.call(ctx, orig_input, orig_output, grad, ksize, strides)
}

/// MaxPoolGradWithArgmax
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MaxPoolGradWithArgmax>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MaxPoolGradWithArgmax {
    ksize: ::std::option::Option<::std::vec::Vec<i64>>,
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    include_batch_in_index: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MaxPoolGradWithArgmax {
    fn default() -> Self {
        Self {
            ksize: None,
            strides: None,
            padding: None,
            include_batch_in_index: Some(false),
            target_device_name: None,
        }
    }
}
impl MaxPoolGradWithArgmax {
    /// Creates a new `MaxPoolGradWithArgmax`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `ksize` attribute.
    pub fn ksize<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.ksize = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `include_batch_in_index` attribute.
    pub fn include_batch_in_index<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.include_batch_in_index = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute max_pool_grad_with_argmax.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        grad: &T1,
        argmax: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MaxPoolGradWithArgmax")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&argmax.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.ksize {
            op.set_attr_int_list("ksize", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.include_batch_in_index {
            op.set_attr_bool("include_batch_in_index", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MaxPoolGradWithArgmax::new().call(&ctx, &input, &grad, &argmax)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MaxPoolGradWithArgmax>
pub fn max_pool_grad_with_argmax<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    grad: &T1,
    argmax: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MaxPoolGradWithArgmax::new();
    op.call(ctx, input, grad, argmax)
}

/// MaxPoolV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MaxPoolV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MaxPoolV2 {
    padding: ::std::option::Option<::std::string::String>,
    data_format: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MaxPoolV2 {
    fn default() -> Self {
        Self {
            padding: None,
            data_format: Some(::std::string::String::from("NHWC")),
            target_device_name: None,
        }
    }
}
impl MaxPoolV2 {
    /// Creates a new `MaxPoolV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `data_format` attribute.
    pub fn data_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.data_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute max_pool_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        ksize: &T1,
        strides: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MaxPoolV2")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&ksize.to_handle(ctx)?)?;
        op.add_input(&strides.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.data_format {
            op.set_attr_string("data_format", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MaxPoolV2::new().call(&ctx, &input, &ksize, &strides)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MaxPoolV2>
pub fn max_pool_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    ksize: &T1,
    strides: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MaxPoolV2::new();
    op.call(ctx, input, ksize, strides)
}

/// MaxPoolWithArgmax
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MaxPoolWithArgmax>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MaxPoolWithArgmax {
    ksize: ::std::option::Option<::std::vec::Vec<i64>>,
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    Targmax: ::std::option::Option<crate::DataType>,
    padding: ::std::option::Option<::std::string::String>,
    include_batch_in_index: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MaxPoolWithArgmax {
    fn default() -> Self {
        Self {
            ksize: None,
            strides: None,
            Targmax: Some(crate::DataType::Int64),
            padding: None,
            include_batch_in_index: Some(false),
            target_device_name: None,
        }
    }
}
impl MaxPoolWithArgmax {
    /// Creates a new `MaxPoolWithArgmax`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `ksize` attribute.
    pub fn ksize<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.ksize = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `Targmax` attribute.
    pub fn Targmax<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Targmax = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `include_batch_in_index` attribute.
    pub fn include_batch_in_index<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.include_batch_in_index = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute max_pool_with_argmax.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "MaxPoolWithArgmax")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.ksize {
            op.set_attr_int_list("ksize", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.Targmax {
            op.set_attr_type("Targmax", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.include_batch_in_index {
            op.set_attr_bool("include_batch_in_index", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `MaxPoolWithArgmax::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MaxPoolWithArgmax>
pub fn max_pool_with_argmax<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = MaxPoolWithArgmax::new();
    op.call(ctx, input)
}

/// Maximum
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Maximum>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Maximum {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Maximum {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Maximum {
    /// Creates a new `Maximum`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute maximum.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Maximum")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Maximum::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Maximum>
pub fn maximum<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Maximum::new();
    op.call(ctx, x, y)
}

/// Mean
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Mean>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Mean {
    keep_dims: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Mean {
    fn default() -> Self {
        Self {
            keep_dims: Some(false),
            target_device_name: None,
        }
    }
}
impl Mean {
    /// Creates a new `Mean`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `keep_dims` attribute.
    pub fn keep_dims<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.keep_dims = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute mean.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        reduction_indices: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Mean")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&reduction_indices.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.keep_dims {
            op.set_attr_bool("keep_dims", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Mean::new().call(&ctx, &input, &reduction_indices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Mean>
pub fn mean<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    reduction_indices: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Mean::new();
    op.call(ctx, input, reduction_indices)
}

/// Merge
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Merge>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Merge {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Merge {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Merge {
    /// Creates a new `Merge`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute merge.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        inputs: &[&T0],
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "Merge")?;

        // Required input arguments
        let mut inputs_list = Vec::new();

        for t in inputs {
            inputs_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&inputs_list)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `Merge::new().call(&ctx, &inputs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Merge>
pub fn merge<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    inputs: &[&T0],
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = Merge::new();
    op.call(ctx, inputs)
}

/// MergeSummary
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MergeSummary>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MergeSummary {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MergeSummary {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl MergeSummary {
    /// Creates a new `MergeSummary`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute merge_summary.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        inputs: &[&T0],
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MergeSummary")?;

        // Required input arguments
        let mut inputs_list = Vec::new();

        for t in inputs {
            inputs_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&inputs_list)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MergeSummary::new().call(&ctx, &inputs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MergeSummary>
pub fn merge_summary<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    inputs: &[&T0],
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MergeSummary::new();
    op.call(ctx, inputs)
}

/// MergeV2Checkpoints
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MergeV2Checkpoints>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MergeV2Checkpoints {
    delete_old_dirs: ::std::option::Option<bool>,
    allow_missing_files: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MergeV2Checkpoints {
    fn default() -> Self {
        Self {
            delete_old_dirs: Some(true),
            allow_missing_files: Some(false),
            target_device_name: None,
        }
    }
}
impl MergeV2Checkpoints {
    /// Creates a new `MergeV2Checkpoints`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `delete_old_dirs` attribute.
    pub fn delete_old_dirs<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.delete_old_dirs = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `allow_missing_files` attribute.
    pub fn allow_missing_files<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.allow_missing_files = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute merge_v2_checkpoints.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        checkpoint_prefixes: &T0,
        destination_prefix: &T1,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "MergeV2Checkpoints")?;

        // Required input arguments
        op.add_input(&checkpoint_prefixes.to_handle(ctx)?)?;
        op.add_input(&destination_prefix.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.delete_old_dirs {
            op.set_attr_bool("delete_old_dirs", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.allow_missing_files {
            op.set_attr_bool("allow_missing_files", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `MergeV2Checkpoints::new().call(&ctx, &checkpoint_prefixes, &destination_prefix)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MergeV2Checkpoints>
pub fn merge_v2_checkpoints<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    checkpoint_prefixes: &T0,
    destination_prefix: &T1,
) -> crate::Result<()> {
    let op = MergeV2Checkpoints::new();
    op.call(ctx, checkpoint_prefixes, destination_prefix)
}

/// Mfcc
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Mfcc>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Mfcc {
    upper_frequency_limit: ::std::option::Option<f32>,
    lower_frequency_limit: ::std::option::Option<f32>,
    filterbank_channel_count: ::std::option::Option<i64>,
    dct_coefficient_count: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Mfcc {
    fn default() -> Self {
        Self {
            upper_frequency_limit: Some(4000f32),
            lower_frequency_limit: Some(20f32),
            filterbank_channel_count: Some(40i64),
            dct_coefficient_count: Some(13i64),
            target_device_name: None,
        }
    }
}
impl Mfcc {
    /// Creates a new `Mfcc`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `upper_frequency_limit` attribute.
    pub fn upper_frequency_limit<ArgType: ::std::convert::Into<f32>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.upper_frequency_limit = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `lower_frequency_limit` attribute.
    pub fn lower_frequency_limit<ArgType: ::std::convert::Into<f32>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.lower_frequency_limit = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `filterbank_channel_count` attribute.
    pub fn filterbank_channel_count<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.filterbank_channel_count = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dct_coefficient_count` attribute.
    pub fn dct_coefficient_count<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dct_coefficient_count = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute mfcc.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        spectrogram: &T0,
        sample_rate: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Mfcc")?;

        // Required input arguments
        op.add_input(&spectrogram.to_handle(ctx)?)?;
        op.add_input(&sample_rate.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.upper_frequency_limit {
            op.set_attr_float("upper_frequency_limit", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.lower_frequency_limit {
            op.set_attr_float("lower_frequency_limit", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.filterbank_channel_count {
            op.set_attr_int("filterbank_channel_count", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dct_coefficient_count {
            op.set_attr_int("dct_coefficient_count", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Mfcc::new().call(&ctx, &spectrogram, &sample_rate)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Mfcc>
pub fn mfcc<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    spectrogram: &T0,
    sample_rate: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Mfcc::new();
    op.call(ctx, spectrogram, sample_rate)
}

/// Min
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Min>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Min {
    keep_dims: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Min {
    fn default() -> Self {
        Self {
            keep_dims: Some(false),
            target_device_name: None,
        }
    }
}
impl Min {
    /// Creates a new `Min`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `keep_dims` attribute.
    pub fn keep_dims<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.keep_dims = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute min.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        reduction_indices: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Min")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&reduction_indices.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.keep_dims {
            op.set_attr_bool("keep_dims", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Min::new().call(&ctx, &input, &reduction_indices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Min>
pub fn min<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    reduction_indices: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Min::new();
    op.call(ctx, input, reduction_indices)
}

/// Minimum
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Minimum>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Minimum {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Minimum {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Minimum {
    /// Creates a new `Minimum`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute minimum.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Minimum")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Minimum::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Minimum>
pub fn minimum<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Minimum::new();
    op.call(ctx, x, y)
}

/// MirrorPad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MirrorPad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MirrorPad {
    mode: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MirrorPad {
    fn default() -> Self {
        Self {
            mode: None,
            target_device_name: None,
        }
    }
}
impl MirrorPad {
    /// Creates a new `MirrorPad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `mode` attribute.
    pub fn mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute mirror_pad.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        paddings: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MirrorPad")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&paddings.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.mode {
            op.set_attr_string("mode", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MirrorPad::new().call(&ctx, &input, &paddings)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MirrorPad>
pub fn mirror_pad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    paddings: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MirrorPad::new();
    op.call(ctx, input, paddings)
}

/// MirrorPadGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MirrorPadGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MirrorPadGrad {
    mode: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MirrorPadGrad {
    fn default() -> Self {
        Self {
            mode: None,
            target_device_name: None,
        }
    }
}
impl MirrorPadGrad {
    /// Creates a new `MirrorPadGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `mode` attribute.
    pub fn mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute mirror_pad_grad.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        paddings: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MirrorPadGrad")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&paddings.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.mode {
            op.set_attr_string("mode", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MirrorPadGrad::new().call(&ctx, &input, &paddings)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MirrorPadGrad>
pub fn mirror_pad_grad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    paddings: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MirrorPadGrad::new();
    op.call(ctx, input, paddings)
}

/// MlirPassthroughOp
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MlirPassthroughOp>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MlirPassthroughOp {
    mlir_module: ::std::option::Option<::std::string::String>,
    Toutputs: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MlirPassthroughOp {
    fn default() -> Self {
        Self {
            mlir_module: None,
            Toutputs: None,
            target_device_name: None,
        }
    }
}
impl MlirPassthroughOp {
    /// Creates a new `MlirPassthroughOp`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `mlir_module` attribute.
    pub fn mlir_module<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.mlir_module = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `Toutputs` attribute.
    pub fn Toutputs<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Toutputs = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute mlir_passthrough_op.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        inputs: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MlirPassthroughOp")?;

        // Required input arguments
        op.add_input(&inputs.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.mlir_module {
            op.set_attr_string("mlir_module", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.Toutputs {
            op.set_attr_type_list("Toutputs", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MlirPassthroughOp::new().call(&ctx, &inputs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MlirPassthroughOp>
pub fn mlir_passthrough_op<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    inputs: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MlirPassthroughOp::new();
    op.call(ctx, inputs)
}

/// Mod
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Mod>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Mod {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Mod {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Mod {
    /// Creates a new `Mod`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute mod_.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Mod")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Mod::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Mod>
pub fn mod_<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Mod::new();
    op.call(ctx, x, y)
}

/// ModelDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ModelDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ModelDataset {
    algorithm: ::std::option::Option<i64>,
    cpu_budget: ::std::option::Option<i64>,
    ram_budget: ::std::option::Option<i64>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ModelDataset {
    fn default() -> Self {
        Self {
            algorithm: Some(0i64),
            cpu_budget: Some(0i64),
            ram_budget: Some(0i64),
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl ModelDataset {
    /// Creates a new `ModelDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `algorithm` attribute.
    pub fn algorithm<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.algorithm = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `cpu_budget` attribute.
    pub fn cpu_budget<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.cpu_budget = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `ram_budget` attribute.
    pub fn ram_budget<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.ram_budget = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute model_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ModelDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.algorithm {
            op.set_attr_int("algorithm", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.cpu_budget {
            op.set_attr_int("cpu_budget", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.ram_budget {
            op.set_attr_int("ram_budget", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ModelDataset::new().call(&ctx, &input_dataset)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ModelDataset>
pub fn model_dataset<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ModelDataset::new();
    op.call(ctx, input_dataset)
}

/// Mul
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Mul>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Mul {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Mul {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Mul {
    /// Creates a new `Mul`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute mul.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Mul")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Mul::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Mul>
pub fn mul<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Mul::new();
    op.call(ctx, x, y)
}

/// MulNoNan
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MulNoNan>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MulNoNan {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MulNoNan {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl MulNoNan {
    /// Creates a new `MulNoNan`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute mul_no_nan.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MulNoNan")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MulNoNan::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MulNoNan>
pub fn mul_no_nan<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MulNoNan::new();
    op.call(ctx, x, y)
}

/// MultiDeviceIterator
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MultiDeviceIterator>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MultiDeviceIterator {
    devices: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    shared_name: ::std::option::Option<::std::string::String>,
    container: ::std::option::Option<::std::string::String>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MultiDeviceIterator {
    fn default() -> Self {
        Self {
            devices: None,
            shared_name: None,
            container: None,
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl MultiDeviceIterator {
    /// Creates a new `MultiDeviceIterator`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `devices` attribute.
    pub fn devices<ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.devices = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute multi_device_iterator.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MultiDeviceIterator")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.devices {
            op.set_attr_string_list("devices", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MultiDeviceIterator::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MultiDeviceIterator>
pub fn multi_device_iterator<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MultiDeviceIterator::new();
    op.call(ctx)
}

/// MultiDeviceIteratorFromStringHandle
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MultiDeviceIteratorFromStringHandle>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MultiDeviceIteratorFromStringHandle {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MultiDeviceIteratorFromStringHandle {
    fn default() -> Self {
        Self {
            output_types: Some(vec![]),
            output_shapes: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl MultiDeviceIteratorFromStringHandle {
    /// Creates a new `MultiDeviceIteratorFromStringHandle`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute multi_device_iterator_from_string_handle.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        string_handle: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MultiDeviceIteratorFromStringHandle")?;

        // Required input arguments
        op.add_input(&string_handle.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MultiDeviceIteratorFromStringHandle::new().call(&ctx, &string_handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MultiDeviceIteratorFromStringHandle>
pub fn multi_device_iterator_from_string_handle<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    string_handle: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MultiDeviceIteratorFromStringHandle::new();
    op.call(ctx, string_handle)
}

/// MultiDeviceIteratorGetNextFromShard
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MultiDeviceIteratorGetNextFromShard>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MultiDeviceIteratorGetNextFromShard {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MultiDeviceIteratorGetNextFromShard {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl MultiDeviceIteratorGetNextFromShard {
    /// Creates a new `MultiDeviceIteratorGetNextFromShard`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute multi_device_iterator_get_next_from_shard.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        multi_device_iterator: &T0,
        shard_num: &T1,
        incarnation_id: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MultiDeviceIteratorGetNextFromShard")?;

        // Required input arguments
        op.add_input(&multi_device_iterator.to_handle(ctx)?)?;
        op.add_input(&shard_num.to_handle(ctx)?)?;
        op.add_input(&incarnation_id.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MultiDeviceIteratorGetNextFromShard::new().call(&ctx, &multi_device_iterator, &shard_num, &incarnation_id)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MultiDeviceIteratorGetNextFromShard>
pub fn multi_device_iterator_get_next_from_shard<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    multi_device_iterator: &T0,
    shard_num: &T1,
    incarnation_id: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MultiDeviceIteratorGetNextFromShard::new();
    op.call(ctx, multi_device_iterator, shard_num, incarnation_id)
}

/// MultiDeviceIteratorInit
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MultiDeviceIteratorInit>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MultiDeviceIteratorInit {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MultiDeviceIteratorInit {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl MultiDeviceIteratorInit {
    /// Creates a new `MultiDeviceIteratorInit`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute multi_device_iterator_init.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        dataset: &T0,
        multi_device_iterator: &T1,
        max_buffer_size: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MultiDeviceIteratorInit")?;

        // Required input arguments
        op.add_input(&dataset.to_handle(ctx)?)?;
        op.add_input(&multi_device_iterator.to_handle(ctx)?)?;
        op.add_input(&max_buffer_size.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MultiDeviceIteratorInit::new().call(&ctx, &dataset, &multi_device_iterator, &max_buffer_size)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MultiDeviceIteratorInit>
pub fn multi_device_iterator_init<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    dataset: &T0,
    multi_device_iterator: &T1,
    max_buffer_size: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MultiDeviceIteratorInit::new();
    op.call(ctx, dataset, multi_device_iterator, max_buffer_size)
}

/// MultiDeviceIteratorToStringHandle
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MultiDeviceIteratorToStringHandle>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MultiDeviceIteratorToStringHandle {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MultiDeviceIteratorToStringHandle {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl MultiDeviceIteratorToStringHandle {
    /// Creates a new `MultiDeviceIteratorToStringHandle`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute multi_device_iterator_to_string_handle.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        multi_device_iterator: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MultiDeviceIteratorToStringHandle")?;

        // Required input arguments
        op.add_input(&multi_device_iterator.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MultiDeviceIteratorToStringHandle::new().call(&ctx, &multi_device_iterator)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MultiDeviceIteratorToStringHandle>
pub fn multi_device_iterator_to_string_handle<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    multi_device_iterator: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MultiDeviceIteratorToStringHandle::new();
    op.call(ctx, multi_device_iterator)
}

/// Multinomial
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Multinomial>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Multinomial {
    seed: ::std::option::Option<i64>,
    seed2: ::std::option::Option<i64>,
    output_dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Multinomial {
    fn default() -> Self {
        Self {
            seed: Some(0i64),
            seed2: Some(0i64),
            output_dtype: Some(crate::DataType::Int64),
            target_device_name: None,
        }
    }
}
impl Multinomial {
    /// Creates a new `Multinomial`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `seed` attribute.
    pub fn seed<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed2` attribute.
    pub fn seed2<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_dtype` attribute.
    pub fn output_dtype<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute multinomial.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        logits: &T0,
        num_samples: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Multinomial")?;

        // Required input arguments
        op.add_input(&logits.to_handle(ctx)?)?;
        op.add_input(&num_samples.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.seed {
            op.set_attr_int("seed", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed2 {
            op.set_attr_int("seed2", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_dtype {
            op.set_attr_type("output_dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Multinomial::new().call(&ctx, &logits, &num_samples)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Multinomial>
pub fn multinomial<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    logits: &T0,
    num_samples: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Multinomial::new();
    op.call(ctx, logits, num_samples)
}

/// MutableDenseHashTable
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MutableDenseHashTable>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MutableDenseHashTable {
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    use_node_name_sharing: ::std::option::Option<bool>,
    value_dtype: ::std::option::Option<crate::DataType>,
    value_shape: ::std::option::Option<crate::Shape>,
    initial_num_buckets: ::std::option::Option<i64>,
    max_load_factor: ::std::option::Option<f32>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MutableDenseHashTable {
    fn default() -> Self {
        Self {
            container: None,
            shared_name: None,
            use_node_name_sharing: Some(false),
            value_dtype: None,
            value_shape: None,
            initial_num_buckets: Some(131072i64),
            max_load_factor: Some(0.8f32),
            target_device_name: None,
        }
    }
}
impl MutableDenseHashTable {
    /// Creates a new `MutableDenseHashTable`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_node_name_sharing` attribute.
    pub fn use_node_name_sharing<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.use_node_name_sharing = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `value_dtype` attribute.
    pub fn value_dtype<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.value_dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `value_shape` attribute.
    pub fn value_shape<ArgType: ::std::convert::Into<crate::Shape>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.value_shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `initial_num_buckets` attribute.
    pub fn initial_num_buckets<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.initial_num_buckets = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `max_load_factor` attribute.
    pub fn max_load_factor<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.max_load_factor = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute mutable_dense_hash_table.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        empty_key: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MutableDenseHashTable")?;

        // Required input arguments
        op.add_input(&empty_key.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_node_name_sharing {
            op.set_attr_bool("use_node_name_sharing", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.value_dtype {
            op.set_attr_type("value_dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.value_shape {
            op.set_attr_shape("value_shape", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.initial_num_buckets {
            op.set_attr_int("initial_num_buckets", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.max_load_factor {
            op.set_attr_float("max_load_factor", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MutableDenseHashTable::new().call(&ctx, &empty_key)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MutableDenseHashTable>
pub fn mutable_dense_hash_table<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    empty_key: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MutableDenseHashTable::new();
    op.call(ctx, empty_key)
}

/// MutableDenseHashTableV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MutableDenseHashTableV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MutableDenseHashTableV2 {
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    use_node_name_sharing: ::std::option::Option<bool>,
    value_dtype: ::std::option::Option<crate::DataType>,
    value_shape: ::std::option::Option<crate::Shape>,
    initial_num_buckets: ::std::option::Option<i64>,
    max_load_factor: ::std::option::Option<f32>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MutableDenseHashTableV2 {
    fn default() -> Self {
        Self {
            container: None,
            shared_name: None,
            use_node_name_sharing: Some(false),
            value_dtype: None,
            value_shape: None,
            initial_num_buckets: Some(131072i64),
            max_load_factor: Some(0.8f32),
            target_device_name: None,
        }
    }
}
impl MutableDenseHashTableV2 {
    /// Creates a new `MutableDenseHashTableV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_node_name_sharing` attribute.
    pub fn use_node_name_sharing<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.use_node_name_sharing = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `value_dtype` attribute.
    pub fn value_dtype<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.value_dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `value_shape` attribute.
    pub fn value_shape<ArgType: ::std::convert::Into<crate::Shape>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.value_shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `initial_num_buckets` attribute.
    pub fn initial_num_buckets<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.initial_num_buckets = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `max_load_factor` attribute.
    pub fn max_load_factor<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.max_load_factor = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute mutable_dense_hash_table_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        empty_key: &T0,
        deleted_key: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MutableDenseHashTableV2")?;

        // Required input arguments
        op.add_input(&empty_key.to_handle(ctx)?)?;
        op.add_input(&deleted_key.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_node_name_sharing {
            op.set_attr_bool("use_node_name_sharing", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.value_dtype {
            op.set_attr_type("value_dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.value_shape {
            op.set_attr_shape("value_shape", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.initial_num_buckets {
            op.set_attr_int("initial_num_buckets", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.max_load_factor {
            op.set_attr_float("max_load_factor", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MutableDenseHashTableV2::new().call(&ctx, &empty_key, &deleted_key)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MutableDenseHashTableV2>
pub fn mutable_dense_hash_table_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    empty_key: &T0,
    deleted_key: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MutableDenseHashTableV2::new();
    op.call(ctx, empty_key, deleted_key)
}

/// MutableHashTable
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MutableHashTable>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MutableHashTable {
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    use_node_name_sharing: ::std::option::Option<bool>,
    key_dtype: ::std::option::Option<crate::DataType>,
    value_dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MutableHashTable {
    fn default() -> Self {
        Self {
            container: None,
            shared_name: None,
            use_node_name_sharing: Some(false),
            key_dtype: None,
            value_dtype: None,
            target_device_name: None,
        }
    }
}
impl MutableHashTable {
    /// Creates a new `MutableHashTable`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_node_name_sharing` attribute.
    pub fn use_node_name_sharing<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.use_node_name_sharing = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `key_dtype` attribute.
    pub fn key_dtype<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.key_dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `value_dtype` attribute.
    pub fn value_dtype<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.value_dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute mutable_hash_table.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MutableHashTable")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_node_name_sharing {
            op.set_attr_bool("use_node_name_sharing", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.key_dtype {
            op.set_attr_type("key_dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.value_dtype {
            op.set_attr_type("value_dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MutableHashTable::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MutableHashTable>
pub fn mutable_hash_table<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MutableHashTable::new();
    op.call(ctx)
}

/// MutableHashTableOfTensors
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MutableHashTableOfTensors>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MutableHashTableOfTensors {
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    use_node_name_sharing: ::std::option::Option<bool>,
    key_dtype: ::std::option::Option<crate::DataType>,
    value_dtype: ::std::option::Option<crate::DataType>,
    value_shape: ::std::option::Option<crate::Shape>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MutableHashTableOfTensors {
    fn default() -> Self {
        Self {
            container: None,
            shared_name: None,
            use_node_name_sharing: Some(false),
            key_dtype: None,
            value_dtype: None,
            value_shape: None,
            target_device_name: None,
        }
    }
}
impl MutableHashTableOfTensors {
    /// Creates a new `MutableHashTableOfTensors`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_node_name_sharing` attribute.
    pub fn use_node_name_sharing<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.use_node_name_sharing = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `key_dtype` attribute.
    pub fn key_dtype<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.key_dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `value_dtype` attribute.
    pub fn value_dtype<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.value_dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `value_shape` attribute.
    pub fn value_shape<ArgType: ::std::convert::Into<crate::Shape>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.value_shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute mutable_hash_table_of_tensors.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MutableHashTableOfTensors")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_node_name_sharing {
            op.set_attr_bool("use_node_name_sharing", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.key_dtype {
            op.set_attr_type("key_dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.value_dtype {
            op.set_attr_type("value_dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.value_shape {
            op.set_attr_shape("value_shape", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MutableHashTableOfTensors::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MutableHashTableOfTensors>
pub fn mutable_hash_table_of_tensors<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MutableHashTableOfTensors::new();
    op.call(ctx)
}

/// MutableHashTableOfTensorsV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MutableHashTableOfTensorsV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MutableHashTableOfTensorsV2 {
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    use_node_name_sharing: ::std::option::Option<bool>,
    key_dtype: ::std::option::Option<crate::DataType>,
    value_dtype: ::std::option::Option<crate::DataType>,
    value_shape: ::std::option::Option<crate::Shape>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MutableHashTableOfTensorsV2 {
    fn default() -> Self {
        Self {
            container: None,
            shared_name: None,
            use_node_name_sharing: Some(false),
            key_dtype: None,
            value_dtype: None,
            value_shape: None,
            target_device_name: None,
        }
    }
}
impl MutableHashTableOfTensorsV2 {
    /// Creates a new `MutableHashTableOfTensorsV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_node_name_sharing` attribute.
    pub fn use_node_name_sharing<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.use_node_name_sharing = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `key_dtype` attribute.
    pub fn key_dtype<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.key_dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `value_dtype` attribute.
    pub fn value_dtype<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.value_dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `value_shape` attribute.
    pub fn value_shape<ArgType: ::std::convert::Into<crate::Shape>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.value_shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute mutable_hash_table_of_tensors_v2.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MutableHashTableOfTensorsV2")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_node_name_sharing {
            op.set_attr_bool("use_node_name_sharing", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.key_dtype {
            op.set_attr_type("key_dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.value_dtype {
            op.set_attr_type("value_dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.value_shape {
            op.set_attr_shape("value_shape", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MutableHashTableOfTensorsV2::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MutableHashTableOfTensorsV2>
pub fn mutable_hash_table_of_tensors_v2<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MutableHashTableOfTensorsV2::new();
    op.call(ctx)
}

/// MutableHashTableV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MutableHashTableV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MutableHashTableV2 {
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    use_node_name_sharing: ::std::option::Option<bool>,
    key_dtype: ::std::option::Option<crate::DataType>,
    value_dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MutableHashTableV2 {
    fn default() -> Self {
        Self {
            container: None,
            shared_name: None,
            use_node_name_sharing: Some(false),
            key_dtype: None,
            value_dtype: None,
            target_device_name: None,
        }
    }
}
impl MutableHashTableV2 {
    /// Creates a new `MutableHashTableV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_node_name_sharing` attribute.
    pub fn use_node_name_sharing<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.use_node_name_sharing = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `key_dtype` attribute.
    pub fn key_dtype<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.key_dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `value_dtype` attribute.
    pub fn value_dtype<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.value_dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute mutable_hash_table_v2.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MutableHashTableV2")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_node_name_sharing {
            op.set_attr_bool("use_node_name_sharing", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.key_dtype {
            op.set_attr_type("key_dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.value_dtype {
            op.set_attr_type("value_dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MutableHashTableV2::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MutableHashTableV2>
pub fn mutable_hash_table_v2<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MutableHashTableV2::new();
    op.call(ctx)
}

/// MutexLock
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MutexLock>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MutexLock {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MutexLock {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl MutexLock {
    /// Creates a new `MutexLock`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute mutex_lock.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        mutex: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MutexLock")?;

        // Required input arguments
        op.add_input(&mutex.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MutexLock::new().call(&ctx, &mutex)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MutexLock>
pub fn mutex_lock<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    mutex: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MutexLock::new();
    op.call(ctx, mutex)
}

/// MutexV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MutexV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct MutexV2 {
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for MutexV2 {
    fn default() -> Self {
        Self {
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl MutexV2 {
    /// Creates a new `MutexV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute mutex_v2.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "MutexV2")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `MutexV2::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/MutexV2>
pub fn mutex_v2<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = MutexV2::new();
    op.call(ctx)
}

/// NcclAllReduce
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/NcclAllReduce>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct NcclAllReduce {
    reduction: ::std::option::Option<::std::string::String>,
    num_devices: ::std::option::Option<i64>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for NcclAllReduce {
    fn default() -> Self {
        Self {
            reduction: None,
            num_devices: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl NcclAllReduce {
    /// Creates a new `NcclAllReduce`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `reduction` attribute.
    pub fn reduction<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.reduction = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_devices` attribute.
    pub fn num_devices<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_devices = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute nccl_all_reduce.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "NcclAllReduce")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.reduction {
            op.set_attr_string("reduction", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_devices {
            op.set_attr_int("num_devices", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `NcclAllReduce::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/NcclAllReduce>
pub fn nccl_all_reduce<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = NcclAllReduce::new();
    op.call(ctx, input)
}

/// NcclBroadcast
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/NcclBroadcast>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct NcclBroadcast {
    shape: ::std::option::Option<crate::Shape>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for NcclBroadcast {
    fn default() -> Self {
        Self {
            shape: None,
            target_device_name: None,
        }
    }
}
impl NcclBroadcast {
    /// Creates a new `NcclBroadcast`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `shape` attribute.
    pub fn shape<ArgType: ::std::convert::Into<crate::Shape>>(mut self, value: ArgType) -> Self {
        self.shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute nccl_broadcast.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "NcclBroadcast")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.shape {
            op.set_attr_shape("shape", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `NcclBroadcast::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/NcclBroadcast>
pub fn nccl_broadcast<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = NcclBroadcast::new();
    op.call(ctx, input)
}

/// NcclReduce
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/NcclReduce>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct NcclReduce {
    reduction: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for NcclReduce {
    fn default() -> Self {
        Self {
            reduction: None,
            target_device_name: None,
        }
    }
}
impl NcclReduce {
    /// Creates a new `NcclReduce`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `reduction` attribute.
    pub fn reduction<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.reduction = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute nccl_reduce.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &[&T0],
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "NcclReduce")?;

        // Required input arguments
        let mut input_list = Vec::new();

        for t in input {
            input_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&input_list)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.reduction {
            op.set_attr_string("reduction", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `NcclReduce::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/NcclReduce>
pub fn nccl_reduce<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &[&T0],
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = NcclReduce::new();
    op.call(ctx, input)
}

/// Ndtri
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Ndtri>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Ndtri {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Ndtri {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Ndtri {
    /// Creates a new `Ndtri`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute ndtri.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Ndtri")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Ndtri::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Ndtri>
pub fn ndtri<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Ndtri::new();
    op.call(ctx, x)
}

/// NearestNeighbors
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/NearestNeighbors>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct NearestNeighbors {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for NearestNeighbors {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl NearestNeighbors {
    /// Creates a new `NearestNeighbors`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute nearest_neighbors.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        points: &T0,
        centers: &T1,
        k: &T2,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "NearestNeighbors")?;

        // Required input arguments
        op.add_input(&points.to_handle(ctx)?)?;
        op.add_input(&centers.to_handle(ctx)?)?;
        op.add_input(&k.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `NearestNeighbors::new().call(&ctx, &points, &centers, &k)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/NearestNeighbors>
pub fn nearest_neighbors<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    points: &T0,
    centers: &T1,
    k: &T2,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = NearestNeighbors::new();
    op.call(ctx, points, centers, k)
}

/// Neg
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Neg>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Neg {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Neg {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Neg {
    /// Creates a new `Neg`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute neg.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Neg")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Neg::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Neg>
pub fn neg<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Neg::new();
    op.call(ctx, x)
}

/// NegTrain
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/NegTrain>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct NegTrain {
    vocab_count: ::std::option::Option<::std::vec::Vec<i64>>,
    num_negative_samples: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for NegTrain {
    fn default() -> Self {
        Self {
            vocab_count: None,
            num_negative_samples: None,
            target_device_name: None,
        }
    }
}
impl NegTrain {
    /// Creates a new `NegTrain`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `vocab_count` attribute.
    pub fn vocab_count<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.vocab_count = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_negative_samples` attribute.
    pub fn num_negative_samples<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.num_negative_samples = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute neg_train.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        w_in: &T0,
        w_out: &T1,
        examples: &T2,
        labels: &T3,
        lr: &T4,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "NegTrain")?;

        // Required input arguments
        op.add_input(&w_in.to_handle(ctx)?)?;
        op.add_input(&w_out.to_handle(ctx)?)?;
        op.add_input(&examples.to_handle(ctx)?)?;
        op.add_input(&labels.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.vocab_count {
            op.set_attr_int_list("vocab_count", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_negative_samples {
            op.set_attr_int("num_negative_samples", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `NegTrain::new().call(&ctx, &w_in, &w_out, &examples, &labels, &lr)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/NegTrain>
pub fn neg_train<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    w_in: &T0,
    w_out: &T1,
    examples: &T2,
    labels: &T3,
    lr: &T4,
) -> crate::Result<()> {
    let op = NegTrain::new();
    op.call(ctx, w_in, w_out, examples, labels, lr)
}

/// NextAfter
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/NextAfter>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct NextAfter {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for NextAfter {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl NextAfter {
    /// Creates a new `NextAfter`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute next_after.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x1: &T0,
        x2: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "NextAfter")?;

        // Required input arguments
        op.add_input(&x1.to_handle(ctx)?)?;
        op.add_input(&x2.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `NextAfter::new().call(&ctx, &x1, &x2)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/NextAfter>
pub fn next_after<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x1: &T0,
    x2: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = NextAfter::new();
    op.call(ctx, x1, x2)
}

/// NextIteration
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/NextIteration>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct NextIteration {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for NextIteration {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl NextIteration {
    /// Creates a new `NextIteration`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute next_iteration.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        data: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "NextIteration")?;

        // Required input arguments
        op.add_input(&data.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `NextIteration::new().call(&ctx, &data)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/NextIteration>
pub fn next_iteration<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    data: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = NextIteration::new();
    op.call(ctx, data)
}

/// NoOp
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/NoOp>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct NoOp {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for NoOp {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl NoOp {
    /// Creates a new `NoOp`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute no_op.
    pub fn call<'a>(&self, ctx: &'a crate::eager::Context) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "NoOp")?;

        // Required input arguments

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `NoOp::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/NoOp>
pub fn no_op<'a>(ctx: &'a crate::eager::Context) -> crate::Result<()> {
    let op = NoOp::new();
    op.call(ctx)
}

/// NonDeterministicInts
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/NonDeterministicInts>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct NonDeterministicInts {
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for NonDeterministicInts {
    fn default() -> Self {
        Self {
            dtype: Some(crate::DataType::Int64),
            target_device_name: None,
        }
    }
}
impl NonDeterministicInts {
    /// Creates a new `NonDeterministicInts`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute non_deterministic_ints.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        shape: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "NonDeterministicInts")?;

        // Required input arguments
        op.add_input(&shape.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `NonDeterministicInts::new().call(&ctx, &shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/NonDeterministicInts>
pub fn non_deterministic_ints<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    shape: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = NonDeterministicInts::new();
    op.call(ctx, shape)
}

/// NonMaxSuppression
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/NonMaxSuppression>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct NonMaxSuppression {
    iou_threshold: ::std::option::Option<f32>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for NonMaxSuppression {
    fn default() -> Self {
        Self {
            iou_threshold: Some(0.5f32),
            target_device_name: None,
        }
    }
}
impl NonMaxSuppression {
    /// Creates a new `NonMaxSuppression`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `iou_threshold` attribute.
    pub fn iou_threshold<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.iou_threshold = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute non_max_suppression.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        boxes: &T0,
        scores: &T1,
        max_output_size: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "NonMaxSuppression")?;

        // Required input arguments
        op.add_input(&boxes.to_handle(ctx)?)?;
        op.add_input(&scores.to_handle(ctx)?)?;
        op.add_input(&max_output_size.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.iou_threshold {
            op.set_attr_float("iou_threshold", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `NonMaxSuppression::new().call(&ctx, &boxes, &scores, &max_output_size)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/NonMaxSuppression>
pub fn non_max_suppression<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    boxes: &T0,
    scores: &T1,
    max_output_size: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = NonMaxSuppression::new();
    op.call(ctx, boxes, scores, max_output_size)
}

/// NonMaxSuppressionV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/NonMaxSuppressionV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct NonMaxSuppressionV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for NonMaxSuppressionV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl NonMaxSuppressionV2 {
    /// Creates a new `NonMaxSuppressionV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute non_max_suppression_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        boxes: &T0,
        scores: &T1,
        max_output_size: &T2,
        iou_threshold: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "NonMaxSuppressionV2")?;

        // Required input arguments
        op.add_input(&boxes.to_handle(ctx)?)?;
        op.add_input(&scores.to_handle(ctx)?)?;
        op.add_input(&max_output_size.to_handle(ctx)?)?;
        op.add_input(&iou_threshold.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `NonMaxSuppressionV2::new().call(&ctx, &boxes, &scores, &max_output_size, &iou_threshold)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/NonMaxSuppressionV2>
pub fn non_max_suppression_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    boxes: &T0,
    scores: &T1,
    max_output_size: &T2,
    iou_threshold: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = NonMaxSuppressionV2::new();
    op.call(ctx, boxes, scores, max_output_size, iou_threshold)
}

/// NonMaxSuppressionV3
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/NonMaxSuppressionV3>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct NonMaxSuppressionV3 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for NonMaxSuppressionV3 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl NonMaxSuppressionV3 {
    /// Creates a new `NonMaxSuppressionV3`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute non_max_suppression_v3.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        boxes: &T0,
        scores: &T1,
        max_output_size: &T2,
        iou_threshold: &T3,
        score_threshold: &T4,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "NonMaxSuppressionV3")?;

        // Required input arguments
        op.add_input(&boxes.to_handle(ctx)?)?;
        op.add_input(&scores.to_handle(ctx)?)?;
        op.add_input(&max_output_size.to_handle(ctx)?)?;
        op.add_input(&iou_threshold.to_handle(ctx)?)?;
        op.add_input(&score_threshold.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `NonMaxSuppressionV3::new().call(&ctx, &boxes, &scores, &max_output_size, &iou_threshold, &score_threshold)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/NonMaxSuppressionV3>
pub fn non_max_suppression_v3<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    boxes: &T0,
    scores: &T1,
    max_output_size: &T2,
    iou_threshold: &T3,
    score_threshold: &T4,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = NonMaxSuppressionV3::new();
    op.call(
        ctx,
        boxes,
        scores,
        max_output_size,
        iou_threshold,
        score_threshold,
    )
}

/// NonMaxSuppressionV4
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/NonMaxSuppressionV4>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct NonMaxSuppressionV4 {
    pad_to_max_output_size: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for NonMaxSuppressionV4 {
    fn default() -> Self {
        Self {
            pad_to_max_output_size: Some(false),
            target_device_name: None,
        }
    }
}
impl NonMaxSuppressionV4 {
    /// Creates a new `NonMaxSuppressionV4`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `pad_to_max_output_size` attribute.
    pub fn pad_to_max_output_size<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.pad_to_max_output_size = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute non_max_suppression_v4.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        boxes: &T0,
        scores: &T1,
        max_output_size: &T2,
        iou_threshold: &T3,
        score_threshold: &T4,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "NonMaxSuppressionV4")?;

        // Required input arguments
        op.add_input(&boxes.to_handle(ctx)?)?;
        op.add_input(&scores.to_handle(ctx)?)?;
        op.add_input(&max_output_size.to_handle(ctx)?)?;
        op.add_input(&iou_threshold.to_handle(ctx)?)?;
        op.add_input(&score_threshold.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.pad_to_max_output_size {
            op.set_attr_bool("pad_to_max_output_size", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `NonMaxSuppressionV4::new().call(&ctx, &boxes, &scores, &max_output_size, &iou_threshold, &score_threshold)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/NonMaxSuppressionV4>
pub fn non_max_suppression_v4<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    boxes: &T0,
    scores: &T1,
    max_output_size: &T2,
    iou_threshold: &T3,
    score_threshold: &T4,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = NonMaxSuppressionV4::new();
    op.call(
        ctx,
        boxes,
        scores,
        max_output_size,
        iou_threshold,
        score_threshold,
    )
}

/// NonMaxSuppressionV5
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/NonMaxSuppressionV5>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct NonMaxSuppressionV5 {
    pad_to_max_output_size: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for NonMaxSuppressionV5 {
    fn default() -> Self {
        Self {
            pad_to_max_output_size: Some(false),
            target_device_name: None,
        }
    }
}
impl NonMaxSuppressionV5 {
    /// Creates a new `NonMaxSuppressionV5`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `pad_to_max_output_size` attribute.
    pub fn pad_to_max_output_size<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.pad_to_max_output_size = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute non_max_suppression_v5.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        boxes: &T0,
        scores: &T1,
        max_output_size: &T2,
        iou_threshold: &T3,
        score_threshold: &T4,
        soft_nms_sigma: &T5,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "NonMaxSuppressionV5")?;

        // Required input arguments
        op.add_input(&boxes.to_handle(ctx)?)?;
        op.add_input(&scores.to_handle(ctx)?)?;
        op.add_input(&max_output_size.to_handle(ctx)?)?;
        op.add_input(&iou_threshold.to_handle(ctx)?)?;
        op.add_input(&score_threshold.to_handle(ctx)?)?;
        op.add_input(&soft_nms_sigma.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.pad_to_max_output_size {
            op.set_attr_bool("pad_to_max_output_size", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `NonMaxSuppressionV5::new().call(&ctx, &boxes, &scores, &max_output_size, &iou_threshold, &score_threshold, &soft_nms_sigma)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/NonMaxSuppressionV5>
pub fn non_max_suppression_v5<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    boxes: &T0,
    scores: &T1,
    max_output_size: &T2,
    iou_threshold: &T3,
    score_threshold: &T4,
    soft_nms_sigma: &T5,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = NonMaxSuppressionV5::new();
    op.call(
        ctx,
        boxes,
        scores,
        max_output_size,
        iou_threshold,
        score_threshold,
        soft_nms_sigma,
    )
}

/// NonMaxSuppressionWithOverlaps
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/NonMaxSuppressionWithOverlaps>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct NonMaxSuppressionWithOverlaps {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for NonMaxSuppressionWithOverlaps {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl NonMaxSuppressionWithOverlaps {
    /// Creates a new `NonMaxSuppressionWithOverlaps`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute non_max_suppression_with_overlaps.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        overlaps: &T0,
        scores: &T1,
        max_output_size: &T2,
        overlap_threshold: &T3,
        score_threshold: &T4,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "NonMaxSuppressionWithOverlaps")?;

        // Required input arguments
        op.add_input(&overlaps.to_handle(ctx)?)?;
        op.add_input(&scores.to_handle(ctx)?)?;
        op.add_input(&max_output_size.to_handle(ctx)?)?;
        op.add_input(&overlap_threshold.to_handle(ctx)?)?;
        op.add_input(&score_threshold.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `NonMaxSuppressionWithOverlaps::new().call(&ctx, &overlaps, &scores, &max_output_size, &overlap_threshold, &score_threshold)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/NonMaxSuppressionWithOverlaps>
pub fn non_max_suppression_with_overlaps<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    overlaps: &T0,
    scores: &T1,
    max_output_size: &T2,
    overlap_threshold: &T3,
    score_threshold: &T4,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = NonMaxSuppressionWithOverlaps::new();
    op.call(
        ctx,
        overlaps,
        scores,
        max_output_size,
        overlap_threshold,
        score_threshold,
    )
}

/// NonSerializableDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/NonSerializableDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct NonSerializableDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for NonSerializableDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl NonSerializableDataset {
    /// Creates a new `NonSerializableDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute non_serializable_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "NonSerializableDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `NonSerializableDataset::new().call(&ctx, &input_dataset)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/NonSerializableDataset>
pub fn non_serializable_dataset<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = NonSerializableDataset::new();
    op.call(ctx, input_dataset)
}

/// NotEqual
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/NotEqual>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct NotEqual {
    incompatible_shape_error: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for NotEqual {
    fn default() -> Self {
        Self {
            incompatible_shape_error: Some(true),
            target_device_name: None,
        }
    }
}
impl NotEqual {
    /// Creates a new `NotEqual`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `incompatible_shape_error` attribute.
    pub fn incompatible_shape_error<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.incompatible_shape_error = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute not_equal.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "NotEqual")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.incompatible_shape_error {
            op.set_attr_bool("incompatible_shape_error", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `NotEqual::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/NotEqual>
pub fn not_equal<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = NotEqual::new();
    op.call(ctx, x, y)
}

/// NthElement
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/NthElement>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct NthElement {
    reverse: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for NthElement {
    fn default() -> Self {
        Self {
            reverse: Some(false),
            target_device_name: None,
        }
    }
}
impl NthElement {
    /// Creates a new `NthElement`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `reverse` attribute.
    pub fn reverse<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.reverse = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute nth_element.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        n: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "NthElement")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&n.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.reverse {
            op.set_attr_bool("reverse", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `NthElement::new().call(&ctx, &input, &n)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/NthElement>
pub fn nth_element<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    n: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = NthElement::new();
    op.call(ctx, input, n)
}

/// OneHot
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OneHot>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct OneHot {
    axis: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for OneHot {
    fn default() -> Self {
        Self {
            axis: Some(-1i64),
            target_device_name: None,
        }
    }
}
impl OneHot {
    /// Creates a new `OneHot`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `axis` attribute.
    pub fn axis<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.axis = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute one_hot.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        indices: &T0,
        depth: &T1,
        on_value: &T2,
        off_value: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "OneHot")?;

        // Required input arguments
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&depth.to_handle(ctx)?)?;
        op.add_input(&on_value.to_handle(ctx)?)?;
        op.add_input(&off_value.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.axis {
            op.set_attr_int("axis", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `OneHot::new().call(&ctx, &indices, &depth, &on_value, &off_value)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OneHot>
pub fn one_hot<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    indices: &T0,
    depth: &T1,
    on_value: &T2,
    off_value: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = OneHot::new();
    op.call(ctx, indices, depth, on_value, off_value)
}

/// OneShotIterator
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OneShotIterator>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct OneShotIterator {
    dataset_factory: ::std::option::Option<::std::string::String>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for OneShotIterator {
    fn default() -> Self {
        Self {
            dataset_factory: None,
            output_types: None,
            output_shapes: None,
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl OneShotIterator {
    /// Creates a new `OneShotIterator`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dataset_factory` attribute.
    pub fn dataset_factory<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dataset_factory = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute one_shot_iterator.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "OneShotIterator")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dataset_factory {
            op.set_attr_string("dataset_factory", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `OneShotIterator::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OneShotIterator>
pub fn one_shot_iterator<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = OneShotIterator::new();
    op.call(ctx)
}

/// OnesLike
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OnesLike>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct OnesLike {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for OnesLike {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl OnesLike {
    /// Creates a new `OnesLike`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute ones_like.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "OnesLike")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `OnesLike::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OnesLike>
pub fn ones_like<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = OnesLike::new();
    op.call(ctx, x)
}

/// OptimizeDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OptimizeDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct OptimizeDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    optimization_configs: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for OptimizeDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            optimization_configs: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl OptimizeDataset {
    /// Creates a new `OptimizeDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `optimization_configs` attribute.
    pub fn optimization_configs<
        ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>,
    >(
        mut self,
        value: ArgType,
    ) -> Self {
        self.optimization_configs = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute optimize_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        optimizations: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "OptimizeDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&optimizations.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.optimization_configs {
            op.set_attr_string_list("optimization_configs", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `OptimizeDataset::new().call(&ctx, &input_dataset, &optimizations)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OptimizeDataset>
pub fn optimize_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    optimizations: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = OptimizeDataset::new();
    op.call(ctx, input_dataset, optimizations)
}

/// OptimizeDatasetV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OptimizeDatasetV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct OptimizeDatasetV2 {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    optimization_configs: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for OptimizeDatasetV2 {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            optimization_configs: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl OptimizeDatasetV2 {
    /// Creates a new `OptimizeDatasetV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `optimization_configs` attribute.
    pub fn optimization_configs<
        ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>,
    >(
        mut self,
        value: ArgType,
    ) -> Self {
        self.optimization_configs = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute optimize_dataset_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        optimizations_enabled: &T1,
        optimizations_disabled: &T2,
        optimizations_default: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "OptimizeDatasetV2")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&optimizations_enabled.to_handle(ctx)?)?;
        op.add_input(&optimizations_disabled.to_handle(ctx)?)?;
        op.add_input(&optimizations_default.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.optimization_configs {
            op.set_attr_string_list("optimization_configs", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `OptimizeDatasetV2::new().call(&ctx, &input_dataset, &optimizations_enabled, &optimizations_disabled, &optimizations_default)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OptimizeDatasetV2>
pub fn optimize_dataset_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    optimizations_enabled: &T1,
    optimizations_disabled: &T2,
    optimizations_default: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = OptimizeDatasetV2::new();
    op.call(
        ctx,
        input_dataset,
        optimizations_enabled,
        optimizations_disabled,
        optimizations_default,
    )
}

/// OptionalFromValue
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OptionalFromValue>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct OptionalFromValue {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for OptionalFromValue {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl OptionalFromValue {
    /// Creates a new `OptionalFromValue`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute optional_from_value.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        components: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "OptionalFromValue")?;

        // Required input arguments
        op.add_input(&components.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `OptionalFromValue::new().call(&ctx, &components)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OptionalFromValue>
pub fn optional_from_value<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    components: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = OptionalFromValue::new();
    op.call(ctx, components)
}

/// OptionalGetValue
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OptionalGetValue>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct OptionalGetValue {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for OptionalGetValue {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl OptionalGetValue {
    /// Creates a new `OptionalGetValue`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute optional_get_value.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        optional: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "OptionalGetValue")?;

        // Required input arguments
        op.add_input(&optional.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `OptionalGetValue::new().call(&ctx, &optional)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OptionalGetValue>
pub fn optional_get_value<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    optional: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = OptionalGetValue::new();
    op.call(ctx, optional)
}

/// OptionalHasValue
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OptionalHasValue>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct OptionalHasValue {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for OptionalHasValue {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl OptionalHasValue {
    /// Creates a new `OptionalHasValue`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute optional_has_value.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        optional: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "OptionalHasValue")?;

        // Required input arguments
        op.add_input(&optional.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `OptionalHasValue::new().call(&ctx, &optional)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OptionalHasValue>
pub fn optional_has_value<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    optional: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = OptionalHasValue::new();
    op.call(ctx, optional)
}

/// OptionalNone
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OptionalNone>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct OptionalNone {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for OptionalNone {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl OptionalNone {
    /// Creates a new `OptionalNone`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute optional_none.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "OptionalNone")?;

        // Required input arguments

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `OptionalNone::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OptionalNone>
pub fn optional_none<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = OptionalNone::new();
    op.call(ctx)
}

/// OptionsDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OptionsDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct OptionsDataset {
    serialized_options: ::std::option::Option<::std::string::String>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for OptionsDataset {
    fn default() -> Self {
        Self {
            serialized_options: None,
            output_types: None,
            output_shapes: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl OptionsDataset {
    /// Creates a new `OptionsDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `serialized_options` attribute.
    pub fn serialized_options<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.serialized_options = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute options_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "OptionsDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.serialized_options {
            op.set_attr_string("serialized_options", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `OptionsDataset::new().call(&ctx, &input_dataset)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OptionsDataset>
pub fn options_dataset<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = OptionsDataset::new();
    op.call(ctx, input_dataset)
}

/// OrderedMapClear
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OrderedMapClear>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct OrderedMapClear {
    capacity: ::std::option::Option<i64>,
    memory_limit: ::std::option::Option<i64>,
    dtypes: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for OrderedMapClear {
    fn default() -> Self {
        Self {
            capacity: Some(0i64),
            memory_limit: Some(0i64),
            dtypes: None,
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl OrderedMapClear {
    /// Creates a new `OrderedMapClear`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `capacity` attribute.
    pub fn capacity<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.capacity = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `memory_limit` attribute.
    pub fn memory_limit<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.memory_limit = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dtypes` attribute.
    pub fn dtypes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dtypes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute ordered_map_clear.
    pub fn call<'a>(&self, ctx: &'a crate::eager::Context) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "OrderedMapClear")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.capacity {
            op.set_attr_int("capacity", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.memory_limit {
            op.set_attr_int("memory_limit", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dtypes {
            op.set_attr_type_list("dtypes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `OrderedMapClear::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OrderedMapClear>
pub fn ordered_map_clear<'a>(ctx: &'a crate::eager::Context) -> crate::Result<()> {
    let op = OrderedMapClear::new();
    op.call(ctx)
}

/// OrderedMapIncompleteSize
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OrderedMapIncompleteSize>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct OrderedMapIncompleteSize {
    capacity: ::std::option::Option<i64>,
    memory_limit: ::std::option::Option<i64>,
    dtypes: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for OrderedMapIncompleteSize {
    fn default() -> Self {
        Self {
            capacity: Some(0i64),
            memory_limit: Some(0i64),
            dtypes: None,
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl OrderedMapIncompleteSize {
    /// Creates a new `OrderedMapIncompleteSize`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `capacity` attribute.
    pub fn capacity<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.capacity = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `memory_limit` attribute.
    pub fn memory_limit<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.memory_limit = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dtypes` attribute.
    pub fn dtypes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dtypes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute ordered_map_incomplete_size.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "OrderedMapIncompleteSize")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.capacity {
            op.set_attr_int("capacity", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.memory_limit {
            op.set_attr_int("memory_limit", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dtypes {
            op.set_attr_type_list("dtypes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `OrderedMapIncompleteSize::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OrderedMapIncompleteSize>
pub fn ordered_map_incomplete_size<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = OrderedMapIncompleteSize::new();
    op.call(ctx)
}

/// OrderedMapPeek
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OrderedMapPeek>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct OrderedMapPeek {
    capacity: ::std::option::Option<i64>,
    memory_limit: ::std::option::Option<i64>,
    dtypes: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for OrderedMapPeek {
    fn default() -> Self {
        Self {
            capacity: Some(0i64),
            memory_limit: Some(0i64),
            dtypes: None,
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl OrderedMapPeek {
    /// Creates a new `OrderedMapPeek`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `capacity` attribute.
    pub fn capacity<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.capacity = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `memory_limit` attribute.
    pub fn memory_limit<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.memory_limit = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dtypes` attribute.
    pub fn dtypes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dtypes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute ordered_map_peek.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        key: &T0,
        indices: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "OrderedMapPeek")?;

        // Required input arguments
        op.add_input(&key.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.capacity {
            op.set_attr_int("capacity", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.memory_limit {
            op.set_attr_int("memory_limit", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dtypes {
            op.set_attr_type_list("dtypes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `OrderedMapPeek::new().call(&ctx, &key, &indices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OrderedMapPeek>
pub fn ordered_map_peek<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    key: &T0,
    indices: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = OrderedMapPeek::new();
    op.call(ctx, key, indices)
}

/// OrderedMapSize
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OrderedMapSize>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct OrderedMapSize {
    capacity: ::std::option::Option<i64>,
    memory_limit: ::std::option::Option<i64>,
    dtypes: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for OrderedMapSize {
    fn default() -> Self {
        Self {
            capacity: Some(0i64),
            memory_limit: Some(0i64),
            dtypes: None,
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl OrderedMapSize {
    /// Creates a new `OrderedMapSize`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `capacity` attribute.
    pub fn capacity<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.capacity = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `memory_limit` attribute.
    pub fn memory_limit<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.memory_limit = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dtypes` attribute.
    pub fn dtypes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dtypes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute ordered_map_size.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "OrderedMapSize")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.capacity {
            op.set_attr_int("capacity", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.memory_limit {
            op.set_attr_int("memory_limit", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dtypes {
            op.set_attr_type_list("dtypes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `OrderedMapSize::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OrderedMapSize>
pub fn ordered_map_size<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = OrderedMapSize::new();
    op.call(ctx)
}

/// OrderedMapStage
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OrderedMapStage>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct OrderedMapStage {
    capacity: ::std::option::Option<i64>,
    memory_limit: ::std::option::Option<i64>,
    dtypes: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for OrderedMapStage {
    fn default() -> Self {
        Self {
            capacity: Some(0i64),
            memory_limit: Some(0i64),
            dtypes: None,
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl OrderedMapStage {
    /// Creates a new `OrderedMapStage`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `capacity` attribute.
    pub fn capacity<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.capacity = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `memory_limit` attribute.
    pub fn memory_limit<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.memory_limit = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dtypes` attribute.
    pub fn dtypes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dtypes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute ordered_map_stage.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        key: &T0,
        indices: &T1,
        values: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "OrderedMapStage")?;

        // Required input arguments
        op.add_input(&key.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&values.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.capacity {
            op.set_attr_int("capacity", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.memory_limit {
            op.set_attr_int("memory_limit", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dtypes {
            op.set_attr_type_list("dtypes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `OrderedMapStage::new().call(&ctx, &key, &indices, &values)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OrderedMapStage>
pub fn ordered_map_stage<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    key: &T0,
    indices: &T1,
    values: &T2,
) -> crate::Result<()> {
    let op = OrderedMapStage::new();
    op.call(ctx, key, indices, values)
}

/// OrderedMapUnstage
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OrderedMapUnstage>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct OrderedMapUnstage {
    capacity: ::std::option::Option<i64>,
    memory_limit: ::std::option::Option<i64>,
    dtypes: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for OrderedMapUnstage {
    fn default() -> Self {
        Self {
            capacity: Some(0i64),
            memory_limit: Some(0i64),
            dtypes: None,
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl OrderedMapUnstage {
    /// Creates a new `OrderedMapUnstage`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `capacity` attribute.
    pub fn capacity<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.capacity = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `memory_limit` attribute.
    pub fn memory_limit<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.memory_limit = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dtypes` attribute.
    pub fn dtypes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dtypes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute ordered_map_unstage.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        key: &T0,
        indices: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "OrderedMapUnstage")?;

        // Required input arguments
        op.add_input(&key.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.capacity {
            op.set_attr_int("capacity", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.memory_limit {
            op.set_attr_int("memory_limit", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dtypes {
            op.set_attr_type_list("dtypes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `OrderedMapUnstage::new().call(&ctx, &key, &indices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OrderedMapUnstage>
pub fn ordered_map_unstage<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    key: &T0,
    indices: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = OrderedMapUnstage::new();
    op.call(ctx, key, indices)
}

/// OrderedMapUnstageNoKey
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OrderedMapUnstageNoKey>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct OrderedMapUnstageNoKey {
    capacity: ::std::option::Option<i64>,
    memory_limit: ::std::option::Option<i64>,
    dtypes: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for OrderedMapUnstageNoKey {
    fn default() -> Self {
        Self {
            capacity: Some(0i64),
            memory_limit: Some(0i64),
            dtypes: None,
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl OrderedMapUnstageNoKey {
    /// Creates a new `OrderedMapUnstageNoKey`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `capacity` attribute.
    pub fn capacity<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.capacity = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `memory_limit` attribute.
    pub fn memory_limit<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.memory_limit = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dtypes` attribute.
    pub fn dtypes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dtypes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute ordered_map_unstage_no_key.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        indices: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "OrderedMapUnstageNoKey")?;

        // Required input arguments
        op.add_input(&indices.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.capacity {
            op.set_attr_int("capacity", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.memory_limit {
            op.set_attr_int("memory_limit", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dtypes {
            op.set_attr_type_list("dtypes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `OrderedMapUnstageNoKey::new().call(&ctx, &indices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OrderedMapUnstageNoKey>
pub fn ordered_map_unstage_no_key<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    indices: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = OrderedMapUnstageNoKey::new();
    op.call(ctx, indices)
}

/// OutfeedDequeue
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OutfeedDequeue>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct OutfeedDequeue {
    dtype: ::std::option::Option<crate::DataType>,
    shape: ::std::option::Option<crate::Shape>,
    device_ordinal: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for OutfeedDequeue {
    fn default() -> Self {
        Self {
            dtype: None,
            shape: None,
            device_ordinal: Some(-1i64),
            target_device_name: None,
        }
    }
}
impl OutfeedDequeue {
    /// Creates a new `OutfeedDequeue`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shape` attribute.
    pub fn shape<ArgType: ::std::convert::Into<crate::Shape>>(mut self, value: ArgType) -> Self {
        self.shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `device_ordinal` attribute.
    pub fn device_ordinal<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.device_ordinal = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute outfeed_dequeue.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "OutfeedDequeue")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shape {
            op.set_attr_shape("shape", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.device_ordinal {
            op.set_attr_int("device_ordinal", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `OutfeedDequeue::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OutfeedDequeue>
pub fn outfeed_dequeue<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = OutfeedDequeue::new();
    op.call(ctx)
}

/// OutfeedDequeueTuple
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OutfeedDequeueTuple>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct OutfeedDequeueTuple {
    dtypes: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    device_ordinal: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for OutfeedDequeueTuple {
    fn default() -> Self {
        Self {
            dtypes: None,
            shapes: None,
            device_ordinal: Some(-1i64),
            target_device_name: None,
        }
    }
}
impl OutfeedDequeueTuple {
    /// Creates a new `OutfeedDequeueTuple`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtypes` attribute.
    pub fn dtypes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dtypes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shapes` attribute.
    pub fn shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `device_ordinal` attribute.
    pub fn device_ordinal<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.device_ordinal = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute outfeed_dequeue_tuple.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "OutfeedDequeueTuple")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtypes {
            op.set_attr_type_list("dtypes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shapes {
            op.set_attr_shape_list("shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.device_ordinal {
            op.set_attr_int("device_ordinal", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `OutfeedDequeueTuple::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OutfeedDequeueTuple>
pub fn outfeed_dequeue_tuple<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = OutfeedDequeueTuple::new();
    op.call(ctx)
}

/// OutfeedDequeueTupleV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OutfeedDequeueTupleV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct OutfeedDequeueTupleV2 {
    dtypes: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for OutfeedDequeueTupleV2 {
    fn default() -> Self {
        Self {
            dtypes: None,
            shapes: None,
            target_device_name: None,
        }
    }
}
impl OutfeedDequeueTupleV2 {
    /// Creates a new `OutfeedDequeueTupleV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtypes` attribute.
    pub fn dtypes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dtypes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shapes` attribute.
    pub fn shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute outfeed_dequeue_tuple_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        device_ordinal: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "OutfeedDequeueTupleV2")?;

        // Required input arguments
        op.add_input(&device_ordinal.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtypes {
            op.set_attr_type_list("dtypes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shapes {
            op.set_attr_shape_list("shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `OutfeedDequeueTupleV2::new().call(&ctx, &device_ordinal)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OutfeedDequeueTupleV2>
pub fn outfeed_dequeue_tuple_v2<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    device_ordinal: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = OutfeedDequeueTupleV2::new();
    op.call(ctx, device_ordinal)
}

/// OutfeedDequeueV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OutfeedDequeueV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct OutfeedDequeueV2 {
    dtype: ::std::option::Option<crate::DataType>,
    shape: ::std::option::Option<crate::Shape>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for OutfeedDequeueV2 {
    fn default() -> Self {
        Self {
            dtype: None,
            shape: None,
            target_device_name: None,
        }
    }
}
impl OutfeedDequeueV2 {
    /// Creates a new `OutfeedDequeueV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shape` attribute.
    pub fn shape<ArgType: ::std::convert::Into<crate::Shape>>(mut self, value: ArgType) -> Self {
        self.shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute outfeed_dequeue_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        device_ordinal: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "OutfeedDequeueV2")?;

        // Required input arguments
        op.add_input(&device_ordinal.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shape {
            op.set_attr_shape("shape", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `OutfeedDequeueV2::new().call(&ctx, &device_ordinal)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OutfeedDequeueV2>
pub fn outfeed_dequeue_v2<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    device_ordinal: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = OutfeedDequeueV2::new();
    op.call(ctx, device_ordinal)
}

/// OutfeedEnqueue
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OutfeedEnqueue>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct OutfeedEnqueue {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for OutfeedEnqueue {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl OutfeedEnqueue {
    /// Creates a new `OutfeedEnqueue`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute outfeed_enqueue.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "OutfeedEnqueue")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `OutfeedEnqueue::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OutfeedEnqueue>
pub fn outfeed_enqueue<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<()> {
    let op = OutfeedEnqueue::new();
    op.call(ctx, input)
}

/// OutfeedEnqueueTuple
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OutfeedEnqueueTuple>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct OutfeedEnqueueTuple {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for OutfeedEnqueueTuple {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl OutfeedEnqueueTuple {
    /// Creates a new `OutfeedEnqueueTuple`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute outfeed_enqueue_tuple.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        inputs: &T0,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "OutfeedEnqueueTuple")?;

        // Required input arguments
        op.add_input(&inputs.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `OutfeedEnqueueTuple::new().call(&ctx, &inputs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/OutfeedEnqueueTuple>
pub fn outfeed_enqueue_tuple<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    inputs: &T0,
) -> crate::Result<()> {
    let op = OutfeedEnqueueTuple::new();
    op.call(ctx, inputs)
}

/// Pack
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Pack>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Pack {
    axis: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Pack {
    fn default() -> Self {
        Self {
            axis: Some(0i64),
            target_device_name: None,
        }
    }
}
impl Pack {
    /// Creates a new `Pack`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `axis` attribute.
    pub fn axis<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.axis = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute pack.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        values: &[&T0],
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Pack")?;

        // Required input arguments
        let mut values_list = Vec::new();

        for t in values {
            values_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&values_list)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.axis {
            op.set_attr_int("axis", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Pack::new().call(&ctx, &values)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Pack>
pub fn pack<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    values: &[&T0],
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Pack::new();
    op.call(ctx, values)
}

/// Pad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Pad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Pad {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Pad {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Pad {
    /// Creates a new `Pad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute pad.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        paddings: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Pad")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&paddings.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Pad::new().call(&ctx, &input, &paddings)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Pad>
pub fn pad<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    paddings: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Pad::new();
    op.call(ctx, input, paddings)
}

/// PadV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/PadV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct PadV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for PadV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl PadV2 {
    /// Creates a new `PadV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute pad_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        paddings: &T1,
        constant_values: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "PadV2")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&paddings.to_handle(ctx)?)?;
        op.add_input(&constant_values.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `PadV2::new().call(&ctx, &input, &paddings, &constant_values)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/PadV2>
pub fn pad_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    paddings: &T1,
    constant_values: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = PadV2::new();
    op.call(ctx, input, paddings, constant_values)
}

/// PaddedBatchDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/PaddedBatchDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct PaddedBatchDataset {
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for PaddedBatchDataset {
    fn default() -> Self {
        Self {
            output_shapes: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl PaddedBatchDataset {
    /// Creates a new `PaddedBatchDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute padded_batch_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        batch_size: &T1,
        padded_shapes: &[&T2],
        padding_values: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "PaddedBatchDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&batch_size.to_handle(ctx)?)?;
        let mut padded_shapes_list = Vec::new();

        for t in padded_shapes {
            padded_shapes_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&padded_shapes_list)?;
        op.add_input(&padding_values.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `PaddedBatchDataset::new().call(&ctx, &input_dataset, &batch_size, &padded_shapes, &padding_values)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/PaddedBatchDataset>
pub fn padded_batch_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    batch_size: &T1,
    padded_shapes: &[&T2],
    padding_values: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = PaddedBatchDataset::new();
    op.call(
        ctx,
        input_dataset,
        batch_size,
        padded_shapes,
        padding_values,
    )
}

/// PaddedBatchDatasetV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/PaddedBatchDatasetV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct PaddedBatchDatasetV2 {
    parallel_copy: ::std::option::Option<bool>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for PaddedBatchDatasetV2 {
    fn default() -> Self {
        Self {
            parallel_copy: Some(false),
            output_shapes: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl PaddedBatchDatasetV2 {
    /// Creates a new `PaddedBatchDatasetV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `parallel_copy` attribute.
    pub fn parallel_copy<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.parallel_copy = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute padded_batch_dataset_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        batch_size: &T1,
        padded_shapes: &[&T2],
        padding_values: &T3,
        drop_remainder: &T4,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "PaddedBatchDatasetV2")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&batch_size.to_handle(ctx)?)?;
        let mut padded_shapes_list = Vec::new();

        for t in padded_shapes {
            padded_shapes_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&padded_shapes_list)?;
        op.add_input(&padding_values.to_handle(ctx)?)?;
        op.add_input(&drop_remainder.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.parallel_copy {
            op.set_attr_bool("parallel_copy", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `PaddedBatchDatasetV2::new().call(&ctx, &input_dataset, &batch_size, &padded_shapes, &padding_values, &drop_remainder)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/PaddedBatchDatasetV2>
pub fn padded_batch_dataset_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    batch_size: &T1,
    padded_shapes: &[&T2],
    padding_values: &T3,
    drop_remainder: &T4,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = PaddedBatchDatasetV2::new();
    op.call(
        ctx,
        input_dataset,
        batch_size,
        padded_shapes,
        padding_values,
        drop_remainder,
    )
}

/// PaddingFIFOQueue
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/PaddingFIFOQueue>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct PaddingFIFOQueue {
    component_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    capacity: ::std::option::Option<i64>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for PaddingFIFOQueue {
    fn default() -> Self {
        Self {
            component_types: None,
            shapes: Some(vec![]),
            capacity: Some(-1i64),
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl PaddingFIFOQueue {
    /// Creates a new `PaddingFIFOQueue`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `component_types` attribute.
    pub fn component_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.component_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shapes` attribute.
    pub fn shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `capacity` attribute.
    pub fn capacity<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.capacity = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute padding_fifoqueue.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "PaddingFIFOQueue")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.component_types {
            op.set_attr_type_list("component_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shapes {
            op.set_attr_shape_list("shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.capacity {
            op.set_attr_int("capacity", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `PaddingFIFOQueue::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/PaddingFIFOQueue>
pub fn padding_fifoqueue<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = PaddingFIFOQueue::new();
    op.call(ctx)
}

/// PaddingFIFOQueueV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/PaddingFIFOQueueV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct PaddingFIFOQueueV2 {
    component_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    capacity: ::std::option::Option<i64>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for PaddingFIFOQueueV2 {
    fn default() -> Self {
        Self {
            component_types: None,
            shapes: Some(vec![]),
            capacity: Some(-1i64),
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl PaddingFIFOQueueV2 {
    /// Creates a new `PaddingFIFOQueueV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `component_types` attribute.
    pub fn component_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.component_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shapes` attribute.
    pub fn shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `capacity` attribute.
    pub fn capacity<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.capacity = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute padding_fifoqueue_v2.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "PaddingFIFOQueueV2")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.component_types {
            op.set_attr_type_list("component_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shapes {
            op.set_attr_shape_list("shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.capacity {
            op.set_attr_int("capacity", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `PaddingFIFOQueueV2::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/PaddingFIFOQueueV2>
pub fn padding_fifoqueue_v2<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = PaddingFIFOQueueV2::new();
    op.call(ctx)
}

/// ParallelBatchDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParallelBatchDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ParallelBatchDataset {
    parallel_copy: ::std::option::Option<bool>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    deterministic: ::std::option::Option<::std::string::String>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ParallelBatchDataset {
    fn default() -> Self {
        Self {
            parallel_copy: Some(false),
            output_types: None,
            output_shapes: None,
            deterministic: Some(::std::string::String::from("default")),
            metadata: None,
            target_device_name: None,
        }
    }
}
impl ParallelBatchDataset {
    /// Creates a new `ParallelBatchDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `parallel_copy` attribute.
    pub fn parallel_copy<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.parallel_copy = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `deterministic` attribute.
    pub fn deterministic<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.deterministic = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute parallel_batch_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        batch_size: &T1,
        num_parallel_calls: &T2,
        drop_remainder: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ParallelBatchDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&batch_size.to_handle(ctx)?)?;
        op.add_input(&num_parallel_calls.to_handle(ctx)?)?;
        op.add_input(&drop_remainder.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.parallel_copy {
            op.set_attr_bool("parallel_copy", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.deterministic {
            op.set_attr_string("deterministic", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ParallelBatchDataset::new().call(&ctx, &input_dataset, &batch_size, &num_parallel_calls, &drop_remainder)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParallelBatchDataset>
pub fn parallel_batch_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    batch_size: &T1,
    num_parallel_calls: &T2,
    drop_remainder: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ParallelBatchDataset::new();
    op.call(
        ctx,
        input_dataset,
        batch_size,
        num_parallel_calls,
        drop_remainder,
    )
}

/// ParallelConcat
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParallelConcat>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ParallelConcat {
    shape: ::std::option::Option<crate::Shape>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ParallelConcat {
    fn default() -> Self {
        Self {
            shape: None,
            target_device_name: None,
        }
    }
}
impl ParallelConcat {
    /// Creates a new `ParallelConcat`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `shape` attribute.
    pub fn shape<ArgType: ::std::convert::Into<crate::Shape>>(mut self, value: ArgType) -> Self {
        self.shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute parallel_concat.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        values: &[&T0],
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ParallelConcat")?;

        // Required input arguments
        let mut values_list = Vec::new();

        for t in values {
            values_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&values_list)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.shape {
            op.set_attr_shape("shape", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ParallelConcat::new().call(&ctx, &values)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParallelConcat>
pub fn parallel_concat<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    values: &[&T0],
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ParallelConcat::new();
    op.call(ctx, values)
}

/// ParallelDynamicStitch
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParallelDynamicStitch>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ParallelDynamicStitch {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ParallelDynamicStitch {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ParallelDynamicStitch {
    /// Creates a new `ParallelDynamicStitch`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute parallel_dynamic_stitch.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        indices: &[&T0],
        data: &[&T1],
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ParallelDynamicStitch")?;

        // Required input arguments
        let mut indices_list = Vec::new();

        for t in indices {
            indices_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&indices_list)?;
        let mut data_list = Vec::new();

        for t in data {
            data_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&data_list)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ParallelDynamicStitch::new().call(&ctx, &indices, &data)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParallelDynamicStitch>
pub fn parallel_dynamic_stitch<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    indices: &[&T0],
    data: &[&T1],
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ParallelDynamicStitch::new();
    op.call(ctx, indices, data)
}

/// ParallelFilterDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParallelFilterDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ParallelFilterDataset {
    predicate: ::std::option::Option<::std::string::String>,
    deterministic: ::std::option::Option<::std::string::String>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ParallelFilterDataset {
    fn default() -> Self {
        Self {
            predicate: None,
            deterministic: Some(::std::string::String::from("default")),
            output_types: None,
            output_shapes: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl ParallelFilterDataset {
    /// Creates a new `ParallelFilterDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `predicate` attribute.
    pub fn predicate<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.predicate = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `deterministic` attribute.
    pub fn deterministic<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.deterministic = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute parallel_filter_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        other_arguments: &T1,
        num_parallel_calls: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ParallelFilterDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&other_arguments.to_handle(ctx)?)?;
        op.add_input(&num_parallel_calls.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.predicate {
            op.set_attr_string("predicate", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.deterministic {
            op.set_attr_string("deterministic", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ParallelFilterDataset::new().call(&ctx, &input_dataset, &other_arguments, &num_parallel_calls)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParallelFilterDataset>
pub fn parallel_filter_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    other_arguments: &T1,
    num_parallel_calls: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ParallelFilterDataset::new();
    op.call(ctx, input_dataset, other_arguments, num_parallel_calls)
}

/// ParallelInterleaveDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParallelInterleaveDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ParallelInterleaveDataset {
    f: ::std::option::Option<::std::string::String>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ParallelInterleaveDataset {
    fn default() -> Self {
        Self {
            f: None,
            output_types: None,
            output_shapes: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl ParallelInterleaveDataset {
    /// Creates a new `ParallelInterleaveDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `f` attribute.
    pub fn f<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.f = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute parallel_interleave_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        other_arguments: &T1,
        cycle_length: &T2,
        block_length: &T3,
        sloppy: &T4,
        buffer_output_elements: &T5,
        prefetch_input_elements: &T6,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ParallelInterleaveDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&other_arguments.to_handle(ctx)?)?;
        op.add_input(&cycle_length.to_handle(ctx)?)?;
        op.add_input(&block_length.to_handle(ctx)?)?;
        op.add_input(&sloppy.to_handle(ctx)?)?;
        op.add_input(&buffer_output_elements.to_handle(ctx)?)?;
        op.add_input(&prefetch_input_elements.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.f {
            op.set_attr_string("f", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ParallelInterleaveDataset::new().call(&ctx, &input_dataset, &other_arguments, &cycle_length, &block_length, &sloppy, &buffer_output_elements, &prefetch_input_elements)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParallelInterleaveDataset>
pub fn parallel_interleave_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    other_arguments: &T1,
    cycle_length: &T2,
    block_length: &T3,
    sloppy: &T4,
    buffer_output_elements: &T5,
    prefetch_input_elements: &T6,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ParallelInterleaveDataset::new();
    op.call(
        ctx,
        input_dataset,
        other_arguments,
        cycle_length,
        block_length,
        sloppy,
        buffer_output_elements,
        prefetch_input_elements,
    )
}

/// ParallelInterleaveDatasetV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParallelInterleaveDatasetV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ParallelInterleaveDatasetV2 {
    f: ::std::option::Option<::std::string::String>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    sloppy: ::std::option::Option<bool>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ParallelInterleaveDatasetV2 {
    fn default() -> Self {
        Self {
            f: None,
            output_types: None,
            output_shapes: None,
            sloppy: Some(false),
            metadata: None,
            target_device_name: None,
        }
    }
}
impl ParallelInterleaveDatasetV2 {
    /// Creates a new `ParallelInterleaveDatasetV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `f` attribute.
    pub fn f<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.f = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `sloppy` attribute.
    pub fn sloppy<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.sloppy = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute parallel_interleave_dataset_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        other_arguments: &T1,
        cycle_length: &T2,
        block_length: &T3,
        num_parallel_calls: &T4,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ParallelInterleaveDatasetV2")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&other_arguments.to_handle(ctx)?)?;
        op.add_input(&cycle_length.to_handle(ctx)?)?;
        op.add_input(&block_length.to_handle(ctx)?)?;
        op.add_input(&num_parallel_calls.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.f {
            op.set_attr_string("f", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.sloppy {
            op.set_attr_bool("sloppy", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ParallelInterleaveDatasetV2::new().call(&ctx, &input_dataset, &other_arguments, &cycle_length, &block_length, &num_parallel_calls)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParallelInterleaveDatasetV2>
pub fn parallel_interleave_dataset_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    other_arguments: &T1,
    cycle_length: &T2,
    block_length: &T3,
    num_parallel_calls: &T4,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ParallelInterleaveDatasetV2::new();
    op.call(
        ctx,
        input_dataset,
        other_arguments,
        cycle_length,
        block_length,
        num_parallel_calls,
    )
}

/// ParallelInterleaveDatasetV3
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParallelInterleaveDatasetV3>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ParallelInterleaveDatasetV3 {
    f: ::std::option::Option<::std::string::String>,
    deterministic: ::std::option::Option<::std::string::String>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ParallelInterleaveDatasetV3 {
    fn default() -> Self {
        Self {
            f: None,
            deterministic: Some(::std::string::String::from("default")),
            output_types: None,
            output_shapes: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl ParallelInterleaveDatasetV3 {
    /// Creates a new `ParallelInterleaveDatasetV3`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `f` attribute.
    pub fn f<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.f = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `deterministic` attribute.
    pub fn deterministic<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.deterministic = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute parallel_interleave_dataset_v3.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        other_arguments: &T1,
        cycle_length: &T2,
        block_length: &T3,
        num_parallel_calls: &T4,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ParallelInterleaveDatasetV3")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&other_arguments.to_handle(ctx)?)?;
        op.add_input(&cycle_length.to_handle(ctx)?)?;
        op.add_input(&block_length.to_handle(ctx)?)?;
        op.add_input(&num_parallel_calls.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.f {
            op.set_attr_string("f", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.deterministic {
            op.set_attr_string("deterministic", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ParallelInterleaveDatasetV3::new().call(&ctx, &input_dataset, &other_arguments, &cycle_length, &block_length, &num_parallel_calls)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParallelInterleaveDatasetV3>
pub fn parallel_interleave_dataset_v3<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    other_arguments: &T1,
    cycle_length: &T2,
    block_length: &T3,
    num_parallel_calls: &T4,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ParallelInterleaveDatasetV3::new();
    op.call(
        ctx,
        input_dataset,
        other_arguments,
        cycle_length,
        block_length,
        num_parallel_calls,
    )
}

/// ParallelInterleaveDatasetV4
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParallelInterleaveDatasetV4>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ParallelInterleaveDatasetV4 {
    f: ::std::option::Option<::std::string::String>,
    deterministic: ::std::option::Option<::std::string::String>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ParallelInterleaveDatasetV4 {
    fn default() -> Self {
        Self {
            f: None,
            deterministic: Some(::std::string::String::from("default")),
            output_types: None,
            output_shapes: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl ParallelInterleaveDatasetV4 {
    /// Creates a new `ParallelInterleaveDatasetV4`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `f` attribute.
    pub fn f<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.f = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `deterministic` attribute.
    pub fn deterministic<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.deterministic = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute parallel_interleave_dataset_v4.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        other_arguments: &T1,
        cycle_length: &T2,
        block_length: &T3,
        buffer_output_elements: &T4,
        prefetch_input_elements: &T5,
        num_parallel_calls: &T6,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ParallelInterleaveDatasetV4")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&other_arguments.to_handle(ctx)?)?;
        op.add_input(&cycle_length.to_handle(ctx)?)?;
        op.add_input(&block_length.to_handle(ctx)?)?;
        op.add_input(&buffer_output_elements.to_handle(ctx)?)?;
        op.add_input(&prefetch_input_elements.to_handle(ctx)?)?;
        op.add_input(&num_parallel_calls.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.f {
            op.set_attr_string("f", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.deterministic {
            op.set_attr_string("deterministic", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ParallelInterleaveDatasetV4::new().call(&ctx, &input_dataset, &other_arguments, &cycle_length, &block_length, &buffer_output_elements, &prefetch_input_elements, &num_parallel_calls)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParallelInterleaveDatasetV4>
pub fn parallel_interleave_dataset_v4<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    other_arguments: &T1,
    cycle_length: &T2,
    block_length: &T3,
    buffer_output_elements: &T4,
    prefetch_input_elements: &T5,
    num_parallel_calls: &T6,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ParallelInterleaveDatasetV4::new();
    op.call(
        ctx,
        input_dataset,
        other_arguments,
        cycle_length,
        block_length,
        buffer_output_elements,
        prefetch_input_elements,
        num_parallel_calls,
    )
}

/// ParallelMapDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParallelMapDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ParallelMapDataset {
    f: ::std::option::Option<::std::string::String>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    use_inter_op_parallelism: ::std::option::Option<bool>,
    sloppy: ::std::option::Option<bool>,
    preserve_cardinality: ::std::option::Option<bool>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ParallelMapDataset {
    fn default() -> Self {
        Self {
            f: None,
            output_types: None,
            output_shapes: None,
            use_inter_op_parallelism: Some(true),
            sloppy: Some(false),
            preserve_cardinality: Some(false),
            metadata: None,
            target_device_name: None,
        }
    }
}
impl ParallelMapDataset {
    /// Creates a new `ParallelMapDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `f` attribute.
    pub fn f<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.f = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_inter_op_parallelism` attribute.
    pub fn use_inter_op_parallelism<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.use_inter_op_parallelism = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `sloppy` attribute.
    pub fn sloppy<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.sloppy = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `preserve_cardinality` attribute.
    pub fn preserve_cardinality<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.preserve_cardinality = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute parallel_map_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        other_arguments: &T1,
        num_parallel_calls: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ParallelMapDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&other_arguments.to_handle(ctx)?)?;
        op.add_input(&num_parallel_calls.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.f {
            op.set_attr_string("f", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_inter_op_parallelism {
            op.set_attr_bool("use_inter_op_parallelism", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.sloppy {
            op.set_attr_bool("sloppy", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.preserve_cardinality {
            op.set_attr_bool("preserve_cardinality", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ParallelMapDataset::new().call(&ctx, &input_dataset, &other_arguments, &num_parallel_calls)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParallelMapDataset>
pub fn parallel_map_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    other_arguments: &T1,
    num_parallel_calls: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ParallelMapDataset::new();
    op.call(ctx, input_dataset, other_arguments, num_parallel_calls)
}

/// ParallelMapDatasetV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParallelMapDatasetV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ParallelMapDatasetV2 {
    f: ::std::option::Option<::std::string::String>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    use_inter_op_parallelism: ::std::option::Option<bool>,
    deterministic: ::std::option::Option<::std::string::String>,
    preserve_cardinality: ::std::option::Option<bool>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ParallelMapDatasetV2 {
    fn default() -> Self {
        Self {
            f: None,
            output_types: None,
            output_shapes: None,
            use_inter_op_parallelism: Some(true),
            deterministic: Some(::std::string::String::from("default")),
            preserve_cardinality: Some(false),
            metadata: None,
            target_device_name: None,
        }
    }
}
impl ParallelMapDatasetV2 {
    /// Creates a new `ParallelMapDatasetV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `f` attribute.
    pub fn f<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.f = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_inter_op_parallelism` attribute.
    pub fn use_inter_op_parallelism<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.use_inter_op_parallelism = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `deterministic` attribute.
    pub fn deterministic<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.deterministic = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `preserve_cardinality` attribute.
    pub fn preserve_cardinality<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.preserve_cardinality = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute parallel_map_dataset_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        other_arguments: &T1,
        num_parallel_calls: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ParallelMapDatasetV2")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&other_arguments.to_handle(ctx)?)?;
        op.add_input(&num_parallel_calls.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.f {
            op.set_attr_string("f", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_inter_op_parallelism {
            op.set_attr_bool("use_inter_op_parallelism", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.deterministic {
            op.set_attr_string("deterministic", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.preserve_cardinality {
            op.set_attr_bool("preserve_cardinality", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ParallelMapDatasetV2::new().call(&ctx, &input_dataset, &other_arguments, &num_parallel_calls)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParallelMapDatasetV2>
pub fn parallel_map_dataset_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    other_arguments: &T1,
    num_parallel_calls: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ParallelMapDatasetV2::new();
    op.call(ctx, input_dataset, other_arguments, num_parallel_calls)
}

/// ParameterizedTruncatedNormal
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParameterizedTruncatedNormal>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ParameterizedTruncatedNormal {
    seed: ::std::option::Option<i64>,
    seed2: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ParameterizedTruncatedNormal {
    fn default() -> Self {
        Self {
            seed: Some(0i64),
            seed2: Some(0i64),
            target_device_name: None,
        }
    }
}
impl ParameterizedTruncatedNormal {
    /// Creates a new `ParameterizedTruncatedNormal`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `seed` attribute.
    pub fn seed<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed2` attribute.
    pub fn seed2<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute parameterized_truncated_normal.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        shape: &T0,
        means: &T1,
        stdevs: &T2,
        minvals: &T3,
        maxvals: &T4,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ParameterizedTruncatedNormal")?;

        // Required input arguments
        op.add_input(&shape.to_handle(ctx)?)?;
        op.add_input(&means.to_handle(ctx)?)?;
        op.add_input(&stdevs.to_handle(ctx)?)?;
        op.add_input(&minvals.to_handle(ctx)?)?;
        op.add_input(&maxvals.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.seed {
            op.set_attr_int("seed", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed2 {
            op.set_attr_int("seed2", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ParameterizedTruncatedNormal::new().call(&ctx, &shape, &means, &stdevs, &minvals, &maxvals)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParameterizedTruncatedNormal>
pub fn parameterized_truncated_normal<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    shape: &T0,
    means: &T1,
    stdevs: &T2,
    minvals: &T3,
    maxvals: &T4,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ParameterizedTruncatedNormal::new();
    op.call(ctx, shape, means, stdevs, minvals, maxvals)
}

/// ParseExample
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParseExample>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ParseExample {
    sparse_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    dense_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ParseExample {
    fn default() -> Self {
        Self {
            sparse_types: None,
            dense_shapes: None,
            target_device_name: None,
        }
    }
}
impl ParseExample {
    /// Creates a new `ParseExample`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `sparse_types` attribute.
    pub fn sparse_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.sparse_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dense_shapes` attribute.
    pub fn dense_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dense_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute parse_example.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        serialized: &T0,
        names: &T1,
        sparse_keys: &[&T2],
        dense_keys: &[&T3],
        dense_defaults: &T4,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 4]> {
        // Define Op
        let mut op = super::Op::new(ctx, "ParseExample")?;

        // Required input arguments
        op.add_input(&serialized.to_handle(ctx)?)?;
        op.add_input(&names.to_handle(ctx)?)?;
        let mut sparse_keys_list = Vec::new();

        for t in sparse_keys {
            sparse_keys_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&sparse_keys_list)?;
        let mut dense_keys_list = Vec::new();

        for t in dense_keys {
            dense_keys_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&dense_keys_list)?;
        op.add_input(&dense_defaults.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.sparse_types {
            op.set_attr_type_list("sparse_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dense_shapes {
            op.set_attr_shape_list("dense_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<4>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `ParseExample::new().call(&ctx, &serialized, &names, &sparse_keys, &dense_keys, &dense_defaults)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParseExample>
pub fn parse_example<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    serialized: &T0,
    names: &T1,
    sparse_keys: &[&T2],
    dense_keys: &[&T3],
    dense_defaults: &T4,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 4]> {
    let op = ParseExample::new();
    op.call(
        ctx,
        serialized,
        names,
        sparse_keys,
        dense_keys,
        dense_defaults,
    )
}

/// ParseExampleDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParseExampleDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ParseExampleDataset {
    sparse_keys: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    dense_keys: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    sparse_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    dense_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    sloppy: ::std::option::Option<bool>,
    ragged_keys: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    ragged_value_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    ragged_split_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ParseExampleDataset {
    fn default() -> Self {
        Self {
            sparse_keys: None,
            dense_keys: None,
            sparse_types: None,
            dense_shapes: None,
            output_types: None,
            output_shapes: None,
            sloppy: Some(false),
            ragged_keys: Some(vec![]),
            ragged_value_types: Some(vec![]),
            ragged_split_types: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl ParseExampleDataset {
    /// Creates a new `ParseExampleDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `sparse_keys` attribute.
    pub fn sparse_keys<ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.sparse_keys = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dense_keys` attribute.
    pub fn dense_keys<ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dense_keys = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `sparse_types` attribute.
    pub fn sparse_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.sparse_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dense_shapes` attribute.
    pub fn dense_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dense_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `sloppy` attribute.
    pub fn sloppy<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.sloppy = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `ragged_keys` attribute.
    pub fn ragged_keys<ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.ragged_keys = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `ragged_value_types` attribute.
    pub fn ragged_value_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.ragged_value_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `ragged_split_types` attribute.
    pub fn ragged_split_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.ragged_split_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute parse_example_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        num_parallel_calls: &T1,
        dense_defaults: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ParseExampleDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&num_parallel_calls.to_handle(ctx)?)?;
        op.add_input(&dense_defaults.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.sparse_keys {
            op.set_attr_string_list("sparse_keys", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dense_keys {
            op.set_attr_string_list("dense_keys", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.sparse_types {
            op.set_attr_type_list("sparse_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dense_shapes {
            op.set_attr_shape_list("dense_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.sloppy {
            op.set_attr_bool("sloppy", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.ragged_keys {
            op.set_attr_string_list("ragged_keys", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.ragged_value_types {
            op.set_attr_type_list("ragged_value_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.ragged_split_types {
            op.set_attr_type_list("ragged_split_types", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ParseExampleDataset::new().call(&ctx, &input_dataset, &num_parallel_calls, &dense_defaults)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParseExampleDataset>
pub fn parse_example_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    num_parallel_calls: &T1,
    dense_defaults: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ParseExampleDataset::new();
    op.call(ctx, input_dataset, num_parallel_calls, dense_defaults)
}

/// ParseExampleDatasetV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParseExampleDatasetV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ParseExampleDatasetV2 {
    sparse_keys: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    dense_keys: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    sparse_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    dense_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    deterministic: ::std::option::Option<::std::string::String>,
    ragged_keys: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    ragged_value_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    ragged_split_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ParseExampleDatasetV2 {
    fn default() -> Self {
        Self {
            sparse_keys: None,
            dense_keys: None,
            sparse_types: None,
            dense_shapes: None,
            output_types: None,
            output_shapes: None,
            deterministic: Some(::std::string::String::from("default")),
            ragged_keys: Some(vec![]),
            ragged_value_types: Some(vec![]),
            ragged_split_types: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl ParseExampleDatasetV2 {
    /// Creates a new `ParseExampleDatasetV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `sparse_keys` attribute.
    pub fn sparse_keys<ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.sparse_keys = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dense_keys` attribute.
    pub fn dense_keys<ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dense_keys = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `sparse_types` attribute.
    pub fn sparse_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.sparse_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dense_shapes` attribute.
    pub fn dense_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dense_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `deterministic` attribute.
    pub fn deterministic<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.deterministic = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `ragged_keys` attribute.
    pub fn ragged_keys<ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.ragged_keys = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `ragged_value_types` attribute.
    pub fn ragged_value_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.ragged_value_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `ragged_split_types` attribute.
    pub fn ragged_split_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.ragged_split_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute parse_example_dataset_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        num_parallel_calls: &T1,
        dense_defaults: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ParseExampleDatasetV2")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&num_parallel_calls.to_handle(ctx)?)?;
        op.add_input(&dense_defaults.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.sparse_keys {
            op.set_attr_string_list("sparse_keys", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dense_keys {
            op.set_attr_string_list("dense_keys", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.sparse_types {
            op.set_attr_type_list("sparse_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dense_shapes {
            op.set_attr_shape_list("dense_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.deterministic {
            op.set_attr_string("deterministic", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.ragged_keys {
            op.set_attr_string_list("ragged_keys", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.ragged_value_types {
            op.set_attr_type_list("ragged_value_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.ragged_split_types {
            op.set_attr_type_list("ragged_split_types", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ParseExampleDatasetV2::new().call(&ctx, &input_dataset, &num_parallel_calls, &dense_defaults)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParseExampleDatasetV2>
pub fn parse_example_dataset_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    num_parallel_calls: &T1,
    dense_defaults: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ParseExampleDatasetV2::new();
    op.call(ctx, input_dataset, num_parallel_calls, dense_defaults)
}

/// ParseExampleV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParseExampleV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ParseExampleV2 {
    num_sparse: ::std::option::Option<i64>,
    sparse_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    ragged_value_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    ragged_split_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    dense_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ParseExampleV2 {
    fn default() -> Self {
        Self {
            num_sparse: None,
            sparse_types: None,
            ragged_value_types: None,
            ragged_split_types: None,
            dense_shapes: None,
            target_device_name: None,
        }
    }
}
impl ParseExampleV2 {
    /// Creates a new `ParseExampleV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_sparse` attribute.
    pub fn num_sparse<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_sparse = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `sparse_types` attribute.
    pub fn sparse_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.sparse_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `ragged_value_types` attribute.
    pub fn ragged_value_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.ragged_value_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `ragged_split_types` attribute.
    pub fn ragged_split_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.ragged_split_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dense_shapes` attribute.
    pub fn dense_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dense_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute parse_example_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        serialized: &T0,
        names: &T1,
        sparse_keys: &T2,
        dense_keys: &T3,
        ragged_keys: &T4,
        dense_defaults: &T5,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 6]> {
        // Define Op
        let mut op = super::Op::new(ctx, "ParseExampleV2")?;

        // Required input arguments
        op.add_input(&serialized.to_handle(ctx)?)?;
        op.add_input(&names.to_handle(ctx)?)?;
        op.add_input(&sparse_keys.to_handle(ctx)?)?;
        op.add_input(&dense_keys.to_handle(ctx)?)?;
        op.add_input(&ragged_keys.to_handle(ctx)?)?;
        op.add_input(&dense_defaults.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_sparse {
            op.set_attr_int("num_sparse", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.sparse_types {
            op.set_attr_type_list("sparse_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.ragged_value_types {
            op.set_attr_type_list("ragged_value_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.ragged_split_types {
            op.set_attr_type_list("ragged_split_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dense_shapes {
            op.set_attr_shape_list("dense_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<6>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `ParseExampleV2::new().call(&ctx, &serialized, &names, &sparse_keys, &dense_keys, &ragged_keys, &dense_defaults)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParseExampleV2>
pub fn parse_example_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    serialized: &T0,
    names: &T1,
    sparse_keys: &T2,
    dense_keys: &T3,
    ragged_keys: &T4,
    dense_defaults: &T5,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 6]> {
    let op = ParseExampleV2::new();
    op.call(
        ctx,
        serialized,
        names,
        sparse_keys,
        dense_keys,
        ragged_keys,
        dense_defaults,
    )
}

/// ParseSequenceExample
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParseSequenceExample>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ParseSequenceExample {
    feature_list_dense_missing_assumed_empty:
        ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    context_sparse_keys: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    context_dense_keys: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    feature_list_sparse_keys: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    feature_list_dense_keys: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    Ncontext_sparse: ::std::option::Option<i64>,
    Ncontext_dense: ::std::option::Option<i64>,
    Nfeature_list_sparse: ::std::option::Option<i64>,
    Nfeature_list_dense: ::std::option::Option<i64>,
    context_sparse_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    feature_list_dense_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    context_dense_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    feature_list_sparse_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    feature_list_dense_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ParseSequenceExample {
    fn default() -> Self {
        Self {
            feature_list_dense_missing_assumed_empty: None,
            context_sparse_keys: None,
            context_dense_keys: None,
            feature_list_sparse_keys: None,
            feature_list_dense_keys: None,
            Ncontext_sparse: Some(0i64),
            Ncontext_dense: Some(0i64),
            Nfeature_list_sparse: Some(0i64),
            Nfeature_list_dense: Some(0i64),
            context_sparse_types: Some(vec![]),
            feature_list_dense_types: Some(vec![]),
            context_dense_shapes: Some(vec![]),
            feature_list_sparse_types: Some(vec![]),
            feature_list_dense_shapes: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl ParseSequenceExample {
    /// Creates a new `ParseSequenceExample`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `feature_list_dense_missing_assumed_empty` attribute.
    pub fn feature_list_dense_missing_assumed_empty<
        ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>,
    >(
        mut self,
        value: ArgType,
    ) -> Self {
        self.feature_list_dense_missing_assumed_empty = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `context_sparse_keys` attribute.
    pub fn context_sparse_keys<
        ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>,
    >(
        mut self,
        value: ArgType,
    ) -> Self {
        self.context_sparse_keys = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `context_dense_keys` attribute.
    pub fn context_dense_keys<
        ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>,
    >(
        mut self,
        value: ArgType,
    ) -> Self {
        self.context_dense_keys = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `feature_list_sparse_keys` attribute.
    pub fn feature_list_sparse_keys<
        ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>,
    >(
        mut self,
        value: ArgType,
    ) -> Self {
        self.feature_list_sparse_keys = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `feature_list_dense_keys` attribute.
    pub fn feature_list_dense_keys<
        ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>,
    >(
        mut self,
        value: ArgType,
    ) -> Self {
        self.feature_list_dense_keys = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `Ncontext_sparse` attribute.
    pub fn Ncontext_sparse<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.Ncontext_sparse = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `Ncontext_dense` attribute.
    pub fn Ncontext_dense<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.Ncontext_dense = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `Nfeature_list_sparse` attribute.
    pub fn Nfeature_list_sparse<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Nfeature_list_sparse = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `Nfeature_list_dense` attribute.
    pub fn Nfeature_list_dense<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Nfeature_list_dense = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `context_sparse_types` attribute.
    pub fn context_sparse_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.context_sparse_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `feature_list_dense_types` attribute.
    pub fn feature_list_dense_types<
        ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>,
    >(
        mut self,
        value: ArgType,
    ) -> Self {
        self.feature_list_dense_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `context_dense_shapes` attribute.
    pub fn context_dense_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.context_dense_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `feature_list_sparse_types` attribute.
    pub fn feature_list_sparse_types<
        ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>,
    >(
        mut self,
        value: ArgType,
    ) -> Self {
        self.feature_list_sparse_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `feature_list_dense_shapes` attribute.
    pub fn feature_list_dense_shapes<
        ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>,
    >(
        mut self,
        value: ArgType,
    ) -> Self {
        self.feature_list_dense_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute parse_sequence_example.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        serialized: &T0,
        debug_name: &T1,
        context_dense_defaults: &T2,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 9]> {
        // Define Op
        let mut op = super::Op::new(ctx, "ParseSequenceExample")?;

        // Required input arguments
        op.add_input(&serialized.to_handle(ctx)?)?;
        op.add_input(&debug_name.to_handle(ctx)?)?;
        op.add_input(&context_dense_defaults.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.feature_list_dense_missing_assumed_empty {
            op.set_attr_string_list("feature_list_dense_missing_assumed_empty", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.context_sparse_keys {
            op.set_attr_string_list("context_sparse_keys", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.context_dense_keys {
            op.set_attr_string_list("context_dense_keys", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.feature_list_sparse_keys {
            op.set_attr_string_list("feature_list_sparse_keys", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.feature_list_dense_keys {
            op.set_attr_string_list("feature_list_dense_keys", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.Ncontext_sparse {
            op.set_attr_int("Ncontext_sparse", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.Ncontext_dense {
            op.set_attr_int("Ncontext_dense", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.Nfeature_list_sparse {
            op.set_attr_int("Nfeature_list_sparse", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.Nfeature_list_dense {
            op.set_attr_int("Nfeature_list_dense", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.context_sparse_types {
            op.set_attr_type_list("context_sparse_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.feature_list_dense_types {
            op.set_attr_type_list("feature_list_dense_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.context_dense_shapes {
            op.set_attr_shape_list("context_dense_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.feature_list_sparse_types {
            op.set_attr_type_list("feature_list_sparse_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.feature_list_dense_shapes {
            op.set_attr_shape_list("feature_list_dense_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<9>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `ParseSequenceExample::new().call(&ctx, &serialized, &debug_name, &context_dense_defaults)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParseSequenceExample>
pub fn parse_sequence_example<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    serialized: &T0,
    debug_name: &T1,
    context_dense_defaults: &T2,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 9]> {
    let op = ParseSequenceExample::new();
    op.call(ctx, serialized, debug_name, context_dense_defaults)
}

/// ParseSequenceExampleV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParseSequenceExampleV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ParseSequenceExampleV2 {
    Ncontext_sparse: ::std::option::Option<i64>,
    context_sparse_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    context_ragged_value_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    context_ragged_split_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    context_dense_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    Nfeature_list_sparse: ::std::option::Option<i64>,
    Nfeature_list_dense: ::std::option::Option<i64>,
    feature_list_dense_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    feature_list_sparse_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    feature_list_ragged_value_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    feature_list_ragged_split_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    feature_list_dense_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ParseSequenceExampleV2 {
    fn default() -> Self {
        Self {
            Ncontext_sparse: Some(0i64),
            context_sparse_types: Some(vec![]),
            context_ragged_value_types: Some(vec![]),
            context_ragged_split_types: Some(vec![]),
            context_dense_shapes: Some(vec![]),
            Nfeature_list_sparse: Some(0i64),
            Nfeature_list_dense: Some(0i64),
            feature_list_dense_types: Some(vec![]),
            feature_list_sparse_types: Some(vec![]),
            feature_list_ragged_value_types: Some(vec![]),
            feature_list_ragged_split_types: Some(vec![]),
            feature_list_dense_shapes: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl ParseSequenceExampleV2 {
    /// Creates a new `ParseSequenceExampleV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Ncontext_sparse` attribute.
    pub fn Ncontext_sparse<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.Ncontext_sparse = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `context_sparse_types` attribute.
    pub fn context_sparse_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.context_sparse_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `context_ragged_value_types` attribute.
    pub fn context_ragged_value_types<
        ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>,
    >(
        mut self,
        value: ArgType,
    ) -> Self {
        self.context_ragged_value_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `context_ragged_split_types` attribute.
    pub fn context_ragged_split_types<
        ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>,
    >(
        mut self,
        value: ArgType,
    ) -> Self {
        self.context_ragged_split_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `context_dense_shapes` attribute.
    pub fn context_dense_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.context_dense_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `Nfeature_list_sparse` attribute.
    pub fn Nfeature_list_sparse<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Nfeature_list_sparse = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `Nfeature_list_dense` attribute.
    pub fn Nfeature_list_dense<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Nfeature_list_dense = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `feature_list_dense_types` attribute.
    pub fn feature_list_dense_types<
        ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>,
    >(
        mut self,
        value: ArgType,
    ) -> Self {
        self.feature_list_dense_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `feature_list_sparse_types` attribute.
    pub fn feature_list_sparse_types<
        ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>,
    >(
        mut self,
        value: ArgType,
    ) -> Self {
        self.feature_list_sparse_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `feature_list_ragged_value_types` attribute.
    pub fn feature_list_ragged_value_types<
        ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>,
    >(
        mut self,
        value: ArgType,
    ) -> Self {
        self.feature_list_ragged_value_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `feature_list_ragged_split_types` attribute.
    pub fn feature_list_ragged_split_types<
        ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>,
    >(
        mut self,
        value: ArgType,
    ) -> Self {
        self.feature_list_ragged_split_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `feature_list_dense_shapes` attribute.
    pub fn feature_list_dense_shapes<
        ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>,
    >(
        mut self,
        value: ArgType,
    ) -> Self {
        self.feature_list_dense_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute parse_sequence_example_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
        T9: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        serialized: &T0,
        debug_name: &T1,
        context_sparse_keys: &T2,
        context_dense_keys: &T3,
        context_ragged_keys: &T4,
        feature_list_sparse_keys: &T5,
        feature_list_dense_keys: &T6,
        feature_list_ragged_keys: &T7,
        feature_list_dense_missing_assumed_empty: &T8,
        context_dense_defaults: &T9,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 14]> {
        // Define Op
        let mut op = super::Op::new(ctx, "ParseSequenceExampleV2")?;

        // Required input arguments
        op.add_input(&serialized.to_handle(ctx)?)?;
        op.add_input(&debug_name.to_handle(ctx)?)?;
        op.add_input(&context_sparse_keys.to_handle(ctx)?)?;
        op.add_input(&context_dense_keys.to_handle(ctx)?)?;
        op.add_input(&context_ragged_keys.to_handle(ctx)?)?;
        op.add_input(&feature_list_sparse_keys.to_handle(ctx)?)?;
        op.add_input(&feature_list_dense_keys.to_handle(ctx)?)?;
        op.add_input(&feature_list_ragged_keys.to_handle(ctx)?)?;
        op.add_input(&feature_list_dense_missing_assumed_empty.to_handle(ctx)?)?;
        op.add_input(&context_dense_defaults.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Ncontext_sparse {
            op.set_attr_int("Ncontext_sparse", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.context_sparse_types {
            op.set_attr_type_list("context_sparse_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.context_ragged_value_types {
            op.set_attr_type_list("context_ragged_value_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.context_ragged_split_types {
            op.set_attr_type_list("context_ragged_split_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.context_dense_shapes {
            op.set_attr_shape_list("context_dense_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.Nfeature_list_sparse {
            op.set_attr_int("Nfeature_list_sparse", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.Nfeature_list_dense {
            op.set_attr_int("Nfeature_list_dense", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.feature_list_dense_types {
            op.set_attr_type_list("feature_list_dense_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.feature_list_sparse_types {
            op.set_attr_type_list("feature_list_sparse_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.feature_list_ragged_value_types {
            op.set_attr_type_list("feature_list_ragged_value_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.feature_list_ragged_split_types {
            op.set_attr_type_list("feature_list_ragged_split_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.feature_list_dense_shapes {
            op.set_attr_shape_list("feature_list_dense_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<14>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `ParseSequenceExampleV2::new().call(&ctx, &serialized, &debug_name, &context_sparse_keys, &context_dense_keys, &context_ragged_keys, &feature_list_sparse_keys, &feature_list_dense_keys, &feature_list_ragged_keys, &feature_list_dense_missing_assumed_empty, &context_dense_defaults)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParseSequenceExampleV2>
pub fn parse_sequence_example_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
    T9: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    serialized: &T0,
    debug_name: &T1,
    context_sparse_keys: &T2,
    context_dense_keys: &T3,
    context_ragged_keys: &T4,
    feature_list_sparse_keys: &T5,
    feature_list_dense_keys: &T6,
    feature_list_ragged_keys: &T7,
    feature_list_dense_missing_assumed_empty: &T8,
    context_dense_defaults: &T9,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 14]> {
    let op = ParseSequenceExampleV2::new();
    op.call(
        ctx,
        serialized,
        debug_name,
        context_sparse_keys,
        context_dense_keys,
        context_ragged_keys,
        feature_list_sparse_keys,
        feature_list_dense_keys,
        feature_list_ragged_keys,
        feature_list_dense_missing_assumed_empty,
        context_dense_defaults,
    )
}

/// ParseSingleExample
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParseSingleExample>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ParseSingleExample {
    num_sparse: ::std::option::Option<i64>,
    sparse_keys: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    dense_keys: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    sparse_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    dense_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ParseSingleExample {
    fn default() -> Self {
        Self {
            num_sparse: None,
            sparse_keys: None,
            dense_keys: None,
            sparse_types: None,
            dense_shapes: None,
            target_device_name: None,
        }
    }
}
impl ParseSingleExample {
    /// Creates a new `ParseSingleExample`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_sparse` attribute.
    pub fn num_sparse<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_sparse = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `sparse_keys` attribute.
    pub fn sparse_keys<ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.sparse_keys = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dense_keys` attribute.
    pub fn dense_keys<ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dense_keys = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `sparse_types` attribute.
    pub fn sparse_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.sparse_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dense_shapes` attribute.
    pub fn dense_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dense_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute parse_single_example.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        serialized: &T0,
        dense_defaults: &T1,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 4]> {
        // Define Op
        let mut op = super::Op::new(ctx, "ParseSingleExample")?;

        // Required input arguments
        op.add_input(&serialized.to_handle(ctx)?)?;
        op.add_input(&dense_defaults.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_sparse {
            op.set_attr_int("num_sparse", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.sparse_keys {
            op.set_attr_string_list("sparse_keys", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dense_keys {
            op.set_attr_string_list("dense_keys", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.sparse_types {
            op.set_attr_type_list("sparse_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dense_shapes {
            op.set_attr_shape_list("dense_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<4>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `ParseSingleExample::new().call(&ctx, &serialized, &dense_defaults)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParseSingleExample>
pub fn parse_single_example<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    serialized: &T0,
    dense_defaults: &T1,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 4]> {
    let op = ParseSingleExample::new();
    op.call(ctx, serialized, dense_defaults)
}

/// ParseSingleSequenceExample
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParseSingleSequenceExample>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ParseSingleSequenceExample {
    context_sparse_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    feature_list_dense_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    context_dense_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    feature_list_sparse_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    feature_list_dense_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ParseSingleSequenceExample {
    fn default() -> Self {
        Self {
            context_sparse_types: Some(vec![]),
            feature_list_dense_types: Some(vec![]),
            context_dense_shapes: Some(vec![]),
            feature_list_sparse_types: Some(vec![]),
            feature_list_dense_shapes: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl ParseSingleSequenceExample {
    /// Creates a new `ParseSingleSequenceExample`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `context_sparse_types` attribute.
    pub fn context_sparse_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.context_sparse_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `feature_list_dense_types` attribute.
    pub fn feature_list_dense_types<
        ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>,
    >(
        mut self,
        value: ArgType,
    ) -> Self {
        self.feature_list_dense_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `context_dense_shapes` attribute.
    pub fn context_dense_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.context_dense_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `feature_list_sparse_types` attribute.
    pub fn feature_list_sparse_types<
        ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>,
    >(
        mut self,
        value: ArgType,
    ) -> Self {
        self.feature_list_sparse_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `feature_list_dense_shapes` attribute.
    pub fn feature_list_dense_shapes<
        ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>,
    >(
        mut self,
        value: ArgType,
    ) -> Self {
        self.feature_list_dense_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute parse_single_sequence_example.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        serialized: &T0,
        feature_list_dense_missing_assumed_empty: &T1,
        context_sparse_keys: &[&T2],
        context_dense_keys: &[&T3],
        feature_list_sparse_keys: &[&T4],
        feature_list_dense_keys: &[&T5],
        context_dense_defaults: &T6,
        debug_name: &T7,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 8]> {
        // Define Op
        let mut op = super::Op::new(ctx, "ParseSingleSequenceExample")?;

        // Required input arguments
        op.add_input(&serialized.to_handle(ctx)?)?;
        op.add_input(&feature_list_dense_missing_assumed_empty.to_handle(ctx)?)?;
        let mut context_sparse_keys_list = Vec::new();

        for t in context_sparse_keys {
            context_sparse_keys_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&context_sparse_keys_list)?;
        let mut context_dense_keys_list = Vec::new();

        for t in context_dense_keys {
            context_dense_keys_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&context_dense_keys_list)?;
        let mut feature_list_sparse_keys_list = Vec::new();

        for t in feature_list_sparse_keys {
            feature_list_sparse_keys_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&feature_list_sparse_keys_list)?;
        let mut feature_list_dense_keys_list = Vec::new();

        for t in feature_list_dense_keys {
            feature_list_dense_keys_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&feature_list_dense_keys_list)?;
        op.add_input(&context_dense_defaults.to_handle(ctx)?)?;
        op.add_input(&debug_name.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.context_sparse_types {
            op.set_attr_type_list("context_sparse_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.feature_list_dense_types {
            op.set_attr_type_list("feature_list_dense_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.context_dense_shapes {
            op.set_attr_shape_list("context_dense_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.feature_list_sparse_types {
            op.set_attr_type_list("feature_list_sparse_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.feature_list_dense_shapes {
            op.set_attr_shape_list("feature_list_dense_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<8>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `ParseSingleSequenceExample::new().call(&ctx, &serialized, &feature_list_dense_missing_assumed_empty, &context_sparse_keys, &context_dense_keys, &feature_list_sparse_keys, &feature_list_dense_keys, &context_dense_defaults, &debug_name)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParseSingleSequenceExample>
pub fn parse_single_sequence_example<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    serialized: &T0,
    feature_list_dense_missing_assumed_empty: &T1,
    context_sparse_keys: &[&T2],
    context_dense_keys: &[&T3],
    feature_list_sparse_keys: &[&T4],
    feature_list_dense_keys: &[&T5],
    context_dense_defaults: &T6,
    debug_name: &T7,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 8]> {
    let op = ParseSingleSequenceExample::new();
    op.call(
        ctx,
        serialized,
        feature_list_dense_missing_assumed_empty,
        context_sparse_keys,
        context_dense_keys,
        feature_list_sparse_keys,
        feature_list_dense_keys,
        context_dense_defaults,
        debug_name,
    )
}

/// ParseTensor
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParseTensor>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ParseTensor {
    out_type: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ParseTensor {
    fn default() -> Self {
        Self {
            out_type: None,
            target_device_name: None,
        }
    }
}
impl ParseTensor {
    /// Creates a new `ParseTensor`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_type` attribute.
    pub fn out_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute parse_tensor.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        serialized: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ParseTensor")?;

        // Required input arguments
        op.add_input(&serialized.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_type {
            op.set_attr_type("out_type", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ParseTensor::new().call(&ctx, &serialized)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ParseTensor>
pub fn parse_tensor<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    serialized: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ParseTensor::new();
    op.call(ctx, serialized)
}

/// PartitionedCall
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/PartitionedCall>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct PartitionedCall {
    Tout: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    f: ::std::option::Option<::std::string::String>,
    config: ::std::option::Option<::std::string::String>,
    config_proto: ::std::option::Option<::std::string::String>,
    executor_type: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for PartitionedCall {
    fn default() -> Self {
        Self {
            Tout: None,
            f: None,
            config: None,
            config_proto: None,
            executor_type: None,
            target_device_name: None,
        }
    }
}
impl PartitionedCall {
    /// Creates a new `PartitionedCall`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Tout` attribute.
    pub fn Tout<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Tout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `f` attribute.
    pub fn f<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.f = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `config_proto` attribute.
    pub fn config_proto<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config_proto = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `executor_type` attribute.
    pub fn executor_type<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.executor_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute partitioned_call.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        args: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "PartitionedCall")?;

        // Required input arguments
        op.add_input(&args.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Tout {
            op.set_attr_type_list("Tout", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.f {
            op.set_attr_string("f", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.config_proto {
            op.set_attr_string("config_proto", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.executor_type {
            op.set_attr_string("executor_type", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `PartitionedCall::new().call(&ctx, &args)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/PartitionedCall>
pub fn partitioned_call<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    args: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = PartitionedCall::new();
    op.call(ctx, args)
}

/// Placeholder
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Placeholder>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Placeholder {
    dtype: ::std::option::Option<crate::DataType>,
    shape: ::std::option::Option<crate::Shape>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Placeholder {
    fn default() -> Self {
        Self {
            dtype: None,
            shape: None,
            target_device_name: None,
        }
    }
}
impl Placeholder {
    /// Creates a new `Placeholder`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shape` attribute.
    pub fn shape<ArgType: ::std::convert::Into<crate::Shape>>(mut self, value: ArgType) -> Self {
        self.shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute placeholder.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Placeholder")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shape {
            op.set_attr_shape("shape", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Placeholder::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Placeholder>
pub fn placeholder<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Placeholder::new();
    op.call(ctx)
}

/// PlaceholderV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/PlaceholderV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct PlaceholderV2 {
    dtype: ::std::option::Option<crate::DataType>,
    shape: ::std::option::Option<crate::Shape>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for PlaceholderV2 {
    fn default() -> Self {
        Self {
            dtype: None,
            shape: None,
            target_device_name: None,
        }
    }
}
impl PlaceholderV2 {
    /// Creates a new `PlaceholderV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shape` attribute.
    pub fn shape<ArgType: ::std::convert::Into<crate::Shape>>(mut self, value: ArgType) -> Self {
        self.shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute placeholder_v2.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "PlaceholderV2")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shape {
            op.set_attr_shape("shape", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `PlaceholderV2::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/PlaceholderV2>
pub fn placeholder_v2<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = PlaceholderV2::new();
    op.call(ctx)
}

/// PlaceholderWithDefault
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/PlaceholderWithDefault>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct PlaceholderWithDefault {
    shape: ::std::option::Option<crate::Shape>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for PlaceholderWithDefault {
    fn default() -> Self {
        Self {
            shape: None,
            target_device_name: None,
        }
    }
}
impl PlaceholderWithDefault {
    /// Creates a new `PlaceholderWithDefault`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `shape` attribute.
    pub fn shape<ArgType: ::std::convert::Into<crate::Shape>>(mut self, value: ArgType) -> Self {
        self.shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute placeholder_with_default.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "PlaceholderWithDefault")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.shape {
            op.set_attr_shape("shape", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `PlaceholderWithDefault::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/PlaceholderWithDefault>
pub fn placeholder_with_default<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = PlaceholderWithDefault::new();
    op.call(ctx, input)
}

/// Polygamma
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Polygamma>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Polygamma {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Polygamma {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Polygamma {
    /// Creates a new `Polygamma`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute polygamma.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        a: &T0,
        x: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Polygamma")?;

        // Required input arguments
        op.add_input(&a.to_handle(ctx)?)?;
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Polygamma::new().call(&ctx, &a, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Polygamma>
pub fn polygamma<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    a: &T0,
    x: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Polygamma::new();
    op.call(ctx, a, x)
}

/// PopulationCount
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/PopulationCount>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct PopulationCount {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for PopulationCount {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl PopulationCount {
    /// Creates a new `PopulationCount`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute population_count.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "PopulationCount")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `PopulationCount::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/PopulationCount>
pub fn population_count<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = PopulationCount::new();
    op.call(ctx, x)
}

/// Pow
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Pow>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Pow {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Pow {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Pow {
    /// Creates a new `Pow`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute pow.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Pow")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Pow::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Pow>
pub fn pow<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Pow::new();
    op.call(ctx, x, y)
}

/// PrefetchDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/PrefetchDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct PrefetchDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    slack_period: ::std::option::Option<i64>,
    legacy_autotune: ::std::option::Option<bool>,
    buffer_size_min: ::std::option::Option<i64>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for PrefetchDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            slack_period: Some(0i64),
            legacy_autotune: Some(true),
            buffer_size_min: Some(0i64),
            metadata: None,
            target_device_name: None,
        }
    }
}
impl PrefetchDataset {
    /// Creates a new `PrefetchDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `slack_period` attribute.
    pub fn slack_period<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.slack_period = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `legacy_autotune` attribute.
    pub fn legacy_autotune<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.legacy_autotune = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `buffer_size_min` attribute.
    pub fn buffer_size_min<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.buffer_size_min = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute prefetch_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        buffer_size: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "PrefetchDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&buffer_size.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.slack_period {
            op.set_attr_int("slack_period", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.legacy_autotune {
            op.set_attr_bool("legacy_autotune", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.buffer_size_min {
            op.set_attr_int("buffer_size_min", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `PrefetchDataset::new().call(&ctx, &input_dataset, &buffer_size)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/PrefetchDataset>
pub fn prefetch_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    buffer_size: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = PrefetchDataset::new();
    op.call(ctx, input_dataset, buffer_size)
}

/// Prelinearize
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Prelinearize>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Prelinearize {
    shape: ::std::option::Option<crate::Shape>,
    layout: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Prelinearize {
    fn default() -> Self {
        Self {
            shape: None,
            layout: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl Prelinearize {
    /// Creates a new `Prelinearize`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `shape` attribute.
    pub fn shape<ArgType: ::std::convert::Into<crate::Shape>>(mut self, value: ArgType) -> Self {
        self.shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `layout` attribute.
    pub fn layout<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.layout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute prelinearize.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Prelinearize")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.shape {
            op.set_attr_shape("shape", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.layout {
            op.set_attr_int_list("layout", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Prelinearize::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Prelinearize>
pub fn prelinearize<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Prelinearize::new();
    op.call(ctx, input)
}

/// PrelinearizeTuple
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/PrelinearizeTuple>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct PrelinearizeTuple {
    shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    layouts: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for PrelinearizeTuple {
    fn default() -> Self {
        Self {
            shapes: None,
            layouts: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl PrelinearizeTuple {
    /// Creates a new `PrelinearizeTuple`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `shapes` attribute.
    pub fn shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `layouts` attribute.
    pub fn layouts<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.layouts = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute prelinearize_tuple.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        inputs: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "PrelinearizeTuple")?;

        // Required input arguments
        op.add_input(&inputs.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.shapes {
            op.set_attr_shape_list("shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.layouts {
            op.set_attr_int_list("layouts", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `PrelinearizeTuple::new().call(&ctx, &inputs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/PrelinearizeTuple>
pub fn prelinearize_tuple<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    inputs: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = PrelinearizeTuple::new();
    op.call(ctx, inputs)
}

/// PreventGradient
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/PreventGradient>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct PreventGradient {
    message: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for PreventGradient {
    fn default() -> Self {
        Self {
            message: None,
            target_device_name: None,
        }
    }
}
impl PreventGradient {
    /// Creates a new `PreventGradient`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `message` attribute.
    pub fn message<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.message = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute prevent_gradient.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "PreventGradient")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.message {
            op.set_attr_string("message", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `PreventGradient::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/PreventGradient>
pub fn prevent_gradient<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = PreventGradient::new();
    op.call(ctx, input)
}

/// Print
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Print>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Print {
    message: ::std::option::Option<::std::string::String>,
    first_n: ::std::option::Option<i64>,
    summarize: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Print {
    fn default() -> Self {
        Self {
            message: None,
            first_n: Some(-1i64),
            summarize: Some(3i64),
            target_device_name: None,
        }
    }
}
impl Print {
    /// Creates a new `Print`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `message` attribute.
    pub fn message<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.message = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `first_n` attribute.
    pub fn first_n<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.first_n = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `summarize` attribute.
    pub fn summarize<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.summarize = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute print.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        data: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Print")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&data.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.message {
            op.set_attr_string("message", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.first_n {
            op.set_attr_int("first_n", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.summarize {
            op.set_attr_int("summarize", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Print::new().call(&ctx, &input, &data)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Print>
pub fn print<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    data: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Print::new();
    op.call(ctx, input, data)
}

/// PrintV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/PrintV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct PrintV2 {
    output_stream: ::std::option::Option<::std::string::String>,
    end: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for PrintV2 {
    fn default() -> Self {
        Self {
            output_stream: Some(::std::string::String::from("stderr")),
            end: Some(::std::string::String::from(
                "
",
            )),
            target_device_name: None,
        }
    }
}
impl PrintV2 {
    /// Creates a new `PrintV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_stream` attribute.
    pub fn output_stream<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_stream = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `end` attribute.
    pub fn end<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.end = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute print_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "PrintV2")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_stream {
            op.set_attr_string("output_stream", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.end {
            op.set_attr_string("end", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `PrintV2::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/PrintV2>
pub fn print_v2<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<()> {
    let op = PrintV2::new();
    op.call(ctx, input)
}

/// PriorityQueue
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/PriorityQueue>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct PriorityQueue {
    component_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    capacity: ::std::option::Option<i64>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for PriorityQueue {
    fn default() -> Self {
        Self {
            component_types: Some(vec![]),
            shapes: None,
            capacity: Some(-1i64),
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl PriorityQueue {
    /// Creates a new `PriorityQueue`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `component_types` attribute.
    pub fn component_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.component_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shapes` attribute.
    pub fn shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `capacity` attribute.
    pub fn capacity<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.capacity = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute priority_queue.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "PriorityQueue")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.component_types {
            op.set_attr_type_list("component_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shapes {
            op.set_attr_shape_list("shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.capacity {
            op.set_attr_int("capacity", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `PriorityQueue::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/PriorityQueue>
pub fn priority_queue<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = PriorityQueue::new();
    op.call(ctx)
}

/// PriorityQueueV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/PriorityQueueV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct PriorityQueueV2 {
    component_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    capacity: ::std::option::Option<i64>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for PriorityQueueV2 {
    fn default() -> Self {
        Self {
            component_types: Some(vec![]),
            shapes: None,
            capacity: Some(-1i64),
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl PriorityQueueV2 {
    /// Creates a new `PriorityQueueV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `component_types` attribute.
    pub fn component_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.component_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shapes` attribute.
    pub fn shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `capacity` attribute.
    pub fn capacity<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.capacity = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute priority_queue_v2.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "PriorityQueueV2")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.component_types {
            op.set_attr_type_list("component_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shapes {
            op.set_attr_shape_list("shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.capacity {
            op.set_attr_int("capacity", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `PriorityQueueV2::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/PriorityQueueV2>
pub fn priority_queue_v2<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = PriorityQueueV2::new();
    op.call(ctx)
}

/// PrivateThreadPoolDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/PrivateThreadPoolDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct PrivateThreadPoolDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for PrivateThreadPoolDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl PrivateThreadPoolDataset {
    /// Creates a new `PrivateThreadPoolDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute private_thread_pool_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        num_threads: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "PrivateThreadPoolDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&num_threads.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `PrivateThreadPoolDataset::new().call(&ctx, &input_dataset, &num_threads)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/PrivateThreadPoolDataset>
pub fn private_thread_pool_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    num_threads: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = PrivateThreadPoolDataset::new();
    op.call(ctx, input_dataset, num_threads)
}

/// Prod
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Prod>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Prod {
    keep_dims: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Prod {
    fn default() -> Self {
        Self {
            keep_dims: Some(false),
            target_device_name: None,
        }
    }
}
impl Prod {
    /// Creates a new `Prod`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `keep_dims` attribute.
    pub fn keep_dims<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.keep_dims = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute prod.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        reduction_indices: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Prod")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&reduction_indices.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.keep_dims {
            op.set_attr_bool("keep_dims", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Prod::new().call(&ctx, &input, &reduction_indices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Prod>
pub fn prod<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    reduction_indices: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Prod::new();
    op.call(ctx, input, reduction_indices)
}

/// PyFunc
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/PyFunc>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct PyFunc {
    token: ::std::option::Option<::std::string::String>,
    Tout: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for PyFunc {
    fn default() -> Self {
        Self {
            token: None,
            Tout: None,
            target_device_name: None,
        }
    }
}
impl PyFunc {
    /// Creates a new `PyFunc`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `token` attribute.
    pub fn token<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.token = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `Tout` attribute.
    pub fn Tout<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Tout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute py_func.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "PyFunc")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.token {
            op.set_attr_string("token", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.Tout {
            op.set_attr_type_list("Tout", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `PyFunc::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/PyFunc>
pub fn py_func<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = PyFunc::new();
    op.call(ctx, input)
}

/// PyFuncStateless
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/PyFuncStateless>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct PyFuncStateless {
    token: ::std::option::Option<::std::string::String>,
    Tout: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for PyFuncStateless {
    fn default() -> Self {
        Self {
            token: None,
            Tout: None,
            target_device_name: None,
        }
    }
}
impl PyFuncStateless {
    /// Creates a new `PyFuncStateless`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `token` attribute.
    pub fn token<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.token = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `Tout` attribute.
    pub fn Tout<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Tout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute py_func_stateless.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "PyFuncStateless")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.token {
            op.set_attr_string("token", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.Tout {
            op.set_attr_type_list("Tout", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `PyFuncStateless::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/PyFuncStateless>
pub fn py_func_stateless<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = PyFuncStateless::new();
    op.call(ctx, input)
}

/// Qr
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Qr>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Qr {
    full_matrices: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Qr {
    fn default() -> Self {
        Self {
            full_matrices: Some(false),
            target_device_name: None,
        }
    }
}
impl Qr {
    /// Creates a new `Qr`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `full_matrices` attribute.
    pub fn full_matrices<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.full_matrices = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute qr.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "Qr")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.full_matrices {
            op.set_attr_bool("full_matrices", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `Qr::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Qr>
pub fn qr<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = Qr::new();
    op.call(ctx, input)
}

/// QuantizeAndDequantize
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizeAndDequantize>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizeAndDequantize {
    signed_input: ::std::option::Option<bool>,
    num_bits: ::std::option::Option<i64>,
    range_given: ::std::option::Option<bool>,
    input_min: ::std::option::Option<f32>,
    input_max: ::std::option::Option<f32>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizeAndDequantize {
    fn default() -> Self {
        Self {
            signed_input: Some(true),
            num_bits: Some(8i64),
            range_given: Some(false),
            input_min: Some(0f32),
            input_max: Some(0f32),
            target_device_name: None,
        }
    }
}
impl QuantizeAndDequantize {
    /// Creates a new `QuantizeAndDequantize`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `signed_input` attribute.
    pub fn signed_input<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.signed_input = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_bits` attribute.
    pub fn num_bits<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_bits = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `range_given` attribute.
    pub fn range_given<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.range_given = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `input_min` attribute.
    pub fn input_min<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.input_min = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `input_max` attribute.
    pub fn input_max<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.input_max = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantize_and_dequantize.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizeAndDequantize")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.signed_input {
            op.set_attr_bool("signed_input", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_bits {
            op.set_attr_int("num_bits", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.range_given {
            op.set_attr_bool("range_given", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.input_min {
            op.set_attr_float("input_min", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.input_max {
            op.set_attr_float("input_max", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `QuantizeAndDequantize::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizeAndDequantize>
pub fn quantize_and_dequantize<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = QuantizeAndDequantize::new();
    op.call(ctx, input)
}

/// QuantizeAndDequantizeV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizeAndDequantizeV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizeAndDequantizeV2 {
    signed_input: ::std::option::Option<bool>,
    num_bits: ::std::option::Option<i64>,
    range_given: ::std::option::Option<bool>,
    round_mode: ::std::option::Option<::std::string::String>,
    narrow_range: ::std::option::Option<bool>,
    axis: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizeAndDequantizeV2 {
    fn default() -> Self {
        Self {
            signed_input: Some(true),
            num_bits: Some(8i64),
            range_given: Some(false),
            round_mode: Some(::std::string::String::from("HALF_TO_EVEN")),
            narrow_range: Some(false),
            axis: Some(-1i64),
            target_device_name: None,
        }
    }
}
impl QuantizeAndDequantizeV2 {
    /// Creates a new `QuantizeAndDequantizeV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `signed_input` attribute.
    pub fn signed_input<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.signed_input = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_bits` attribute.
    pub fn num_bits<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_bits = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `range_given` attribute.
    pub fn range_given<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.range_given = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `round_mode` attribute.
    pub fn round_mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.round_mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `narrow_range` attribute.
    pub fn narrow_range<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.narrow_range = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `axis` attribute.
    pub fn axis<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.axis = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantize_and_dequantize_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        input_min: &T1,
        input_max: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizeAndDequantizeV2")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&input_min.to_handle(ctx)?)?;
        op.add_input(&input_max.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.signed_input {
            op.set_attr_bool("signed_input", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_bits {
            op.set_attr_int("num_bits", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.range_given {
            op.set_attr_bool("range_given", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.round_mode {
            op.set_attr_string("round_mode", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.narrow_range {
            op.set_attr_bool("narrow_range", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.axis {
            op.set_attr_int("axis", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `QuantizeAndDequantizeV2::new().call(&ctx, &input, &input_min, &input_max)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizeAndDequantizeV2>
pub fn quantize_and_dequantize_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    input_min: &T1,
    input_max: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = QuantizeAndDequantizeV2::new();
    op.call(ctx, input, input_min, input_max)
}

/// QuantizeAndDequantizeV3
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizeAndDequantizeV3>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizeAndDequantizeV3 {
    signed_input: ::std::option::Option<bool>,
    range_given: ::std::option::Option<bool>,
    narrow_range: ::std::option::Option<bool>,
    axis: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizeAndDequantizeV3 {
    fn default() -> Self {
        Self {
            signed_input: Some(true),
            range_given: Some(true),
            narrow_range: Some(false),
            axis: Some(-1i64),
            target_device_name: None,
        }
    }
}
impl QuantizeAndDequantizeV3 {
    /// Creates a new `QuantizeAndDequantizeV3`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `signed_input` attribute.
    pub fn signed_input<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.signed_input = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `range_given` attribute.
    pub fn range_given<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.range_given = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `narrow_range` attribute.
    pub fn narrow_range<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.narrow_range = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `axis` attribute.
    pub fn axis<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.axis = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantize_and_dequantize_v3.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        input_min: &T1,
        input_max: &T2,
        num_bits: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizeAndDequantizeV3")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&input_min.to_handle(ctx)?)?;
        op.add_input(&input_max.to_handle(ctx)?)?;
        op.add_input(&num_bits.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.signed_input {
            op.set_attr_bool("signed_input", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.range_given {
            op.set_attr_bool("range_given", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.narrow_range {
            op.set_attr_bool("narrow_range", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.axis {
            op.set_attr_int("axis", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `QuantizeAndDequantizeV3::new().call(&ctx, &input, &input_min, &input_max, &num_bits)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizeAndDequantizeV3>
pub fn quantize_and_dequantize_v3<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    input_min: &T1,
    input_max: &T2,
    num_bits: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = QuantizeAndDequantizeV3::new();
    op.call(ctx, input, input_min, input_max, num_bits)
}

/// QuantizeAndDequantizeV4
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizeAndDequantizeV4>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizeAndDequantizeV4 {
    signed_input: ::std::option::Option<bool>,
    num_bits: ::std::option::Option<i64>,
    range_given: ::std::option::Option<bool>,
    round_mode: ::std::option::Option<::std::string::String>,
    narrow_range: ::std::option::Option<bool>,
    axis: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizeAndDequantizeV4 {
    fn default() -> Self {
        Self {
            signed_input: Some(true),
            num_bits: Some(8i64),
            range_given: Some(false),
            round_mode: Some(::std::string::String::from("HALF_TO_EVEN")),
            narrow_range: Some(false),
            axis: Some(-1i64),
            target_device_name: None,
        }
    }
}
impl QuantizeAndDequantizeV4 {
    /// Creates a new `QuantizeAndDequantizeV4`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `signed_input` attribute.
    pub fn signed_input<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.signed_input = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_bits` attribute.
    pub fn num_bits<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_bits = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `range_given` attribute.
    pub fn range_given<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.range_given = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `round_mode` attribute.
    pub fn round_mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.round_mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `narrow_range` attribute.
    pub fn narrow_range<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.narrow_range = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `axis` attribute.
    pub fn axis<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.axis = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantize_and_dequantize_v4.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        input_min: &T1,
        input_max: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizeAndDequantizeV4")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&input_min.to_handle(ctx)?)?;
        op.add_input(&input_max.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.signed_input {
            op.set_attr_bool("signed_input", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_bits {
            op.set_attr_int("num_bits", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.range_given {
            op.set_attr_bool("range_given", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.round_mode {
            op.set_attr_string("round_mode", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.narrow_range {
            op.set_attr_bool("narrow_range", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.axis {
            op.set_attr_int("axis", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `QuantizeAndDequantizeV4::new().call(&ctx, &input, &input_min, &input_max)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizeAndDequantizeV4>
pub fn quantize_and_dequantize_v4<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    input_min: &T1,
    input_max: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = QuantizeAndDequantizeV4::new();
    op.call(ctx, input, input_min, input_max)
}

/// QuantizeAndDequantizeV4Grad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizeAndDequantizeV4Grad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizeAndDequantizeV4Grad {
    axis: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizeAndDequantizeV4Grad {
    fn default() -> Self {
        Self {
            axis: Some(-1i64),
            target_device_name: None,
        }
    }
}
impl QuantizeAndDequantizeV4Grad {
    /// Creates a new `QuantizeAndDequantizeV4Grad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `axis` attribute.
    pub fn axis<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.axis = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantize_and_dequantize_v4_grad.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        gradients: &T0,
        input: &T1,
        input_min: &T2,
        input_max: &T3,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizeAndDequantizeV4Grad")?;

        // Required input arguments
        op.add_input(&gradients.to_handle(ctx)?)?;
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&input_min.to_handle(ctx)?)?;
        op.add_input(&input_max.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.axis {
            op.set_attr_int("axis", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `QuantizeAndDequantizeV4Grad::new().call(&ctx, &gradients, &input, &input_min, &input_max)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizeAndDequantizeV4Grad>
pub fn quantize_and_dequantize_v4_grad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    gradients: &T0,
    input: &T1,
    input_min: &T2,
    input_max: &T3,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = QuantizeAndDequantizeV4Grad::new();
    op.call(ctx, gradients, input, input_min, input_max)
}

/// QuantizeDownAndShrinkRange
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizeDownAndShrinkRange>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizeDownAndShrinkRange {
    out_type: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizeDownAndShrinkRange {
    fn default() -> Self {
        Self {
            out_type: None,
            target_device_name: None,
        }
    }
}
impl QuantizeDownAndShrinkRange {
    /// Creates a new `QuantizeDownAndShrinkRange`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_type` attribute.
    pub fn out_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantize_down_and_shrink_range.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        input_min: &T1,
        input_max: &T2,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizeDownAndShrinkRange")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&input_min.to_handle(ctx)?)?;
        op.add_input(&input_max.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_type {
            op.set_attr_type("out_type", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `QuantizeDownAndShrinkRange::new().call(&ctx, &input, &input_min, &input_max)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizeDownAndShrinkRange>
pub fn quantize_down_and_shrink_range<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    input_min: &T1,
    input_max: &T2,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = QuantizeDownAndShrinkRange::new();
    op.call(ctx, input, input_min, input_max)
}

/// QuantizeV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizeV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizeV2 {
    T: ::std::option::Option<crate::DataType>,
    mode: ::std::option::Option<::std::string::String>,
    round_mode: ::std::option::Option<::std::string::String>,
    narrow_range: ::std::option::Option<bool>,
    axis: ::std::option::Option<i64>,
    ensure_minimum_range: ::std::option::Option<f32>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizeV2 {
    fn default() -> Self {
        Self {
            T: None,
            mode: Some(::std::string::String::from("MIN_COMBINED")),
            round_mode: Some(::std::string::String::from("HALF_AWAY_FROM_ZERO")),
            narrow_range: Some(false),
            axis: Some(-1i64),
            ensure_minimum_range: Some(0.01f32),
            target_device_name: None,
        }
    }
}
impl QuantizeV2 {
    /// Creates a new `QuantizeV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `T` attribute.
    pub fn T<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.T = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `mode` attribute.
    pub fn mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `round_mode` attribute.
    pub fn round_mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.round_mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `narrow_range` attribute.
    pub fn narrow_range<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.narrow_range = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `axis` attribute.
    pub fn axis<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.axis = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `ensure_minimum_range` attribute.
    pub fn ensure_minimum_range<ArgType: ::std::convert::Into<f32>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.ensure_minimum_range = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantize_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        min_range: &T1,
        max_range: &T2,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizeV2")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&min_range.to_handle(ctx)?)?;
        op.add_input(&max_range.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.T {
            op.set_attr_type("T", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.mode {
            op.set_attr_string("mode", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.round_mode {
            op.set_attr_string("round_mode", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.narrow_range {
            op.set_attr_bool("narrow_range", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.axis {
            op.set_attr_int("axis", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.ensure_minimum_range {
            op.set_attr_float("ensure_minimum_range", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `QuantizeV2::new().call(&ctx, &input, &min_range, &max_range)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizeV2>
pub fn quantize_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    min_range: &T1,
    max_range: &T2,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = QuantizeV2::new();
    op.call(ctx, input, min_range, max_range)
}

/// QuantizedAdd
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedAdd>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizedAdd {
    Toutput: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizedAdd {
    fn default() -> Self {
        Self {
            Toutput: Some(crate::DataType::QInt32),
            target_device_name: None,
        }
    }
}
impl QuantizedAdd {
    /// Creates a new `QuantizedAdd`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Toutput` attribute.
    pub fn Toutput<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Toutput = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantized_add.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
        min_x: &T2,
        max_x: &T3,
        min_y: &T4,
        max_y: &T5,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizedAdd")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;
        op.add_input(&min_x.to_handle(ctx)?)?;
        op.add_input(&max_x.to_handle(ctx)?)?;
        op.add_input(&min_y.to_handle(ctx)?)?;
        op.add_input(&max_y.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Toutput {
            op.set_attr_type("Toutput", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `QuantizedAdd::new().call(&ctx, &x, &y, &min_x, &max_x, &min_y, &max_y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedAdd>
pub fn quantized_add<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
    min_x: &T2,
    max_x: &T3,
    min_y: &T4,
    max_y: &T5,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = QuantizedAdd::new();
    op.call(ctx, x, y, min_x, max_x, min_y, max_y)
}

/// QuantizedAvgPool
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedAvgPool>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizedAvgPool {
    ksize: ::std::option::Option<::std::vec::Vec<i64>>,
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizedAvgPool {
    fn default() -> Self {
        Self {
            ksize: None,
            strides: None,
            padding: None,
            target_device_name: None,
        }
    }
}
impl QuantizedAvgPool {
    /// Creates a new `QuantizedAvgPool`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `ksize` attribute.
    pub fn ksize<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.ksize = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantized_avg_pool.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        min_input: &T1,
        max_input: &T2,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizedAvgPool")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&min_input.to_handle(ctx)?)?;
        op.add_input(&max_input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.ksize {
            op.set_attr_int_list("ksize", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `QuantizedAvgPool::new().call(&ctx, &input, &min_input, &max_input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedAvgPool>
pub fn quantized_avg_pool<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    min_input: &T1,
    max_input: &T2,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = QuantizedAvgPool::new();
    op.call(ctx, input, min_input, max_input)
}

/// QuantizedBatchNormWithGlobalNormalization
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedBatchNormWithGlobalNormalization>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizedBatchNormWithGlobalNormalization {
    out_type: ::std::option::Option<crate::DataType>,
    variance_epsilon: ::std::option::Option<f32>,
    scale_after_normalization: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizedBatchNormWithGlobalNormalization {
    fn default() -> Self {
        Self {
            out_type: None,
            variance_epsilon: None,
            scale_after_normalization: None,
            target_device_name: None,
        }
    }
}
impl QuantizedBatchNormWithGlobalNormalization {
    /// Creates a new `QuantizedBatchNormWithGlobalNormalization`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_type` attribute.
    pub fn out_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `variance_epsilon` attribute.
    pub fn variance_epsilon<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.variance_epsilon = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `scale_after_normalization` attribute.
    pub fn scale_after_normalization<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.scale_after_normalization = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantized_batch_norm_with_global_normalization.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
        T9: crate::eager::ToTensorHandle<'a>,
        T10: crate::eager::ToTensorHandle<'a>,
        T11: crate::eager::ToTensorHandle<'a>,
        T12: crate::eager::ToTensorHandle<'a>,
        T13: crate::eager::ToTensorHandle<'a>,
        T14: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        t: &T0,
        t_min: &T1,
        t_max: &T2,
        m: &T3,
        m_min: &T4,
        m_max: &T5,
        v: &T6,
        v_min: &T7,
        v_max: &T8,
        beta: &T9,
        beta_min: &T10,
        beta_max: &T11,
        gamma: &T12,
        gamma_min: &T13,
        gamma_max: &T14,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizedBatchNormWithGlobalNormalization")?;

        // Required input arguments
        op.add_input(&t.to_handle(ctx)?)?;
        op.add_input(&t_min.to_handle(ctx)?)?;
        op.add_input(&t_max.to_handle(ctx)?)?;
        op.add_input(&m.to_handle(ctx)?)?;
        op.add_input(&m_min.to_handle(ctx)?)?;
        op.add_input(&m_max.to_handle(ctx)?)?;
        op.add_input(&v.to_handle(ctx)?)?;
        op.add_input(&v_min.to_handle(ctx)?)?;
        op.add_input(&v_max.to_handle(ctx)?)?;
        op.add_input(&beta.to_handle(ctx)?)?;
        op.add_input(&beta_min.to_handle(ctx)?)?;
        op.add_input(&beta_max.to_handle(ctx)?)?;
        op.add_input(&gamma.to_handle(ctx)?)?;
        op.add_input(&gamma_min.to_handle(ctx)?)?;
        op.add_input(&gamma_max.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_type {
            op.set_attr_type("out_type", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.variance_epsilon {
            op.set_attr_float("variance_epsilon", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.scale_after_normalization {
            op.set_attr_bool("scale_after_normalization", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `QuantizedBatchNormWithGlobalNormalization::new().call(&ctx, &t, &t_min, &t_max, &m, &m_min, &m_max, &v, &v_min, &v_max, &beta, &beta_min, &beta_max, &gamma, &gamma_min, &gamma_max)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedBatchNormWithGlobalNormalization>
pub fn quantized_batch_norm_with_global_normalization<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
    T9: crate::eager::ToTensorHandle<'a>,
    T10: crate::eager::ToTensorHandle<'a>,
    T11: crate::eager::ToTensorHandle<'a>,
    T12: crate::eager::ToTensorHandle<'a>,
    T13: crate::eager::ToTensorHandle<'a>,
    T14: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    t: &T0,
    t_min: &T1,
    t_max: &T2,
    m: &T3,
    m_min: &T4,
    m_max: &T5,
    v: &T6,
    v_min: &T7,
    v_max: &T8,
    beta: &T9,
    beta_min: &T10,
    beta_max: &T11,
    gamma: &T12,
    gamma_min: &T13,
    gamma_max: &T14,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = QuantizedBatchNormWithGlobalNormalization::new();
    op.call(
        ctx, t, t_min, t_max, m, m_min, m_max, v, v_min, v_max, beta, beta_min, beta_max, gamma,
        gamma_min, gamma_max,
    )
}

/// QuantizedBiasAdd
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedBiasAdd>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizedBiasAdd {
    out_type: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizedBiasAdd {
    fn default() -> Self {
        Self {
            out_type: None,
            target_device_name: None,
        }
    }
}
impl QuantizedBiasAdd {
    /// Creates a new `QuantizedBiasAdd`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_type` attribute.
    pub fn out_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantized_bias_add.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        bias: &T1,
        min_input: &T2,
        max_input: &T3,
        min_bias: &T4,
        max_bias: &T5,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizedBiasAdd")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&bias.to_handle(ctx)?)?;
        op.add_input(&min_input.to_handle(ctx)?)?;
        op.add_input(&max_input.to_handle(ctx)?)?;
        op.add_input(&min_bias.to_handle(ctx)?)?;
        op.add_input(&max_bias.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_type {
            op.set_attr_type("out_type", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `QuantizedBiasAdd::new().call(&ctx, &input, &bias, &min_input, &max_input, &min_bias, &max_bias)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedBiasAdd>
pub fn quantized_bias_add<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    bias: &T1,
    min_input: &T2,
    max_input: &T3,
    min_bias: &T4,
    max_bias: &T5,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = QuantizedBiasAdd::new();
    op.call(ctx, input, bias, min_input, max_input, min_bias, max_bias)
}

/// QuantizedConcat
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedConcat>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizedConcat {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizedConcat {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl QuantizedConcat {
    /// Creates a new `QuantizedConcat`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantized_concat.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        concat_dim: &T0,
        values: &[&T1],
        input_mins: &[&T2],
        input_maxes: &[&T3],
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizedConcat")?;

        // Required input arguments
        op.add_input(&concat_dim.to_handle(ctx)?)?;
        let mut values_list = Vec::new();

        for t in values {
            values_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&values_list)?;
        let mut input_mins_list = Vec::new();

        for t in input_mins {
            input_mins_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&input_mins_list)?;
        let mut input_maxes_list = Vec::new();

        for t in input_maxes {
            input_maxes_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&input_maxes_list)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `QuantizedConcat::new().call(&ctx, &concat_dim, &values, &input_mins, &input_maxes)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedConcat>
pub fn quantized_concat<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    concat_dim: &T0,
    values: &[&T1],
    input_mins: &[&T2],
    input_maxes: &[&T3],
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = QuantizedConcat::new();
    op.call(ctx, concat_dim, values, input_mins, input_maxes)
}

/// QuantizedConv2D
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedConv2D>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizedConv2D {
    out_type: ::std::option::Option<crate::DataType>,
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    dilations: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizedConv2D {
    fn default() -> Self {
        Self {
            out_type: Some(crate::DataType::QInt32),
            strides: None,
            padding: None,
            dilations: Some(vec![1, 1, 1, 1]),
            target_device_name: None,
        }
    }
}
impl QuantizedConv2D {
    /// Creates a new `QuantizedConv2D`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_type` attribute.
    pub fn out_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dilations` attribute.
    pub fn dilations<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dilations = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantized_conv2_d.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        filter: &T1,
        min_input: &T2,
        max_input: &T3,
        min_filter: &T4,
        max_filter: &T5,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizedConv2D")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&filter.to_handle(ctx)?)?;
        op.add_input(&min_input.to_handle(ctx)?)?;
        op.add_input(&max_input.to_handle(ctx)?)?;
        op.add_input(&min_filter.to_handle(ctx)?)?;
        op.add_input(&max_filter.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_type {
            op.set_attr_type("out_type", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dilations {
            op.set_attr_int_list("dilations", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `QuantizedConv2D::new().call(&ctx, &input, &filter, &min_input, &max_input, &min_filter, &max_filter)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedConv2D>
pub fn quantized_conv2_d<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    filter: &T1,
    min_input: &T2,
    max_input: &T3,
    min_filter: &T4,
    max_filter: &T5,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = QuantizedConv2D::new();
    op.call(
        ctx, input, filter, min_input, max_input, min_filter, max_filter,
    )
}

/// QuantizedConv2DAndRelu
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedConv2DAndRelu>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizedConv2DAndRelu {
    out_type: ::std::option::Option<crate::DataType>,
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    dilations: ::std::option::Option<::std::vec::Vec<i64>>,
    padding_list: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizedConv2DAndRelu {
    fn default() -> Self {
        Self {
            out_type: Some(crate::DataType::QInt32),
            strides: None,
            padding: None,
            dilations: Some(vec![1, 1, 1, 1]),
            padding_list: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl QuantizedConv2DAndRelu {
    /// Creates a new `QuantizedConv2DAndRelu`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_type` attribute.
    pub fn out_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dilations` attribute.
    pub fn dilations<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dilations = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding_list` attribute.
    pub fn padding_list<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding_list = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantized_conv2_dand_relu.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        filter: &T1,
        min_input: &T2,
        max_input: &T3,
        min_filter: &T4,
        max_filter: &T5,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizedConv2DAndRelu")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&filter.to_handle(ctx)?)?;
        op.add_input(&min_input.to_handle(ctx)?)?;
        op.add_input(&max_input.to_handle(ctx)?)?;
        op.add_input(&min_filter.to_handle(ctx)?)?;
        op.add_input(&max_filter.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_type {
            op.set_attr_type("out_type", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dilations {
            op.set_attr_int_list("dilations", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding_list {
            op.set_attr_int_list("padding_list", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `QuantizedConv2DAndRelu::new().call(&ctx, &input, &filter, &min_input, &max_input, &min_filter, &max_filter)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedConv2DAndRelu>
pub fn quantized_conv2_dand_relu<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    filter: &T1,
    min_input: &T2,
    max_input: &T3,
    min_filter: &T4,
    max_filter: &T5,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = QuantizedConv2DAndRelu::new();
    op.call(
        ctx, input, filter, min_input, max_input, min_filter, max_filter,
    )
}

/// QuantizedConv2DAndReluAndRequantize
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedConv2DAndReluAndRequantize>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizedConv2DAndReluAndRequantize {
    out_type: ::std::option::Option<crate::DataType>,
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    dilations: ::std::option::Option<::std::vec::Vec<i64>>,
    padding_list: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizedConv2DAndReluAndRequantize {
    fn default() -> Self {
        Self {
            out_type: Some(crate::DataType::QUInt8),
            strides: None,
            padding: None,
            dilations: Some(vec![1, 1, 1, 1]),
            padding_list: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl QuantizedConv2DAndReluAndRequantize {
    /// Creates a new `QuantizedConv2DAndReluAndRequantize`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_type` attribute.
    pub fn out_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dilations` attribute.
    pub fn dilations<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dilations = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding_list` attribute.
    pub fn padding_list<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding_list = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantized_conv2_dand_relu_and_requantize.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        filter: &T1,
        min_input: &T2,
        max_input: &T3,
        min_filter: &T4,
        max_filter: &T5,
        min_freezed_output: &T6,
        max_freezed_output: &T7,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizedConv2DAndReluAndRequantize")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&filter.to_handle(ctx)?)?;
        op.add_input(&min_input.to_handle(ctx)?)?;
        op.add_input(&max_input.to_handle(ctx)?)?;
        op.add_input(&min_filter.to_handle(ctx)?)?;
        op.add_input(&max_filter.to_handle(ctx)?)?;
        op.add_input(&min_freezed_output.to_handle(ctx)?)?;
        op.add_input(&max_freezed_output.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_type {
            op.set_attr_type("out_type", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dilations {
            op.set_attr_int_list("dilations", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding_list {
            op.set_attr_int_list("padding_list", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `QuantizedConv2DAndReluAndRequantize::new().call(&ctx, &input, &filter, &min_input, &max_input, &min_filter, &max_filter, &min_freezed_output, &max_freezed_output)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedConv2DAndReluAndRequantize>
pub fn quantized_conv2_dand_relu_and_requantize<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    filter: &T1,
    min_input: &T2,
    max_input: &T3,
    min_filter: &T4,
    max_filter: &T5,
    min_freezed_output: &T6,
    max_freezed_output: &T7,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = QuantizedConv2DAndReluAndRequantize::new();
    op.call(
        ctx,
        input,
        filter,
        min_input,
        max_input,
        min_filter,
        max_filter,
        min_freezed_output,
        max_freezed_output,
    )
}

/// QuantizedConv2DAndRequantize
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedConv2DAndRequantize>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizedConv2DAndRequantize {
    out_type: ::std::option::Option<crate::DataType>,
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    dilations: ::std::option::Option<::std::vec::Vec<i64>>,
    padding_list: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizedConv2DAndRequantize {
    fn default() -> Self {
        Self {
            out_type: Some(crate::DataType::QInt8),
            strides: None,
            padding: None,
            dilations: Some(vec![1, 1, 1, 1]),
            padding_list: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl QuantizedConv2DAndRequantize {
    /// Creates a new `QuantizedConv2DAndRequantize`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_type` attribute.
    pub fn out_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dilations` attribute.
    pub fn dilations<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dilations = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding_list` attribute.
    pub fn padding_list<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding_list = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantized_conv2_dand_requantize.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        filter: &T1,
        min_input: &T2,
        max_input: &T3,
        min_filter: &T4,
        max_filter: &T5,
        min_freezed_output: &T6,
        max_freezed_output: &T7,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizedConv2DAndRequantize")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&filter.to_handle(ctx)?)?;
        op.add_input(&min_input.to_handle(ctx)?)?;
        op.add_input(&max_input.to_handle(ctx)?)?;
        op.add_input(&min_filter.to_handle(ctx)?)?;
        op.add_input(&max_filter.to_handle(ctx)?)?;
        op.add_input(&min_freezed_output.to_handle(ctx)?)?;
        op.add_input(&max_freezed_output.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_type {
            op.set_attr_type("out_type", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dilations {
            op.set_attr_int_list("dilations", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding_list {
            op.set_attr_int_list("padding_list", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `QuantizedConv2DAndRequantize::new().call(&ctx, &input, &filter, &min_input, &max_input, &min_filter, &max_filter, &min_freezed_output, &max_freezed_output)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedConv2DAndRequantize>
pub fn quantized_conv2_dand_requantize<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    filter: &T1,
    min_input: &T2,
    max_input: &T3,
    min_filter: &T4,
    max_filter: &T5,
    min_freezed_output: &T6,
    max_freezed_output: &T7,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = QuantizedConv2DAndRequantize::new();
    op.call(
        ctx,
        input,
        filter,
        min_input,
        max_input,
        min_filter,
        max_filter,
        min_freezed_output,
        max_freezed_output,
    )
}

/// QuantizedConv2DPerChannel
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedConv2DPerChannel>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizedConv2DPerChannel {
    out_type: ::std::option::Option<crate::DataType>,
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    dilations: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizedConv2DPerChannel {
    fn default() -> Self {
        Self {
            out_type: Some(crate::DataType::QInt32),
            strides: None,
            padding: None,
            dilations: Some(vec![1, 1, 1, 1]),
            target_device_name: None,
        }
    }
}
impl QuantizedConv2DPerChannel {
    /// Creates a new `QuantizedConv2DPerChannel`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_type` attribute.
    pub fn out_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dilations` attribute.
    pub fn dilations<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dilations = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantized_conv2_dper_channel.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        filter: &T1,
        min_input: &T2,
        max_input: &T3,
        min_filter: &T4,
        max_filter: &T5,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizedConv2DPerChannel")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&filter.to_handle(ctx)?)?;
        op.add_input(&min_input.to_handle(ctx)?)?;
        op.add_input(&max_input.to_handle(ctx)?)?;
        op.add_input(&min_filter.to_handle(ctx)?)?;
        op.add_input(&max_filter.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_type {
            op.set_attr_type("out_type", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dilations {
            op.set_attr_int_list("dilations", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `QuantizedConv2DPerChannel::new().call(&ctx, &input, &filter, &min_input, &max_input, &min_filter, &max_filter)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedConv2DPerChannel>
pub fn quantized_conv2_dper_channel<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    filter: &T1,
    min_input: &T2,
    max_input: &T3,
    min_filter: &T4,
    max_filter: &T5,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = QuantizedConv2DPerChannel::new();
    op.call(
        ctx, input, filter, min_input, max_input, min_filter, max_filter,
    )
}

/// QuantizedConv2DWithBias
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedConv2DWithBias>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizedConv2DWithBias {
    out_type: ::std::option::Option<crate::DataType>,
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    dilations: ::std::option::Option<::std::vec::Vec<i64>>,
    padding_list: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizedConv2DWithBias {
    fn default() -> Self {
        Self {
            out_type: Some(crate::DataType::QInt32),
            strides: None,
            padding: None,
            dilations: Some(vec![1, 1, 1, 1]),
            padding_list: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl QuantizedConv2DWithBias {
    /// Creates a new `QuantizedConv2DWithBias`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_type` attribute.
    pub fn out_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dilations` attribute.
    pub fn dilations<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dilations = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding_list` attribute.
    pub fn padding_list<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding_list = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantized_conv2_dwith_bias.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        filter: &T1,
        bias: &T2,
        min_input: &T3,
        max_input: &T4,
        min_filter: &T5,
        max_filter: &T6,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizedConv2DWithBias")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&filter.to_handle(ctx)?)?;
        op.add_input(&bias.to_handle(ctx)?)?;
        op.add_input(&min_input.to_handle(ctx)?)?;
        op.add_input(&max_input.to_handle(ctx)?)?;
        op.add_input(&min_filter.to_handle(ctx)?)?;
        op.add_input(&max_filter.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_type {
            op.set_attr_type("out_type", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dilations {
            op.set_attr_int_list("dilations", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding_list {
            op.set_attr_int_list("padding_list", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `QuantizedConv2DWithBias::new().call(&ctx, &input, &filter, &bias, &min_input, &max_input, &min_filter, &max_filter)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedConv2DWithBias>
pub fn quantized_conv2_dwith_bias<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    filter: &T1,
    bias: &T2,
    min_input: &T3,
    max_input: &T4,
    min_filter: &T5,
    max_filter: &T6,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = QuantizedConv2DWithBias::new();
    op.call(
        ctx, input, filter, bias, min_input, max_input, min_filter, max_filter,
    )
}

/// QuantizedConv2DWithBiasAndRelu
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedConv2DWithBiasAndRelu>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizedConv2DWithBiasAndRelu {
    out_type: ::std::option::Option<crate::DataType>,
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    dilations: ::std::option::Option<::std::vec::Vec<i64>>,
    padding_list: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizedConv2DWithBiasAndRelu {
    fn default() -> Self {
        Self {
            out_type: Some(crate::DataType::QInt32),
            strides: None,
            padding: None,
            dilations: Some(vec![1, 1, 1, 1]),
            padding_list: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl QuantizedConv2DWithBiasAndRelu {
    /// Creates a new `QuantizedConv2DWithBiasAndRelu`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_type` attribute.
    pub fn out_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dilations` attribute.
    pub fn dilations<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dilations = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding_list` attribute.
    pub fn padding_list<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding_list = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantized_conv2_dwith_bias_and_relu.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        filter: &T1,
        bias: &T2,
        min_input: &T3,
        max_input: &T4,
        min_filter: &T5,
        max_filter: &T6,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizedConv2DWithBiasAndRelu")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&filter.to_handle(ctx)?)?;
        op.add_input(&bias.to_handle(ctx)?)?;
        op.add_input(&min_input.to_handle(ctx)?)?;
        op.add_input(&max_input.to_handle(ctx)?)?;
        op.add_input(&min_filter.to_handle(ctx)?)?;
        op.add_input(&max_filter.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_type {
            op.set_attr_type("out_type", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dilations {
            op.set_attr_int_list("dilations", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding_list {
            op.set_attr_int_list("padding_list", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `QuantizedConv2DWithBiasAndRelu::new().call(&ctx, &input, &filter, &bias, &min_input, &max_input, &min_filter, &max_filter)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedConv2DWithBiasAndRelu>
pub fn quantized_conv2_dwith_bias_and_relu<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    filter: &T1,
    bias: &T2,
    min_input: &T3,
    max_input: &T4,
    min_filter: &T5,
    max_filter: &T6,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = QuantizedConv2DWithBiasAndRelu::new();
    op.call(
        ctx, input, filter, bias, min_input, max_input, min_filter, max_filter,
    )
}

/// QuantizedConv2DWithBiasAndReluAndRequantize
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedConv2DWithBiasAndReluAndRequantize>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizedConv2DWithBiasAndReluAndRequantize {
    out_type: ::std::option::Option<crate::DataType>,
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    dilations: ::std::option::Option<::std::vec::Vec<i64>>,
    padding_list: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizedConv2DWithBiasAndReluAndRequantize {
    fn default() -> Self {
        Self {
            out_type: Some(crate::DataType::QUInt8),
            strides: None,
            padding: None,
            dilations: Some(vec![1, 1, 1, 1]),
            padding_list: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl QuantizedConv2DWithBiasAndReluAndRequantize {
    /// Creates a new `QuantizedConv2DWithBiasAndReluAndRequantize`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_type` attribute.
    pub fn out_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dilations` attribute.
    pub fn dilations<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dilations = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding_list` attribute.
    pub fn padding_list<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding_list = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantized_conv2_dwith_bias_and_relu_and_requantize.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        filter: &T1,
        bias: &T2,
        min_input: &T3,
        max_input: &T4,
        min_filter: &T5,
        max_filter: &T6,
        min_freezed_output: &T7,
        max_freezed_output: &T8,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizedConv2DWithBiasAndReluAndRequantize")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&filter.to_handle(ctx)?)?;
        op.add_input(&bias.to_handle(ctx)?)?;
        op.add_input(&min_input.to_handle(ctx)?)?;
        op.add_input(&max_input.to_handle(ctx)?)?;
        op.add_input(&min_filter.to_handle(ctx)?)?;
        op.add_input(&max_filter.to_handle(ctx)?)?;
        op.add_input(&min_freezed_output.to_handle(ctx)?)?;
        op.add_input(&max_freezed_output.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_type {
            op.set_attr_type("out_type", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dilations {
            op.set_attr_int_list("dilations", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding_list {
            op.set_attr_int_list("padding_list", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `QuantizedConv2DWithBiasAndReluAndRequantize::new().call(&ctx, &input, &filter, &bias, &min_input, &max_input, &min_filter, &max_filter, &min_freezed_output, &max_freezed_output)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedConv2DWithBiasAndReluAndRequantize>
pub fn quantized_conv2_dwith_bias_and_relu_and_requantize<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    filter: &T1,
    bias: &T2,
    min_input: &T3,
    max_input: &T4,
    min_filter: &T5,
    max_filter: &T6,
    min_freezed_output: &T7,
    max_freezed_output: &T8,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = QuantizedConv2DWithBiasAndReluAndRequantize::new();
    op.call(
        ctx,
        input,
        filter,
        bias,
        min_input,
        max_input,
        min_filter,
        max_filter,
        min_freezed_output,
        max_freezed_output,
    )
}

/// QuantizedConv2DWithBiasAndRequantize
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedConv2DWithBiasAndRequantize>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizedConv2DWithBiasAndRequantize {
    out_type: ::std::option::Option<crate::DataType>,
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    dilations: ::std::option::Option<::std::vec::Vec<i64>>,
    padding_list: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizedConv2DWithBiasAndRequantize {
    fn default() -> Self {
        Self {
            out_type: Some(crate::DataType::QInt8),
            strides: None,
            padding: None,
            dilations: Some(vec![1, 1, 1, 1]),
            padding_list: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl QuantizedConv2DWithBiasAndRequantize {
    /// Creates a new `QuantizedConv2DWithBiasAndRequantize`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_type` attribute.
    pub fn out_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dilations` attribute.
    pub fn dilations<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dilations = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding_list` attribute.
    pub fn padding_list<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding_list = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantized_conv2_dwith_bias_and_requantize.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        filter: &T1,
        bias: &T2,
        min_input: &T3,
        max_input: &T4,
        min_filter: &T5,
        max_filter: &T6,
        min_freezed_output: &T7,
        max_freezed_output: &T8,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizedConv2DWithBiasAndRequantize")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&filter.to_handle(ctx)?)?;
        op.add_input(&bias.to_handle(ctx)?)?;
        op.add_input(&min_input.to_handle(ctx)?)?;
        op.add_input(&max_input.to_handle(ctx)?)?;
        op.add_input(&min_filter.to_handle(ctx)?)?;
        op.add_input(&max_filter.to_handle(ctx)?)?;
        op.add_input(&min_freezed_output.to_handle(ctx)?)?;
        op.add_input(&max_freezed_output.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_type {
            op.set_attr_type("out_type", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dilations {
            op.set_attr_int_list("dilations", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding_list {
            op.set_attr_int_list("padding_list", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `QuantizedConv2DWithBiasAndRequantize::new().call(&ctx, &input, &filter, &bias, &min_input, &max_input, &min_filter, &max_filter, &min_freezed_output, &max_freezed_output)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedConv2DWithBiasAndRequantize>
pub fn quantized_conv2_dwith_bias_and_requantize<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    filter: &T1,
    bias: &T2,
    min_input: &T3,
    max_input: &T4,
    min_filter: &T5,
    max_filter: &T6,
    min_freezed_output: &T7,
    max_freezed_output: &T8,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = QuantizedConv2DWithBiasAndRequantize::new();
    op.call(
        ctx,
        input,
        filter,
        bias,
        min_input,
        max_input,
        min_filter,
        max_filter,
        min_freezed_output,
        max_freezed_output,
    )
}

/// QuantizedConv2DWithBiasSignedSumAndReluAndRequantize
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedConv2DWithBiasSignedSumAndReluAndRequantize>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizedConv2DWithBiasSignedSumAndReluAndRequantize {
    out_type: ::std::option::Option<crate::DataType>,
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    dilations: ::std::option::Option<::std::vec::Vec<i64>>,
    padding_list: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizedConv2DWithBiasSignedSumAndReluAndRequantize {
    fn default() -> Self {
        Self {
            out_type: Some(crate::DataType::QUInt8),
            strides: None,
            padding: None,
            dilations: Some(vec![1, 1, 1, 1]),
            padding_list: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl QuantizedConv2DWithBiasSignedSumAndReluAndRequantize {
    /// Creates a new `QuantizedConv2DWithBiasSignedSumAndReluAndRequantize`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_type` attribute.
    pub fn out_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dilations` attribute.
    pub fn dilations<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dilations = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding_list` attribute.
    pub fn padding_list<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding_list = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantized_conv2_dwith_bias_signed_sum_and_relu_and_requantize.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
        T9: crate::eager::ToTensorHandle<'a>,
        T10: crate::eager::ToTensorHandle<'a>,
        T11: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        filter: &T1,
        bias: &T2,
        min_input: &T3,
        max_input: &T4,
        min_filter: &T5,
        max_filter: &T6,
        min_freezed_output: &T7,
        max_freezed_output: &T8,
        summand: &T9,
        min_summand: &T10,
        max_summand: &T11,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizedConv2DWithBiasSignedSumAndReluAndRequantize")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&filter.to_handle(ctx)?)?;
        op.add_input(&bias.to_handle(ctx)?)?;
        op.add_input(&min_input.to_handle(ctx)?)?;
        op.add_input(&max_input.to_handle(ctx)?)?;
        op.add_input(&min_filter.to_handle(ctx)?)?;
        op.add_input(&max_filter.to_handle(ctx)?)?;
        op.add_input(&min_freezed_output.to_handle(ctx)?)?;
        op.add_input(&max_freezed_output.to_handle(ctx)?)?;
        op.add_input(&summand.to_handle(ctx)?)?;
        op.add_input(&min_summand.to_handle(ctx)?)?;
        op.add_input(&max_summand.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_type {
            op.set_attr_type("out_type", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dilations {
            op.set_attr_int_list("dilations", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding_list {
            op.set_attr_int_list("padding_list", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `QuantizedConv2DWithBiasSignedSumAndReluAndRequantize::new().call(&ctx, &input, &filter, &bias, &min_input, &max_input, &min_filter, &max_filter, &min_freezed_output, &max_freezed_output, &summand, &min_summand, &max_summand)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedConv2DWithBiasSignedSumAndReluAndRequantize>
pub fn quantized_conv2_dwith_bias_signed_sum_and_relu_and_requantize<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
    T9: crate::eager::ToTensorHandle<'a>,
    T10: crate::eager::ToTensorHandle<'a>,
    T11: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    filter: &T1,
    bias: &T2,
    min_input: &T3,
    max_input: &T4,
    min_filter: &T5,
    max_filter: &T6,
    min_freezed_output: &T7,
    max_freezed_output: &T8,
    summand: &T9,
    min_summand: &T10,
    max_summand: &T11,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = QuantizedConv2DWithBiasSignedSumAndReluAndRequantize::new();
    op.call(
        ctx,
        input,
        filter,
        bias,
        min_input,
        max_input,
        min_filter,
        max_filter,
        min_freezed_output,
        max_freezed_output,
        summand,
        min_summand,
        max_summand,
    )
}

/// QuantizedConv2DWithBiasSumAndRelu
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedConv2DWithBiasSumAndRelu>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizedConv2DWithBiasSumAndRelu {
    out_type: ::std::option::Option<crate::DataType>,
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    dilations: ::std::option::Option<::std::vec::Vec<i64>>,
    padding_list: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizedConv2DWithBiasSumAndRelu {
    fn default() -> Self {
        Self {
            out_type: Some(crate::DataType::QInt32),
            strides: None,
            padding: None,
            dilations: Some(vec![1, 1, 1, 1]),
            padding_list: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl QuantizedConv2DWithBiasSumAndRelu {
    /// Creates a new `QuantizedConv2DWithBiasSumAndRelu`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_type` attribute.
    pub fn out_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dilations` attribute.
    pub fn dilations<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dilations = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding_list` attribute.
    pub fn padding_list<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding_list = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantized_conv2_dwith_bias_sum_and_relu.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        filter: &T1,
        bias: &T2,
        min_input: &T3,
        max_input: &T4,
        min_filter: &T5,
        max_filter: &T6,
        summand: &T7,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizedConv2DWithBiasSumAndRelu")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&filter.to_handle(ctx)?)?;
        op.add_input(&bias.to_handle(ctx)?)?;
        op.add_input(&min_input.to_handle(ctx)?)?;
        op.add_input(&max_input.to_handle(ctx)?)?;
        op.add_input(&min_filter.to_handle(ctx)?)?;
        op.add_input(&max_filter.to_handle(ctx)?)?;
        op.add_input(&summand.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_type {
            op.set_attr_type("out_type", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dilations {
            op.set_attr_int_list("dilations", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding_list {
            op.set_attr_int_list("padding_list", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `QuantizedConv2DWithBiasSumAndRelu::new().call(&ctx, &input, &filter, &bias, &min_input, &max_input, &min_filter, &max_filter, &summand)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedConv2DWithBiasSumAndRelu>
pub fn quantized_conv2_dwith_bias_sum_and_relu<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    filter: &T1,
    bias: &T2,
    min_input: &T3,
    max_input: &T4,
    min_filter: &T5,
    max_filter: &T6,
    summand: &T7,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = QuantizedConv2DWithBiasSumAndRelu::new();
    op.call(
        ctx, input, filter, bias, min_input, max_input, min_filter, max_filter, summand,
    )
}

/// QuantizedConv2DWithBiasSumAndReluAndRequantize
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedConv2DWithBiasSumAndReluAndRequantize>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizedConv2DWithBiasSumAndReluAndRequantize {
    out_type: ::std::option::Option<crate::DataType>,
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    dilations: ::std::option::Option<::std::vec::Vec<i64>>,
    padding_list: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizedConv2DWithBiasSumAndReluAndRequantize {
    fn default() -> Self {
        Self {
            out_type: Some(crate::DataType::QUInt8),
            strides: None,
            padding: None,
            dilations: Some(vec![1, 1, 1, 1]),
            padding_list: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl QuantizedConv2DWithBiasSumAndReluAndRequantize {
    /// Creates a new `QuantizedConv2DWithBiasSumAndReluAndRequantize`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_type` attribute.
    pub fn out_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dilations` attribute.
    pub fn dilations<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dilations = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding_list` attribute.
    pub fn padding_list<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding_list = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantized_conv2_dwith_bias_sum_and_relu_and_requantize.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
        T9: crate::eager::ToTensorHandle<'a>,
        T10: crate::eager::ToTensorHandle<'a>,
        T11: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        filter: &T1,
        bias: &T2,
        min_input: &T3,
        max_input: &T4,
        min_filter: &T5,
        max_filter: &T6,
        min_freezed_output: &T7,
        max_freezed_output: &T8,
        summand: &T9,
        min_summand: &T10,
        max_summand: &T11,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizedConv2DWithBiasSumAndReluAndRequantize")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&filter.to_handle(ctx)?)?;
        op.add_input(&bias.to_handle(ctx)?)?;
        op.add_input(&min_input.to_handle(ctx)?)?;
        op.add_input(&max_input.to_handle(ctx)?)?;
        op.add_input(&min_filter.to_handle(ctx)?)?;
        op.add_input(&max_filter.to_handle(ctx)?)?;
        op.add_input(&min_freezed_output.to_handle(ctx)?)?;
        op.add_input(&max_freezed_output.to_handle(ctx)?)?;
        op.add_input(&summand.to_handle(ctx)?)?;
        op.add_input(&min_summand.to_handle(ctx)?)?;
        op.add_input(&max_summand.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_type {
            op.set_attr_type("out_type", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dilations {
            op.set_attr_int_list("dilations", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding_list {
            op.set_attr_int_list("padding_list", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `QuantizedConv2DWithBiasSumAndReluAndRequantize::new().call(&ctx, &input, &filter, &bias, &min_input, &max_input, &min_filter, &max_filter, &min_freezed_output, &max_freezed_output, &summand, &min_summand, &max_summand)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedConv2DWithBiasSumAndReluAndRequantize>
pub fn quantized_conv2_dwith_bias_sum_and_relu_and_requantize<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
    T9: crate::eager::ToTensorHandle<'a>,
    T10: crate::eager::ToTensorHandle<'a>,
    T11: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    filter: &T1,
    bias: &T2,
    min_input: &T3,
    max_input: &T4,
    min_filter: &T5,
    max_filter: &T6,
    min_freezed_output: &T7,
    max_freezed_output: &T8,
    summand: &T9,
    min_summand: &T10,
    max_summand: &T11,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = QuantizedConv2DWithBiasSumAndReluAndRequantize::new();
    op.call(
        ctx,
        input,
        filter,
        bias,
        min_input,
        max_input,
        min_filter,
        max_filter,
        min_freezed_output,
        max_freezed_output,
        summand,
        min_summand,
        max_summand,
    )
}

/// QuantizedDepthwiseConv2D
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedDepthwiseConv2D>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizedDepthwiseConv2D {
    out_type: ::std::option::Option<crate::DataType>,
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    dilations: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizedDepthwiseConv2D {
    fn default() -> Self {
        Self {
            out_type: Some(crate::DataType::QInt32),
            strides: None,
            padding: None,
            dilations: Some(vec![1, 1, 1, 1]),
            target_device_name: None,
        }
    }
}
impl QuantizedDepthwiseConv2D {
    /// Creates a new `QuantizedDepthwiseConv2D`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_type` attribute.
    pub fn out_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dilations` attribute.
    pub fn dilations<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dilations = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantized_depthwise_conv2_d.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        filter: &T1,
        min_input: &T2,
        max_input: &T3,
        min_filter: &T4,
        max_filter: &T5,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizedDepthwiseConv2D")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&filter.to_handle(ctx)?)?;
        op.add_input(&min_input.to_handle(ctx)?)?;
        op.add_input(&max_input.to_handle(ctx)?)?;
        op.add_input(&min_filter.to_handle(ctx)?)?;
        op.add_input(&max_filter.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_type {
            op.set_attr_type("out_type", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dilations {
            op.set_attr_int_list("dilations", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `QuantizedDepthwiseConv2D::new().call(&ctx, &input, &filter, &min_input, &max_input, &min_filter, &max_filter)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedDepthwiseConv2D>
pub fn quantized_depthwise_conv2_d<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    filter: &T1,
    min_input: &T2,
    max_input: &T3,
    min_filter: &T4,
    max_filter: &T5,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = QuantizedDepthwiseConv2D::new();
    op.call(
        ctx, input, filter, min_input, max_input, min_filter, max_filter,
    )
}

/// QuantizedDepthwiseConv2DWithBias
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedDepthwiseConv2DWithBias>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizedDepthwiseConv2DWithBias {
    out_type: ::std::option::Option<crate::DataType>,
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    dilations: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizedDepthwiseConv2DWithBias {
    fn default() -> Self {
        Self {
            out_type: Some(crate::DataType::QInt32),
            strides: None,
            padding: None,
            dilations: Some(vec![1, 1, 1, 1]),
            target_device_name: None,
        }
    }
}
impl QuantizedDepthwiseConv2DWithBias {
    /// Creates a new `QuantizedDepthwiseConv2DWithBias`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_type` attribute.
    pub fn out_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dilations` attribute.
    pub fn dilations<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dilations = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantized_depthwise_conv2_dwith_bias.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        filter: &T1,
        bias: &T2,
        min_input: &T3,
        max_input: &T4,
        min_filter: &T5,
        max_filter: &T6,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizedDepthwiseConv2DWithBias")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&filter.to_handle(ctx)?)?;
        op.add_input(&bias.to_handle(ctx)?)?;
        op.add_input(&min_input.to_handle(ctx)?)?;
        op.add_input(&max_input.to_handle(ctx)?)?;
        op.add_input(&min_filter.to_handle(ctx)?)?;
        op.add_input(&max_filter.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_type {
            op.set_attr_type("out_type", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dilations {
            op.set_attr_int_list("dilations", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `QuantizedDepthwiseConv2DWithBias::new().call(&ctx, &input, &filter, &bias, &min_input, &max_input, &min_filter, &max_filter)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedDepthwiseConv2DWithBias>
pub fn quantized_depthwise_conv2_dwith_bias<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    filter: &T1,
    bias: &T2,
    min_input: &T3,
    max_input: &T4,
    min_filter: &T5,
    max_filter: &T6,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = QuantizedDepthwiseConv2DWithBias::new();
    op.call(
        ctx, input, filter, bias, min_input, max_input, min_filter, max_filter,
    )
}

/// QuantizedDepthwiseConv2DWithBiasAndRelu
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedDepthwiseConv2DWithBiasAndRelu>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizedDepthwiseConv2DWithBiasAndRelu {
    out_type: ::std::option::Option<crate::DataType>,
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    dilations: ::std::option::Option<::std::vec::Vec<i64>>,
    padding_list: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizedDepthwiseConv2DWithBiasAndRelu {
    fn default() -> Self {
        Self {
            out_type: Some(crate::DataType::QInt32),
            strides: None,
            padding: None,
            dilations: Some(vec![1, 1, 1, 1]),
            padding_list: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl QuantizedDepthwiseConv2DWithBiasAndRelu {
    /// Creates a new `QuantizedDepthwiseConv2DWithBiasAndRelu`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_type` attribute.
    pub fn out_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dilations` attribute.
    pub fn dilations<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dilations = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding_list` attribute.
    pub fn padding_list<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding_list = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantized_depthwise_conv2_dwith_bias_and_relu.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        filter: &T1,
        bias: &T2,
        min_input: &T3,
        max_input: &T4,
        min_filter: &T5,
        max_filter: &T6,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizedDepthwiseConv2DWithBiasAndRelu")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&filter.to_handle(ctx)?)?;
        op.add_input(&bias.to_handle(ctx)?)?;
        op.add_input(&min_input.to_handle(ctx)?)?;
        op.add_input(&max_input.to_handle(ctx)?)?;
        op.add_input(&min_filter.to_handle(ctx)?)?;
        op.add_input(&max_filter.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_type {
            op.set_attr_type("out_type", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dilations {
            op.set_attr_int_list("dilations", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding_list {
            op.set_attr_int_list("padding_list", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `QuantizedDepthwiseConv2DWithBiasAndRelu::new().call(&ctx, &input, &filter, &bias, &min_input, &max_input, &min_filter, &max_filter)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedDepthwiseConv2DWithBiasAndRelu>
pub fn quantized_depthwise_conv2_dwith_bias_and_relu<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    filter: &T1,
    bias: &T2,
    min_input: &T3,
    max_input: &T4,
    min_filter: &T5,
    max_filter: &T6,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = QuantizedDepthwiseConv2DWithBiasAndRelu::new();
    op.call(
        ctx, input, filter, bias, min_input, max_input, min_filter, max_filter,
    )
}

/// QuantizedDepthwiseConv2DWithBiasAndReluAndRequantize
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedDepthwiseConv2DWithBiasAndReluAndRequantize>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizedDepthwiseConv2DWithBiasAndReluAndRequantize {
    out_type: ::std::option::Option<crate::DataType>,
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    dilations: ::std::option::Option<::std::vec::Vec<i64>>,
    padding_list: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizedDepthwiseConv2DWithBiasAndReluAndRequantize {
    fn default() -> Self {
        Self {
            out_type: Some(crate::DataType::QUInt8),
            strides: None,
            padding: None,
            dilations: Some(vec![1, 1, 1, 1]),
            padding_list: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl QuantizedDepthwiseConv2DWithBiasAndReluAndRequantize {
    /// Creates a new `QuantizedDepthwiseConv2DWithBiasAndReluAndRequantize`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_type` attribute.
    pub fn out_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dilations` attribute.
    pub fn dilations<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dilations = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding_list` attribute.
    pub fn padding_list<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding_list = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantized_depthwise_conv2_dwith_bias_and_relu_and_requantize.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        filter: &T1,
        bias: &T2,
        min_input: &T3,
        max_input: &T4,
        min_filter: &T5,
        max_filter: &T6,
        min_freezed_output: &T7,
        max_freezed_output: &T8,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizedDepthwiseConv2DWithBiasAndReluAndRequantize")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&filter.to_handle(ctx)?)?;
        op.add_input(&bias.to_handle(ctx)?)?;
        op.add_input(&min_input.to_handle(ctx)?)?;
        op.add_input(&max_input.to_handle(ctx)?)?;
        op.add_input(&min_filter.to_handle(ctx)?)?;
        op.add_input(&max_filter.to_handle(ctx)?)?;
        op.add_input(&min_freezed_output.to_handle(ctx)?)?;
        op.add_input(&max_freezed_output.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_type {
            op.set_attr_type("out_type", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dilations {
            op.set_attr_int_list("dilations", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding_list {
            op.set_attr_int_list("padding_list", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `QuantizedDepthwiseConv2DWithBiasAndReluAndRequantize::new().call(&ctx, &input, &filter, &bias, &min_input, &max_input, &min_filter, &max_filter, &min_freezed_output, &max_freezed_output)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedDepthwiseConv2DWithBiasAndReluAndRequantize>
pub fn quantized_depthwise_conv2_dwith_bias_and_relu_and_requantize<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    filter: &T1,
    bias: &T2,
    min_input: &T3,
    max_input: &T4,
    min_filter: &T5,
    max_filter: &T6,
    min_freezed_output: &T7,
    max_freezed_output: &T8,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = QuantizedDepthwiseConv2DWithBiasAndReluAndRequantize::new();
    op.call(
        ctx,
        input,
        filter,
        bias,
        min_input,
        max_input,
        min_filter,
        max_filter,
        min_freezed_output,
        max_freezed_output,
    )
}

/// QuantizedInstanceNorm
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedInstanceNorm>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizedInstanceNorm {
    output_range_given: ::std::option::Option<bool>,
    given_y_min: ::std::option::Option<f32>,
    given_y_max: ::std::option::Option<f32>,
    variance_epsilon: ::std::option::Option<f32>,
    min_separation: ::std::option::Option<f32>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizedInstanceNorm {
    fn default() -> Self {
        Self {
            output_range_given: Some(false),
            given_y_min: Some(0f32),
            given_y_max: Some(0f32),
            variance_epsilon: Some(0.00001f32),
            min_separation: Some(0.001f32),
            target_device_name: None,
        }
    }
}
impl QuantizedInstanceNorm {
    /// Creates a new `QuantizedInstanceNorm`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_range_given` attribute.
    pub fn output_range_given<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_range_given = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `given_y_min` attribute.
    pub fn given_y_min<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.given_y_min = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `given_y_max` attribute.
    pub fn given_y_max<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.given_y_max = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `variance_epsilon` attribute.
    pub fn variance_epsilon<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.variance_epsilon = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `min_separation` attribute.
    pub fn min_separation<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.min_separation = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantized_instance_norm.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        x_min: &T1,
        x_max: &T2,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizedInstanceNorm")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&x_min.to_handle(ctx)?)?;
        op.add_input(&x_max.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_range_given {
            op.set_attr_bool("output_range_given", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.given_y_min {
            op.set_attr_float("given_y_min", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.given_y_max {
            op.set_attr_float("given_y_max", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.variance_epsilon {
            op.set_attr_float("variance_epsilon", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.min_separation {
            op.set_attr_float("min_separation", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `QuantizedInstanceNorm::new().call(&ctx, &x, &x_min, &x_max)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedInstanceNorm>
pub fn quantized_instance_norm<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    x_min: &T1,
    x_max: &T2,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = QuantizedInstanceNorm::new();
    op.call(ctx, x, x_min, x_max)
}

/// QuantizedMatMul
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedMatMul>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizedMatMul {
    Toutput: ::std::option::Option<crate::DataType>,
    transpose_a: ::std::option::Option<bool>,
    transpose_b: ::std::option::Option<bool>,
    Tactivation: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizedMatMul {
    fn default() -> Self {
        Self {
            Toutput: Some(crate::DataType::QInt32),
            transpose_a: Some(false),
            transpose_b: Some(false),
            Tactivation: Some(crate::DataType::QUInt8),
            target_device_name: None,
        }
    }
}
impl QuantizedMatMul {
    /// Creates a new `QuantizedMatMul`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Toutput` attribute.
    pub fn Toutput<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Toutput = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `transpose_a` attribute.
    pub fn transpose_a<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.transpose_a = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `transpose_b` attribute.
    pub fn transpose_b<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.transpose_b = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `Tactivation` attribute.
    pub fn Tactivation<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Tactivation = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantized_mat_mul.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        a: &T0,
        b: &T1,
        min_a: &T2,
        max_a: &T3,
        min_b: &T4,
        max_b: &T5,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizedMatMul")?;

        // Required input arguments
        op.add_input(&a.to_handle(ctx)?)?;
        op.add_input(&b.to_handle(ctx)?)?;
        op.add_input(&min_a.to_handle(ctx)?)?;
        op.add_input(&max_a.to_handle(ctx)?)?;
        op.add_input(&min_b.to_handle(ctx)?)?;
        op.add_input(&max_b.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Toutput {
            op.set_attr_type("Toutput", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.transpose_a {
            op.set_attr_bool("transpose_a", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.transpose_b {
            op.set_attr_bool("transpose_b", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.Tactivation {
            op.set_attr_type("Tactivation", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `QuantizedMatMul::new().call(&ctx, &a, &b, &min_a, &max_a, &min_b, &max_b)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedMatMul>
pub fn quantized_mat_mul<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    a: &T0,
    b: &T1,
    min_a: &T2,
    max_a: &T3,
    min_b: &T4,
    max_b: &T5,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = QuantizedMatMul::new();
    op.call(ctx, a, b, min_a, max_a, min_b, max_b)
}

/// QuantizedMatMulWithBias
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedMatMulWithBias>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizedMatMulWithBias {
    Toutput: ::std::option::Option<crate::DataType>,
    transpose_a: ::std::option::Option<bool>,
    transpose_b: ::std::option::Option<bool>,
    input_quant_mode: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizedMatMulWithBias {
    fn default() -> Self {
        Self {
            Toutput: Some(crate::DataType::QInt32),
            transpose_a: Some(false),
            transpose_b: Some(false),
            input_quant_mode: Some(::std::string::String::from("MIN_FIRST")),
            target_device_name: None,
        }
    }
}
impl QuantizedMatMulWithBias {
    /// Creates a new `QuantizedMatMulWithBias`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Toutput` attribute.
    pub fn Toutput<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Toutput = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `transpose_a` attribute.
    pub fn transpose_a<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.transpose_a = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `transpose_b` attribute.
    pub fn transpose_b<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.transpose_b = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `input_quant_mode` attribute.
    pub fn input_quant_mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.input_quant_mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantized_mat_mul_with_bias.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        a: &T0,
        b: &T1,
        bias: &T2,
        min_a: &T3,
        max_a: &T4,
        min_b: &T5,
        max_b: &T6,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizedMatMulWithBias")?;

        // Required input arguments
        op.add_input(&a.to_handle(ctx)?)?;
        op.add_input(&b.to_handle(ctx)?)?;
        op.add_input(&bias.to_handle(ctx)?)?;
        op.add_input(&min_a.to_handle(ctx)?)?;
        op.add_input(&max_a.to_handle(ctx)?)?;
        op.add_input(&min_b.to_handle(ctx)?)?;
        op.add_input(&max_b.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Toutput {
            op.set_attr_type("Toutput", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.transpose_a {
            op.set_attr_bool("transpose_a", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.transpose_b {
            op.set_attr_bool("transpose_b", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.input_quant_mode {
            op.set_attr_string("input_quant_mode", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `QuantizedMatMulWithBias::new().call(&ctx, &a, &b, &bias, &min_a, &max_a, &min_b, &max_b)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedMatMulWithBias>
pub fn quantized_mat_mul_with_bias<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    a: &T0,
    b: &T1,
    bias: &T2,
    min_a: &T3,
    max_a: &T4,
    min_b: &T5,
    max_b: &T6,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = QuantizedMatMulWithBias::new();
    op.call(ctx, a, b, bias, min_a, max_a, min_b, max_b)
}

/// QuantizedMatMulWithBiasAndDequantize
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedMatMulWithBiasAndDequantize>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizedMatMulWithBiasAndDequantize {
    Toutput: ::std::option::Option<crate::DataType>,
    transpose_a: ::std::option::Option<bool>,
    transpose_b: ::std::option::Option<bool>,
    input_quant_mode: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizedMatMulWithBiasAndDequantize {
    fn default() -> Self {
        Self {
            Toutput: None,
            transpose_a: Some(false),
            transpose_b: Some(false),
            input_quant_mode: Some(::std::string::String::from("MIN_FIRST")),
            target_device_name: None,
        }
    }
}
impl QuantizedMatMulWithBiasAndDequantize {
    /// Creates a new `QuantizedMatMulWithBiasAndDequantize`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Toutput` attribute.
    pub fn Toutput<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Toutput = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `transpose_a` attribute.
    pub fn transpose_a<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.transpose_a = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `transpose_b` attribute.
    pub fn transpose_b<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.transpose_b = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `input_quant_mode` attribute.
    pub fn input_quant_mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.input_quant_mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantized_mat_mul_with_bias_and_dequantize.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        a: &T0,
        b: &T1,
        bias: &T2,
        min_a: &T3,
        max_a: &T4,
        min_b: &T5,
        max_b: &T6,
        min_freezed_output: &T7,
        max_freezed_output: &T8,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizedMatMulWithBiasAndDequantize")?;

        // Required input arguments
        op.add_input(&a.to_handle(ctx)?)?;
        op.add_input(&b.to_handle(ctx)?)?;
        op.add_input(&bias.to_handle(ctx)?)?;
        op.add_input(&min_a.to_handle(ctx)?)?;
        op.add_input(&max_a.to_handle(ctx)?)?;
        op.add_input(&min_b.to_handle(ctx)?)?;
        op.add_input(&max_b.to_handle(ctx)?)?;
        op.add_input(&min_freezed_output.to_handle(ctx)?)?;
        op.add_input(&max_freezed_output.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Toutput {
            op.set_attr_type("Toutput", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.transpose_a {
            op.set_attr_bool("transpose_a", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.transpose_b {
            op.set_attr_bool("transpose_b", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.input_quant_mode {
            op.set_attr_string("input_quant_mode", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `QuantizedMatMulWithBiasAndDequantize::new().call(&ctx, &a, &b, &bias, &min_a, &max_a, &min_b, &max_b, &min_freezed_output, &max_freezed_output)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedMatMulWithBiasAndDequantize>
pub fn quantized_mat_mul_with_bias_and_dequantize<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    a: &T0,
    b: &T1,
    bias: &T2,
    min_a: &T3,
    max_a: &T4,
    min_b: &T5,
    max_b: &T6,
    min_freezed_output: &T7,
    max_freezed_output: &T8,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = QuantizedMatMulWithBiasAndDequantize::new();
    op.call(
        ctx,
        a,
        b,
        bias,
        min_a,
        max_a,
        min_b,
        max_b,
        min_freezed_output,
        max_freezed_output,
    )
}

/// QuantizedMatMulWithBiasAndRelu
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedMatMulWithBiasAndRelu>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizedMatMulWithBiasAndRelu {
    Toutput: ::std::option::Option<crate::DataType>,
    transpose_a: ::std::option::Option<bool>,
    transpose_b: ::std::option::Option<bool>,
    input_quant_mode: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizedMatMulWithBiasAndRelu {
    fn default() -> Self {
        Self {
            Toutput: Some(crate::DataType::QInt32),
            transpose_a: Some(false),
            transpose_b: Some(false),
            input_quant_mode: Some(::std::string::String::from("MIN_FIRST")),
            target_device_name: None,
        }
    }
}
impl QuantizedMatMulWithBiasAndRelu {
    /// Creates a new `QuantizedMatMulWithBiasAndRelu`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Toutput` attribute.
    pub fn Toutput<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Toutput = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `transpose_a` attribute.
    pub fn transpose_a<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.transpose_a = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `transpose_b` attribute.
    pub fn transpose_b<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.transpose_b = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `input_quant_mode` attribute.
    pub fn input_quant_mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.input_quant_mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantized_mat_mul_with_bias_and_relu.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        a: &T0,
        b: &T1,
        bias: &T2,
        min_a: &T3,
        max_a: &T4,
        min_b: &T5,
        max_b: &T6,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizedMatMulWithBiasAndRelu")?;

        // Required input arguments
        op.add_input(&a.to_handle(ctx)?)?;
        op.add_input(&b.to_handle(ctx)?)?;
        op.add_input(&bias.to_handle(ctx)?)?;
        op.add_input(&min_a.to_handle(ctx)?)?;
        op.add_input(&max_a.to_handle(ctx)?)?;
        op.add_input(&min_b.to_handle(ctx)?)?;
        op.add_input(&max_b.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Toutput {
            op.set_attr_type("Toutput", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.transpose_a {
            op.set_attr_bool("transpose_a", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.transpose_b {
            op.set_attr_bool("transpose_b", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.input_quant_mode {
            op.set_attr_string("input_quant_mode", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `QuantizedMatMulWithBiasAndRelu::new().call(&ctx, &a, &b, &bias, &min_a, &max_a, &min_b, &max_b)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedMatMulWithBiasAndRelu>
pub fn quantized_mat_mul_with_bias_and_relu<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    a: &T0,
    b: &T1,
    bias: &T2,
    min_a: &T3,
    max_a: &T4,
    min_b: &T5,
    max_b: &T6,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = QuantizedMatMulWithBiasAndRelu::new();
    op.call(ctx, a, b, bias, min_a, max_a, min_b, max_b)
}

/// QuantizedMatMulWithBiasAndReluAndRequantize
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedMatMulWithBiasAndReluAndRequantize>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizedMatMulWithBiasAndReluAndRequantize {
    Toutput: ::std::option::Option<crate::DataType>,
    transpose_a: ::std::option::Option<bool>,
    transpose_b: ::std::option::Option<bool>,
    input_quant_mode: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizedMatMulWithBiasAndReluAndRequantize {
    fn default() -> Self {
        Self {
            Toutput: Some(crate::DataType::QUInt8),
            transpose_a: Some(false),
            transpose_b: Some(false),
            input_quant_mode: Some(::std::string::String::from("MIN_FIRST")),
            target_device_name: None,
        }
    }
}
impl QuantizedMatMulWithBiasAndReluAndRequantize {
    /// Creates a new `QuantizedMatMulWithBiasAndReluAndRequantize`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Toutput` attribute.
    pub fn Toutput<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Toutput = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `transpose_a` attribute.
    pub fn transpose_a<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.transpose_a = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `transpose_b` attribute.
    pub fn transpose_b<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.transpose_b = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `input_quant_mode` attribute.
    pub fn input_quant_mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.input_quant_mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantized_mat_mul_with_bias_and_relu_and_requantize.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        a: &T0,
        b: &T1,
        bias: &T2,
        min_a: &T3,
        max_a: &T4,
        min_b: &T5,
        max_b: &T6,
        min_freezed_output: &T7,
        max_freezed_output: &T8,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizedMatMulWithBiasAndReluAndRequantize")?;

        // Required input arguments
        op.add_input(&a.to_handle(ctx)?)?;
        op.add_input(&b.to_handle(ctx)?)?;
        op.add_input(&bias.to_handle(ctx)?)?;
        op.add_input(&min_a.to_handle(ctx)?)?;
        op.add_input(&max_a.to_handle(ctx)?)?;
        op.add_input(&min_b.to_handle(ctx)?)?;
        op.add_input(&max_b.to_handle(ctx)?)?;
        op.add_input(&min_freezed_output.to_handle(ctx)?)?;
        op.add_input(&max_freezed_output.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Toutput {
            op.set_attr_type("Toutput", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.transpose_a {
            op.set_attr_bool("transpose_a", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.transpose_b {
            op.set_attr_bool("transpose_b", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.input_quant_mode {
            op.set_attr_string("input_quant_mode", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `QuantizedMatMulWithBiasAndReluAndRequantize::new().call(&ctx, &a, &b, &bias, &min_a, &max_a, &min_b, &max_b, &min_freezed_output, &max_freezed_output)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedMatMulWithBiasAndReluAndRequantize>
pub fn quantized_mat_mul_with_bias_and_relu_and_requantize<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    a: &T0,
    b: &T1,
    bias: &T2,
    min_a: &T3,
    max_a: &T4,
    min_b: &T5,
    max_b: &T6,
    min_freezed_output: &T7,
    max_freezed_output: &T8,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = QuantizedMatMulWithBiasAndReluAndRequantize::new();
    op.call(
        ctx,
        a,
        b,
        bias,
        min_a,
        max_a,
        min_b,
        max_b,
        min_freezed_output,
        max_freezed_output,
    )
}

/// QuantizedMatMulWithBiasAndRequantize
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedMatMulWithBiasAndRequantize>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizedMatMulWithBiasAndRequantize {
    Toutput: ::std::option::Option<crate::DataType>,
    transpose_a: ::std::option::Option<bool>,
    transpose_b: ::std::option::Option<bool>,
    input_quant_mode: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizedMatMulWithBiasAndRequantize {
    fn default() -> Self {
        Self {
            Toutput: Some(crate::DataType::QUInt8),
            transpose_a: Some(false),
            transpose_b: Some(false),
            input_quant_mode: Some(::std::string::String::from("MIN_FIRST")),
            target_device_name: None,
        }
    }
}
impl QuantizedMatMulWithBiasAndRequantize {
    /// Creates a new `QuantizedMatMulWithBiasAndRequantize`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Toutput` attribute.
    pub fn Toutput<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Toutput = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `transpose_a` attribute.
    pub fn transpose_a<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.transpose_a = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `transpose_b` attribute.
    pub fn transpose_b<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.transpose_b = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `input_quant_mode` attribute.
    pub fn input_quant_mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.input_quant_mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantized_mat_mul_with_bias_and_requantize.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        a: &T0,
        b: &T1,
        bias: &T2,
        min_a: &T3,
        max_a: &T4,
        min_b: &T5,
        max_b: &T6,
        min_freezed_output: &T7,
        max_freezed_output: &T8,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizedMatMulWithBiasAndRequantize")?;

        // Required input arguments
        op.add_input(&a.to_handle(ctx)?)?;
        op.add_input(&b.to_handle(ctx)?)?;
        op.add_input(&bias.to_handle(ctx)?)?;
        op.add_input(&min_a.to_handle(ctx)?)?;
        op.add_input(&max_a.to_handle(ctx)?)?;
        op.add_input(&min_b.to_handle(ctx)?)?;
        op.add_input(&max_b.to_handle(ctx)?)?;
        op.add_input(&min_freezed_output.to_handle(ctx)?)?;
        op.add_input(&max_freezed_output.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Toutput {
            op.set_attr_type("Toutput", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.transpose_a {
            op.set_attr_bool("transpose_a", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.transpose_b {
            op.set_attr_bool("transpose_b", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.input_quant_mode {
            op.set_attr_string("input_quant_mode", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `QuantizedMatMulWithBiasAndRequantize::new().call(&ctx, &a, &b, &bias, &min_a, &max_a, &min_b, &max_b, &min_freezed_output, &max_freezed_output)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedMatMulWithBiasAndRequantize>
pub fn quantized_mat_mul_with_bias_and_requantize<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    a: &T0,
    b: &T1,
    bias: &T2,
    min_a: &T3,
    max_a: &T4,
    min_b: &T5,
    max_b: &T6,
    min_freezed_output: &T7,
    max_freezed_output: &T8,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = QuantizedMatMulWithBiasAndRequantize::new();
    op.call(
        ctx,
        a,
        b,
        bias,
        min_a,
        max_a,
        min_b,
        max_b,
        min_freezed_output,
        max_freezed_output,
    )
}

/// QuantizedMaxPool
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedMaxPool>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizedMaxPool {
    ksize: ::std::option::Option<::std::vec::Vec<i64>>,
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    padding: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizedMaxPool {
    fn default() -> Self {
        Self {
            ksize: None,
            strides: None,
            padding: None,
            target_device_name: None,
        }
    }
}
impl QuantizedMaxPool {
    /// Creates a new `QuantizedMaxPool`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `ksize` attribute.
    pub fn ksize<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.ksize = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding` attribute.
    pub fn padding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantized_max_pool.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        min_input: &T1,
        max_input: &T2,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizedMaxPool")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&min_input.to_handle(ctx)?)?;
        op.add_input(&max_input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.ksize {
            op.set_attr_int_list("ksize", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding {
            op.set_attr_string("padding", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `QuantizedMaxPool::new().call(&ctx, &input, &min_input, &max_input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedMaxPool>
pub fn quantized_max_pool<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    min_input: &T1,
    max_input: &T2,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = QuantizedMaxPool::new();
    op.call(ctx, input, min_input, max_input)
}

/// QuantizedMul
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedMul>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizedMul {
    Toutput: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizedMul {
    fn default() -> Self {
        Self {
            Toutput: Some(crate::DataType::QInt32),
            target_device_name: None,
        }
    }
}
impl QuantizedMul {
    /// Creates a new `QuantizedMul`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Toutput` attribute.
    pub fn Toutput<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Toutput = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantized_mul.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
        min_x: &T2,
        max_x: &T3,
        min_y: &T4,
        max_y: &T5,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizedMul")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;
        op.add_input(&min_x.to_handle(ctx)?)?;
        op.add_input(&max_x.to_handle(ctx)?)?;
        op.add_input(&min_y.to_handle(ctx)?)?;
        op.add_input(&max_y.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Toutput {
            op.set_attr_type("Toutput", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `QuantizedMul::new().call(&ctx, &x, &y, &min_x, &max_x, &min_y, &max_y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedMul>
pub fn quantized_mul<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
    min_x: &T2,
    max_x: &T3,
    min_y: &T4,
    max_y: &T5,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = QuantizedMul::new();
    op.call(ctx, x, y, min_x, max_x, min_y, max_y)
}

/// QuantizedRelu
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedRelu>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizedRelu {
    out_type: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizedRelu {
    fn default() -> Self {
        Self {
            out_type: Some(crate::DataType::QUInt8),
            target_device_name: None,
        }
    }
}
impl QuantizedRelu {
    /// Creates a new `QuantizedRelu`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_type` attribute.
    pub fn out_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantized_relu.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        features: &T0,
        min_features: &T1,
        max_features: &T2,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizedRelu")?;

        // Required input arguments
        op.add_input(&features.to_handle(ctx)?)?;
        op.add_input(&min_features.to_handle(ctx)?)?;
        op.add_input(&max_features.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_type {
            op.set_attr_type("out_type", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `QuantizedRelu::new().call(&ctx, &features, &min_features, &max_features)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedRelu>
pub fn quantized_relu<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    features: &T0,
    min_features: &T1,
    max_features: &T2,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = QuantizedRelu::new();
    op.call(ctx, features, min_features, max_features)
}

/// QuantizedRelu6
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedRelu6>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizedRelu6 {
    out_type: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizedRelu6 {
    fn default() -> Self {
        Self {
            out_type: Some(crate::DataType::QUInt8),
            target_device_name: None,
        }
    }
}
impl QuantizedRelu6 {
    /// Creates a new `QuantizedRelu6`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_type` attribute.
    pub fn out_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantized_relu6.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        features: &T0,
        min_features: &T1,
        max_features: &T2,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizedRelu6")?;

        // Required input arguments
        op.add_input(&features.to_handle(ctx)?)?;
        op.add_input(&min_features.to_handle(ctx)?)?;
        op.add_input(&max_features.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_type {
            op.set_attr_type("out_type", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `QuantizedRelu6::new().call(&ctx, &features, &min_features, &max_features)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedRelu6>
pub fn quantized_relu6<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    features: &T0,
    min_features: &T1,
    max_features: &T2,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = QuantizedRelu6::new();
    op.call(ctx, features, min_features, max_features)
}

/// QuantizedReluX
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedReluX>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizedReluX {
    out_type: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizedReluX {
    fn default() -> Self {
        Self {
            out_type: Some(crate::DataType::QUInt8),
            target_device_name: None,
        }
    }
}
impl QuantizedReluX {
    /// Creates a new `QuantizedReluX`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_type` attribute.
    pub fn out_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantized_relu_x.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        features: &T0,
        max_value: &T1,
        min_features: &T2,
        max_features: &T3,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizedReluX")?;

        // Required input arguments
        op.add_input(&features.to_handle(ctx)?)?;
        op.add_input(&max_value.to_handle(ctx)?)?;
        op.add_input(&min_features.to_handle(ctx)?)?;
        op.add_input(&max_features.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_type {
            op.set_attr_type("out_type", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `QuantizedReluX::new().call(&ctx, &features, &max_value, &min_features, &max_features)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedReluX>
pub fn quantized_relu_x<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    features: &T0,
    max_value: &T1,
    min_features: &T2,
    max_features: &T3,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = QuantizedReluX::new();
    op.call(ctx, features, max_value, min_features, max_features)
}

/// QuantizedReshape
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedReshape>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizedReshape {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizedReshape {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl QuantizedReshape {
    /// Creates a new `QuantizedReshape`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantized_reshape.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        tensor: &T0,
        shape: &T1,
        input_min: &T2,
        input_max: &T3,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizedReshape")?;

        // Required input arguments
        op.add_input(&tensor.to_handle(ctx)?)?;
        op.add_input(&shape.to_handle(ctx)?)?;
        op.add_input(&input_min.to_handle(ctx)?)?;
        op.add_input(&input_max.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `QuantizedReshape::new().call(&ctx, &tensor, &shape, &input_min, &input_max)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedReshape>
pub fn quantized_reshape<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    tensor: &T0,
    shape: &T1,
    input_min: &T2,
    input_max: &T3,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = QuantizedReshape::new();
    op.call(ctx, tensor, shape, input_min, input_max)
}

/// QuantizedResizeBilinear
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedResizeBilinear>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QuantizedResizeBilinear {
    align_corners: ::std::option::Option<bool>,
    half_pixel_centers: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QuantizedResizeBilinear {
    fn default() -> Self {
        Self {
            align_corners: Some(false),
            half_pixel_centers: Some(false),
            target_device_name: None,
        }
    }
}
impl QuantizedResizeBilinear {
    /// Creates a new `QuantizedResizeBilinear`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `align_corners` attribute.
    pub fn align_corners<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.align_corners = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `half_pixel_centers` attribute.
    pub fn half_pixel_centers<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.half_pixel_centers = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute quantized_resize_bilinear.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        images: &T0,
        size: &T1,
        min: &T2,
        max: &T3,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "QuantizedResizeBilinear")?;

        // Required input arguments
        op.add_input(&images.to_handle(ctx)?)?;
        op.add_input(&size.to_handle(ctx)?)?;
        op.add_input(&min.to_handle(ctx)?)?;
        op.add_input(&max.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.align_corners {
            op.set_attr_bool("align_corners", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.half_pixel_centers {
            op.set_attr_bool("half_pixel_centers", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `QuantizedResizeBilinear::new().call(&ctx, &images, &size, &min, &max)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QuantizedResizeBilinear>
pub fn quantized_resize_bilinear<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    images: &T0,
    size: &T1,
    min: &T2,
    max: &T3,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = QuantizedResizeBilinear::new();
    op.call(ctx, images, size, min, max)
}

/// QueueClose
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QueueClose>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QueueClose {
    cancel_pending_enqueues: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QueueClose {
    fn default() -> Self {
        Self {
            cancel_pending_enqueues: Some(false),
            target_device_name: None,
        }
    }
}
impl QueueClose {
    /// Creates a new `QueueClose`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `cancel_pending_enqueues` attribute.
    pub fn cancel_pending_enqueues<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.cancel_pending_enqueues = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute queue_close.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "QueueClose")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.cancel_pending_enqueues {
            op.set_attr_bool("cancel_pending_enqueues", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `QueueClose::new().call(&ctx, &handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QueueClose>
pub fn queue_close<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
) -> crate::Result<()> {
    let op = QueueClose::new();
    op.call(ctx, handle)
}

/// QueueCloseV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QueueCloseV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QueueCloseV2 {
    cancel_pending_enqueues: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QueueCloseV2 {
    fn default() -> Self {
        Self {
            cancel_pending_enqueues: Some(false),
            target_device_name: None,
        }
    }
}
impl QueueCloseV2 {
    /// Creates a new `QueueCloseV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `cancel_pending_enqueues` attribute.
    pub fn cancel_pending_enqueues<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.cancel_pending_enqueues = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute queue_close_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "QueueCloseV2")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.cancel_pending_enqueues {
            op.set_attr_bool("cancel_pending_enqueues", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `QueueCloseV2::new().call(&ctx, &handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QueueCloseV2>
pub fn queue_close_v2<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
) -> crate::Result<()> {
    let op = QueueCloseV2::new();
    op.call(ctx, handle)
}

/// QueueDequeue
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QueueDequeue>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QueueDequeue {
    component_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    timeout_ms: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QueueDequeue {
    fn default() -> Self {
        Self {
            component_types: None,
            timeout_ms: Some(-1i64),
            target_device_name: None,
        }
    }
}
impl QueueDequeue {
    /// Creates a new `QueueDequeue`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `component_types` attribute.
    pub fn component_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.component_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `timeout_ms` attribute.
    pub fn timeout_ms<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.timeout_ms = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute queue_dequeue.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "QueueDequeue")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.component_types {
            op.set_attr_type_list("component_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.timeout_ms {
            op.set_attr_int("timeout_ms", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `QueueDequeue::new().call(&ctx, &handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QueueDequeue>
pub fn queue_dequeue<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = QueueDequeue::new();
    op.call(ctx, handle)
}

/// QueueDequeueMany
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QueueDequeueMany>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QueueDequeueMany {
    component_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    timeout_ms: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QueueDequeueMany {
    fn default() -> Self {
        Self {
            component_types: None,
            timeout_ms: Some(-1i64),
            target_device_name: None,
        }
    }
}
impl QueueDequeueMany {
    /// Creates a new `QueueDequeueMany`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `component_types` attribute.
    pub fn component_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.component_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `timeout_ms` attribute.
    pub fn timeout_ms<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.timeout_ms = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute queue_dequeue_many.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        n: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "QueueDequeueMany")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&n.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.component_types {
            op.set_attr_type_list("component_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.timeout_ms {
            op.set_attr_int("timeout_ms", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `QueueDequeueMany::new().call(&ctx, &handle, &n)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QueueDequeueMany>
pub fn queue_dequeue_many<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    n: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = QueueDequeueMany::new();
    op.call(ctx, handle, n)
}

/// QueueDequeueManyV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QueueDequeueManyV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QueueDequeueManyV2 {
    component_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    timeout_ms: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QueueDequeueManyV2 {
    fn default() -> Self {
        Self {
            component_types: None,
            timeout_ms: Some(-1i64),
            target_device_name: None,
        }
    }
}
impl QueueDequeueManyV2 {
    /// Creates a new `QueueDequeueManyV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `component_types` attribute.
    pub fn component_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.component_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `timeout_ms` attribute.
    pub fn timeout_ms<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.timeout_ms = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute queue_dequeue_many_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        n: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "QueueDequeueManyV2")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&n.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.component_types {
            op.set_attr_type_list("component_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.timeout_ms {
            op.set_attr_int("timeout_ms", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `QueueDequeueManyV2::new().call(&ctx, &handle, &n)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QueueDequeueManyV2>
pub fn queue_dequeue_many_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    n: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = QueueDequeueManyV2::new();
    op.call(ctx, handle, n)
}

/// QueueDequeueUpTo
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QueueDequeueUpTo>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QueueDequeueUpTo {
    component_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    timeout_ms: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QueueDequeueUpTo {
    fn default() -> Self {
        Self {
            component_types: None,
            timeout_ms: Some(-1i64),
            target_device_name: None,
        }
    }
}
impl QueueDequeueUpTo {
    /// Creates a new `QueueDequeueUpTo`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `component_types` attribute.
    pub fn component_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.component_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `timeout_ms` attribute.
    pub fn timeout_ms<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.timeout_ms = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute queue_dequeue_up_to.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        n: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "QueueDequeueUpTo")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&n.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.component_types {
            op.set_attr_type_list("component_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.timeout_ms {
            op.set_attr_int("timeout_ms", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `QueueDequeueUpTo::new().call(&ctx, &handle, &n)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QueueDequeueUpTo>
pub fn queue_dequeue_up_to<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    n: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = QueueDequeueUpTo::new();
    op.call(ctx, handle, n)
}

/// QueueDequeueUpToV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QueueDequeueUpToV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QueueDequeueUpToV2 {
    component_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    timeout_ms: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QueueDequeueUpToV2 {
    fn default() -> Self {
        Self {
            component_types: None,
            timeout_ms: Some(-1i64),
            target_device_name: None,
        }
    }
}
impl QueueDequeueUpToV2 {
    /// Creates a new `QueueDequeueUpToV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `component_types` attribute.
    pub fn component_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.component_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `timeout_ms` attribute.
    pub fn timeout_ms<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.timeout_ms = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute queue_dequeue_up_to_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        n: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "QueueDequeueUpToV2")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&n.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.component_types {
            op.set_attr_type_list("component_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.timeout_ms {
            op.set_attr_int("timeout_ms", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `QueueDequeueUpToV2::new().call(&ctx, &handle, &n)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QueueDequeueUpToV2>
pub fn queue_dequeue_up_to_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    n: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = QueueDequeueUpToV2::new();
    op.call(ctx, handle, n)
}

/// QueueDequeueV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QueueDequeueV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QueueDequeueV2 {
    component_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    timeout_ms: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QueueDequeueV2 {
    fn default() -> Self {
        Self {
            component_types: None,
            timeout_ms: Some(-1i64),
            target_device_name: None,
        }
    }
}
impl QueueDequeueV2 {
    /// Creates a new `QueueDequeueV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `component_types` attribute.
    pub fn component_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.component_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `timeout_ms` attribute.
    pub fn timeout_ms<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.timeout_ms = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute queue_dequeue_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "QueueDequeueV2")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.component_types {
            op.set_attr_type_list("component_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.timeout_ms {
            op.set_attr_int("timeout_ms", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `QueueDequeueV2::new().call(&ctx, &handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QueueDequeueV2>
pub fn queue_dequeue_v2<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = QueueDequeueV2::new();
    op.call(ctx, handle)
}

/// QueueEnqueue
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QueueEnqueue>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QueueEnqueue {
    timeout_ms: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QueueEnqueue {
    fn default() -> Self {
        Self {
            timeout_ms: Some(-1i64),
            target_device_name: None,
        }
    }
}
impl QueueEnqueue {
    /// Creates a new `QueueEnqueue`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `timeout_ms` attribute.
    pub fn timeout_ms<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.timeout_ms = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute queue_enqueue.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        components: &T1,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "QueueEnqueue")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&components.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.timeout_ms {
            op.set_attr_int("timeout_ms", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `QueueEnqueue::new().call(&ctx, &handle, &components)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QueueEnqueue>
pub fn queue_enqueue<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    components: &T1,
) -> crate::Result<()> {
    let op = QueueEnqueue::new();
    op.call(ctx, handle, components)
}

/// QueueEnqueueMany
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QueueEnqueueMany>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QueueEnqueueMany {
    timeout_ms: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QueueEnqueueMany {
    fn default() -> Self {
        Self {
            timeout_ms: Some(-1i64),
            target_device_name: None,
        }
    }
}
impl QueueEnqueueMany {
    /// Creates a new `QueueEnqueueMany`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `timeout_ms` attribute.
    pub fn timeout_ms<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.timeout_ms = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute queue_enqueue_many.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        components: &T1,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "QueueEnqueueMany")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&components.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.timeout_ms {
            op.set_attr_int("timeout_ms", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `QueueEnqueueMany::new().call(&ctx, &handle, &components)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QueueEnqueueMany>
pub fn queue_enqueue_many<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    components: &T1,
) -> crate::Result<()> {
    let op = QueueEnqueueMany::new();
    op.call(ctx, handle, components)
}

/// QueueEnqueueManyV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QueueEnqueueManyV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QueueEnqueueManyV2 {
    timeout_ms: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QueueEnqueueManyV2 {
    fn default() -> Self {
        Self {
            timeout_ms: Some(-1i64),
            target_device_name: None,
        }
    }
}
impl QueueEnqueueManyV2 {
    /// Creates a new `QueueEnqueueManyV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `timeout_ms` attribute.
    pub fn timeout_ms<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.timeout_ms = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute queue_enqueue_many_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        components: &T1,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "QueueEnqueueManyV2")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&components.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.timeout_ms {
            op.set_attr_int("timeout_ms", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `QueueEnqueueManyV2::new().call(&ctx, &handle, &components)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QueueEnqueueManyV2>
pub fn queue_enqueue_many_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    components: &T1,
) -> crate::Result<()> {
    let op = QueueEnqueueManyV2::new();
    op.call(ctx, handle, components)
}

/// QueueEnqueueV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QueueEnqueueV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QueueEnqueueV2 {
    timeout_ms: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QueueEnqueueV2 {
    fn default() -> Self {
        Self {
            timeout_ms: Some(-1i64),
            target_device_name: None,
        }
    }
}
impl QueueEnqueueV2 {
    /// Creates a new `QueueEnqueueV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `timeout_ms` attribute.
    pub fn timeout_ms<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.timeout_ms = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute queue_enqueue_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        components: &T1,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "QueueEnqueueV2")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&components.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.timeout_ms {
            op.set_attr_int("timeout_ms", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `QueueEnqueueV2::new().call(&ctx, &handle, &components)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QueueEnqueueV2>
pub fn queue_enqueue_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    components: &T1,
) -> crate::Result<()> {
    let op = QueueEnqueueV2::new();
    op.call(ctx, handle, components)
}

/// QueueIsClosed
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QueueIsClosed>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QueueIsClosed {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QueueIsClosed {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl QueueIsClosed {
    /// Creates a new `QueueIsClosed`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute queue_is_closed.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "QueueIsClosed")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `QueueIsClosed::new().call(&ctx, &handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QueueIsClosed>
pub fn queue_is_closed<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = QueueIsClosed::new();
    op.call(ctx, handle)
}

/// QueueIsClosedV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QueueIsClosedV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QueueIsClosedV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QueueIsClosedV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl QueueIsClosedV2 {
    /// Creates a new `QueueIsClosedV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute queue_is_closed_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "QueueIsClosedV2")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `QueueIsClosedV2::new().call(&ctx, &handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QueueIsClosedV2>
pub fn queue_is_closed_v2<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = QueueIsClosedV2::new();
    op.call(ctx, handle)
}

/// QueueSize
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QueueSize>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QueueSize {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QueueSize {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl QueueSize {
    /// Creates a new `QueueSize`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute queue_size.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "QueueSize")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `QueueSize::new().call(&ctx, &handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QueueSize>
pub fn queue_size<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = QueueSize::new();
    op.call(ctx, handle)
}

/// QueueSizeV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QueueSizeV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct QueueSizeV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for QueueSizeV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl QueueSizeV2 {
    /// Creates a new `QueueSizeV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute queue_size_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "QueueSizeV2")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `QueueSizeV2::new().call(&ctx, &handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/QueueSizeV2>
pub fn queue_size_v2<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = QueueSizeV2::new();
    op.call(ctx, handle)
}

/// RFFT
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RFFT>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RFFT {
    Tcomplex: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RFFT {
    fn default() -> Self {
        Self {
            Tcomplex: Some(crate::DataType::Complex64),
            target_device_name: None,
        }
    }
}
impl RFFT {
    /// Creates a new `RFFT`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Tcomplex` attribute.
    pub fn Tcomplex<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Tcomplex = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute rfft.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        fft_length: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RFFT")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&fft_length.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Tcomplex {
            op.set_attr_type("Tcomplex", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RFFT::new().call(&ctx, &input, &fft_length)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RFFT>
pub fn rfft<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    fft_length: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RFFT::new();
    op.call(ctx, input, fft_length)
}

/// RFFT2D
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RFFT2D>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RFFT2D {
    Tcomplex: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RFFT2D {
    fn default() -> Self {
        Self {
            Tcomplex: Some(crate::DataType::Complex64),
            target_device_name: None,
        }
    }
}
impl RFFT2D {
    /// Creates a new `RFFT2D`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Tcomplex` attribute.
    pub fn Tcomplex<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Tcomplex = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute rfft2_d.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        fft_length: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RFFT2D")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&fft_length.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Tcomplex {
            op.set_attr_type("Tcomplex", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RFFT2D::new().call(&ctx, &input, &fft_length)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RFFT2D>
pub fn rfft2_d<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    fft_length: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RFFT2D::new();
    op.call(ctx, input, fft_length)
}

/// RFFT3D
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RFFT3D>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RFFT3D {
    Tcomplex: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RFFT3D {
    fn default() -> Self {
        Self {
            Tcomplex: Some(crate::DataType::Complex64),
            target_device_name: None,
        }
    }
}
impl RFFT3D {
    /// Creates a new `RFFT3D`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Tcomplex` attribute.
    pub fn Tcomplex<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Tcomplex = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute rfft3_d.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        fft_length: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RFFT3D")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&fft_length.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Tcomplex {
            op.set_attr_type("Tcomplex", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RFFT3D::new().call(&ctx, &input, &fft_length)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RFFT3D>
pub fn rfft3_d<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    fft_length: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RFFT3D::new();
    op.call(ctx, input, fft_length)
}

/// RGBToHSV
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RGBToHSV>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RGBToHSV {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RGBToHSV {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RGBToHSV {
    /// Creates a new `RGBToHSV`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute rgbto_hsv.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        images: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RGBToHSV")?;

        // Required input arguments
        op.add_input(&images.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RGBToHSV::new().call(&ctx, &images)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RGBToHSV>
pub fn rgbto_hsv<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    images: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RGBToHSV::new();
    op.call(ctx, images)
}

/// RaggedBincount
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RaggedBincount>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RaggedBincount {
    binary_output: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RaggedBincount {
    fn default() -> Self {
        Self {
            binary_output: Some(false),
            target_device_name: None,
        }
    }
}
impl RaggedBincount {
    /// Creates a new `RaggedBincount`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `binary_output` attribute.
    pub fn binary_output<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.binary_output = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute ragged_bincount.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        splits: &T0,
        values: &T1,
        size: &T2,
        weights: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RaggedBincount")?;

        // Required input arguments
        op.add_input(&splits.to_handle(ctx)?)?;
        op.add_input(&values.to_handle(ctx)?)?;
        op.add_input(&size.to_handle(ctx)?)?;
        op.add_input(&weights.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.binary_output {
            op.set_attr_bool("binary_output", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RaggedBincount::new().call(&ctx, &splits, &values, &size, &weights)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RaggedBincount>
pub fn ragged_bincount<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    splits: &T0,
    values: &T1,
    size: &T2,
    weights: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RaggedBincount::new();
    op.call(ctx, splits, values, size, weights)
}

/// RaggedCountSparseOutput
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RaggedCountSparseOutput>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RaggedCountSparseOutput {
    minlength: ::std::option::Option<i64>,
    maxlength: ::std::option::Option<i64>,
    binary_output: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RaggedCountSparseOutput {
    fn default() -> Self {
        Self {
            minlength: Some(-1i64),
            maxlength: Some(-1i64),
            binary_output: None,
            target_device_name: None,
        }
    }
}
impl RaggedCountSparseOutput {
    /// Creates a new `RaggedCountSparseOutput`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `minlength` attribute.
    pub fn minlength<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.minlength = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `maxlength` attribute.
    pub fn maxlength<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.maxlength = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `binary_output` attribute.
    pub fn binary_output<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.binary_output = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute ragged_count_sparse_output.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        splits: &T0,
        values: &T1,
        weights: &T2,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "RaggedCountSparseOutput")?;

        // Required input arguments
        op.add_input(&splits.to_handle(ctx)?)?;
        op.add_input(&values.to_handle(ctx)?)?;
        op.add_input(&weights.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.minlength {
            op.set_attr_int("minlength", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.maxlength {
            op.set_attr_int("maxlength", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.binary_output {
            op.set_attr_bool("binary_output", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `RaggedCountSparseOutput::new().call(&ctx, &splits, &values, &weights)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RaggedCountSparseOutput>
pub fn ragged_count_sparse_output<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    splits: &T0,
    values: &T1,
    weights: &T2,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = RaggedCountSparseOutput::new();
    op.call(ctx, splits, values, weights)
}

/// RaggedCross
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RaggedCross>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RaggedCross {
    input_order: ::std::option::Option<::std::string::String>,
    hashed_output: ::std::option::Option<bool>,
    num_buckets: ::std::option::Option<i64>,
    hash_key: ::std::option::Option<i64>,
    out_values_type: ::std::option::Option<crate::DataType>,
    out_row_splits_type: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RaggedCross {
    fn default() -> Self {
        Self {
            input_order: None,
            hashed_output: None,
            num_buckets: None,
            hash_key: None,
            out_values_type: None,
            out_row_splits_type: None,
            target_device_name: None,
        }
    }
}
impl RaggedCross {
    /// Creates a new `RaggedCross`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `input_order` attribute.
    pub fn input_order<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.input_order = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `hashed_output` attribute.
    pub fn hashed_output<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.hashed_output = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_buckets` attribute.
    pub fn num_buckets<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_buckets = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `hash_key` attribute.
    pub fn hash_key<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.hash_key = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `out_values_type` attribute.
    pub fn out_values_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_values_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `out_row_splits_type` attribute.
    pub fn out_row_splits_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_row_splits_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute ragged_cross.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        ragged_values: &T0,
        ragged_row_splits: &T1,
        sparse_indices: &[&T2],
        sparse_values: &T3,
        sparse_shape: &[&T4],
        dense_inputs: &T5,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "RaggedCross")?;

        // Required input arguments
        op.add_input(&ragged_values.to_handle(ctx)?)?;
        op.add_input(&ragged_row_splits.to_handle(ctx)?)?;
        let mut sparse_indices_list = Vec::new();

        for t in sparse_indices {
            sparse_indices_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&sparse_indices_list)?;
        op.add_input(&sparse_values.to_handle(ctx)?)?;
        let mut sparse_shape_list = Vec::new();

        for t in sparse_shape {
            sparse_shape_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&sparse_shape_list)?;
        op.add_input(&dense_inputs.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.input_order {
            op.set_attr_string("input_order", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.hashed_output {
            op.set_attr_bool("hashed_output", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_buckets {
            op.set_attr_int("num_buckets", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.hash_key {
            op.set_attr_int("hash_key", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.out_values_type {
            op.set_attr_type("out_values_type", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.out_row_splits_type {
            op.set_attr_type("out_row_splits_type", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `RaggedCross::new().call(&ctx, &ragged_values, &ragged_row_splits, &sparse_indices, &sparse_values, &sparse_shape, &dense_inputs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RaggedCross>
pub fn ragged_cross<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    ragged_values: &T0,
    ragged_row_splits: &T1,
    sparse_indices: &[&T2],
    sparse_values: &T3,
    sparse_shape: &[&T4],
    dense_inputs: &T5,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = RaggedCross::new();
    op.call(
        ctx,
        ragged_values,
        ragged_row_splits,
        sparse_indices,
        sparse_values,
        sparse_shape,
        dense_inputs,
    )
}

/// RaggedGather
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RaggedGather>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RaggedGather {
    OUTPUT_RAGGED_RANK: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RaggedGather {
    fn default() -> Self {
        Self {
            OUTPUT_RAGGED_RANK: None,
            target_device_name: None,
        }
    }
}
impl RaggedGather {
    /// Creates a new `RaggedGather`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `OUTPUT_RAGGED_RANK` attribute.
    pub fn OUTPUT_RAGGED_RANK<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.OUTPUT_RAGGED_RANK = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute ragged_gather.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        params_nested_splits: &[&T0],
        params_dense_values: &T1,
        indices: &T2,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "RaggedGather")?;

        // Required input arguments
        let mut params_nested_splits_list = Vec::new();

        for t in params_nested_splits {
            params_nested_splits_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&params_nested_splits_list)?;
        op.add_input(&params_dense_values.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.OUTPUT_RAGGED_RANK {
            op.set_attr_int("OUTPUT_RAGGED_RANK", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `RaggedGather::new().call(&ctx, &params_nested_splits, &params_dense_values, &indices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RaggedGather>
pub fn ragged_gather<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    params_nested_splits: &[&T0],
    params_dense_values: &T1,
    indices: &T2,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = RaggedGather::new();
    op.call(ctx, params_nested_splits, params_dense_values, indices)
}

/// RaggedRange
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RaggedRange>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RaggedRange {
    Tsplits: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RaggedRange {
    fn default() -> Self {
        Self {
            Tsplits: Some(crate::DataType::Int64),
            target_device_name: None,
        }
    }
}
impl RaggedRange {
    /// Creates a new `RaggedRange`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Tsplits` attribute.
    pub fn Tsplits<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Tsplits = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute ragged_range.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        starts: &T0,
        limits: &T1,
        deltas: &T2,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "RaggedRange")?;

        // Required input arguments
        op.add_input(&starts.to_handle(ctx)?)?;
        op.add_input(&limits.to_handle(ctx)?)?;
        op.add_input(&deltas.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Tsplits {
            op.set_attr_type("Tsplits", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `RaggedRange::new().call(&ctx, &starts, &limits, &deltas)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RaggedRange>
pub fn ragged_range<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    starts: &T0,
    limits: &T1,
    deltas: &T2,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = RaggedRange::new();
    op.call(ctx, starts, limits, deltas)
}

/// RaggedTensorFromVariant
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RaggedTensorFromVariant>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RaggedTensorFromVariant {
    input_ragged_rank: ::std::option::Option<i64>,
    output_ragged_rank: ::std::option::Option<i64>,
    Tvalues: ::std::option::Option<crate::DataType>,
    Tsplits: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RaggedTensorFromVariant {
    fn default() -> Self {
        Self {
            input_ragged_rank: None,
            output_ragged_rank: None,
            Tvalues: None,
            Tsplits: Some(crate::DataType::Int64),
            target_device_name: None,
        }
    }
}
impl RaggedTensorFromVariant {
    /// Creates a new `RaggedTensorFromVariant`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `input_ragged_rank` attribute.
    pub fn input_ragged_rank<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.input_ragged_rank = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_ragged_rank` attribute.
    pub fn output_ragged_rank<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_ragged_rank = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `Tvalues` attribute.
    pub fn Tvalues<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Tvalues = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `Tsplits` attribute.
    pub fn Tsplits<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Tsplits = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute ragged_tensor_from_variant.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        encoded_ragged: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "RaggedTensorFromVariant")?;

        // Required input arguments
        op.add_input(&encoded_ragged.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.input_ragged_rank {
            op.set_attr_int("input_ragged_rank", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_ragged_rank {
            op.set_attr_int("output_ragged_rank", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.Tvalues {
            op.set_attr_type("Tvalues", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.Tsplits {
            op.set_attr_type("Tsplits", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `RaggedTensorFromVariant::new().call(&ctx, &encoded_ragged)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RaggedTensorFromVariant>
pub fn ragged_tensor_from_variant<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    encoded_ragged: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = RaggedTensorFromVariant::new();
    op.call(ctx, encoded_ragged)
}

/// RaggedTensorToSparse
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RaggedTensorToSparse>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RaggedTensorToSparse {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RaggedTensorToSparse {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RaggedTensorToSparse {
    /// Creates a new `RaggedTensorToSparse`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute ragged_tensor_to_sparse.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        rt_nested_splits: &[&T0],
        rt_dense_values: &T1,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "RaggedTensorToSparse")?;

        // Required input arguments
        let mut rt_nested_splits_list = Vec::new();

        for t in rt_nested_splits {
            rt_nested_splits_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&rt_nested_splits_list)?;
        op.add_input(&rt_dense_values.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `RaggedTensorToSparse::new().call(&ctx, &rt_nested_splits, &rt_dense_values)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RaggedTensorToSparse>
pub fn ragged_tensor_to_sparse<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    rt_nested_splits: &[&T0],
    rt_dense_values: &T1,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = RaggedTensorToSparse::new();
    op.call(ctx, rt_nested_splits, rt_dense_values)
}

/// RaggedTensorToTensor
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RaggedTensorToTensor>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RaggedTensorToTensor {
    row_partition_types: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RaggedTensorToTensor {
    fn default() -> Self {
        Self {
            row_partition_types: None,
            target_device_name: None,
        }
    }
}
impl RaggedTensorToTensor {
    /// Creates a new `RaggedTensorToTensor`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `row_partition_types` attribute.
    pub fn row_partition_types<
        ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>,
    >(
        mut self,
        value: ArgType,
    ) -> Self {
        self.row_partition_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute ragged_tensor_to_tensor.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        shape: &T0,
        values: &T1,
        default_value: &T2,
        row_partition_tensors: &[&T3],
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RaggedTensorToTensor")?;

        // Required input arguments
        op.add_input(&shape.to_handle(ctx)?)?;
        op.add_input(&values.to_handle(ctx)?)?;
        op.add_input(&default_value.to_handle(ctx)?)?;
        let mut row_partition_tensors_list = Vec::new();

        for t in row_partition_tensors {
            row_partition_tensors_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&row_partition_tensors_list)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.row_partition_types {
            op.set_attr_string_list("row_partition_types", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RaggedTensorToTensor::new().call(&ctx, &shape, &values, &default_value, &row_partition_tensors)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RaggedTensorToTensor>
pub fn ragged_tensor_to_tensor<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    shape: &T0,
    values: &T1,
    default_value: &T2,
    row_partition_tensors: &[&T3],
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RaggedTensorToTensor::new();
    op.call(ctx, shape, values, default_value, row_partition_tensors)
}

/// RaggedTensorToVariant
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RaggedTensorToVariant>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RaggedTensorToVariant {
    batched_input: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RaggedTensorToVariant {
    fn default() -> Self {
        Self {
            batched_input: None,
            target_device_name: None,
        }
    }
}
impl RaggedTensorToVariant {
    /// Creates a new `RaggedTensorToVariant`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `batched_input` attribute.
    pub fn batched_input<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.batched_input = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute ragged_tensor_to_variant.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        rt_nested_splits: &[&T0],
        rt_dense_values: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RaggedTensorToVariant")?;

        // Required input arguments
        let mut rt_nested_splits_list = Vec::new();

        for t in rt_nested_splits {
            rt_nested_splits_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&rt_nested_splits_list)?;
        op.add_input(&rt_dense_values.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.batched_input {
            op.set_attr_bool("batched_input", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RaggedTensorToVariant::new().call(&ctx, &rt_nested_splits, &rt_dense_values)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RaggedTensorToVariant>
pub fn ragged_tensor_to_variant<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    rt_nested_splits: &[&T0],
    rt_dense_values: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RaggedTensorToVariant::new();
    op.call(ctx, rt_nested_splits, rt_dense_values)
}

/// RaggedTensorToVariantGradient
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RaggedTensorToVariantGradient>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RaggedTensorToVariantGradient {
    Tvalues: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RaggedTensorToVariantGradient {
    fn default() -> Self {
        Self {
            Tvalues: None,
            target_device_name: None,
        }
    }
}
impl RaggedTensorToVariantGradient {
    /// Creates a new `RaggedTensorToVariantGradient`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Tvalues` attribute.
    pub fn Tvalues<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Tvalues = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute ragged_tensor_to_variant_gradient.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        encoded_ragged_grad: &T0,
        row_splits: &T1,
        dense_values_shape: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RaggedTensorToVariantGradient")?;

        // Required input arguments
        op.add_input(&encoded_ragged_grad.to_handle(ctx)?)?;
        op.add_input(&row_splits.to_handle(ctx)?)?;
        op.add_input(&dense_values_shape.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Tvalues {
            op.set_attr_type("Tvalues", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RaggedTensorToVariantGradient::new().call(&ctx, &encoded_ragged_grad, &row_splits, &dense_values_shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RaggedTensorToVariantGradient>
pub fn ragged_tensor_to_variant_gradient<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    encoded_ragged_grad: &T0,
    row_splits: &T1,
    dense_values_shape: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RaggedTensorToVariantGradient::new();
    op.call(ctx, encoded_ragged_grad, row_splits, dense_values_shape)
}

/// RandomCrop
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RandomCrop>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RandomCrop {
    seed: ::std::option::Option<i64>,
    seed2: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RandomCrop {
    fn default() -> Self {
        Self {
            seed: Some(0i64),
            seed2: Some(0i64),
            target_device_name: None,
        }
    }
}
impl RandomCrop {
    /// Creates a new `RandomCrop`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `seed` attribute.
    pub fn seed<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed2` attribute.
    pub fn seed2<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute random_crop.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        image: &T0,
        size: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RandomCrop")?;

        // Required input arguments
        op.add_input(&image.to_handle(ctx)?)?;
        op.add_input(&size.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.seed {
            op.set_attr_int("seed", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed2 {
            op.set_attr_int("seed2", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RandomCrop::new().call(&ctx, &image, &size)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RandomCrop>
pub fn random_crop<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    image: &T0,
    size: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RandomCrop::new();
    op.call(ctx, image, size)
}

/// RandomDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RandomDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RandomDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RandomDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl RandomDataset {
    /// Creates a new `RandomDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute random_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        seed: &T0,
        seed2: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RandomDataset")?;

        // Required input arguments
        op.add_input(&seed.to_handle(ctx)?)?;
        op.add_input(&seed2.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RandomDataset::new().call(&ctx, &seed, &seed2)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RandomDataset>
pub fn random_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    seed: &T0,
    seed2: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RandomDataset::new();
    op.call(ctx, seed, seed2)
}

/// RandomGamma
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RandomGamma>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RandomGamma {
    seed: ::std::option::Option<i64>,
    seed2: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RandomGamma {
    fn default() -> Self {
        Self {
            seed: Some(0i64),
            seed2: Some(0i64),
            target_device_name: None,
        }
    }
}
impl RandomGamma {
    /// Creates a new `RandomGamma`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `seed` attribute.
    pub fn seed<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed2` attribute.
    pub fn seed2<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute random_gamma.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        shape: &T0,
        alpha: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RandomGamma")?;

        // Required input arguments
        op.add_input(&shape.to_handle(ctx)?)?;
        op.add_input(&alpha.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.seed {
            op.set_attr_int("seed", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed2 {
            op.set_attr_int("seed2", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RandomGamma::new().call(&ctx, &shape, &alpha)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RandomGamma>
pub fn random_gamma<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    shape: &T0,
    alpha: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RandomGamma::new();
    op.call(ctx, shape, alpha)
}

/// RandomGammaGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RandomGammaGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RandomGammaGrad {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RandomGammaGrad {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RandomGammaGrad {
    /// Creates a new `RandomGammaGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute random_gamma_grad.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        alpha: &T0,
        sample: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RandomGammaGrad")?;

        // Required input arguments
        op.add_input(&alpha.to_handle(ctx)?)?;
        op.add_input(&sample.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RandomGammaGrad::new().call(&ctx, &alpha, &sample)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RandomGammaGrad>
pub fn random_gamma_grad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    alpha: &T0,
    sample: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RandomGammaGrad::new();
    op.call(ctx, alpha, sample)
}

/// RandomIndexShuffle
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RandomIndexShuffle>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RandomIndexShuffle {
    rounds: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RandomIndexShuffle {
    fn default() -> Self {
        Self {
            rounds: Some(4i64),
            target_device_name: None,
        }
    }
}
impl RandomIndexShuffle {
    /// Creates a new `RandomIndexShuffle`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `rounds` attribute.
    pub fn rounds<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.rounds = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute random_index_shuffle.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        index: &T0,
        seed: &T1,
        max_index: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RandomIndexShuffle")?;

        // Required input arguments
        op.add_input(&index.to_handle(ctx)?)?;
        op.add_input(&seed.to_handle(ctx)?)?;
        op.add_input(&max_index.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.rounds {
            op.set_attr_int("rounds", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RandomIndexShuffle::new().call(&ctx, &index, &seed, &max_index)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RandomIndexShuffle>
pub fn random_index_shuffle<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    index: &T0,
    seed: &T1,
    max_index: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RandomIndexShuffle::new();
    op.call(ctx, index, seed, max_index)
}

/// RandomPoisson
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RandomPoisson>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RandomPoisson {
    seed: ::std::option::Option<i64>,
    seed2: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RandomPoisson {
    fn default() -> Self {
        Self {
            seed: Some(0i64),
            seed2: Some(0i64),
            target_device_name: None,
        }
    }
}
impl RandomPoisson {
    /// Creates a new `RandomPoisson`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `seed` attribute.
    pub fn seed<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed2` attribute.
    pub fn seed2<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute random_poisson.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        shape: &T0,
        rate: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RandomPoisson")?;

        // Required input arguments
        op.add_input(&shape.to_handle(ctx)?)?;
        op.add_input(&rate.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.seed {
            op.set_attr_int("seed", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed2 {
            op.set_attr_int("seed2", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RandomPoisson::new().call(&ctx, &shape, &rate)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RandomPoisson>
pub fn random_poisson<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    shape: &T0,
    rate: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RandomPoisson::new();
    op.call(ctx, shape, rate)
}

/// RandomPoissonV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RandomPoissonV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RandomPoissonV2 {
    seed: ::std::option::Option<i64>,
    seed2: ::std::option::Option<i64>,
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RandomPoissonV2 {
    fn default() -> Self {
        Self {
            seed: Some(0i64),
            seed2: Some(0i64),
            dtype: Some(crate::DataType::Int64),
            target_device_name: None,
        }
    }
}
impl RandomPoissonV2 {
    /// Creates a new `RandomPoissonV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `seed` attribute.
    pub fn seed<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed2` attribute.
    pub fn seed2<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute random_poisson_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        shape: &T0,
        rate: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RandomPoissonV2")?;

        // Required input arguments
        op.add_input(&shape.to_handle(ctx)?)?;
        op.add_input(&rate.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.seed {
            op.set_attr_int("seed", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed2 {
            op.set_attr_int("seed2", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RandomPoissonV2::new().call(&ctx, &shape, &rate)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RandomPoissonV2>
pub fn random_poisson_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    shape: &T0,
    rate: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RandomPoissonV2::new();
    op.call(ctx, shape, rate)
}

/// RandomShuffle
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RandomShuffle>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RandomShuffle {
    seed: ::std::option::Option<i64>,
    seed2: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RandomShuffle {
    fn default() -> Self {
        Self {
            seed: Some(0i64),
            seed2: Some(0i64),
            target_device_name: None,
        }
    }
}
impl RandomShuffle {
    /// Creates a new `RandomShuffle`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `seed` attribute.
    pub fn seed<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed2` attribute.
    pub fn seed2<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute random_shuffle.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        value: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RandomShuffle")?;

        // Required input arguments
        op.add_input(&value.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.seed {
            op.set_attr_int("seed", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed2 {
            op.set_attr_int("seed2", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RandomShuffle::new().call(&ctx, &value)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RandomShuffle>
pub fn random_shuffle<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    value: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RandomShuffle::new();
    op.call(ctx, value)
}

/// RandomShuffleQueue
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RandomShuffleQueue>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RandomShuffleQueue {
    component_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    capacity: ::std::option::Option<i64>,
    min_after_dequeue: ::std::option::Option<i64>,
    seed: ::std::option::Option<i64>,
    seed2: ::std::option::Option<i64>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RandomShuffleQueue {
    fn default() -> Self {
        Self {
            component_types: None,
            shapes: Some(vec![]),
            capacity: Some(-1i64),
            min_after_dequeue: Some(0i64),
            seed: Some(0i64),
            seed2: Some(0i64),
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl RandomShuffleQueue {
    /// Creates a new `RandomShuffleQueue`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `component_types` attribute.
    pub fn component_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.component_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shapes` attribute.
    pub fn shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `capacity` attribute.
    pub fn capacity<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.capacity = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `min_after_dequeue` attribute.
    pub fn min_after_dequeue<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.min_after_dequeue = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed` attribute.
    pub fn seed<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed2` attribute.
    pub fn seed2<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute random_shuffle_queue.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RandomShuffleQueue")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.component_types {
            op.set_attr_type_list("component_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shapes {
            op.set_attr_shape_list("shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.capacity {
            op.set_attr_int("capacity", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.min_after_dequeue {
            op.set_attr_int("min_after_dequeue", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed {
            op.set_attr_int("seed", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed2 {
            op.set_attr_int("seed2", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RandomShuffleQueue::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RandomShuffleQueue>
pub fn random_shuffle_queue<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RandomShuffleQueue::new();
    op.call(ctx)
}

/// RandomShuffleQueueV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RandomShuffleQueueV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RandomShuffleQueueV2 {
    component_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    capacity: ::std::option::Option<i64>,
    min_after_dequeue: ::std::option::Option<i64>,
    seed: ::std::option::Option<i64>,
    seed2: ::std::option::Option<i64>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RandomShuffleQueueV2 {
    fn default() -> Self {
        Self {
            component_types: None,
            shapes: Some(vec![]),
            capacity: Some(-1i64),
            min_after_dequeue: Some(0i64),
            seed: Some(0i64),
            seed2: Some(0i64),
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl RandomShuffleQueueV2 {
    /// Creates a new `RandomShuffleQueueV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `component_types` attribute.
    pub fn component_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.component_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shapes` attribute.
    pub fn shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `capacity` attribute.
    pub fn capacity<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.capacity = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `min_after_dequeue` attribute.
    pub fn min_after_dequeue<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.min_after_dequeue = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed` attribute.
    pub fn seed<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed2` attribute.
    pub fn seed2<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute random_shuffle_queue_v2.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RandomShuffleQueueV2")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.component_types {
            op.set_attr_type_list("component_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shapes {
            op.set_attr_shape_list("shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.capacity {
            op.set_attr_int("capacity", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.min_after_dequeue {
            op.set_attr_int("min_after_dequeue", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed {
            op.set_attr_int("seed", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed2 {
            op.set_attr_int("seed2", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RandomShuffleQueueV2::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RandomShuffleQueueV2>
pub fn random_shuffle_queue_v2<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RandomShuffleQueueV2::new();
    op.call(ctx)
}

/// RandomStandardNormal
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RandomStandardNormal>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RandomStandardNormal {
    seed: ::std::option::Option<i64>,
    seed2: ::std::option::Option<i64>,
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RandomStandardNormal {
    fn default() -> Self {
        Self {
            seed: Some(0i64),
            seed2: Some(0i64),
            dtype: None,
            target_device_name: None,
        }
    }
}
impl RandomStandardNormal {
    /// Creates a new `RandomStandardNormal`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `seed` attribute.
    pub fn seed<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed2` attribute.
    pub fn seed2<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute random_standard_normal.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        shape: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RandomStandardNormal")?;

        // Required input arguments
        op.add_input(&shape.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.seed {
            op.set_attr_int("seed", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed2 {
            op.set_attr_int("seed2", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RandomStandardNormal::new().call(&ctx, &shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RandomStandardNormal>
pub fn random_standard_normal<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    shape: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RandomStandardNormal::new();
    op.call(ctx, shape)
}

/// RandomUniform
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RandomUniform>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RandomUniform {
    seed: ::std::option::Option<i64>,
    seed2: ::std::option::Option<i64>,
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RandomUniform {
    fn default() -> Self {
        Self {
            seed: Some(0i64),
            seed2: Some(0i64),
            dtype: None,
            target_device_name: None,
        }
    }
}
impl RandomUniform {
    /// Creates a new `RandomUniform`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `seed` attribute.
    pub fn seed<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed2` attribute.
    pub fn seed2<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute random_uniform.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        shape: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RandomUniform")?;

        // Required input arguments
        op.add_input(&shape.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.seed {
            op.set_attr_int("seed", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed2 {
            op.set_attr_int("seed2", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RandomUniform::new().call(&ctx, &shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RandomUniform>
pub fn random_uniform<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    shape: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RandomUniform::new();
    op.call(ctx, shape)
}

/// RandomUniformInt
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RandomUniformInt>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RandomUniformInt {
    seed: ::std::option::Option<i64>,
    seed2: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RandomUniformInt {
    fn default() -> Self {
        Self {
            seed: Some(0i64),
            seed2: Some(0i64),
            target_device_name: None,
        }
    }
}
impl RandomUniformInt {
    /// Creates a new `RandomUniformInt`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `seed` attribute.
    pub fn seed<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed2` attribute.
    pub fn seed2<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute random_uniform_int.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        shape: &T0,
        minval: &T1,
        maxval: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RandomUniformInt")?;

        // Required input arguments
        op.add_input(&shape.to_handle(ctx)?)?;
        op.add_input(&minval.to_handle(ctx)?)?;
        op.add_input(&maxval.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.seed {
            op.set_attr_int("seed", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed2 {
            op.set_attr_int("seed2", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RandomUniformInt::new().call(&ctx, &shape, &minval, &maxval)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RandomUniformInt>
pub fn random_uniform_int<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    shape: &T0,
    minval: &T1,
    maxval: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RandomUniformInt::new();
    op.call(ctx, shape, minval, maxval)
}

/// Range
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Range>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Range {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Range {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Range {
    /// Creates a new `Range`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute range.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        start: &T0,
        limit: &T1,
        delta: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Range")?;

        // Required input arguments
        op.add_input(&start.to_handle(ctx)?)?;
        op.add_input(&limit.to_handle(ctx)?)?;
        op.add_input(&delta.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Range::new().call(&ctx, &start, &limit, &delta)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Range>
pub fn range<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    start: &T0,
    limit: &T1,
    delta: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Range::new();
    op.call(ctx, start, limit, delta)
}

/// RangeDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RangeDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RangeDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    metadata: ::std::option::Option<::std::string::String>,
    replicate_on_split: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RangeDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            metadata: None,
            replicate_on_split: Some(false),
            target_device_name: None,
        }
    }
}
impl RangeDataset {
    /// Creates a new `RangeDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `replicate_on_split` attribute.
    pub fn replicate_on_split<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.replicate_on_split = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute range_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        start: &T0,
        stop: &T1,
        step: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RangeDataset")?;

        // Required input arguments
        op.add_input(&start.to_handle(ctx)?)?;
        op.add_input(&stop.to_handle(ctx)?)?;
        op.add_input(&step.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.replicate_on_split {
            op.set_attr_bool("replicate_on_split", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RangeDataset::new().call(&ctx, &start, &stop, &step)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RangeDataset>
pub fn range_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    start: &T0,
    stop: &T1,
    step: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RangeDataset::new();
    op.call(ctx, start, stop, step)
}

/// Rank
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Rank>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Rank {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Rank {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Rank {
    /// Creates a new `Rank`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute rank.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Rank")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Rank::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Rank>
pub fn rank<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Rank::new();
    op.call(ctx, input)
}

/// ReadFile
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReadFile>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ReadFile {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ReadFile {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ReadFile {
    /// Creates a new `ReadFile`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute read_file.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        filename: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ReadFile")?;

        // Required input arguments
        op.add_input(&filename.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ReadFile::new().call(&ctx, &filename)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReadFile>
pub fn read_file<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    filename: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ReadFile::new();
    op.call(ctx, filename)
}

/// ReadVariableOp
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReadVariableOp>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ReadVariableOp {
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ReadVariableOp {
    fn default() -> Self {
        Self {
            dtype: None,
            target_device_name: None,
        }
    }
}
impl ReadVariableOp {
    /// Creates a new `ReadVariableOp`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute read_variable_op.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        resource: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ReadVariableOp")?;

        // Required input arguments
        op.add_input(&resource.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ReadVariableOp::new().call(&ctx, &resource)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReadVariableOp>
pub fn read_variable_op<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    resource: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ReadVariableOp::new();
    op.call(ctx, resource)
}

/// ReadVariableXlaSplitND
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReadVariableXlaSplitND>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ReadVariableXlaSplitND {
    T: ::std::option::Option<crate::DataType>,
    N: ::std::option::Option<i64>,
    num_splits: ::std::option::Option<::std::vec::Vec<i64>>,
    paddings: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ReadVariableXlaSplitND {
    fn default() -> Self {
        Self {
            T: None,
            N: None,
            num_splits: None,
            paddings: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl ReadVariableXlaSplitND {
    /// Creates a new `ReadVariableXlaSplitND`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `T` attribute.
    pub fn T<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.T = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `N` attribute.
    pub fn N<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.N = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_splits` attribute.
    pub fn num_splits<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.num_splits = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `paddings` attribute.
    pub fn paddings<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.paddings = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute read_variable_xla_split_nd.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        resource: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ReadVariableXlaSplitND")?;

        // Required input arguments
        op.add_input(&resource.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.T {
            op.set_attr_type("T", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.N {
            op.set_attr_int("N", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_splits {
            op.set_attr_int_list("num_splits", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.paddings {
            op.set_attr_int_list("paddings", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ReadVariableXlaSplitND::new().call(&ctx, &resource)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReadVariableXlaSplitND>
pub fn read_variable_xla_split_nd<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    resource: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ReadVariableXlaSplitND::new();
    op.call(ctx, resource)
}

/// ReaderNumRecordsProduced
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReaderNumRecordsProduced>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ReaderNumRecordsProduced {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ReaderNumRecordsProduced {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ReaderNumRecordsProduced {
    /// Creates a new `ReaderNumRecordsProduced`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute reader_num_records_produced.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        reader_handle: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ReaderNumRecordsProduced")?;

        // Required input arguments
        op.add_input(&reader_handle.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ReaderNumRecordsProduced::new().call(&ctx, &reader_handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReaderNumRecordsProduced>
pub fn reader_num_records_produced<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    reader_handle: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ReaderNumRecordsProduced::new();
    op.call(ctx, reader_handle)
}

/// ReaderNumRecordsProducedV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReaderNumRecordsProducedV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ReaderNumRecordsProducedV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ReaderNumRecordsProducedV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ReaderNumRecordsProducedV2 {
    /// Creates a new `ReaderNumRecordsProducedV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute reader_num_records_produced_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        reader_handle: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ReaderNumRecordsProducedV2")?;

        // Required input arguments
        op.add_input(&reader_handle.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ReaderNumRecordsProducedV2::new().call(&ctx, &reader_handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReaderNumRecordsProducedV2>
pub fn reader_num_records_produced_v2<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    reader_handle: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ReaderNumRecordsProducedV2::new();
    op.call(ctx, reader_handle)
}

/// ReaderNumWorkUnitsCompleted
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReaderNumWorkUnitsCompleted>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ReaderNumWorkUnitsCompleted {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ReaderNumWorkUnitsCompleted {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ReaderNumWorkUnitsCompleted {
    /// Creates a new `ReaderNumWorkUnitsCompleted`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute reader_num_work_units_completed.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        reader_handle: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ReaderNumWorkUnitsCompleted")?;

        // Required input arguments
        op.add_input(&reader_handle.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ReaderNumWorkUnitsCompleted::new().call(&ctx, &reader_handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReaderNumWorkUnitsCompleted>
pub fn reader_num_work_units_completed<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    reader_handle: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ReaderNumWorkUnitsCompleted::new();
    op.call(ctx, reader_handle)
}

/// ReaderNumWorkUnitsCompletedV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReaderNumWorkUnitsCompletedV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ReaderNumWorkUnitsCompletedV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ReaderNumWorkUnitsCompletedV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ReaderNumWorkUnitsCompletedV2 {
    /// Creates a new `ReaderNumWorkUnitsCompletedV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute reader_num_work_units_completed_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        reader_handle: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ReaderNumWorkUnitsCompletedV2")?;

        // Required input arguments
        op.add_input(&reader_handle.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ReaderNumWorkUnitsCompletedV2::new().call(&ctx, &reader_handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReaderNumWorkUnitsCompletedV2>
pub fn reader_num_work_units_completed_v2<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    reader_handle: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ReaderNumWorkUnitsCompletedV2::new();
    op.call(ctx, reader_handle)
}

/// ReaderRead
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReaderRead>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ReaderRead {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ReaderRead {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ReaderRead {
    /// Creates a new `ReaderRead`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute reader_read.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        reader_handle: &T0,
        queue_handle: &T1,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "ReaderRead")?;

        // Required input arguments
        op.add_input(&reader_handle.to_handle(ctx)?)?;
        op.add_input(&queue_handle.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `ReaderRead::new().call(&ctx, &reader_handle, &queue_handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReaderRead>
pub fn reader_read<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    reader_handle: &T0,
    queue_handle: &T1,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = ReaderRead::new();
    op.call(ctx, reader_handle, queue_handle)
}

/// ReaderReadUpTo
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReaderReadUpTo>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ReaderReadUpTo {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ReaderReadUpTo {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ReaderReadUpTo {
    /// Creates a new `ReaderReadUpTo`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute reader_read_up_to.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        reader_handle: &T0,
        queue_handle: &T1,
        num_records: &T2,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "ReaderReadUpTo")?;

        // Required input arguments
        op.add_input(&reader_handle.to_handle(ctx)?)?;
        op.add_input(&queue_handle.to_handle(ctx)?)?;
        op.add_input(&num_records.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `ReaderReadUpTo::new().call(&ctx, &reader_handle, &queue_handle, &num_records)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReaderReadUpTo>
pub fn reader_read_up_to<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    reader_handle: &T0,
    queue_handle: &T1,
    num_records: &T2,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = ReaderReadUpTo::new();
    op.call(ctx, reader_handle, queue_handle, num_records)
}

/// ReaderReadUpToV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReaderReadUpToV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ReaderReadUpToV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ReaderReadUpToV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ReaderReadUpToV2 {
    /// Creates a new `ReaderReadUpToV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute reader_read_up_to_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        reader_handle: &T0,
        queue_handle: &T1,
        num_records: &T2,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "ReaderReadUpToV2")?;

        // Required input arguments
        op.add_input(&reader_handle.to_handle(ctx)?)?;
        op.add_input(&queue_handle.to_handle(ctx)?)?;
        op.add_input(&num_records.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `ReaderReadUpToV2::new().call(&ctx, &reader_handle, &queue_handle, &num_records)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReaderReadUpToV2>
pub fn reader_read_up_to_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    reader_handle: &T0,
    queue_handle: &T1,
    num_records: &T2,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = ReaderReadUpToV2::new();
    op.call(ctx, reader_handle, queue_handle, num_records)
}

/// ReaderReadV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReaderReadV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ReaderReadV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ReaderReadV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ReaderReadV2 {
    /// Creates a new `ReaderReadV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute reader_read_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        reader_handle: &T0,
        queue_handle: &T1,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "ReaderReadV2")?;

        // Required input arguments
        op.add_input(&reader_handle.to_handle(ctx)?)?;
        op.add_input(&queue_handle.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `ReaderReadV2::new().call(&ctx, &reader_handle, &queue_handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReaderReadV2>
pub fn reader_read_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    reader_handle: &T0,
    queue_handle: &T1,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = ReaderReadV2::new();
    op.call(ctx, reader_handle, queue_handle)
}

/// ReaderReset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReaderReset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ReaderReset {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ReaderReset {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ReaderReset {
    /// Creates a new `ReaderReset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute reader_reset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        reader_handle: &T0,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ReaderReset")?;

        // Required input arguments
        op.add_input(&reader_handle.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ReaderReset::new().call(&ctx, &reader_handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReaderReset>
pub fn reader_reset<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    reader_handle: &T0,
) -> crate::Result<()> {
    let op = ReaderReset::new();
    op.call(ctx, reader_handle)
}

/// ReaderResetV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReaderResetV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ReaderResetV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ReaderResetV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ReaderResetV2 {
    /// Creates a new `ReaderResetV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute reader_reset_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        reader_handle: &T0,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ReaderResetV2")?;

        // Required input arguments
        op.add_input(&reader_handle.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ReaderResetV2::new().call(&ctx, &reader_handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReaderResetV2>
pub fn reader_reset_v2<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    reader_handle: &T0,
) -> crate::Result<()> {
    let op = ReaderResetV2::new();
    op.call(ctx, reader_handle)
}

/// ReaderRestoreState
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReaderRestoreState>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ReaderRestoreState {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ReaderRestoreState {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ReaderRestoreState {
    /// Creates a new `ReaderRestoreState`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute reader_restore_state.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        reader_handle: &T0,
        state: &T1,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ReaderRestoreState")?;

        // Required input arguments
        op.add_input(&reader_handle.to_handle(ctx)?)?;
        op.add_input(&state.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ReaderRestoreState::new().call(&ctx, &reader_handle, &state)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReaderRestoreState>
pub fn reader_restore_state<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    reader_handle: &T0,
    state: &T1,
) -> crate::Result<()> {
    let op = ReaderRestoreState::new();
    op.call(ctx, reader_handle, state)
}

/// ReaderRestoreStateV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReaderRestoreStateV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ReaderRestoreStateV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ReaderRestoreStateV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ReaderRestoreStateV2 {
    /// Creates a new `ReaderRestoreStateV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute reader_restore_state_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        reader_handle: &T0,
        state: &T1,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ReaderRestoreStateV2")?;

        // Required input arguments
        op.add_input(&reader_handle.to_handle(ctx)?)?;
        op.add_input(&state.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ReaderRestoreStateV2::new().call(&ctx, &reader_handle, &state)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReaderRestoreStateV2>
pub fn reader_restore_state_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    reader_handle: &T0,
    state: &T1,
) -> crate::Result<()> {
    let op = ReaderRestoreStateV2::new();
    op.call(ctx, reader_handle, state)
}

/// ReaderSerializeState
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReaderSerializeState>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ReaderSerializeState {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ReaderSerializeState {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ReaderSerializeState {
    /// Creates a new `ReaderSerializeState`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute reader_serialize_state.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        reader_handle: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ReaderSerializeState")?;

        // Required input arguments
        op.add_input(&reader_handle.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ReaderSerializeState::new().call(&ctx, &reader_handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReaderSerializeState>
pub fn reader_serialize_state<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    reader_handle: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ReaderSerializeState::new();
    op.call(ctx, reader_handle)
}

/// ReaderSerializeStateV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReaderSerializeStateV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ReaderSerializeStateV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ReaderSerializeStateV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ReaderSerializeStateV2 {
    /// Creates a new `ReaderSerializeStateV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute reader_serialize_state_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        reader_handle: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ReaderSerializeStateV2")?;

        // Required input arguments
        op.add_input(&reader_handle.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ReaderSerializeStateV2::new().call(&ctx, &reader_handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReaderSerializeStateV2>
pub fn reader_serialize_state_v2<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    reader_handle: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ReaderSerializeStateV2::new();
    op.call(ctx, reader_handle)
}

/// Real
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Real>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Real {
    Tout: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Real {
    fn default() -> Self {
        Self {
            Tout: Some(crate::DataType::Float),
            target_device_name: None,
        }
    }
}
impl Real {
    /// Creates a new `Real`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Tout` attribute.
    pub fn Tout<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.Tout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute real.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Real")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Tout {
            op.set_attr_type("Tout", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Real::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Real>
pub fn real<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Real::new();
    op.call(ctx, input)
}

/// RealDiv
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RealDiv>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RealDiv {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RealDiv {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RealDiv {
    /// Creates a new `RealDiv`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute real_div.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RealDiv")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RealDiv::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RealDiv>
pub fn real_div<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RealDiv::new();
    op.call(ctx, x, y)
}

/// RebatchDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RebatchDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RebatchDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    use_fallback: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RebatchDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            use_fallback: Some(true),
            target_device_name: None,
        }
    }
}
impl RebatchDataset {
    /// Creates a new `RebatchDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_fallback` attribute.
    pub fn use_fallback<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_fallback = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute rebatch_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        num_replicas: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RebatchDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&num_replicas.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_fallback {
            op.set_attr_bool("use_fallback", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RebatchDataset::new().call(&ctx, &input_dataset, &num_replicas)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RebatchDataset>
pub fn rebatch_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    num_replicas: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RebatchDataset::new();
    op.call(ctx, input_dataset, num_replicas)
}

/// RebatchDatasetV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RebatchDatasetV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RebatchDatasetV2 {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RebatchDatasetV2 {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl RebatchDatasetV2 {
    /// Creates a new `RebatchDatasetV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute rebatch_dataset_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        batch_sizes: &T1,
        drop_remainder: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RebatchDatasetV2")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&batch_sizes.to_handle(ctx)?)?;
        op.add_input(&drop_remainder.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RebatchDatasetV2::new().call(&ctx, &input_dataset, &batch_sizes, &drop_remainder)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RebatchDatasetV2>
pub fn rebatch_dataset_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    batch_sizes: &T1,
    drop_remainder: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RebatchDatasetV2::new();
    op.call(ctx, input_dataset, batch_sizes, drop_remainder)
}

/// Reciprocal
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Reciprocal>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Reciprocal {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Reciprocal {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Reciprocal {
    /// Creates a new `Reciprocal`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute reciprocal.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Reciprocal")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Reciprocal::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Reciprocal>
pub fn reciprocal<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Reciprocal::new();
    op.call(ctx, x)
}

/// ReciprocalGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReciprocalGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ReciprocalGrad {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ReciprocalGrad {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ReciprocalGrad {
    /// Creates a new `ReciprocalGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute reciprocal_grad.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        y: &T0,
        dy: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ReciprocalGrad")?;

        // Required input arguments
        op.add_input(&y.to_handle(ctx)?)?;
        op.add_input(&dy.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ReciprocalGrad::new().call(&ctx, &y, &dy)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReciprocalGrad>
pub fn reciprocal_grad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    y: &T0,
    dy: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ReciprocalGrad::new();
    op.call(ctx, y, dy)
}

/// RecordInput
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RecordInput>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RecordInput {
    file_pattern: ::std::option::Option<::std::string::String>,
    file_random_seed: ::std::option::Option<i64>,
    file_shuffle_shift_ratio: ::std::option::Option<f32>,
    file_buffer_size: ::std::option::Option<i64>,
    file_parallelism: ::std::option::Option<i64>,
    batch_size: ::std::option::Option<i64>,
    compression_type: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RecordInput {
    fn default() -> Self {
        Self {
            file_pattern: None,
            file_random_seed: Some(301i64),
            file_shuffle_shift_ratio: Some(0f32),
            file_buffer_size: Some(10000i64),
            file_parallelism: Some(16i64),
            batch_size: Some(32i64),
            compression_type: None,
            target_device_name: None,
        }
    }
}
impl RecordInput {
    /// Creates a new `RecordInput`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `file_pattern` attribute.
    pub fn file_pattern<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.file_pattern = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `file_random_seed` attribute.
    pub fn file_random_seed<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.file_random_seed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `file_shuffle_shift_ratio` attribute.
    pub fn file_shuffle_shift_ratio<ArgType: ::std::convert::Into<f32>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.file_shuffle_shift_ratio = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `file_buffer_size` attribute.
    pub fn file_buffer_size<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.file_buffer_size = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `file_parallelism` attribute.
    pub fn file_parallelism<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.file_parallelism = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `batch_size` attribute.
    pub fn batch_size<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.batch_size = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `compression_type` attribute.
    pub fn compression_type<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.compression_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute record_input.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RecordInput")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.file_pattern {
            op.set_attr_string("file_pattern", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.file_random_seed {
            op.set_attr_int("file_random_seed", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.file_shuffle_shift_ratio {
            op.set_attr_float("file_shuffle_shift_ratio", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.file_buffer_size {
            op.set_attr_int("file_buffer_size", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.file_parallelism {
            op.set_attr_int("file_parallelism", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.batch_size {
            op.set_attr_int("batch_size", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.compression_type {
            op.set_attr_string("compression_type", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RecordInput::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RecordInput>
pub fn record_input<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RecordInput::new();
    op.call(ctx)
}

/// Recv
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Recv>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Recv {
    tensor_type: ::std::option::Option<crate::DataType>,
    tensor_name: ::std::option::Option<::std::string::String>,
    send_device: ::std::option::Option<::std::string::String>,
    send_device_incarnation: ::std::option::Option<i64>,
    recv_device: ::std::option::Option<::std::string::String>,
    client_terminated: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Recv {
    fn default() -> Self {
        Self {
            tensor_type: None,
            tensor_name: None,
            send_device: None,
            send_device_incarnation: None,
            recv_device: None,
            client_terminated: Some(false),
            target_device_name: None,
        }
    }
}
impl Recv {
    /// Creates a new `Recv`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `tensor_type` attribute.
    pub fn tensor_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.tensor_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `tensor_name` attribute.
    pub fn tensor_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.tensor_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `send_device` attribute.
    pub fn send_device<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.send_device = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `send_device_incarnation` attribute.
    pub fn send_device_incarnation<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.send_device_incarnation = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `recv_device` attribute.
    pub fn recv_device<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.recv_device = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `client_terminated` attribute.
    pub fn client_terminated<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.client_terminated = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute recv.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Recv")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.tensor_type {
            op.set_attr_type("tensor_type", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.tensor_name {
            op.set_attr_string("tensor_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.send_device {
            op.set_attr_string("send_device", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.send_device_incarnation {
            op.set_attr_int("send_device_incarnation", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.recv_device {
            op.set_attr_string("recv_device", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.client_terminated {
            op.set_attr_bool("client_terminated", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Recv::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Recv>
pub fn recv<'a>(ctx: &'a crate::eager::Context) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Recv::new();
    op.call(ctx)
}

/// RecvTPUEmbeddingActivations
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RecvTPUEmbeddingActivations>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RecvTPUEmbeddingActivations {
    num_outputs: ::std::option::Option<i64>,
    config: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RecvTPUEmbeddingActivations {
    fn default() -> Self {
        Self {
            num_outputs: None,
            config: None,
            target_device_name: None,
        }
    }
}
impl RecvTPUEmbeddingActivations {
    /// Creates a new `RecvTPUEmbeddingActivations`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_outputs` attribute.
    pub fn num_outputs<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_outputs = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute recv_tpuembedding_activations.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RecvTPUEmbeddingActivations")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_outputs {
            op.set_attr_int("num_outputs", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RecvTPUEmbeddingActivations::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RecvTPUEmbeddingActivations>
pub fn recv_tpuembedding_activations<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RecvTPUEmbeddingActivations::new();
    op.call(ctx)
}

/// ReduceDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReduceDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ReduceDataset {
    f: ::std::option::Option<::std::string::String>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    use_inter_op_parallelism: ::std::option::Option<bool>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ReduceDataset {
    fn default() -> Self {
        Self {
            f: None,
            output_types: None,
            output_shapes: None,
            use_inter_op_parallelism: Some(true),
            metadata: None,
            target_device_name: None,
        }
    }
}
impl ReduceDataset {
    /// Creates a new `ReduceDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `f` attribute.
    pub fn f<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.f = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_inter_op_parallelism` attribute.
    pub fn use_inter_op_parallelism<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.use_inter_op_parallelism = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute reduce_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        initial_state: &T1,
        other_arguments: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ReduceDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&initial_state.to_handle(ctx)?)?;
        op.add_input(&other_arguments.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.f {
            op.set_attr_string("f", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_inter_op_parallelism {
            op.set_attr_bool("use_inter_op_parallelism", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ReduceDataset::new().call(&ctx, &input_dataset, &initial_state, &other_arguments)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReduceDataset>
pub fn reduce_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    initial_state: &T1,
    other_arguments: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ReduceDataset::new();
    op.call(ctx, input_dataset, initial_state, other_arguments)
}

/// ReduceJoin
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReduceJoin>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ReduceJoin {
    keep_dims: ::std::option::Option<bool>,
    separator: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ReduceJoin {
    fn default() -> Self {
        Self {
            keep_dims: Some(false),
            separator: None,
            target_device_name: None,
        }
    }
}
impl ReduceJoin {
    /// Creates a new `ReduceJoin`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `keep_dims` attribute.
    pub fn keep_dims<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.keep_dims = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `separator` attribute.
    pub fn separator<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.separator = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute reduce_join.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        inputs: &T0,
        reduction_indices: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ReduceJoin")?;

        // Required input arguments
        op.add_input(&inputs.to_handle(ctx)?)?;
        op.add_input(&reduction_indices.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.keep_dims {
            op.set_attr_bool("keep_dims", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.separator {
            op.set_attr_string("separator", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ReduceJoin::new().call(&ctx, &inputs, &reduction_indices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReduceJoin>
pub fn reduce_join<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    inputs: &T0,
    reduction_indices: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ReduceJoin::new();
    op.call(ctx, inputs, reduction_indices)
}

/// RefEnter
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RefEnter>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RefEnter {
    frame_name: ::std::option::Option<::std::string::String>,
    is_constant: ::std::option::Option<bool>,
    parallel_iterations: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RefEnter {
    fn default() -> Self {
        Self {
            frame_name: None,
            is_constant: Some(false),
            parallel_iterations: Some(10i64),
            target_device_name: None,
        }
    }
}
impl RefEnter {
    /// Creates a new `RefEnter`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `frame_name` attribute.
    pub fn frame_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.frame_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `is_constant` attribute.
    pub fn is_constant<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.is_constant = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `parallel_iterations` attribute.
    pub fn parallel_iterations<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.parallel_iterations = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute ref_enter.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        data: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RefEnter")?;

        // Required input arguments
        op.add_input(&data.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.frame_name {
            op.set_attr_string("frame_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.is_constant {
            op.set_attr_bool("is_constant", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.parallel_iterations {
            op.set_attr_int("parallel_iterations", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RefEnter::new().call(&ctx, &data)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RefEnter>
pub fn ref_enter<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    data: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RefEnter::new();
    op.call(ctx, data)
}

/// RefExit
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RefExit>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RefExit {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RefExit {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RefExit {
    /// Creates a new `RefExit`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute ref_exit.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        data: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RefExit")?;

        // Required input arguments
        op.add_input(&data.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RefExit::new().call(&ctx, &data)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RefExit>
pub fn ref_exit<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    data: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RefExit::new();
    op.call(ctx, data)
}

/// RefIdentity
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RefIdentity>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RefIdentity {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RefIdentity {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RefIdentity {
    /// Creates a new `RefIdentity`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute ref_identity.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RefIdentity")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RefIdentity::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RefIdentity>
pub fn ref_identity<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RefIdentity::new();
    op.call(ctx, input)
}

/// RefMerge
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RefMerge>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RefMerge {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RefMerge {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RefMerge {
    /// Creates a new `RefMerge`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute ref_merge.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        inputs: &[&T0],
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "RefMerge")?;

        // Required input arguments
        let mut inputs_list = Vec::new();

        for t in inputs {
            inputs_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&inputs_list)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `RefMerge::new().call(&ctx, &inputs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RefMerge>
pub fn ref_merge<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    inputs: &[&T0],
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = RefMerge::new();
    op.call(ctx, inputs)
}

/// RefNextIteration
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RefNextIteration>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RefNextIteration {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RefNextIteration {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RefNextIteration {
    /// Creates a new `RefNextIteration`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute ref_next_iteration.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        data: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RefNextIteration")?;

        // Required input arguments
        op.add_input(&data.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RefNextIteration::new().call(&ctx, &data)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RefNextIteration>
pub fn ref_next_iteration<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    data: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RefNextIteration::new();
    op.call(ctx, data)
}

/// RefSelect
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RefSelect>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RefSelect {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RefSelect {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RefSelect {
    /// Creates a new `RefSelect`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute ref_select.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        index: &T0,
        inputs: &[&T1],
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RefSelect")?;

        // Required input arguments
        op.add_input(&index.to_handle(ctx)?)?;
        let mut inputs_list = Vec::new();

        for t in inputs {
            inputs_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&inputs_list)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RefSelect::new().call(&ctx, &index, &inputs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RefSelect>
pub fn ref_select<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    index: &T0,
    inputs: &[&T1],
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RefSelect::new();
    op.call(ctx, index, inputs)
}

/// RefSwitch
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RefSwitch>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RefSwitch {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RefSwitch {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RefSwitch {
    /// Creates a new `RefSwitch`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute ref_switch.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        data: &T0,
        pred: &T1,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "RefSwitch")?;

        // Required input arguments
        op.add_input(&data.to_handle(ctx)?)?;
        op.add_input(&pred.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `RefSwitch::new().call(&ctx, &data, &pred)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RefSwitch>
pub fn ref_switch<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    data: &T0,
    pred: &T1,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = RefSwitch::new();
    op.call(ctx, data, pred)
}

/// RegexFullMatch
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RegexFullMatch>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RegexFullMatch {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RegexFullMatch {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RegexFullMatch {
    /// Creates a new `RegexFullMatch`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute regex_full_match.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        pattern: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RegexFullMatch")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&pattern.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RegexFullMatch::new().call(&ctx, &input, &pattern)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RegexFullMatch>
pub fn regex_full_match<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    pattern: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RegexFullMatch::new();
    op.call(ctx, input, pattern)
}

/// RegexReplace
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RegexReplace>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RegexReplace {
    replace_global: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RegexReplace {
    fn default() -> Self {
        Self {
            replace_global: Some(true),
            target_device_name: None,
        }
    }
}
impl RegexReplace {
    /// Creates a new `RegexReplace`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `replace_global` attribute.
    pub fn replace_global<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.replace_global = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute regex_replace.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        pattern: &T1,
        rewrite: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RegexReplace")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&pattern.to_handle(ctx)?)?;
        op.add_input(&rewrite.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.replace_global {
            op.set_attr_bool("replace_global", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RegexReplace::new().call(&ctx, &input, &pattern, &rewrite)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RegexReplace>
pub fn regex_replace<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    pattern: &T1,
    rewrite: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RegexReplace::new();
    op.call(ctx, input, pattern, rewrite)
}

/// RegisterDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RegisterDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RegisterDataset {
    external_state_policy: ::std::option::Option<i64>,
    element_spec: ::std::option::Option<::std::string::String>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RegisterDataset {
    fn default() -> Self {
        Self {
            external_state_policy: None,
            element_spec: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl RegisterDataset {
    /// Creates a new `RegisterDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `external_state_policy` attribute.
    pub fn external_state_policy<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.external_state_policy = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `element_spec` attribute.
    pub fn element_spec<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.element_spec = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute register_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        dataset: &T0,
        address: &T1,
        protocol: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RegisterDataset")?;

        // Required input arguments
        op.add_input(&dataset.to_handle(ctx)?)?;
        op.add_input(&address.to_handle(ctx)?)?;
        op.add_input(&protocol.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.external_state_policy {
            op.set_attr_int("external_state_policy", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.element_spec {
            op.set_attr_string("element_spec", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RegisterDataset::new().call(&ctx, &dataset, &address, &protocol)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RegisterDataset>
pub fn register_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    dataset: &T0,
    address: &T1,
    protocol: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RegisterDataset::new();
    op.call(ctx, dataset, address, protocol)
}

/// RegisterDatasetV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RegisterDatasetV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RegisterDatasetV2 {
    external_state_policy: ::std::option::Option<i64>,
    element_spec: ::std::option::Option<::std::string::String>,
    requested_dataset_id: ::std::option::Option<::std::string::String>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RegisterDatasetV2 {
    fn default() -> Self {
        Self {
            external_state_policy: None,
            element_spec: None,
            requested_dataset_id: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl RegisterDatasetV2 {
    /// Creates a new `RegisterDatasetV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `external_state_policy` attribute.
    pub fn external_state_policy<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.external_state_policy = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `element_spec` attribute.
    pub fn element_spec<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.element_spec = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `requested_dataset_id` attribute.
    pub fn requested_dataset_id<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.requested_dataset_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute register_dataset_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        dataset: &T0,
        address: &T1,
        protocol: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RegisterDatasetV2")?;

        // Required input arguments
        op.add_input(&dataset.to_handle(ctx)?)?;
        op.add_input(&address.to_handle(ctx)?)?;
        op.add_input(&protocol.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.external_state_policy {
            op.set_attr_int("external_state_policy", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.element_spec {
            op.set_attr_string("element_spec", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.requested_dataset_id {
            op.set_attr_string("requested_dataset_id", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RegisterDatasetV2::new().call(&ctx, &dataset, &address, &protocol)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RegisterDatasetV2>
pub fn register_dataset_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    dataset: &T0,
    address: &T1,
    protocol: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RegisterDatasetV2::new();
    op.call(ctx, dataset, address, protocol)
}

/// Relayout
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Relayout>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Relayout {
    layout: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Relayout {
    fn default() -> Self {
        Self {
            layout: None,
            target_device_name: None,
        }
    }
}
impl Relayout {
    /// Creates a new `Relayout`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `layout` attribute.
    pub fn layout<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.layout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute relayout.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Relayout")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.layout {
            op.set_attr_string("layout", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Relayout::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Relayout>
pub fn relayout<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Relayout::new();
    op.call(ctx, input)
}

/// Relu
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Relu>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Relu {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Relu {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Relu {
    /// Creates a new `Relu`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute relu.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        features: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Relu")?;

        // Required input arguments
        op.add_input(&features.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Relu::new().call(&ctx, &features)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Relu>
pub fn relu<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    features: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Relu::new();
    op.call(ctx, features)
}

/// Relu6
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Relu6>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Relu6 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Relu6 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Relu6 {
    /// Creates a new `Relu6`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute relu6.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        features: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Relu6")?;

        // Required input arguments
        op.add_input(&features.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Relu6::new().call(&ctx, &features)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Relu6>
pub fn relu6<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    features: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Relu6::new();
    op.call(ctx, features)
}

/// Relu6Grad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Relu6Grad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Relu6Grad {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Relu6Grad {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Relu6Grad {
    /// Creates a new `Relu6Grad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute relu6_grad.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        gradients: &T0,
        features: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Relu6Grad")?;

        // Required input arguments
        op.add_input(&gradients.to_handle(ctx)?)?;
        op.add_input(&features.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Relu6Grad::new().call(&ctx, &gradients, &features)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Relu6Grad>
pub fn relu6_grad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    gradients: &T0,
    features: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Relu6Grad::new();
    op.call(ctx, gradients, features)
}

/// ReluGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReluGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ReluGrad {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ReluGrad {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ReluGrad {
    /// Creates a new `ReluGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute relu_grad.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        gradients: &T0,
        features: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ReluGrad")?;

        // Required input arguments
        op.add_input(&gradients.to_handle(ctx)?)?;
        op.add_input(&features.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ReluGrad::new().call(&ctx, &gradients, &features)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReluGrad>
pub fn relu_grad<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    gradients: &T0,
    features: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ReluGrad::new();
    op.call(ctx, gradients, features)
}

/// RemoteCall
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RemoteCall>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RemoteCall {
    Tout: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    f: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RemoteCall {
    fn default() -> Self {
        Self {
            Tout: None,
            f: None,
            target_device_name: None,
        }
    }
}
impl RemoteCall {
    /// Creates a new `RemoteCall`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Tout` attribute.
    pub fn Tout<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Tout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `f` attribute.
    pub fn f<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.f = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute remote_call.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        target: &T0,
        args: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RemoteCall")?;

        // Required input arguments
        op.add_input(&target.to_handle(ctx)?)?;
        op.add_input(&args.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Tout {
            op.set_attr_type_list("Tout", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.f {
            op.set_attr_string("f", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RemoteCall::new().call(&ctx, &target, &args)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RemoteCall>
pub fn remote_call<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    target: &T0,
    args: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RemoteCall::new();
    op.call(ctx, target, args)
}

/// RepeatDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RepeatDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RepeatDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RepeatDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl RepeatDataset {
    /// Creates a new `RepeatDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute repeat_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        count: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RepeatDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&count.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RepeatDataset::new().call(&ctx, &input_dataset, &count)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RepeatDataset>
pub fn repeat_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    count: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RepeatDataset::new();
    op.call(ctx, input_dataset, count)
}

/// RequantizationRange
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RequantizationRange>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RequantizationRange {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RequantizationRange {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RequantizationRange {
    /// Creates a new `RequantizationRange`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute requantization_range.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        input_min: &T1,
        input_max: &T2,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "RequantizationRange")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&input_min.to_handle(ctx)?)?;
        op.add_input(&input_max.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `RequantizationRange::new().call(&ctx, &input, &input_min, &input_max)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RequantizationRange>
pub fn requantization_range<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    input_min: &T1,
    input_max: &T2,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = RequantizationRange::new();
    op.call(ctx, input, input_min, input_max)
}

/// RequantizationRangePerChannel
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RequantizationRangePerChannel>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RequantizationRangePerChannel {
    clip_value_max: ::std::option::Option<f32>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RequantizationRangePerChannel {
    fn default() -> Self {
        Self {
            clip_value_max: None,
            target_device_name: None,
        }
    }
}
impl RequantizationRangePerChannel {
    /// Creates a new `RequantizationRangePerChannel`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `clip_value_max` attribute.
    pub fn clip_value_max<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.clip_value_max = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute requantization_range_per_channel.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        input_min: &T1,
        input_max: &T2,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "RequantizationRangePerChannel")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&input_min.to_handle(ctx)?)?;
        op.add_input(&input_max.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.clip_value_max {
            op.set_attr_float("clip_value_max", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `RequantizationRangePerChannel::new().call(&ctx, &input, &input_min, &input_max)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RequantizationRangePerChannel>
pub fn requantization_range_per_channel<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    input_min: &T1,
    input_max: &T2,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = RequantizationRangePerChannel::new();
    op.call(ctx, input, input_min, input_max)
}

/// Requantize
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Requantize>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Requantize {
    out_type: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Requantize {
    fn default() -> Self {
        Self {
            out_type: None,
            target_device_name: None,
        }
    }
}
impl Requantize {
    /// Creates a new `Requantize`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_type` attribute.
    pub fn out_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute requantize.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        input_min: &T1,
        input_max: &T2,
        requested_output_min: &T3,
        requested_output_max: &T4,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "Requantize")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&input_min.to_handle(ctx)?)?;
        op.add_input(&input_max.to_handle(ctx)?)?;
        op.add_input(&requested_output_min.to_handle(ctx)?)?;
        op.add_input(&requested_output_max.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_type {
            op.set_attr_type("out_type", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `Requantize::new().call(&ctx, &input, &input_min, &input_max, &requested_output_min, &requested_output_max)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Requantize>
pub fn requantize<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    input_min: &T1,
    input_max: &T2,
    requested_output_min: &T3,
    requested_output_max: &T4,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = Requantize::new();
    op.call(
        ctx,
        input,
        input_min,
        input_max,
        requested_output_min,
        requested_output_max,
    )
}

/// RequantizePerChannel
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RequantizePerChannel>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RequantizePerChannel {
    out_type: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RequantizePerChannel {
    fn default() -> Self {
        Self {
            out_type: Some(crate::DataType::QUInt8),
            target_device_name: None,
        }
    }
}
impl RequantizePerChannel {
    /// Creates a new `RequantizePerChannel`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_type` attribute.
    pub fn out_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute requantize_per_channel.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        input_min: &T1,
        input_max: &T2,
        requested_output_min: &T3,
        requested_output_max: &T4,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "RequantizePerChannel")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&input_min.to_handle(ctx)?)?;
        op.add_input(&input_max.to_handle(ctx)?)?;
        op.add_input(&requested_output_min.to_handle(ctx)?)?;
        op.add_input(&requested_output_max.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_type {
            op.set_attr_type("out_type", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `RequantizePerChannel::new().call(&ctx, &input, &input_min, &input_max, &requested_output_min, &requested_output_max)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RequantizePerChannel>
pub fn requantize_per_channel<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    input_min: &T1,
    input_max: &T2,
    requested_output_min: &T3,
    requested_output_max: &T4,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = RequantizePerChannel::new();
    op.call(
        ctx,
        input,
        input_min,
        input_max,
        requested_output_min,
        requested_output_max,
    )
}

/// Reshape
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Reshape>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Reshape {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Reshape {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Reshape {
    /// Creates a new `Reshape`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute reshape.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        tensor: &T0,
        shape: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Reshape")?;

        // Required input arguments
        op.add_input(&tensor.to_handle(ctx)?)?;
        op.add_input(&shape.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Reshape::new().call(&ctx, &tensor, &shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Reshape>
pub fn reshape<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    tensor: &T0,
    shape: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Reshape::new();
    op.call(ctx, tensor, shape)
}

/// ResizeArea
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResizeArea>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResizeArea {
    align_corners: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResizeArea {
    fn default() -> Self {
        Self {
            align_corners: Some(false),
            target_device_name: None,
        }
    }
}
impl ResizeArea {
    /// Creates a new `ResizeArea`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `align_corners` attribute.
    pub fn align_corners<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.align_corners = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resize_area.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        images: &T0,
        size: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResizeArea")?;

        // Required input arguments
        op.add_input(&images.to_handle(ctx)?)?;
        op.add_input(&size.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.align_corners {
            op.set_attr_bool("align_corners", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ResizeArea::new().call(&ctx, &images, &size)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResizeArea>
pub fn resize_area<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    images: &T0,
    size: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ResizeArea::new();
    op.call(ctx, images, size)
}

/// ResizeBicubic
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResizeBicubic>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResizeBicubic {
    align_corners: ::std::option::Option<bool>,
    half_pixel_centers: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResizeBicubic {
    fn default() -> Self {
        Self {
            align_corners: Some(false),
            half_pixel_centers: Some(false),
            target_device_name: None,
        }
    }
}
impl ResizeBicubic {
    /// Creates a new `ResizeBicubic`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `align_corners` attribute.
    pub fn align_corners<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.align_corners = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `half_pixel_centers` attribute.
    pub fn half_pixel_centers<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.half_pixel_centers = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resize_bicubic.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        images: &T0,
        size: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResizeBicubic")?;

        // Required input arguments
        op.add_input(&images.to_handle(ctx)?)?;
        op.add_input(&size.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.align_corners {
            op.set_attr_bool("align_corners", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.half_pixel_centers {
            op.set_attr_bool("half_pixel_centers", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ResizeBicubic::new().call(&ctx, &images, &size)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResizeBicubic>
pub fn resize_bicubic<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    images: &T0,
    size: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ResizeBicubic::new();
    op.call(ctx, images, size)
}

/// ResizeBicubicGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResizeBicubicGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResizeBicubicGrad {
    align_corners: ::std::option::Option<bool>,
    half_pixel_centers: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResizeBicubicGrad {
    fn default() -> Self {
        Self {
            align_corners: Some(false),
            half_pixel_centers: Some(false),
            target_device_name: None,
        }
    }
}
impl ResizeBicubicGrad {
    /// Creates a new `ResizeBicubicGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `align_corners` attribute.
    pub fn align_corners<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.align_corners = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `half_pixel_centers` attribute.
    pub fn half_pixel_centers<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.half_pixel_centers = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resize_bicubic_grad.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        grads: &T0,
        original_image: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResizeBicubicGrad")?;

        // Required input arguments
        op.add_input(&grads.to_handle(ctx)?)?;
        op.add_input(&original_image.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.align_corners {
            op.set_attr_bool("align_corners", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.half_pixel_centers {
            op.set_attr_bool("half_pixel_centers", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ResizeBicubicGrad::new().call(&ctx, &grads, &original_image)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResizeBicubicGrad>
pub fn resize_bicubic_grad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    grads: &T0,
    original_image: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ResizeBicubicGrad::new();
    op.call(ctx, grads, original_image)
}

/// ResizeBilinear
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResizeBilinear>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResizeBilinear {
    align_corners: ::std::option::Option<bool>,
    half_pixel_centers: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResizeBilinear {
    fn default() -> Self {
        Self {
            align_corners: Some(false),
            half_pixel_centers: Some(false),
            target_device_name: None,
        }
    }
}
impl ResizeBilinear {
    /// Creates a new `ResizeBilinear`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `align_corners` attribute.
    pub fn align_corners<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.align_corners = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `half_pixel_centers` attribute.
    pub fn half_pixel_centers<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.half_pixel_centers = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resize_bilinear.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        images: &T0,
        size: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResizeBilinear")?;

        // Required input arguments
        op.add_input(&images.to_handle(ctx)?)?;
        op.add_input(&size.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.align_corners {
            op.set_attr_bool("align_corners", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.half_pixel_centers {
            op.set_attr_bool("half_pixel_centers", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ResizeBilinear::new().call(&ctx, &images, &size)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResizeBilinear>
pub fn resize_bilinear<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    images: &T0,
    size: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ResizeBilinear::new();
    op.call(ctx, images, size)
}

/// ResizeBilinearGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResizeBilinearGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResizeBilinearGrad {
    align_corners: ::std::option::Option<bool>,
    half_pixel_centers: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResizeBilinearGrad {
    fn default() -> Self {
        Self {
            align_corners: Some(false),
            half_pixel_centers: Some(false),
            target_device_name: None,
        }
    }
}
impl ResizeBilinearGrad {
    /// Creates a new `ResizeBilinearGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `align_corners` attribute.
    pub fn align_corners<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.align_corners = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `half_pixel_centers` attribute.
    pub fn half_pixel_centers<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.half_pixel_centers = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resize_bilinear_grad.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        grads: &T0,
        original_image: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResizeBilinearGrad")?;

        // Required input arguments
        op.add_input(&grads.to_handle(ctx)?)?;
        op.add_input(&original_image.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.align_corners {
            op.set_attr_bool("align_corners", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.half_pixel_centers {
            op.set_attr_bool("half_pixel_centers", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ResizeBilinearGrad::new().call(&ctx, &grads, &original_image)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResizeBilinearGrad>
pub fn resize_bilinear_grad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    grads: &T0,
    original_image: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ResizeBilinearGrad::new();
    op.call(ctx, grads, original_image)
}

/// ResizeNearestNeighbor
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResizeNearestNeighbor>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResizeNearestNeighbor {
    align_corners: ::std::option::Option<bool>,
    half_pixel_centers: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResizeNearestNeighbor {
    fn default() -> Self {
        Self {
            align_corners: Some(false),
            half_pixel_centers: Some(false),
            target_device_name: None,
        }
    }
}
impl ResizeNearestNeighbor {
    /// Creates a new `ResizeNearestNeighbor`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `align_corners` attribute.
    pub fn align_corners<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.align_corners = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `half_pixel_centers` attribute.
    pub fn half_pixel_centers<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.half_pixel_centers = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resize_nearest_neighbor.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        images: &T0,
        size: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResizeNearestNeighbor")?;

        // Required input arguments
        op.add_input(&images.to_handle(ctx)?)?;
        op.add_input(&size.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.align_corners {
            op.set_attr_bool("align_corners", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.half_pixel_centers {
            op.set_attr_bool("half_pixel_centers", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ResizeNearestNeighbor::new().call(&ctx, &images, &size)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResizeNearestNeighbor>
pub fn resize_nearest_neighbor<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    images: &T0,
    size: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ResizeNearestNeighbor::new();
    op.call(ctx, images, size)
}

/// ResizeNearestNeighborGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResizeNearestNeighborGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResizeNearestNeighborGrad {
    align_corners: ::std::option::Option<bool>,
    half_pixel_centers: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResizeNearestNeighborGrad {
    fn default() -> Self {
        Self {
            align_corners: Some(false),
            half_pixel_centers: Some(false),
            target_device_name: None,
        }
    }
}
impl ResizeNearestNeighborGrad {
    /// Creates a new `ResizeNearestNeighborGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `align_corners` attribute.
    pub fn align_corners<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.align_corners = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `half_pixel_centers` attribute.
    pub fn half_pixel_centers<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.half_pixel_centers = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resize_nearest_neighbor_grad.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        grads: &T0,
        size: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResizeNearestNeighborGrad")?;

        // Required input arguments
        op.add_input(&grads.to_handle(ctx)?)?;
        op.add_input(&size.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.align_corners {
            op.set_attr_bool("align_corners", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.half_pixel_centers {
            op.set_attr_bool("half_pixel_centers", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ResizeNearestNeighborGrad::new().call(&ctx, &grads, &size)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResizeNearestNeighborGrad>
pub fn resize_nearest_neighbor_grad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    grads: &T0,
    size: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ResizeNearestNeighborGrad::new();
    op.call(ctx, grads, size)
}

/// ResourceAccumulatorApplyGradient
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceAccumulatorApplyGradient>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceAccumulatorApplyGradient {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceAccumulatorApplyGradient {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ResourceAccumulatorApplyGradient {
    /// Creates a new `ResourceAccumulatorApplyGradient`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_accumulator_apply_gradient.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        local_step: &T1,
        gradient: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceAccumulatorApplyGradient")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&local_step.to_handle(ctx)?)?;
        op.add_input(&gradient.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceAccumulatorApplyGradient::new().call(&ctx, &handle, &local_step, &gradient)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceAccumulatorApplyGradient>
pub fn resource_accumulator_apply_gradient<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    local_step: &T1,
    gradient: &T2,
) -> crate::Result<()> {
    let op = ResourceAccumulatorApplyGradient::new();
    op.call(ctx, handle, local_step, gradient)
}

/// ResourceAccumulatorNumAccumulated
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceAccumulatorNumAccumulated>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceAccumulatorNumAccumulated {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceAccumulatorNumAccumulated {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ResourceAccumulatorNumAccumulated {
    /// Creates a new `ResourceAccumulatorNumAccumulated`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_accumulator_num_accumulated.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceAccumulatorNumAccumulated")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ResourceAccumulatorNumAccumulated::new().call(&ctx, &handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceAccumulatorNumAccumulated>
pub fn resource_accumulator_num_accumulated<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ResourceAccumulatorNumAccumulated::new();
    op.call(ctx, handle)
}

/// ResourceAccumulatorSetGlobalStep
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceAccumulatorSetGlobalStep>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceAccumulatorSetGlobalStep {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceAccumulatorSetGlobalStep {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ResourceAccumulatorSetGlobalStep {
    /// Creates a new `ResourceAccumulatorSetGlobalStep`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_accumulator_set_global_step.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        new_global_step: &T1,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceAccumulatorSetGlobalStep")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&new_global_step.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceAccumulatorSetGlobalStep::new().call(&ctx, &handle, &new_global_step)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceAccumulatorSetGlobalStep>
pub fn resource_accumulator_set_global_step<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    new_global_step: &T1,
) -> crate::Result<()> {
    let op = ResourceAccumulatorSetGlobalStep::new();
    op.call(ctx, handle, new_global_step)
}

/// ResourceAccumulatorTakeGradient
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceAccumulatorTakeGradient>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceAccumulatorTakeGradient {
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceAccumulatorTakeGradient {
    fn default() -> Self {
        Self {
            dtype: None,
            target_device_name: None,
        }
    }
}
impl ResourceAccumulatorTakeGradient {
    /// Creates a new `ResourceAccumulatorTakeGradient`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_accumulator_take_gradient.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        num_required: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceAccumulatorTakeGradient")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&num_required.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ResourceAccumulatorTakeGradient::new().call(&ctx, &handle, &num_required)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceAccumulatorTakeGradient>
pub fn resource_accumulator_take_gradient<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    num_required: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ResourceAccumulatorTakeGradient::new();
    op.call(ctx, handle, num_required)
}

/// ResourceApplyAdaMax
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceApplyAdaMax>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceApplyAdaMax {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceApplyAdaMax {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl ResourceApplyAdaMax {
    /// Creates a new `ResourceApplyAdaMax`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_apply_ada_max.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        m: &T1,
        v: &T2,
        beta1_power: &T3,
        lr: &T4,
        beta1: &T5,
        beta2: &T6,
        epsilon: &T7,
        grad: &T8,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceApplyAdaMax")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&m.to_handle(ctx)?)?;
        op.add_input(&v.to_handle(ctx)?)?;
        op.add_input(&beta1_power.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&beta1.to_handle(ctx)?)?;
        op.add_input(&beta2.to_handle(ctx)?)?;
        op.add_input(&epsilon.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceApplyAdaMax::new().call(&ctx, &var, &m, &v, &beta1_power, &lr, &beta1, &beta2, &epsilon, &grad)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceApplyAdaMax>
pub fn resource_apply_ada_max<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    m: &T1,
    v: &T2,
    beta1_power: &T3,
    lr: &T4,
    beta1: &T5,
    beta2: &T6,
    epsilon: &T7,
    grad: &T8,
) -> crate::Result<()> {
    let op = ResourceApplyAdaMax::new();
    op.call(ctx, var, m, v, beta1_power, lr, beta1, beta2, epsilon, grad)
}

/// ResourceApplyAdadelta
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceApplyAdadelta>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceApplyAdadelta {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceApplyAdadelta {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl ResourceApplyAdadelta {
    /// Creates a new `ResourceApplyAdadelta`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_apply_adadelta.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        accum: &T1,
        accum_update: &T2,
        lr: &T3,
        rho: &T4,
        epsilon: &T5,
        grad: &T6,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceApplyAdadelta")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&accum.to_handle(ctx)?)?;
        op.add_input(&accum_update.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&rho.to_handle(ctx)?)?;
        op.add_input(&epsilon.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceApplyAdadelta::new().call(&ctx, &var, &accum, &accum_update, &lr, &rho, &epsilon, &grad)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceApplyAdadelta>
pub fn resource_apply_adadelta<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    accum: &T1,
    accum_update: &T2,
    lr: &T3,
    rho: &T4,
    epsilon: &T5,
    grad: &T6,
) -> crate::Result<()> {
    let op = ResourceApplyAdadelta::new();
    op.call(ctx, var, accum, accum_update, lr, rho, epsilon, grad)
}

/// ResourceApplyAdagrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceApplyAdagrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceApplyAdagrad {
    use_locking: ::std::option::Option<bool>,
    update_slots: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceApplyAdagrad {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            update_slots: Some(true),
            target_device_name: None,
        }
    }
}
impl ResourceApplyAdagrad {
    /// Creates a new `ResourceApplyAdagrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `update_slots` attribute.
    pub fn update_slots<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.update_slots = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_apply_adagrad.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        accum: &T1,
        lr: &T2,
        grad: &T3,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceApplyAdagrad")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&accum.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.update_slots {
            op.set_attr_bool("update_slots", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceApplyAdagrad::new().call(&ctx, &var, &accum, &lr, &grad)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceApplyAdagrad>
pub fn resource_apply_adagrad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    accum: &T1,
    lr: &T2,
    grad: &T3,
) -> crate::Result<()> {
    let op = ResourceApplyAdagrad::new();
    op.call(ctx, var, accum, lr, grad)
}

/// ResourceApplyAdagradDA
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceApplyAdagradDA>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceApplyAdagradDA {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceApplyAdagradDA {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl ResourceApplyAdagradDA {
    /// Creates a new `ResourceApplyAdagradDA`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_apply_adagrad_da.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        gradient_accumulator: &T1,
        gradient_squared_accumulator: &T2,
        grad: &T3,
        lr: &T4,
        l1: &T5,
        l2: &T6,
        global_step: &T7,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceApplyAdagradDA")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&gradient_accumulator.to_handle(ctx)?)?;
        op.add_input(&gradient_squared_accumulator.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&l1.to_handle(ctx)?)?;
        op.add_input(&l2.to_handle(ctx)?)?;
        op.add_input(&global_step.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceApplyAdagradDA::new().call(&ctx, &var, &gradient_accumulator, &gradient_squared_accumulator, &grad, &lr, &l1, &l2, &global_step)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceApplyAdagradDA>
pub fn resource_apply_adagrad_da<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    gradient_accumulator: &T1,
    gradient_squared_accumulator: &T2,
    grad: &T3,
    lr: &T4,
    l1: &T5,
    l2: &T6,
    global_step: &T7,
) -> crate::Result<()> {
    let op = ResourceApplyAdagradDA::new();
    op.call(
        ctx,
        var,
        gradient_accumulator,
        gradient_squared_accumulator,
        grad,
        lr,
        l1,
        l2,
        global_step,
    )
}

/// ResourceApplyAdagradV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceApplyAdagradV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceApplyAdagradV2 {
    use_locking: ::std::option::Option<bool>,
    update_slots: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceApplyAdagradV2 {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            update_slots: Some(true),
            target_device_name: None,
        }
    }
}
impl ResourceApplyAdagradV2 {
    /// Creates a new `ResourceApplyAdagradV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `update_slots` attribute.
    pub fn update_slots<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.update_slots = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_apply_adagrad_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        accum: &T1,
        lr: &T2,
        epsilon: &T3,
        grad: &T4,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceApplyAdagradV2")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&accum.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&epsilon.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.update_slots {
            op.set_attr_bool("update_slots", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceApplyAdagradV2::new().call(&ctx, &var, &accum, &lr, &epsilon, &grad)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceApplyAdagradV2>
pub fn resource_apply_adagrad_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    accum: &T1,
    lr: &T2,
    epsilon: &T3,
    grad: &T4,
) -> crate::Result<()> {
    let op = ResourceApplyAdagradV2::new();
    op.call(ctx, var, accum, lr, epsilon, grad)
}

/// ResourceApplyAdam
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceApplyAdam>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceApplyAdam {
    use_locking: ::std::option::Option<bool>,
    use_nesterov: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceApplyAdam {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            use_nesterov: Some(false),
            target_device_name: None,
        }
    }
}
impl ResourceApplyAdam {
    /// Creates a new `ResourceApplyAdam`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_nesterov` attribute.
    pub fn use_nesterov<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_nesterov = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_apply_adam.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
        T9: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        m: &T1,
        v: &T2,
        beta1_power: &T3,
        beta2_power: &T4,
        lr: &T5,
        beta1: &T6,
        beta2: &T7,
        epsilon: &T8,
        grad: &T9,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceApplyAdam")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&m.to_handle(ctx)?)?;
        op.add_input(&v.to_handle(ctx)?)?;
        op.add_input(&beta1_power.to_handle(ctx)?)?;
        op.add_input(&beta2_power.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&beta1.to_handle(ctx)?)?;
        op.add_input(&beta2.to_handle(ctx)?)?;
        op.add_input(&epsilon.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_nesterov {
            op.set_attr_bool("use_nesterov", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceApplyAdam::new().call(&ctx, &var, &m, &v, &beta1_power, &beta2_power, &lr, &beta1, &beta2, &epsilon, &grad)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceApplyAdam>
pub fn resource_apply_adam<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
    T9: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    m: &T1,
    v: &T2,
    beta1_power: &T3,
    beta2_power: &T4,
    lr: &T5,
    beta1: &T6,
    beta2: &T7,
    epsilon: &T8,
    grad: &T9,
) -> crate::Result<()> {
    let op = ResourceApplyAdam::new();
    op.call(
        ctx,
        var,
        m,
        v,
        beta1_power,
        beta2_power,
        lr,
        beta1,
        beta2,
        epsilon,
        grad,
    )
}

/// ResourceApplyAdamWithAmsgrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceApplyAdamWithAmsgrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceApplyAdamWithAmsgrad {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceApplyAdamWithAmsgrad {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl ResourceApplyAdamWithAmsgrad {
    /// Creates a new `ResourceApplyAdamWithAmsgrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_apply_adam_with_amsgrad.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
        T9: crate::eager::ToTensorHandle<'a>,
        T10: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        m: &T1,
        v: &T2,
        vhat: &T3,
        beta1_power: &T4,
        beta2_power: &T5,
        lr: &T6,
        beta1: &T7,
        beta2: &T8,
        epsilon: &T9,
        grad: &T10,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceApplyAdamWithAmsgrad")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&m.to_handle(ctx)?)?;
        op.add_input(&v.to_handle(ctx)?)?;
        op.add_input(&vhat.to_handle(ctx)?)?;
        op.add_input(&beta1_power.to_handle(ctx)?)?;
        op.add_input(&beta2_power.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&beta1.to_handle(ctx)?)?;
        op.add_input(&beta2.to_handle(ctx)?)?;
        op.add_input(&epsilon.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceApplyAdamWithAmsgrad::new().call(&ctx, &var, &m, &v, &vhat, &beta1_power, &beta2_power, &lr, &beta1, &beta2, &epsilon, &grad)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceApplyAdamWithAmsgrad>
pub fn resource_apply_adam_with_amsgrad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
    T9: crate::eager::ToTensorHandle<'a>,
    T10: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    m: &T1,
    v: &T2,
    vhat: &T3,
    beta1_power: &T4,
    beta2_power: &T5,
    lr: &T6,
    beta1: &T7,
    beta2: &T8,
    epsilon: &T9,
    grad: &T10,
) -> crate::Result<()> {
    let op = ResourceApplyAdamWithAmsgrad::new();
    op.call(
        ctx,
        var,
        m,
        v,
        vhat,
        beta1_power,
        beta2_power,
        lr,
        beta1,
        beta2,
        epsilon,
        grad,
    )
}

/// ResourceApplyAddSign
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceApplyAddSign>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceApplyAddSign {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceApplyAddSign {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl ResourceApplyAddSign {
    /// Creates a new `ResourceApplyAddSign`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_apply_add_sign.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        m: &T1,
        lr: &T2,
        alpha: &T3,
        sign_decay: &T4,
        beta: &T5,
        grad: &T6,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceApplyAddSign")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&m.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&alpha.to_handle(ctx)?)?;
        op.add_input(&sign_decay.to_handle(ctx)?)?;
        op.add_input(&beta.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceApplyAddSign::new().call(&ctx, &var, &m, &lr, &alpha, &sign_decay, &beta, &grad)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceApplyAddSign>
pub fn resource_apply_add_sign<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    m: &T1,
    lr: &T2,
    alpha: &T3,
    sign_decay: &T4,
    beta: &T5,
    grad: &T6,
) -> crate::Result<()> {
    let op = ResourceApplyAddSign::new();
    op.call(ctx, var, m, lr, alpha, sign_decay, beta, grad)
}

/// ResourceApplyCenteredRMSProp
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceApplyCenteredRMSProp>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceApplyCenteredRMSProp {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceApplyCenteredRMSProp {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl ResourceApplyCenteredRMSProp {
    /// Creates a new `ResourceApplyCenteredRMSProp`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_apply_centered_rmsprop.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        mg: &T1,
        ms: &T2,
        mom: &T3,
        lr: &T4,
        rho: &T5,
        momentum: &T6,
        epsilon: &T7,
        grad: &T8,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceApplyCenteredRMSProp")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&mg.to_handle(ctx)?)?;
        op.add_input(&ms.to_handle(ctx)?)?;
        op.add_input(&mom.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&rho.to_handle(ctx)?)?;
        op.add_input(&momentum.to_handle(ctx)?)?;
        op.add_input(&epsilon.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceApplyCenteredRMSProp::new().call(&ctx, &var, &mg, &ms, &mom, &lr, &rho, &momentum, &epsilon, &grad)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceApplyCenteredRMSProp>
pub fn resource_apply_centered_rmsprop<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    mg: &T1,
    ms: &T2,
    mom: &T3,
    lr: &T4,
    rho: &T5,
    momentum: &T6,
    epsilon: &T7,
    grad: &T8,
) -> crate::Result<()> {
    let op = ResourceApplyCenteredRMSProp::new();
    op.call(ctx, var, mg, ms, mom, lr, rho, momentum, epsilon, grad)
}

/// ResourceApplyFtrl
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceApplyFtrl>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceApplyFtrl {
    use_locking: ::std::option::Option<bool>,
    multiply_linear_by_lr: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceApplyFtrl {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            multiply_linear_by_lr: Some(false),
            target_device_name: None,
        }
    }
}
impl ResourceApplyFtrl {
    /// Creates a new `ResourceApplyFtrl`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `multiply_linear_by_lr` attribute.
    pub fn multiply_linear_by_lr<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.multiply_linear_by_lr = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_apply_ftrl.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        accum: &T1,
        linear: &T2,
        grad: &T3,
        lr: &T4,
        l1: &T5,
        l2: &T6,
        lr_power: &T7,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceApplyFtrl")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&accum.to_handle(ctx)?)?;
        op.add_input(&linear.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&l1.to_handle(ctx)?)?;
        op.add_input(&l2.to_handle(ctx)?)?;
        op.add_input(&lr_power.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.multiply_linear_by_lr {
            op.set_attr_bool("multiply_linear_by_lr", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceApplyFtrl::new().call(&ctx, &var, &accum, &linear, &grad, &lr, &l1, &l2, &lr_power)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceApplyFtrl>
pub fn resource_apply_ftrl<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    accum: &T1,
    linear: &T2,
    grad: &T3,
    lr: &T4,
    l1: &T5,
    l2: &T6,
    lr_power: &T7,
) -> crate::Result<()> {
    let op = ResourceApplyFtrl::new();
    op.call(ctx, var, accum, linear, grad, lr, l1, l2, lr_power)
}

/// ResourceApplyFtrlV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceApplyFtrlV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceApplyFtrlV2 {
    use_locking: ::std::option::Option<bool>,
    multiply_linear_by_lr: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceApplyFtrlV2 {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            multiply_linear_by_lr: Some(false),
            target_device_name: None,
        }
    }
}
impl ResourceApplyFtrlV2 {
    /// Creates a new `ResourceApplyFtrlV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `multiply_linear_by_lr` attribute.
    pub fn multiply_linear_by_lr<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.multiply_linear_by_lr = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_apply_ftrl_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        accum: &T1,
        linear: &T2,
        grad: &T3,
        lr: &T4,
        l1: &T5,
        l2: &T6,
        l2_shrinkage: &T7,
        lr_power: &T8,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceApplyFtrlV2")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&accum.to_handle(ctx)?)?;
        op.add_input(&linear.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&l1.to_handle(ctx)?)?;
        op.add_input(&l2.to_handle(ctx)?)?;
        op.add_input(&l2_shrinkage.to_handle(ctx)?)?;
        op.add_input(&lr_power.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.multiply_linear_by_lr {
            op.set_attr_bool("multiply_linear_by_lr", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceApplyFtrlV2::new().call(&ctx, &var, &accum, &linear, &grad, &lr, &l1, &l2, &l2_shrinkage, &lr_power)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceApplyFtrlV2>
pub fn resource_apply_ftrl_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    accum: &T1,
    linear: &T2,
    grad: &T3,
    lr: &T4,
    l1: &T5,
    l2: &T6,
    l2_shrinkage: &T7,
    lr_power: &T8,
) -> crate::Result<()> {
    let op = ResourceApplyFtrlV2::new();
    op.call(
        ctx,
        var,
        accum,
        linear,
        grad,
        lr,
        l1,
        l2,
        l2_shrinkage,
        lr_power,
    )
}

/// ResourceApplyGradientDescent
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceApplyGradientDescent>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceApplyGradientDescent {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceApplyGradientDescent {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl ResourceApplyGradientDescent {
    /// Creates a new `ResourceApplyGradientDescent`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_apply_gradient_descent.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        alpha: &T1,
        delta: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceApplyGradientDescent")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&alpha.to_handle(ctx)?)?;
        op.add_input(&delta.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceApplyGradientDescent::new().call(&ctx, &var, &alpha, &delta)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceApplyGradientDescent>
pub fn resource_apply_gradient_descent<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    alpha: &T1,
    delta: &T2,
) -> crate::Result<()> {
    let op = ResourceApplyGradientDescent::new();
    op.call(ctx, var, alpha, delta)
}

/// ResourceApplyKerasMomentum
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceApplyKerasMomentum>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceApplyKerasMomentum {
    use_locking: ::std::option::Option<bool>,
    use_nesterov: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceApplyKerasMomentum {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            use_nesterov: Some(false),
            target_device_name: None,
        }
    }
}
impl ResourceApplyKerasMomentum {
    /// Creates a new `ResourceApplyKerasMomentum`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_nesterov` attribute.
    pub fn use_nesterov<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_nesterov = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_apply_keras_momentum.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        accum: &T1,
        lr: &T2,
        grad: &T3,
        momentum: &T4,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceApplyKerasMomentum")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&accum.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&momentum.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_nesterov {
            op.set_attr_bool("use_nesterov", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceApplyKerasMomentum::new().call(&ctx, &var, &accum, &lr, &grad, &momentum)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceApplyKerasMomentum>
pub fn resource_apply_keras_momentum<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    accum: &T1,
    lr: &T2,
    grad: &T3,
    momentum: &T4,
) -> crate::Result<()> {
    let op = ResourceApplyKerasMomentum::new();
    op.call(ctx, var, accum, lr, grad, momentum)
}

/// ResourceApplyMomentum
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceApplyMomentum>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceApplyMomentum {
    use_locking: ::std::option::Option<bool>,
    use_nesterov: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceApplyMomentum {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            use_nesterov: Some(false),
            target_device_name: None,
        }
    }
}
impl ResourceApplyMomentum {
    /// Creates a new `ResourceApplyMomentum`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_nesterov` attribute.
    pub fn use_nesterov<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_nesterov = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_apply_momentum.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        accum: &T1,
        lr: &T2,
        grad: &T3,
        momentum: &T4,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceApplyMomentum")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&accum.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&momentum.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_nesterov {
            op.set_attr_bool("use_nesterov", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceApplyMomentum::new().call(&ctx, &var, &accum, &lr, &grad, &momentum)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceApplyMomentum>
pub fn resource_apply_momentum<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    accum: &T1,
    lr: &T2,
    grad: &T3,
    momentum: &T4,
) -> crate::Result<()> {
    let op = ResourceApplyMomentum::new();
    op.call(ctx, var, accum, lr, grad, momentum)
}

/// ResourceApplyPowerSign
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceApplyPowerSign>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceApplyPowerSign {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceApplyPowerSign {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl ResourceApplyPowerSign {
    /// Creates a new `ResourceApplyPowerSign`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_apply_power_sign.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        m: &T1,
        lr: &T2,
        logbase: &T3,
        sign_decay: &T4,
        beta: &T5,
        grad: &T6,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceApplyPowerSign")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&m.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&logbase.to_handle(ctx)?)?;
        op.add_input(&sign_decay.to_handle(ctx)?)?;
        op.add_input(&beta.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceApplyPowerSign::new().call(&ctx, &var, &m, &lr, &logbase, &sign_decay, &beta, &grad)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceApplyPowerSign>
pub fn resource_apply_power_sign<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    m: &T1,
    lr: &T2,
    logbase: &T3,
    sign_decay: &T4,
    beta: &T5,
    grad: &T6,
) -> crate::Result<()> {
    let op = ResourceApplyPowerSign::new();
    op.call(ctx, var, m, lr, logbase, sign_decay, beta, grad)
}

/// ResourceApplyProximalAdagrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceApplyProximalAdagrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceApplyProximalAdagrad {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceApplyProximalAdagrad {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl ResourceApplyProximalAdagrad {
    /// Creates a new `ResourceApplyProximalAdagrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_apply_proximal_adagrad.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        accum: &T1,
        lr: &T2,
        l1: &T3,
        l2: &T4,
        grad: &T5,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceApplyProximalAdagrad")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&accum.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&l1.to_handle(ctx)?)?;
        op.add_input(&l2.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceApplyProximalAdagrad::new().call(&ctx, &var, &accum, &lr, &l1, &l2, &grad)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceApplyProximalAdagrad>
pub fn resource_apply_proximal_adagrad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    accum: &T1,
    lr: &T2,
    l1: &T3,
    l2: &T4,
    grad: &T5,
) -> crate::Result<()> {
    let op = ResourceApplyProximalAdagrad::new();
    op.call(ctx, var, accum, lr, l1, l2, grad)
}

/// ResourceApplyProximalGradientDescent
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceApplyProximalGradientDescent>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceApplyProximalGradientDescent {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceApplyProximalGradientDescent {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl ResourceApplyProximalGradientDescent {
    /// Creates a new `ResourceApplyProximalGradientDescent`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_apply_proximal_gradient_descent.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        alpha: &T1,
        l1: &T2,
        l2: &T3,
        delta: &T4,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceApplyProximalGradientDescent")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&alpha.to_handle(ctx)?)?;
        op.add_input(&l1.to_handle(ctx)?)?;
        op.add_input(&l2.to_handle(ctx)?)?;
        op.add_input(&delta.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceApplyProximalGradientDescent::new().call(&ctx, &var, &alpha, &l1, &l2, &delta)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceApplyProximalGradientDescent>
pub fn resource_apply_proximal_gradient_descent<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    alpha: &T1,
    l1: &T2,
    l2: &T3,
    delta: &T4,
) -> crate::Result<()> {
    let op = ResourceApplyProximalGradientDescent::new();
    op.call(ctx, var, alpha, l1, l2, delta)
}

/// ResourceApplyRMSProp
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceApplyRMSProp>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceApplyRMSProp {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceApplyRMSProp {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl ResourceApplyRMSProp {
    /// Creates a new `ResourceApplyRMSProp`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_apply_rmsprop.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        ms: &T1,
        mom: &T2,
        lr: &T3,
        rho: &T4,
        momentum: &T5,
        epsilon: &T6,
        grad: &T7,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceApplyRMSProp")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&ms.to_handle(ctx)?)?;
        op.add_input(&mom.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&rho.to_handle(ctx)?)?;
        op.add_input(&momentum.to_handle(ctx)?)?;
        op.add_input(&epsilon.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceApplyRMSProp::new().call(&ctx, &var, &ms, &mom, &lr, &rho, &momentum, &epsilon, &grad)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceApplyRMSProp>
pub fn resource_apply_rmsprop<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    ms: &T1,
    mom: &T2,
    lr: &T3,
    rho: &T4,
    momentum: &T5,
    epsilon: &T6,
    grad: &T7,
) -> crate::Result<()> {
    let op = ResourceApplyRMSProp::new();
    op.call(ctx, var, ms, mom, lr, rho, momentum, epsilon, grad)
}

/// ResourceConditionalAccumulator
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceConditionalAccumulator>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceConditionalAccumulator {
    dtype: ::std::option::Option<crate::DataType>,
    shape: ::std::option::Option<crate::Shape>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    reduction_type: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceConditionalAccumulator {
    fn default() -> Self {
        Self {
            dtype: None,
            shape: None,
            container: None,
            shared_name: None,
            reduction_type: Some(::std::string::String::from("MEAN")),
            target_device_name: None,
        }
    }
}
impl ResourceConditionalAccumulator {
    /// Creates a new `ResourceConditionalAccumulator`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shape` attribute.
    pub fn shape<ArgType: ::std::convert::Into<crate::Shape>>(mut self, value: ArgType) -> Self {
        self.shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `reduction_type` attribute.
    pub fn reduction_type<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.reduction_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_conditional_accumulator.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceConditionalAccumulator")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shape {
            op.set_attr_shape("shape", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.reduction_type {
            op.set_attr_string("reduction_type", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ResourceConditionalAccumulator::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceConditionalAccumulator>
pub fn resource_conditional_accumulator<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ResourceConditionalAccumulator::new();
    op.call(ctx)
}

/// ResourceCountUpTo
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceCountUpTo>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceCountUpTo {
    limit: ::std::option::Option<i64>,
    T: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceCountUpTo {
    fn default() -> Self {
        Self {
            limit: None,
            T: None,
            target_device_name: None,
        }
    }
}
impl ResourceCountUpTo {
    /// Creates a new `ResourceCountUpTo`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `limit` attribute.
    pub fn limit<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.limit = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `T` attribute.
    pub fn T<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.T = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_count_up_to.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        resource: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceCountUpTo")?;

        // Required input arguments
        op.add_input(&resource.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.limit {
            op.set_attr_int("limit", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.T {
            op.set_attr_type("T", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ResourceCountUpTo::new().call(&ctx, &resource)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceCountUpTo>
pub fn resource_count_up_to<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    resource: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ResourceCountUpTo::new();
    op.call(ctx, resource)
}

/// ResourceGather
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceGather>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceGather {
    batch_dims: ::std::option::Option<i64>,
    validate_indices: ::std::option::Option<bool>,
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceGather {
    fn default() -> Self {
        Self {
            batch_dims: Some(0i64),
            validate_indices: Some(true),
            dtype: None,
            target_device_name: None,
        }
    }
}
impl ResourceGather {
    /// Creates a new `ResourceGather`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `batch_dims` attribute.
    pub fn batch_dims<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.batch_dims = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `validate_indices` attribute.
    pub fn validate_indices<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.validate_indices = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_gather.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        resource: &T0,
        indices: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceGather")?;

        // Required input arguments
        op.add_input(&resource.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.batch_dims {
            op.set_attr_int("batch_dims", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.validate_indices {
            op.set_attr_bool("validate_indices", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ResourceGather::new().call(&ctx, &resource, &indices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceGather>
pub fn resource_gather<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    resource: &T0,
    indices: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ResourceGather::new();
    op.call(ctx, resource, indices)
}

/// ResourceGatherNd
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceGatherNd>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceGatherNd {
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceGatherNd {
    fn default() -> Self {
        Self {
            dtype: None,
            target_device_name: None,
        }
    }
}
impl ResourceGatherNd {
    /// Creates a new `ResourceGatherNd`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_gather_nd.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        resource: &T0,
        indices: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceGatherNd")?;

        // Required input arguments
        op.add_input(&resource.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ResourceGatherNd::new().call(&ctx, &resource, &indices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceGatherNd>
pub fn resource_gather_nd<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    resource: &T0,
    indices: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ResourceGatherNd::new();
    op.call(ctx, resource, indices)
}

/// ResourceScatterAdd
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceScatterAdd>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceScatterAdd {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceScatterAdd {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ResourceScatterAdd {
    /// Creates a new `ResourceScatterAdd`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_scatter_add.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        resource: &T0,
        indices: &T1,
        updates: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceScatterAdd")?;

        // Required input arguments
        op.add_input(&resource.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&updates.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceScatterAdd::new().call(&ctx, &resource, &indices, &updates)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceScatterAdd>
pub fn resource_scatter_add<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    resource: &T0,
    indices: &T1,
    updates: &T2,
) -> crate::Result<()> {
    let op = ResourceScatterAdd::new();
    op.call(ctx, resource, indices, updates)
}

/// ResourceScatterDiv
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceScatterDiv>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceScatterDiv {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceScatterDiv {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ResourceScatterDiv {
    /// Creates a new `ResourceScatterDiv`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_scatter_div.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        resource: &T0,
        indices: &T1,
        updates: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceScatterDiv")?;

        // Required input arguments
        op.add_input(&resource.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&updates.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceScatterDiv::new().call(&ctx, &resource, &indices, &updates)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceScatterDiv>
pub fn resource_scatter_div<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    resource: &T0,
    indices: &T1,
    updates: &T2,
) -> crate::Result<()> {
    let op = ResourceScatterDiv::new();
    op.call(ctx, resource, indices, updates)
}

/// ResourceScatterMax
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceScatterMax>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceScatterMax {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceScatterMax {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ResourceScatterMax {
    /// Creates a new `ResourceScatterMax`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_scatter_max.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        resource: &T0,
        indices: &T1,
        updates: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceScatterMax")?;

        // Required input arguments
        op.add_input(&resource.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&updates.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceScatterMax::new().call(&ctx, &resource, &indices, &updates)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceScatterMax>
pub fn resource_scatter_max<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    resource: &T0,
    indices: &T1,
    updates: &T2,
) -> crate::Result<()> {
    let op = ResourceScatterMax::new();
    op.call(ctx, resource, indices, updates)
}

/// ResourceScatterMin
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceScatterMin>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceScatterMin {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceScatterMin {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ResourceScatterMin {
    /// Creates a new `ResourceScatterMin`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_scatter_min.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        resource: &T0,
        indices: &T1,
        updates: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceScatterMin")?;

        // Required input arguments
        op.add_input(&resource.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&updates.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceScatterMin::new().call(&ctx, &resource, &indices, &updates)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceScatterMin>
pub fn resource_scatter_min<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    resource: &T0,
    indices: &T1,
    updates: &T2,
) -> crate::Result<()> {
    let op = ResourceScatterMin::new();
    op.call(ctx, resource, indices, updates)
}

/// ResourceScatterMul
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceScatterMul>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceScatterMul {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceScatterMul {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ResourceScatterMul {
    /// Creates a new `ResourceScatterMul`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_scatter_mul.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        resource: &T0,
        indices: &T1,
        updates: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceScatterMul")?;

        // Required input arguments
        op.add_input(&resource.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&updates.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceScatterMul::new().call(&ctx, &resource, &indices, &updates)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceScatterMul>
pub fn resource_scatter_mul<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    resource: &T0,
    indices: &T1,
    updates: &T2,
) -> crate::Result<()> {
    let op = ResourceScatterMul::new();
    op.call(ctx, resource, indices, updates)
}

/// ResourceScatterNdAdd
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceScatterNdAdd>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceScatterNdAdd {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceScatterNdAdd {
    fn default() -> Self {
        Self {
            use_locking: Some(true),
            target_device_name: None,
        }
    }
}
impl ResourceScatterNdAdd {
    /// Creates a new `ResourceScatterNdAdd`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_scatter_nd_add.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        ref_: &T0,
        indices: &T1,
        updates: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceScatterNdAdd")?;

        // Required input arguments
        op.add_input(&ref_.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&updates.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceScatterNdAdd::new().call(&ctx, &ref_, &indices, &updates)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceScatterNdAdd>
pub fn resource_scatter_nd_add<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    ref_: &T0,
    indices: &T1,
    updates: &T2,
) -> crate::Result<()> {
    let op = ResourceScatterNdAdd::new();
    op.call(ctx, ref_, indices, updates)
}

/// ResourceScatterNdMax
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceScatterNdMax>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceScatterNdMax {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceScatterNdMax {
    fn default() -> Self {
        Self {
            use_locking: Some(true),
            target_device_name: None,
        }
    }
}
impl ResourceScatterNdMax {
    /// Creates a new `ResourceScatterNdMax`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_scatter_nd_max.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        ref_: &T0,
        indices: &T1,
        updates: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceScatterNdMax")?;

        // Required input arguments
        op.add_input(&ref_.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&updates.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceScatterNdMax::new().call(&ctx, &ref_, &indices, &updates)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceScatterNdMax>
pub fn resource_scatter_nd_max<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    ref_: &T0,
    indices: &T1,
    updates: &T2,
) -> crate::Result<()> {
    let op = ResourceScatterNdMax::new();
    op.call(ctx, ref_, indices, updates)
}

/// ResourceScatterNdMin
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceScatterNdMin>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceScatterNdMin {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceScatterNdMin {
    fn default() -> Self {
        Self {
            use_locking: Some(true),
            target_device_name: None,
        }
    }
}
impl ResourceScatterNdMin {
    /// Creates a new `ResourceScatterNdMin`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_scatter_nd_min.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        ref_: &T0,
        indices: &T1,
        updates: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceScatterNdMin")?;

        // Required input arguments
        op.add_input(&ref_.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&updates.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceScatterNdMin::new().call(&ctx, &ref_, &indices, &updates)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceScatterNdMin>
pub fn resource_scatter_nd_min<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    ref_: &T0,
    indices: &T1,
    updates: &T2,
) -> crate::Result<()> {
    let op = ResourceScatterNdMin::new();
    op.call(ctx, ref_, indices, updates)
}

/// ResourceScatterNdSub
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceScatterNdSub>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceScatterNdSub {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceScatterNdSub {
    fn default() -> Self {
        Self {
            use_locking: Some(true),
            target_device_name: None,
        }
    }
}
impl ResourceScatterNdSub {
    /// Creates a new `ResourceScatterNdSub`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_scatter_nd_sub.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        ref_: &T0,
        indices: &T1,
        updates: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceScatterNdSub")?;

        // Required input arguments
        op.add_input(&ref_.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&updates.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceScatterNdSub::new().call(&ctx, &ref_, &indices, &updates)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceScatterNdSub>
pub fn resource_scatter_nd_sub<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    ref_: &T0,
    indices: &T1,
    updates: &T2,
) -> crate::Result<()> {
    let op = ResourceScatterNdSub::new();
    op.call(ctx, ref_, indices, updates)
}

/// ResourceScatterNdUpdate
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceScatterNdUpdate>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceScatterNdUpdate {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceScatterNdUpdate {
    fn default() -> Self {
        Self {
            use_locking: Some(true),
            target_device_name: None,
        }
    }
}
impl ResourceScatterNdUpdate {
    /// Creates a new `ResourceScatterNdUpdate`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_scatter_nd_update.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        ref_: &T0,
        indices: &T1,
        updates: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceScatterNdUpdate")?;

        // Required input arguments
        op.add_input(&ref_.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&updates.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceScatterNdUpdate::new().call(&ctx, &ref_, &indices, &updates)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceScatterNdUpdate>
pub fn resource_scatter_nd_update<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    ref_: &T0,
    indices: &T1,
    updates: &T2,
) -> crate::Result<()> {
    let op = ResourceScatterNdUpdate::new();
    op.call(ctx, ref_, indices, updates)
}

/// ResourceScatterSub
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceScatterSub>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceScatterSub {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceScatterSub {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ResourceScatterSub {
    /// Creates a new `ResourceScatterSub`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_scatter_sub.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        resource: &T0,
        indices: &T1,
        updates: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceScatterSub")?;

        // Required input arguments
        op.add_input(&resource.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&updates.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceScatterSub::new().call(&ctx, &resource, &indices, &updates)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceScatterSub>
pub fn resource_scatter_sub<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    resource: &T0,
    indices: &T1,
    updates: &T2,
) -> crate::Result<()> {
    let op = ResourceScatterSub::new();
    op.call(ctx, resource, indices, updates)
}

/// ResourceScatterUpdate
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceScatterUpdate>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceScatterUpdate {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceScatterUpdate {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ResourceScatterUpdate {
    /// Creates a new `ResourceScatterUpdate`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_scatter_update.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        resource: &T0,
        indices: &T1,
        updates: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceScatterUpdate")?;

        // Required input arguments
        op.add_input(&resource.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&updates.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceScatterUpdate::new().call(&ctx, &resource, &indices, &updates)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceScatterUpdate>
pub fn resource_scatter_update<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    resource: &T0,
    indices: &T1,
    updates: &T2,
) -> crate::Result<()> {
    let op = ResourceScatterUpdate::new();
    op.call(ctx, resource, indices, updates)
}

/// ResourceSparseApplyAdadelta
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceSparseApplyAdadelta>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceSparseApplyAdadelta {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceSparseApplyAdadelta {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl ResourceSparseApplyAdadelta {
    /// Creates a new `ResourceSparseApplyAdadelta`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_sparse_apply_adadelta.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        accum: &T1,
        accum_update: &T2,
        lr: &T3,
        rho: &T4,
        epsilon: &T5,
        grad: &T6,
        indices: &T7,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceSparseApplyAdadelta")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&accum.to_handle(ctx)?)?;
        op.add_input(&accum_update.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&rho.to_handle(ctx)?)?;
        op.add_input(&epsilon.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceSparseApplyAdadelta::new().call(&ctx, &var, &accum, &accum_update, &lr, &rho, &epsilon, &grad, &indices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceSparseApplyAdadelta>
pub fn resource_sparse_apply_adadelta<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    accum: &T1,
    accum_update: &T2,
    lr: &T3,
    rho: &T4,
    epsilon: &T5,
    grad: &T6,
    indices: &T7,
) -> crate::Result<()> {
    let op = ResourceSparseApplyAdadelta::new();
    op.call(
        ctx,
        var,
        accum,
        accum_update,
        lr,
        rho,
        epsilon,
        grad,
        indices,
    )
}

/// ResourceSparseApplyAdagrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceSparseApplyAdagrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceSparseApplyAdagrad {
    use_locking: ::std::option::Option<bool>,
    update_slots: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceSparseApplyAdagrad {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            update_slots: Some(true),
            target_device_name: None,
        }
    }
}
impl ResourceSparseApplyAdagrad {
    /// Creates a new `ResourceSparseApplyAdagrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `update_slots` attribute.
    pub fn update_slots<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.update_slots = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_sparse_apply_adagrad.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        accum: &T1,
        lr: &T2,
        grad: &T3,
        indices: &T4,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceSparseApplyAdagrad")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&accum.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.update_slots {
            op.set_attr_bool("update_slots", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceSparseApplyAdagrad::new().call(&ctx, &var, &accum, &lr, &grad, &indices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceSparseApplyAdagrad>
pub fn resource_sparse_apply_adagrad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    accum: &T1,
    lr: &T2,
    grad: &T3,
    indices: &T4,
) -> crate::Result<()> {
    let op = ResourceSparseApplyAdagrad::new();
    op.call(ctx, var, accum, lr, grad, indices)
}

/// ResourceSparseApplyAdagradDA
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceSparseApplyAdagradDA>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceSparseApplyAdagradDA {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceSparseApplyAdagradDA {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl ResourceSparseApplyAdagradDA {
    /// Creates a new `ResourceSparseApplyAdagradDA`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_sparse_apply_adagrad_da.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        gradient_accumulator: &T1,
        gradient_squared_accumulator: &T2,
        grad: &T3,
        indices: &T4,
        lr: &T5,
        l1: &T6,
        l2: &T7,
        global_step: &T8,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceSparseApplyAdagradDA")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&gradient_accumulator.to_handle(ctx)?)?;
        op.add_input(&gradient_squared_accumulator.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&l1.to_handle(ctx)?)?;
        op.add_input(&l2.to_handle(ctx)?)?;
        op.add_input(&global_step.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceSparseApplyAdagradDA::new().call(&ctx, &var, &gradient_accumulator, &gradient_squared_accumulator, &grad, &indices, &lr, &l1, &l2, &global_step)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceSparseApplyAdagradDA>
pub fn resource_sparse_apply_adagrad_da<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    gradient_accumulator: &T1,
    gradient_squared_accumulator: &T2,
    grad: &T3,
    indices: &T4,
    lr: &T5,
    l1: &T6,
    l2: &T7,
    global_step: &T8,
) -> crate::Result<()> {
    let op = ResourceSparseApplyAdagradDA::new();
    op.call(
        ctx,
        var,
        gradient_accumulator,
        gradient_squared_accumulator,
        grad,
        indices,
        lr,
        l1,
        l2,
        global_step,
    )
}

/// ResourceSparseApplyAdagradV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceSparseApplyAdagradV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceSparseApplyAdagradV2 {
    use_locking: ::std::option::Option<bool>,
    update_slots: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceSparseApplyAdagradV2 {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            update_slots: Some(true),
            target_device_name: None,
        }
    }
}
impl ResourceSparseApplyAdagradV2 {
    /// Creates a new `ResourceSparseApplyAdagradV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `update_slots` attribute.
    pub fn update_slots<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.update_slots = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_sparse_apply_adagrad_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        accum: &T1,
        lr: &T2,
        epsilon: &T3,
        grad: &T4,
        indices: &T5,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceSparseApplyAdagradV2")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&accum.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&epsilon.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.update_slots {
            op.set_attr_bool("update_slots", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceSparseApplyAdagradV2::new().call(&ctx, &var, &accum, &lr, &epsilon, &grad, &indices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceSparseApplyAdagradV2>
pub fn resource_sparse_apply_adagrad_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    accum: &T1,
    lr: &T2,
    epsilon: &T3,
    grad: &T4,
    indices: &T5,
) -> crate::Result<()> {
    let op = ResourceSparseApplyAdagradV2::new();
    op.call(ctx, var, accum, lr, epsilon, grad, indices)
}

/// ResourceSparseApplyCenteredRMSProp
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceSparseApplyCenteredRMSProp>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceSparseApplyCenteredRMSProp {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceSparseApplyCenteredRMSProp {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl ResourceSparseApplyCenteredRMSProp {
    /// Creates a new `ResourceSparseApplyCenteredRMSProp`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_sparse_apply_centered_rmsprop.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
        T9: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        mg: &T1,
        ms: &T2,
        mom: &T3,
        lr: &T4,
        rho: &T5,
        momentum: &T6,
        epsilon: &T7,
        grad: &T8,
        indices: &T9,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceSparseApplyCenteredRMSProp")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&mg.to_handle(ctx)?)?;
        op.add_input(&ms.to_handle(ctx)?)?;
        op.add_input(&mom.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&rho.to_handle(ctx)?)?;
        op.add_input(&momentum.to_handle(ctx)?)?;
        op.add_input(&epsilon.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceSparseApplyCenteredRMSProp::new().call(&ctx, &var, &mg, &ms, &mom, &lr, &rho, &momentum, &epsilon, &grad, &indices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceSparseApplyCenteredRMSProp>
pub fn resource_sparse_apply_centered_rmsprop<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
    T9: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    mg: &T1,
    ms: &T2,
    mom: &T3,
    lr: &T4,
    rho: &T5,
    momentum: &T6,
    epsilon: &T7,
    grad: &T8,
    indices: &T9,
) -> crate::Result<()> {
    let op = ResourceSparseApplyCenteredRMSProp::new();
    op.call(
        ctx, var, mg, ms, mom, lr, rho, momentum, epsilon, grad, indices,
    )
}

/// ResourceSparseApplyFtrl
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceSparseApplyFtrl>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceSparseApplyFtrl {
    use_locking: ::std::option::Option<bool>,
    multiply_linear_by_lr: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceSparseApplyFtrl {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            multiply_linear_by_lr: Some(false),
            target_device_name: None,
        }
    }
}
impl ResourceSparseApplyFtrl {
    /// Creates a new `ResourceSparseApplyFtrl`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `multiply_linear_by_lr` attribute.
    pub fn multiply_linear_by_lr<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.multiply_linear_by_lr = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_sparse_apply_ftrl.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        accum: &T1,
        linear: &T2,
        grad: &T3,
        indices: &T4,
        lr: &T5,
        l1: &T6,
        l2: &T7,
        lr_power: &T8,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceSparseApplyFtrl")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&accum.to_handle(ctx)?)?;
        op.add_input(&linear.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&l1.to_handle(ctx)?)?;
        op.add_input(&l2.to_handle(ctx)?)?;
        op.add_input(&lr_power.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.multiply_linear_by_lr {
            op.set_attr_bool("multiply_linear_by_lr", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceSparseApplyFtrl::new().call(&ctx, &var, &accum, &linear, &grad, &indices, &lr, &l1, &l2, &lr_power)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceSparseApplyFtrl>
pub fn resource_sparse_apply_ftrl<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    accum: &T1,
    linear: &T2,
    grad: &T3,
    indices: &T4,
    lr: &T5,
    l1: &T6,
    l2: &T7,
    lr_power: &T8,
) -> crate::Result<()> {
    let op = ResourceSparseApplyFtrl::new();
    op.call(ctx, var, accum, linear, grad, indices, lr, l1, l2, lr_power)
}

/// ResourceSparseApplyFtrlV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceSparseApplyFtrlV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceSparseApplyFtrlV2 {
    use_locking: ::std::option::Option<bool>,
    multiply_linear_by_lr: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceSparseApplyFtrlV2 {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            multiply_linear_by_lr: Some(false),
            target_device_name: None,
        }
    }
}
impl ResourceSparseApplyFtrlV2 {
    /// Creates a new `ResourceSparseApplyFtrlV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `multiply_linear_by_lr` attribute.
    pub fn multiply_linear_by_lr<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.multiply_linear_by_lr = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_sparse_apply_ftrl_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
        T9: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        accum: &T1,
        linear: &T2,
        grad: &T3,
        indices: &T4,
        lr: &T5,
        l1: &T6,
        l2: &T7,
        l2_shrinkage: &T8,
        lr_power: &T9,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceSparseApplyFtrlV2")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&accum.to_handle(ctx)?)?;
        op.add_input(&linear.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&l1.to_handle(ctx)?)?;
        op.add_input(&l2.to_handle(ctx)?)?;
        op.add_input(&l2_shrinkage.to_handle(ctx)?)?;
        op.add_input(&lr_power.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.multiply_linear_by_lr {
            op.set_attr_bool("multiply_linear_by_lr", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceSparseApplyFtrlV2::new().call(&ctx, &var, &accum, &linear, &grad, &indices, &lr, &l1, &l2, &l2_shrinkage, &lr_power)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceSparseApplyFtrlV2>
pub fn resource_sparse_apply_ftrl_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
    T9: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    accum: &T1,
    linear: &T2,
    grad: &T3,
    indices: &T4,
    lr: &T5,
    l1: &T6,
    l2: &T7,
    l2_shrinkage: &T8,
    lr_power: &T9,
) -> crate::Result<()> {
    let op = ResourceSparseApplyFtrlV2::new();
    op.call(
        ctx,
        var,
        accum,
        linear,
        grad,
        indices,
        lr,
        l1,
        l2,
        l2_shrinkage,
        lr_power,
    )
}

/// ResourceSparseApplyKerasMomentum
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceSparseApplyKerasMomentum>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceSparseApplyKerasMomentum {
    use_locking: ::std::option::Option<bool>,
    use_nesterov: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceSparseApplyKerasMomentum {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            use_nesterov: Some(false),
            target_device_name: None,
        }
    }
}
impl ResourceSparseApplyKerasMomentum {
    /// Creates a new `ResourceSparseApplyKerasMomentum`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_nesterov` attribute.
    pub fn use_nesterov<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_nesterov = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_sparse_apply_keras_momentum.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        accum: &T1,
        lr: &T2,
        grad: &T3,
        indices: &T4,
        momentum: &T5,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceSparseApplyKerasMomentum")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&accum.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&momentum.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_nesterov {
            op.set_attr_bool("use_nesterov", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceSparseApplyKerasMomentum::new().call(&ctx, &var, &accum, &lr, &grad, &indices, &momentum)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceSparseApplyKerasMomentum>
pub fn resource_sparse_apply_keras_momentum<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    accum: &T1,
    lr: &T2,
    grad: &T3,
    indices: &T4,
    momentum: &T5,
) -> crate::Result<()> {
    let op = ResourceSparseApplyKerasMomentum::new();
    op.call(ctx, var, accum, lr, grad, indices, momentum)
}

/// ResourceSparseApplyMomentum
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceSparseApplyMomentum>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceSparseApplyMomentum {
    use_locking: ::std::option::Option<bool>,
    use_nesterov: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceSparseApplyMomentum {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            use_nesterov: Some(false),
            target_device_name: None,
        }
    }
}
impl ResourceSparseApplyMomentum {
    /// Creates a new `ResourceSparseApplyMomentum`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_nesterov` attribute.
    pub fn use_nesterov<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_nesterov = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_sparse_apply_momentum.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        accum: &T1,
        lr: &T2,
        grad: &T3,
        indices: &T4,
        momentum: &T5,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceSparseApplyMomentum")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&accum.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&momentum.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_nesterov {
            op.set_attr_bool("use_nesterov", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceSparseApplyMomentum::new().call(&ctx, &var, &accum, &lr, &grad, &indices, &momentum)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceSparseApplyMomentum>
pub fn resource_sparse_apply_momentum<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    accum: &T1,
    lr: &T2,
    grad: &T3,
    indices: &T4,
    momentum: &T5,
) -> crate::Result<()> {
    let op = ResourceSparseApplyMomentum::new();
    op.call(ctx, var, accum, lr, grad, indices, momentum)
}

/// ResourceSparseApplyProximalAdagrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceSparseApplyProximalAdagrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceSparseApplyProximalAdagrad {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceSparseApplyProximalAdagrad {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl ResourceSparseApplyProximalAdagrad {
    /// Creates a new `ResourceSparseApplyProximalAdagrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_sparse_apply_proximal_adagrad.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        accum: &T1,
        lr: &T2,
        l1: &T3,
        l2: &T4,
        grad: &T5,
        indices: &T6,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceSparseApplyProximalAdagrad")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&accum.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&l1.to_handle(ctx)?)?;
        op.add_input(&l2.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceSparseApplyProximalAdagrad::new().call(&ctx, &var, &accum, &lr, &l1, &l2, &grad, &indices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceSparseApplyProximalAdagrad>
pub fn resource_sparse_apply_proximal_adagrad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    accum: &T1,
    lr: &T2,
    l1: &T3,
    l2: &T4,
    grad: &T5,
    indices: &T6,
) -> crate::Result<()> {
    let op = ResourceSparseApplyProximalAdagrad::new();
    op.call(ctx, var, accum, lr, l1, l2, grad, indices)
}

/// ResourceSparseApplyProximalGradientDescent
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceSparseApplyProximalGradientDescent>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceSparseApplyProximalGradientDescent {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceSparseApplyProximalGradientDescent {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl ResourceSparseApplyProximalGradientDescent {
    /// Creates a new `ResourceSparseApplyProximalGradientDescent`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_sparse_apply_proximal_gradient_descent.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        alpha: &T1,
        l1: &T2,
        l2: &T3,
        grad: &T4,
        indices: &T5,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceSparseApplyProximalGradientDescent")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&alpha.to_handle(ctx)?)?;
        op.add_input(&l1.to_handle(ctx)?)?;
        op.add_input(&l2.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceSparseApplyProximalGradientDescent::new().call(&ctx, &var, &alpha, &l1, &l2, &grad, &indices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceSparseApplyProximalGradientDescent>
pub fn resource_sparse_apply_proximal_gradient_descent<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    alpha: &T1,
    l1: &T2,
    l2: &T3,
    grad: &T4,
    indices: &T5,
) -> crate::Result<()> {
    let op = ResourceSparseApplyProximalGradientDescent::new();
    op.call(ctx, var, alpha, l1, l2, grad, indices)
}

/// ResourceSparseApplyRMSProp
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceSparseApplyRMSProp>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceSparseApplyRMSProp {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceSparseApplyRMSProp {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl ResourceSparseApplyRMSProp {
    /// Creates a new `ResourceSparseApplyRMSProp`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_sparse_apply_rmsprop.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        ms: &T1,
        mom: &T2,
        lr: &T3,
        rho: &T4,
        momentum: &T5,
        epsilon: &T6,
        grad: &T7,
        indices: &T8,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceSparseApplyRMSProp")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&ms.to_handle(ctx)?)?;
        op.add_input(&mom.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&rho.to_handle(ctx)?)?;
        op.add_input(&momentum.to_handle(ctx)?)?;
        op.add_input(&epsilon.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceSparseApplyRMSProp::new().call(&ctx, &var, &ms, &mom, &lr, &rho, &momentum, &epsilon, &grad, &indices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceSparseApplyRMSProp>
pub fn resource_sparse_apply_rmsprop<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    ms: &T1,
    mom: &T2,
    lr: &T3,
    rho: &T4,
    momentum: &T5,
    epsilon: &T6,
    grad: &T7,
    indices: &T8,
) -> crate::Result<()> {
    let op = ResourceSparseApplyRMSProp::new();
    op.call(ctx, var, ms, mom, lr, rho, momentum, epsilon, grad, indices)
}

/// ResourceStridedSliceAssign
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceStridedSliceAssign>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ResourceStridedSliceAssign {
    begin_mask: ::std::option::Option<i64>,
    end_mask: ::std::option::Option<i64>,
    ellipsis_mask: ::std::option::Option<i64>,
    new_axis_mask: ::std::option::Option<i64>,
    shrink_axis_mask: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ResourceStridedSliceAssign {
    fn default() -> Self {
        Self {
            begin_mask: Some(0i64),
            end_mask: Some(0i64),
            ellipsis_mask: Some(0i64),
            new_axis_mask: Some(0i64),
            shrink_axis_mask: Some(0i64),
            target_device_name: None,
        }
    }
}
impl ResourceStridedSliceAssign {
    /// Creates a new `ResourceStridedSliceAssign`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `begin_mask` attribute.
    pub fn begin_mask<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.begin_mask = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `end_mask` attribute.
    pub fn end_mask<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.end_mask = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `ellipsis_mask` attribute.
    pub fn ellipsis_mask<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.ellipsis_mask = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `new_axis_mask` attribute.
    pub fn new_axis_mask<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.new_axis_mask = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shrink_axis_mask` attribute.
    pub fn shrink_axis_mask<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.shrink_axis_mask = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute resource_strided_slice_assign.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        ref_: &T0,
        begin: &T1,
        end: &T2,
        strides: &T3,
        value: &T4,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ResourceStridedSliceAssign")?;

        // Required input arguments
        op.add_input(&ref_.to_handle(ctx)?)?;
        op.add_input(&begin.to_handle(ctx)?)?;
        op.add_input(&end.to_handle(ctx)?)?;
        op.add_input(&strides.to_handle(ctx)?)?;
        op.add_input(&value.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.begin_mask {
            op.set_attr_int("begin_mask", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.end_mask {
            op.set_attr_int("end_mask", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.ellipsis_mask {
            op.set_attr_int("ellipsis_mask", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.new_axis_mask {
            op.set_attr_int("new_axis_mask", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shrink_axis_mask {
            op.set_attr_int("shrink_axis_mask", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ResourceStridedSliceAssign::new().call(&ctx, &ref_, &begin, &end, &strides, &value)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ResourceStridedSliceAssign>
pub fn resource_strided_slice_assign<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    ref_: &T0,
    begin: &T1,
    end: &T2,
    strides: &T3,
    value: &T4,
) -> crate::Result<()> {
    let op = ResourceStridedSliceAssign::new();
    op.call(ctx, ref_, begin, end, strides, value)
}

/// Restore
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Restore>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Restore {
    dt: ::std::option::Option<crate::DataType>,
    preferred_shard: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Restore {
    fn default() -> Self {
        Self {
            dt: None,
            preferred_shard: Some(-1i64),
            target_device_name: None,
        }
    }
}
impl Restore {
    /// Creates a new `Restore`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dt` attribute.
    pub fn dt<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dt = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `preferred_shard` attribute.
    pub fn preferred_shard<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.preferred_shard = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute restore.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        file_pattern: &T0,
        tensor_name: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Restore")?;

        // Required input arguments
        op.add_input(&file_pattern.to_handle(ctx)?)?;
        op.add_input(&tensor_name.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dt {
            op.set_attr_type("dt", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.preferred_shard {
            op.set_attr_int("preferred_shard", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Restore::new().call(&ctx, &file_pattern, &tensor_name)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Restore>
pub fn restore<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    file_pattern: &T0,
    tensor_name: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Restore::new();
    op.call(ctx, file_pattern, tensor_name)
}

/// RestoreSlice
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RestoreSlice>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RestoreSlice {
    dt: ::std::option::Option<crate::DataType>,
    preferred_shard: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RestoreSlice {
    fn default() -> Self {
        Self {
            dt: None,
            preferred_shard: Some(-1i64),
            target_device_name: None,
        }
    }
}
impl RestoreSlice {
    /// Creates a new `RestoreSlice`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dt` attribute.
    pub fn dt<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dt = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `preferred_shard` attribute.
    pub fn preferred_shard<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.preferred_shard = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute restore_slice.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        file_pattern: &T0,
        tensor_name: &T1,
        shape_and_slice: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RestoreSlice")?;

        // Required input arguments
        op.add_input(&file_pattern.to_handle(ctx)?)?;
        op.add_input(&tensor_name.to_handle(ctx)?)?;
        op.add_input(&shape_and_slice.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dt {
            op.set_attr_type("dt", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.preferred_shard {
            op.set_attr_int("preferred_shard", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RestoreSlice::new().call(&ctx, &file_pattern, &tensor_name, &shape_and_slice)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RestoreSlice>
pub fn restore_slice<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    file_pattern: &T0,
    tensor_name: &T1,
    shape_and_slice: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RestoreSlice::new();
    op.call(ctx, file_pattern, tensor_name, shape_and_slice)
}

/// RestoreV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RestoreV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RestoreV2 {
    dtypes: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RestoreV2 {
    fn default() -> Self {
        Self {
            dtypes: None,
            target_device_name: None,
        }
    }
}
impl RestoreV2 {
    /// Creates a new `RestoreV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtypes` attribute.
    pub fn dtypes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dtypes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute restore_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        prefix: &T0,
        tensor_names: &T1,
        shape_and_slices: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RestoreV2")?;

        // Required input arguments
        op.add_input(&prefix.to_handle(ctx)?)?;
        op.add_input(&tensor_names.to_handle(ctx)?)?;
        op.add_input(&shape_and_slices.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtypes {
            op.set_attr_type_list("dtypes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RestoreV2::new().call(&ctx, &prefix, &tensor_names, &shape_and_slices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RestoreV2>
pub fn restore_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    prefix: &T0,
    tensor_names: &T1,
    shape_and_slices: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RestoreV2::new();
    op.call(ctx, prefix, tensor_names, shape_and_slices)
}

/// RetrieveAllTPUEmbeddingParameters
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RetrieveAllTPUEmbeddingParameters>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RetrieveAllTPUEmbeddingParameters {
    NumTables: ::std::option::Option<i64>,
    config: ::std::option::Option<::std::string::String>,
    num_shards: ::std::option::Option<i64>,
    shard_id: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RetrieveAllTPUEmbeddingParameters {
    fn default() -> Self {
        Self {
            NumTables: None,
            config: None,
            num_shards: None,
            shard_id: None,
            target_device_name: None,
        }
    }
}
impl RetrieveAllTPUEmbeddingParameters {
    /// Creates a new `RetrieveAllTPUEmbeddingParameters`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `NumTables` attribute.
    pub fn NumTables<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.NumTables = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_shards` attribute.
    pub fn num_shards<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_shards = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shard_id` attribute.
    pub fn shard_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.shard_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute retrieve_all_tpuembedding_parameters.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 8]> {
        // Define Op
        let mut op = super::Op::new(ctx, "RetrieveAllTPUEmbeddingParameters")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.NumTables {
            op.set_attr_int("NumTables", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_shards {
            op.set_attr_int("num_shards", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shard_id {
            op.set_attr_int("shard_id", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<8>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `RetrieveAllTPUEmbeddingParameters::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RetrieveAllTPUEmbeddingParameters>
pub fn retrieve_all_tpuembedding_parameters<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 8]> {
    let op = RetrieveAllTPUEmbeddingParameters::new();
    op.call(ctx)
}

/// RetrieveTPUEmbeddingADAMParameters
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RetrieveTPUEmbeddingADAMParameters>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RetrieveTPUEmbeddingADAMParameters {
    table_id: ::std::option::Option<i64>,
    table_name: ::std::option::Option<::std::string::String>,
    num_shards: ::std::option::Option<i64>,
    shard_id: ::std::option::Option<i64>,
    config: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RetrieveTPUEmbeddingADAMParameters {
    fn default() -> Self {
        Self {
            table_id: Some(-1i64),
            table_name: None,
            num_shards: None,
            shard_id: None,
            config: None,
            target_device_name: None,
        }
    }
}
impl RetrieveTPUEmbeddingADAMParameters {
    /// Creates a new `RetrieveTPUEmbeddingADAMParameters`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `table_id` attribute.
    pub fn table_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.table_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `table_name` attribute.
    pub fn table_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.table_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_shards` attribute.
    pub fn num_shards<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_shards = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shard_id` attribute.
    pub fn shard_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.shard_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute retrieve_tpuembedding_adamparameters.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "RetrieveTPUEmbeddingADAMParameters")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.table_id {
            op.set_attr_int("table_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.table_name {
            op.set_attr_string("table_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_shards {
            op.set_attr_int("num_shards", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shard_id {
            op.set_attr_int("shard_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `RetrieveTPUEmbeddingADAMParameters::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RetrieveTPUEmbeddingADAMParameters>
pub fn retrieve_tpuembedding_adamparameters<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = RetrieveTPUEmbeddingADAMParameters::new();
    op.call(ctx)
}

/// RetrieveTPUEmbeddingAdadeltaParameters
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RetrieveTPUEmbeddingAdadeltaParameters>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RetrieveTPUEmbeddingAdadeltaParameters {
    table_id: ::std::option::Option<i64>,
    table_name: ::std::option::Option<::std::string::String>,
    num_shards: ::std::option::Option<i64>,
    shard_id: ::std::option::Option<i64>,
    config: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RetrieveTPUEmbeddingAdadeltaParameters {
    fn default() -> Self {
        Self {
            table_id: Some(-1i64),
            table_name: None,
            num_shards: None,
            shard_id: None,
            config: None,
            target_device_name: None,
        }
    }
}
impl RetrieveTPUEmbeddingAdadeltaParameters {
    /// Creates a new `RetrieveTPUEmbeddingAdadeltaParameters`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `table_id` attribute.
    pub fn table_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.table_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `table_name` attribute.
    pub fn table_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.table_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_shards` attribute.
    pub fn num_shards<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_shards = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shard_id` attribute.
    pub fn shard_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.shard_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute retrieve_tpuembedding_adadelta_parameters.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "RetrieveTPUEmbeddingAdadeltaParameters")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.table_id {
            op.set_attr_int("table_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.table_name {
            op.set_attr_string("table_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_shards {
            op.set_attr_int("num_shards", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shard_id {
            op.set_attr_int("shard_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `RetrieveTPUEmbeddingAdadeltaParameters::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RetrieveTPUEmbeddingAdadeltaParameters>
pub fn retrieve_tpuembedding_adadelta_parameters<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = RetrieveTPUEmbeddingAdadeltaParameters::new();
    op.call(ctx)
}

/// RetrieveTPUEmbeddingAdagradMomentumParameters
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RetrieveTPUEmbeddingAdagradMomentumParameters>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RetrieveTPUEmbeddingAdagradMomentumParameters {
    table_id: ::std::option::Option<i64>,
    table_name: ::std::option::Option<::std::string::String>,
    num_shards: ::std::option::Option<i64>,
    shard_id: ::std::option::Option<i64>,
    config: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RetrieveTPUEmbeddingAdagradMomentumParameters {
    fn default() -> Self {
        Self {
            table_id: Some(-1i64),
            table_name: None,
            num_shards: None,
            shard_id: None,
            config: None,
            target_device_name: None,
        }
    }
}
impl RetrieveTPUEmbeddingAdagradMomentumParameters {
    /// Creates a new `RetrieveTPUEmbeddingAdagradMomentumParameters`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `table_id` attribute.
    pub fn table_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.table_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `table_name` attribute.
    pub fn table_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.table_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_shards` attribute.
    pub fn num_shards<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_shards = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shard_id` attribute.
    pub fn shard_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.shard_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute retrieve_tpuembedding_adagrad_momentum_parameters.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "RetrieveTPUEmbeddingAdagradMomentumParameters")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.table_id {
            op.set_attr_int("table_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.table_name {
            op.set_attr_string("table_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_shards {
            op.set_attr_int("num_shards", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shard_id {
            op.set_attr_int("shard_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `RetrieveTPUEmbeddingAdagradMomentumParameters::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RetrieveTPUEmbeddingAdagradMomentumParameters>
pub fn retrieve_tpuembedding_adagrad_momentum_parameters<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = RetrieveTPUEmbeddingAdagradMomentumParameters::new();
    op.call(ctx)
}

/// RetrieveTPUEmbeddingAdagradParameters
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RetrieveTPUEmbeddingAdagradParameters>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RetrieveTPUEmbeddingAdagradParameters {
    table_id: ::std::option::Option<i64>,
    table_name: ::std::option::Option<::std::string::String>,
    num_shards: ::std::option::Option<i64>,
    shard_id: ::std::option::Option<i64>,
    config: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RetrieveTPUEmbeddingAdagradParameters {
    fn default() -> Self {
        Self {
            table_id: Some(-1i64),
            table_name: None,
            num_shards: None,
            shard_id: None,
            config: None,
            target_device_name: None,
        }
    }
}
impl RetrieveTPUEmbeddingAdagradParameters {
    /// Creates a new `RetrieveTPUEmbeddingAdagradParameters`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `table_id` attribute.
    pub fn table_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.table_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `table_name` attribute.
    pub fn table_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.table_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_shards` attribute.
    pub fn num_shards<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_shards = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shard_id` attribute.
    pub fn shard_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.shard_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute retrieve_tpuembedding_adagrad_parameters.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "RetrieveTPUEmbeddingAdagradParameters")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.table_id {
            op.set_attr_int("table_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.table_name {
            op.set_attr_string("table_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_shards {
            op.set_attr_int("num_shards", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shard_id {
            op.set_attr_int("shard_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `RetrieveTPUEmbeddingAdagradParameters::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RetrieveTPUEmbeddingAdagradParameters>
pub fn retrieve_tpuembedding_adagrad_parameters<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = RetrieveTPUEmbeddingAdagradParameters::new();
    op.call(ctx)
}

/// RetrieveTPUEmbeddingCenteredRMSPropParameters
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RetrieveTPUEmbeddingCenteredRMSPropParameters>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RetrieveTPUEmbeddingCenteredRMSPropParameters {
    table_id: ::std::option::Option<i64>,
    table_name: ::std::option::Option<::std::string::String>,
    num_shards: ::std::option::Option<i64>,
    shard_id: ::std::option::Option<i64>,
    config: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RetrieveTPUEmbeddingCenteredRMSPropParameters {
    fn default() -> Self {
        Self {
            table_id: Some(-1i64),
            table_name: None,
            num_shards: None,
            shard_id: None,
            config: None,
            target_device_name: None,
        }
    }
}
impl RetrieveTPUEmbeddingCenteredRMSPropParameters {
    /// Creates a new `RetrieveTPUEmbeddingCenteredRMSPropParameters`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `table_id` attribute.
    pub fn table_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.table_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `table_name` attribute.
    pub fn table_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.table_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_shards` attribute.
    pub fn num_shards<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_shards = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shard_id` attribute.
    pub fn shard_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.shard_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute retrieve_tpuembedding_centered_rmsprop_parameters.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 4]> {
        // Define Op
        let mut op = super::Op::new(ctx, "RetrieveTPUEmbeddingCenteredRMSPropParameters")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.table_id {
            op.set_attr_int("table_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.table_name {
            op.set_attr_string("table_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_shards {
            op.set_attr_int("num_shards", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shard_id {
            op.set_attr_int("shard_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<4>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `RetrieveTPUEmbeddingCenteredRMSPropParameters::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RetrieveTPUEmbeddingCenteredRMSPropParameters>
pub fn retrieve_tpuembedding_centered_rmsprop_parameters<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 4]> {
    let op = RetrieveTPUEmbeddingCenteredRMSPropParameters::new();
    op.call(ctx)
}

/// RetrieveTPUEmbeddingFTRLParameters
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RetrieveTPUEmbeddingFTRLParameters>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RetrieveTPUEmbeddingFTRLParameters {
    table_id: ::std::option::Option<i64>,
    table_name: ::std::option::Option<::std::string::String>,
    num_shards: ::std::option::Option<i64>,
    shard_id: ::std::option::Option<i64>,
    config: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RetrieveTPUEmbeddingFTRLParameters {
    fn default() -> Self {
        Self {
            table_id: Some(-1i64),
            table_name: None,
            num_shards: None,
            shard_id: None,
            config: None,
            target_device_name: None,
        }
    }
}
impl RetrieveTPUEmbeddingFTRLParameters {
    /// Creates a new `RetrieveTPUEmbeddingFTRLParameters`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `table_id` attribute.
    pub fn table_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.table_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `table_name` attribute.
    pub fn table_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.table_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_shards` attribute.
    pub fn num_shards<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_shards = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shard_id` attribute.
    pub fn shard_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.shard_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute retrieve_tpuembedding_ftrlparameters.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "RetrieveTPUEmbeddingFTRLParameters")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.table_id {
            op.set_attr_int("table_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.table_name {
            op.set_attr_string("table_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_shards {
            op.set_attr_int("num_shards", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shard_id {
            op.set_attr_int("shard_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `RetrieveTPUEmbeddingFTRLParameters::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RetrieveTPUEmbeddingFTRLParameters>
pub fn retrieve_tpuembedding_ftrlparameters<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = RetrieveTPUEmbeddingFTRLParameters::new();
    op.call(ctx)
}

/// RetrieveTPUEmbeddingFrequencyEstimatorParameters
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RetrieveTPUEmbeddingFrequencyEstimatorParameters>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RetrieveTPUEmbeddingFrequencyEstimatorParameters {
    table_id: ::std::option::Option<i64>,
    table_name: ::std::option::Option<::std::string::String>,
    num_shards: ::std::option::Option<i64>,
    shard_id: ::std::option::Option<i64>,
    config: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RetrieveTPUEmbeddingFrequencyEstimatorParameters {
    fn default() -> Self {
        Self {
            table_id: Some(-1i64),
            table_name: None,
            num_shards: None,
            shard_id: None,
            config: None,
            target_device_name: None,
        }
    }
}
impl RetrieveTPUEmbeddingFrequencyEstimatorParameters {
    /// Creates a new `RetrieveTPUEmbeddingFrequencyEstimatorParameters`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `table_id` attribute.
    pub fn table_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.table_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `table_name` attribute.
    pub fn table_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.table_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_shards` attribute.
    pub fn num_shards<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_shards = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shard_id` attribute.
    pub fn shard_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.shard_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute retrieve_tpuembedding_frequency_estimator_parameters.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "RetrieveTPUEmbeddingFrequencyEstimatorParameters")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.table_id {
            op.set_attr_int("table_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.table_name {
            op.set_attr_string("table_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_shards {
            op.set_attr_int("num_shards", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shard_id {
            op.set_attr_int("shard_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `RetrieveTPUEmbeddingFrequencyEstimatorParameters::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RetrieveTPUEmbeddingFrequencyEstimatorParameters>
pub fn retrieve_tpuembedding_frequency_estimator_parameters<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = RetrieveTPUEmbeddingFrequencyEstimatorParameters::new();
    op.call(ctx)
}

/// RetrieveTPUEmbeddingMDLAdagradLightParameters
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RetrieveTPUEmbeddingMDLAdagradLightParameters>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RetrieveTPUEmbeddingMDLAdagradLightParameters {
    table_id: ::std::option::Option<i64>,
    table_name: ::std::option::Option<::std::string::String>,
    num_shards: ::std::option::Option<i64>,
    shard_id: ::std::option::Option<i64>,
    config: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RetrieveTPUEmbeddingMDLAdagradLightParameters {
    fn default() -> Self {
        Self {
            table_id: Some(-1i64),
            table_name: None,
            num_shards: None,
            shard_id: None,
            config: None,
            target_device_name: None,
        }
    }
}
impl RetrieveTPUEmbeddingMDLAdagradLightParameters {
    /// Creates a new `RetrieveTPUEmbeddingMDLAdagradLightParameters`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `table_id` attribute.
    pub fn table_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.table_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `table_name` attribute.
    pub fn table_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.table_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_shards` attribute.
    pub fn num_shards<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_shards = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shard_id` attribute.
    pub fn shard_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.shard_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute retrieve_tpuembedding_mdladagrad_light_parameters.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 4]> {
        // Define Op
        let mut op = super::Op::new(ctx, "RetrieveTPUEmbeddingMDLAdagradLightParameters")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.table_id {
            op.set_attr_int("table_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.table_name {
            op.set_attr_string("table_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_shards {
            op.set_attr_int("num_shards", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shard_id {
            op.set_attr_int("shard_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<4>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `RetrieveTPUEmbeddingMDLAdagradLightParameters::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RetrieveTPUEmbeddingMDLAdagradLightParameters>
pub fn retrieve_tpuembedding_mdladagrad_light_parameters<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 4]> {
    let op = RetrieveTPUEmbeddingMDLAdagradLightParameters::new();
    op.call(ctx)
}

/// RetrieveTPUEmbeddingMomentumParameters
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RetrieveTPUEmbeddingMomentumParameters>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RetrieveTPUEmbeddingMomentumParameters {
    table_id: ::std::option::Option<i64>,
    table_name: ::std::option::Option<::std::string::String>,
    num_shards: ::std::option::Option<i64>,
    shard_id: ::std::option::Option<i64>,
    config: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RetrieveTPUEmbeddingMomentumParameters {
    fn default() -> Self {
        Self {
            table_id: Some(-1i64),
            table_name: None,
            num_shards: None,
            shard_id: None,
            config: None,
            target_device_name: None,
        }
    }
}
impl RetrieveTPUEmbeddingMomentumParameters {
    /// Creates a new `RetrieveTPUEmbeddingMomentumParameters`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `table_id` attribute.
    pub fn table_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.table_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `table_name` attribute.
    pub fn table_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.table_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_shards` attribute.
    pub fn num_shards<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_shards = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shard_id` attribute.
    pub fn shard_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.shard_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute retrieve_tpuembedding_momentum_parameters.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "RetrieveTPUEmbeddingMomentumParameters")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.table_id {
            op.set_attr_int("table_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.table_name {
            op.set_attr_string("table_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_shards {
            op.set_attr_int("num_shards", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shard_id {
            op.set_attr_int("shard_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `RetrieveTPUEmbeddingMomentumParameters::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RetrieveTPUEmbeddingMomentumParameters>
pub fn retrieve_tpuembedding_momentum_parameters<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = RetrieveTPUEmbeddingMomentumParameters::new();
    op.call(ctx)
}

/// RetrieveTPUEmbeddingProximalAdagradParameters
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RetrieveTPUEmbeddingProximalAdagradParameters>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RetrieveTPUEmbeddingProximalAdagradParameters {
    table_id: ::std::option::Option<i64>,
    table_name: ::std::option::Option<::std::string::String>,
    num_shards: ::std::option::Option<i64>,
    shard_id: ::std::option::Option<i64>,
    config: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RetrieveTPUEmbeddingProximalAdagradParameters {
    fn default() -> Self {
        Self {
            table_id: Some(-1i64),
            table_name: None,
            num_shards: None,
            shard_id: None,
            config: None,
            target_device_name: None,
        }
    }
}
impl RetrieveTPUEmbeddingProximalAdagradParameters {
    /// Creates a new `RetrieveTPUEmbeddingProximalAdagradParameters`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `table_id` attribute.
    pub fn table_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.table_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `table_name` attribute.
    pub fn table_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.table_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_shards` attribute.
    pub fn num_shards<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_shards = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shard_id` attribute.
    pub fn shard_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.shard_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute retrieve_tpuembedding_proximal_adagrad_parameters.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "RetrieveTPUEmbeddingProximalAdagradParameters")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.table_id {
            op.set_attr_int("table_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.table_name {
            op.set_attr_string("table_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_shards {
            op.set_attr_int("num_shards", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shard_id {
            op.set_attr_int("shard_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `RetrieveTPUEmbeddingProximalAdagradParameters::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RetrieveTPUEmbeddingProximalAdagradParameters>
pub fn retrieve_tpuembedding_proximal_adagrad_parameters<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = RetrieveTPUEmbeddingProximalAdagradParameters::new();
    op.call(ctx)
}

/// RetrieveTPUEmbeddingProximalYogiParameters
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RetrieveTPUEmbeddingProximalYogiParameters>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RetrieveTPUEmbeddingProximalYogiParameters {
    table_id: ::std::option::Option<i64>,
    table_name: ::std::option::Option<::std::string::String>,
    num_shards: ::std::option::Option<i64>,
    shard_id: ::std::option::Option<i64>,
    config: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RetrieveTPUEmbeddingProximalYogiParameters {
    fn default() -> Self {
        Self {
            table_id: Some(-1i64),
            table_name: None,
            num_shards: None,
            shard_id: None,
            config: None,
            target_device_name: None,
        }
    }
}
impl RetrieveTPUEmbeddingProximalYogiParameters {
    /// Creates a new `RetrieveTPUEmbeddingProximalYogiParameters`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `table_id` attribute.
    pub fn table_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.table_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `table_name` attribute.
    pub fn table_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.table_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_shards` attribute.
    pub fn num_shards<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_shards = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shard_id` attribute.
    pub fn shard_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.shard_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute retrieve_tpuembedding_proximal_yogi_parameters.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "RetrieveTPUEmbeddingProximalYogiParameters")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.table_id {
            op.set_attr_int("table_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.table_name {
            op.set_attr_string("table_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_shards {
            op.set_attr_int("num_shards", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shard_id {
            op.set_attr_int("shard_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `RetrieveTPUEmbeddingProximalYogiParameters::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RetrieveTPUEmbeddingProximalYogiParameters>
pub fn retrieve_tpuembedding_proximal_yogi_parameters<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = RetrieveTPUEmbeddingProximalYogiParameters::new();
    op.call(ctx)
}

/// RetrieveTPUEmbeddingRMSPropParameters
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RetrieveTPUEmbeddingRMSPropParameters>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RetrieveTPUEmbeddingRMSPropParameters {
    table_id: ::std::option::Option<i64>,
    table_name: ::std::option::Option<::std::string::String>,
    num_shards: ::std::option::Option<i64>,
    shard_id: ::std::option::Option<i64>,
    config: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RetrieveTPUEmbeddingRMSPropParameters {
    fn default() -> Self {
        Self {
            table_id: Some(-1i64),
            table_name: None,
            num_shards: None,
            shard_id: None,
            config: None,
            target_device_name: None,
        }
    }
}
impl RetrieveTPUEmbeddingRMSPropParameters {
    /// Creates a new `RetrieveTPUEmbeddingRMSPropParameters`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `table_id` attribute.
    pub fn table_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.table_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `table_name` attribute.
    pub fn table_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.table_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_shards` attribute.
    pub fn num_shards<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_shards = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shard_id` attribute.
    pub fn shard_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.shard_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute retrieve_tpuembedding_rmsprop_parameters.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "RetrieveTPUEmbeddingRMSPropParameters")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.table_id {
            op.set_attr_int("table_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.table_name {
            op.set_attr_string("table_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_shards {
            op.set_attr_int("num_shards", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shard_id {
            op.set_attr_int("shard_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `RetrieveTPUEmbeddingRMSPropParameters::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RetrieveTPUEmbeddingRMSPropParameters>
pub fn retrieve_tpuembedding_rmsprop_parameters<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = RetrieveTPUEmbeddingRMSPropParameters::new();
    op.call(ctx)
}

/// RetrieveTPUEmbeddingStochasticGradientDescentParameters
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RetrieveTPUEmbeddingStochasticGradientDescentParameters>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RetrieveTPUEmbeddingStochasticGradientDescentParameters {
    table_id: ::std::option::Option<i64>,
    table_name: ::std::option::Option<::std::string::String>,
    num_shards: ::std::option::Option<i64>,
    shard_id: ::std::option::Option<i64>,
    config: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RetrieveTPUEmbeddingStochasticGradientDescentParameters {
    fn default() -> Self {
        Self {
            table_id: Some(-1i64),
            table_name: None,
            num_shards: None,
            shard_id: None,
            config: None,
            target_device_name: None,
        }
    }
}
impl RetrieveTPUEmbeddingStochasticGradientDescentParameters {
    /// Creates a new `RetrieveTPUEmbeddingStochasticGradientDescentParameters`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `table_id` attribute.
    pub fn table_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.table_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `table_name` attribute.
    pub fn table_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.table_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_shards` attribute.
    pub fn num_shards<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_shards = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shard_id` attribute.
    pub fn shard_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.shard_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute retrieve_tpuembedding_stochastic_gradient_descent_parameters.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(
            ctx,
            "RetrieveTPUEmbeddingStochasticGradientDescentParameters",
        )?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.table_id {
            op.set_attr_int("table_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.table_name {
            op.set_attr_string("table_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_shards {
            op.set_attr_int("num_shards", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shard_id {
            op.set_attr_int("shard_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RetrieveTPUEmbeddingStochasticGradientDescentParameters::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RetrieveTPUEmbeddingStochasticGradientDescentParameters>
pub fn retrieve_tpuembedding_stochastic_gradient_descent_parameters<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RetrieveTPUEmbeddingStochasticGradientDescentParameters::new();
    op.call(ctx)
}

/// Reverse
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Reverse>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Reverse {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Reverse {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Reverse {
    /// Creates a new `Reverse`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute reverse.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        tensor: &T0,
        dims: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Reverse")?;

        // Required input arguments
        op.add_input(&tensor.to_handle(ctx)?)?;
        op.add_input(&dims.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Reverse::new().call(&ctx, &tensor, &dims)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Reverse>
pub fn reverse<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    tensor: &T0,
    dims: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Reverse::new();
    op.call(ctx, tensor, dims)
}

/// ReverseSequence
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReverseSequence>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ReverseSequence {
    seq_dim: ::std::option::Option<i64>,
    batch_dim: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ReverseSequence {
    fn default() -> Self {
        Self {
            seq_dim: None,
            batch_dim: Some(0i64),
            target_device_name: None,
        }
    }
}
impl ReverseSequence {
    /// Creates a new `ReverseSequence`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `seq_dim` attribute.
    pub fn seq_dim<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seq_dim = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `batch_dim` attribute.
    pub fn batch_dim<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.batch_dim = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute reverse_sequence.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        seq_lengths: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ReverseSequence")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&seq_lengths.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.seq_dim {
            op.set_attr_int("seq_dim", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.batch_dim {
            op.set_attr_int("batch_dim", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ReverseSequence::new().call(&ctx, &input, &seq_lengths)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReverseSequence>
pub fn reverse_sequence<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    seq_lengths: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ReverseSequence::new();
    op.call(ctx, input, seq_lengths)
}

/// ReverseV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReverseV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ReverseV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ReverseV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ReverseV2 {
    /// Creates a new `ReverseV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute reverse_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        tensor: &T0,
        axis: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ReverseV2")?;

        // Required input arguments
        op.add_input(&tensor.to_handle(ctx)?)?;
        op.add_input(&axis.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ReverseV2::new().call(&ctx, &tensor, &axis)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ReverseV2>
pub fn reverse_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    tensor: &T0,
    axis: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ReverseV2::new();
    op.call(ctx, tensor, axis)
}

/// RewriteDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RewriteDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RewriteDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RewriteDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl RewriteDataset {
    /// Creates a new `RewriteDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute rewrite_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        rewrite_name: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RewriteDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&rewrite_name.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RewriteDataset::new().call(&ctx, &input_dataset, &rewrite_name)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RewriteDataset>
pub fn rewrite_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    rewrite_name: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RewriteDataset::new();
    op.call(ctx, input_dataset, rewrite_name)
}

/// RightShift
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RightShift>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RightShift {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RightShift {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RightShift {
    /// Creates a new `RightShift`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute right_shift.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RightShift")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RightShift::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RightShift>
pub fn right_shift<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RightShift::new();
    op.call(ctx, x, y)
}

/// Rint
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Rint>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Rint {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Rint {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Rint {
    /// Creates a new `Rint`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute rint.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Rint")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Rint::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Rint>
pub fn rint<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Rint::new();
    op.call(ctx, x)
}

/// RiscAbs
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscAbs>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscAbs {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscAbs {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RiscAbs {
    /// Creates a new `RiscAbs`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_abs.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscAbs")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscAbs::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscAbs>
pub fn risc_abs<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscAbs::new();
    op.call(ctx, x)
}

/// RiscAdd
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscAdd>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscAdd {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscAdd {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RiscAdd {
    /// Creates a new `RiscAdd`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_add.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscAdd")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscAdd::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscAdd>
pub fn risc_add<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscAdd::new();
    op.call(ctx, x, y)
}

/// RiscBinaryArithmetic
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscBinaryArithmetic>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscBinaryArithmetic {
    op_type: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscBinaryArithmetic {
    fn default() -> Self {
        Self {
            op_type: None,
            target_device_name: None,
        }
    }
}
impl RiscBinaryArithmetic {
    /// Creates a new `RiscBinaryArithmetic`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `op_type` attribute.
    pub fn op_type<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.op_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_binary_arithmetic.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscBinaryArithmetic")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.op_type {
            op.set_attr_string("op_type", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscBinaryArithmetic::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscBinaryArithmetic>
pub fn risc_binary_arithmetic<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscBinaryArithmetic::new();
    op.call(ctx, x, y)
}

/// RiscBinaryComparison
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscBinaryComparison>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscBinaryComparison {
    op_type: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscBinaryComparison {
    fn default() -> Self {
        Self {
            op_type: None,
            target_device_name: None,
        }
    }
}
impl RiscBinaryComparison {
    /// Creates a new `RiscBinaryComparison`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `op_type` attribute.
    pub fn op_type<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.op_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_binary_comparison.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscBinaryComparison")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.op_type {
            op.set_attr_string("op_type", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscBinaryComparison::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscBinaryComparison>
pub fn risc_binary_comparison<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscBinaryComparison::new();
    op.call(ctx, x, y)
}

/// RiscBitcast
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscBitcast>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscBitcast {
    DstT: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscBitcast {
    fn default() -> Self {
        Self {
            DstT: None,
            target_device_name: None,
        }
    }
}
impl RiscBitcast {
    /// Creates a new `RiscBitcast`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `DstT` attribute.
    pub fn DstT<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.DstT = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_bitcast.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscBitcast")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.DstT {
            op.set_attr_type("DstT", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscBitcast::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscBitcast>
pub fn risc_bitcast<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscBitcast::new();
    op.call(ctx, x)
}

/// RiscBroadcast
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscBroadcast>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscBroadcast {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscBroadcast {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RiscBroadcast {
    /// Creates a new `RiscBroadcast`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_broadcast.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        shape: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscBroadcast")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&shape.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscBroadcast::new().call(&ctx, &input, &shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscBroadcast>
pub fn risc_broadcast<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    shape: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscBroadcast::new();
    op.call(ctx, input, shape)
}

/// RiscCast
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscCast>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscCast {
    DstT: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscCast {
    fn default() -> Self {
        Self {
            DstT: None,
            target_device_name: None,
        }
    }
}
impl RiscCast {
    /// Creates a new `RiscCast`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `DstT` attribute.
    pub fn DstT<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.DstT = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_cast.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscCast")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.DstT {
            op.set_attr_type("DstT", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscCast::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscCast>
pub fn risc_cast<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscCast::new();
    op.call(ctx, x)
}

/// RiscCeil
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscCeil>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscCeil {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscCeil {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RiscCeil {
    /// Creates a new `RiscCeil`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_ceil.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscCeil")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscCeil::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscCeil>
pub fn risc_ceil<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscCeil::new();
    op.call(ctx, x)
}

/// RiscCholesky
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscCholesky>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscCholesky {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscCholesky {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RiscCholesky {
    /// Creates a new `RiscCholesky`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_cholesky.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscCholesky")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscCholesky::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscCholesky>
pub fn risc_cholesky<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscCholesky::new();
    op.call(ctx, input)
}

/// RiscConcat
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscConcat>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscConcat {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscConcat {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RiscConcat {
    /// Creates a new `RiscConcat`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_concat.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        values: &[&T0],
        axis: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscConcat")?;

        // Required input arguments
        let mut values_list = Vec::new();

        for t in values {
            values_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&values_list)?;
        op.add_input(&axis.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscConcat::new().call(&ctx, &values, &axis)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscConcat>
pub fn risc_concat<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    values: &[&T0],
    axis: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscConcat::new();
    op.call(ctx, values, axis)
}

/// RiscCondition
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscCondition>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscCondition {
    func_true: ::std::option::Option<::std::string::String>,
    func_false: ::std::option::Option<::std::string::String>,
    DstT: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscCondition {
    fn default() -> Self {
        Self {
            func_true: None,
            func_false: None,
            DstT: None,
            target_device_name: None,
        }
    }
}
impl RiscCondition {
    /// Creates a new `RiscCondition`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `func_true` attribute.
    pub fn func_true<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.func_true = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `func_false` attribute.
    pub fn func_false<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.func_false = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `DstT` attribute.
    pub fn DstT<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.DstT = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_condition.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        pred: &T0,
        input_true: &T1,
        input_false: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscCondition")?;

        // Required input arguments
        op.add_input(&pred.to_handle(ctx)?)?;
        op.add_input(&input_true.to_handle(ctx)?)?;
        op.add_input(&input_false.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.func_true {
            op.set_attr_string("func_true", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.func_false {
            op.set_attr_string("func_false", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.DstT {
            op.set_attr_type("DstT", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscCondition::new().call(&ctx, &pred, &input_true, &input_false)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscCondition>
pub fn risc_condition<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    pred: &T0,
    input_true: &T1,
    input_false: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscCondition::new();
    op.call(ctx, pred, input_true, input_false)
}

/// RiscConv
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscConv>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscConv {
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    data_format: ::std::option::Option<::std::string::String>,
    dilations: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscConv {
    fn default() -> Self {
        Self {
            strides: None,
            data_format: Some(::std::string::String::from("NHWC")),
            dilations: Some(vec![1, 1, 1, 1]),
            target_device_name: None,
        }
    }
}
impl RiscConv {
    /// Creates a new `RiscConv`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `data_format` attribute.
    pub fn data_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.data_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dilations` attribute.
    pub fn dilations<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dilations = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_conv.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        filter: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscConv")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&filter.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.data_format {
            op.set_attr_string("data_format", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dilations {
            op.set_attr_int_list("dilations", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscConv::new().call(&ctx, &input, &filter)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscConv>
pub fn risc_conv<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    filter: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscConv::new();
    op.call(ctx, input, filter)
}

/// RiscCos
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscCos>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscCos {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscCos {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RiscCos {
    /// Creates a new `RiscCos`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_cos.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscCos")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscCos::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscCos>
pub fn risc_cos<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscCos::new();
    op.call(ctx, x)
}

/// RiscDiv
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscDiv>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscDiv {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscDiv {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RiscDiv {
    /// Creates a new `RiscDiv`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_div.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscDiv")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscDiv::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscDiv>
pub fn risc_div<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscDiv::new();
    op.call(ctx, x, y)
}

/// RiscDot
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscDot>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscDot {
    transpose_a: ::std::option::Option<bool>,
    transpose_b: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscDot {
    fn default() -> Self {
        Self {
            transpose_a: Some(false),
            transpose_b: Some(false),
            target_device_name: None,
        }
    }
}
impl RiscDot {
    /// Creates a new `RiscDot`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `transpose_a` attribute.
    pub fn transpose_a<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.transpose_a = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `transpose_b` attribute.
    pub fn transpose_b<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.transpose_b = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_dot.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        a: &T0,
        b: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscDot")?;

        // Required input arguments
        op.add_input(&a.to_handle(ctx)?)?;
        op.add_input(&b.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.transpose_a {
            op.set_attr_bool("transpose_a", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.transpose_b {
            op.set_attr_bool("transpose_b", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscDot::new().call(&ctx, &a, &b)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscDot>
pub fn risc_dot<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    a: &T0,
    b: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscDot::new();
    op.call(ctx, a, b)
}

/// RiscExp
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscExp>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscExp {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscExp {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RiscExp {
    /// Creates a new `RiscExp`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_exp.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscExp")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscExp::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscExp>
pub fn risc_exp<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscExp::new();
    op.call(ctx, x)
}

/// RiscFft
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscFft>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscFft {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscFft {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RiscFft {
    /// Creates a new `RiscFft`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_fft.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscFft")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscFft::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscFft>
pub fn risc_fft<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscFft::new();
    op.call(ctx, input)
}

/// RiscFloor
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscFloor>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscFloor {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscFloor {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RiscFloor {
    /// Creates a new `RiscFloor`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_floor.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscFloor")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscFloor::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscFloor>
pub fn risc_floor<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscFloor::new();
    op.call(ctx, x)
}

/// RiscGather
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscGather>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscGather {
    batch_dims: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscGather {
    fn default() -> Self {
        Self {
            batch_dims: Some(0i64),
            target_device_name: None,
        }
    }
}
impl RiscGather {
    /// Creates a new `RiscGather`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `batch_dims` attribute.
    pub fn batch_dims<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.batch_dims = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_gather.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        params: &T0,
        indices: &T1,
        axis: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscGather")?;

        // Required input arguments
        op.add_input(&params.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&axis.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.batch_dims {
            op.set_attr_int("batch_dims", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscGather::new().call(&ctx, &params, &indices, &axis)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscGather>
pub fn risc_gather<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    params: &T0,
    indices: &T1,
    axis: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscGather::new();
    op.call(ctx, params, indices, axis)
}

/// RiscImag
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscImag>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscImag {
    Tout: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscImag {
    fn default() -> Self {
        Self {
            Tout: Some(crate::DataType::Float),
            target_device_name: None,
        }
    }
}
impl RiscImag {
    /// Creates a new `RiscImag`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Tout` attribute.
    pub fn Tout<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.Tout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_imag.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscImag")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Tout {
            op.set_attr_type("Tout", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscImag::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscImag>
pub fn risc_imag<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscImag::new();
    op.call(ctx, input)
}

/// RiscIsFinite
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscIsFinite>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscIsFinite {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscIsFinite {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RiscIsFinite {
    /// Creates a new `RiscIsFinite`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_is_finite.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscIsFinite")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscIsFinite::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscIsFinite>
pub fn risc_is_finite<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscIsFinite::new();
    op.call(ctx, x)
}

/// RiscLog
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscLog>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscLog {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscLog {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RiscLog {
    /// Creates a new `RiscLog`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_log.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscLog")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscLog::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscLog>
pub fn risc_log<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscLog::new();
    op.call(ctx, x)
}

/// RiscLogicalAnd
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscLogicalAnd>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscLogicalAnd {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscLogicalAnd {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RiscLogicalAnd {
    /// Creates a new `RiscLogicalAnd`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_logical_and.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscLogicalAnd")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscLogicalAnd::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscLogicalAnd>
pub fn risc_logical_and<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscLogicalAnd::new();
    op.call(ctx, x, y)
}

/// RiscLogicalNot
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscLogicalNot>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscLogicalNot {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscLogicalNot {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RiscLogicalNot {
    /// Creates a new `RiscLogicalNot`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_logical_not.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscLogicalNot")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscLogicalNot::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscLogicalNot>
pub fn risc_logical_not<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscLogicalNot::new();
    op.call(ctx, x)
}

/// RiscLogicalOr
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscLogicalOr>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscLogicalOr {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscLogicalOr {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RiscLogicalOr {
    /// Creates a new `RiscLogicalOr`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_logical_or.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscLogicalOr")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscLogicalOr::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscLogicalOr>
pub fn risc_logical_or<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscLogicalOr::new();
    op.call(ctx, x, y)
}

/// RiscMax
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscMax>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscMax {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscMax {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RiscMax {
    /// Creates a new `RiscMax`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_max.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscMax")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscMax::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscMax>
pub fn risc_max<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscMax::new();
    op.call(ctx, x, y)
}

/// RiscMin
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscMin>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscMin {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscMin {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RiscMin {
    /// Creates a new `RiscMin`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_min.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscMin")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscMin::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscMin>
pub fn risc_min<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscMin::new();
    op.call(ctx, x, y)
}

/// RiscMul
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscMul>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscMul {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscMul {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RiscMul {
    /// Creates a new `RiscMul`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_mul.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscMul")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscMul::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscMul>
pub fn risc_mul<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscMul::new();
    op.call(ctx, x, y)
}

/// RiscNeg
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscNeg>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscNeg {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscNeg {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RiscNeg {
    /// Creates a new `RiscNeg`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_neg.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscNeg")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscNeg::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscNeg>
pub fn risc_neg<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscNeg::new();
    op.call(ctx, x)
}

/// RiscPad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscPad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscPad {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscPad {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RiscPad {
    /// Creates a new `RiscPad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_pad.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        paddings: &T1,
        constant_values: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscPad")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&paddings.to_handle(ctx)?)?;
        op.add_input(&constant_values.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscPad::new().call(&ctx, &input, &paddings, &constant_values)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscPad>
pub fn risc_pad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    paddings: &T1,
    constant_values: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscPad::new();
    op.call(ctx, input, paddings, constant_values)
}

/// RiscPool
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscPool>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscPool {
    ksize: ::std::option::Option<::std::vec::Vec<i64>>,
    strides: ::std::option::Option<::std::vec::Vec<i64>>,
    pooling_type: ::std::option::Option<::std::string::String>,
    data_format: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscPool {
    fn default() -> Self {
        Self {
            ksize: None,
            strides: None,
            pooling_type: None,
            data_format: Some(::std::string::String::from("NHWC")),
            target_device_name: None,
        }
    }
}
impl RiscPool {
    /// Creates a new `RiscPool`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `ksize` attribute.
    pub fn ksize<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.ksize = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `strides` attribute.
    pub fn strides<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.strides = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `pooling_type` attribute.
    pub fn pooling_type<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.pooling_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `data_format` attribute.
    pub fn data_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.data_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_pool.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        value: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscPool")?;

        // Required input arguments
        op.add_input(&value.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.ksize {
            op.set_attr_int_list("ksize", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.strides {
            op.set_attr_int_list("strides", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.pooling_type {
            op.set_attr_string("pooling_type", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.data_format {
            op.set_attr_string("data_format", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscPool::new().call(&ctx, &value)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscPool>
pub fn risc_pool<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    value: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscPool::new();
    op.call(ctx, value)
}

/// RiscPow
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscPow>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscPow {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscPow {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RiscPow {
    /// Creates a new `RiscPow`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_pow.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscPow")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscPow::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscPow>
pub fn risc_pow<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscPow::new();
    op.call(ctx, x, y)
}

/// RiscRandomUniform
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscRandomUniform>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscRandomUniform {
    seed: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscRandomUniform {
    fn default() -> Self {
        Self {
            seed: Some(0i64),
            target_device_name: None,
        }
    }
}
impl RiscRandomUniform {
    /// Creates a new `RiscRandomUniform`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `seed` attribute.
    pub fn seed<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_random_uniform.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        shape: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscRandomUniform")?;

        // Required input arguments
        op.add_input(&shape.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.seed {
            op.set_attr_int("seed", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscRandomUniform::new().call(&ctx, &shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscRandomUniform>
pub fn risc_random_uniform<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    shape: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscRandomUniform::new();
    op.call(ctx, shape)
}

/// RiscReal
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscReal>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscReal {
    Tout: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscReal {
    fn default() -> Self {
        Self {
            Tout: Some(crate::DataType::Float),
            target_device_name: None,
        }
    }
}
impl RiscReal {
    /// Creates a new `RiscReal`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Tout` attribute.
    pub fn Tout<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.Tout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_real.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscReal")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Tout {
            op.set_attr_type("Tout", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscReal::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscReal>
pub fn risc_real<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscReal::new();
    op.call(ctx, input)
}

/// RiscReduce
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscReduce>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscReduce {
    reduce_type: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscReduce {
    fn default() -> Self {
        Self {
            reduce_type: None,
            target_device_name: None,
        }
    }
}
impl RiscReduce {
    /// Creates a new `RiscReduce`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `reduce_type` attribute.
    pub fn reduce_type<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.reduce_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_reduce.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        tensor: &T0,
        axis: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscReduce")?;

        // Required input arguments
        op.add_input(&tensor.to_handle(ctx)?)?;
        op.add_input(&axis.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.reduce_type {
            op.set_attr_string("reduce_type", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscReduce::new().call(&ctx, &tensor, &axis)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscReduce>
pub fn risc_reduce<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    tensor: &T0,
    axis: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscReduce::new();
    op.call(ctx, tensor, axis)
}

/// RiscRem
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscRem>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscRem {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscRem {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RiscRem {
    /// Creates a new `RiscRem`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_rem.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscRem")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscRem::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscRem>
pub fn risc_rem<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscRem::new();
    op.call(ctx, x, y)
}

/// RiscReshape
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscReshape>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscReshape {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscReshape {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RiscReshape {
    /// Creates a new `RiscReshape`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_reshape.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        tensor: &T0,
        shape: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscReshape")?;

        // Required input arguments
        op.add_input(&tensor.to_handle(ctx)?)?;
        op.add_input(&shape.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscReshape::new().call(&ctx, &tensor, &shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscReshape>
pub fn risc_reshape<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    tensor: &T0,
    shape: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscReshape::new();
    op.call(ctx, tensor, shape)
}

/// RiscReverse
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscReverse>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscReverse {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscReverse {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RiscReverse {
    /// Creates a new `RiscReverse`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_reverse.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        tensor: &T0,
        axis: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscReverse")?;

        // Required input arguments
        op.add_input(&tensor.to_handle(ctx)?)?;
        op.add_input(&axis.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscReverse::new().call(&ctx, &tensor, &axis)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscReverse>
pub fn risc_reverse<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    tensor: &T0,
    axis: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscReverse::new();
    op.call(ctx, tensor, axis)
}

/// RiscScatter
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscScatter>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscScatter {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscScatter {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RiscScatter {
    /// Creates a new `RiscScatter`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_scatter.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        indices: &T0,
        updates: &T1,
        shape: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscScatter")?;

        // Required input arguments
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&updates.to_handle(ctx)?)?;
        op.add_input(&shape.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscScatter::new().call(&ctx, &indices, &updates, &shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscScatter>
pub fn risc_scatter<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    indices: &T0,
    updates: &T1,
    shape: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscScatter::new();
    op.call(ctx, indices, updates, shape)
}

/// RiscShape
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscShape>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscShape {
    out_type: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscShape {
    fn default() -> Self {
        Self {
            out_type: Some(crate::DataType::Int32),
            target_device_name: None,
        }
    }
}
impl RiscShape {
    /// Creates a new `RiscShape`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_type` attribute.
    pub fn out_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_shape.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscShape")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_type {
            op.set_attr_type("out_type", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscShape::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscShape>
pub fn risc_shape<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscShape::new();
    op.call(ctx, input)
}

/// RiscSign
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscSign>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscSign {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscSign {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RiscSign {
    /// Creates a new `RiscSign`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_sign.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscSign")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscSign::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscSign>
pub fn risc_sign<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscSign::new();
    op.call(ctx, x)
}

/// RiscSlice
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscSlice>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscSlice {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscSlice {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RiscSlice {
    /// Creates a new `RiscSlice`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_slice.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        begin: &T1,
        size: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscSlice")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&begin.to_handle(ctx)?)?;
        op.add_input(&size.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscSlice::new().call(&ctx, &input, &begin, &size)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscSlice>
pub fn risc_slice<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    begin: &T1,
    size: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscSlice::new();
    op.call(ctx, input, begin, size)
}

/// RiscSort
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscSort>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscSort {
    direction: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscSort {
    fn default() -> Self {
        Self {
            direction: None,
            target_device_name: None,
        }
    }
}
impl RiscSort {
    /// Creates a new `RiscSort`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `direction` attribute.
    pub fn direction<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.direction = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_sort.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        axis: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscSort")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&axis.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.direction {
            op.set_attr_string("direction", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscSort::new().call(&ctx, &input, &axis)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscSort>
pub fn risc_sort<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    axis: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscSort::new();
    op.call(ctx, input, axis)
}

/// RiscSqueeze
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscSqueeze>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscSqueeze {
    squeeze_dims: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscSqueeze {
    fn default() -> Self {
        Self {
            squeeze_dims: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl RiscSqueeze {
    /// Creates a new `RiscSqueeze`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `squeeze_dims` attribute.
    pub fn squeeze_dims<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.squeeze_dims = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_squeeze.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscSqueeze")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.squeeze_dims {
            op.set_attr_int_list("squeeze_dims", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscSqueeze::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscSqueeze>
pub fn risc_squeeze<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscSqueeze::new();
    op.call(ctx, input)
}

/// RiscSub
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscSub>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscSub {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscSub {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RiscSub {
    /// Creates a new `RiscSub`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_sub.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscSub")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscSub::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscSub>
pub fn risc_sub<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscSub::new();
    op.call(ctx, x, y)
}

/// RiscTranspose
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscTranspose>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscTranspose {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscTranspose {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RiscTranspose {
    /// Creates a new `RiscTranspose`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_transpose.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        perm: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscTranspose")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&perm.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscTranspose::new().call(&ctx, &x, &perm)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscTranspose>
pub fn risc_transpose<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    perm: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscTranspose::new();
    op.call(ctx, x, perm)
}

/// RiscTriangularSolve
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscTriangularSolve>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscTriangularSolve {
    lower: ::std::option::Option<bool>,
    adjoint: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscTriangularSolve {
    fn default() -> Self {
        Self {
            lower: Some(true),
            adjoint: Some(false),
            target_device_name: None,
        }
    }
}
impl RiscTriangularSolve {
    /// Creates a new `RiscTriangularSolve`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `lower` attribute.
    pub fn lower<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.lower = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `adjoint` attribute.
    pub fn adjoint<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.adjoint = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_triangular_solve.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        matrix: &T0,
        rhs: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscTriangularSolve")?;

        // Required input arguments
        op.add_input(&matrix.to_handle(ctx)?)?;
        op.add_input(&rhs.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.lower {
            op.set_attr_bool("lower", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.adjoint {
            op.set_attr_bool("adjoint", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscTriangularSolve::new().call(&ctx, &matrix, &rhs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscTriangularSolve>
pub fn risc_triangular_solve<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    matrix: &T0,
    rhs: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscTriangularSolve::new();
    op.call(ctx, matrix, rhs)
}

/// RiscUnary
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscUnary>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscUnary {
    op_type: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscUnary {
    fn default() -> Self {
        Self {
            op_type: None,
            target_device_name: None,
        }
    }
}
impl RiscUnary {
    /// Creates a new `RiscUnary`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `op_type` attribute.
    pub fn op_type<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.op_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_unary.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscUnary")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.op_type {
            op.set_attr_string("op_type", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscUnary::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscUnary>
pub fn risc_unary<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscUnary::new();
    op.call(ctx, x)
}

/// RiscWhile
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscWhile>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RiscWhile {
    cond: ::std::option::Option<::std::string::String>,
    body: ::std::option::Option<::std::string::String>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    parallel_iterations: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RiscWhile {
    fn default() -> Self {
        Self {
            cond: None,
            body: None,
            output_shapes: Some(vec![]),
            parallel_iterations: Some(10i64),
            target_device_name: None,
        }
    }
}
impl RiscWhile {
    /// Creates a new `RiscWhile`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `cond` attribute.
    pub fn cond<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.cond = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `body` attribute.
    pub fn body<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.body = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `parallel_iterations` attribute.
    pub fn parallel_iterations<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.parallel_iterations = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute risc_while.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RiscWhile")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.cond {
            op.set_attr_string("cond", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.body {
            op.set_attr_string("body", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.parallel_iterations {
            op.set_attr_int("parallel_iterations", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RiscWhile::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RiscWhile>
pub fn risc_while<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RiscWhile::new();
    op.call(ctx, input)
}

/// RngReadAndSkip
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RngReadAndSkip>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RngReadAndSkip {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RngReadAndSkip {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RngReadAndSkip {
    /// Creates a new `RngReadAndSkip`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute rng_read_and_skip.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        resource: &T0,
        alg: &T1,
        delta: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RngReadAndSkip")?;

        // Required input arguments
        op.add_input(&resource.to_handle(ctx)?)?;
        op.add_input(&alg.to_handle(ctx)?)?;
        op.add_input(&delta.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RngReadAndSkip::new().call(&ctx, &resource, &alg, &delta)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RngReadAndSkip>
pub fn rng_read_and_skip<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    resource: &T0,
    alg: &T1,
    delta: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RngReadAndSkip::new();
    op.call(ctx, resource, alg, delta)
}

/// RngSkip
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RngSkip>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RngSkip {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RngSkip {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RngSkip {
    /// Creates a new `RngSkip`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute rng_skip.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        resource: &T0,
        algorithm: &T1,
        delta: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "RngSkip")?;

        // Required input arguments
        op.add_input(&resource.to_handle(ctx)?)?;
        op.add_input(&algorithm.to_handle(ctx)?)?;
        op.add_input(&delta.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `RngSkip::new().call(&ctx, &resource, &algorithm, &delta)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RngSkip>
pub fn rng_skip<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    resource: &T0,
    algorithm: &T1,
    delta: &T2,
) -> crate::Result<()> {
    let op = RngSkip::new();
    op.call(ctx, resource, algorithm, delta)
}

/// Roll
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Roll>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Roll {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Roll {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Roll {
    /// Creates a new `Roll`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute roll.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        shift: &T1,
        axis: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Roll")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&shift.to_handle(ctx)?)?;
        op.add_input(&axis.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Roll::new().call(&ctx, &input, &shift, &axis)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Roll>
pub fn roll<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    shift: &T1,
    axis: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Roll::new();
    op.call(ctx, input, shift, axis)
}

/// Round
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Round>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Round {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Round {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Round {
    /// Creates a new `Round`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute round.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Round")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Round::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Round>
pub fn round<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Round::new();
    op.call(ctx, x)
}

/// Rsqrt
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Rsqrt>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Rsqrt {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Rsqrt {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Rsqrt {
    /// Creates a new `Rsqrt`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute rsqrt.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Rsqrt")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Rsqrt::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Rsqrt>
pub fn rsqrt<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Rsqrt::new();
    op.call(ctx, x)
}

/// RsqrtGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RsqrtGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct RsqrtGrad {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for RsqrtGrad {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl RsqrtGrad {
    /// Creates a new `RsqrtGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute rsqrt_grad.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        y: &T0,
        dy: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "RsqrtGrad")?;

        // Required input arguments
        op.add_input(&y.to_handle(ctx)?)?;
        op.add_input(&dy.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `RsqrtGrad::new().call(&ctx, &y, &dy)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/RsqrtGrad>
pub fn rsqrt_grad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    y: &T0,
    dy: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = RsqrtGrad::new();
    op.call(ctx, y, dy)
}

/// SampleDistortedBoundingBox
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SampleDistortedBoundingBox>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SampleDistortedBoundingBox {
    seed: ::std::option::Option<i64>,
    seed2: ::std::option::Option<i64>,
    min_object_covered: ::std::option::Option<f32>,
    aspect_ratio_range: ::std::option::Option<::std::vec::Vec<f32>>,
    area_range: ::std::option::Option<::std::vec::Vec<f32>>,
    max_attempts: ::std::option::Option<i64>,
    use_image_if_no_bounding_boxes: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SampleDistortedBoundingBox {
    fn default() -> Self {
        Self {
            seed: Some(0i64),
            seed2: Some(0i64),
            min_object_covered: Some(0.1f32),
            aspect_ratio_range: Some(vec![0.75, 1.33]),
            area_range: Some(vec![0.05, 1.0]),
            max_attempts: Some(100i64),
            use_image_if_no_bounding_boxes: Some(false),
            target_device_name: None,
        }
    }
}
impl SampleDistortedBoundingBox {
    /// Creates a new `SampleDistortedBoundingBox`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `seed` attribute.
    pub fn seed<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed2` attribute.
    pub fn seed2<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `min_object_covered` attribute.
    pub fn min_object_covered<ArgType: ::std::convert::Into<f32>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.min_object_covered = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `aspect_ratio_range` attribute.
    pub fn aspect_ratio_range<ArgType: ::std::convert::Into<::std::vec::Vec<f32>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.aspect_ratio_range = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `area_range` attribute.
    pub fn area_range<ArgType: ::std::convert::Into<::std::vec::Vec<f32>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.area_range = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `max_attempts` attribute.
    pub fn max_attempts<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.max_attempts = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_image_if_no_bounding_boxes` attribute.
    pub fn use_image_if_no_bounding_boxes<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.use_image_if_no_bounding_boxes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sample_distorted_bounding_box.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        image_size: &T0,
        bounding_boxes: &T1,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "SampleDistortedBoundingBox")?;

        // Required input arguments
        op.add_input(&image_size.to_handle(ctx)?)?;
        op.add_input(&bounding_boxes.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.seed {
            op.set_attr_int("seed", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed2 {
            op.set_attr_int("seed2", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.min_object_covered {
            op.set_attr_float("min_object_covered", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.aspect_ratio_range {
            op.set_attr_float_list("aspect_ratio_range", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.area_range {
            op.set_attr_float_list("area_range", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.max_attempts {
            op.set_attr_int("max_attempts", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_image_if_no_bounding_boxes {
            op.set_attr_bool("use_image_if_no_bounding_boxes", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `SampleDistortedBoundingBox::new().call(&ctx, &image_size, &bounding_boxes)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SampleDistortedBoundingBox>
pub fn sample_distorted_bounding_box<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    image_size: &T0,
    bounding_boxes: &T1,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = SampleDistortedBoundingBox::new();
    op.call(ctx, image_size, bounding_boxes)
}

/// SampleDistortedBoundingBoxV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SampleDistortedBoundingBoxV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SampleDistortedBoundingBoxV2 {
    seed: ::std::option::Option<i64>,
    seed2: ::std::option::Option<i64>,
    aspect_ratio_range: ::std::option::Option<::std::vec::Vec<f32>>,
    area_range: ::std::option::Option<::std::vec::Vec<f32>>,
    max_attempts: ::std::option::Option<i64>,
    use_image_if_no_bounding_boxes: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SampleDistortedBoundingBoxV2 {
    fn default() -> Self {
        Self {
            seed: Some(0i64),
            seed2: Some(0i64),
            aspect_ratio_range: Some(vec![0.75, 1.33]),
            area_range: Some(vec![0.05, 1.0]),
            max_attempts: Some(100i64),
            use_image_if_no_bounding_boxes: Some(false),
            target_device_name: None,
        }
    }
}
impl SampleDistortedBoundingBoxV2 {
    /// Creates a new `SampleDistortedBoundingBoxV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `seed` attribute.
    pub fn seed<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed2` attribute.
    pub fn seed2<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `aspect_ratio_range` attribute.
    pub fn aspect_ratio_range<ArgType: ::std::convert::Into<::std::vec::Vec<f32>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.aspect_ratio_range = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `area_range` attribute.
    pub fn area_range<ArgType: ::std::convert::Into<::std::vec::Vec<f32>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.area_range = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `max_attempts` attribute.
    pub fn max_attempts<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.max_attempts = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_image_if_no_bounding_boxes` attribute.
    pub fn use_image_if_no_bounding_boxes<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.use_image_if_no_bounding_boxes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sample_distorted_bounding_box_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        image_size: &T0,
        bounding_boxes: &T1,
        min_object_covered: &T2,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "SampleDistortedBoundingBoxV2")?;

        // Required input arguments
        op.add_input(&image_size.to_handle(ctx)?)?;
        op.add_input(&bounding_boxes.to_handle(ctx)?)?;
        op.add_input(&min_object_covered.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.seed {
            op.set_attr_int("seed", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed2 {
            op.set_attr_int("seed2", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.aspect_ratio_range {
            op.set_attr_float_list("aspect_ratio_range", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.area_range {
            op.set_attr_float_list("area_range", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.max_attempts {
            op.set_attr_int("max_attempts", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_image_if_no_bounding_boxes {
            op.set_attr_bool("use_image_if_no_bounding_boxes", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `SampleDistortedBoundingBoxV2::new().call(&ctx, &image_size, &bounding_boxes, &min_object_covered)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SampleDistortedBoundingBoxV2>
pub fn sample_distorted_bounding_box_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    image_size: &T0,
    bounding_boxes: &T1,
    min_object_covered: &T2,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = SampleDistortedBoundingBoxV2::new();
    op.call(ctx, image_size, bounding_boxes, min_object_covered)
}

/// SamplingDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SamplingDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SamplingDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SamplingDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl SamplingDataset {
    /// Creates a new `SamplingDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sampling_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        rate: &T1,
        seed: &T2,
        seed2: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SamplingDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&rate.to_handle(ctx)?)?;
        op.add_input(&seed.to_handle(ctx)?)?;
        op.add_input(&seed2.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SamplingDataset::new().call(&ctx, &input_dataset, &rate, &seed, &seed2)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SamplingDataset>
pub fn sampling_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    rate: &T1,
    seed: &T2,
    seed2: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SamplingDataset::new();
    op.call(ctx, input_dataset, rate, seed, seed2)
}

/// Save
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Save>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Save {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Save {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Save {
    /// Creates a new `Save`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute save.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        filename: &T0,
        tensor_names: &T1,
        data: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "Save")?;

        // Required input arguments
        op.add_input(&filename.to_handle(ctx)?)?;
        op.add_input(&tensor_names.to_handle(ctx)?)?;
        op.add_input(&data.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `Save::new().call(&ctx, &filename, &tensor_names, &data)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Save>
pub fn save<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    filename: &T0,
    tensor_names: &T1,
    data: &T2,
) -> crate::Result<()> {
    let op = Save::new();
    op.call(ctx, filename, tensor_names, data)
}

/// SaveDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SaveDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SaveDataset {
    compression: ::std::option::Option<::std::string::String>,
    shard_func: ::std::option::Option<::std::string::String>,
    use_shard_func: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SaveDataset {
    fn default() -> Self {
        Self {
            compression: None,
            shard_func: None,
            use_shard_func: Some(true),
            target_device_name: None,
        }
    }
}
impl SaveDataset {
    /// Creates a new `SaveDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `compression` attribute.
    pub fn compression<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.compression = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shard_func` attribute.
    pub fn shard_func<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shard_func = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_shard_func` attribute.
    pub fn use_shard_func<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_shard_func = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute save_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        path: &T1,
        shard_func_other_args: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "SaveDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&path.to_handle(ctx)?)?;
        op.add_input(&shard_func_other_args.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.compression {
            op.set_attr_string("compression", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shard_func {
            op.set_attr_string("shard_func", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_shard_func {
            op.set_attr_bool("use_shard_func", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `SaveDataset::new().call(&ctx, &input_dataset, &path, &shard_func_other_args)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SaveDataset>
pub fn save_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    path: &T1,
    shard_func_other_args: &T2,
) -> crate::Result<()> {
    let op = SaveDataset::new();
    op.call(ctx, input_dataset, path, shard_func_other_args)
}

/// SaveDatasetV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SaveDatasetV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SaveDatasetV2 {
    compression: ::std::option::Option<::std::string::String>,
    shard_func: ::std::option::Option<::std::string::String>,
    use_shard_func: ::std::option::Option<bool>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SaveDatasetV2 {
    fn default() -> Self {
        Self {
            compression: None,
            shard_func: None,
            use_shard_func: Some(true),
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl SaveDatasetV2 {
    /// Creates a new `SaveDatasetV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `compression` attribute.
    pub fn compression<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.compression = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shard_func` attribute.
    pub fn shard_func<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shard_func = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_shard_func` attribute.
    pub fn use_shard_func<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_shard_func = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute save_dataset_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        path: &T1,
        shard_func_other_args: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SaveDatasetV2")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&path.to_handle(ctx)?)?;
        op.add_input(&shard_func_other_args.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.compression {
            op.set_attr_string("compression", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shard_func {
            op.set_attr_string("shard_func", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_shard_func {
            op.set_attr_bool("use_shard_func", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SaveDatasetV2::new().call(&ctx, &input_dataset, &path, &shard_func_other_args)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SaveDatasetV2>
pub fn save_dataset_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    path: &T1,
    shard_func_other_args: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SaveDatasetV2::new();
    op.call(ctx, input_dataset, path, shard_func_other_args)
}

/// SaveSlices
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SaveSlices>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SaveSlices {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SaveSlices {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SaveSlices {
    /// Creates a new `SaveSlices`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute save_slices.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        filename: &T0,
        tensor_names: &T1,
        shapes_and_slices: &T2,
        data: &T3,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "SaveSlices")?;

        // Required input arguments
        op.add_input(&filename.to_handle(ctx)?)?;
        op.add_input(&tensor_names.to_handle(ctx)?)?;
        op.add_input(&shapes_and_slices.to_handle(ctx)?)?;
        op.add_input(&data.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `SaveSlices::new().call(&ctx, &filename, &tensor_names, &shapes_and_slices, &data)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SaveSlices>
pub fn save_slices<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    filename: &T0,
    tensor_names: &T1,
    shapes_and_slices: &T2,
    data: &T3,
) -> crate::Result<()> {
    let op = SaveSlices::new();
    op.call(ctx, filename, tensor_names, shapes_and_slices, data)
}

/// SaveV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SaveV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SaveV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SaveV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SaveV2 {
    /// Creates a new `SaveV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute save_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        prefix: &T0,
        tensor_names: &T1,
        shape_and_slices: &T2,
        tensors: &T3,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "SaveV2")?;

        // Required input arguments
        op.add_input(&prefix.to_handle(ctx)?)?;
        op.add_input(&tensor_names.to_handle(ctx)?)?;
        op.add_input(&shape_and_slices.to_handle(ctx)?)?;
        op.add_input(&tensors.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `SaveV2::new().call(&ctx, &prefix, &tensor_names, &shape_and_slices, &tensors)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SaveV2>
pub fn save_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    prefix: &T0,
    tensor_names: &T1,
    shape_and_slices: &T2,
    tensors: &T3,
) -> crate::Result<()> {
    let op = SaveV2::new();
    op.call(ctx, prefix, tensor_names, shape_and_slices, tensors)
}

/// ScalarSummary
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ScalarSummary>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ScalarSummary {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ScalarSummary {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ScalarSummary {
    /// Creates a new `ScalarSummary`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute scalar_summary.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        tags: &T0,
        values: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ScalarSummary")?;

        // Required input arguments
        op.add_input(&tags.to_handle(ctx)?)?;
        op.add_input(&values.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ScalarSummary::new().call(&ctx, &tags, &values)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ScalarSummary>
pub fn scalar_summary<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    tags: &T0,
    values: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ScalarSummary::new();
    op.call(ctx, tags, values)
}

/// ScaleAndTranslate
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ScaleAndTranslate>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ScaleAndTranslate {
    kernel_type: ::std::option::Option<::std::string::String>,
    antialias: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ScaleAndTranslate {
    fn default() -> Self {
        Self {
            kernel_type: Some(::std::string::String::from("lanczos3")),
            antialias: Some(true),
            target_device_name: None,
        }
    }
}
impl ScaleAndTranslate {
    /// Creates a new `ScaleAndTranslate`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `kernel_type` attribute.
    pub fn kernel_type<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.kernel_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `antialias` attribute.
    pub fn antialias<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.antialias = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute scale_and_translate.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        images: &T0,
        size: &T1,
        scale: &T2,
        translation: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ScaleAndTranslate")?;

        // Required input arguments
        op.add_input(&images.to_handle(ctx)?)?;
        op.add_input(&size.to_handle(ctx)?)?;
        op.add_input(&scale.to_handle(ctx)?)?;
        op.add_input(&translation.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.kernel_type {
            op.set_attr_string("kernel_type", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.antialias {
            op.set_attr_bool("antialias", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ScaleAndTranslate::new().call(&ctx, &images, &size, &scale, &translation)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ScaleAndTranslate>
pub fn scale_and_translate<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    images: &T0,
    size: &T1,
    scale: &T2,
    translation: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ScaleAndTranslate::new();
    op.call(ctx, images, size, scale, translation)
}

/// ScaleAndTranslateGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ScaleAndTranslateGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ScaleAndTranslateGrad {
    kernel_type: ::std::option::Option<::std::string::String>,
    antialias: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ScaleAndTranslateGrad {
    fn default() -> Self {
        Self {
            kernel_type: Some(::std::string::String::from("lanczos3")),
            antialias: Some(true),
            target_device_name: None,
        }
    }
}
impl ScaleAndTranslateGrad {
    /// Creates a new `ScaleAndTranslateGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `kernel_type` attribute.
    pub fn kernel_type<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.kernel_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `antialias` attribute.
    pub fn antialias<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.antialias = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute scale_and_translate_grad.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        grads: &T0,
        original_image: &T1,
        scale: &T2,
        translation: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ScaleAndTranslateGrad")?;

        // Required input arguments
        op.add_input(&grads.to_handle(ctx)?)?;
        op.add_input(&original_image.to_handle(ctx)?)?;
        op.add_input(&scale.to_handle(ctx)?)?;
        op.add_input(&translation.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.kernel_type {
            op.set_attr_string("kernel_type", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.antialias {
            op.set_attr_bool("antialias", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ScaleAndTranslateGrad::new().call(&ctx, &grads, &original_image, &scale, &translation)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ScaleAndTranslateGrad>
pub fn scale_and_translate_grad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    grads: &T0,
    original_image: &T1,
    scale: &T2,
    translation: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ScaleAndTranslateGrad::new();
    op.call(ctx, grads, original_image, scale, translation)
}

/// ScanDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ScanDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ScanDataset {
    f: ::std::option::Option<::std::string::String>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    preserve_cardinality: ::std::option::Option<bool>,
    use_default_device: ::std::option::Option<bool>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ScanDataset {
    fn default() -> Self {
        Self {
            f: None,
            output_types: None,
            output_shapes: None,
            preserve_cardinality: Some(false),
            use_default_device: Some(true),
            metadata: None,
            target_device_name: None,
        }
    }
}
impl ScanDataset {
    /// Creates a new `ScanDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `f` attribute.
    pub fn f<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.f = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `preserve_cardinality` attribute.
    pub fn preserve_cardinality<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.preserve_cardinality = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_default_device` attribute.
    pub fn use_default_device<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.use_default_device = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute scan_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        initial_state: &T1,
        other_arguments: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ScanDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&initial_state.to_handle(ctx)?)?;
        op.add_input(&other_arguments.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.f {
            op.set_attr_string("f", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.preserve_cardinality {
            op.set_attr_bool("preserve_cardinality", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_default_device {
            op.set_attr_bool("use_default_device", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ScanDataset::new().call(&ctx, &input_dataset, &initial_state, &other_arguments)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ScanDataset>
pub fn scan_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    initial_state: &T1,
    other_arguments: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ScanDataset::new();
    op.call(ctx, input_dataset, initial_state, other_arguments)
}

/// ScatterAdd
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ScatterAdd>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ScatterAdd {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ScatterAdd {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl ScatterAdd {
    /// Creates a new `ScatterAdd`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute scatter_add.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        ref_: &T0,
        indices: &T1,
        updates: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ScatterAdd")?;

        // Required input arguments
        op.add_input(&ref_.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&updates.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ScatterAdd::new().call(&ctx, &ref_, &indices, &updates)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ScatterAdd>
pub fn scatter_add<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    ref_: &T0,
    indices: &T1,
    updates: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ScatterAdd::new();
    op.call(ctx, ref_, indices, updates)
}

/// ScatterDiv
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ScatterDiv>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ScatterDiv {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ScatterDiv {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl ScatterDiv {
    /// Creates a new `ScatterDiv`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute scatter_div.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        ref_: &T0,
        indices: &T1,
        updates: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ScatterDiv")?;

        // Required input arguments
        op.add_input(&ref_.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&updates.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ScatterDiv::new().call(&ctx, &ref_, &indices, &updates)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ScatterDiv>
pub fn scatter_div<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    ref_: &T0,
    indices: &T1,
    updates: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ScatterDiv::new();
    op.call(ctx, ref_, indices, updates)
}

/// ScatterMax
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ScatterMax>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ScatterMax {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ScatterMax {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl ScatterMax {
    /// Creates a new `ScatterMax`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute scatter_max.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        ref_: &T0,
        indices: &T1,
        updates: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ScatterMax")?;

        // Required input arguments
        op.add_input(&ref_.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&updates.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ScatterMax::new().call(&ctx, &ref_, &indices, &updates)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ScatterMax>
pub fn scatter_max<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    ref_: &T0,
    indices: &T1,
    updates: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ScatterMax::new();
    op.call(ctx, ref_, indices, updates)
}

/// ScatterMin
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ScatterMin>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ScatterMin {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ScatterMin {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl ScatterMin {
    /// Creates a new `ScatterMin`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute scatter_min.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        ref_: &T0,
        indices: &T1,
        updates: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ScatterMin")?;

        // Required input arguments
        op.add_input(&ref_.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&updates.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ScatterMin::new().call(&ctx, &ref_, &indices, &updates)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ScatterMin>
pub fn scatter_min<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    ref_: &T0,
    indices: &T1,
    updates: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ScatterMin::new();
    op.call(ctx, ref_, indices, updates)
}

/// ScatterMul
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ScatterMul>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ScatterMul {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ScatterMul {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl ScatterMul {
    /// Creates a new `ScatterMul`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute scatter_mul.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        ref_: &T0,
        indices: &T1,
        updates: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ScatterMul")?;

        // Required input arguments
        op.add_input(&ref_.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&updates.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ScatterMul::new().call(&ctx, &ref_, &indices, &updates)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ScatterMul>
pub fn scatter_mul<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    ref_: &T0,
    indices: &T1,
    updates: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ScatterMul::new();
    op.call(ctx, ref_, indices, updates)
}

/// ScatterNd
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ScatterNd>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ScatterNd {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ScatterNd {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ScatterNd {
    /// Creates a new `ScatterNd`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute scatter_nd.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        indices: &T0,
        updates: &T1,
        shape: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ScatterNd")?;

        // Required input arguments
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&updates.to_handle(ctx)?)?;
        op.add_input(&shape.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ScatterNd::new().call(&ctx, &indices, &updates, &shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ScatterNd>
pub fn scatter_nd<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    indices: &T0,
    updates: &T1,
    shape: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ScatterNd::new();
    op.call(ctx, indices, updates, shape)
}

/// ScatterNdAdd
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ScatterNdAdd>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ScatterNdAdd {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ScatterNdAdd {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl ScatterNdAdd {
    /// Creates a new `ScatterNdAdd`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute scatter_nd_add.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        ref_: &T0,
        indices: &T1,
        updates: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ScatterNdAdd")?;

        // Required input arguments
        op.add_input(&ref_.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&updates.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ScatterNdAdd::new().call(&ctx, &ref_, &indices, &updates)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ScatterNdAdd>
pub fn scatter_nd_add<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    ref_: &T0,
    indices: &T1,
    updates: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ScatterNdAdd::new();
    op.call(ctx, ref_, indices, updates)
}

/// ScatterNdMax
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ScatterNdMax>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ScatterNdMax {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ScatterNdMax {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl ScatterNdMax {
    /// Creates a new `ScatterNdMax`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute scatter_nd_max.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        ref_: &T0,
        indices: &T1,
        updates: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ScatterNdMax")?;

        // Required input arguments
        op.add_input(&ref_.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&updates.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ScatterNdMax::new().call(&ctx, &ref_, &indices, &updates)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ScatterNdMax>
pub fn scatter_nd_max<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    ref_: &T0,
    indices: &T1,
    updates: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ScatterNdMax::new();
    op.call(ctx, ref_, indices, updates)
}

/// ScatterNdMin
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ScatterNdMin>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ScatterNdMin {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ScatterNdMin {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl ScatterNdMin {
    /// Creates a new `ScatterNdMin`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute scatter_nd_min.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        ref_: &T0,
        indices: &T1,
        updates: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ScatterNdMin")?;

        // Required input arguments
        op.add_input(&ref_.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&updates.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ScatterNdMin::new().call(&ctx, &ref_, &indices, &updates)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ScatterNdMin>
pub fn scatter_nd_min<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    ref_: &T0,
    indices: &T1,
    updates: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ScatterNdMin::new();
    op.call(ctx, ref_, indices, updates)
}

/// ScatterNdNonAliasingAdd
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ScatterNdNonAliasingAdd>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ScatterNdNonAliasingAdd {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ScatterNdNonAliasingAdd {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ScatterNdNonAliasingAdd {
    /// Creates a new `ScatterNdNonAliasingAdd`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute scatter_nd_non_aliasing_add.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        indices: &T1,
        updates: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ScatterNdNonAliasingAdd")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&updates.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ScatterNdNonAliasingAdd::new().call(&ctx, &input, &indices, &updates)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ScatterNdNonAliasingAdd>
pub fn scatter_nd_non_aliasing_add<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    indices: &T1,
    updates: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ScatterNdNonAliasingAdd::new();
    op.call(ctx, input, indices, updates)
}

/// ScatterNdSub
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ScatterNdSub>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ScatterNdSub {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ScatterNdSub {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl ScatterNdSub {
    /// Creates a new `ScatterNdSub`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute scatter_nd_sub.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        ref_: &T0,
        indices: &T1,
        updates: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ScatterNdSub")?;

        // Required input arguments
        op.add_input(&ref_.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&updates.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ScatterNdSub::new().call(&ctx, &ref_, &indices, &updates)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ScatterNdSub>
pub fn scatter_nd_sub<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    ref_: &T0,
    indices: &T1,
    updates: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ScatterNdSub::new();
    op.call(ctx, ref_, indices, updates)
}

/// ScatterNdUpdate
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ScatterNdUpdate>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ScatterNdUpdate {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ScatterNdUpdate {
    fn default() -> Self {
        Self {
            use_locking: Some(true),
            target_device_name: None,
        }
    }
}
impl ScatterNdUpdate {
    /// Creates a new `ScatterNdUpdate`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute scatter_nd_update.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        ref_: &T0,
        indices: &T1,
        updates: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ScatterNdUpdate")?;

        // Required input arguments
        op.add_input(&ref_.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&updates.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ScatterNdUpdate::new().call(&ctx, &ref_, &indices, &updates)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ScatterNdUpdate>
pub fn scatter_nd_update<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    ref_: &T0,
    indices: &T1,
    updates: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ScatterNdUpdate::new();
    op.call(ctx, ref_, indices, updates)
}

/// ScatterSub
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ScatterSub>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ScatterSub {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ScatterSub {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl ScatterSub {
    /// Creates a new `ScatterSub`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute scatter_sub.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        ref_: &T0,
        indices: &T1,
        updates: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ScatterSub")?;

        // Required input arguments
        op.add_input(&ref_.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&updates.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ScatterSub::new().call(&ctx, &ref_, &indices, &updates)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ScatterSub>
pub fn scatter_sub<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    ref_: &T0,
    indices: &T1,
    updates: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ScatterSub::new();
    op.call(ctx, ref_, indices, updates)
}

/// ScatterUpdate
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ScatterUpdate>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ScatterUpdate {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ScatterUpdate {
    fn default() -> Self {
        Self {
            use_locking: Some(true),
            target_device_name: None,
        }
    }
}
impl ScatterUpdate {
    /// Creates a new `ScatterUpdate`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute scatter_update.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        ref_: &T0,
        indices: &T1,
        updates: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ScatterUpdate")?;

        // Required input arguments
        op.add_input(&ref_.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&updates.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ScatterUpdate::new().call(&ctx, &ref_, &indices, &updates)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ScatterUpdate>
pub fn scatter_update<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    ref_: &T0,
    indices: &T1,
    updates: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ScatterUpdate::new();
    op.call(ctx, ref_, indices, updates)
}

/// SdcaFprint
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SdcaFprint>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SdcaFprint {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SdcaFprint {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SdcaFprint {
    /// Creates a new `SdcaFprint`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sdca_fprint.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SdcaFprint")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SdcaFprint::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SdcaFprint>
pub fn sdca_fprint<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SdcaFprint::new();
    op.call(ctx, input)
}

/// SdcaOptimizer
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SdcaOptimizer>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SdcaOptimizer {
    loss_type: ::std::option::Option<::std::string::String>,
    adaptative: ::std::option::Option<bool>,
    l1: ::std::option::Option<f32>,
    l2: ::std::option::Option<f32>,
    num_loss_partitions: ::std::option::Option<i64>,
    num_inner_iterations: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SdcaOptimizer {
    fn default() -> Self {
        Self {
            loss_type: None,
            adaptative: Some(false),
            l1: None,
            l2: None,
            num_loss_partitions: None,
            num_inner_iterations: None,
            target_device_name: None,
        }
    }
}
impl SdcaOptimizer {
    /// Creates a new `SdcaOptimizer`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `loss_type` attribute.
    pub fn loss_type<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.loss_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `adaptative` attribute.
    pub fn adaptative<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.adaptative = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `l1` attribute.
    pub fn l1<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.l1 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `l2` attribute.
    pub fn l2<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.l2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_loss_partitions` attribute.
    pub fn num_loss_partitions<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.num_loss_partitions = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_inner_iterations` attribute.
    pub fn num_inner_iterations<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.num_inner_iterations = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sdca_optimizer.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
        T9: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        sparse_example_indices: &[&T0],
        sparse_feature_indices: &[&T1],
        sparse_feature_values: &[&T2],
        dense_features: &[&T3],
        example_weights: &T4,
        example_labels: &T5,
        sparse_indices: &[&T6],
        sparse_weights: &[&T7],
        dense_weights: &[&T8],
        example_state_data: &T9,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "SdcaOptimizer")?;

        // Required input arguments
        let mut sparse_example_indices_list = Vec::new();

        for t in sparse_example_indices {
            sparse_example_indices_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&sparse_example_indices_list)?;
        let mut sparse_feature_indices_list = Vec::new();

        for t in sparse_feature_indices {
            sparse_feature_indices_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&sparse_feature_indices_list)?;
        let mut sparse_feature_values_list = Vec::new();

        for t in sparse_feature_values {
            sparse_feature_values_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&sparse_feature_values_list)?;
        let mut dense_features_list = Vec::new();

        for t in dense_features {
            dense_features_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&dense_features_list)?;
        op.add_input(&example_weights.to_handle(ctx)?)?;
        op.add_input(&example_labels.to_handle(ctx)?)?;
        let mut sparse_indices_list = Vec::new();

        for t in sparse_indices {
            sparse_indices_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&sparse_indices_list)?;
        let mut sparse_weights_list = Vec::new();

        for t in sparse_weights {
            sparse_weights_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&sparse_weights_list)?;
        let mut dense_weights_list = Vec::new();

        for t in dense_weights {
            dense_weights_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&dense_weights_list)?;
        op.add_input(&example_state_data.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.loss_type {
            op.set_attr_string("loss_type", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.adaptative {
            op.set_attr_bool("adaptative", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.l1 {
            op.set_attr_float("l1", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.l2 {
            op.set_attr_float("l2", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_loss_partitions {
            op.set_attr_int("num_loss_partitions", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_inner_iterations {
            op.set_attr_int("num_inner_iterations", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `SdcaOptimizer::new().call(&ctx, &sparse_example_indices, &sparse_feature_indices, &sparse_feature_values, &dense_features, &example_weights, &example_labels, &sparse_indices, &sparse_weights, &dense_weights, &example_state_data)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SdcaOptimizer>
pub fn sdca_optimizer<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
    T9: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    sparse_example_indices: &[&T0],
    sparse_feature_indices: &[&T1],
    sparse_feature_values: &[&T2],
    dense_features: &[&T3],
    example_weights: &T4,
    example_labels: &T5,
    sparse_indices: &[&T6],
    sparse_weights: &[&T7],
    dense_weights: &[&T8],
    example_state_data: &T9,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = SdcaOptimizer::new();
    op.call(
        ctx,
        sparse_example_indices,
        sparse_feature_indices,
        sparse_feature_values,
        dense_features,
        example_weights,
        example_labels,
        sparse_indices,
        sparse_weights,
        dense_weights,
        example_state_data,
    )
}

/// SdcaOptimizerV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SdcaOptimizerV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SdcaOptimizerV2 {
    loss_type: ::std::option::Option<::std::string::String>,
    adaptive: ::std::option::Option<bool>,
    l1: ::std::option::Option<f32>,
    l2: ::std::option::Option<f32>,
    num_loss_partitions: ::std::option::Option<i64>,
    num_inner_iterations: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SdcaOptimizerV2 {
    fn default() -> Self {
        Self {
            loss_type: None,
            adaptive: Some(false),
            l1: None,
            l2: None,
            num_loss_partitions: None,
            num_inner_iterations: None,
            target_device_name: None,
        }
    }
}
impl SdcaOptimizerV2 {
    /// Creates a new `SdcaOptimizerV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `loss_type` attribute.
    pub fn loss_type<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.loss_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `adaptive` attribute.
    pub fn adaptive<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.adaptive = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `l1` attribute.
    pub fn l1<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.l1 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `l2` attribute.
    pub fn l2<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.l2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_loss_partitions` attribute.
    pub fn num_loss_partitions<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.num_loss_partitions = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_inner_iterations` attribute.
    pub fn num_inner_iterations<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.num_inner_iterations = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sdca_optimizer_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
        T9: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        sparse_example_indices: &[&T0],
        sparse_feature_indices: &[&T1],
        sparse_feature_values: &[&T2],
        dense_features: &[&T3],
        example_weights: &T4,
        example_labels: &T5,
        sparse_indices: &[&T6],
        sparse_weights: &[&T7],
        dense_weights: &[&T8],
        example_state_data: &T9,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "SdcaOptimizerV2")?;

        // Required input arguments
        let mut sparse_example_indices_list = Vec::new();

        for t in sparse_example_indices {
            sparse_example_indices_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&sparse_example_indices_list)?;
        let mut sparse_feature_indices_list = Vec::new();

        for t in sparse_feature_indices {
            sparse_feature_indices_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&sparse_feature_indices_list)?;
        let mut sparse_feature_values_list = Vec::new();

        for t in sparse_feature_values {
            sparse_feature_values_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&sparse_feature_values_list)?;
        let mut dense_features_list = Vec::new();

        for t in dense_features {
            dense_features_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&dense_features_list)?;
        op.add_input(&example_weights.to_handle(ctx)?)?;
        op.add_input(&example_labels.to_handle(ctx)?)?;
        let mut sparse_indices_list = Vec::new();

        for t in sparse_indices {
            sparse_indices_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&sparse_indices_list)?;
        let mut sparse_weights_list = Vec::new();

        for t in sparse_weights {
            sparse_weights_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&sparse_weights_list)?;
        let mut dense_weights_list = Vec::new();

        for t in dense_weights {
            dense_weights_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&dense_weights_list)?;
        op.add_input(&example_state_data.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.loss_type {
            op.set_attr_string("loss_type", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.adaptive {
            op.set_attr_bool("adaptive", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.l1 {
            op.set_attr_float("l1", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.l2 {
            op.set_attr_float("l2", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_loss_partitions {
            op.set_attr_int("num_loss_partitions", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_inner_iterations {
            op.set_attr_int("num_inner_iterations", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `SdcaOptimizerV2::new().call(&ctx, &sparse_example_indices, &sparse_feature_indices, &sparse_feature_values, &dense_features, &example_weights, &example_labels, &sparse_indices, &sparse_weights, &dense_weights, &example_state_data)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SdcaOptimizerV2>
pub fn sdca_optimizer_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
    T9: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    sparse_example_indices: &[&T0],
    sparse_feature_indices: &[&T1],
    sparse_feature_values: &[&T2],
    dense_features: &[&T3],
    example_weights: &T4,
    example_labels: &T5,
    sparse_indices: &[&T6],
    sparse_weights: &[&T7],
    dense_weights: &[&T8],
    example_state_data: &T9,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = SdcaOptimizerV2::new();
    op.call(
        ctx,
        sparse_example_indices,
        sparse_feature_indices,
        sparse_feature_values,
        dense_features,
        example_weights,
        example_labels,
        sparse_indices,
        sparse_weights,
        dense_weights,
        example_state_data,
    )
}

/// SdcaShrinkL1
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SdcaShrinkL1>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SdcaShrinkL1 {
    l1: ::std::option::Option<f32>,
    l2: ::std::option::Option<f32>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SdcaShrinkL1 {
    fn default() -> Self {
        Self {
            l1: None,
            l2: None,
            target_device_name: None,
        }
    }
}
impl SdcaShrinkL1 {
    /// Creates a new `SdcaShrinkL1`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `l1` attribute.
    pub fn l1<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.l1 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `l2` attribute.
    pub fn l2<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.l2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sdca_shrink_l1.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        weights: &[&T0],
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "SdcaShrinkL1")?;

        // Required input arguments
        let mut weights_list = Vec::new();

        for t in weights {
            weights_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&weights_list)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.l1 {
            op.set_attr_float("l1", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.l2 {
            op.set_attr_float("l2", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `SdcaShrinkL1::new().call(&ctx, &weights)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SdcaShrinkL1>
pub fn sdca_shrink_l1<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    weights: &[&T0],
) -> crate::Result<()> {
    let op = SdcaShrinkL1::new();
    op.call(ctx, weights)
}

/// SegmentMax
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SegmentMax>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SegmentMax {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SegmentMax {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SegmentMax {
    /// Creates a new `SegmentMax`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute segment_max.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        data: &T0,
        segment_ids: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SegmentMax")?;

        // Required input arguments
        op.add_input(&data.to_handle(ctx)?)?;
        op.add_input(&segment_ids.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SegmentMax::new().call(&ctx, &data, &segment_ids)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SegmentMax>
pub fn segment_max<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    data: &T0,
    segment_ids: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SegmentMax::new();
    op.call(ctx, data, segment_ids)
}

/// SegmentMean
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SegmentMean>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SegmentMean {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SegmentMean {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SegmentMean {
    /// Creates a new `SegmentMean`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute segment_mean.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        data: &T0,
        segment_ids: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SegmentMean")?;

        // Required input arguments
        op.add_input(&data.to_handle(ctx)?)?;
        op.add_input(&segment_ids.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SegmentMean::new().call(&ctx, &data, &segment_ids)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SegmentMean>
pub fn segment_mean<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    data: &T0,
    segment_ids: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SegmentMean::new();
    op.call(ctx, data, segment_ids)
}

/// SegmentMin
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SegmentMin>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SegmentMin {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SegmentMin {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SegmentMin {
    /// Creates a new `SegmentMin`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute segment_min.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        data: &T0,
        segment_ids: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SegmentMin")?;

        // Required input arguments
        op.add_input(&data.to_handle(ctx)?)?;
        op.add_input(&segment_ids.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SegmentMin::new().call(&ctx, &data, &segment_ids)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SegmentMin>
pub fn segment_min<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    data: &T0,
    segment_ids: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SegmentMin::new();
    op.call(ctx, data, segment_ids)
}

/// SegmentProd
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SegmentProd>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SegmentProd {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SegmentProd {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SegmentProd {
    /// Creates a new `SegmentProd`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute segment_prod.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        data: &T0,
        segment_ids: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SegmentProd")?;

        // Required input arguments
        op.add_input(&data.to_handle(ctx)?)?;
        op.add_input(&segment_ids.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SegmentProd::new().call(&ctx, &data, &segment_ids)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SegmentProd>
pub fn segment_prod<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    data: &T0,
    segment_ids: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SegmentProd::new();
    op.call(ctx, data, segment_ids)
}

/// SegmentSum
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SegmentSum>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SegmentSum {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SegmentSum {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SegmentSum {
    /// Creates a new `SegmentSum`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute segment_sum.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        data: &T0,
        segment_ids: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SegmentSum")?;

        // Required input arguments
        op.add_input(&data.to_handle(ctx)?)?;
        op.add_input(&segment_ids.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SegmentSum::new().call(&ctx, &data, &segment_ids)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SegmentSum>
pub fn segment_sum<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    data: &T0,
    segment_ids: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SegmentSum::new();
    op.call(ctx, data, segment_ids)
}

/// Select
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Select>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Select {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Select {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Select {
    /// Creates a new `Select`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute select.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        condition: &T0,
        t: &T1,
        e: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Select")?;

        // Required input arguments
        op.add_input(&condition.to_handle(ctx)?)?;
        op.add_input(&t.to_handle(ctx)?)?;
        op.add_input(&e.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Select::new().call(&ctx, &condition, &t, &e)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Select>
pub fn select<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    condition: &T0,
    t: &T1,
    e: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Select::new();
    op.call(ctx, condition, t, e)
}

/// SelectV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SelectV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SelectV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SelectV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SelectV2 {
    /// Creates a new `SelectV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute select_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        condition: &T0,
        t: &T1,
        e: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SelectV2")?;

        // Required input arguments
        op.add_input(&condition.to_handle(ctx)?)?;
        op.add_input(&t.to_handle(ctx)?)?;
        op.add_input(&e.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SelectV2::new().call(&ctx, &condition, &t, &e)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SelectV2>
pub fn select_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    condition: &T0,
    t: &T1,
    e: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SelectV2::new();
    op.call(ctx, condition, t, e)
}

/// SelfAdjointEig
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SelfAdjointEig>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SelfAdjointEig {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SelfAdjointEig {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SelfAdjointEig {
    /// Creates a new `SelfAdjointEig`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute self_adjoint_eig.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SelfAdjointEig")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SelfAdjointEig::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SelfAdjointEig>
pub fn self_adjoint_eig<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SelfAdjointEig::new();
    op.call(ctx, input)
}

/// SelfAdjointEigV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SelfAdjointEigV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SelfAdjointEigV2 {
    compute_v: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SelfAdjointEigV2 {
    fn default() -> Self {
        Self {
            compute_v: Some(true),
            target_device_name: None,
        }
    }
}
impl SelfAdjointEigV2 {
    /// Creates a new `SelfAdjointEigV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `compute_v` attribute.
    pub fn compute_v<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.compute_v = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute self_adjoint_eig_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "SelfAdjointEigV2")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.compute_v {
            op.set_attr_bool("compute_v", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `SelfAdjointEigV2::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SelfAdjointEigV2>
pub fn self_adjoint_eig_v2<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = SelfAdjointEigV2::new();
    op.call(ctx, input)
}

/// Selu
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Selu>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Selu {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Selu {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Selu {
    /// Creates a new `Selu`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute selu.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        features: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Selu")?;

        // Required input arguments
        op.add_input(&features.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Selu::new().call(&ctx, &features)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Selu>
pub fn selu<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    features: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Selu::new();
    op.call(ctx, features)
}

/// SeluGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SeluGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SeluGrad {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SeluGrad {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SeluGrad {
    /// Creates a new `SeluGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute selu_grad.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        gradients: &T0,
        outputs: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SeluGrad")?;

        // Required input arguments
        op.add_input(&gradients.to_handle(ctx)?)?;
        op.add_input(&outputs.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SeluGrad::new().call(&ctx, &gradients, &outputs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SeluGrad>
pub fn selu_grad<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    gradients: &T0,
    outputs: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SeluGrad::new();
    op.call(ctx, gradients, outputs)
}

/// Send
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Send>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Send {
    tensor_name: ::std::option::Option<::std::string::String>,
    send_device: ::std::option::Option<::std::string::String>,
    send_device_incarnation: ::std::option::Option<i64>,
    recv_device: ::std::option::Option<::std::string::String>,
    client_terminated: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Send {
    fn default() -> Self {
        Self {
            tensor_name: None,
            send_device: None,
            send_device_incarnation: None,
            recv_device: None,
            client_terminated: Some(false),
            target_device_name: None,
        }
    }
}
impl Send {
    /// Creates a new `Send`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `tensor_name` attribute.
    pub fn tensor_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.tensor_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `send_device` attribute.
    pub fn send_device<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.send_device = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `send_device_incarnation` attribute.
    pub fn send_device_incarnation<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.send_device_incarnation = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `recv_device` attribute.
    pub fn recv_device<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.recv_device = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `client_terminated` attribute.
    pub fn client_terminated<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.client_terminated = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute send.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        tensor: &T0,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "Send")?;

        // Required input arguments
        op.add_input(&tensor.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.tensor_name {
            op.set_attr_string("tensor_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.send_device {
            op.set_attr_string("send_device", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.send_device_incarnation {
            op.set_attr_int("send_device_incarnation", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.recv_device {
            op.set_attr_string("recv_device", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.client_terminated {
            op.set_attr_bool("client_terminated", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `Send::new().call(&ctx, &tensor)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Send>
pub fn send<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    tensor: &T0,
) -> crate::Result<()> {
    let op = Send::new();
    op.call(ctx, tensor)
}

/// SendTPUEmbeddingGradients
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SendTPUEmbeddingGradients>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SendTPUEmbeddingGradients {
    config: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SendTPUEmbeddingGradients {
    fn default() -> Self {
        Self {
            config: None,
            target_device_name: None,
        }
    }
}
impl SendTPUEmbeddingGradients {
    /// Creates a new `SendTPUEmbeddingGradients`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute send_tpuembedding_gradients.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        inputs: &[&T0],
        learning_rates: &[&T1],
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "SendTPUEmbeddingGradients")?;

        // Required input arguments
        let mut inputs_list = Vec::new();

        for t in inputs {
            inputs_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&inputs_list)?;
        let mut learning_rates_list = Vec::new();

        for t in learning_rates {
            learning_rates_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&learning_rates_list)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `SendTPUEmbeddingGradients::new().call(&ctx, &inputs, &learning_rates)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SendTPUEmbeddingGradients>
pub fn send_tpuembedding_gradients<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    inputs: &[&T0],
    learning_rates: &[&T1],
) -> crate::Result<()> {
    let op = SendTPUEmbeddingGradients::new();
    op.call(ctx, inputs, learning_rates)
}

/// SerializeIterator
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SerializeIterator>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SerializeIterator {
    external_state_policy: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SerializeIterator {
    fn default() -> Self {
        Self {
            external_state_policy: Some(0i64),
            target_device_name: None,
        }
    }
}
impl SerializeIterator {
    /// Creates a new `SerializeIterator`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `external_state_policy` attribute.
    pub fn external_state_policy<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.external_state_policy = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute serialize_iterator.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        resource_handle: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SerializeIterator")?;

        // Required input arguments
        op.add_input(&resource_handle.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.external_state_policy {
            op.set_attr_int("external_state_policy", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SerializeIterator::new().call(&ctx, &resource_handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SerializeIterator>
pub fn serialize_iterator<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    resource_handle: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SerializeIterator::new();
    op.call(ctx, resource_handle)
}

/// SerializeManySparse
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SerializeManySparse>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SerializeManySparse {
    out_type: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SerializeManySparse {
    fn default() -> Self {
        Self {
            out_type: Some(crate::DataType::String),
            target_device_name: None,
        }
    }
}
impl SerializeManySparse {
    /// Creates a new `SerializeManySparse`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_type` attribute.
    pub fn out_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute serialize_many_sparse.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        sparse_indices: &T0,
        sparse_values: &T1,
        sparse_shape: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SerializeManySparse")?;

        // Required input arguments
        op.add_input(&sparse_indices.to_handle(ctx)?)?;
        op.add_input(&sparse_values.to_handle(ctx)?)?;
        op.add_input(&sparse_shape.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_type {
            op.set_attr_type("out_type", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SerializeManySparse::new().call(&ctx, &sparse_indices, &sparse_values, &sparse_shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SerializeManySparse>
pub fn serialize_many_sparse<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    sparse_indices: &T0,
    sparse_values: &T1,
    sparse_shape: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SerializeManySparse::new();
    op.call(ctx, sparse_indices, sparse_values, sparse_shape)
}

/// SerializeSparse
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SerializeSparse>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SerializeSparse {
    out_type: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SerializeSparse {
    fn default() -> Self {
        Self {
            out_type: Some(crate::DataType::String),
            target_device_name: None,
        }
    }
}
impl SerializeSparse {
    /// Creates a new `SerializeSparse`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_type` attribute.
    pub fn out_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute serialize_sparse.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        sparse_indices: &T0,
        sparse_values: &T1,
        sparse_shape: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SerializeSparse")?;

        // Required input arguments
        op.add_input(&sparse_indices.to_handle(ctx)?)?;
        op.add_input(&sparse_values.to_handle(ctx)?)?;
        op.add_input(&sparse_shape.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_type {
            op.set_attr_type("out_type", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SerializeSparse::new().call(&ctx, &sparse_indices, &sparse_values, &sparse_shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SerializeSparse>
pub fn serialize_sparse<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    sparse_indices: &T0,
    sparse_values: &T1,
    sparse_shape: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SerializeSparse::new();
    op.call(ctx, sparse_indices, sparse_values, sparse_shape)
}

/// SerializeTensor
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SerializeTensor>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SerializeTensor {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SerializeTensor {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SerializeTensor {
    /// Creates a new `SerializeTensor`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute serialize_tensor.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        tensor: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SerializeTensor")?;

        // Required input arguments
        op.add_input(&tensor.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SerializeTensor::new().call(&ctx, &tensor)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SerializeTensor>
pub fn serialize_tensor<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    tensor: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SerializeTensor::new();
    op.call(ctx, tensor)
}

/// SetSize
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SetSize>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SetSize {
    validate_indices: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SetSize {
    fn default() -> Self {
        Self {
            validate_indices: Some(true),
            target_device_name: None,
        }
    }
}
impl SetSize {
    /// Creates a new `SetSize`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `validate_indices` attribute.
    pub fn validate_indices<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.validate_indices = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute set_size.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        set_indices: &T0,
        set_values: &T1,
        set_shape: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SetSize")?;

        // Required input arguments
        op.add_input(&set_indices.to_handle(ctx)?)?;
        op.add_input(&set_values.to_handle(ctx)?)?;
        op.add_input(&set_shape.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.validate_indices {
            op.set_attr_bool("validate_indices", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SetSize::new().call(&ctx, &set_indices, &set_values, &set_shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SetSize>
pub fn set_size<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    set_indices: &T0,
    set_values: &T1,
    set_shape: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SetSize::new();
    op.call(ctx, set_indices, set_values, set_shape)
}

/// SetStatsAggregatorDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SetStatsAggregatorDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SetStatsAggregatorDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SetStatsAggregatorDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl SetStatsAggregatorDataset {
    /// Creates a new `SetStatsAggregatorDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute set_stats_aggregator_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        stats_aggregator: &T1,
        tag: &T2,
        counter_prefix: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SetStatsAggregatorDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&stats_aggregator.to_handle(ctx)?)?;
        op.add_input(&tag.to_handle(ctx)?)?;
        op.add_input(&counter_prefix.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SetStatsAggregatorDataset::new().call(&ctx, &input_dataset, &stats_aggregator, &tag, &counter_prefix)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SetStatsAggregatorDataset>
pub fn set_stats_aggregator_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    stats_aggregator: &T1,
    tag: &T2,
    counter_prefix: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SetStatsAggregatorDataset::new();
    op.call(ctx, input_dataset, stats_aggregator, tag, counter_prefix)
}

/// Shape
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Shape>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Shape {
    out_type: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Shape {
    fn default() -> Self {
        Self {
            out_type: Some(crate::DataType::Int32),
            target_device_name: None,
        }
    }
}
impl Shape {
    /// Creates a new `Shape`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_type` attribute.
    pub fn out_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute shape.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Shape")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_type {
            op.set_attr_type("out_type", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Shape::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Shape>
pub fn shape<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Shape::new();
    op.call(ctx, input)
}

/// ShapeN
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ShapeN>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ShapeN {
    out_type: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ShapeN {
    fn default() -> Self {
        Self {
            out_type: Some(crate::DataType::Int32),
            target_device_name: None,
        }
    }
}
impl ShapeN {
    /// Creates a new `ShapeN`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_type` attribute.
    pub fn out_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute shape_n.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &[&T0],
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ShapeN")?;

        // Required input arguments
        let mut input_list = Vec::new();

        for t in input {
            input_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&input_list)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_type {
            op.set_attr_type("out_type", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ShapeN::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ShapeN>
pub fn shape_n<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &[&T0],
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ShapeN::new();
    op.call(ctx, input)
}

/// ShardDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ShardDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ShardDataset {
    require_non_empty: ::std::option::Option<bool>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ShardDataset {
    fn default() -> Self {
        Self {
            require_non_empty: Some(false),
            output_types: None,
            output_shapes: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl ShardDataset {
    /// Creates a new `ShardDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `require_non_empty` attribute.
    pub fn require_non_empty<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.require_non_empty = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute shard_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        num_shards: &T1,
        index: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ShardDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&num_shards.to_handle(ctx)?)?;
        op.add_input(&index.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.require_non_empty {
            op.set_attr_bool("require_non_empty", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ShardDataset::new().call(&ctx, &input_dataset, &num_shards, &index)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ShardDataset>
pub fn shard_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    num_shards: &T1,
    index: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ShardDataset::new();
    op.call(ctx, input_dataset, num_shards, index)
}

/// ShardedFilename
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ShardedFilename>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ShardedFilename {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ShardedFilename {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ShardedFilename {
    /// Creates a new `ShardedFilename`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sharded_filename.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        basename: &T0,
        shard: &T1,
        num_shards: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ShardedFilename")?;

        // Required input arguments
        op.add_input(&basename.to_handle(ctx)?)?;
        op.add_input(&shard.to_handle(ctx)?)?;
        op.add_input(&num_shards.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ShardedFilename::new().call(&ctx, &basename, &shard, &num_shards)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ShardedFilename>
pub fn sharded_filename<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    basename: &T0,
    shard: &T1,
    num_shards: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ShardedFilename::new();
    op.call(ctx, basename, shard, num_shards)
}

/// ShardedFilespec
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ShardedFilespec>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ShardedFilespec {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ShardedFilespec {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ShardedFilespec {
    /// Creates a new `ShardedFilespec`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sharded_filespec.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        basename: &T0,
        num_shards: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ShardedFilespec")?;

        // Required input arguments
        op.add_input(&basename.to_handle(ctx)?)?;
        op.add_input(&num_shards.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ShardedFilespec::new().call(&ctx, &basename, &num_shards)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ShardedFilespec>
pub fn sharded_filespec<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    basename: &T0,
    num_shards: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ShardedFilespec::new();
    op.call(ctx, basename, num_shards)
}

/// ShuffleAndRepeatDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ShuffleAndRepeatDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ShuffleAndRepeatDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    reshuffle_each_iteration: ::std::option::Option<bool>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ShuffleAndRepeatDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            reshuffle_each_iteration: Some(true),
            metadata: None,
            target_device_name: None,
        }
    }
}
impl ShuffleAndRepeatDataset {
    /// Creates a new `ShuffleAndRepeatDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `reshuffle_each_iteration` attribute.
    pub fn reshuffle_each_iteration<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.reshuffle_each_iteration = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute shuffle_and_repeat_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        buffer_size: &T1,
        seed: &T2,
        seed2: &T3,
        count: &T4,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ShuffleAndRepeatDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&buffer_size.to_handle(ctx)?)?;
        op.add_input(&seed.to_handle(ctx)?)?;
        op.add_input(&seed2.to_handle(ctx)?)?;
        op.add_input(&count.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.reshuffle_each_iteration {
            op.set_attr_bool("reshuffle_each_iteration", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ShuffleAndRepeatDataset::new().call(&ctx, &input_dataset, &buffer_size, &seed, &seed2, &count)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ShuffleAndRepeatDataset>
pub fn shuffle_and_repeat_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    buffer_size: &T1,
    seed: &T2,
    seed2: &T3,
    count: &T4,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ShuffleAndRepeatDataset::new();
    op.call(ctx, input_dataset, buffer_size, seed, seed2, count)
}

/// ShuffleAndRepeatDatasetV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ShuffleAndRepeatDatasetV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ShuffleAndRepeatDatasetV2 {
    reshuffle_each_iteration: ::std::option::Option<bool>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ShuffleAndRepeatDatasetV2 {
    fn default() -> Self {
        Self {
            reshuffle_each_iteration: Some(true),
            output_types: None,
            output_shapes: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl ShuffleAndRepeatDatasetV2 {
    /// Creates a new `ShuffleAndRepeatDatasetV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `reshuffle_each_iteration` attribute.
    pub fn reshuffle_each_iteration<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.reshuffle_each_iteration = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute shuffle_and_repeat_dataset_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        buffer_size: &T1,
        seed: &T2,
        seed2: &T3,
        count: &T4,
        seed_generator: &T5,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ShuffleAndRepeatDatasetV2")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&buffer_size.to_handle(ctx)?)?;
        op.add_input(&seed.to_handle(ctx)?)?;
        op.add_input(&seed2.to_handle(ctx)?)?;
        op.add_input(&count.to_handle(ctx)?)?;
        op.add_input(&seed_generator.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.reshuffle_each_iteration {
            op.set_attr_bool("reshuffle_each_iteration", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ShuffleAndRepeatDatasetV2::new().call(&ctx, &input_dataset, &buffer_size, &seed, &seed2, &count, &seed_generator)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ShuffleAndRepeatDatasetV2>
pub fn shuffle_and_repeat_dataset_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    buffer_size: &T1,
    seed: &T2,
    seed2: &T3,
    count: &T4,
    seed_generator: &T5,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ShuffleAndRepeatDatasetV2::new();
    op.call(
        ctx,
        input_dataset,
        buffer_size,
        seed,
        seed2,
        count,
        seed_generator,
    )
}

/// ShuffleDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ShuffleDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ShuffleDataset {
    reshuffle_each_iteration: ::std::option::Option<bool>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ShuffleDataset {
    fn default() -> Self {
        Self {
            reshuffle_each_iteration: Some(true),
            output_types: None,
            output_shapes: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl ShuffleDataset {
    /// Creates a new `ShuffleDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `reshuffle_each_iteration` attribute.
    pub fn reshuffle_each_iteration<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.reshuffle_each_iteration = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute shuffle_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        buffer_size: &T1,
        seed: &T2,
        seed2: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ShuffleDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&buffer_size.to_handle(ctx)?)?;
        op.add_input(&seed.to_handle(ctx)?)?;
        op.add_input(&seed2.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.reshuffle_each_iteration {
            op.set_attr_bool("reshuffle_each_iteration", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ShuffleDataset::new().call(&ctx, &input_dataset, &buffer_size, &seed, &seed2)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ShuffleDataset>
pub fn shuffle_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    buffer_size: &T1,
    seed: &T2,
    seed2: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ShuffleDataset::new();
    op.call(ctx, input_dataset, buffer_size, seed, seed2)
}

/// ShuffleDatasetV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ShuffleDatasetV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ShuffleDatasetV2 {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ShuffleDatasetV2 {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl ShuffleDatasetV2 {
    /// Creates a new `ShuffleDatasetV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute shuffle_dataset_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        buffer_size: &T1,
        seed_generator: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ShuffleDatasetV2")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&buffer_size.to_handle(ctx)?)?;
        op.add_input(&seed_generator.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ShuffleDatasetV2::new().call(&ctx, &input_dataset, &buffer_size, &seed_generator)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ShuffleDatasetV2>
pub fn shuffle_dataset_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    buffer_size: &T1,
    seed_generator: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ShuffleDatasetV2::new();
    op.call(ctx, input_dataset, buffer_size, seed_generator)
}

/// ShuffleDatasetV3
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ShuffleDatasetV3>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ShuffleDatasetV3 {
    reshuffle_each_iteration: ::std::option::Option<bool>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ShuffleDatasetV3 {
    fn default() -> Self {
        Self {
            reshuffle_each_iteration: Some(true),
            output_types: None,
            output_shapes: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl ShuffleDatasetV3 {
    /// Creates a new `ShuffleDatasetV3`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `reshuffle_each_iteration` attribute.
    pub fn reshuffle_each_iteration<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.reshuffle_each_iteration = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute shuffle_dataset_v3.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        buffer_size: &T1,
        seed: &T2,
        seed2: &T3,
        seed_generator: &T4,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ShuffleDatasetV3")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&buffer_size.to_handle(ctx)?)?;
        op.add_input(&seed.to_handle(ctx)?)?;
        op.add_input(&seed2.to_handle(ctx)?)?;
        op.add_input(&seed_generator.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.reshuffle_each_iteration {
            op.set_attr_bool("reshuffle_each_iteration", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ShuffleDatasetV3::new().call(&ctx, &input_dataset, &buffer_size, &seed, &seed2, &seed_generator)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ShuffleDatasetV3>
pub fn shuffle_dataset_v3<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    buffer_size: &T1,
    seed: &T2,
    seed2: &T3,
    seed_generator: &T4,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ShuffleDatasetV3::new();
    op.call(ctx, input_dataset, buffer_size, seed, seed2, seed_generator)
}

/// ShutdownDistributedTPU
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ShutdownDistributedTPU>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ShutdownDistributedTPU {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ShutdownDistributedTPU {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ShutdownDistributedTPU {
    /// Creates a new `ShutdownDistributedTPU`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute shutdown_distributed_tpu.
    pub fn call<'a>(&self, ctx: &'a crate::eager::Context) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "ShutdownDistributedTPU")?;

        // Required input arguments

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `ShutdownDistributedTPU::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ShutdownDistributedTPU>
pub fn shutdown_distributed_tpu<'a>(ctx: &'a crate::eager::Context) -> crate::Result<()> {
    let op = ShutdownDistributedTPU::new();
    op.call(ctx)
}

/// ShutdownTPUSystem
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ShutdownTPUSystem>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ShutdownTPUSystem {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ShutdownTPUSystem {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ShutdownTPUSystem {
    /// Creates a new `ShutdownTPUSystem`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute shutdown_tpusystem.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ShutdownTPUSystem")?;

        // Required input arguments

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ShutdownTPUSystem::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ShutdownTPUSystem>
pub fn shutdown_tpusystem<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ShutdownTPUSystem::new();
    op.call(ctx)
}

/// Sigmoid
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Sigmoid>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Sigmoid {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Sigmoid {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Sigmoid {
    /// Creates a new `Sigmoid`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sigmoid.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Sigmoid")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Sigmoid::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Sigmoid>
pub fn sigmoid<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Sigmoid::new();
    op.call(ctx, x)
}

/// SigmoidGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SigmoidGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SigmoidGrad {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SigmoidGrad {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SigmoidGrad {
    /// Creates a new `SigmoidGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sigmoid_grad.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        y: &T0,
        dy: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SigmoidGrad")?;

        // Required input arguments
        op.add_input(&y.to_handle(ctx)?)?;
        op.add_input(&dy.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SigmoidGrad::new().call(&ctx, &y, &dy)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SigmoidGrad>
pub fn sigmoid_grad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    y: &T0,
    dy: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SigmoidGrad::new();
    op.call(ctx, y, dy)
}

/// Sign
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Sign>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Sign {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Sign {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Sign {
    /// Creates a new `Sign`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sign.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Sign")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Sign::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Sign>
pub fn sign<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Sign::new();
    op.call(ctx, x)
}

/// Sin
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Sin>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Sin {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Sin {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Sin {
    /// Creates a new `Sin`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sin.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Sin")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Sin::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Sin>
pub fn sin<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Sin::new();
    op.call(ctx, x)
}

/// Sinh
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Sinh>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Sinh {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Sinh {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Sinh {
    /// Creates a new `Sinh`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sinh.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Sinh")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Sinh::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Sinh>
pub fn sinh<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Sinh::new();
    op.call(ctx, x)
}

/// Size
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Size>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Size {
    out_type: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Size {
    fn default() -> Self {
        Self {
            out_type: Some(crate::DataType::Int32),
            target_device_name: None,
        }
    }
}
impl Size {
    /// Creates a new `Size`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_type` attribute.
    pub fn out_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute size.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Size")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_type {
            op.set_attr_type("out_type", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Size::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Size>
pub fn size<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Size::new();
    op.call(ctx, input)
}

/// SkipDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SkipDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SkipDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SkipDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl SkipDataset {
    /// Creates a new `SkipDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute skip_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        count: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SkipDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&count.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SkipDataset::new().call(&ctx, &input_dataset, &count)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SkipDataset>
pub fn skip_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    count: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SkipDataset::new();
    op.call(ctx, input_dataset, count)
}

/// Skipgram
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Skipgram>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Skipgram {
    filename: ::std::option::Option<::std::string::String>,
    batch_size: ::std::option::Option<i64>,
    window_size: ::std::option::Option<i64>,
    min_count: ::std::option::Option<i64>,
    subsample: ::std::option::Option<f32>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Skipgram {
    fn default() -> Self {
        Self {
            filename: None,
            batch_size: None,
            window_size: Some(5i64),
            min_count: Some(5i64),
            subsample: Some(0.001f32),
            target_device_name: None,
        }
    }
}
impl Skipgram {
    /// Creates a new `Skipgram`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `filename` attribute.
    pub fn filename<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.filename = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `batch_size` attribute.
    pub fn batch_size<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.batch_size = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `window_size` attribute.
    pub fn window_size<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.window_size = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `min_count` attribute.
    pub fn min_count<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.min_count = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `subsample` attribute.
    pub fn subsample<ArgType: ::std::convert::Into<f32>>(mut self, value: ArgType) -> Self {
        self.subsample = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute skipgram.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 7]> {
        // Define Op
        let mut op = super::Op::new(ctx, "Skipgram")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.filename {
            op.set_attr_string("filename", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.batch_size {
            op.set_attr_int("batch_size", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.window_size {
            op.set_attr_int("window_size", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.min_count {
            op.set_attr_int("min_count", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.subsample {
            op.set_attr_float("subsample", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<7>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `Skipgram::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Skipgram>
pub fn skipgram<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 7]> {
    let op = Skipgram::new();
    op.call(ctx)
}

/// SleepDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SleepDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SleepDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SleepDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl SleepDataset {
    /// Creates a new `SleepDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sleep_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        sleep_microseconds: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SleepDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&sleep_microseconds.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SleepDataset::new().call(&ctx, &input_dataset, &sleep_microseconds)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SleepDataset>
pub fn sleep_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    sleep_microseconds: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SleepDataset::new();
    op.call(ctx, input_dataset, sleep_microseconds)
}

/// Slice
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Slice>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Slice {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Slice {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Slice {
    /// Creates a new `Slice`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute slice.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        begin: &T1,
        size: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Slice")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&begin.to_handle(ctx)?)?;
        op.add_input(&size.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Slice::new().call(&ctx, &input, &begin, &size)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Slice>
pub fn slice<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    begin: &T1,
    size: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Slice::new();
    op.call(ctx, input, begin, size)
}

/// SlidingWindowDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SlidingWindowDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SlidingWindowDataset {
    drop_remainder: ::std::option::Option<bool>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SlidingWindowDataset {
    fn default() -> Self {
        Self {
            drop_remainder: Some(true),
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl SlidingWindowDataset {
    /// Creates a new `SlidingWindowDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `drop_remainder` attribute.
    pub fn drop_remainder<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.drop_remainder = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sliding_window_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        window_size: &T1,
        window_shift: &T2,
        window_stride: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SlidingWindowDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&window_size.to_handle(ctx)?)?;
        op.add_input(&window_shift.to_handle(ctx)?)?;
        op.add_input(&window_stride.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.drop_remainder {
            op.set_attr_bool("drop_remainder", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SlidingWindowDataset::new().call(&ctx, &input_dataset, &window_size, &window_shift, &window_stride)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SlidingWindowDataset>
pub fn sliding_window_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    window_size: &T1,
    window_shift: &T2,
    window_stride: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SlidingWindowDataset::new();
    op.call(ctx, input_dataset, window_size, window_shift, window_stride)
}

/// Snapshot
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Snapshot>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Snapshot {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Snapshot {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Snapshot {
    /// Creates a new `Snapshot`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute snapshot.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Snapshot")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Snapshot::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Snapshot>
pub fn snapshot<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Snapshot::new();
    op.call(ctx, input)
}

/// SnapshotDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SnapshotDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SnapshotDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    compression: ::std::option::Option<::std::string::String>,
    reader_path_prefix: ::std::option::Option<::std::string::String>,
    writer_path_prefix: ::std::option::Option<::std::string::String>,
    shard_size_bytes: ::std::option::Option<i64>,
    pending_snapshot_expiry_seconds: ::std::option::Option<i64>,
    num_reader_threads: ::std::option::Option<i64>,
    reader_buffer_size: ::std::option::Option<i64>,
    num_writer_threads: ::std::option::Option<i64>,
    writer_buffer_size: ::std::option::Option<i64>,
    shuffle_on_read: ::std::option::Option<bool>,
    seed: ::std::option::Option<i64>,
    seed2: ::std::option::Option<i64>,
    mode: ::std::option::Option<::std::string::String>,
    snapshot_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SnapshotDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            compression: None,
            reader_path_prefix: None,
            writer_path_prefix: None,
            shard_size_bytes: Some(10737418240i64),
            pending_snapshot_expiry_seconds: Some(86400i64),
            num_reader_threads: Some(1i64),
            reader_buffer_size: Some(1i64),
            num_writer_threads: Some(1i64),
            writer_buffer_size: Some(1i64),
            shuffle_on_read: Some(false),
            seed: Some(0i64),
            seed2: Some(0i64),
            mode: Some(::std::string::String::from("auto")),
            snapshot_name: None,
            target_device_name: None,
        }
    }
}
impl SnapshotDataset {
    /// Creates a new `SnapshotDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `compression` attribute.
    pub fn compression<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.compression = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `reader_path_prefix` attribute.
    pub fn reader_path_prefix<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.reader_path_prefix = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `writer_path_prefix` attribute.
    pub fn writer_path_prefix<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.writer_path_prefix = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shard_size_bytes` attribute.
    pub fn shard_size_bytes<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.shard_size_bytes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `pending_snapshot_expiry_seconds` attribute.
    pub fn pending_snapshot_expiry_seconds<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.pending_snapshot_expiry_seconds = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_reader_threads` attribute.
    pub fn num_reader_threads<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.num_reader_threads = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `reader_buffer_size` attribute.
    pub fn reader_buffer_size<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.reader_buffer_size = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_writer_threads` attribute.
    pub fn num_writer_threads<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.num_writer_threads = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `writer_buffer_size` attribute.
    pub fn writer_buffer_size<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.writer_buffer_size = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shuffle_on_read` attribute.
    pub fn shuffle_on_read<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.shuffle_on_read = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed` attribute.
    pub fn seed<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed2` attribute.
    pub fn seed2<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `mode` attribute.
    pub fn mode<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.mode = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `snapshot_name` attribute.
    pub fn snapshot_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.snapshot_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute snapshot_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        path: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SnapshotDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&path.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.compression {
            op.set_attr_string("compression", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.reader_path_prefix {
            op.set_attr_string("reader_path_prefix", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.writer_path_prefix {
            op.set_attr_string("writer_path_prefix", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shard_size_bytes {
            op.set_attr_int("shard_size_bytes", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.pending_snapshot_expiry_seconds {
            op.set_attr_int("pending_snapshot_expiry_seconds", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_reader_threads {
            op.set_attr_int("num_reader_threads", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.reader_buffer_size {
            op.set_attr_int("reader_buffer_size", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_writer_threads {
            op.set_attr_int("num_writer_threads", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.writer_buffer_size {
            op.set_attr_int("writer_buffer_size", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shuffle_on_read {
            op.set_attr_bool("shuffle_on_read", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed {
            op.set_attr_int("seed", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed2 {
            op.set_attr_int("seed2", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.mode {
            op.set_attr_string("mode", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.snapshot_name {
            op.set_attr_string("snapshot_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SnapshotDataset::new().call(&ctx, &input_dataset, &path)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SnapshotDataset>
pub fn snapshot_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    path: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SnapshotDataset::new();
    op.call(ctx, input_dataset, path)
}

/// SnapshotDatasetReader
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SnapshotDatasetReader>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SnapshotDatasetReader {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    compression: ::std::option::Option<::std::string::String>,
    version: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SnapshotDatasetReader {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            compression: None,
            version: None,
            target_device_name: None,
        }
    }
}
impl SnapshotDatasetReader {
    /// Creates a new `SnapshotDatasetReader`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `compression` attribute.
    pub fn compression<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.compression = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `version` attribute.
    pub fn version<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.version = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute snapshot_dataset_reader.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        shard_dir: &T0,
        start_index: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SnapshotDatasetReader")?;

        // Required input arguments
        op.add_input(&shard_dir.to_handle(ctx)?)?;
        op.add_input(&start_index.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.compression {
            op.set_attr_string("compression", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.version {
            op.set_attr_int("version", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SnapshotDatasetReader::new().call(&ctx, &shard_dir, &start_index)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SnapshotDatasetReader>
pub fn snapshot_dataset_reader<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    shard_dir: &T0,
    start_index: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SnapshotDatasetReader::new();
    op.call(ctx, shard_dir, start_index)
}

/// SnapshotDatasetV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SnapshotDatasetV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SnapshotDatasetV2 {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    compression: ::std::option::Option<::std::string::String>,
    reader_prefix: ::std::option::Option<::std::string::String>,
    writer_prefix: ::std::option::Option<::std::string::String>,
    hash_valid: ::std::option::Option<bool>,
    hash: ::std::option::Option<i64>,
    reader_func: ::std::option::Option<::std::string::String>,
    shard_func: ::std::option::Option<::std::string::String>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SnapshotDatasetV2 {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            compression: None,
            reader_prefix: None,
            writer_prefix: None,
            hash_valid: Some(false),
            hash: Some(0i64),
            reader_func: None,
            shard_func: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl SnapshotDatasetV2 {
    /// Creates a new `SnapshotDatasetV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `compression` attribute.
    pub fn compression<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.compression = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `reader_prefix` attribute.
    pub fn reader_prefix<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.reader_prefix = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `writer_prefix` attribute.
    pub fn writer_prefix<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.writer_prefix = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `hash_valid` attribute.
    pub fn hash_valid<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.hash_valid = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `hash` attribute.
    pub fn hash<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.hash = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `reader_func` attribute.
    pub fn reader_func<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.reader_func = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shard_func` attribute.
    pub fn shard_func<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shard_func = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute snapshot_dataset_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        path: &T1,
        reader_func_other_args: &T2,
        shard_func_other_args: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SnapshotDatasetV2")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&path.to_handle(ctx)?)?;
        op.add_input(&reader_func_other_args.to_handle(ctx)?)?;
        op.add_input(&shard_func_other_args.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.compression {
            op.set_attr_string("compression", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.reader_prefix {
            op.set_attr_string("reader_prefix", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.writer_prefix {
            op.set_attr_string("writer_prefix", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.hash_valid {
            op.set_attr_bool("hash_valid", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.hash {
            op.set_attr_int("hash", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.reader_func {
            op.set_attr_string("reader_func", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shard_func {
            op.set_attr_string("shard_func", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SnapshotDatasetV2::new().call(&ctx, &input_dataset, &path, &reader_func_other_args, &shard_func_other_args)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SnapshotDatasetV2>
pub fn snapshot_dataset_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    path: &T1,
    reader_func_other_args: &T2,
    shard_func_other_args: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SnapshotDatasetV2::new();
    op.call(
        ctx,
        input_dataset,
        path,
        reader_func_other_args,
        shard_func_other_args,
    )
}

/// SnapshotNestedDatasetReader
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SnapshotNestedDatasetReader>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SnapshotNestedDatasetReader {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SnapshotNestedDatasetReader {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl SnapshotNestedDatasetReader {
    /// Creates a new `SnapshotNestedDatasetReader`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute snapshot_nested_dataset_reader.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        inputs: &[&T0],
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SnapshotNestedDatasetReader")?;

        // Required input arguments
        let mut inputs_list = Vec::new();

        for t in inputs {
            inputs_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&inputs_list)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SnapshotNestedDatasetReader::new().call(&ctx, &inputs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SnapshotNestedDatasetReader>
pub fn snapshot_nested_dataset_reader<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    inputs: &[&T0],
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SnapshotNestedDatasetReader::new();
    op.call(ctx, inputs)
}

/// SobolSample
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SobolSample>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SobolSample {
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SobolSample {
    fn default() -> Self {
        Self {
            dtype: Some(crate::DataType::Float),
            target_device_name: None,
        }
    }
}
impl SobolSample {
    /// Creates a new `SobolSample`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sobol_sample.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        dim: &T0,
        num_results: &T1,
        skip: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SobolSample")?;

        // Required input arguments
        op.add_input(&dim.to_handle(ctx)?)?;
        op.add_input(&num_results.to_handle(ctx)?)?;
        op.add_input(&skip.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SobolSample::new().call(&ctx, &dim, &num_results, &skip)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SobolSample>
pub fn sobol_sample<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    dim: &T0,
    num_results: &T1,
    skip: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SobolSample::new();
    op.call(ctx, dim, num_results, skip)
}

/// Softmax
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Softmax>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Softmax {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Softmax {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Softmax {
    /// Creates a new `Softmax`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute softmax.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        logits: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Softmax")?;

        // Required input arguments
        op.add_input(&logits.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Softmax::new().call(&ctx, &logits)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Softmax>
pub fn softmax<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    logits: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Softmax::new();
    op.call(ctx, logits)
}

/// SoftmaxCrossEntropyWithLogits
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SoftmaxCrossEntropyWithLogits>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SoftmaxCrossEntropyWithLogits {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SoftmaxCrossEntropyWithLogits {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SoftmaxCrossEntropyWithLogits {
    /// Creates a new `SoftmaxCrossEntropyWithLogits`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute softmax_cross_entropy_with_logits.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        features: &T0,
        labels: &T1,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "SoftmaxCrossEntropyWithLogits")?;

        // Required input arguments
        op.add_input(&features.to_handle(ctx)?)?;
        op.add_input(&labels.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `SoftmaxCrossEntropyWithLogits::new().call(&ctx, &features, &labels)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SoftmaxCrossEntropyWithLogits>
pub fn softmax_cross_entropy_with_logits<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    features: &T0,
    labels: &T1,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = SoftmaxCrossEntropyWithLogits::new();
    op.call(ctx, features, labels)
}

/// Softplus
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Softplus>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Softplus {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Softplus {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Softplus {
    /// Creates a new `Softplus`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute softplus.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        features: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Softplus")?;

        // Required input arguments
        op.add_input(&features.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Softplus::new().call(&ctx, &features)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Softplus>
pub fn softplus<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    features: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Softplus::new();
    op.call(ctx, features)
}

/// SoftplusGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SoftplusGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SoftplusGrad {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SoftplusGrad {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SoftplusGrad {
    /// Creates a new `SoftplusGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute softplus_grad.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        gradients: &T0,
        features: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SoftplusGrad")?;

        // Required input arguments
        op.add_input(&gradients.to_handle(ctx)?)?;
        op.add_input(&features.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SoftplusGrad::new().call(&ctx, &gradients, &features)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SoftplusGrad>
pub fn softplus_grad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    gradients: &T0,
    features: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SoftplusGrad::new();
    op.call(ctx, gradients, features)
}

/// Softsign
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Softsign>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Softsign {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Softsign {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Softsign {
    /// Creates a new `Softsign`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute softsign.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        features: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Softsign")?;

        // Required input arguments
        op.add_input(&features.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Softsign::new().call(&ctx, &features)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Softsign>
pub fn softsign<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    features: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Softsign::new();
    op.call(ctx, features)
}

/// SoftsignGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SoftsignGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SoftsignGrad {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SoftsignGrad {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SoftsignGrad {
    /// Creates a new `SoftsignGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute softsign_grad.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        gradients: &T0,
        features: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SoftsignGrad")?;

        // Required input arguments
        op.add_input(&gradients.to_handle(ctx)?)?;
        op.add_input(&features.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SoftsignGrad::new().call(&ctx, &gradients, &features)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SoftsignGrad>
pub fn softsign_grad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    gradients: &T0,
    features: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SoftsignGrad::new();
    op.call(ctx, gradients, features)
}

/// SpaceToBatch
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SpaceToBatch>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SpaceToBatch {
    block_size: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SpaceToBatch {
    fn default() -> Self {
        Self {
            block_size: None,
            target_device_name: None,
        }
    }
}
impl SpaceToBatch {
    /// Creates a new `SpaceToBatch`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `block_size` attribute.
    pub fn block_size<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.block_size = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute space_to_batch.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        paddings: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SpaceToBatch")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&paddings.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.block_size {
            op.set_attr_int("block_size", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SpaceToBatch::new().call(&ctx, &input, &paddings)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SpaceToBatch>
pub fn space_to_batch<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    paddings: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SpaceToBatch::new();
    op.call(ctx, input, paddings)
}

/// SpaceToBatchND
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SpaceToBatchND>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SpaceToBatchND {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SpaceToBatchND {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SpaceToBatchND {
    /// Creates a new `SpaceToBatchND`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute space_to_batch_nd.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        block_shape: &T1,
        paddings: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SpaceToBatchND")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&block_shape.to_handle(ctx)?)?;
        op.add_input(&paddings.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SpaceToBatchND::new().call(&ctx, &input, &block_shape, &paddings)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SpaceToBatchND>
pub fn space_to_batch_nd<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    block_shape: &T1,
    paddings: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SpaceToBatchND::new();
    op.call(ctx, input, block_shape, paddings)
}

/// SpaceToDepth
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SpaceToDepth>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SpaceToDepth {
    block_size: ::std::option::Option<i64>,
    data_format: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SpaceToDepth {
    fn default() -> Self {
        Self {
            block_size: None,
            data_format: Some(::std::string::String::from("NHWC")),
            target_device_name: None,
        }
    }
}
impl SpaceToDepth {
    /// Creates a new `SpaceToDepth`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `block_size` attribute.
    pub fn block_size<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.block_size = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `data_format` attribute.
    pub fn data_format<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.data_format = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute space_to_depth.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SpaceToDepth")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.block_size {
            op.set_attr_int("block_size", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.data_format {
            op.set_attr_string("data_format", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SpaceToDepth::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SpaceToDepth>
pub fn space_to_depth<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SpaceToDepth::new();
    op.call(ctx, input)
}

/// SparseAccumulatorApplyGradient
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseAccumulatorApplyGradient>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseAccumulatorApplyGradient {
    has_known_shape: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseAccumulatorApplyGradient {
    fn default() -> Self {
        Self {
            has_known_shape: None,
            target_device_name: None,
        }
    }
}
impl SparseAccumulatorApplyGradient {
    /// Creates a new `SparseAccumulatorApplyGradient`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `has_known_shape` attribute.
    pub fn has_known_shape<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.has_known_shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_accumulator_apply_gradient.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        local_step: &T1,
        gradient_indices: &T2,
        gradient_values: &T3,
        gradient_shape: &T4,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseAccumulatorApplyGradient")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&local_step.to_handle(ctx)?)?;
        op.add_input(&gradient_indices.to_handle(ctx)?)?;
        op.add_input(&gradient_values.to_handle(ctx)?)?;
        op.add_input(&gradient_shape.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.has_known_shape {
            op.set_attr_bool("has_known_shape", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `SparseAccumulatorApplyGradient::new().call(&ctx, &handle, &local_step, &gradient_indices, &gradient_values, &gradient_shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseAccumulatorApplyGradient>
pub fn sparse_accumulator_apply_gradient<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    local_step: &T1,
    gradient_indices: &T2,
    gradient_values: &T3,
    gradient_shape: &T4,
) -> crate::Result<()> {
    let op = SparseAccumulatorApplyGradient::new();
    op.call(
        ctx,
        handle,
        local_step,
        gradient_indices,
        gradient_values,
        gradient_shape,
    )
}

/// SparseAccumulatorTakeGradient
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseAccumulatorTakeGradient>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseAccumulatorTakeGradient {
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseAccumulatorTakeGradient {
    fn default() -> Self {
        Self {
            dtype: None,
            target_device_name: None,
        }
    }
}
impl SparseAccumulatorTakeGradient {
    /// Creates a new `SparseAccumulatorTakeGradient`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_accumulator_take_gradient.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        num_required: &T1,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseAccumulatorTakeGradient")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&num_required.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `SparseAccumulatorTakeGradient::new().call(&ctx, &handle, &num_required)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseAccumulatorTakeGradient>
pub fn sparse_accumulator_take_gradient<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    num_required: &T1,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = SparseAccumulatorTakeGradient::new();
    op.call(ctx, handle, num_required)
}

/// SparseAdd
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseAdd>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseAdd {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseAdd {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SparseAdd {
    /// Creates a new `SparseAdd`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_add.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        a_indices: &T0,
        a_values: &T1,
        a_shape: &T2,
        b_indices: &T3,
        b_values: &T4,
        b_shape: &T5,
        thresh: &T6,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseAdd")?;

        // Required input arguments
        op.add_input(&a_indices.to_handle(ctx)?)?;
        op.add_input(&a_values.to_handle(ctx)?)?;
        op.add_input(&a_shape.to_handle(ctx)?)?;
        op.add_input(&b_indices.to_handle(ctx)?)?;
        op.add_input(&b_values.to_handle(ctx)?)?;
        op.add_input(&b_shape.to_handle(ctx)?)?;
        op.add_input(&thresh.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `SparseAdd::new().call(&ctx, &a_indices, &a_values, &a_shape, &b_indices, &b_values, &b_shape, &thresh)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseAdd>
pub fn sparse_add<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    a_indices: &T0,
    a_values: &T1,
    a_shape: &T2,
    b_indices: &T3,
    b_values: &T4,
    b_shape: &T5,
    thresh: &T6,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = SparseAdd::new();
    op.call(
        ctx, a_indices, a_values, a_shape, b_indices, b_values, b_shape, thresh,
    )
}

/// SparseAddGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseAddGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseAddGrad {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseAddGrad {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SparseAddGrad {
    /// Creates a new `SparseAddGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_add_grad.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        backprop_val_grad: &T0,
        a_indices: &T1,
        b_indices: &T2,
        sum_indices: &T3,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseAddGrad")?;

        // Required input arguments
        op.add_input(&backprop_val_grad.to_handle(ctx)?)?;
        op.add_input(&a_indices.to_handle(ctx)?)?;
        op.add_input(&b_indices.to_handle(ctx)?)?;
        op.add_input(&sum_indices.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `SparseAddGrad::new().call(&ctx, &backprop_val_grad, &a_indices, &b_indices, &sum_indices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseAddGrad>
pub fn sparse_add_grad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    backprop_val_grad: &T0,
    a_indices: &T1,
    b_indices: &T2,
    sum_indices: &T3,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = SparseAddGrad::new();
    op.call(ctx, backprop_val_grad, a_indices, b_indices, sum_indices)
}

/// SparseApplyAdadelta
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseApplyAdadelta>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseApplyAdadelta {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseApplyAdadelta {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl SparseApplyAdadelta {
    /// Creates a new `SparseApplyAdadelta`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_apply_adadelta.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        accum: &T1,
        accum_update: &T2,
        lr: &T3,
        rho: &T4,
        epsilon: &T5,
        grad: &T6,
        indices: &T7,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseApplyAdadelta")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&accum.to_handle(ctx)?)?;
        op.add_input(&accum_update.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&rho.to_handle(ctx)?)?;
        op.add_input(&epsilon.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseApplyAdadelta::new().call(&ctx, &var, &accum, &accum_update, &lr, &rho, &epsilon, &grad, &indices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseApplyAdadelta>
pub fn sparse_apply_adadelta<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    accum: &T1,
    accum_update: &T2,
    lr: &T3,
    rho: &T4,
    epsilon: &T5,
    grad: &T6,
    indices: &T7,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseApplyAdadelta::new();
    op.call(
        ctx,
        var,
        accum,
        accum_update,
        lr,
        rho,
        epsilon,
        grad,
        indices,
    )
}

/// SparseApplyAdagrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseApplyAdagrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseApplyAdagrad {
    use_locking: ::std::option::Option<bool>,
    update_slots: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseApplyAdagrad {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            update_slots: Some(true),
            target_device_name: None,
        }
    }
}
impl SparseApplyAdagrad {
    /// Creates a new `SparseApplyAdagrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `update_slots` attribute.
    pub fn update_slots<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.update_slots = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_apply_adagrad.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        accum: &T1,
        lr: &T2,
        grad: &T3,
        indices: &T4,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseApplyAdagrad")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&accum.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.update_slots {
            op.set_attr_bool("update_slots", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseApplyAdagrad::new().call(&ctx, &var, &accum, &lr, &grad, &indices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseApplyAdagrad>
pub fn sparse_apply_adagrad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    accum: &T1,
    lr: &T2,
    grad: &T3,
    indices: &T4,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseApplyAdagrad::new();
    op.call(ctx, var, accum, lr, grad, indices)
}

/// SparseApplyAdagradDA
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseApplyAdagradDA>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseApplyAdagradDA {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseApplyAdagradDA {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl SparseApplyAdagradDA {
    /// Creates a new `SparseApplyAdagradDA`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_apply_adagrad_da.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        gradient_accumulator: &T1,
        gradient_squared_accumulator: &T2,
        grad: &T3,
        indices: &T4,
        lr: &T5,
        l1: &T6,
        l2: &T7,
        global_step: &T8,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseApplyAdagradDA")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&gradient_accumulator.to_handle(ctx)?)?;
        op.add_input(&gradient_squared_accumulator.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&l1.to_handle(ctx)?)?;
        op.add_input(&l2.to_handle(ctx)?)?;
        op.add_input(&global_step.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseApplyAdagradDA::new().call(&ctx, &var, &gradient_accumulator, &gradient_squared_accumulator, &grad, &indices, &lr, &l1, &l2, &global_step)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseApplyAdagradDA>
pub fn sparse_apply_adagrad_da<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    gradient_accumulator: &T1,
    gradient_squared_accumulator: &T2,
    grad: &T3,
    indices: &T4,
    lr: &T5,
    l1: &T6,
    l2: &T7,
    global_step: &T8,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseApplyAdagradDA::new();
    op.call(
        ctx,
        var,
        gradient_accumulator,
        gradient_squared_accumulator,
        grad,
        indices,
        lr,
        l1,
        l2,
        global_step,
    )
}

/// SparseApplyAdagradV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseApplyAdagradV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseApplyAdagradV2 {
    use_locking: ::std::option::Option<bool>,
    update_slots: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseApplyAdagradV2 {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            update_slots: Some(true),
            target_device_name: None,
        }
    }
}
impl SparseApplyAdagradV2 {
    /// Creates a new `SparseApplyAdagradV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `update_slots` attribute.
    pub fn update_slots<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.update_slots = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_apply_adagrad_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        accum: &T1,
        lr: &T2,
        epsilon: &T3,
        grad: &T4,
        indices: &T5,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseApplyAdagradV2")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&accum.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&epsilon.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.update_slots {
            op.set_attr_bool("update_slots", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseApplyAdagradV2::new().call(&ctx, &var, &accum, &lr, &epsilon, &grad, &indices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseApplyAdagradV2>
pub fn sparse_apply_adagrad_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    accum: &T1,
    lr: &T2,
    epsilon: &T3,
    grad: &T4,
    indices: &T5,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseApplyAdagradV2::new();
    op.call(ctx, var, accum, lr, epsilon, grad, indices)
}

/// SparseApplyCenteredRMSProp
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseApplyCenteredRMSProp>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseApplyCenteredRMSProp {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseApplyCenteredRMSProp {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl SparseApplyCenteredRMSProp {
    /// Creates a new `SparseApplyCenteredRMSProp`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_apply_centered_rmsprop.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
        T9: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        mg: &T1,
        ms: &T2,
        mom: &T3,
        lr: &T4,
        rho: &T5,
        momentum: &T6,
        epsilon: &T7,
        grad: &T8,
        indices: &T9,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseApplyCenteredRMSProp")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&mg.to_handle(ctx)?)?;
        op.add_input(&ms.to_handle(ctx)?)?;
        op.add_input(&mom.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&rho.to_handle(ctx)?)?;
        op.add_input(&momentum.to_handle(ctx)?)?;
        op.add_input(&epsilon.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseApplyCenteredRMSProp::new().call(&ctx, &var, &mg, &ms, &mom, &lr, &rho, &momentum, &epsilon, &grad, &indices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseApplyCenteredRMSProp>
pub fn sparse_apply_centered_rmsprop<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
    T9: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    mg: &T1,
    ms: &T2,
    mom: &T3,
    lr: &T4,
    rho: &T5,
    momentum: &T6,
    epsilon: &T7,
    grad: &T8,
    indices: &T9,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseApplyCenteredRMSProp::new();
    op.call(
        ctx, var, mg, ms, mom, lr, rho, momentum, epsilon, grad, indices,
    )
}

/// SparseApplyFtrl
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseApplyFtrl>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseApplyFtrl {
    use_locking: ::std::option::Option<bool>,
    multiply_linear_by_lr: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseApplyFtrl {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            multiply_linear_by_lr: Some(false),
            target_device_name: None,
        }
    }
}
impl SparseApplyFtrl {
    /// Creates a new `SparseApplyFtrl`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `multiply_linear_by_lr` attribute.
    pub fn multiply_linear_by_lr<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.multiply_linear_by_lr = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_apply_ftrl.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        accum: &T1,
        linear: &T2,
        grad: &T3,
        indices: &T4,
        lr: &T5,
        l1: &T6,
        l2: &T7,
        lr_power: &T8,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseApplyFtrl")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&accum.to_handle(ctx)?)?;
        op.add_input(&linear.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&l1.to_handle(ctx)?)?;
        op.add_input(&l2.to_handle(ctx)?)?;
        op.add_input(&lr_power.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.multiply_linear_by_lr {
            op.set_attr_bool("multiply_linear_by_lr", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseApplyFtrl::new().call(&ctx, &var, &accum, &linear, &grad, &indices, &lr, &l1, &l2, &lr_power)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseApplyFtrl>
pub fn sparse_apply_ftrl<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    accum: &T1,
    linear: &T2,
    grad: &T3,
    indices: &T4,
    lr: &T5,
    l1: &T6,
    l2: &T7,
    lr_power: &T8,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseApplyFtrl::new();
    op.call(ctx, var, accum, linear, grad, indices, lr, l1, l2, lr_power)
}

/// SparseApplyFtrlV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseApplyFtrlV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseApplyFtrlV2 {
    use_locking: ::std::option::Option<bool>,
    multiply_linear_by_lr: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseApplyFtrlV2 {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            multiply_linear_by_lr: Some(false),
            target_device_name: None,
        }
    }
}
impl SparseApplyFtrlV2 {
    /// Creates a new `SparseApplyFtrlV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `multiply_linear_by_lr` attribute.
    pub fn multiply_linear_by_lr<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.multiply_linear_by_lr = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_apply_ftrl_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
        T9: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        accum: &T1,
        linear: &T2,
        grad: &T3,
        indices: &T4,
        lr: &T5,
        l1: &T6,
        l2: &T7,
        l2_shrinkage: &T8,
        lr_power: &T9,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseApplyFtrlV2")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&accum.to_handle(ctx)?)?;
        op.add_input(&linear.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&l1.to_handle(ctx)?)?;
        op.add_input(&l2.to_handle(ctx)?)?;
        op.add_input(&l2_shrinkage.to_handle(ctx)?)?;
        op.add_input(&lr_power.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.multiply_linear_by_lr {
            op.set_attr_bool("multiply_linear_by_lr", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseApplyFtrlV2::new().call(&ctx, &var, &accum, &linear, &grad, &indices, &lr, &l1, &l2, &l2_shrinkage, &lr_power)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseApplyFtrlV2>
pub fn sparse_apply_ftrl_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
    T9: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    accum: &T1,
    linear: &T2,
    grad: &T3,
    indices: &T4,
    lr: &T5,
    l1: &T6,
    l2: &T7,
    l2_shrinkage: &T8,
    lr_power: &T9,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseApplyFtrlV2::new();
    op.call(
        ctx,
        var,
        accum,
        linear,
        grad,
        indices,
        lr,
        l1,
        l2,
        l2_shrinkage,
        lr_power,
    )
}

/// SparseApplyMomentum
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseApplyMomentum>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseApplyMomentum {
    use_locking: ::std::option::Option<bool>,
    use_nesterov: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseApplyMomentum {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            use_nesterov: Some(false),
            target_device_name: None,
        }
    }
}
impl SparseApplyMomentum {
    /// Creates a new `SparseApplyMomentum`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_nesterov` attribute.
    pub fn use_nesterov<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_nesterov = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_apply_momentum.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        accum: &T1,
        lr: &T2,
        grad: &T3,
        indices: &T4,
        momentum: &T5,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseApplyMomentum")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&accum.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&momentum.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_nesterov {
            op.set_attr_bool("use_nesterov", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseApplyMomentum::new().call(&ctx, &var, &accum, &lr, &grad, &indices, &momentum)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseApplyMomentum>
pub fn sparse_apply_momentum<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    accum: &T1,
    lr: &T2,
    grad: &T3,
    indices: &T4,
    momentum: &T5,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseApplyMomentum::new();
    op.call(ctx, var, accum, lr, grad, indices, momentum)
}

/// SparseApplyProximalAdagrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseApplyProximalAdagrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseApplyProximalAdagrad {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseApplyProximalAdagrad {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl SparseApplyProximalAdagrad {
    /// Creates a new `SparseApplyProximalAdagrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_apply_proximal_adagrad.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        accum: &T1,
        lr: &T2,
        l1: &T3,
        l2: &T4,
        grad: &T5,
        indices: &T6,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseApplyProximalAdagrad")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&accum.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&l1.to_handle(ctx)?)?;
        op.add_input(&l2.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseApplyProximalAdagrad::new().call(&ctx, &var, &accum, &lr, &l1, &l2, &grad, &indices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseApplyProximalAdagrad>
pub fn sparse_apply_proximal_adagrad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    accum: &T1,
    lr: &T2,
    l1: &T3,
    l2: &T4,
    grad: &T5,
    indices: &T6,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseApplyProximalAdagrad::new();
    op.call(ctx, var, accum, lr, l1, l2, grad, indices)
}

/// SparseApplyProximalGradientDescent
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseApplyProximalGradientDescent>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseApplyProximalGradientDescent {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseApplyProximalGradientDescent {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl SparseApplyProximalGradientDescent {
    /// Creates a new `SparseApplyProximalGradientDescent`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_apply_proximal_gradient_descent.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        alpha: &T1,
        l1: &T2,
        l2: &T3,
        grad: &T4,
        indices: &T5,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseApplyProximalGradientDescent")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&alpha.to_handle(ctx)?)?;
        op.add_input(&l1.to_handle(ctx)?)?;
        op.add_input(&l2.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseApplyProximalGradientDescent::new().call(&ctx, &var, &alpha, &l1, &l2, &grad, &indices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseApplyProximalGradientDescent>
pub fn sparse_apply_proximal_gradient_descent<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    alpha: &T1,
    l1: &T2,
    l2: &T3,
    grad: &T4,
    indices: &T5,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseApplyProximalGradientDescent::new();
    op.call(ctx, var, alpha, l1, l2, grad, indices)
}

/// SparseApplyRMSProp
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseApplyRMSProp>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseApplyRMSProp {
    use_locking: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseApplyRMSProp {
    fn default() -> Self {
        Self {
            use_locking: Some(false),
            target_device_name: None,
        }
    }
}
impl SparseApplyRMSProp {
    /// Creates a new `SparseApplyRMSProp`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `use_locking` attribute.
    pub fn use_locking<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_locking = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_apply_rmsprop.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
        T8: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        var: &T0,
        ms: &T1,
        mom: &T2,
        lr: &T3,
        rho: &T4,
        momentum: &T5,
        epsilon: &T6,
        grad: &T7,
        indices: &T8,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseApplyRMSProp")?;

        // Required input arguments
        op.add_input(&var.to_handle(ctx)?)?;
        op.add_input(&ms.to_handle(ctx)?)?;
        op.add_input(&mom.to_handle(ctx)?)?;
        op.add_input(&lr.to_handle(ctx)?)?;
        op.add_input(&rho.to_handle(ctx)?)?;
        op.add_input(&momentum.to_handle(ctx)?)?;
        op.add_input(&epsilon.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.use_locking {
            op.set_attr_bool("use_locking", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseApplyRMSProp::new().call(&ctx, &var, &ms, &mom, &lr, &rho, &momentum, &epsilon, &grad, &indices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseApplyRMSProp>
pub fn sparse_apply_rmsprop<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
    T8: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    var: &T0,
    ms: &T1,
    mom: &T2,
    lr: &T3,
    rho: &T4,
    momentum: &T5,
    epsilon: &T6,
    grad: &T7,
    indices: &T8,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseApplyRMSProp::new();
    op.call(ctx, var, ms, mom, lr, rho, momentum, epsilon, grad, indices)
}

/// SparseBincount
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseBincount>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseBincount {
    binary_output: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseBincount {
    fn default() -> Self {
        Self {
            binary_output: Some(false),
            target_device_name: None,
        }
    }
}
impl SparseBincount {
    /// Creates a new `SparseBincount`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `binary_output` attribute.
    pub fn binary_output<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.binary_output = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_bincount.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        indices: &T0,
        values: &T1,
        dense_shape: &T2,
        size: &T3,
        weights: &T4,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseBincount")?;

        // Required input arguments
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&values.to_handle(ctx)?)?;
        op.add_input(&dense_shape.to_handle(ctx)?)?;
        op.add_input(&size.to_handle(ctx)?)?;
        op.add_input(&weights.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.binary_output {
            op.set_attr_bool("binary_output", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseBincount::new().call(&ctx, &indices, &values, &dense_shape, &size, &weights)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseBincount>
pub fn sparse_bincount<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    indices: &T0,
    values: &T1,
    dense_shape: &T2,
    size: &T3,
    weights: &T4,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseBincount::new();
    op.call(ctx, indices, values, dense_shape, size, weights)
}

/// SparseConcat
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseConcat>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseConcat {
    concat_dim: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseConcat {
    fn default() -> Self {
        Self {
            concat_dim: None,
            target_device_name: None,
        }
    }
}
impl SparseConcat {
    /// Creates a new `SparseConcat`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `concat_dim` attribute.
    pub fn concat_dim<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.concat_dim = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_concat.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        indices: &[&T0],
        values: &[&T1],
        shapes: &[&T2],
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseConcat")?;

        // Required input arguments
        let mut indices_list = Vec::new();

        for t in indices {
            indices_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&indices_list)?;
        let mut values_list = Vec::new();

        for t in values {
            values_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&values_list)?;
        let mut shapes_list = Vec::new();

        for t in shapes {
            shapes_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&shapes_list)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.concat_dim {
            op.set_attr_int("concat_dim", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `SparseConcat::new().call(&ctx, &indices, &values, &shapes)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseConcat>
pub fn sparse_concat<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    indices: &[&T0],
    values: &[&T1],
    shapes: &[&T2],
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = SparseConcat::new();
    op.call(ctx, indices, values, shapes)
}

/// SparseConditionalAccumulator
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseConditionalAccumulator>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseConditionalAccumulator {
    dtype: ::std::option::Option<crate::DataType>,
    shape: ::std::option::Option<crate::Shape>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    reduction_type: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseConditionalAccumulator {
    fn default() -> Self {
        Self {
            dtype: None,
            shape: None,
            container: None,
            shared_name: None,
            reduction_type: Some(::std::string::String::from("MEAN")),
            target_device_name: None,
        }
    }
}
impl SparseConditionalAccumulator {
    /// Creates a new `SparseConditionalAccumulator`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shape` attribute.
    pub fn shape<ArgType: ::std::convert::Into<crate::Shape>>(mut self, value: ArgType) -> Self {
        self.shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `reduction_type` attribute.
    pub fn reduction_type<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.reduction_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_conditional_accumulator.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseConditionalAccumulator")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shape {
            op.set_attr_shape("shape", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.reduction_type {
            op.set_attr_string("reduction_type", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseConditionalAccumulator::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseConditionalAccumulator>
pub fn sparse_conditional_accumulator<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseConditionalAccumulator::new();
    op.call(ctx)
}

/// SparseCountSparseOutput
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseCountSparseOutput>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseCountSparseOutput {
    minlength: ::std::option::Option<i64>,
    maxlength: ::std::option::Option<i64>,
    binary_output: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseCountSparseOutput {
    fn default() -> Self {
        Self {
            minlength: Some(-1i64),
            maxlength: Some(-1i64),
            binary_output: None,
            target_device_name: None,
        }
    }
}
impl SparseCountSparseOutput {
    /// Creates a new `SparseCountSparseOutput`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `minlength` attribute.
    pub fn minlength<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.minlength = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `maxlength` attribute.
    pub fn maxlength<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.maxlength = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `binary_output` attribute.
    pub fn binary_output<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.binary_output = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_count_sparse_output.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        indices: &T0,
        values: &T1,
        dense_shape: &T2,
        weights: &T3,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseCountSparseOutput")?;

        // Required input arguments
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&values.to_handle(ctx)?)?;
        op.add_input(&dense_shape.to_handle(ctx)?)?;
        op.add_input(&weights.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.minlength {
            op.set_attr_int("minlength", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.maxlength {
            op.set_attr_int("maxlength", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.binary_output {
            op.set_attr_bool("binary_output", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `SparseCountSparseOutput::new().call(&ctx, &indices, &values, &dense_shape, &weights)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseCountSparseOutput>
pub fn sparse_count_sparse_output<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    indices: &T0,
    values: &T1,
    dense_shape: &T2,
    weights: &T3,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = SparseCountSparseOutput::new();
    op.call(ctx, indices, values, dense_shape, weights)
}

/// SparseCross
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseCross>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseCross {
    hashed_output: ::std::option::Option<bool>,
    num_buckets: ::std::option::Option<i64>,
    hash_key: ::std::option::Option<i64>,
    out_type: ::std::option::Option<crate::DataType>,
    internal_type: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseCross {
    fn default() -> Self {
        Self {
            hashed_output: None,
            num_buckets: None,
            hash_key: None,
            out_type: None,
            internal_type: None,
            target_device_name: None,
        }
    }
}
impl SparseCross {
    /// Creates a new `SparseCross`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `hashed_output` attribute.
    pub fn hashed_output<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.hashed_output = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_buckets` attribute.
    pub fn num_buckets<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_buckets = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `hash_key` attribute.
    pub fn hash_key<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.hash_key = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `out_type` attribute.
    pub fn out_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `internal_type` attribute.
    pub fn internal_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.internal_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_cross.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        indices: &[&T0],
        values: &T1,
        shapes: &[&T2],
        dense_inputs: &T3,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseCross")?;

        // Required input arguments
        let mut indices_list = Vec::new();

        for t in indices {
            indices_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&indices_list)?;
        op.add_input(&values.to_handle(ctx)?)?;
        let mut shapes_list = Vec::new();

        for t in shapes {
            shapes_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&shapes_list)?;
        op.add_input(&dense_inputs.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.hashed_output {
            op.set_attr_bool("hashed_output", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_buckets {
            op.set_attr_int("num_buckets", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.hash_key {
            op.set_attr_int("hash_key", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.out_type {
            op.set_attr_type("out_type", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.internal_type {
            op.set_attr_type("internal_type", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `SparseCross::new().call(&ctx, &indices, &values, &shapes, &dense_inputs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseCross>
pub fn sparse_cross<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    indices: &[&T0],
    values: &T1,
    shapes: &[&T2],
    dense_inputs: &T3,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = SparseCross::new();
    op.call(ctx, indices, values, shapes, dense_inputs)
}

/// SparseCrossHashed
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseCrossHashed>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseCrossHashed {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseCrossHashed {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SparseCrossHashed {
    /// Creates a new `SparseCrossHashed`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_cross_hashed.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        indices: &[&T0],
        values: &T1,
        shapes: &[&T2],
        dense_inputs: &T3,
        num_buckets: &T4,
        strong_hash: &T5,
        salt: &T6,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseCrossHashed")?;

        // Required input arguments
        let mut indices_list = Vec::new();

        for t in indices {
            indices_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&indices_list)?;
        op.add_input(&values.to_handle(ctx)?)?;
        let mut shapes_list = Vec::new();

        for t in shapes {
            shapes_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&shapes_list)?;
        op.add_input(&dense_inputs.to_handle(ctx)?)?;
        op.add_input(&num_buckets.to_handle(ctx)?)?;
        op.add_input(&strong_hash.to_handle(ctx)?)?;
        op.add_input(&salt.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `SparseCrossHashed::new().call(&ctx, &indices, &values, &shapes, &dense_inputs, &num_buckets, &strong_hash, &salt)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseCrossHashed>
pub fn sparse_cross_hashed<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    indices: &[&T0],
    values: &T1,
    shapes: &[&T2],
    dense_inputs: &T3,
    num_buckets: &T4,
    strong_hash: &T5,
    salt: &T6,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = SparseCrossHashed::new();
    op.call(
        ctx,
        indices,
        values,
        shapes,
        dense_inputs,
        num_buckets,
        strong_hash,
        salt,
    )
}

/// SparseCrossV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseCrossV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseCrossV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseCrossV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SparseCrossV2 {
    /// Creates a new `SparseCrossV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_cross_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        indices: &[&T0],
        values: &T1,
        shapes: &[&T2],
        dense_inputs: &T3,
        sep: &T4,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseCrossV2")?;

        // Required input arguments
        let mut indices_list = Vec::new();

        for t in indices {
            indices_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&indices_list)?;
        op.add_input(&values.to_handle(ctx)?)?;
        let mut shapes_list = Vec::new();

        for t in shapes {
            shapes_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&shapes_list)?;
        op.add_input(&dense_inputs.to_handle(ctx)?)?;
        op.add_input(&sep.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `SparseCrossV2::new().call(&ctx, &indices, &values, &shapes, &dense_inputs, &sep)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseCrossV2>
pub fn sparse_cross_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    indices: &[&T0],
    values: &T1,
    shapes: &[&T2],
    dense_inputs: &T3,
    sep: &T4,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = SparseCrossV2::new();
    op.call(ctx, indices, values, shapes, dense_inputs, sep)
}

/// SparseDenseCwiseAdd
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseDenseCwiseAdd>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseDenseCwiseAdd {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseDenseCwiseAdd {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SparseDenseCwiseAdd {
    /// Creates a new `SparseDenseCwiseAdd`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_dense_cwise_add.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        sp_indices: &T0,
        sp_values: &T1,
        sp_shape: &T2,
        dense: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseDenseCwiseAdd")?;

        // Required input arguments
        op.add_input(&sp_indices.to_handle(ctx)?)?;
        op.add_input(&sp_values.to_handle(ctx)?)?;
        op.add_input(&sp_shape.to_handle(ctx)?)?;
        op.add_input(&dense.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseDenseCwiseAdd::new().call(&ctx, &sp_indices, &sp_values, &sp_shape, &dense)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseDenseCwiseAdd>
pub fn sparse_dense_cwise_add<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    sp_indices: &T0,
    sp_values: &T1,
    sp_shape: &T2,
    dense: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseDenseCwiseAdd::new();
    op.call(ctx, sp_indices, sp_values, sp_shape, dense)
}

/// SparseDenseCwiseDiv
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseDenseCwiseDiv>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseDenseCwiseDiv {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseDenseCwiseDiv {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SparseDenseCwiseDiv {
    /// Creates a new `SparseDenseCwiseDiv`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_dense_cwise_div.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        sp_indices: &T0,
        sp_values: &T1,
        sp_shape: &T2,
        dense: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseDenseCwiseDiv")?;

        // Required input arguments
        op.add_input(&sp_indices.to_handle(ctx)?)?;
        op.add_input(&sp_values.to_handle(ctx)?)?;
        op.add_input(&sp_shape.to_handle(ctx)?)?;
        op.add_input(&dense.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseDenseCwiseDiv::new().call(&ctx, &sp_indices, &sp_values, &sp_shape, &dense)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseDenseCwiseDiv>
pub fn sparse_dense_cwise_div<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    sp_indices: &T0,
    sp_values: &T1,
    sp_shape: &T2,
    dense: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseDenseCwiseDiv::new();
    op.call(ctx, sp_indices, sp_values, sp_shape, dense)
}

/// SparseDenseCwiseMul
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseDenseCwiseMul>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseDenseCwiseMul {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseDenseCwiseMul {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SparseDenseCwiseMul {
    /// Creates a new `SparseDenseCwiseMul`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_dense_cwise_mul.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        sp_indices: &T0,
        sp_values: &T1,
        sp_shape: &T2,
        dense: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseDenseCwiseMul")?;

        // Required input arguments
        op.add_input(&sp_indices.to_handle(ctx)?)?;
        op.add_input(&sp_values.to_handle(ctx)?)?;
        op.add_input(&sp_shape.to_handle(ctx)?)?;
        op.add_input(&dense.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseDenseCwiseMul::new().call(&ctx, &sp_indices, &sp_values, &sp_shape, &dense)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseDenseCwiseMul>
pub fn sparse_dense_cwise_mul<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    sp_indices: &T0,
    sp_values: &T1,
    sp_shape: &T2,
    dense: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseDenseCwiseMul::new();
    op.call(ctx, sp_indices, sp_values, sp_shape, dense)
}

/// SparseFillEmptyRows
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseFillEmptyRows>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseFillEmptyRows {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseFillEmptyRows {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SparseFillEmptyRows {
    /// Creates a new `SparseFillEmptyRows`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_fill_empty_rows.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        indices: &T0,
        values: &T1,
        dense_shape: &T2,
        default_value: &T3,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 4]> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseFillEmptyRows")?;

        // Required input arguments
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&values.to_handle(ctx)?)?;
        op.add_input(&dense_shape.to_handle(ctx)?)?;
        op.add_input(&default_value.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<4>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `SparseFillEmptyRows::new().call(&ctx, &indices, &values, &dense_shape, &default_value)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseFillEmptyRows>
pub fn sparse_fill_empty_rows<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    indices: &T0,
    values: &T1,
    dense_shape: &T2,
    default_value: &T3,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 4]> {
    let op = SparseFillEmptyRows::new();
    op.call(ctx, indices, values, dense_shape, default_value)
}

/// SparseFillEmptyRowsGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseFillEmptyRowsGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseFillEmptyRowsGrad {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseFillEmptyRowsGrad {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SparseFillEmptyRowsGrad {
    /// Creates a new `SparseFillEmptyRowsGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_fill_empty_rows_grad.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        reverse_index_map: &T0,
        grad_values: &T1,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseFillEmptyRowsGrad")?;

        // Required input arguments
        op.add_input(&reverse_index_map.to_handle(ctx)?)?;
        op.add_input(&grad_values.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `SparseFillEmptyRowsGrad::new().call(&ctx, &reverse_index_map, &grad_values)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseFillEmptyRowsGrad>
pub fn sparse_fill_empty_rows_grad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    reverse_index_map: &T0,
    grad_values: &T1,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = SparseFillEmptyRowsGrad::new();
    op.call(ctx, reverse_index_map, grad_values)
}

/// SparseMatMul
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseMatMul>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseMatMul {
    transpose_a: ::std::option::Option<bool>,
    transpose_b: ::std::option::Option<bool>,
    a_is_sparse: ::std::option::Option<bool>,
    b_is_sparse: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseMatMul {
    fn default() -> Self {
        Self {
            transpose_a: Some(false),
            transpose_b: Some(false),
            a_is_sparse: Some(false),
            b_is_sparse: Some(false),
            target_device_name: None,
        }
    }
}
impl SparseMatMul {
    /// Creates a new `SparseMatMul`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `transpose_a` attribute.
    pub fn transpose_a<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.transpose_a = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `transpose_b` attribute.
    pub fn transpose_b<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.transpose_b = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `a_is_sparse` attribute.
    pub fn a_is_sparse<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.a_is_sparse = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `b_is_sparse` attribute.
    pub fn b_is_sparse<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.b_is_sparse = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_mat_mul.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        a: &T0,
        b: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseMatMul")?;

        // Required input arguments
        op.add_input(&a.to_handle(ctx)?)?;
        op.add_input(&b.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.transpose_a {
            op.set_attr_bool("transpose_a", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.transpose_b {
            op.set_attr_bool("transpose_b", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.a_is_sparse {
            op.set_attr_bool("a_is_sparse", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.b_is_sparse {
            op.set_attr_bool("b_is_sparse", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseMatMul::new().call(&ctx, &a, &b)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseMatMul>
pub fn sparse_mat_mul<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    a: &T0,
    b: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseMatMul::new();
    op.call(ctx, a, b)
}

/// SparseMatrixAdd
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseMatrixAdd>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseMatrixAdd {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseMatrixAdd {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SparseMatrixAdd {
    /// Creates a new `SparseMatrixAdd`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_matrix_add.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        a: &T0,
        b: &T1,
        alpha: &T2,
        beta: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseMatrixAdd")?;

        // Required input arguments
        op.add_input(&a.to_handle(ctx)?)?;
        op.add_input(&b.to_handle(ctx)?)?;
        op.add_input(&alpha.to_handle(ctx)?)?;
        op.add_input(&beta.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseMatrixAdd::new().call(&ctx, &a, &b, &alpha, &beta)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseMatrixAdd>
pub fn sparse_matrix_add<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    a: &T0,
    b: &T1,
    alpha: &T2,
    beta: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseMatrixAdd::new();
    op.call(ctx, a, b, alpha, beta)
}

/// SparseMatrixMatMul
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseMatrixMatMul>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseMatrixMatMul {
    transpose_a: ::std::option::Option<bool>,
    transpose_b: ::std::option::Option<bool>,
    adjoint_a: ::std::option::Option<bool>,
    adjoint_b: ::std::option::Option<bool>,
    transpose_output: ::std::option::Option<bool>,
    conjugate_output: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseMatrixMatMul {
    fn default() -> Self {
        Self {
            transpose_a: Some(false),
            transpose_b: Some(false),
            adjoint_a: Some(false),
            adjoint_b: Some(false),
            transpose_output: Some(false),
            conjugate_output: Some(false),
            target_device_name: None,
        }
    }
}
impl SparseMatrixMatMul {
    /// Creates a new `SparseMatrixMatMul`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `transpose_a` attribute.
    pub fn transpose_a<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.transpose_a = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `transpose_b` attribute.
    pub fn transpose_b<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.transpose_b = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `adjoint_a` attribute.
    pub fn adjoint_a<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.adjoint_a = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `adjoint_b` attribute.
    pub fn adjoint_b<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.adjoint_b = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `transpose_output` attribute.
    pub fn transpose_output<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.transpose_output = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `conjugate_output` attribute.
    pub fn conjugate_output<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.conjugate_output = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_matrix_mat_mul.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        a: &T0,
        b: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseMatrixMatMul")?;

        // Required input arguments
        op.add_input(&a.to_handle(ctx)?)?;
        op.add_input(&b.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.transpose_a {
            op.set_attr_bool("transpose_a", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.transpose_b {
            op.set_attr_bool("transpose_b", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.adjoint_a {
            op.set_attr_bool("adjoint_a", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.adjoint_b {
            op.set_attr_bool("adjoint_b", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.transpose_output {
            op.set_attr_bool("transpose_output", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.conjugate_output {
            op.set_attr_bool("conjugate_output", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseMatrixMatMul::new().call(&ctx, &a, &b)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseMatrixMatMul>
pub fn sparse_matrix_mat_mul<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    a: &T0,
    b: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseMatrixMatMul::new();
    op.call(ctx, a, b)
}

/// SparseMatrixMul
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseMatrixMul>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseMatrixMul {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseMatrixMul {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SparseMatrixMul {
    /// Creates a new `SparseMatrixMul`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_matrix_mul.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        a: &T0,
        b: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseMatrixMul")?;

        // Required input arguments
        op.add_input(&a.to_handle(ctx)?)?;
        op.add_input(&b.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseMatrixMul::new().call(&ctx, &a, &b)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseMatrixMul>
pub fn sparse_matrix_mul<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    a: &T0,
    b: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseMatrixMul::new();
    op.call(ctx, a, b)
}

/// SparseMatrixNNZ
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseMatrixNNZ>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseMatrixNNZ {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseMatrixNNZ {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SparseMatrixNNZ {
    /// Creates a new `SparseMatrixNNZ`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_matrix_nnz.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        sparse_matrix: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseMatrixNNZ")?;

        // Required input arguments
        op.add_input(&sparse_matrix.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseMatrixNNZ::new().call(&ctx, &sparse_matrix)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseMatrixNNZ>
pub fn sparse_matrix_nnz<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    sparse_matrix: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseMatrixNNZ::new();
    op.call(ctx, sparse_matrix)
}

/// SparseMatrixOrderingAMD
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseMatrixOrderingAMD>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseMatrixOrderingAMD {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseMatrixOrderingAMD {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SparseMatrixOrderingAMD {
    /// Creates a new `SparseMatrixOrderingAMD`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_matrix_ordering_amd.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseMatrixOrderingAMD")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseMatrixOrderingAMD::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseMatrixOrderingAMD>
pub fn sparse_matrix_ordering_amd<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseMatrixOrderingAMD::new();
    op.call(ctx, input)
}

/// SparseMatrixSoftmax
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseMatrixSoftmax>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseMatrixSoftmax {
    type_: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseMatrixSoftmax {
    fn default() -> Self {
        Self {
            type_: None,
            target_device_name: None,
        }
    }
}
impl SparseMatrixSoftmax {
    /// Creates a new `SparseMatrixSoftmax`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `type` attribute.
    pub fn type_<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.type_ = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_matrix_softmax.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        logits: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseMatrixSoftmax")?;

        // Required input arguments
        op.add_input(&logits.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.type_ {
            op.set_attr_type("type", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseMatrixSoftmax::new().call(&ctx, &logits)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseMatrixSoftmax>
pub fn sparse_matrix_softmax<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    logits: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseMatrixSoftmax::new();
    op.call(ctx, logits)
}

/// SparseMatrixSoftmaxGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseMatrixSoftmaxGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseMatrixSoftmaxGrad {
    type_: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseMatrixSoftmaxGrad {
    fn default() -> Self {
        Self {
            type_: None,
            target_device_name: None,
        }
    }
}
impl SparseMatrixSoftmaxGrad {
    /// Creates a new `SparseMatrixSoftmaxGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `type` attribute.
    pub fn type_<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.type_ = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_matrix_softmax_grad.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        softmax: &T0,
        grad_softmax: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseMatrixSoftmaxGrad")?;

        // Required input arguments
        op.add_input(&softmax.to_handle(ctx)?)?;
        op.add_input(&grad_softmax.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.type_ {
            op.set_attr_type("type", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseMatrixSoftmaxGrad::new().call(&ctx, &softmax, &grad_softmax)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseMatrixSoftmaxGrad>
pub fn sparse_matrix_softmax_grad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    softmax: &T0,
    grad_softmax: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseMatrixSoftmaxGrad::new();
    op.call(ctx, softmax, grad_softmax)
}

/// SparseMatrixSparseCholesky
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseMatrixSparseCholesky>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseMatrixSparseCholesky {
    type_: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseMatrixSparseCholesky {
    fn default() -> Self {
        Self {
            type_: None,
            target_device_name: None,
        }
    }
}
impl SparseMatrixSparseCholesky {
    /// Creates a new `SparseMatrixSparseCholesky`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `type` attribute.
    pub fn type_<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.type_ = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_matrix_sparse_cholesky.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        permutation: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseMatrixSparseCholesky")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&permutation.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.type_ {
            op.set_attr_type("type", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseMatrixSparseCholesky::new().call(&ctx, &input, &permutation)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseMatrixSparseCholesky>
pub fn sparse_matrix_sparse_cholesky<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    permutation: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseMatrixSparseCholesky::new();
    op.call(ctx, input, permutation)
}

/// SparseMatrixSparseMatMul
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseMatrixSparseMatMul>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseMatrixSparseMatMul {
    type_: ::std::option::Option<crate::DataType>,
    transpose_a: ::std::option::Option<bool>,
    transpose_b: ::std::option::Option<bool>,
    adjoint_a: ::std::option::Option<bool>,
    adjoint_b: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseMatrixSparseMatMul {
    fn default() -> Self {
        Self {
            type_: None,
            transpose_a: Some(false),
            transpose_b: Some(false),
            adjoint_a: Some(false),
            adjoint_b: Some(false),
            target_device_name: None,
        }
    }
}
impl SparseMatrixSparseMatMul {
    /// Creates a new `SparseMatrixSparseMatMul`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `type` attribute.
    pub fn type_<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.type_ = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `transpose_a` attribute.
    pub fn transpose_a<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.transpose_a = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `transpose_b` attribute.
    pub fn transpose_b<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.transpose_b = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `adjoint_a` attribute.
    pub fn adjoint_a<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.adjoint_a = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `adjoint_b` attribute.
    pub fn adjoint_b<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.adjoint_b = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_matrix_sparse_mat_mul.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        a: &T0,
        b: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseMatrixSparseMatMul")?;

        // Required input arguments
        op.add_input(&a.to_handle(ctx)?)?;
        op.add_input(&b.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.type_ {
            op.set_attr_type("type", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.transpose_a {
            op.set_attr_bool("transpose_a", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.transpose_b {
            op.set_attr_bool("transpose_b", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.adjoint_a {
            op.set_attr_bool("adjoint_a", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.adjoint_b {
            op.set_attr_bool("adjoint_b", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseMatrixSparseMatMul::new().call(&ctx, &a, &b)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseMatrixSparseMatMul>
pub fn sparse_matrix_sparse_mat_mul<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    a: &T0,
    b: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseMatrixSparseMatMul::new();
    op.call(ctx, a, b)
}

/// SparseMatrixTranspose
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseMatrixTranspose>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseMatrixTranspose {
    conjugate: ::std::option::Option<bool>,
    type_: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseMatrixTranspose {
    fn default() -> Self {
        Self {
            conjugate: Some(false),
            type_: None,
            target_device_name: None,
        }
    }
}
impl SparseMatrixTranspose {
    /// Creates a new `SparseMatrixTranspose`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `conjugate` attribute.
    pub fn conjugate<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.conjugate = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `type` attribute.
    pub fn type_<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.type_ = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_matrix_transpose.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseMatrixTranspose")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.conjugate {
            op.set_attr_bool("conjugate", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.type_ {
            op.set_attr_type("type", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseMatrixTranspose::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseMatrixTranspose>
pub fn sparse_matrix_transpose<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseMatrixTranspose::new();
    op.call(ctx, input)
}

/// SparseMatrixZeros
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseMatrixZeros>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseMatrixZeros {
    type_: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseMatrixZeros {
    fn default() -> Self {
        Self {
            type_: None,
            target_device_name: None,
        }
    }
}
impl SparseMatrixZeros {
    /// Creates a new `SparseMatrixZeros`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `type` attribute.
    pub fn type_<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.type_ = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_matrix_zeros.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        dense_shape: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseMatrixZeros")?;

        // Required input arguments
        op.add_input(&dense_shape.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.type_ {
            op.set_attr_type("type", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseMatrixZeros::new().call(&ctx, &dense_shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseMatrixZeros>
pub fn sparse_matrix_zeros<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    dense_shape: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseMatrixZeros::new();
    op.call(ctx, dense_shape)
}

/// SparseReduceMax
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseReduceMax>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseReduceMax {
    keep_dims: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseReduceMax {
    fn default() -> Self {
        Self {
            keep_dims: Some(false),
            target_device_name: None,
        }
    }
}
impl SparseReduceMax {
    /// Creates a new `SparseReduceMax`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `keep_dims` attribute.
    pub fn keep_dims<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.keep_dims = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_reduce_max.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_indices: &T0,
        input_values: &T1,
        input_shape: &T2,
        reduction_axes: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseReduceMax")?;

        // Required input arguments
        op.add_input(&input_indices.to_handle(ctx)?)?;
        op.add_input(&input_values.to_handle(ctx)?)?;
        op.add_input(&input_shape.to_handle(ctx)?)?;
        op.add_input(&reduction_axes.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.keep_dims {
            op.set_attr_bool("keep_dims", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseReduceMax::new().call(&ctx, &input_indices, &input_values, &input_shape, &reduction_axes)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseReduceMax>
pub fn sparse_reduce_max<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_indices: &T0,
    input_values: &T1,
    input_shape: &T2,
    reduction_axes: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseReduceMax::new();
    op.call(
        ctx,
        input_indices,
        input_values,
        input_shape,
        reduction_axes,
    )
}

/// SparseReduceMaxSparse
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseReduceMaxSparse>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseReduceMaxSparse {
    keep_dims: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseReduceMaxSparse {
    fn default() -> Self {
        Self {
            keep_dims: Some(false),
            target_device_name: None,
        }
    }
}
impl SparseReduceMaxSparse {
    /// Creates a new `SparseReduceMaxSparse`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `keep_dims` attribute.
    pub fn keep_dims<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.keep_dims = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_reduce_max_sparse.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_indices: &T0,
        input_values: &T1,
        input_shape: &T2,
        reduction_axes: &T3,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseReduceMaxSparse")?;

        // Required input arguments
        op.add_input(&input_indices.to_handle(ctx)?)?;
        op.add_input(&input_values.to_handle(ctx)?)?;
        op.add_input(&input_shape.to_handle(ctx)?)?;
        op.add_input(&reduction_axes.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.keep_dims {
            op.set_attr_bool("keep_dims", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `SparseReduceMaxSparse::new().call(&ctx, &input_indices, &input_values, &input_shape, &reduction_axes)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseReduceMaxSparse>
pub fn sparse_reduce_max_sparse<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_indices: &T0,
    input_values: &T1,
    input_shape: &T2,
    reduction_axes: &T3,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = SparseReduceMaxSparse::new();
    op.call(
        ctx,
        input_indices,
        input_values,
        input_shape,
        reduction_axes,
    )
}

/// SparseReduceSum
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseReduceSum>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseReduceSum {
    keep_dims: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseReduceSum {
    fn default() -> Self {
        Self {
            keep_dims: Some(false),
            target_device_name: None,
        }
    }
}
impl SparseReduceSum {
    /// Creates a new `SparseReduceSum`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `keep_dims` attribute.
    pub fn keep_dims<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.keep_dims = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_reduce_sum.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_indices: &T0,
        input_values: &T1,
        input_shape: &T2,
        reduction_axes: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseReduceSum")?;

        // Required input arguments
        op.add_input(&input_indices.to_handle(ctx)?)?;
        op.add_input(&input_values.to_handle(ctx)?)?;
        op.add_input(&input_shape.to_handle(ctx)?)?;
        op.add_input(&reduction_axes.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.keep_dims {
            op.set_attr_bool("keep_dims", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseReduceSum::new().call(&ctx, &input_indices, &input_values, &input_shape, &reduction_axes)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseReduceSum>
pub fn sparse_reduce_sum<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_indices: &T0,
    input_values: &T1,
    input_shape: &T2,
    reduction_axes: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseReduceSum::new();
    op.call(
        ctx,
        input_indices,
        input_values,
        input_shape,
        reduction_axes,
    )
}

/// SparseReduceSumSparse
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseReduceSumSparse>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseReduceSumSparse {
    keep_dims: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseReduceSumSparse {
    fn default() -> Self {
        Self {
            keep_dims: Some(false),
            target_device_name: None,
        }
    }
}
impl SparseReduceSumSparse {
    /// Creates a new `SparseReduceSumSparse`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `keep_dims` attribute.
    pub fn keep_dims<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.keep_dims = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_reduce_sum_sparse.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_indices: &T0,
        input_values: &T1,
        input_shape: &T2,
        reduction_axes: &T3,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseReduceSumSparse")?;

        // Required input arguments
        op.add_input(&input_indices.to_handle(ctx)?)?;
        op.add_input(&input_values.to_handle(ctx)?)?;
        op.add_input(&input_shape.to_handle(ctx)?)?;
        op.add_input(&reduction_axes.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.keep_dims {
            op.set_attr_bool("keep_dims", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `SparseReduceSumSparse::new().call(&ctx, &input_indices, &input_values, &input_shape, &reduction_axes)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseReduceSumSparse>
pub fn sparse_reduce_sum_sparse<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_indices: &T0,
    input_values: &T1,
    input_shape: &T2,
    reduction_axes: &T3,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = SparseReduceSumSparse::new();
    op.call(
        ctx,
        input_indices,
        input_values,
        input_shape,
        reduction_axes,
    )
}

/// SparseReorder
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseReorder>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseReorder {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseReorder {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SparseReorder {
    /// Creates a new `SparseReorder`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_reorder.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_indices: &T0,
        input_values: &T1,
        input_shape: &T2,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseReorder")?;

        // Required input arguments
        op.add_input(&input_indices.to_handle(ctx)?)?;
        op.add_input(&input_values.to_handle(ctx)?)?;
        op.add_input(&input_shape.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `SparseReorder::new().call(&ctx, &input_indices, &input_values, &input_shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseReorder>
pub fn sparse_reorder<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_indices: &T0,
    input_values: &T1,
    input_shape: &T2,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = SparseReorder::new();
    op.call(ctx, input_indices, input_values, input_shape)
}

/// SparseReshape
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseReshape>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseReshape {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseReshape {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SparseReshape {
    /// Creates a new `SparseReshape`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_reshape.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_indices: &T0,
        input_shape: &T1,
        new_shape: &T2,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseReshape")?;

        // Required input arguments
        op.add_input(&input_indices.to_handle(ctx)?)?;
        op.add_input(&input_shape.to_handle(ctx)?)?;
        op.add_input(&new_shape.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `SparseReshape::new().call(&ctx, &input_indices, &input_shape, &new_shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseReshape>
pub fn sparse_reshape<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_indices: &T0,
    input_shape: &T1,
    new_shape: &T2,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = SparseReshape::new();
    op.call(ctx, input_indices, input_shape, new_shape)
}

/// SparseSegmentMean
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseSegmentMean>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseSegmentMean {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseSegmentMean {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SparseSegmentMean {
    /// Creates a new `SparseSegmentMean`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_segment_mean.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        data: &T0,
        indices: &T1,
        segment_ids: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseSegmentMean")?;

        // Required input arguments
        op.add_input(&data.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&segment_ids.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseSegmentMean::new().call(&ctx, &data, &indices, &segment_ids)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseSegmentMean>
pub fn sparse_segment_mean<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    data: &T0,
    indices: &T1,
    segment_ids: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseSegmentMean::new();
    op.call(ctx, data, indices, segment_ids)
}

/// SparseSegmentMeanGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseSegmentMeanGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseSegmentMeanGrad {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseSegmentMeanGrad {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SparseSegmentMeanGrad {
    /// Creates a new `SparseSegmentMeanGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_segment_mean_grad.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        grad: &T0,
        indices: &T1,
        segment_ids: &T2,
        output_dim0: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseSegmentMeanGrad")?;

        // Required input arguments
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&segment_ids.to_handle(ctx)?)?;
        op.add_input(&output_dim0.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseSegmentMeanGrad::new().call(&ctx, &grad, &indices, &segment_ids, &output_dim0)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseSegmentMeanGrad>
pub fn sparse_segment_mean_grad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    grad: &T0,
    indices: &T1,
    segment_ids: &T2,
    output_dim0: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseSegmentMeanGrad::new();
    op.call(ctx, grad, indices, segment_ids, output_dim0)
}

/// SparseSegmentMeanWithNumSegments
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseSegmentMeanWithNumSegments>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseSegmentMeanWithNumSegments {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseSegmentMeanWithNumSegments {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SparseSegmentMeanWithNumSegments {
    /// Creates a new `SparseSegmentMeanWithNumSegments`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_segment_mean_with_num_segments.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        data: &T0,
        indices: &T1,
        segment_ids: &T2,
        num_segments: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseSegmentMeanWithNumSegments")?;

        // Required input arguments
        op.add_input(&data.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&segment_ids.to_handle(ctx)?)?;
        op.add_input(&num_segments.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseSegmentMeanWithNumSegments::new().call(&ctx, &data, &indices, &segment_ids, &num_segments)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseSegmentMeanWithNumSegments>
pub fn sparse_segment_mean_with_num_segments<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    data: &T0,
    indices: &T1,
    segment_ids: &T2,
    num_segments: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseSegmentMeanWithNumSegments::new();
    op.call(ctx, data, indices, segment_ids, num_segments)
}

/// SparseSegmentSqrtN
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseSegmentSqrtN>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseSegmentSqrtN {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseSegmentSqrtN {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SparseSegmentSqrtN {
    /// Creates a new `SparseSegmentSqrtN`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_segment_sqrt_n.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        data: &T0,
        indices: &T1,
        segment_ids: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseSegmentSqrtN")?;

        // Required input arguments
        op.add_input(&data.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&segment_ids.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseSegmentSqrtN::new().call(&ctx, &data, &indices, &segment_ids)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseSegmentSqrtN>
pub fn sparse_segment_sqrt_n<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    data: &T0,
    indices: &T1,
    segment_ids: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseSegmentSqrtN::new();
    op.call(ctx, data, indices, segment_ids)
}

/// SparseSegmentSqrtNGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseSegmentSqrtNGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseSegmentSqrtNGrad {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseSegmentSqrtNGrad {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SparseSegmentSqrtNGrad {
    /// Creates a new `SparseSegmentSqrtNGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_segment_sqrt_ngrad.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        grad: &T0,
        indices: &T1,
        segment_ids: &T2,
        output_dim0: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseSegmentSqrtNGrad")?;

        // Required input arguments
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&segment_ids.to_handle(ctx)?)?;
        op.add_input(&output_dim0.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseSegmentSqrtNGrad::new().call(&ctx, &grad, &indices, &segment_ids, &output_dim0)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseSegmentSqrtNGrad>
pub fn sparse_segment_sqrt_ngrad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    grad: &T0,
    indices: &T1,
    segment_ids: &T2,
    output_dim0: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseSegmentSqrtNGrad::new();
    op.call(ctx, grad, indices, segment_ids, output_dim0)
}

/// SparseSegmentSqrtNWithNumSegments
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseSegmentSqrtNWithNumSegments>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseSegmentSqrtNWithNumSegments {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseSegmentSqrtNWithNumSegments {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SparseSegmentSqrtNWithNumSegments {
    /// Creates a new `SparseSegmentSqrtNWithNumSegments`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_segment_sqrt_nwith_num_segments.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        data: &T0,
        indices: &T1,
        segment_ids: &T2,
        num_segments: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseSegmentSqrtNWithNumSegments")?;

        // Required input arguments
        op.add_input(&data.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&segment_ids.to_handle(ctx)?)?;
        op.add_input(&num_segments.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseSegmentSqrtNWithNumSegments::new().call(&ctx, &data, &indices, &segment_ids, &num_segments)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseSegmentSqrtNWithNumSegments>
pub fn sparse_segment_sqrt_nwith_num_segments<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    data: &T0,
    indices: &T1,
    segment_ids: &T2,
    num_segments: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseSegmentSqrtNWithNumSegments::new();
    op.call(ctx, data, indices, segment_ids, num_segments)
}

/// SparseSegmentSum
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseSegmentSum>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseSegmentSum {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseSegmentSum {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SparseSegmentSum {
    /// Creates a new `SparseSegmentSum`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_segment_sum.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        data: &T0,
        indices: &T1,
        segment_ids: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseSegmentSum")?;

        // Required input arguments
        op.add_input(&data.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&segment_ids.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseSegmentSum::new().call(&ctx, &data, &indices, &segment_ids)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseSegmentSum>
pub fn sparse_segment_sum<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    data: &T0,
    indices: &T1,
    segment_ids: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseSegmentSum::new();
    op.call(ctx, data, indices, segment_ids)
}

/// SparseSegmentSumGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseSegmentSumGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseSegmentSumGrad {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseSegmentSumGrad {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SparseSegmentSumGrad {
    /// Creates a new `SparseSegmentSumGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_segment_sum_grad.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        grad: &T0,
        indices: &T1,
        segment_ids: &T2,
        output_dim0: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseSegmentSumGrad")?;

        // Required input arguments
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&segment_ids.to_handle(ctx)?)?;
        op.add_input(&output_dim0.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseSegmentSumGrad::new().call(&ctx, &grad, &indices, &segment_ids, &output_dim0)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseSegmentSumGrad>
pub fn sparse_segment_sum_grad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    grad: &T0,
    indices: &T1,
    segment_ids: &T2,
    output_dim0: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseSegmentSumGrad::new();
    op.call(ctx, grad, indices, segment_ids, output_dim0)
}

/// SparseSegmentSumWithNumSegments
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseSegmentSumWithNumSegments>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseSegmentSumWithNumSegments {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseSegmentSumWithNumSegments {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SparseSegmentSumWithNumSegments {
    /// Creates a new `SparseSegmentSumWithNumSegments`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_segment_sum_with_num_segments.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        data: &T0,
        indices: &T1,
        segment_ids: &T2,
        num_segments: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseSegmentSumWithNumSegments")?;

        // Required input arguments
        op.add_input(&data.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&segment_ids.to_handle(ctx)?)?;
        op.add_input(&num_segments.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseSegmentSumWithNumSegments::new().call(&ctx, &data, &indices, &segment_ids, &num_segments)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseSegmentSumWithNumSegments>
pub fn sparse_segment_sum_with_num_segments<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    data: &T0,
    indices: &T1,
    segment_ids: &T2,
    num_segments: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseSegmentSumWithNumSegments::new();
    op.call(ctx, data, indices, segment_ids, num_segments)
}

/// SparseSlice
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseSlice>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseSlice {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseSlice {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SparseSlice {
    /// Creates a new `SparseSlice`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_slice.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        indices: &T0,
        values: &T1,
        shape: &T2,
        start: &T3,
        size: &T4,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseSlice")?;

        // Required input arguments
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&values.to_handle(ctx)?)?;
        op.add_input(&shape.to_handle(ctx)?)?;
        op.add_input(&start.to_handle(ctx)?)?;
        op.add_input(&size.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `SparseSlice::new().call(&ctx, &indices, &values, &shape, &start, &size)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseSlice>
pub fn sparse_slice<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    indices: &T0,
    values: &T1,
    shape: &T2,
    start: &T3,
    size: &T4,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = SparseSlice::new();
    op.call(ctx, indices, values, shape, start, size)
}

/// SparseSliceGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseSliceGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseSliceGrad {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseSliceGrad {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SparseSliceGrad {
    /// Creates a new `SparseSliceGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_slice_grad.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        backprop_val_grad: &T0,
        input_indices: &T1,
        input_start: &T2,
        output_indices: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseSliceGrad")?;

        // Required input arguments
        op.add_input(&backprop_val_grad.to_handle(ctx)?)?;
        op.add_input(&input_indices.to_handle(ctx)?)?;
        op.add_input(&input_start.to_handle(ctx)?)?;
        op.add_input(&output_indices.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseSliceGrad::new().call(&ctx, &backprop_val_grad, &input_indices, &input_start, &output_indices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseSliceGrad>
pub fn sparse_slice_grad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    backprop_val_grad: &T0,
    input_indices: &T1,
    input_start: &T2,
    output_indices: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseSliceGrad::new();
    op.call(
        ctx,
        backprop_val_grad,
        input_indices,
        input_start,
        output_indices,
    )
}

/// SparseSoftmax
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseSoftmax>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseSoftmax {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseSoftmax {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SparseSoftmax {
    /// Creates a new `SparseSoftmax`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_softmax.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        sp_indices: &T0,
        sp_values: &T1,
        sp_shape: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseSoftmax")?;

        // Required input arguments
        op.add_input(&sp_indices.to_handle(ctx)?)?;
        op.add_input(&sp_values.to_handle(ctx)?)?;
        op.add_input(&sp_shape.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseSoftmax::new().call(&ctx, &sp_indices, &sp_values, &sp_shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseSoftmax>
pub fn sparse_softmax<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    sp_indices: &T0,
    sp_values: &T1,
    sp_shape: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseSoftmax::new();
    op.call(ctx, sp_indices, sp_values, sp_shape)
}

/// SparseSoftmaxCrossEntropyWithLogits
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseSoftmaxCrossEntropyWithLogits>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseSoftmaxCrossEntropyWithLogits {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseSoftmaxCrossEntropyWithLogits {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SparseSoftmaxCrossEntropyWithLogits {
    /// Creates a new `SparseSoftmaxCrossEntropyWithLogits`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_softmax_cross_entropy_with_logits.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        features: &T0,
        labels: &T1,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseSoftmaxCrossEntropyWithLogits")?;

        // Required input arguments
        op.add_input(&features.to_handle(ctx)?)?;
        op.add_input(&labels.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `SparseSoftmaxCrossEntropyWithLogits::new().call(&ctx, &features, &labels)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseSoftmaxCrossEntropyWithLogits>
pub fn sparse_softmax_cross_entropy_with_logits<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    features: &T0,
    labels: &T1,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = SparseSoftmaxCrossEntropyWithLogits::new();
    op.call(ctx, features, labels)
}

/// SparseSparseMaximum
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseSparseMaximum>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseSparseMaximum {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseSparseMaximum {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SparseSparseMaximum {
    /// Creates a new `SparseSparseMaximum`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_sparse_maximum.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        a_indices: &T0,
        a_values: &T1,
        a_shape: &T2,
        b_indices: &T3,
        b_values: &T4,
        b_shape: &T5,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseSparseMaximum")?;

        // Required input arguments
        op.add_input(&a_indices.to_handle(ctx)?)?;
        op.add_input(&a_values.to_handle(ctx)?)?;
        op.add_input(&a_shape.to_handle(ctx)?)?;
        op.add_input(&b_indices.to_handle(ctx)?)?;
        op.add_input(&b_values.to_handle(ctx)?)?;
        op.add_input(&b_shape.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `SparseSparseMaximum::new().call(&ctx, &a_indices, &a_values, &a_shape, &b_indices, &b_values, &b_shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseSparseMaximum>
pub fn sparse_sparse_maximum<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    a_indices: &T0,
    a_values: &T1,
    a_shape: &T2,
    b_indices: &T3,
    b_values: &T4,
    b_shape: &T5,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = SparseSparseMaximum::new();
    op.call(
        ctx, a_indices, a_values, a_shape, b_indices, b_values, b_shape,
    )
}

/// SparseSparseMinimum
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseSparseMinimum>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseSparseMinimum {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseSparseMinimum {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SparseSparseMinimum {
    /// Creates a new `SparseSparseMinimum`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_sparse_minimum.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        a_indices: &T0,
        a_values: &T1,
        a_shape: &T2,
        b_indices: &T3,
        b_values: &T4,
        b_shape: &T5,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseSparseMinimum")?;

        // Required input arguments
        op.add_input(&a_indices.to_handle(ctx)?)?;
        op.add_input(&a_values.to_handle(ctx)?)?;
        op.add_input(&a_shape.to_handle(ctx)?)?;
        op.add_input(&b_indices.to_handle(ctx)?)?;
        op.add_input(&b_values.to_handle(ctx)?)?;
        op.add_input(&b_shape.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `SparseSparseMinimum::new().call(&ctx, &a_indices, &a_values, &a_shape, &b_indices, &b_values, &b_shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseSparseMinimum>
pub fn sparse_sparse_minimum<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    a_indices: &T0,
    a_values: &T1,
    a_shape: &T2,
    b_indices: &T3,
    b_values: &T4,
    b_shape: &T5,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = SparseSparseMinimum::new();
    op.call(
        ctx, a_indices, a_values, a_shape, b_indices, b_values, b_shape,
    )
}

/// SparseSplit
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseSplit>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseSplit {
    num_split: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseSplit {
    fn default() -> Self {
        Self {
            num_split: None,
            target_device_name: None,
        }
    }
}
impl SparseSplit {
    /// Creates a new `SparseSplit`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_split` attribute.
    pub fn num_split<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_split = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_split.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        split_dim: &T0,
        indices: &T1,
        values: &T2,
        shape: &T3,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseSplit")?;

        // Required input arguments
        op.add_input(&split_dim.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&values.to_handle(ctx)?)?;
        op.add_input(&shape.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_split {
            op.set_attr_int("num_split", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `SparseSplit::new().call(&ctx, &split_dim, &indices, &values, &shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseSplit>
pub fn sparse_split<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    split_dim: &T0,
    indices: &T1,
    values: &T2,
    shape: &T3,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = SparseSplit::new();
    op.call(ctx, split_dim, indices, values, shape)
}

/// SparseTensorDenseAdd
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseTensorDenseAdd>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseTensorDenseAdd {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseTensorDenseAdd {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SparseTensorDenseAdd {
    /// Creates a new `SparseTensorDenseAdd`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_tensor_dense_add.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        a_indices: &T0,
        a_values: &T1,
        a_shape: &T2,
        b: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseTensorDenseAdd")?;

        // Required input arguments
        op.add_input(&a_indices.to_handle(ctx)?)?;
        op.add_input(&a_values.to_handle(ctx)?)?;
        op.add_input(&a_shape.to_handle(ctx)?)?;
        op.add_input(&b.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseTensorDenseAdd::new().call(&ctx, &a_indices, &a_values, &a_shape, &b)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseTensorDenseAdd>
pub fn sparse_tensor_dense_add<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    a_indices: &T0,
    a_values: &T1,
    a_shape: &T2,
    b: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseTensorDenseAdd::new();
    op.call(ctx, a_indices, a_values, a_shape, b)
}

/// SparseTensorDenseMatMul
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseTensorDenseMatMul>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseTensorDenseMatMul {
    adjoint_a: ::std::option::Option<bool>,
    adjoint_b: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseTensorDenseMatMul {
    fn default() -> Self {
        Self {
            adjoint_a: Some(false),
            adjoint_b: Some(false),
            target_device_name: None,
        }
    }
}
impl SparseTensorDenseMatMul {
    /// Creates a new `SparseTensorDenseMatMul`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `adjoint_a` attribute.
    pub fn adjoint_a<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.adjoint_a = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `adjoint_b` attribute.
    pub fn adjoint_b<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.adjoint_b = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_tensor_dense_mat_mul.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        a_indices: &T0,
        a_values: &T1,
        a_shape: &T2,
        b: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseTensorDenseMatMul")?;

        // Required input arguments
        op.add_input(&a_indices.to_handle(ctx)?)?;
        op.add_input(&a_values.to_handle(ctx)?)?;
        op.add_input(&a_shape.to_handle(ctx)?)?;
        op.add_input(&b.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.adjoint_a {
            op.set_attr_bool("adjoint_a", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.adjoint_b {
            op.set_attr_bool("adjoint_b", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseTensorDenseMatMul::new().call(&ctx, &a_indices, &a_values, &a_shape, &b)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseTensorDenseMatMul>
pub fn sparse_tensor_dense_mat_mul<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    a_indices: &T0,
    a_values: &T1,
    a_shape: &T2,
    b: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseTensorDenseMatMul::new();
    op.call(ctx, a_indices, a_values, a_shape, b)
}

/// SparseTensorSliceDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseTensorSliceDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseTensorSliceDataset {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseTensorSliceDataset {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SparseTensorSliceDataset {
    /// Creates a new `SparseTensorSliceDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_tensor_slice_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        indices: &T0,
        values: &T1,
        dense_shape: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseTensorSliceDataset")?;

        // Required input arguments
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&values.to_handle(ctx)?)?;
        op.add_input(&dense_shape.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseTensorSliceDataset::new().call(&ctx, &indices, &values, &dense_shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseTensorSliceDataset>
pub fn sparse_tensor_slice_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    indices: &T0,
    values: &T1,
    dense_shape: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseTensorSliceDataset::new();
    op.call(ctx, indices, values, dense_shape)
}

/// SparseTensorToCSRSparseMatrix
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseTensorToCSRSparseMatrix>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseTensorToCSRSparseMatrix {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseTensorToCSRSparseMatrix {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SparseTensorToCSRSparseMatrix {
    /// Creates a new `SparseTensorToCSRSparseMatrix`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_tensor_to_csrsparse_matrix.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        indices: &T0,
        values: &T1,
        dense_shape: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseTensorToCSRSparseMatrix")?;

        // Required input arguments
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&values.to_handle(ctx)?)?;
        op.add_input(&dense_shape.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseTensorToCSRSparseMatrix::new().call(&ctx, &indices, &values, &dense_shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseTensorToCSRSparseMatrix>
pub fn sparse_tensor_to_csrsparse_matrix<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    indices: &T0,
    values: &T1,
    dense_shape: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseTensorToCSRSparseMatrix::new();
    op.call(ctx, indices, values, dense_shape)
}

/// SparseToDense
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseToDense>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseToDense {
    validate_indices: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseToDense {
    fn default() -> Self {
        Self {
            validate_indices: Some(true),
            target_device_name: None,
        }
    }
}
impl SparseToDense {
    /// Creates a new `SparseToDense`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `validate_indices` attribute.
    pub fn validate_indices<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.validate_indices = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_to_dense.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        sparse_indices: &T0,
        output_shape: &T1,
        sparse_values: &T2,
        default_value: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseToDense")?;

        // Required input arguments
        op.add_input(&sparse_indices.to_handle(ctx)?)?;
        op.add_input(&output_shape.to_handle(ctx)?)?;
        op.add_input(&sparse_values.to_handle(ctx)?)?;
        op.add_input(&default_value.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.validate_indices {
            op.set_attr_bool("validate_indices", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SparseToDense::new().call(&ctx, &sparse_indices, &output_shape, &sparse_values, &default_value)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseToDense>
pub fn sparse_to_dense<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    sparse_indices: &T0,
    output_shape: &T1,
    sparse_values: &T2,
    default_value: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SparseToDense::new();
    op.call(
        ctx,
        sparse_indices,
        output_shape,
        sparse_values,
        default_value,
    )
}

/// SparseToSparseSetOperation
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseToSparseSetOperation>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SparseToSparseSetOperation {
    set_operation: ::std::option::Option<::std::string::String>,
    validate_indices: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SparseToSparseSetOperation {
    fn default() -> Self {
        Self {
            set_operation: None,
            validate_indices: Some(true),
            target_device_name: None,
        }
    }
}
impl SparseToSparseSetOperation {
    /// Creates a new `SparseToSparseSetOperation`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `set_operation` attribute.
    pub fn set_operation<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.set_operation = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `validate_indices` attribute.
    pub fn validate_indices<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.validate_indices = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sparse_to_sparse_set_operation.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        set1_indices: &T0,
        set1_values: &T1,
        set1_shape: &T2,
        set2_indices: &T3,
        set2_values: &T4,
        set2_shape: &T5,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "SparseToSparseSetOperation")?;

        // Required input arguments
        op.add_input(&set1_indices.to_handle(ctx)?)?;
        op.add_input(&set1_values.to_handle(ctx)?)?;
        op.add_input(&set1_shape.to_handle(ctx)?)?;
        op.add_input(&set2_indices.to_handle(ctx)?)?;
        op.add_input(&set2_values.to_handle(ctx)?)?;
        op.add_input(&set2_shape.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.set_operation {
            op.set_attr_string("set_operation", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.validate_indices {
            op.set_attr_bool("validate_indices", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `SparseToSparseSetOperation::new().call(&ctx, &set1_indices, &set1_values, &set1_shape, &set2_indices, &set2_values, &set2_shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SparseToSparseSetOperation>
pub fn sparse_to_sparse_set_operation<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    set1_indices: &T0,
    set1_values: &T1,
    set1_shape: &T2,
    set2_indices: &T3,
    set2_values: &T4,
    set2_shape: &T5,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = SparseToSparseSetOperation::new();
    op.call(
        ctx,
        set1_indices,
        set1_values,
        set1_shape,
        set2_indices,
        set2_values,
        set2_shape,
    )
}

/// Spence
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Spence>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Spence {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Spence {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Spence {
    /// Creates a new `Spence`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute spence.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Spence")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Spence::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Spence>
pub fn spence<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Spence::new();
    op.call(ctx, x)
}

/// Split
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Split>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Split {
    num_split: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Split {
    fn default() -> Self {
        Self {
            num_split: None,
            target_device_name: None,
        }
    }
}
impl Split {
    /// Creates a new `Split`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_split` attribute.
    pub fn num_split<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_split = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute split.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        split_dim: &T0,
        value: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Split")?;

        // Required input arguments
        op.add_input(&split_dim.to_handle(ctx)?)?;
        op.add_input(&value.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_split {
            op.set_attr_int("num_split", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Split::new().call(&ctx, &split_dim, &value)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Split>
pub fn split<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    split_dim: &T0,
    value: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Split::new();
    op.call(ctx, split_dim, value)
}

/// SplitV
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SplitV>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SplitV {
    num_split: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SplitV {
    fn default() -> Self {
        Self {
            num_split: None,
            target_device_name: None,
        }
    }
}
impl SplitV {
    /// Creates a new `SplitV`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_split` attribute.
    pub fn num_split<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_split = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute split_v.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        value: &T0,
        size_splits: &T1,
        split_dim: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SplitV")?;

        // Required input arguments
        op.add_input(&value.to_handle(ctx)?)?;
        op.add_input(&size_splits.to_handle(ctx)?)?;
        op.add_input(&split_dim.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_split {
            op.set_attr_int("num_split", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SplitV::new().call(&ctx, &value, &size_splits, &split_dim)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SplitV>
pub fn split_v<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    value: &T0,
    size_splits: &T1,
    split_dim: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SplitV::new();
    op.call(ctx, value, size_splits, split_dim)
}

/// SqlDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SqlDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SqlDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SqlDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl SqlDataset {
    /// Creates a new `SqlDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sql_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        driver_name: &T0,
        data_source_name: &T1,
        query: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SqlDataset")?;

        // Required input arguments
        op.add_input(&driver_name.to_handle(ctx)?)?;
        op.add_input(&data_source_name.to_handle(ctx)?)?;
        op.add_input(&query.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SqlDataset::new().call(&ctx, &driver_name, &data_source_name, &query)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SqlDataset>
pub fn sql_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    driver_name: &T0,
    data_source_name: &T1,
    query: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SqlDataset::new();
    op.call(ctx, driver_name, data_source_name, query)
}

/// Sqrt
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Sqrt>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Sqrt {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Sqrt {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Sqrt {
    /// Creates a new `Sqrt`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sqrt.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Sqrt")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Sqrt::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Sqrt>
pub fn sqrt<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Sqrt::new();
    op.call(ctx, x)
}

/// SqrtGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SqrtGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SqrtGrad {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SqrtGrad {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SqrtGrad {
    /// Creates a new `SqrtGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sqrt_grad.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        y: &T0,
        dy: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SqrtGrad")?;

        // Required input arguments
        op.add_input(&y.to_handle(ctx)?)?;
        op.add_input(&dy.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SqrtGrad::new().call(&ctx, &y, &dy)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SqrtGrad>
pub fn sqrt_grad<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    y: &T0,
    dy: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SqrtGrad::new();
    op.call(ctx, y, dy)
}

/// Square
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Square>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Square {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Square {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Square {
    /// Creates a new `Square`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute square.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Square")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Square::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Square>
pub fn square<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Square::new();
    op.call(ctx, x)
}

/// SquaredDifference
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SquaredDifference>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SquaredDifference {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SquaredDifference {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl SquaredDifference {
    /// Creates a new `SquaredDifference`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute squared_difference.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SquaredDifference")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SquaredDifference::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SquaredDifference>
pub fn squared_difference<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SquaredDifference::new();
    op.call(ctx, x, y)
}

/// Squeeze
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Squeeze>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Squeeze {
    squeeze_dims: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Squeeze {
    fn default() -> Self {
        Self {
            squeeze_dims: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl Squeeze {
    /// Creates a new `Squeeze`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `squeeze_dims` attribute.
    pub fn squeeze_dims<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.squeeze_dims = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute squeeze.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Squeeze")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.squeeze_dims {
            op.set_attr_int_list("squeeze_dims", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Squeeze::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Squeeze>
pub fn squeeze<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Squeeze::new();
    op.call(ctx, input)
}

/// Stack
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Stack>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Stack {
    elem_type: ::std::option::Option<crate::DataType>,
    stack_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Stack {
    fn default() -> Self {
        Self {
            elem_type: None,
            stack_name: None,
            target_device_name: None,
        }
    }
}
impl Stack {
    /// Creates a new `Stack`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `elem_type` attribute.
    pub fn elem_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.elem_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `stack_name` attribute.
    pub fn stack_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.stack_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stack.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Stack")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.elem_type {
            op.set_attr_type("elem_type", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.stack_name {
            op.set_attr_string("stack_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Stack::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Stack>
pub fn stack<'a>(ctx: &'a crate::eager::Context) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Stack::new();
    op.call(ctx)
}

/// StackClose
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StackClose>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StackClose {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StackClose {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl StackClose {
    /// Creates a new `StackClose`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stack_close.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "StackClose")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `StackClose::new().call(&ctx, &handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StackClose>
pub fn stack_close<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
) -> crate::Result<()> {
    let op = StackClose::new();
    op.call(ctx, handle)
}

/// StackCloseV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StackCloseV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StackCloseV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StackCloseV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl StackCloseV2 {
    /// Creates a new `StackCloseV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stack_close_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "StackCloseV2")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `StackCloseV2::new().call(&ctx, &handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StackCloseV2>
pub fn stack_close_v2<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
) -> crate::Result<()> {
    let op = StackCloseV2::new();
    op.call(ctx, handle)
}

/// StackPop
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StackPop>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StackPop {
    elem_type: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StackPop {
    fn default() -> Self {
        Self {
            elem_type: None,
            target_device_name: None,
        }
    }
}
impl StackPop {
    /// Creates a new `StackPop`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `elem_type` attribute.
    pub fn elem_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.elem_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stack_pop.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StackPop")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.elem_type {
            op.set_attr_type("elem_type", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StackPop::new().call(&ctx, &handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StackPop>
pub fn stack_pop<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StackPop::new();
    op.call(ctx, handle)
}

/// StackPopV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StackPopV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StackPopV2 {
    elem_type: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StackPopV2 {
    fn default() -> Self {
        Self {
            elem_type: None,
            target_device_name: None,
        }
    }
}
impl StackPopV2 {
    /// Creates a new `StackPopV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `elem_type` attribute.
    pub fn elem_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.elem_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stack_pop_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StackPopV2")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.elem_type {
            op.set_attr_type("elem_type", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StackPopV2::new().call(&ctx, &handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StackPopV2>
pub fn stack_pop_v2<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StackPopV2::new();
    op.call(ctx, handle)
}

/// StackPush
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StackPush>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StackPush {
    swap_memory: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StackPush {
    fn default() -> Self {
        Self {
            swap_memory: Some(false),
            target_device_name: None,
        }
    }
}
impl StackPush {
    /// Creates a new `StackPush`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `swap_memory` attribute.
    pub fn swap_memory<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.swap_memory = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stack_push.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        elem: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StackPush")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&elem.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.swap_memory {
            op.set_attr_bool("swap_memory", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StackPush::new().call(&ctx, &handle, &elem)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StackPush>
pub fn stack_push<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    elem: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StackPush::new();
    op.call(ctx, handle, elem)
}

/// StackPushV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StackPushV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StackPushV2 {
    swap_memory: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StackPushV2 {
    fn default() -> Self {
        Self {
            swap_memory: Some(false),
            target_device_name: None,
        }
    }
}
impl StackPushV2 {
    /// Creates a new `StackPushV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `swap_memory` attribute.
    pub fn swap_memory<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.swap_memory = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stack_push_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        elem: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StackPushV2")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&elem.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.swap_memory {
            op.set_attr_bool("swap_memory", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StackPushV2::new().call(&ctx, &handle, &elem)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StackPushV2>
pub fn stack_push_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    elem: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StackPushV2::new();
    op.call(ctx, handle, elem)
}

/// StackV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StackV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StackV2 {
    elem_type: ::std::option::Option<crate::DataType>,
    stack_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StackV2 {
    fn default() -> Self {
        Self {
            elem_type: None,
            stack_name: None,
            target_device_name: None,
        }
    }
}
impl StackV2 {
    /// Creates a new `StackV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `elem_type` attribute.
    pub fn elem_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.elem_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `stack_name` attribute.
    pub fn stack_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.stack_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stack_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        max_size: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StackV2")?;

        // Required input arguments
        op.add_input(&max_size.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.elem_type {
            op.set_attr_type("elem_type", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.stack_name {
            op.set_attr_string("stack_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StackV2::new().call(&ctx, &max_size)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StackV2>
pub fn stack_v2<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    max_size: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StackV2::new();
    op.call(ctx, max_size)
}

/// Stage
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Stage>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Stage {
    capacity: ::std::option::Option<i64>,
    memory_limit: ::std::option::Option<i64>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Stage {
    fn default() -> Self {
        Self {
            capacity: Some(0i64),
            memory_limit: Some(0i64),
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl Stage {
    /// Creates a new `Stage`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `capacity` attribute.
    pub fn capacity<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.capacity = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `memory_limit` attribute.
    pub fn memory_limit<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.memory_limit = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stage.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        values: &T0,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "Stage")?;

        // Required input arguments
        op.add_input(&values.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.capacity {
            op.set_attr_int("capacity", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.memory_limit {
            op.set_attr_int("memory_limit", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `Stage::new().call(&ctx, &values)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Stage>
pub fn stage<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    values: &T0,
) -> crate::Result<()> {
    let op = Stage::new();
    op.call(ctx, values)
}

/// StageClear
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StageClear>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StageClear {
    capacity: ::std::option::Option<i64>,
    memory_limit: ::std::option::Option<i64>,
    dtypes: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StageClear {
    fn default() -> Self {
        Self {
            capacity: Some(0i64),
            memory_limit: Some(0i64),
            dtypes: None,
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl StageClear {
    /// Creates a new `StageClear`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `capacity` attribute.
    pub fn capacity<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.capacity = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `memory_limit` attribute.
    pub fn memory_limit<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.memory_limit = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dtypes` attribute.
    pub fn dtypes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dtypes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stage_clear.
    pub fn call<'a>(&self, ctx: &'a crate::eager::Context) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "StageClear")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.capacity {
            op.set_attr_int("capacity", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.memory_limit {
            op.set_attr_int("memory_limit", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dtypes {
            op.set_attr_type_list("dtypes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `StageClear::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StageClear>
pub fn stage_clear<'a>(ctx: &'a crate::eager::Context) -> crate::Result<()> {
    let op = StageClear::new();
    op.call(ctx)
}

/// StagePeek
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StagePeek>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StagePeek {
    capacity: ::std::option::Option<i64>,
    memory_limit: ::std::option::Option<i64>,
    dtypes: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StagePeek {
    fn default() -> Self {
        Self {
            capacity: Some(0i64),
            memory_limit: Some(0i64),
            dtypes: None,
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl StagePeek {
    /// Creates a new `StagePeek`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `capacity` attribute.
    pub fn capacity<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.capacity = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `memory_limit` attribute.
    pub fn memory_limit<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.memory_limit = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dtypes` attribute.
    pub fn dtypes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dtypes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stage_peek.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        index: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StagePeek")?;

        // Required input arguments
        op.add_input(&index.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.capacity {
            op.set_attr_int("capacity", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.memory_limit {
            op.set_attr_int("memory_limit", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dtypes {
            op.set_attr_type_list("dtypes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StagePeek::new().call(&ctx, &index)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StagePeek>
pub fn stage_peek<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    index: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StagePeek::new();
    op.call(ctx, index)
}

/// StageSize
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StageSize>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StageSize {
    capacity: ::std::option::Option<i64>,
    memory_limit: ::std::option::Option<i64>,
    dtypes: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StageSize {
    fn default() -> Self {
        Self {
            capacity: Some(0i64),
            memory_limit: Some(0i64),
            dtypes: None,
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl StageSize {
    /// Creates a new `StageSize`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `capacity` attribute.
    pub fn capacity<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.capacity = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `memory_limit` attribute.
    pub fn memory_limit<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.memory_limit = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dtypes` attribute.
    pub fn dtypes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dtypes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stage_size.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StageSize")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.capacity {
            op.set_attr_int("capacity", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.memory_limit {
            op.set_attr_int("memory_limit", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dtypes {
            op.set_attr_type_list("dtypes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StageSize::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StageSize>
pub fn stage_size<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StageSize::new();
    op.call(ctx)
}

/// StatefulPartitionedCall
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatefulPartitionedCall>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StatefulPartitionedCall {
    Tout: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    f: ::std::option::Option<::std::string::String>,
    config: ::std::option::Option<::std::string::String>,
    config_proto: ::std::option::Option<::std::string::String>,
    executor_type: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StatefulPartitionedCall {
    fn default() -> Self {
        Self {
            Tout: None,
            f: None,
            config: None,
            config_proto: None,
            executor_type: None,
            target_device_name: None,
        }
    }
}
impl StatefulPartitionedCall {
    /// Creates a new `StatefulPartitionedCall`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Tout` attribute.
    pub fn Tout<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Tout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `f` attribute.
    pub fn f<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.f = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `config_proto` attribute.
    pub fn config_proto<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config_proto = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `executor_type` attribute.
    pub fn executor_type<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.executor_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stateful_partitioned_call.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        args: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StatefulPartitionedCall")?;

        // Required input arguments
        op.add_input(&args.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Tout {
            op.set_attr_type_list("Tout", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.f {
            op.set_attr_string("f", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.config_proto {
            op.set_attr_string("config_proto", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.executor_type {
            op.set_attr_string("executor_type", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StatefulPartitionedCall::new().call(&ctx, &args)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatefulPartitionedCall>
pub fn stateful_partitioned_call<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    args: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StatefulPartitionedCall::new();
    op.call(ctx, args)
}

/// StatefulRandomBinomial
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatefulRandomBinomial>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StatefulRandomBinomial {
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StatefulRandomBinomial {
    fn default() -> Self {
        Self {
            dtype: Some(crate::DataType::Int64),
            target_device_name: None,
        }
    }
}
impl StatefulRandomBinomial {
    /// Creates a new `StatefulRandomBinomial`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stateful_random_binomial.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        resource: &T0,
        algorithm: &T1,
        shape: &T2,
        counts: &T3,
        probs: &T4,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StatefulRandomBinomial")?;

        // Required input arguments
        op.add_input(&resource.to_handle(ctx)?)?;
        op.add_input(&algorithm.to_handle(ctx)?)?;
        op.add_input(&shape.to_handle(ctx)?)?;
        op.add_input(&counts.to_handle(ctx)?)?;
        op.add_input(&probs.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StatefulRandomBinomial::new().call(&ctx, &resource, &algorithm, &shape, &counts, &probs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatefulRandomBinomial>
pub fn stateful_random_binomial<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    resource: &T0,
    algorithm: &T1,
    shape: &T2,
    counts: &T3,
    probs: &T4,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StatefulRandomBinomial::new();
    op.call(ctx, resource, algorithm, shape, counts, probs)
}

/// StatefulStandardNormal
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatefulStandardNormal>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StatefulStandardNormal {
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StatefulStandardNormal {
    fn default() -> Self {
        Self {
            dtype: Some(crate::DataType::Float),
            target_device_name: None,
        }
    }
}
impl StatefulStandardNormal {
    /// Creates a new `StatefulStandardNormal`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stateful_standard_normal.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        resource: &T0,
        shape: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StatefulStandardNormal")?;

        // Required input arguments
        op.add_input(&resource.to_handle(ctx)?)?;
        op.add_input(&shape.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StatefulStandardNormal::new().call(&ctx, &resource, &shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatefulStandardNormal>
pub fn stateful_standard_normal<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    resource: &T0,
    shape: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StatefulStandardNormal::new();
    op.call(ctx, resource, shape)
}

/// StatefulStandardNormalV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatefulStandardNormalV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StatefulStandardNormalV2 {
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StatefulStandardNormalV2 {
    fn default() -> Self {
        Self {
            dtype: Some(crate::DataType::Float),
            target_device_name: None,
        }
    }
}
impl StatefulStandardNormalV2 {
    /// Creates a new `StatefulStandardNormalV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stateful_standard_normal_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        resource: &T0,
        algorithm: &T1,
        shape: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StatefulStandardNormalV2")?;

        // Required input arguments
        op.add_input(&resource.to_handle(ctx)?)?;
        op.add_input(&algorithm.to_handle(ctx)?)?;
        op.add_input(&shape.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StatefulStandardNormalV2::new().call(&ctx, &resource, &algorithm, &shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatefulStandardNormalV2>
pub fn stateful_standard_normal_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    resource: &T0,
    algorithm: &T1,
    shape: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StatefulStandardNormalV2::new();
    op.call(ctx, resource, algorithm, shape)
}

/// StatefulTruncatedNormal
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatefulTruncatedNormal>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StatefulTruncatedNormal {
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StatefulTruncatedNormal {
    fn default() -> Self {
        Self {
            dtype: Some(crate::DataType::Float),
            target_device_name: None,
        }
    }
}
impl StatefulTruncatedNormal {
    /// Creates a new `StatefulTruncatedNormal`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stateful_truncated_normal.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        resource: &T0,
        algorithm: &T1,
        shape: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StatefulTruncatedNormal")?;

        // Required input arguments
        op.add_input(&resource.to_handle(ctx)?)?;
        op.add_input(&algorithm.to_handle(ctx)?)?;
        op.add_input(&shape.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StatefulTruncatedNormal::new().call(&ctx, &resource, &algorithm, &shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatefulTruncatedNormal>
pub fn stateful_truncated_normal<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    resource: &T0,
    algorithm: &T1,
    shape: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StatefulTruncatedNormal::new();
    op.call(ctx, resource, algorithm, shape)
}

/// StatefulUniform
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatefulUniform>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StatefulUniform {
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StatefulUniform {
    fn default() -> Self {
        Self {
            dtype: Some(crate::DataType::Float),
            target_device_name: None,
        }
    }
}
impl StatefulUniform {
    /// Creates a new `StatefulUniform`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stateful_uniform.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        resource: &T0,
        algorithm: &T1,
        shape: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StatefulUniform")?;

        // Required input arguments
        op.add_input(&resource.to_handle(ctx)?)?;
        op.add_input(&algorithm.to_handle(ctx)?)?;
        op.add_input(&shape.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StatefulUniform::new().call(&ctx, &resource, &algorithm, &shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatefulUniform>
pub fn stateful_uniform<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    resource: &T0,
    algorithm: &T1,
    shape: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StatefulUniform::new();
    op.call(ctx, resource, algorithm, shape)
}

/// StatefulUniformFullInt
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatefulUniformFullInt>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StatefulUniformFullInt {
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StatefulUniformFullInt {
    fn default() -> Self {
        Self {
            dtype: Some(crate::DataType::UInt64),
            target_device_name: None,
        }
    }
}
impl StatefulUniformFullInt {
    /// Creates a new `StatefulUniformFullInt`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stateful_uniform_full_int.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        resource: &T0,
        algorithm: &T1,
        shape: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StatefulUniformFullInt")?;

        // Required input arguments
        op.add_input(&resource.to_handle(ctx)?)?;
        op.add_input(&algorithm.to_handle(ctx)?)?;
        op.add_input(&shape.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StatefulUniformFullInt::new().call(&ctx, &resource, &algorithm, &shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatefulUniformFullInt>
pub fn stateful_uniform_full_int<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    resource: &T0,
    algorithm: &T1,
    shape: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StatefulUniformFullInt::new();
    op.call(ctx, resource, algorithm, shape)
}

/// StatefulUniformInt
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatefulUniformInt>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StatefulUniformInt {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StatefulUniformInt {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl StatefulUniformInt {
    /// Creates a new `StatefulUniformInt`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stateful_uniform_int.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        resource: &T0,
        algorithm: &T1,
        shape: &T2,
        minval: &T3,
        maxval: &T4,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StatefulUniformInt")?;

        // Required input arguments
        op.add_input(&resource.to_handle(ctx)?)?;
        op.add_input(&algorithm.to_handle(ctx)?)?;
        op.add_input(&shape.to_handle(ctx)?)?;
        op.add_input(&minval.to_handle(ctx)?)?;
        op.add_input(&maxval.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StatefulUniformInt::new().call(&ctx, &resource, &algorithm, &shape, &minval, &maxval)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatefulUniformInt>
pub fn stateful_uniform_int<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    resource: &T0,
    algorithm: &T1,
    shape: &T2,
    minval: &T3,
    maxval: &T4,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StatefulUniformInt::new();
    op.call(ctx, resource, algorithm, shape, minval, maxval)
}

/// StatelessCase
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessCase>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StatelessCase {
    Tout: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    branches: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StatelessCase {
    fn default() -> Self {
        Self {
            Tout: None,
            branches: None,
            output_shapes: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl StatelessCase {
    /// Creates a new `StatelessCase`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Tout` attribute.
    pub fn Tout<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Tout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `branches` attribute.
    pub fn branches<ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.branches = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stateless_case.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        branch_index: &T0,
        input: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StatelessCase")?;

        // Required input arguments
        op.add_input(&branch_index.to_handle(ctx)?)?;
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Tout {
            op.set_attr_type_list("Tout", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.branches {
            op.set_attr_string_list("branches", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StatelessCase::new().call(&ctx, &branch_index, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessCase>
pub fn stateless_case<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    branch_index: &T0,
    input: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StatelessCase::new();
    op.call(ctx, branch_index, input)
}

/// StatelessIf
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessIf>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StatelessIf {
    Tout: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    then_branch: ::std::option::Option<::std::string::String>,
    else_branch: ::std::option::Option<::std::string::String>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StatelessIf {
    fn default() -> Self {
        Self {
            Tout: None,
            then_branch: None,
            else_branch: None,
            output_shapes: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl StatelessIf {
    /// Creates a new `StatelessIf`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Tout` attribute.
    pub fn Tout<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Tout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `then_branch` attribute.
    pub fn then_branch<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.then_branch = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `else_branch` attribute.
    pub fn else_branch<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.else_branch = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stateless_if.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        cond: &T0,
        input: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StatelessIf")?;

        // Required input arguments
        op.add_input(&cond.to_handle(ctx)?)?;
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Tout {
            op.set_attr_type_list("Tout", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.then_branch {
            op.set_attr_string("then_branch", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.else_branch {
            op.set_attr_string("else_branch", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StatelessIf::new().call(&ctx, &cond, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessIf>
pub fn stateless_if<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    cond: &T0,
    input: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StatelessIf::new();
    op.call(ctx, cond, input)
}

/// StatelessMultinomial
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessMultinomial>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StatelessMultinomial {
    output_dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StatelessMultinomial {
    fn default() -> Self {
        Self {
            output_dtype: Some(crate::DataType::Int64),
            target_device_name: None,
        }
    }
}
impl StatelessMultinomial {
    /// Creates a new `StatelessMultinomial`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_dtype` attribute.
    pub fn output_dtype<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stateless_multinomial.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        logits: &T0,
        num_samples: &T1,
        seed: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StatelessMultinomial")?;

        // Required input arguments
        op.add_input(&logits.to_handle(ctx)?)?;
        op.add_input(&num_samples.to_handle(ctx)?)?;
        op.add_input(&seed.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_dtype {
            op.set_attr_type("output_dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StatelessMultinomial::new().call(&ctx, &logits, &num_samples, &seed)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessMultinomial>
pub fn stateless_multinomial<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    logits: &T0,
    num_samples: &T1,
    seed: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StatelessMultinomial::new();
    op.call(ctx, logits, num_samples, seed)
}

/// StatelessParameterizedTruncatedNormal
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessParameterizedTruncatedNormal>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StatelessParameterizedTruncatedNormal {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StatelessParameterizedTruncatedNormal {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl StatelessParameterizedTruncatedNormal {
    /// Creates a new `StatelessParameterizedTruncatedNormal`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stateless_parameterized_truncated_normal.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        shape: &T0,
        seed: &T1,
        means: &T2,
        stddevs: &T3,
        minvals: &T4,
        maxvals: &T5,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StatelessParameterizedTruncatedNormal")?;

        // Required input arguments
        op.add_input(&shape.to_handle(ctx)?)?;
        op.add_input(&seed.to_handle(ctx)?)?;
        op.add_input(&means.to_handle(ctx)?)?;
        op.add_input(&stddevs.to_handle(ctx)?)?;
        op.add_input(&minvals.to_handle(ctx)?)?;
        op.add_input(&maxvals.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StatelessParameterizedTruncatedNormal::new().call(&ctx, &shape, &seed, &means, &stddevs, &minvals, &maxvals)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessParameterizedTruncatedNormal>
pub fn stateless_parameterized_truncated_normal<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    shape: &T0,
    seed: &T1,
    means: &T2,
    stddevs: &T3,
    minvals: &T4,
    maxvals: &T5,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StatelessParameterizedTruncatedNormal::new();
    op.call(ctx, shape, seed, means, stddevs, minvals, maxvals)
}

/// StatelessRandomBinomial
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessRandomBinomial>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StatelessRandomBinomial {
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StatelessRandomBinomial {
    fn default() -> Self {
        Self {
            dtype: Some(crate::DataType::Int64),
            target_device_name: None,
        }
    }
}
impl StatelessRandomBinomial {
    /// Creates a new `StatelessRandomBinomial`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stateless_random_binomial.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        shape: &T0,
        seed: &T1,
        counts: &T2,
        probs: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StatelessRandomBinomial")?;

        // Required input arguments
        op.add_input(&shape.to_handle(ctx)?)?;
        op.add_input(&seed.to_handle(ctx)?)?;
        op.add_input(&counts.to_handle(ctx)?)?;
        op.add_input(&probs.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StatelessRandomBinomial::new().call(&ctx, &shape, &seed, &counts, &probs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessRandomBinomial>
pub fn stateless_random_binomial<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    shape: &T0,
    seed: &T1,
    counts: &T2,
    probs: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StatelessRandomBinomial::new();
    op.call(ctx, shape, seed, counts, probs)
}

/// StatelessRandomGammaV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessRandomGammaV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StatelessRandomGammaV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StatelessRandomGammaV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl StatelessRandomGammaV2 {
    /// Creates a new `StatelessRandomGammaV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stateless_random_gamma_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        shape: &T0,
        seed: &T1,
        alpha: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StatelessRandomGammaV2")?;

        // Required input arguments
        op.add_input(&shape.to_handle(ctx)?)?;
        op.add_input(&seed.to_handle(ctx)?)?;
        op.add_input(&alpha.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StatelessRandomGammaV2::new().call(&ctx, &shape, &seed, &alpha)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessRandomGammaV2>
pub fn stateless_random_gamma_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    shape: &T0,
    seed: &T1,
    alpha: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StatelessRandomGammaV2::new();
    op.call(ctx, shape, seed, alpha)
}

/// StatelessRandomGetAlg
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessRandomGetAlg>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StatelessRandomGetAlg {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StatelessRandomGetAlg {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl StatelessRandomGetAlg {
    /// Creates a new `StatelessRandomGetAlg`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stateless_random_get_alg.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StatelessRandomGetAlg")?;

        // Required input arguments

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StatelessRandomGetAlg::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessRandomGetAlg>
pub fn stateless_random_get_alg<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StatelessRandomGetAlg::new();
    op.call(ctx)
}

/// StatelessRandomGetKeyCounter
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessRandomGetKeyCounter>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StatelessRandomGetKeyCounter {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StatelessRandomGetKeyCounter {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl StatelessRandomGetKeyCounter {
    /// Creates a new `StatelessRandomGetKeyCounter`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stateless_random_get_key_counter.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        seed: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "StatelessRandomGetKeyCounter")?;

        // Required input arguments
        op.add_input(&seed.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `StatelessRandomGetKeyCounter::new().call(&ctx, &seed)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessRandomGetKeyCounter>
pub fn stateless_random_get_key_counter<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    seed: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = StatelessRandomGetKeyCounter::new();
    op.call(ctx, seed)
}

/// StatelessRandomGetKeyCounterAlg
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessRandomGetKeyCounterAlg>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StatelessRandomGetKeyCounterAlg {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StatelessRandomGetKeyCounterAlg {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl StatelessRandomGetKeyCounterAlg {
    /// Creates a new `StatelessRandomGetKeyCounterAlg`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stateless_random_get_key_counter_alg.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        seed: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "StatelessRandomGetKeyCounterAlg")?;

        // Required input arguments
        op.add_input(&seed.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `StatelessRandomGetKeyCounterAlg::new().call(&ctx, &seed)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessRandomGetKeyCounterAlg>
pub fn stateless_random_get_key_counter_alg<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    seed: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = StatelessRandomGetKeyCounterAlg::new();
    op.call(ctx, seed)
}

/// StatelessRandomNormal
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessRandomNormal>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StatelessRandomNormal {
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StatelessRandomNormal {
    fn default() -> Self {
        Self {
            dtype: Some(crate::DataType::Float),
            target_device_name: None,
        }
    }
}
impl StatelessRandomNormal {
    /// Creates a new `StatelessRandomNormal`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stateless_random_normal.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        shape: &T0,
        seed: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StatelessRandomNormal")?;

        // Required input arguments
        op.add_input(&shape.to_handle(ctx)?)?;
        op.add_input(&seed.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StatelessRandomNormal::new().call(&ctx, &shape, &seed)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessRandomNormal>
pub fn stateless_random_normal<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    shape: &T0,
    seed: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StatelessRandomNormal::new();
    op.call(ctx, shape, seed)
}

/// StatelessRandomNormalV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessRandomNormalV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StatelessRandomNormalV2 {
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StatelessRandomNormalV2 {
    fn default() -> Self {
        Self {
            dtype: Some(crate::DataType::Float),
            target_device_name: None,
        }
    }
}
impl StatelessRandomNormalV2 {
    /// Creates a new `StatelessRandomNormalV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stateless_random_normal_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        shape: &T0,
        key: &T1,
        counter: &T2,
        alg: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StatelessRandomNormalV2")?;

        // Required input arguments
        op.add_input(&shape.to_handle(ctx)?)?;
        op.add_input(&key.to_handle(ctx)?)?;
        op.add_input(&counter.to_handle(ctx)?)?;
        op.add_input(&alg.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StatelessRandomNormalV2::new().call(&ctx, &shape, &key, &counter, &alg)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessRandomNormalV2>
pub fn stateless_random_normal_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    shape: &T0,
    key: &T1,
    counter: &T2,
    alg: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StatelessRandomNormalV2::new();
    op.call(ctx, shape, key, counter, alg)
}

/// StatelessRandomPoisson
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessRandomPoisson>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StatelessRandomPoisson {
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StatelessRandomPoisson {
    fn default() -> Self {
        Self {
            dtype: None,
            target_device_name: None,
        }
    }
}
impl StatelessRandomPoisson {
    /// Creates a new `StatelessRandomPoisson`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stateless_random_poisson.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        shape: &T0,
        seed: &T1,
        lam: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StatelessRandomPoisson")?;

        // Required input arguments
        op.add_input(&shape.to_handle(ctx)?)?;
        op.add_input(&seed.to_handle(ctx)?)?;
        op.add_input(&lam.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StatelessRandomPoisson::new().call(&ctx, &shape, &seed, &lam)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessRandomPoisson>
pub fn stateless_random_poisson<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    shape: &T0,
    seed: &T1,
    lam: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StatelessRandomPoisson::new();
    op.call(ctx, shape, seed, lam)
}

/// StatelessRandomUniform
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessRandomUniform>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StatelessRandomUniform {
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StatelessRandomUniform {
    fn default() -> Self {
        Self {
            dtype: Some(crate::DataType::Float),
            target_device_name: None,
        }
    }
}
impl StatelessRandomUniform {
    /// Creates a new `StatelessRandomUniform`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stateless_random_uniform.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        shape: &T0,
        seed: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StatelessRandomUniform")?;

        // Required input arguments
        op.add_input(&shape.to_handle(ctx)?)?;
        op.add_input(&seed.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StatelessRandomUniform::new().call(&ctx, &shape, &seed)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessRandomUniform>
pub fn stateless_random_uniform<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    shape: &T0,
    seed: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StatelessRandomUniform::new();
    op.call(ctx, shape, seed)
}

/// StatelessRandomUniformFullInt
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessRandomUniformFullInt>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StatelessRandomUniformFullInt {
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StatelessRandomUniformFullInt {
    fn default() -> Self {
        Self {
            dtype: Some(crate::DataType::UInt64),
            target_device_name: None,
        }
    }
}
impl StatelessRandomUniformFullInt {
    /// Creates a new `StatelessRandomUniformFullInt`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stateless_random_uniform_full_int.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        shape: &T0,
        seed: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StatelessRandomUniformFullInt")?;

        // Required input arguments
        op.add_input(&shape.to_handle(ctx)?)?;
        op.add_input(&seed.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StatelessRandomUniformFullInt::new().call(&ctx, &shape, &seed)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessRandomUniformFullInt>
pub fn stateless_random_uniform_full_int<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    shape: &T0,
    seed: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StatelessRandomUniformFullInt::new();
    op.call(ctx, shape, seed)
}

/// StatelessRandomUniformFullIntV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessRandomUniformFullIntV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StatelessRandomUniformFullIntV2 {
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StatelessRandomUniformFullIntV2 {
    fn default() -> Self {
        Self {
            dtype: Some(crate::DataType::UInt64),
            target_device_name: None,
        }
    }
}
impl StatelessRandomUniformFullIntV2 {
    /// Creates a new `StatelessRandomUniformFullIntV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stateless_random_uniform_full_int_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        shape: &T0,
        key: &T1,
        counter: &T2,
        alg: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StatelessRandomUniformFullIntV2")?;

        // Required input arguments
        op.add_input(&shape.to_handle(ctx)?)?;
        op.add_input(&key.to_handle(ctx)?)?;
        op.add_input(&counter.to_handle(ctx)?)?;
        op.add_input(&alg.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StatelessRandomUniformFullIntV2::new().call(&ctx, &shape, &key, &counter, &alg)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessRandomUniformFullIntV2>
pub fn stateless_random_uniform_full_int_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    shape: &T0,
    key: &T1,
    counter: &T2,
    alg: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StatelessRandomUniformFullIntV2::new();
    op.call(ctx, shape, key, counter, alg)
}

/// StatelessRandomUniformInt
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessRandomUniformInt>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StatelessRandomUniformInt {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StatelessRandomUniformInt {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl StatelessRandomUniformInt {
    /// Creates a new `StatelessRandomUniformInt`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stateless_random_uniform_int.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        shape: &T0,
        seed: &T1,
        minval: &T2,
        maxval: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StatelessRandomUniformInt")?;

        // Required input arguments
        op.add_input(&shape.to_handle(ctx)?)?;
        op.add_input(&seed.to_handle(ctx)?)?;
        op.add_input(&minval.to_handle(ctx)?)?;
        op.add_input(&maxval.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StatelessRandomUniformInt::new().call(&ctx, &shape, &seed, &minval, &maxval)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessRandomUniformInt>
pub fn stateless_random_uniform_int<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    shape: &T0,
    seed: &T1,
    minval: &T2,
    maxval: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StatelessRandomUniformInt::new();
    op.call(ctx, shape, seed, minval, maxval)
}

/// StatelessRandomUniformIntV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessRandomUniformIntV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StatelessRandomUniformIntV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StatelessRandomUniformIntV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl StatelessRandomUniformIntV2 {
    /// Creates a new `StatelessRandomUniformIntV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stateless_random_uniform_int_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        shape: &T0,
        key: &T1,
        counter: &T2,
        alg: &T3,
        minval: &T4,
        maxval: &T5,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StatelessRandomUniformIntV2")?;

        // Required input arguments
        op.add_input(&shape.to_handle(ctx)?)?;
        op.add_input(&key.to_handle(ctx)?)?;
        op.add_input(&counter.to_handle(ctx)?)?;
        op.add_input(&alg.to_handle(ctx)?)?;
        op.add_input(&minval.to_handle(ctx)?)?;
        op.add_input(&maxval.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StatelessRandomUniformIntV2::new().call(&ctx, &shape, &key, &counter, &alg, &minval, &maxval)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessRandomUniformIntV2>
pub fn stateless_random_uniform_int_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    shape: &T0,
    key: &T1,
    counter: &T2,
    alg: &T3,
    minval: &T4,
    maxval: &T5,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StatelessRandomUniformIntV2::new();
    op.call(ctx, shape, key, counter, alg, minval, maxval)
}

/// StatelessRandomUniformV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessRandomUniformV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StatelessRandomUniformV2 {
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StatelessRandomUniformV2 {
    fn default() -> Self {
        Self {
            dtype: Some(crate::DataType::Float),
            target_device_name: None,
        }
    }
}
impl StatelessRandomUniformV2 {
    /// Creates a new `StatelessRandomUniformV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stateless_random_uniform_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        shape: &T0,
        key: &T1,
        counter: &T2,
        alg: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StatelessRandomUniformV2")?;

        // Required input arguments
        op.add_input(&shape.to_handle(ctx)?)?;
        op.add_input(&key.to_handle(ctx)?)?;
        op.add_input(&counter.to_handle(ctx)?)?;
        op.add_input(&alg.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StatelessRandomUniformV2::new().call(&ctx, &shape, &key, &counter, &alg)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessRandomUniformV2>
pub fn stateless_random_uniform_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    shape: &T0,
    key: &T1,
    counter: &T2,
    alg: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StatelessRandomUniformV2::new();
    op.call(ctx, shape, key, counter, alg)
}

/// StatelessSampleDistortedBoundingBox
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessSampleDistortedBoundingBox>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StatelessSampleDistortedBoundingBox {
    aspect_ratio_range: ::std::option::Option<::std::vec::Vec<f32>>,
    area_range: ::std::option::Option<::std::vec::Vec<f32>>,
    max_attempts: ::std::option::Option<i64>,
    use_image_if_no_bounding_boxes: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StatelessSampleDistortedBoundingBox {
    fn default() -> Self {
        Self {
            aspect_ratio_range: Some(vec![0.75, 1.33]),
            area_range: Some(vec![0.05, 1.0]),
            max_attempts: Some(100i64),
            use_image_if_no_bounding_boxes: Some(false),
            target_device_name: None,
        }
    }
}
impl StatelessSampleDistortedBoundingBox {
    /// Creates a new `StatelessSampleDistortedBoundingBox`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `aspect_ratio_range` attribute.
    pub fn aspect_ratio_range<ArgType: ::std::convert::Into<::std::vec::Vec<f32>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.aspect_ratio_range = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `area_range` attribute.
    pub fn area_range<ArgType: ::std::convert::Into<::std::vec::Vec<f32>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.area_range = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `max_attempts` attribute.
    pub fn max_attempts<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.max_attempts = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_image_if_no_bounding_boxes` attribute.
    pub fn use_image_if_no_bounding_boxes<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.use_image_if_no_bounding_boxes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stateless_sample_distorted_bounding_box.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        image_size: &T0,
        bounding_boxes: &T1,
        min_object_covered: &T2,
        seed: &T3,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "StatelessSampleDistortedBoundingBox")?;

        // Required input arguments
        op.add_input(&image_size.to_handle(ctx)?)?;
        op.add_input(&bounding_boxes.to_handle(ctx)?)?;
        op.add_input(&min_object_covered.to_handle(ctx)?)?;
        op.add_input(&seed.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.aspect_ratio_range {
            op.set_attr_float_list("aspect_ratio_range", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.area_range {
            op.set_attr_float_list("area_range", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.max_attempts {
            op.set_attr_int("max_attempts", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_image_if_no_bounding_boxes {
            op.set_attr_bool("use_image_if_no_bounding_boxes", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `StatelessSampleDistortedBoundingBox::new().call(&ctx, &image_size, &bounding_boxes, &min_object_covered, &seed)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessSampleDistortedBoundingBox>
pub fn stateless_sample_distorted_bounding_box<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    image_size: &T0,
    bounding_boxes: &T1,
    min_object_covered: &T2,
    seed: &T3,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = StatelessSampleDistortedBoundingBox::new();
    op.call(ctx, image_size, bounding_boxes, min_object_covered, seed)
}

/// StatelessShuffle
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessShuffle>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StatelessShuffle {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StatelessShuffle {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl StatelessShuffle {
    /// Creates a new `StatelessShuffle`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stateless_shuffle.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        value: &T0,
        key: &T1,
        counter: &T2,
        alg: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StatelessShuffle")?;

        // Required input arguments
        op.add_input(&value.to_handle(ctx)?)?;
        op.add_input(&key.to_handle(ctx)?)?;
        op.add_input(&counter.to_handle(ctx)?)?;
        op.add_input(&alg.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StatelessShuffle::new().call(&ctx, &value, &key, &counter, &alg)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessShuffle>
pub fn stateless_shuffle<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    value: &T0,
    key: &T1,
    counter: &T2,
    alg: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StatelessShuffle::new();
    op.call(ctx, value, key, counter, alg)
}

/// StatelessTruncatedNormal
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessTruncatedNormal>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StatelessTruncatedNormal {
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StatelessTruncatedNormal {
    fn default() -> Self {
        Self {
            dtype: Some(crate::DataType::Float),
            target_device_name: None,
        }
    }
}
impl StatelessTruncatedNormal {
    /// Creates a new `StatelessTruncatedNormal`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stateless_truncated_normal.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        shape: &T0,
        seed: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StatelessTruncatedNormal")?;

        // Required input arguments
        op.add_input(&shape.to_handle(ctx)?)?;
        op.add_input(&seed.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StatelessTruncatedNormal::new().call(&ctx, &shape, &seed)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessTruncatedNormal>
pub fn stateless_truncated_normal<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    shape: &T0,
    seed: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StatelessTruncatedNormal::new();
    op.call(ctx, shape, seed)
}

/// StatelessTruncatedNormalV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessTruncatedNormalV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StatelessTruncatedNormalV2 {
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StatelessTruncatedNormalV2 {
    fn default() -> Self {
        Self {
            dtype: Some(crate::DataType::Float),
            target_device_name: None,
        }
    }
}
impl StatelessTruncatedNormalV2 {
    /// Creates a new `StatelessTruncatedNormalV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stateless_truncated_normal_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        shape: &T0,
        key: &T1,
        counter: &T2,
        alg: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StatelessTruncatedNormalV2")?;

        // Required input arguments
        op.add_input(&shape.to_handle(ctx)?)?;
        op.add_input(&key.to_handle(ctx)?)?;
        op.add_input(&counter.to_handle(ctx)?)?;
        op.add_input(&alg.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StatelessTruncatedNormalV2::new().call(&ctx, &shape, &key, &counter, &alg)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessTruncatedNormalV2>
pub fn stateless_truncated_normal_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    shape: &T0,
    key: &T1,
    counter: &T2,
    alg: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StatelessTruncatedNormalV2::new();
    op.call(ctx, shape, key, counter, alg)
}

/// StatelessWhile
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessWhile>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StatelessWhile {
    cond: ::std::option::Option<::std::string::String>,
    body: ::std::option::Option<::std::string::String>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    parallel_iterations: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StatelessWhile {
    fn default() -> Self {
        Self {
            cond: None,
            body: None,
            output_shapes: Some(vec![]),
            parallel_iterations: Some(10i64),
            target_device_name: None,
        }
    }
}
impl StatelessWhile {
    /// Creates a new `StatelessWhile`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `cond` attribute.
    pub fn cond<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.cond = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `body` attribute.
    pub fn body<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.body = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `parallel_iterations` attribute.
    pub fn parallel_iterations<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.parallel_iterations = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stateless_while.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StatelessWhile")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.cond {
            op.set_attr_string("cond", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.body {
            op.set_attr_string("body", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.parallel_iterations {
            op.set_attr_int("parallel_iterations", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StatelessWhile::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatelessWhile>
pub fn stateless_while<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StatelessWhile::new();
    op.call(ctx, input)
}

/// StaticRegexFullMatch
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StaticRegexFullMatch>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StaticRegexFullMatch {
    pattern: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StaticRegexFullMatch {
    fn default() -> Self {
        Self {
            pattern: None,
            target_device_name: None,
        }
    }
}
impl StaticRegexFullMatch {
    /// Creates a new `StaticRegexFullMatch`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `pattern` attribute.
    pub fn pattern<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.pattern = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute static_regex_full_match.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StaticRegexFullMatch")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.pattern {
            op.set_attr_string("pattern", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StaticRegexFullMatch::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StaticRegexFullMatch>
pub fn static_regex_full_match<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StaticRegexFullMatch::new();
    op.call(ctx, input)
}

/// StaticRegexReplace
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StaticRegexReplace>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StaticRegexReplace {
    pattern: ::std::option::Option<::std::string::String>,
    rewrite: ::std::option::Option<::std::string::String>,
    replace_global: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StaticRegexReplace {
    fn default() -> Self {
        Self {
            pattern: None,
            rewrite: None,
            replace_global: Some(true),
            target_device_name: None,
        }
    }
}
impl StaticRegexReplace {
    /// Creates a new `StaticRegexReplace`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `pattern` attribute.
    pub fn pattern<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.pattern = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `rewrite` attribute.
    pub fn rewrite<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.rewrite = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `replace_global` attribute.
    pub fn replace_global<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.replace_global = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute static_regex_replace.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StaticRegexReplace")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.pattern {
            op.set_attr_string("pattern", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.rewrite {
            op.set_attr_string("rewrite", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.replace_global {
            op.set_attr_bool("replace_global", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StaticRegexReplace::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StaticRegexReplace>
pub fn static_regex_replace<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StaticRegexReplace::new();
    op.call(ctx, input)
}

/// StatsAggregatorHandle
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatsAggregatorHandle>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StatsAggregatorHandle {
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StatsAggregatorHandle {
    fn default() -> Self {
        Self {
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl StatsAggregatorHandle {
    /// Creates a new `StatsAggregatorHandle`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stats_aggregator_handle.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StatsAggregatorHandle")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StatsAggregatorHandle::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatsAggregatorHandle>
pub fn stats_aggregator_handle<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StatsAggregatorHandle::new();
    op.call(ctx)
}

/// StatsAggregatorHandleV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatsAggregatorHandleV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StatsAggregatorHandleV2 {
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StatsAggregatorHandleV2 {
    fn default() -> Self {
        Self {
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl StatsAggregatorHandleV2 {
    /// Creates a new `StatsAggregatorHandleV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stats_aggregator_handle_v2.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StatsAggregatorHandleV2")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StatsAggregatorHandleV2::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatsAggregatorHandleV2>
pub fn stats_aggregator_handle_v2<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StatsAggregatorHandleV2::new();
    op.call(ctx)
}

/// StatsAggregatorSetSummaryWriter
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatsAggregatorSetSummaryWriter>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StatsAggregatorSetSummaryWriter {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StatsAggregatorSetSummaryWriter {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl StatsAggregatorSetSummaryWriter {
    /// Creates a new `StatsAggregatorSetSummaryWriter`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stats_aggregator_set_summary_writer.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        stats_aggregator: &T0,
        summary: &T1,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "StatsAggregatorSetSummaryWriter")?;

        // Required input arguments
        op.add_input(&stats_aggregator.to_handle(ctx)?)?;
        op.add_input(&summary.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `StatsAggregatorSetSummaryWriter::new().call(&ctx, &stats_aggregator, &summary)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatsAggregatorSetSummaryWriter>
pub fn stats_aggregator_set_summary_writer<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    stats_aggregator: &T0,
    summary: &T1,
) -> crate::Result<()> {
    let op = StatsAggregatorSetSummaryWriter::new();
    op.call(ctx, stats_aggregator, summary)
}

/// StatsAggregatorSummary
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatsAggregatorSummary>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StatsAggregatorSummary {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StatsAggregatorSummary {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl StatsAggregatorSummary {
    /// Creates a new `StatsAggregatorSummary`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stats_aggregator_summary.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        iterator: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StatsAggregatorSummary")?;

        // Required input arguments
        op.add_input(&iterator.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StatsAggregatorSummary::new().call(&ctx, &iterator)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StatsAggregatorSummary>
pub fn stats_aggregator_summary<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    iterator: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StatsAggregatorSummary::new();
    op.call(ctx, iterator)
}

/// StopGradient
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StopGradient>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StopGradient {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StopGradient {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl StopGradient {
    /// Creates a new `StopGradient`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute stop_gradient.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StopGradient")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StopGradient::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StopGradient>
pub fn stop_gradient<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StopGradient::new();
    op.call(ctx, input)
}

/// StridedSlice
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StridedSlice>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StridedSlice {
    begin_mask: ::std::option::Option<i64>,
    end_mask: ::std::option::Option<i64>,
    ellipsis_mask: ::std::option::Option<i64>,
    new_axis_mask: ::std::option::Option<i64>,
    shrink_axis_mask: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StridedSlice {
    fn default() -> Self {
        Self {
            begin_mask: Some(0i64),
            end_mask: Some(0i64),
            ellipsis_mask: Some(0i64),
            new_axis_mask: Some(0i64),
            shrink_axis_mask: Some(0i64),
            target_device_name: None,
        }
    }
}
impl StridedSlice {
    /// Creates a new `StridedSlice`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `begin_mask` attribute.
    pub fn begin_mask<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.begin_mask = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `end_mask` attribute.
    pub fn end_mask<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.end_mask = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `ellipsis_mask` attribute.
    pub fn ellipsis_mask<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.ellipsis_mask = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `new_axis_mask` attribute.
    pub fn new_axis_mask<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.new_axis_mask = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shrink_axis_mask` attribute.
    pub fn shrink_axis_mask<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.shrink_axis_mask = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute strided_slice.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        begin: &T1,
        end: &T2,
        strides: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StridedSlice")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&begin.to_handle(ctx)?)?;
        op.add_input(&end.to_handle(ctx)?)?;
        op.add_input(&strides.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.begin_mask {
            op.set_attr_int("begin_mask", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.end_mask {
            op.set_attr_int("end_mask", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.ellipsis_mask {
            op.set_attr_int("ellipsis_mask", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.new_axis_mask {
            op.set_attr_int("new_axis_mask", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shrink_axis_mask {
            op.set_attr_int("shrink_axis_mask", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StridedSlice::new().call(&ctx, &input, &begin, &end, &strides)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StridedSlice>
pub fn strided_slice<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    begin: &T1,
    end: &T2,
    strides: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StridedSlice::new();
    op.call(ctx, input, begin, end, strides)
}

/// StridedSliceAssign
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StridedSliceAssign>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StridedSliceAssign {
    begin_mask: ::std::option::Option<i64>,
    end_mask: ::std::option::Option<i64>,
    ellipsis_mask: ::std::option::Option<i64>,
    new_axis_mask: ::std::option::Option<i64>,
    shrink_axis_mask: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StridedSliceAssign {
    fn default() -> Self {
        Self {
            begin_mask: Some(0i64),
            end_mask: Some(0i64),
            ellipsis_mask: Some(0i64),
            new_axis_mask: Some(0i64),
            shrink_axis_mask: Some(0i64),
            target_device_name: None,
        }
    }
}
impl StridedSliceAssign {
    /// Creates a new `StridedSliceAssign`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `begin_mask` attribute.
    pub fn begin_mask<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.begin_mask = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `end_mask` attribute.
    pub fn end_mask<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.end_mask = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `ellipsis_mask` attribute.
    pub fn ellipsis_mask<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.ellipsis_mask = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `new_axis_mask` attribute.
    pub fn new_axis_mask<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.new_axis_mask = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shrink_axis_mask` attribute.
    pub fn shrink_axis_mask<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.shrink_axis_mask = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute strided_slice_assign.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        ref_: &T0,
        begin: &T1,
        end: &T2,
        strides: &T3,
        value: &T4,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StridedSliceAssign")?;

        // Required input arguments
        op.add_input(&ref_.to_handle(ctx)?)?;
        op.add_input(&begin.to_handle(ctx)?)?;
        op.add_input(&end.to_handle(ctx)?)?;
        op.add_input(&strides.to_handle(ctx)?)?;
        op.add_input(&value.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.begin_mask {
            op.set_attr_int("begin_mask", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.end_mask {
            op.set_attr_int("end_mask", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.ellipsis_mask {
            op.set_attr_int("ellipsis_mask", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.new_axis_mask {
            op.set_attr_int("new_axis_mask", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shrink_axis_mask {
            op.set_attr_int("shrink_axis_mask", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StridedSliceAssign::new().call(&ctx, &ref_, &begin, &end, &strides, &value)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StridedSliceAssign>
pub fn strided_slice_assign<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    ref_: &T0,
    begin: &T1,
    end: &T2,
    strides: &T3,
    value: &T4,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StridedSliceAssign::new();
    op.call(ctx, ref_, begin, end, strides, value)
}

/// StridedSliceGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StridedSliceGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StridedSliceGrad {
    begin_mask: ::std::option::Option<i64>,
    end_mask: ::std::option::Option<i64>,
    ellipsis_mask: ::std::option::Option<i64>,
    new_axis_mask: ::std::option::Option<i64>,
    shrink_axis_mask: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StridedSliceGrad {
    fn default() -> Self {
        Self {
            begin_mask: Some(0i64),
            end_mask: Some(0i64),
            ellipsis_mask: Some(0i64),
            new_axis_mask: Some(0i64),
            shrink_axis_mask: Some(0i64),
            target_device_name: None,
        }
    }
}
impl StridedSliceGrad {
    /// Creates a new `StridedSliceGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `begin_mask` attribute.
    pub fn begin_mask<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.begin_mask = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `end_mask` attribute.
    pub fn end_mask<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.end_mask = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `ellipsis_mask` attribute.
    pub fn ellipsis_mask<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.ellipsis_mask = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `new_axis_mask` attribute.
    pub fn new_axis_mask<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.new_axis_mask = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shrink_axis_mask` attribute.
    pub fn shrink_axis_mask<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.shrink_axis_mask = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute strided_slice_grad.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        shape: &T0,
        begin: &T1,
        end: &T2,
        strides: &T3,
        dy: &T4,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StridedSliceGrad")?;

        // Required input arguments
        op.add_input(&shape.to_handle(ctx)?)?;
        op.add_input(&begin.to_handle(ctx)?)?;
        op.add_input(&end.to_handle(ctx)?)?;
        op.add_input(&strides.to_handle(ctx)?)?;
        op.add_input(&dy.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.begin_mask {
            op.set_attr_int("begin_mask", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.end_mask {
            op.set_attr_int("end_mask", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.ellipsis_mask {
            op.set_attr_int("ellipsis_mask", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.new_axis_mask {
            op.set_attr_int("new_axis_mask", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shrink_axis_mask {
            op.set_attr_int("shrink_axis_mask", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StridedSliceGrad::new().call(&ctx, &shape, &begin, &end, &strides, &dy)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StridedSliceGrad>
pub fn strided_slice_grad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    shape: &T0,
    begin: &T1,
    end: &T2,
    strides: &T3,
    dy: &T4,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StridedSliceGrad::new();
    op.call(ctx, shape, begin, end, strides, dy)
}

/// StringFormat
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StringFormat>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StringFormat {
    template: ::std::option::Option<::std::string::String>,
    placeholder: ::std::option::Option<::std::string::String>,
    summarize: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StringFormat {
    fn default() -> Self {
        Self {
            template: Some(::std::string::String::from("%s")),
            placeholder: Some(::std::string::String::from("%s")),
            summarize: Some(3i64),
            target_device_name: None,
        }
    }
}
impl StringFormat {
    /// Creates a new `StringFormat`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `template` attribute.
    pub fn template<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.template = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `placeholder` attribute.
    pub fn placeholder<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.placeholder = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `summarize` attribute.
    pub fn summarize<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.summarize = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute string_format.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        inputs: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StringFormat")?;

        // Required input arguments
        op.add_input(&inputs.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.template {
            op.set_attr_string("template", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.placeholder {
            op.set_attr_string("placeholder", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.summarize {
            op.set_attr_int("summarize", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StringFormat::new().call(&ctx, &inputs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StringFormat>
pub fn string_format<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    inputs: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StringFormat::new();
    op.call(ctx, inputs)
}

/// StringJoin
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StringJoin>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StringJoin {
    separator: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StringJoin {
    fn default() -> Self {
        Self {
            separator: None,
            target_device_name: None,
        }
    }
}
impl StringJoin {
    /// Creates a new `StringJoin`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `separator` attribute.
    pub fn separator<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.separator = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute string_join.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        inputs: &[&T0],
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StringJoin")?;

        // Required input arguments
        let mut inputs_list = Vec::new();

        for t in inputs {
            inputs_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&inputs_list)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.separator {
            op.set_attr_string("separator", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StringJoin::new().call(&ctx, &inputs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StringJoin>
pub fn string_join<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    inputs: &[&T0],
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StringJoin::new();
    op.call(ctx, inputs)
}

/// StringLength
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StringLength>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StringLength {
    unit: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StringLength {
    fn default() -> Self {
        Self {
            unit: Some(::std::string::String::from("BYTE")),
            target_device_name: None,
        }
    }
}
impl StringLength {
    /// Creates a new `StringLength`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `unit` attribute.
    pub fn unit<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.unit = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute string_length.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StringLength")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.unit {
            op.set_attr_string("unit", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StringLength::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StringLength>
pub fn string_length<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StringLength::new();
    op.call(ctx, input)
}

/// StringLower
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StringLower>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StringLower {
    encoding: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StringLower {
    fn default() -> Self {
        Self {
            encoding: None,
            target_device_name: None,
        }
    }
}
impl StringLower {
    /// Creates a new `StringLower`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `encoding` attribute.
    pub fn encoding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.encoding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute string_lower.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StringLower")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.encoding {
            op.set_attr_string("encoding", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StringLower::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StringLower>
pub fn string_lower<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StringLower::new();
    op.call(ctx, input)
}

/// StringNGrams
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StringNGrams>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StringNGrams {
    separator: ::std::option::Option<::std::string::String>,
    ngram_widths: ::std::option::Option<::std::vec::Vec<i64>>,
    left_pad: ::std::option::Option<::std::string::String>,
    right_pad: ::std::option::Option<::std::string::String>,
    pad_width: ::std::option::Option<i64>,
    preserve_short_sequences: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StringNGrams {
    fn default() -> Self {
        Self {
            separator: None,
            ngram_widths: None,
            left_pad: None,
            right_pad: None,
            pad_width: None,
            preserve_short_sequences: None,
            target_device_name: None,
        }
    }
}
impl StringNGrams {
    /// Creates a new `StringNGrams`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `separator` attribute.
    pub fn separator<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.separator = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `ngram_widths` attribute.
    pub fn ngram_widths<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.ngram_widths = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `left_pad` attribute.
    pub fn left_pad<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.left_pad = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `right_pad` attribute.
    pub fn right_pad<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.right_pad = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `pad_width` attribute.
    pub fn pad_width<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.pad_width = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `preserve_short_sequences` attribute.
    pub fn preserve_short_sequences<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.preserve_short_sequences = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute string_ngrams.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        data: &T0,
        data_splits: &T1,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "StringNGrams")?;

        // Required input arguments
        op.add_input(&data.to_handle(ctx)?)?;
        op.add_input(&data_splits.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.separator {
            op.set_attr_string("separator", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.ngram_widths {
            op.set_attr_int_list("ngram_widths", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.left_pad {
            op.set_attr_string("left_pad", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.right_pad {
            op.set_attr_string("right_pad", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.pad_width {
            op.set_attr_int("pad_width", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.preserve_short_sequences {
            op.set_attr_bool("preserve_short_sequences", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `StringNGrams::new().call(&ctx, &data, &data_splits)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StringNGrams>
pub fn string_ngrams<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    data: &T0,
    data_splits: &T1,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = StringNGrams::new();
    op.call(ctx, data, data_splits)
}

/// StringSplit
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StringSplit>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StringSplit {
    skip_empty: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StringSplit {
    fn default() -> Self {
        Self {
            skip_empty: Some(true),
            target_device_name: None,
        }
    }
}
impl StringSplit {
    /// Creates a new `StringSplit`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `skip_empty` attribute.
    pub fn skip_empty<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.skip_empty = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute string_split.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        delimiter: &T1,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "StringSplit")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&delimiter.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.skip_empty {
            op.set_attr_bool("skip_empty", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `StringSplit::new().call(&ctx, &input, &delimiter)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StringSplit>
pub fn string_split<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    delimiter: &T1,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = StringSplit::new();
    op.call(ctx, input, delimiter)
}

/// StringSplitV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StringSplitV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StringSplitV2 {
    maxsplit: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StringSplitV2 {
    fn default() -> Self {
        Self {
            maxsplit: Some(-1i64),
            target_device_name: None,
        }
    }
}
impl StringSplitV2 {
    /// Creates a new `StringSplitV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `maxsplit` attribute.
    pub fn maxsplit<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.maxsplit = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute string_split_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        sep: &T1,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "StringSplitV2")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&sep.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.maxsplit {
            op.set_attr_int("maxsplit", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `StringSplitV2::new().call(&ctx, &input, &sep)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StringSplitV2>
pub fn string_split_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    sep: &T1,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = StringSplitV2::new();
    op.call(ctx, input, sep)
}

/// StringStrip
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StringStrip>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StringStrip {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StringStrip {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl StringStrip {
    /// Creates a new `StringStrip`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute string_strip.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StringStrip")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StringStrip::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StringStrip>
pub fn string_strip<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StringStrip::new();
    op.call(ctx, input)
}

/// StringToHashBucket
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StringToHashBucket>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StringToHashBucket {
    num_buckets: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StringToHashBucket {
    fn default() -> Self {
        Self {
            num_buckets: None,
            target_device_name: None,
        }
    }
}
impl StringToHashBucket {
    /// Creates a new `StringToHashBucket`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_buckets` attribute.
    pub fn num_buckets<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_buckets = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute string_to_hash_bucket.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        string_tensor: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StringToHashBucket")?;

        // Required input arguments
        op.add_input(&string_tensor.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_buckets {
            op.set_attr_int("num_buckets", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StringToHashBucket::new().call(&ctx, &string_tensor)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StringToHashBucket>
pub fn string_to_hash_bucket<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    string_tensor: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StringToHashBucket::new();
    op.call(ctx, string_tensor)
}

/// StringToHashBucketFast
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StringToHashBucketFast>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StringToHashBucketFast {
    num_buckets: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StringToHashBucketFast {
    fn default() -> Self {
        Self {
            num_buckets: None,
            target_device_name: None,
        }
    }
}
impl StringToHashBucketFast {
    /// Creates a new `StringToHashBucketFast`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_buckets` attribute.
    pub fn num_buckets<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_buckets = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute string_to_hash_bucket_fast.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StringToHashBucketFast")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_buckets {
            op.set_attr_int("num_buckets", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StringToHashBucketFast::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StringToHashBucketFast>
pub fn string_to_hash_bucket_fast<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StringToHashBucketFast::new();
    op.call(ctx, input)
}

/// StringToHashBucketStrong
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StringToHashBucketStrong>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StringToHashBucketStrong {
    num_buckets: ::std::option::Option<i64>,
    key: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StringToHashBucketStrong {
    fn default() -> Self {
        Self {
            num_buckets: None,
            key: None,
            target_device_name: None,
        }
    }
}
impl StringToHashBucketStrong {
    /// Creates a new `StringToHashBucketStrong`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_buckets` attribute.
    pub fn num_buckets<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_buckets = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `key` attribute.
    pub fn key<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.key = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute string_to_hash_bucket_strong.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StringToHashBucketStrong")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_buckets {
            op.set_attr_int("num_buckets", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.key {
            op.set_attr_int_list("key", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StringToHashBucketStrong::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StringToHashBucketStrong>
pub fn string_to_hash_bucket_strong<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StringToHashBucketStrong::new();
    op.call(ctx, input)
}

/// StringToNumber
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StringToNumber>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StringToNumber {
    out_type: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StringToNumber {
    fn default() -> Self {
        Self {
            out_type: Some(crate::DataType::Float),
            target_device_name: None,
        }
    }
}
impl StringToNumber {
    /// Creates a new `StringToNumber`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_type` attribute.
    pub fn out_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute string_to_number.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        string_tensor: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StringToNumber")?;

        // Required input arguments
        op.add_input(&string_tensor.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_type {
            op.set_attr_type("out_type", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StringToNumber::new().call(&ctx, &string_tensor)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StringToNumber>
pub fn string_to_number<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    string_tensor: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StringToNumber::new();
    op.call(ctx, string_tensor)
}

/// StringUpper
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StringUpper>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct StringUpper {
    encoding: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for StringUpper {
    fn default() -> Self {
        Self {
            encoding: None,
            target_device_name: None,
        }
    }
}
impl StringUpper {
    /// Creates a new `StringUpper`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `encoding` attribute.
    pub fn encoding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.encoding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute string_upper.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "StringUpper")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.encoding {
            op.set_attr_string("encoding", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `StringUpper::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/StringUpper>
pub fn string_upper<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = StringUpper::new();
    op.call(ctx, input)
}

/// Sub
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Sub>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Sub {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Sub {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Sub {
    /// Creates a new `Sub`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sub.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Sub")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Sub::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Sub>
pub fn sub<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Sub::new();
    op.call(ctx, x, y)
}

/// Substr
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Substr>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Substr {
    unit: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Substr {
    fn default() -> Self {
        Self {
            unit: Some(::std::string::String::from("BYTE")),
            target_device_name: None,
        }
    }
}
impl Substr {
    /// Creates a new `Substr`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `unit` attribute.
    pub fn unit<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.unit = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute substr.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        pos: &T1,
        len: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Substr")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&pos.to_handle(ctx)?)?;
        op.add_input(&len.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.unit {
            op.set_attr_string("unit", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Substr::new().call(&ctx, &input, &pos, &len)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Substr>
pub fn substr<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    pos: &T1,
    len: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Substr::new();
    op.call(ctx, input, pos, len)
}

/// Sum
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Sum>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Sum {
    keep_dims: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Sum {
    fn default() -> Self {
        Self {
            keep_dims: Some(false),
            target_device_name: None,
        }
    }
}
impl Sum {
    /// Creates a new `Sum`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `keep_dims` attribute.
    pub fn keep_dims<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.keep_dims = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute sum.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        reduction_indices: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Sum")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&reduction_indices.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.keep_dims {
            op.set_attr_bool("keep_dims", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Sum::new().call(&ctx, &input, &reduction_indices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Sum>
pub fn sum<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    reduction_indices: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Sum::new();
    op.call(ctx, input, reduction_indices)
}

/// SummaryWriter
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SummaryWriter>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SummaryWriter {
    shared_name: ::std::option::Option<::std::string::String>,
    container: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SummaryWriter {
    fn default() -> Self {
        Self {
            shared_name: None,
            container: None,
            target_device_name: None,
        }
    }
}
impl SummaryWriter {
    /// Creates a new `SummaryWriter`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute summary_writer.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SummaryWriter")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SummaryWriter::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SummaryWriter>
pub fn summary_writer<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SummaryWriter::new();
    op.call(ctx)
}

/// Svd
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Svd>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Svd {
    compute_uv: ::std::option::Option<bool>,
    full_matrices: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Svd {
    fn default() -> Self {
        Self {
            compute_uv: Some(true),
            full_matrices: Some(false),
            target_device_name: None,
        }
    }
}
impl Svd {
    /// Creates a new `Svd`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `compute_uv` attribute.
    pub fn compute_uv<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.compute_uv = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `full_matrices` attribute.
    pub fn full_matrices<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.full_matrices = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute svd.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "Svd")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.compute_uv {
            op.set_attr_bool("compute_uv", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.full_matrices {
            op.set_attr_bool("full_matrices", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `Svd::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Svd>
pub fn svd<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = Svd::new();
    op.call(ctx, input)
}

/// Switch
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Switch>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Switch {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Switch {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Switch {
    /// Creates a new `Switch`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute switch.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        data: &T0,
        pred: &T1,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "Switch")?;

        // Required input arguments
        op.add_input(&data.to_handle(ctx)?)?;
        op.add_input(&pred.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `Switch::new().call(&ctx, &data, &pred)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Switch>
pub fn switch<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    data: &T0,
    pred: &T1,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = Switch::new();
    op.call(ctx, data, pred)
}

/// SymbolicGradient
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SymbolicGradient>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct SymbolicGradient {
    Tout: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    f: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for SymbolicGradient {
    fn default() -> Self {
        Self {
            Tout: None,
            f: None,
            target_device_name: None,
        }
    }
}
impl SymbolicGradient {
    /// Creates a new `SymbolicGradient`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Tout` attribute.
    pub fn Tout<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Tout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `f` attribute.
    pub fn f<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.f = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute symbolic_gradient.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "SymbolicGradient")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Tout {
            op.set_attr_type_list("Tout", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.f {
            op.set_attr_string("f", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `SymbolicGradient::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/SymbolicGradient>
pub fn symbolic_gradient<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = SymbolicGradient::new();
    op.call(ctx, input)
}

/// TFRecordDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TFRecordDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TFRecordDataset {
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TFRecordDataset {
    fn default() -> Self {
        Self {
            metadata: None,
            target_device_name: None,
        }
    }
}
impl TFRecordDataset {
    /// Creates a new `TFRecordDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tfrecord_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        filenames: &T0,
        compression_type: &T1,
        buffer_size: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TFRecordDataset")?;

        // Required input arguments
        op.add_input(&filenames.to_handle(ctx)?)?;
        op.add_input(&compression_type.to_handle(ctx)?)?;
        op.add_input(&buffer_size.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TFRecordDataset::new().call(&ctx, &filenames, &compression_type, &buffer_size)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TFRecordDataset>
pub fn tfrecord_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    filenames: &T0,
    compression_type: &T1,
    buffer_size: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TFRecordDataset::new();
    op.call(ctx, filenames, compression_type, buffer_size)
}

/// TFRecordReader
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TFRecordReader>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TFRecordReader {
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    compression_type: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TFRecordReader {
    fn default() -> Self {
        Self {
            container: None,
            shared_name: None,
            compression_type: None,
            target_device_name: None,
        }
    }
}
impl TFRecordReader {
    /// Creates a new `TFRecordReader`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `compression_type` attribute.
    pub fn compression_type<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.compression_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tfrecord_reader.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TFRecordReader")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.compression_type {
            op.set_attr_string("compression_type", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TFRecordReader::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TFRecordReader>
pub fn tfrecord_reader<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TFRecordReader::new();
    op.call(ctx)
}

/// TFRecordReaderV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TFRecordReaderV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TFRecordReaderV2 {
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    compression_type: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TFRecordReaderV2 {
    fn default() -> Self {
        Self {
            container: None,
            shared_name: None,
            compression_type: None,
            target_device_name: None,
        }
    }
}
impl TFRecordReaderV2 {
    /// Creates a new `TFRecordReaderV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `compression_type` attribute.
    pub fn compression_type<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.compression_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tfrecord_reader_v2.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TFRecordReaderV2")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.compression_type {
            op.set_attr_string("compression_type", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TFRecordReaderV2::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TFRecordReaderV2>
pub fn tfrecord_reader_v2<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TFRecordReaderV2::new();
    op.call(ctx)
}

/// TPUCompilationResult
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TPUCompilationResult>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TPUCompilationResult {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TPUCompilationResult {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TPUCompilationResult {
    /// Creates a new `TPUCompilationResult`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tpucompilation_result.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TPUCompilationResult")?;

        // Required input arguments

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TPUCompilationResult::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TPUCompilationResult>
pub fn tpucompilation_result<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TPUCompilationResult::new();
    op.call(ctx)
}

/// TPUCompile
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TPUCompile>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TPUCompile {
    num_computations: ::std::option::Option<i64>,
    function: ::std::option::Option<::std::string::String>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TPUCompile {
    fn default() -> Self {
        Self {
            num_computations: None,
            function: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl TPUCompile {
    /// Creates a new `TPUCompile`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_computations` attribute.
    pub fn num_computations<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_computations = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `function` attribute.
    pub fn function<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.function = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tpucompile.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        dynamic_shapes: &[&T0],
        guaranteed_constants: &T1,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "TPUCompile")?;

        // Required input arguments
        let mut dynamic_shapes_list = Vec::new();

        for t in dynamic_shapes {
            dynamic_shapes_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&dynamic_shapes_list)?;
        op.add_input(&guaranteed_constants.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_computations {
            op.set_attr_int("num_computations", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.function {
            op.set_attr_string("function", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `TPUCompile::new().call(&ctx, &dynamic_shapes, &guaranteed_constants)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TPUCompile>
pub fn tpucompile<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    dynamic_shapes: &[&T0],
    guaranteed_constants: &T1,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = TPUCompile::new();
    op.call(ctx, dynamic_shapes, guaranteed_constants)
}

/// TPUCompileSucceededAssert
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TPUCompileSucceededAssert>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TPUCompileSucceededAssert {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TPUCompileSucceededAssert {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TPUCompileSucceededAssert {
    /// Creates a new `TPUCompileSucceededAssert`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tpucompile_succeeded_assert.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        compilation_status: &T0,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "TPUCompileSucceededAssert")?;

        // Required input arguments
        op.add_input(&compilation_status.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `TPUCompileSucceededAssert::new().call(&ctx, &compilation_status)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TPUCompileSucceededAssert>
pub fn tpucompile_succeeded_assert<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    compilation_status: &T0,
) -> crate::Result<()> {
    let op = TPUCompileSucceededAssert::new();
    op.call(ctx, compilation_status)
}

/// TPUEmbeddingActivations
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TPUEmbeddingActivations>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TPUEmbeddingActivations {
    table_id: ::std::option::Option<i64>,
    lookup_id: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TPUEmbeddingActivations {
    fn default() -> Self {
        Self {
            table_id: None,
            lookup_id: None,
            target_device_name: None,
        }
    }
}
impl TPUEmbeddingActivations {
    /// Creates a new `TPUEmbeddingActivations`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `table_id` attribute.
    pub fn table_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.table_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `lookup_id` attribute.
    pub fn lookup_id<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.lookup_id = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tpuembedding_activations.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        embedding_variable: &T0,
        sliced_activations: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TPUEmbeddingActivations")?;

        // Required input arguments
        op.add_input(&embedding_variable.to_handle(ctx)?)?;
        op.add_input(&sliced_activations.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.table_id {
            op.set_attr_int("table_id", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.lookup_id {
            op.set_attr_int("lookup_id", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TPUEmbeddingActivations::new().call(&ctx, &embedding_variable, &sliced_activations)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TPUEmbeddingActivations>
pub fn tpuembedding_activations<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    embedding_variable: &T0,
    sliced_activations: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TPUEmbeddingActivations::new();
    op.call(ctx, embedding_variable, sliced_activations)
}

/// TPUExecute
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TPUExecute>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TPUExecute {
    Tresults: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TPUExecute {
    fn default() -> Self {
        Self {
            Tresults: None,
            target_device_name: None,
        }
    }
}
impl TPUExecute {
    /// Creates a new `TPUExecute`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Tresults` attribute.
    pub fn Tresults<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Tresults = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tpuexecute.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        args: &T0,
        key: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TPUExecute")?;

        // Required input arguments
        op.add_input(&args.to_handle(ctx)?)?;
        op.add_input(&key.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Tresults {
            op.set_attr_type_list("Tresults", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TPUExecute::new().call(&ctx, &args, &key)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TPUExecute>
pub fn tpuexecute<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    args: &T0,
    key: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TPUExecute::new();
    op.call(ctx, args, key)
}

/// TPUExecuteAndUpdateVariables
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TPUExecuteAndUpdateVariables>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TPUExecuteAndUpdateVariables {
    Tresults: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    device_var_reads_indices: ::std::option::Option<::std::vec::Vec<i64>>,
    device_var_updates_indices: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TPUExecuteAndUpdateVariables {
    fn default() -> Self {
        Self {
            Tresults: None,
            device_var_reads_indices: None,
            device_var_updates_indices: None,
            target_device_name: None,
        }
    }
}
impl TPUExecuteAndUpdateVariables {
    /// Creates a new `TPUExecuteAndUpdateVariables`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Tresults` attribute.
    pub fn Tresults<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Tresults = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `device_var_reads_indices` attribute.
    pub fn device_var_reads_indices<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.device_var_reads_indices = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `device_var_updates_indices` attribute.
    pub fn device_var_updates_indices<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.device_var_updates_indices = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tpuexecute_and_update_variables.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        args: &T0,
        key: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TPUExecuteAndUpdateVariables")?;

        // Required input arguments
        op.add_input(&args.to_handle(ctx)?)?;
        op.add_input(&key.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Tresults {
            op.set_attr_type_list("Tresults", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.device_var_reads_indices {
            op.set_attr_int_list("device_var_reads_indices", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.device_var_updates_indices {
            op.set_attr_int_list("device_var_updates_indices", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TPUExecuteAndUpdateVariables::new().call(&ctx, &args, &key)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TPUExecuteAndUpdateVariables>
pub fn tpuexecute_and_update_variables<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    args: &T0,
    key: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TPUExecuteAndUpdateVariables::new();
    op.call(ctx, args, key)
}

/// TPUOrdinalSelector
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TPUOrdinalSelector>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TPUOrdinalSelector {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TPUOrdinalSelector {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TPUOrdinalSelector {
    /// Creates a new `TPUOrdinalSelector`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tpuordinal_selector.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TPUOrdinalSelector")?;

        // Required input arguments

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TPUOrdinalSelector::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TPUOrdinalSelector>
pub fn tpuordinal_selector<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TPUOrdinalSelector::new();
    op.call(ctx)
}

/// TPUPartitionedCall
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TPUPartitionedCall>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TPUPartitionedCall {
    Tout: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    f: ::std::option::Option<::std::string::String>,
    autotuner_thresh: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TPUPartitionedCall {
    fn default() -> Self {
        Self {
            Tout: None,
            f: None,
            autotuner_thresh: Some(0i64),
            target_device_name: None,
        }
    }
}
impl TPUPartitionedCall {
    /// Creates a new `TPUPartitionedCall`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Tout` attribute.
    pub fn Tout<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Tout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `f` attribute.
    pub fn f<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.f = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `autotuner_thresh` attribute.
    pub fn autotuner_thresh<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.autotuner_thresh = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tpupartitioned_call.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        args: &T0,
        device_ordinal: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TPUPartitionedCall")?;

        // Required input arguments
        op.add_input(&args.to_handle(ctx)?)?;
        op.add_input(&device_ordinal.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Tout {
            op.set_attr_type_list("Tout", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.f {
            op.set_attr_string("f", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.autotuner_thresh {
            op.set_attr_int("autotuner_thresh", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TPUPartitionedCall::new().call(&ctx, &args, &device_ordinal)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TPUPartitionedCall>
pub fn tpupartitioned_call<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    args: &T0,
    device_ordinal: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TPUPartitionedCall::new();
    op.call(ctx, args, device_ordinal)
}

/// TPUPartitionedInput
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TPUPartitionedInput>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TPUPartitionedInput {
    partition_dim: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TPUPartitionedInput {
    fn default() -> Self {
        Self {
            partition_dim: Some(0i64),
            target_device_name: None,
        }
    }
}
impl TPUPartitionedInput {
    /// Creates a new `TPUPartitionedInput`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `partition_dim` attribute.
    pub fn partition_dim<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.partition_dim = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tpupartitioned_input.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        inputs: &[&T0],
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TPUPartitionedInput")?;

        // Required input arguments
        let mut inputs_list = Vec::new();

        for t in inputs {
            inputs_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&inputs_list)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.partition_dim {
            op.set_attr_int("partition_dim", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TPUPartitionedInput::new().call(&ctx, &inputs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TPUPartitionedInput>
pub fn tpupartitioned_input<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    inputs: &[&T0],
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TPUPartitionedInput::new();
    op.call(ctx, inputs)
}

/// TPUPartitionedOutput
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TPUPartitionedOutput>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TPUPartitionedOutput {
    num_splits: ::std::option::Option<i64>,
    partition_dim: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TPUPartitionedOutput {
    fn default() -> Self {
        Self {
            num_splits: None,
            partition_dim: Some(0i64),
            target_device_name: None,
        }
    }
}
impl TPUPartitionedOutput {
    /// Creates a new `TPUPartitionedOutput`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_splits` attribute.
    pub fn num_splits<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_splits = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `partition_dim` attribute.
    pub fn partition_dim<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.partition_dim = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tpupartitioned_output.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        inputs: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TPUPartitionedOutput")?;

        // Required input arguments
        op.add_input(&inputs.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_splits {
            op.set_attr_int("num_splits", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.partition_dim {
            op.set_attr_int("partition_dim", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TPUPartitionedOutput::new().call(&ctx, &inputs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TPUPartitionedOutput>
pub fn tpupartitioned_output<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    inputs: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TPUPartitionedOutput::new();
    op.call(ctx, inputs)
}

/// TPUReplicateMetadata
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TPUReplicateMetadata>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TPUReplicateMetadata {
    num_replicas: ::std::option::Option<i64>,
    num_cores_per_replica: ::std::option::Option<i64>,
    topology: ::std::option::Option<::std::string::String>,
    use_tpu: ::std::option::Option<bool>,
    device_assignment: ::std::option::Option<::std::vec::Vec<i64>>,
    computation_shape: ::std::option::Option<::std::vec::Vec<i64>>,
    host_compute_core: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    padding_map: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    step_marker_location: ::std::option::Option<::std::string::String>,
    allow_soft_placement: ::std::option::Option<bool>,
    use_spmd_for_xla_partitioning: ::std::option::Option<bool>,
    tpu_compile_options_proto: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TPUReplicateMetadata {
    fn default() -> Self {
        Self {
            num_replicas: None,
            num_cores_per_replica: Some(1i64),
            topology: None,
            use_tpu: Some(true),
            device_assignment: Some(vec![]),
            computation_shape: Some(vec![]),
            host_compute_core: Some(vec![]),
            padding_map: Some(vec![]),
            step_marker_location: Some(::std::string::String::from("STEP_MARK_AT_ENTRY")),
            allow_soft_placement: Some(false),
            use_spmd_for_xla_partitioning: Some(false),
            tpu_compile_options_proto: None,
            target_device_name: None,
        }
    }
}
impl TPUReplicateMetadata {
    /// Creates a new `TPUReplicateMetadata`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_replicas` attribute.
    pub fn num_replicas<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_replicas = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_cores_per_replica` attribute.
    pub fn num_cores_per_replica<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.num_cores_per_replica = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `topology` attribute.
    pub fn topology<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.topology = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_tpu` attribute.
    pub fn use_tpu<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.use_tpu = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `device_assignment` attribute.
    pub fn device_assignment<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.device_assignment = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `computation_shape` attribute.
    pub fn computation_shape<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.computation_shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `host_compute_core` attribute.
    pub fn host_compute_core<
        ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>,
    >(
        mut self,
        value: ArgType,
    ) -> Self {
        self.host_compute_core = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `padding_map` attribute.
    pub fn padding_map<ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.padding_map = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `step_marker_location` attribute.
    pub fn step_marker_location<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.step_marker_location = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `allow_soft_placement` attribute.
    pub fn allow_soft_placement<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.allow_soft_placement = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `use_spmd_for_xla_partitioning` attribute.
    pub fn use_spmd_for_xla_partitioning<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.use_spmd_for_xla_partitioning = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `tpu_compile_options_proto` attribute.
    pub fn tpu_compile_options_proto<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.tpu_compile_options_proto = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tpureplicate_metadata.
    pub fn call<'a>(&self, ctx: &'a crate::eager::Context) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "TPUReplicateMetadata")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_replicas {
            op.set_attr_int("num_replicas", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_cores_per_replica {
            op.set_attr_int("num_cores_per_replica", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.topology {
            op.set_attr_string("topology", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_tpu {
            op.set_attr_bool("use_tpu", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.device_assignment {
            op.set_attr_int_list("device_assignment", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.computation_shape {
            op.set_attr_int_list("computation_shape", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.host_compute_core {
            op.set_attr_string_list("host_compute_core", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.padding_map {
            op.set_attr_string_list("padding_map", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.step_marker_location {
            op.set_attr_string("step_marker_location", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.allow_soft_placement {
            op.set_attr_bool("allow_soft_placement", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.use_spmd_for_xla_partitioning {
            op.set_attr_bool("use_spmd_for_xla_partitioning", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.tpu_compile_options_proto {
            op.set_attr_string("tpu_compile_options_proto", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `TPUReplicateMetadata::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TPUReplicateMetadata>
pub fn tpureplicate_metadata<'a>(ctx: &'a crate::eager::Context) -> crate::Result<()> {
    let op = TPUReplicateMetadata::new();
    op.call(ctx)
}

/// TPUReplicatedInput
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TPUReplicatedInput>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TPUReplicatedInput {
    is_mirrored_variable: ::std::option::Option<bool>,
    index: ::std::option::Option<i64>,
    is_packed: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TPUReplicatedInput {
    fn default() -> Self {
        Self {
            is_mirrored_variable: Some(false),
            index: Some(-1i64),
            is_packed: Some(false),
            target_device_name: None,
        }
    }
}
impl TPUReplicatedInput {
    /// Creates a new `TPUReplicatedInput`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `is_mirrored_variable` attribute.
    pub fn is_mirrored_variable<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.is_mirrored_variable = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `index` attribute.
    pub fn index<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.index = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `is_packed` attribute.
    pub fn is_packed<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.is_packed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tpureplicated_input.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        inputs: &[&T0],
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TPUReplicatedInput")?;

        // Required input arguments
        let mut inputs_list = Vec::new();

        for t in inputs {
            inputs_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&inputs_list)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.is_mirrored_variable {
            op.set_attr_bool("is_mirrored_variable", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.index {
            op.set_attr_int("index", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.is_packed {
            op.set_attr_bool("is_packed", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TPUReplicatedInput::new().call(&ctx, &inputs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TPUReplicatedInput>
pub fn tpureplicated_input<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    inputs: &[&T0],
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TPUReplicatedInput::new();
    op.call(ctx, inputs)
}

/// TPUReplicatedOutput
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TPUReplicatedOutput>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TPUReplicatedOutput {
    num_replicas: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TPUReplicatedOutput {
    fn default() -> Self {
        Self {
            num_replicas: None,
            target_device_name: None,
        }
    }
}
impl TPUReplicatedOutput {
    /// Creates a new `TPUReplicatedOutput`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_replicas` attribute.
    pub fn num_replicas<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_replicas = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tpureplicated_output.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TPUReplicatedOutput")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_replicas {
            op.set_attr_int("num_replicas", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TPUReplicatedOutput::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TPUReplicatedOutput>
pub fn tpureplicated_output<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TPUReplicatedOutput::new();
    op.call(ctx, input)
}

/// TPUReshardVariables
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TPUReshardVariables>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TPUReshardVariables {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TPUReshardVariables {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TPUReshardVariables {
    /// Creates a new `TPUReshardVariables`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tpureshard_variables.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        vars: &[&T0],
        new_format_key: &T1,
        format_state_var: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "TPUReshardVariables")?;

        // Required input arguments
        let mut vars_list = Vec::new();

        for t in vars {
            vars_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&vars_list)?;
        op.add_input(&new_format_key.to_handle(ctx)?)?;
        op.add_input(&format_state_var.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `TPUReshardVariables::new().call(&ctx, &vars, &new_format_key, &format_state_var)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TPUReshardVariables>
pub fn tpureshard_variables<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    vars: &[&T0],
    new_format_key: &T1,
    format_state_var: &T2,
) -> crate::Result<()> {
    let op = TPUReshardVariables::new();
    op.call(ctx, vars, new_format_key, format_state_var)
}

/// TPURoundRobin
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TPURoundRobin>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TPURoundRobin {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TPURoundRobin {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TPURoundRobin {
    /// Creates a new `TPURoundRobin`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tpuround_robin.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TPURoundRobin")?;

        // Required input arguments

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TPURoundRobin::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TPURoundRobin>
pub fn tpuround_robin<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TPURoundRobin::new();
    op.call(ctx)
}

/// TakeDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TakeDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TakeDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TakeDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl TakeDataset {
    /// Creates a new `TakeDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute take_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        count: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TakeDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&count.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TakeDataset::new().call(&ctx, &input_dataset, &count)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TakeDataset>
pub fn take_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    count: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TakeDataset::new();
    op.call(ctx, input_dataset, count)
}

/// TakeManySparseFromTensorsMap
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TakeManySparseFromTensorsMap>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TakeManySparseFromTensorsMap {
    dtype: ::std::option::Option<crate::DataType>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TakeManySparseFromTensorsMap {
    fn default() -> Self {
        Self {
            dtype: None,
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl TakeManySparseFromTensorsMap {
    /// Creates a new `TakeManySparseFromTensorsMap`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute take_many_sparse_from_tensors_map.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        sparse_handles: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "TakeManySparseFromTensorsMap")?;

        // Required input arguments
        op.add_input(&sparse_handles.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `TakeManySparseFromTensorsMap::new().call(&ctx, &sparse_handles)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TakeManySparseFromTensorsMap>
pub fn take_many_sparse_from_tensors_map<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    sparse_handles: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = TakeManySparseFromTensorsMap::new();
    op.call(ctx, sparse_handles)
}

/// TakeWhileDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TakeWhileDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TakeWhileDataset {
    predicate: ::std::option::Option<::std::string::String>,
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TakeWhileDataset {
    fn default() -> Self {
        Self {
            predicate: None,
            output_types: None,
            output_shapes: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl TakeWhileDataset {
    /// Creates a new `TakeWhileDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `predicate` attribute.
    pub fn predicate<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.predicate = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute take_while_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        other_arguments: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TakeWhileDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&other_arguments.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.predicate {
            op.set_attr_string("predicate", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TakeWhileDataset::new().call(&ctx, &input_dataset, &other_arguments)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TakeWhileDataset>
pub fn take_while_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    other_arguments: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TakeWhileDataset::new();
    op.call(ctx, input_dataset, other_arguments)
}

/// Tan
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Tan>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Tan {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Tan {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Tan {
    /// Creates a new `Tan`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tan.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Tan")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Tan::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Tan>
pub fn tan<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Tan::new();
    op.call(ctx, x)
}

/// Tanh
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Tanh>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Tanh {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Tanh {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Tanh {
    /// Creates a new `Tanh`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tanh.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Tanh")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Tanh::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Tanh>
pub fn tanh<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Tanh::new();
    op.call(ctx, x)
}

/// TanhGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TanhGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TanhGrad {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TanhGrad {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TanhGrad {
    /// Creates a new `TanhGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tanh_grad.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        y: &T0,
        dy: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TanhGrad")?;

        // Required input arguments
        op.add_input(&y.to_handle(ctx)?)?;
        op.add_input(&dy.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TanhGrad::new().call(&ctx, &y, &dy)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TanhGrad>
pub fn tanh_grad<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    y: &T0,
    dy: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TanhGrad::new();
    op.call(ctx, y, dy)
}

/// TemporaryVariable
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TemporaryVariable>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TemporaryVariable {
    shape: ::std::option::Option<crate::Shape>,
    dtype: ::std::option::Option<crate::DataType>,
    var_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TemporaryVariable {
    fn default() -> Self {
        Self {
            shape: None,
            dtype: None,
            var_name: None,
            target_device_name: None,
        }
    }
}
impl TemporaryVariable {
    /// Creates a new `TemporaryVariable`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `shape` attribute.
    pub fn shape<ArgType: ::std::convert::Into<crate::Shape>>(mut self, value: ArgType) -> Self {
        self.shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `var_name` attribute.
    pub fn var_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.var_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute temporary_variable.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TemporaryVariable")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.shape {
            op.set_attr_shape("shape", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.var_name {
            op.set_attr_string("var_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TemporaryVariable::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TemporaryVariable>
pub fn temporary_variable<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TemporaryVariable::new();
    op.call(ctx)
}

/// TensorArray
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArray>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorArray {
    dtype: ::std::option::Option<crate::DataType>,
    dynamic_size: ::std::option::Option<bool>,
    clear_after_read: ::std::option::Option<bool>,
    tensor_array_name: ::std::option::Option<::std::string::String>,
    element_shape: ::std::option::Option<crate::Shape>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorArray {
    fn default() -> Self {
        Self {
            dtype: None,
            dynamic_size: Some(false),
            clear_after_read: Some(true),
            tensor_array_name: None,
            element_shape: None,
            target_device_name: None,
        }
    }
}
impl TensorArray {
    /// Creates a new `TensorArray`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dynamic_size` attribute.
    pub fn dynamic_size<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.dynamic_size = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `clear_after_read` attribute.
    pub fn clear_after_read<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.clear_after_read = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `tensor_array_name` attribute.
    pub fn tensor_array_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.tensor_array_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `element_shape` attribute.
    pub fn element_shape<ArgType: ::std::convert::Into<crate::Shape>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.element_shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_array.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        size: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorArray")?;

        // Required input arguments
        op.add_input(&size.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dynamic_size {
            op.set_attr_bool("dynamic_size", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.clear_after_read {
            op.set_attr_bool("clear_after_read", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.tensor_array_name {
            op.set_attr_string("tensor_array_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.element_shape {
            op.set_attr_shape("element_shape", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorArray::new().call(&ctx, &size)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArray>
pub fn tensor_array<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    size: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorArray::new();
    op.call(ctx, size)
}

/// TensorArrayClose
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayClose>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorArrayClose {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorArrayClose {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TensorArrayClose {
    /// Creates a new `TensorArrayClose`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_array_close.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorArrayClose")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `TensorArrayClose::new().call(&ctx, &handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayClose>
pub fn tensor_array_close<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
) -> crate::Result<()> {
    let op = TensorArrayClose::new();
    op.call(ctx, handle)
}

/// TensorArrayCloseV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayCloseV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorArrayCloseV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorArrayCloseV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TensorArrayCloseV2 {
    /// Creates a new `TensorArrayCloseV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_array_close_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorArrayCloseV2")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `TensorArrayCloseV2::new().call(&ctx, &handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayCloseV2>
pub fn tensor_array_close_v2<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
) -> crate::Result<()> {
    let op = TensorArrayCloseV2::new();
    op.call(ctx, handle)
}

/// TensorArrayCloseV3
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayCloseV3>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorArrayCloseV3 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorArrayCloseV3 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TensorArrayCloseV3 {
    /// Creates a new `TensorArrayCloseV3`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_array_close_v3.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorArrayCloseV3")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `TensorArrayCloseV3::new().call(&ctx, &handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayCloseV3>
pub fn tensor_array_close_v3<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
) -> crate::Result<()> {
    let op = TensorArrayCloseV3::new();
    op.call(ctx, handle)
}

/// TensorArrayConcat
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayConcat>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorArrayConcat {
    dtype: ::std::option::Option<crate::DataType>,
    element_shape_except0: ::std::option::Option<crate::Shape>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorArrayConcat {
    fn default() -> Self {
        Self {
            dtype: None,
            element_shape_except0: None,
            target_device_name: None,
        }
    }
}
impl TensorArrayConcat {
    /// Creates a new `TensorArrayConcat`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `element_shape_except0` attribute.
    pub fn element_shape_except0<ArgType: ::std::convert::Into<crate::Shape>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.element_shape_except0 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_array_concat.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        flow_in: &T1,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorArrayConcat")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&flow_in.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.element_shape_except0 {
            op.set_attr_shape("element_shape_except0", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `TensorArrayConcat::new().call(&ctx, &handle, &flow_in)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayConcat>
pub fn tensor_array_concat<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    flow_in: &T1,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = TensorArrayConcat::new();
    op.call(ctx, handle, flow_in)
}

/// TensorArrayConcatV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayConcatV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorArrayConcatV2 {
    dtype: ::std::option::Option<crate::DataType>,
    element_shape_except0: ::std::option::Option<crate::Shape>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorArrayConcatV2 {
    fn default() -> Self {
        Self {
            dtype: None,
            element_shape_except0: None,
            target_device_name: None,
        }
    }
}
impl TensorArrayConcatV2 {
    /// Creates a new `TensorArrayConcatV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `element_shape_except0` attribute.
    pub fn element_shape_except0<ArgType: ::std::convert::Into<crate::Shape>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.element_shape_except0 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_array_concat_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        flow_in: &T1,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorArrayConcatV2")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&flow_in.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.element_shape_except0 {
            op.set_attr_shape("element_shape_except0", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `TensorArrayConcatV2::new().call(&ctx, &handle, &flow_in)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayConcatV2>
pub fn tensor_array_concat_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    flow_in: &T1,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = TensorArrayConcatV2::new();
    op.call(ctx, handle, flow_in)
}

/// TensorArrayConcatV3
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayConcatV3>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorArrayConcatV3 {
    dtype: ::std::option::Option<crate::DataType>,
    element_shape_except0: ::std::option::Option<crate::Shape>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorArrayConcatV3 {
    fn default() -> Self {
        Self {
            dtype: None,
            element_shape_except0: None,
            target_device_name: None,
        }
    }
}
impl TensorArrayConcatV3 {
    /// Creates a new `TensorArrayConcatV3`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `element_shape_except0` attribute.
    pub fn element_shape_except0<ArgType: ::std::convert::Into<crate::Shape>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.element_shape_except0 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_array_concat_v3.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        flow_in: &T1,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorArrayConcatV3")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&flow_in.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.element_shape_except0 {
            op.set_attr_shape("element_shape_except0", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `TensorArrayConcatV3::new().call(&ctx, &handle, &flow_in)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayConcatV3>
pub fn tensor_array_concat_v3<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    flow_in: &T1,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = TensorArrayConcatV3::new();
    op.call(ctx, handle, flow_in)
}

/// TensorArrayGather
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayGather>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorArrayGather {
    dtype: ::std::option::Option<crate::DataType>,
    element_shape: ::std::option::Option<crate::Shape>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorArrayGather {
    fn default() -> Self {
        Self {
            dtype: None,
            element_shape: None,
            target_device_name: None,
        }
    }
}
impl TensorArrayGather {
    /// Creates a new `TensorArrayGather`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `element_shape` attribute.
    pub fn element_shape<ArgType: ::std::convert::Into<crate::Shape>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.element_shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_array_gather.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        indices: &T1,
        flow_in: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorArrayGather")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&flow_in.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.element_shape {
            op.set_attr_shape("element_shape", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorArrayGather::new().call(&ctx, &handle, &indices, &flow_in)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayGather>
pub fn tensor_array_gather<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    indices: &T1,
    flow_in: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorArrayGather::new();
    op.call(ctx, handle, indices, flow_in)
}

/// TensorArrayGatherV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayGatherV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorArrayGatherV2 {
    dtype: ::std::option::Option<crate::DataType>,
    element_shape: ::std::option::Option<crate::Shape>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorArrayGatherV2 {
    fn default() -> Self {
        Self {
            dtype: None,
            element_shape: None,
            target_device_name: None,
        }
    }
}
impl TensorArrayGatherV2 {
    /// Creates a new `TensorArrayGatherV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `element_shape` attribute.
    pub fn element_shape<ArgType: ::std::convert::Into<crate::Shape>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.element_shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_array_gather_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        indices: &T1,
        flow_in: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorArrayGatherV2")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&flow_in.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.element_shape {
            op.set_attr_shape("element_shape", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorArrayGatherV2::new().call(&ctx, &handle, &indices, &flow_in)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayGatherV2>
pub fn tensor_array_gather_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    indices: &T1,
    flow_in: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorArrayGatherV2::new();
    op.call(ctx, handle, indices, flow_in)
}

/// TensorArrayGatherV3
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayGatherV3>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorArrayGatherV3 {
    dtype: ::std::option::Option<crate::DataType>,
    element_shape: ::std::option::Option<crate::Shape>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorArrayGatherV3 {
    fn default() -> Self {
        Self {
            dtype: None,
            element_shape: None,
            target_device_name: None,
        }
    }
}
impl TensorArrayGatherV3 {
    /// Creates a new `TensorArrayGatherV3`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `element_shape` attribute.
    pub fn element_shape<ArgType: ::std::convert::Into<crate::Shape>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.element_shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_array_gather_v3.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        indices: &T1,
        flow_in: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorArrayGatherV3")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&flow_in.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.element_shape {
            op.set_attr_shape("element_shape", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorArrayGatherV3::new().call(&ctx, &handle, &indices, &flow_in)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayGatherV3>
pub fn tensor_array_gather_v3<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    indices: &T1,
    flow_in: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorArrayGatherV3::new();
    op.call(ctx, handle, indices, flow_in)
}

/// TensorArrayGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorArrayGrad {
    source: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorArrayGrad {
    fn default() -> Self {
        Self {
            source: None,
            target_device_name: None,
        }
    }
}
impl TensorArrayGrad {
    /// Creates a new `TensorArrayGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `source` attribute.
    pub fn source<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.source = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_array_grad.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        flow_in: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorArrayGrad")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&flow_in.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.source {
            op.set_attr_string("source", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorArrayGrad::new().call(&ctx, &handle, &flow_in)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayGrad>
pub fn tensor_array_grad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    flow_in: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorArrayGrad::new();
    op.call(ctx, handle, flow_in)
}

/// TensorArrayGradV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayGradV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorArrayGradV2 {
    source: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorArrayGradV2 {
    fn default() -> Self {
        Self {
            source: None,
            target_device_name: None,
        }
    }
}
impl TensorArrayGradV2 {
    /// Creates a new `TensorArrayGradV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `source` attribute.
    pub fn source<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.source = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_array_grad_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        flow_in: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorArrayGradV2")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&flow_in.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.source {
            op.set_attr_string("source", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorArrayGradV2::new().call(&ctx, &handle, &flow_in)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayGradV2>
pub fn tensor_array_grad_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    flow_in: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorArrayGradV2::new();
    op.call(ctx, handle, flow_in)
}

/// TensorArrayGradV3
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayGradV3>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorArrayGradV3 {
    source: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorArrayGradV3 {
    fn default() -> Self {
        Self {
            source: None,
            target_device_name: None,
        }
    }
}
impl TensorArrayGradV3 {
    /// Creates a new `TensorArrayGradV3`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `source` attribute.
    pub fn source<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.source = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_array_grad_v3.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        flow_in: &T1,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorArrayGradV3")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&flow_in.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.source {
            op.set_attr_string("source", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `TensorArrayGradV3::new().call(&ctx, &handle, &flow_in)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayGradV3>
pub fn tensor_array_grad_v3<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    flow_in: &T1,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = TensorArrayGradV3::new();
    op.call(ctx, handle, flow_in)
}

/// TensorArrayGradWithShape
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayGradWithShape>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorArrayGradWithShape {
    source: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorArrayGradWithShape {
    fn default() -> Self {
        Self {
            source: None,
            target_device_name: None,
        }
    }
}
impl TensorArrayGradWithShape {
    /// Creates a new `TensorArrayGradWithShape`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `source` attribute.
    pub fn source<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.source = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_array_grad_with_shape.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        flow_in: &T1,
        shape_to_prepend: &T2,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorArrayGradWithShape")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&flow_in.to_handle(ctx)?)?;
        op.add_input(&shape_to_prepend.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.source {
            op.set_attr_string("source", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `TensorArrayGradWithShape::new().call(&ctx, &handle, &flow_in, &shape_to_prepend)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayGradWithShape>
pub fn tensor_array_grad_with_shape<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    flow_in: &T1,
    shape_to_prepend: &T2,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = TensorArrayGradWithShape::new();
    op.call(ctx, handle, flow_in, shape_to_prepend)
}

/// TensorArrayPack
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayPack>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorArrayPack {
    dtype: ::std::option::Option<crate::DataType>,
    element_shape: ::std::option::Option<crate::Shape>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorArrayPack {
    fn default() -> Self {
        Self {
            dtype: None,
            element_shape: None,
            target_device_name: None,
        }
    }
}
impl TensorArrayPack {
    /// Creates a new `TensorArrayPack`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `element_shape` attribute.
    pub fn element_shape<ArgType: ::std::convert::Into<crate::Shape>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.element_shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_array_pack.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        flow_in: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorArrayPack")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&flow_in.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.element_shape {
            op.set_attr_shape("element_shape", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorArrayPack::new().call(&ctx, &handle, &flow_in)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayPack>
pub fn tensor_array_pack<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    flow_in: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorArrayPack::new();
    op.call(ctx, handle, flow_in)
}

/// TensorArrayRead
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayRead>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorArrayRead {
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorArrayRead {
    fn default() -> Self {
        Self {
            dtype: None,
            target_device_name: None,
        }
    }
}
impl TensorArrayRead {
    /// Creates a new `TensorArrayRead`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_array_read.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        index: &T1,
        flow_in: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorArrayRead")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&index.to_handle(ctx)?)?;
        op.add_input(&flow_in.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorArrayRead::new().call(&ctx, &handle, &index, &flow_in)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayRead>
pub fn tensor_array_read<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    index: &T1,
    flow_in: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorArrayRead::new();
    op.call(ctx, handle, index, flow_in)
}

/// TensorArrayReadV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayReadV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorArrayReadV2 {
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorArrayReadV2 {
    fn default() -> Self {
        Self {
            dtype: None,
            target_device_name: None,
        }
    }
}
impl TensorArrayReadV2 {
    /// Creates a new `TensorArrayReadV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_array_read_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        index: &T1,
        flow_in: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorArrayReadV2")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&index.to_handle(ctx)?)?;
        op.add_input(&flow_in.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorArrayReadV2::new().call(&ctx, &handle, &index, &flow_in)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayReadV2>
pub fn tensor_array_read_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    index: &T1,
    flow_in: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorArrayReadV2::new();
    op.call(ctx, handle, index, flow_in)
}

/// TensorArrayReadV3
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayReadV3>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorArrayReadV3 {
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorArrayReadV3 {
    fn default() -> Self {
        Self {
            dtype: None,
            target_device_name: None,
        }
    }
}
impl TensorArrayReadV3 {
    /// Creates a new `TensorArrayReadV3`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_array_read_v3.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        index: &T1,
        flow_in: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorArrayReadV3")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&index.to_handle(ctx)?)?;
        op.add_input(&flow_in.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorArrayReadV3::new().call(&ctx, &handle, &index, &flow_in)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayReadV3>
pub fn tensor_array_read_v3<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    index: &T1,
    flow_in: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorArrayReadV3::new();
    op.call(ctx, handle, index, flow_in)
}

/// TensorArrayScatter
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayScatter>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorArrayScatter {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorArrayScatter {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TensorArrayScatter {
    /// Creates a new `TensorArrayScatter`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_array_scatter.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        indices: &T1,
        value: &T2,
        flow_in: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorArrayScatter")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&value.to_handle(ctx)?)?;
        op.add_input(&flow_in.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorArrayScatter::new().call(&ctx, &handle, &indices, &value, &flow_in)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayScatter>
pub fn tensor_array_scatter<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    indices: &T1,
    value: &T2,
    flow_in: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorArrayScatter::new();
    op.call(ctx, handle, indices, value, flow_in)
}

/// TensorArrayScatterV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayScatterV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorArrayScatterV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorArrayScatterV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TensorArrayScatterV2 {
    /// Creates a new `TensorArrayScatterV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_array_scatter_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        indices: &T1,
        value: &T2,
        flow_in: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorArrayScatterV2")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&value.to_handle(ctx)?)?;
        op.add_input(&flow_in.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorArrayScatterV2::new().call(&ctx, &handle, &indices, &value, &flow_in)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayScatterV2>
pub fn tensor_array_scatter_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    indices: &T1,
    value: &T2,
    flow_in: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorArrayScatterV2::new();
    op.call(ctx, handle, indices, value, flow_in)
}

/// TensorArrayScatterV3
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayScatterV3>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorArrayScatterV3 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorArrayScatterV3 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TensorArrayScatterV3 {
    /// Creates a new `TensorArrayScatterV3`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_array_scatter_v3.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        indices: &T1,
        value: &T2,
        flow_in: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorArrayScatterV3")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&value.to_handle(ctx)?)?;
        op.add_input(&flow_in.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorArrayScatterV3::new().call(&ctx, &handle, &indices, &value, &flow_in)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayScatterV3>
pub fn tensor_array_scatter_v3<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    indices: &T1,
    value: &T2,
    flow_in: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorArrayScatterV3::new();
    op.call(ctx, handle, indices, value, flow_in)
}

/// TensorArraySize
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArraySize>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorArraySize {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorArraySize {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TensorArraySize {
    /// Creates a new `TensorArraySize`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_array_size.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        flow_in: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorArraySize")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&flow_in.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorArraySize::new().call(&ctx, &handle, &flow_in)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArraySize>
pub fn tensor_array_size<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    flow_in: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorArraySize::new();
    op.call(ctx, handle, flow_in)
}

/// TensorArraySizeV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArraySizeV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorArraySizeV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorArraySizeV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TensorArraySizeV2 {
    /// Creates a new `TensorArraySizeV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_array_size_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        flow_in: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorArraySizeV2")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&flow_in.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorArraySizeV2::new().call(&ctx, &handle, &flow_in)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArraySizeV2>
pub fn tensor_array_size_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    flow_in: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorArraySizeV2::new();
    op.call(ctx, handle, flow_in)
}

/// TensorArraySizeV3
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArraySizeV3>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorArraySizeV3 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorArraySizeV3 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TensorArraySizeV3 {
    /// Creates a new `TensorArraySizeV3`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_array_size_v3.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        flow_in: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorArraySizeV3")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&flow_in.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorArraySizeV3::new().call(&ctx, &handle, &flow_in)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArraySizeV3>
pub fn tensor_array_size_v3<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    flow_in: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorArraySizeV3::new();
    op.call(ctx, handle, flow_in)
}

/// TensorArraySplit
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArraySplit>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorArraySplit {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorArraySplit {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TensorArraySplit {
    /// Creates a new `TensorArraySplit`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_array_split.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        value: &T1,
        lengths: &T2,
        flow_in: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorArraySplit")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&value.to_handle(ctx)?)?;
        op.add_input(&lengths.to_handle(ctx)?)?;
        op.add_input(&flow_in.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorArraySplit::new().call(&ctx, &handle, &value, &lengths, &flow_in)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArraySplit>
pub fn tensor_array_split<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    value: &T1,
    lengths: &T2,
    flow_in: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorArraySplit::new();
    op.call(ctx, handle, value, lengths, flow_in)
}

/// TensorArraySplitV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArraySplitV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorArraySplitV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorArraySplitV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TensorArraySplitV2 {
    /// Creates a new `TensorArraySplitV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_array_split_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        value: &T1,
        lengths: &T2,
        flow_in: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorArraySplitV2")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&value.to_handle(ctx)?)?;
        op.add_input(&lengths.to_handle(ctx)?)?;
        op.add_input(&flow_in.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorArraySplitV2::new().call(&ctx, &handle, &value, &lengths, &flow_in)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArraySplitV2>
pub fn tensor_array_split_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    value: &T1,
    lengths: &T2,
    flow_in: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorArraySplitV2::new();
    op.call(ctx, handle, value, lengths, flow_in)
}

/// TensorArraySplitV3
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArraySplitV3>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorArraySplitV3 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorArraySplitV3 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TensorArraySplitV3 {
    /// Creates a new `TensorArraySplitV3`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_array_split_v3.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        value: &T1,
        lengths: &T2,
        flow_in: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorArraySplitV3")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&value.to_handle(ctx)?)?;
        op.add_input(&lengths.to_handle(ctx)?)?;
        op.add_input(&flow_in.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorArraySplitV3::new().call(&ctx, &handle, &value, &lengths, &flow_in)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArraySplitV3>
pub fn tensor_array_split_v3<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    value: &T1,
    lengths: &T2,
    flow_in: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorArraySplitV3::new();
    op.call(ctx, handle, value, lengths, flow_in)
}

/// TensorArrayUnpack
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayUnpack>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorArrayUnpack {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorArrayUnpack {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TensorArrayUnpack {
    /// Creates a new `TensorArrayUnpack`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_array_unpack.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        value: &T1,
        flow_in: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorArrayUnpack")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&value.to_handle(ctx)?)?;
        op.add_input(&flow_in.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorArrayUnpack::new().call(&ctx, &handle, &value, &flow_in)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayUnpack>
pub fn tensor_array_unpack<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    value: &T1,
    flow_in: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorArrayUnpack::new();
    op.call(ctx, handle, value, flow_in)
}

/// TensorArrayV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorArrayV2 {
    dtype: ::std::option::Option<crate::DataType>,
    element_shape: ::std::option::Option<crate::Shape>,
    dynamic_size: ::std::option::Option<bool>,
    clear_after_read: ::std::option::Option<bool>,
    tensor_array_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorArrayV2 {
    fn default() -> Self {
        Self {
            dtype: None,
            element_shape: None,
            dynamic_size: Some(false),
            clear_after_read: Some(true),
            tensor_array_name: None,
            target_device_name: None,
        }
    }
}
impl TensorArrayV2 {
    /// Creates a new `TensorArrayV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `element_shape` attribute.
    pub fn element_shape<ArgType: ::std::convert::Into<crate::Shape>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.element_shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dynamic_size` attribute.
    pub fn dynamic_size<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.dynamic_size = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `clear_after_read` attribute.
    pub fn clear_after_read<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.clear_after_read = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `tensor_array_name` attribute.
    pub fn tensor_array_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.tensor_array_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_array_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        size: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorArrayV2")?;

        // Required input arguments
        op.add_input(&size.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.element_shape {
            op.set_attr_shape("element_shape", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dynamic_size {
            op.set_attr_bool("dynamic_size", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.clear_after_read {
            op.set_attr_bool("clear_after_read", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.tensor_array_name {
            op.set_attr_string("tensor_array_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorArrayV2::new().call(&ctx, &size)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayV2>
pub fn tensor_array_v2<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    size: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorArrayV2::new();
    op.call(ctx, size)
}

/// TensorArrayV3
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayV3>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorArrayV3 {
    dtype: ::std::option::Option<crate::DataType>,
    element_shape: ::std::option::Option<crate::Shape>,
    dynamic_size: ::std::option::Option<bool>,
    clear_after_read: ::std::option::Option<bool>,
    identical_element_shapes: ::std::option::Option<bool>,
    tensor_array_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorArrayV3 {
    fn default() -> Self {
        Self {
            dtype: None,
            element_shape: None,
            dynamic_size: Some(false),
            clear_after_read: Some(true),
            identical_element_shapes: Some(false),
            tensor_array_name: None,
            target_device_name: None,
        }
    }
}
impl TensorArrayV3 {
    /// Creates a new `TensorArrayV3`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `element_shape` attribute.
    pub fn element_shape<ArgType: ::std::convert::Into<crate::Shape>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.element_shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dynamic_size` attribute.
    pub fn dynamic_size<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.dynamic_size = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `clear_after_read` attribute.
    pub fn clear_after_read<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.clear_after_read = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `identical_element_shapes` attribute.
    pub fn identical_element_shapes<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.identical_element_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `tensor_array_name` attribute.
    pub fn tensor_array_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.tensor_array_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_array_v3.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        size: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorArrayV3")?;

        // Required input arguments
        op.add_input(&size.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.element_shape {
            op.set_attr_shape("element_shape", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dynamic_size {
            op.set_attr_bool("dynamic_size", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.clear_after_read {
            op.set_attr_bool("clear_after_read", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.identical_element_shapes {
            op.set_attr_bool("identical_element_shapes", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.tensor_array_name {
            op.set_attr_string("tensor_array_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `TensorArrayV3::new().call(&ctx, &size)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayV3>
pub fn tensor_array_v3<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    size: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = TensorArrayV3::new();
    op.call(ctx, size)
}

/// TensorArrayWrite
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayWrite>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorArrayWrite {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorArrayWrite {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TensorArrayWrite {
    /// Creates a new `TensorArrayWrite`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_array_write.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        index: &T1,
        value: &T2,
        flow_in: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorArrayWrite")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&index.to_handle(ctx)?)?;
        op.add_input(&value.to_handle(ctx)?)?;
        op.add_input(&flow_in.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorArrayWrite::new().call(&ctx, &handle, &index, &value, &flow_in)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayWrite>
pub fn tensor_array_write<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    index: &T1,
    value: &T2,
    flow_in: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorArrayWrite::new();
    op.call(ctx, handle, index, value, flow_in)
}

/// TensorArrayWriteV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayWriteV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorArrayWriteV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorArrayWriteV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TensorArrayWriteV2 {
    /// Creates a new `TensorArrayWriteV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_array_write_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        index: &T1,
        value: &T2,
        flow_in: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorArrayWriteV2")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&index.to_handle(ctx)?)?;
        op.add_input(&value.to_handle(ctx)?)?;
        op.add_input(&flow_in.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorArrayWriteV2::new().call(&ctx, &handle, &index, &value, &flow_in)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayWriteV2>
pub fn tensor_array_write_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    index: &T1,
    value: &T2,
    flow_in: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorArrayWriteV2::new();
    op.call(ctx, handle, index, value, flow_in)
}

/// TensorArrayWriteV3
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayWriteV3>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorArrayWriteV3 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorArrayWriteV3 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TensorArrayWriteV3 {
    /// Creates a new `TensorArrayWriteV3`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_array_write_v3.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        handle: &T0,
        index: &T1,
        value: &T2,
        flow_in: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorArrayWriteV3")?;

        // Required input arguments
        op.add_input(&handle.to_handle(ctx)?)?;
        op.add_input(&index.to_handle(ctx)?)?;
        op.add_input(&value.to_handle(ctx)?)?;
        op.add_input(&flow_in.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorArrayWriteV3::new().call(&ctx, &handle, &index, &value, &flow_in)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorArrayWriteV3>
pub fn tensor_array_write_v3<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    handle: &T0,
    index: &T1,
    value: &T2,
    flow_in: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorArrayWriteV3::new();
    op.call(ctx, handle, index, value, flow_in)
}

/// TensorDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorDataset {
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorDataset {
    fn default() -> Self {
        Self {
            output_shapes: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl TensorDataset {
    /// Creates a new `TensorDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        components: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorDataset")?;

        // Required input arguments
        op.add_input(&components.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorDataset::new().call(&ctx, &components)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorDataset>
pub fn tensor_dataset<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    components: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorDataset::new();
    op.call(ctx, components)
}

/// TensorListConcat
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorListConcat>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorListConcat {
    element_dtype: ::std::option::Option<crate::DataType>,
    element_shape: ::std::option::Option<crate::Shape>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorListConcat {
    fn default() -> Self {
        Self {
            element_dtype: None,
            element_shape: None,
            target_device_name: None,
        }
    }
}
impl TensorListConcat {
    /// Creates a new `TensorListConcat`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `element_dtype` attribute.
    pub fn element_dtype<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.element_dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `element_shape` attribute.
    pub fn element_shape<ArgType: ::std::convert::Into<crate::Shape>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.element_shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_list_concat.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_handle: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorListConcat")?;

        // Required input arguments
        op.add_input(&input_handle.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.element_dtype {
            op.set_attr_type("element_dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.element_shape {
            op.set_attr_shape("element_shape", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `TensorListConcat::new().call(&ctx, &input_handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorListConcat>
pub fn tensor_list_concat<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input_handle: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = TensorListConcat::new();
    op.call(ctx, input_handle)
}

/// TensorListConcatLists
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorListConcatLists>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorListConcatLists {
    element_dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorListConcatLists {
    fn default() -> Self {
        Self {
            element_dtype: None,
            target_device_name: None,
        }
    }
}
impl TensorListConcatLists {
    /// Creates a new `TensorListConcatLists`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `element_dtype` attribute.
    pub fn element_dtype<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.element_dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_list_concat_lists.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_a: &T0,
        input_b: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorListConcatLists")?;

        // Required input arguments
        op.add_input(&input_a.to_handle(ctx)?)?;
        op.add_input(&input_b.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.element_dtype {
            op.set_attr_type("element_dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorListConcatLists::new().call(&ctx, &input_a, &input_b)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorListConcatLists>
pub fn tensor_list_concat_lists<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_a: &T0,
    input_b: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorListConcatLists::new();
    op.call(ctx, input_a, input_b)
}

/// TensorListConcatV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorListConcatV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorListConcatV2 {
    element_dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorListConcatV2 {
    fn default() -> Self {
        Self {
            element_dtype: None,
            target_device_name: None,
        }
    }
}
impl TensorListConcatV2 {
    /// Creates a new `TensorListConcatV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `element_dtype` attribute.
    pub fn element_dtype<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.element_dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_list_concat_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_handle: &T0,
        element_shape: &T1,
        leading_dims: &T2,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorListConcatV2")?;

        // Required input arguments
        op.add_input(&input_handle.to_handle(ctx)?)?;
        op.add_input(&element_shape.to_handle(ctx)?)?;
        op.add_input(&leading_dims.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.element_dtype {
            op.set_attr_type("element_dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `TensorListConcatV2::new().call(&ctx, &input_handle, &element_shape, &leading_dims)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorListConcatV2>
pub fn tensor_list_concat_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_handle: &T0,
    element_shape: &T1,
    leading_dims: &T2,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = TensorListConcatV2::new();
    op.call(ctx, input_handle, element_shape, leading_dims)
}

/// TensorListElementShape
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorListElementShape>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorListElementShape {
    shape_type: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorListElementShape {
    fn default() -> Self {
        Self {
            shape_type: None,
            target_device_name: None,
        }
    }
}
impl TensorListElementShape {
    /// Creates a new `TensorListElementShape`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `shape_type` attribute.
    pub fn shape_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shape_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_list_element_shape.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_handle: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorListElementShape")?;

        // Required input arguments
        op.add_input(&input_handle.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.shape_type {
            op.set_attr_type("shape_type", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorListElementShape::new().call(&ctx, &input_handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorListElementShape>
pub fn tensor_list_element_shape<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input_handle: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorListElementShape::new();
    op.call(ctx, input_handle)
}

/// TensorListFromTensor
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorListFromTensor>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorListFromTensor {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorListFromTensor {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TensorListFromTensor {
    /// Creates a new `TensorListFromTensor`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_list_from_tensor.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        tensor: &T0,
        element_shape: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorListFromTensor")?;

        // Required input arguments
        op.add_input(&tensor.to_handle(ctx)?)?;
        op.add_input(&element_shape.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorListFromTensor::new().call(&ctx, &tensor, &element_shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorListFromTensor>
pub fn tensor_list_from_tensor<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    tensor: &T0,
    element_shape: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorListFromTensor::new();
    op.call(ctx, tensor, element_shape)
}

/// TensorListGather
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorListGather>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorListGather {
    element_dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorListGather {
    fn default() -> Self {
        Self {
            element_dtype: None,
            target_device_name: None,
        }
    }
}
impl TensorListGather {
    /// Creates a new `TensorListGather`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `element_dtype` attribute.
    pub fn element_dtype<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.element_dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_list_gather.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_handle: &T0,
        indices: &T1,
        element_shape: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorListGather")?;

        // Required input arguments
        op.add_input(&input_handle.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&element_shape.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.element_dtype {
            op.set_attr_type("element_dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorListGather::new().call(&ctx, &input_handle, &indices, &element_shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorListGather>
pub fn tensor_list_gather<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_handle: &T0,
    indices: &T1,
    element_shape: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorListGather::new();
    op.call(ctx, input_handle, indices, element_shape)
}

/// TensorListGetItem
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorListGetItem>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorListGetItem {
    element_dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorListGetItem {
    fn default() -> Self {
        Self {
            element_dtype: None,
            target_device_name: None,
        }
    }
}
impl TensorListGetItem {
    /// Creates a new `TensorListGetItem`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `element_dtype` attribute.
    pub fn element_dtype<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.element_dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_list_get_item.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_handle: &T0,
        index: &T1,
        element_shape: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorListGetItem")?;

        // Required input arguments
        op.add_input(&input_handle.to_handle(ctx)?)?;
        op.add_input(&index.to_handle(ctx)?)?;
        op.add_input(&element_shape.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.element_dtype {
            op.set_attr_type("element_dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorListGetItem::new().call(&ctx, &input_handle, &index, &element_shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorListGetItem>
pub fn tensor_list_get_item<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_handle: &T0,
    index: &T1,
    element_shape: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorListGetItem::new();
    op.call(ctx, input_handle, index, element_shape)
}

/// TensorListLength
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorListLength>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorListLength {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorListLength {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TensorListLength {
    /// Creates a new `TensorListLength`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_list_length.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_handle: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorListLength")?;

        // Required input arguments
        op.add_input(&input_handle.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorListLength::new().call(&ctx, &input_handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorListLength>
pub fn tensor_list_length<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input_handle: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorListLength::new();
    op.call(ctx, input_handle)
}

/// TensorListPopBack
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorListPopBack>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorListPopBack {
    element_dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorListPopBack {
    fn default() -> Self {
        Self {
            element_dtype: None,
            target_device_name: None,
        }
    }
}
impl TensorListPopBack {
    /// Creates a new `TensorListPopBack`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `element_dtype` attribute.
    pub fn element_dtype<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.element_dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_list_pop_back.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_handle: &T0,
        element_shape: &T1,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorListPopBack")?;

        // Required input arguments
        op.add_input(&input_handle.to_handle(ctx)?)?;
        op.add_input(&element_shape.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.element_dtype {
            op.set_attr_type("element_dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `TensorListPopBack::new().call(&ctx, &input_handle, &element_shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorListPopBack>
pub fn tensor_list_pop_back<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_handle: &T0,
    element_shape: &T1,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = TensorListPopBack::new();
    op.call(ctx, input_handle, element_shape)
}

/// TensorListPushBack
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorListPushBack>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorListPushBack {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorListPushBack {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TensorListPushBack {
    /// Creates a new `TensorListPushBack`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_list_push_back.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_handle: &T0,
        tensor: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorListPushBack")?;

        // Required input arguments
        op.add_input(&input_handle.to_handle(ctx)?)?;
        op.add_input(&tensor.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorListPushBack::new().call(&ctx, &input_handle, &tensor)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorListPushBack>
pub fn tensor_list_push_back<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_handle: &T0,
    tensor: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorListPushBack::new();
    op.call(ctx, input_handle, tensor)
}

/// TensorListPushBackBatch
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorListPushBackBatch>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorListPushBackBatch {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorListPushBackBatch {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TensorListPushBackBatch {
    /// Creates a new `TensorListPushBackBatch`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_list_push_back_batch.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_handles: &T0,
        tensor: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorListPushBackBatch")?;

        // Required input arguments
        op.add_input(&input_handles.to_handle(ctx)?)?;
        op.add_input(&tensor.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorListPushBackBatch::new().call(&ctx, &input_handles, &tensor)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorListPushBackBatch>
pub fn tensor_list_push_back_batch<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_handles: &T0,
    tensor: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorListPushBackBatch::new();
    op.call(ctx, input_handles, tensor)
}

/// TensorListReserve
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorListReserve>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorListReserve {
    element_dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorListReserve {
    fn default() -> Self {
        Self {
            element_dtype: None,
            target_device_name: None,
        }
    }
}
impl TensorListReserve {
    /// Creates a new `TensorListReserve`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `element_dtype` attribute.
    pub fn element_dtype<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.element_dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_list_reserve.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        element_shape: &T0,
        num_elements: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorListReserve")?;

        // Required input arguments
        op.add_input(&element_shape.to_handle(ctx)?)?;
        op.add_input(&num_elements.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.element_dtype {
            op.set_attr_type("element_dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorListReserve::new().call(&ctx, &element_shape, &num_elements)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorListReserve>
pub fn tensor_list_reserve<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    element_shape: &T0,
    num_elements: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorListReserve::new();
    op.call(ctx, element_shape, num_elements)
}

/// TensorListResize
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorListResize>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorListResize {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorListResize {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TensorListResize {
    /// Creates a new `TensorListResize`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_list_resize.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_handle: &T0,
        size: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorListResize")?;

        // Required input arguments
        op.add_input(&input_handle.to_handle(ctx)?)?;
        op.add_input(&size.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorListResize::new().call(&ctx, &input_handle, &size)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorListResize>
pub fn tensor_list_resize<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_handle: &T0,
    size: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorListResize::new();
    op.call(ctx, input_handle, size)
}

/// TensorListScatter
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorListScatter>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorListScatter {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorListScatter {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TensorListScatter {
    /// Creates a new `TensorListScatter`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_list_scatter.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        tensor: &T0,
        indices: &T1,
        element_shape: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorListScatter")?;

        // Required input arguments
        op.add_input(&tensor.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&element_shape.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorListScatter::new().call(&ctx, &tensor, &indices, &element_shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorListScatter>
pub fn tensor_list_scatter<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    tensor: &T0,
    indices: &T1,
    element_shape: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorListScatter::new();
    op.call(ctx, tensor, indices, element_shape)
}

/// TensorListScatterIntoExistingList
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorListScatterIntoExistingList>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorListScatterIntoExistingList {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorListScatterIntoExistingList {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TensorListScatterIntoExistingList {
    /// Creates a new `TensorListScatterIntoExistingList`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_list_scatter_into_existing_list.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_handle: &T0,
        tensor: &T1,
        indices: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorListScatterIntoExistingList")?;

        // Required input arguments
        op.add_input(&input_handle.to_handle(ctx)?)?;
        op.add_input(&tensor.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorListScatterIntoExistingList::new().call(&ctx, &input_handle, &tensor, &indices)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorListScatterIntoExistingList>
pub fn tensor_list_scatter_into_existing_list<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_handle: &T0,
    tensor: &T1,
    indices: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorListScatterIntoExistingList::new();
    op.call(ctx, input_handle, tensor, indices)
}

/// TensorListScatterV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorListScatterV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorListScatterV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorListScatterV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TensorListScatterV2 {
    /// Creates a new `TensorListScatterV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_list_scatter_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        tensor: &T0,
        indices: &T1,
        element_shape: &T2,
        num_elements: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorListScatterV2")?;

        // Required input arguments
        op.add_input(&tensor.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&element_shape.to_handle(ctx)?)?;
        op.add_input(&num_elements.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorListScatterV2::new().call(&ctx, &tensor, &indices, &element_shape, &num_elements)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorListScatterV2>
pub fn tensor_list_scatter_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    tensor: &T0,
    indices: &T1,
    element_shape: &T2,
    num_elements: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorListScatterV2::new();
    op.call(ctx, tensor, indices, element_shape, num_elements)
}

/// TensorListSetItem
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorListSetItem>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorListSetItem {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorListSetItem {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TensorListSetItem {
    /// Creates a new `TensorListSetItem`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_list_set_item.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_handle: &T0,
        index: &T1,
        item: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorListSetItem")?;

        // Required input arguments
        op.add_input(&input_handle.to_handle(ctx)?)?;
        op.add_input(&index.to_handle(ctx)?)?;
        op.add_input(&item.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorListSetItem::new().call(&ctx, &input_handle, &index, &item)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorListSetItem>
pub fn tensor_list_set_item<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_handle: &T0,
    index: &T1,
    item: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorListSetItem::new();
    op.call(ctx, input_handle, index, item)
}

/// TensorListSplit
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorListSplit>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorListSplit {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorListSplit {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TensorListSplit {
    /// Creates a new `TensorListSplit`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_list_split.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        tensor: &T0,
        element_shape: &T1,
        lengths: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorListSplit")?;

        // Required input arguments
        op.add_input(&tensor.to_handle(ctx)?)?;
        op.add_input(&element_shape.to_handle(ctx)?)?;
        op.add_input(&lengths.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorListSplit::new().call(&ctx, &tensor, &element_shape, &lengths)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorListSplit>
pub fn tensor_list_split<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    tensor: &T0,
    element_shape: &T1,
    lengths: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorListSplit::new();
    op.call(ctx, tensor, element_shape, lengths)
}

/// TensorListStack
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorListStack>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorListStack {
    element_dtype: ::std::option::Option<crate::DataType>,
    num_elements: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorListStack {
    fn default() -> Self {
        Self {
            element_dtype: None,
            num_elements: Some(-1i64),
            target_device_name: None,
        }
    }
}
impl TensorListStack {
    /// Creates a new `TensorListStack`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `element_dtype` attribute.
    pub fn element_dtype<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.element_dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_elements` attribute.
    pub fn num_elements<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_elements = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_list_stack.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_handle: &T0,
        element_shape: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorListStack")?;

        // Required input arguments
        op.add_input(&input_handle.to_handle(ctx)?)?;
        op.add_input(&element_shape.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.element_dtype {
            op.set_attr_type("element_dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_elements {
            op.set_attr_int("num_elements", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorListStack::new().call(&ctx, &input_handle, &element_shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorListStack>
pub fn tensor_list_stack<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_handle: &T0,
    element_shape: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorListStack::new();
    op.call(ctx, input_handle, element_shape)
}

/// TensorMapErase
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorMapErase>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorMapErase {
    value_dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorMapErase {
    fn default() -> Self {
        Self {
            value_dtype: None,
            target_device_name: None,
        }
    }
}
impl TensorMapErase {
    /// Creates a new `TensorMapErase`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `value_dtype` attribute.
    pub fn value_dtype<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.value_dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_map_erase.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_handle: &T0,
        key: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorMapErase")?;

        // Required input arguments
        op.add_input(&input_handle.to_handle(ctx)?)?;
        op.add_input(&key.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.value_dtype {
            op.set_attr_type("value_dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorMapErase::new().call(&ctx, &input_handle, &key)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorMapErase>
pub fn tensor_map_erase<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_handle: &T0,
    key: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorMapErase::new();
    op.call(ctx, input_handle, key)
}

/// TensorMapHasKey
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorMapHasKey>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorMapHasKey {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorMapHasKey {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TensorMapHasKey {
    /// Creates a new `TensorMapHasKey`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_map_has_key.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_handle: &T0,
        key: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorMapHasKey")?;

        // Required input arguments
        op.add_input(&input_handle.to_handle(ctx)?)?;
        op.add_input(&key.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorMapHasKey::new().call(&ctx, &input_handle, &key)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorMapHasKey>
pub fn tensor_map_has_key<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_handle: &T0,
    key: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorMapHasKey::new();
    op.call(ctx, input_handle, key)
}

/// TensorMapInsert
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorMapInsert>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorMapInsert {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorMapInsert {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TensorMapInsert {
    /// Creates a new `TensorMapInsert`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_map_insert.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_handle: &T0,
        key: &T1,
        value: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorMapInsert")?;

        // Required input arguments
        op.add_input(&input_handle.to_handle(ctx)?)?;
        op.add_input(&key.to_handle(ctx)?)?;
        op.add_input(&value.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorMapInsert::new().call(&ctx, &input_handle, &key, &value)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorMapInsert>
pub fn tensor_map_insert<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_handle: &T0,
    key: &T1,
    value: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorMapInsert::new();
    op.call(ctx, input_handle, key, value)
}

/// TensorMapLookup
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorMapLookup>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorMapLookup {
    value_dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorMapLookup {
    fn default() -> Self {
        Self {
            value_dtype: None,
            target_device_name: None,
        }
    }
}
impl TensorMapLookup {
    /// Creates a new `TensorMapLookup`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `value_dtype` attribute.
    pub fn value_dtype<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.value_dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_map_lookup.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_handle: &T0,
        key: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorMapLookup")?;

        // Required input arguments
        op.add_input(&input_handle.to_handle(ctx)?)?;
        op.add_input(&key.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.value_dtype {
            op.set_attr_type("value_dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorMapLookup::new().call(&ctx, &input_handle, &key)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorMapLookup>
pub fn tensor_map_lookup<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_handle: &T0,
    key: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorMapLookup::new();
    op.call(ctx, input_handle, key)
}

/// TensorMapSize
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorMapSize>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorMapSize {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorMapSize {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TensorMapSize {
    /// Creates a new `TensorMapSize`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_map_size.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_handle: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorMapSize")?;

        // Required input arguments
        op.add_input(&input_handle.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorMapSize::new().call(&ctx, &input_handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorMapSize>
pub fn tensor_map_size<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input_handle: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorMapSize::new();
    op.call(ctx, input_handle)
}

/// TensorMapStackKeys
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorMapStackKeys>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorMapStackKeys {
    key_dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorMapStackKeys {
    fn default() -> Self {
        Self {
            key_dtype: None,
            target_device_name: None,
        }
    }
}
impl TensorMapStackKeys {
    /// Creates a new `TensorMapStackKeys`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `key_dtype` attribute.
    pub fn key_dtype<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.key_dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_map_stack_keys.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_handle: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorMapStackKeys")?;

        // Required input arguments
        op.add_input(&input_handle.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.key_dtype {
            op.set_attr_type("key_dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorMapStackKeys::new().call(&ctx, &input_handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorMapStackKeys>
pub fn tensor_map_stack_keys<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input_handle: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorMapStackKeys::new();
    op.call(ctx, input_handle)
}

/// TensorScatterAdd
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorScatterAdd>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorScatterAdd {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorScatterAdd {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TensorScatterAdd {
    /// Creates a new `TensorScatterAdd`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_scatter_add.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        tensor: &T0,
        indices: &T1,
        updates: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorScatterAdd")?;

        // Required input arguments
        op.add_input(&tensor.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&updates.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorScatterAdd::new().call(&ctx, &tensor, &indices, &updates)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorScatterAdd>
pub fn tensor_scatter_add<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    tensor: &T0,
    indices: &T1,
    updates: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorScatterAdd::new();
    op.call(ctx, tensor, indices, updates)
}

/// TensorScatterMax
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorScatterMax>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorScatterMax {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorScatterMax {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TensorScatterMax {
    /// Creates a new `TensorScatterMax`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_scatter_max.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        tensor: &T0,
        indices: &T1,
        updates: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorScatterMax")?;

        // Required input arguments
        op.add_input(&tensor.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&updates.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorScatterMax::new().call(&ctx, &tensor, &indices, &updates)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorScatterMax>
pub fn tensor_scatter_max<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    tensor: &T0,
    indices: &T1,
    updates: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorScatterMax::new();
    op.call(ctx, tensor, indices, updates)
}

/// TensorScatterMin
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorScatterMin>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorScatterMin {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorScatterMin {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TensorScatterMin {
    /// Creates a new `TensorScatterMin`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_scatter_min.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        tensor: &T0,
        indices: &T1,
        updates: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorScatterMin")?;

        // Required input arguments
        op.add_input(&tensor.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&updates.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorScatterMin::new().call(&ctx, &tensor, &indices, &updates)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorScatterMin>
pub fn tensor_scatter_min<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    tensor: &T0,
    indices: &T1,
    updates: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorScatterMin::new();
    op.call(ctx, tensor, indices, updates)
}

/// TensorScatterSub
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorScatterSub>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorScatterSub {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorScatterSub {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TensorScatterSub {
    /// Creates a new `TensorScatterSub`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_scatter_sub.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        tensor: &T0,
        indices: &T1,
        updates: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorScatterSub")?;

        // Required input arguments
        op.add_input(&tensor.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&updates.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorScatterSub::new().call(&ctx, &tensor, &indices, &updates)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorScatterSub>
pub fn tensor_scatter_sub<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    tensor: &T0,
    indices: &T1,
    updates: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorScatterSub::new();
    op.call(ctx, tensor, indices, updates)
}

/// TensorScatterUpdate
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorScatterUpdate>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorScatterUpdate {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorScatterUpdate {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TensorScatterUpdate {
    /// Creates a new `TensorScatterUpdate`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_scatter_update.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        tensor: &T0,
        indices: &T1,
        updates: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorScatterUpdate")?;

        // Required input arguments
        op.add_input(&tensor.to_handle(ctx)?)?;
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&updates.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorScatterUpdate::new().call(&ctx, &tensor, &indices, &updates)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorScatterUpdate>
pub fn tensor_scatter_update<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    tensor: &T0,
    indices: &T1,
    updates: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorScatterUpdate::new();
    op.call(ctx, tensor, indices, updates)
}

/// TensorSliceDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorSliceDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorSliceDataset {
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    is_files: ::std::option::Option<bool>,
    metadata: ::std::option::Option<::std::string::String>,
    replicate_on_split: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorSliceDataset {
    fn default() -> Self {
        Self {
            output_shapes: None,
            is_files: Some(false),
            metadata: None,
            replicate_on_split: Some(false),
            target_device_name: None,
        }
    }
}
impl TensorSliceDataset {
    /// Creates a new `TensorSliceDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `is_files` attribute.
    pub fn is_files<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.is_files = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `replicate_on_split` attribute.
    pub fn replicate_on_split<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.replicate_on_split = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_slice_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        components: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorSliceDataset")?;

        // Required input arguments
        op.add_input(&components.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.is_files {
            op.set_attr_bool("is_files", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.replicate_on_split {
            op.set_attr_bool("replicate_on_split", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorSliceDataset::new().call(&ctx, &components)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorSliceDataset>
pub fn tensor_slice_dataset<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    components: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorSliceDataset::new();
    op.call(ctx, components)
}

/// TensorStridedSliceUpdate
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorStridedSliceUpdate>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorStridedSliceUpdate {
    begin_mask: ::std::option::Option<i64>,
    end_mask: ::std::option::Option<i64>,
    ellipsis_mask: ::std::option::Option<i64>,
    new_axis_mask: ::std::option::Option<i64>,
    shrink_axis_mask: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorStridedSliceUpdate {
    fn default() -> Self {
        Self {
            begin_mask: Some(0i64),
            end_mask: Some(0i64),
            ellipsis_mask: Some(0i64),
            new_axis_mask: Some(0i64),
            shrink_axis_mask: Some(0i64),
            target_device_name: None,
        }
    }
}
impl TensorStridedSliceUpdate {
    /// Creates a new `TensorStridedSliceUpdate`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `begin_mask` attribute.
    pub fn begin_mask<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.begin_mask = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `end_mask` attribute.
    pub fn end_mask<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.end_mask = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `ellipsis_mask` attribute.
    pub fn ellipsis_mask<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.ellipsis_mask = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `new_axis_mask` attribute.
    pub fn new_axis_mask<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.new_axis_mask = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shrink_axis_mask` attribute.
    pub fn shrink_axis_mask<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.shrink_axis_mask = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_strided_slice_update.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        begin: &T1,
        end: &T2,
        strides: &T3,
        value: &T4,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorStridedSliceUpdate")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&begin.to_handle(ctx)?)?;
        op.add_input(&end.to_handle(ctx)?)?;
        op.add_input(&strides.to_handle(ctx)?)?;
        op.add_input(&value.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.begin_mask {
            op.set_attr_int("begin_mask", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.end_mask {
            op.set_attr_int("end_mask", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.ellipsis_mask {
            op.set_attr_int("ellipsis_mask", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.new_axis_mask {
            op.set_attr_int("new_axis_mask", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shrink_axis_mask {
            op.set_attr_int("shrink_axis_mask", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorStridedSliceUpdate::new().call(&ctx, &input, &begin, &end, &strides, &value)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorStridedSliceUpdate>
pub fn tensor_strided_slice_update<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    begin: &T1,
    end: &T2,
    strides: &T3,
    value: &T4,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorStridedSliceUpdate::new();
    op.call(ctx, input, begin, end, strides, value)
}

/// TensorSummary
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorSummary>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorSummary {
    description: ::std::option::Option<::std::string::String>,
    labels: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    display_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorSummary {
    fn default() -> Self {
        Self {
            description: None,
            labels: Some(vec![]),
            display_name: None,
            target_device_name: None,
        }
    }
}
impl TensorSummary {
    /// Creates a new `TensorSummary`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `description` attribute.
    pub fn description<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.description = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `labels` attribute.
    pub fn labels<ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.labels = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `display_name` attribute.
    pub fn display_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.display_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_summary.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        tensor: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorSummary")?;

        // Required input arguments
        op.add_input(&tensor.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.description {
            op.set_attr_string("description", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.labels {
            op.set_attr_string_list("labels", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.display_name {
            op.set_attr_string("display_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorSummary::new().call(&ctx, &tensor)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorSummary>
pub fn tensor_summary<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    tensor: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorSummary::new();
    op.call(ctx, tensor)
}

/// TensorSummaryV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorSummaryV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TensorSummaryV2 {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TensorSummaryV2 {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TensorSummaryV2 {
    /// Creates a new `TensorSummaryV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tensor_summary_v2.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        tag: &T0,
        tensor: &T1,
        serialized_summary_metadata: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TensorSummaryV2")?;

        // Required input arguments
        op.add_input(&tag.to_handle(ctx)?)?;
        op.add_input(&tensor.to_handle(ctx)?)?;
        op.add_input(&serialized_summary_metadata.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TensorSummaryV2::new().call(&ctx, &tag, &tensor, &serialized_summary_metadata)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TensorSummaryV2>
pub fn tensor_summary_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    tag: &T0,
    tensor: &T1,
    serialized_summary_metadata: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TensorSummaryV2::new();
    op.call(ctx, tag, tensor, serialized_summary_metadata)
}

/// TextLineDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TextLineDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TextLineDataset {
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TextLineDataset {
    fn default() -> Self {
        Self {
            metadata: None,
            target_device_name: None,
        }
    }
}
impl TextLineDataset {
    /// Creates a new `TextLineDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute text_line_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        filenames: &T0,
        compression_type: &T1,
        buffer_size: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TextLineDataset")?;

        // Required input arguments
        op.add_input(&filenames.to_handle(ctx)?)?;
        op.add_input(&compression_type.to_handle(ctx)?)?;
        op.add_input(&buffer_size.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TextLineDataset::new().call(&ctx, &filenames, &compression_type, &buffer_size)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TextLineDataset>
pub fn text_line_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    filenames: &T0,
    compression_type: &T1,
    buffer_size: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TextLineDataset::new();
    op.call(ctx, filenames, compression_type, buffer_size)
}

/// TextLineReader
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TextLineReader>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TextLineReader {
    skip_header_lines: ::std::option::Option<i64>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TextLineReader {
    fn default() -> Self {
        Self {
            skip_header_lines: Some(0i64),
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl TextLineReader {
    /// Creates a new `TextLineReader`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `skip_header_lines` attribute.
    pub fn skip_header_lines<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.skip_header_lines = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute text_line_reader.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TextLineReader")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.skip_header_lines {
            op.set_attr_int("skip_header_lines", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TextLineReader::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TextLineReader>
pub fn text_line_reader<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TextLineReader::new();
    op.call(ctx)
}

/// TextLineReaderV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TextLineReaderV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TextLineReaderV2 {
    skip_header_lines: ::std::option::Option<i64>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TextLineReaderV2 {
    fn default() -> Self {
        Self {
            skip_header_lines: Some(0i64),
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl TextLineReaderV2 {
    /// Creates a new `TextLineReaderV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `skip_header_lines` attribute.
    pub fn skip_header_lines<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.skip_header_lines = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute text_line_reader_v2.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TextLineReaderV2")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.skip_header_lines {
            op.set_attr_int("skip_header_lines", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TextLineReaderV2::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TextLineReaderV2>
pub fn text_line_reader_v2<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TextLineReaderV2::new();
    op.call(ctx)
}

/// ThreadPoolDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ThreadPoolDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ThreadPoolDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ThreadPoolDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl ThreadPoolDataset {
    /// Creates a new `ThreadPoolDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute thread_pool_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        thread_pool: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ThreadPoolDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&thread_pool.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ThreadPoolDataset::new().call(&ctx, &input_dataset, &thread_pool)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ThreadPoolDataset>
pub fn thread_pool_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    thread_pool: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ThreadPoolDataset::new();
    op.call(ctx, input_dataset, thread_pool)
}

/// ThreadPoolHandle
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ThreadPoolHandle>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ThreadPoolHandle {
    num_threads: ::std::option::Option<i64>,
    max_intra_op_parallelism: ::std::option::Option<i64>,
    display_name: ::std::option::Option<::std::string::String>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ThreadPoolHandle {
    fn default() -> Self {
        Self {
            num_threads: None,
            max_intra_op_parallelism: Some(1i64),
            display_name: None,
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl ThreadPoolHandle {
    /// Creates a new `ThreadPoolHandle`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_threads` attribute.
    pub fn num_threads<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_threads = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `max_intra_op_parallelism` attribute.
    pub fn max_intra_op_parallelism<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.max_intra_op_parallelism = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `display_name` attribute.
    pub fn display_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.display_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute thread_pool_handle.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ThreadPoolHandle")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_threads {
            op.set_attr_int("num_threads", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.max_intra_op_parallelism {
            op.set_attr_int("max_intra_op_parallelism", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.display_name {
            op.set_attr_string("display_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ThreadPoolHandle::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ThreadPoolHandle>
pub fn thread_pool_handle<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ThreadPoolHandle::new();
    op.call(ctx)
}

/// ThreadUnsafeUnigramCandidateSampler
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ThreadUnsafeUnigramCandidateSampler>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ThreadUnsafeUnigramCandidateSampler {
    num_true: ::std::option::Option<i64>,
    num_sampled: ::std::option::Option<i64>,
    unique: ::std::option::Option<bool>,
    range_max: ::std::option::Option<i64>,
    seed: ::std::option::Option<i64>,
    seed2: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ThreadUnsafeUnigramCandidateSampler {
    fn default() -> Self {
        Self {
            num_true: None,
            num_sampled: None,
            unique: None,
            range_max: None,
            seed: Some(0i64),
            seed2: Some(0i64),
            target_device_name: None,
        }
    }
}
impl ThreadUnsafeUnigramCandidateSampler {
    /// Creates a new `ThreadUnsafeUnigramCandidateSampler`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_true` attribute.
    pub fn num_true<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_true = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_sampled` attribute.
    pub fn num_sampled<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_sampled = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `unique` attribute.
    pub fn unique<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.unique = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `range_max` attribute.
    pub fn range_max<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.range_max = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed` attribute.
    pub fn seed<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed2` attribute.
    pub fn seed2<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute thread_unsafe_unigram_candidate_sampler.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        true_classes: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "ThreadUnsafeUnigramCandidateSampler")?;

        // Required input arguments
        op.add_input(&true_classes.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_true {
            op.set_attr_int("num_true", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_sampled {
            op.set_attr_int("num_sampled", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.unique {
            op.set_attr_bool("unique", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.range_max {
            op.set_attr_int("range_max", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed {
            op.set_attr_int("seed", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed2 {
            op.set_attr_int("seed2", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `ThreadUnsafeUnigramCandidateSampler::new().call(&ctx, &true_classes)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ThreadUnsafeUnigramCandidateSampler>
pub fn thread_unsafe_unigram_candidate_sampler<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    true_classes: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = ThreadUnsafeUnigramCandidateSampler::new();
    op.call(ctx, true_classes)
}

/// Tile
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Tile>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Tile {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Tile {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Tile {
    /// Creates a new `Tile`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tile.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        multiples: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Tile")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&multiples.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Tile::new().call(&ctx, &input, &multiples)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Tile>
pub fn tile<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    multiples: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Tile::new();
    op.call(ctx, input, multiples)
}

/// TileGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TileGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TileGrad {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TileGrad {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TileGrad {
    /// Creates a new `TileGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tile_grad.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        multiples: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TileGrad")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&multiples.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TileGrad::new().call(&ctx, &input, &multiples)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TileGrad>
pub fn tile_grad<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    multiples: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TileGrad::new();
    op.call(ctx, input, multiples)
}

/// Timestamp
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Timestamp>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Timestamp {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Timestamp {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Timestamp {
    /// Creates a new `Timestamp`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute timestamp.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Timestamp")?;

        // Required input arguments

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Timestamp::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Timestamp>
pub fn timestamp<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Timestamp::new();
    op.call(ctx)
}

/// ToBool
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ToBool>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ToBool {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ToBool {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ToBool {
    /// Creates a new `ToBool`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute to_bool.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ToBool")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ToBool::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ToBool>
pub fn to_bool<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ToBool::new();
    op.call(ctx, input)
}

/// TopK
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TopK>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TopK {
    k: ::std::option::Option<i64>,
    sorted: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TopK {
    fn default() -> Self {
        Self {
            k: None,
            sorted: Some(true),
            target_device_name: None,
        }
    }
}
impl TopK {
    /// Creates a new `TopK`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `k` attribute.
    pub fn k<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.k = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `sorted` attribute.
    pub fn sorted<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.sorted = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute top_k.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "TopK")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.k {
            op.set_attr_int("k", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.sorted {
            op.set_attr_bool("sorted", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `TopK::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TopK>
pub fn top_k<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = TopK::new();
    op.call(ctx, input)
}

/// TopKUnique
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TopKUnique>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TopKUnique {
    k: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TopKUnique {
    fn default() -> Self {
        Self {
            k: None,
            target_device_name: None,
        }
    }
}
impl TopKUnique {
    /// Creates a new `TopKUnique`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `k` attribute.
    pub fn k<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.k = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute top_kunique.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "TopKUnique")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.k {
            op.set_attr_int("k", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `TopKUnique::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TopKUnique>
pub fn top_kunique<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = TopKUnique::new();
    op.call(ctx, input)
}

/// TopKV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TopKV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TopKV2 {
    sorted: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TopKV2 {
    fn default() -> Self {
        Self {
            sorted: Some(true),
            target_device_name: None,
        }
    }
}
impl TopKV2 {
    /// Creates a new `TopKV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `sorted` attribute.
    pub fn sorted<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.sorted = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute top_kv2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        k: &T1,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "TopKV2")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&k.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.sorted {
            op.set_attr_bool("sorted", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `TopKV2::new().call(&ctx, &input, &k)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TopKV2>
pub fn top_kv2<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    k: &T1,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = TopKV2::new();
    op.call(ctx, input, k)
}

/// TopKWithUnique
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TopKWithUnique>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TopKWithUnique {
    k: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TopKWithUnique {
    fn default() -> Self {
        Self {
            k: None,
            target_device_name: None,
        }
    }
}
impl TopKWithUnique {
    /// Creates a new `TopKWithUnique`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `k` attribute.
    pub fn k<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.k = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute top_kwith_unique.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "TopKWithUnique")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.k {
            op.set_attr_int("k", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `TopKWithUnique::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TopKWithUnique>
pub fn top_kwith_unique<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = TopKWithUnique::new();
    op.call(ctx, input)
}

/// TpuHandleToProtoKey
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TpuHandleToProtoKey>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TpuHandleToProtoKey {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TpuHandleToProtoKey {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TpuHandleToProtoKey {
    /// Creates a new `TpuHandleToProtoKey`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tpu_handle_to_proto_key.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        uid: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TpuHandleToProtoKey")?;

        // Required input arguments
        op.add_input(&uid.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TpuHandleToProtoKey::new().call(&ctx, &uid)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TpuHandleToProtoKey>
pub fn tpu_handle_to_proto_key<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    uid: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TpuHandleToProtoKey::new();
    op.call(ctx, uid)
}

/// Transpose
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Transpose>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Transpose {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Transpose {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Transpose {
    /// Creates a new `Transpose`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute transpose.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        perm: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Transpose")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&perm.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Transpose::new().call(&ctx, &x, &perm)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Transpose>
pub fn transpose<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    perm: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Transpose::new();
    op.call(ctx, x, perm)
}

/// TridiagonalMatMul
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TridiagonalMatMul>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TridiagonalMatMul {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TridiagonalMatMul {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TridiagonalMatMul {
    /// Creates a new `TridiagonalMatMul`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tridiagonal_mat_mul.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        superdiag: &T0,
        maindiag: &T1,
        subdiag: &T2,
        rhs: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TridiagonalMatMul")?;

        // Required input arguments
        op.add_input(&superdiag.to_handle(ctx)?)?;
        op.add_input(&maindiag.to_handle(ctx)?)?;
        op.add_input(&subdiag.to_handle(ctx)?)?;
        op.add_input(&rhs.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TridiagonalMatMul::new().call(&ctx, &superdiag, &maindiag, &subdiag, &rhs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TridiagonalMatMul>
pub fn tridiagonal_mat_mul<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    superdiag: &T0,
    maindiag: &T1,
    subdiag: &T2,
    rhs: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TridiagonalMatMul::new();
    op.call(ctx, superdiag, maindiag, subdiag, rhs)
}

/// TridiagonalSolve
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TridiagonalSolve>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TridiagonalSolve {
    partial_pivoting: ::std::option::Option<bool>,
    perturb_singular: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TridiagonalSolve {
    fn default() -> Self {
        Self {
            partial_pivoting: Some(true),
            perturb_singular: Some(false),
            target_device_name: None,
        }
    }
}
impl TridiagonalSolve {
    /// Creates a new `TridiagonalSolve`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `partial_pivoting` attribute.
    pub fn partial_pivoting<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.partial_pivoting = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `perturb_singular` attribute.
    pub fn perturb_singular<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.perturb_singular = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute tridiagonal_solve.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        diagonals: &T0,
        rhs: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TridiagonalSolve")?;

        // Required input arguments
        op.add_input(&diagonals.to_handle(ctx)?)?;
        op.add_input(&rhs.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.partial_pivoting {
            op.set_attr_bool("partial_pivoting", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.perturb_singular {
            op.set_attr_bool("perturb_singular", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TridiagonalSolve::new().call(&ctx, &diagonals, &rhs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TridiagonalSolve>
pub fn tridiagonal_solve<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    diagonals: &T0,
    rhs: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TridiagonalSolve::new();
    op.call(ctx, diagonals, rhs)
}

/// TruncateDiv
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TruncateDiv>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TruncateDiv {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TruncateDiv {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TruncateDiv {
    /// Creates a new `TruncateDiv`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute truncate_div.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TruncateDiv")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TruncateDiv::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TruncateDiv>
pub fn truncate_div<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TruncateDiv::new();
    op.call(ctx, x, y)
}

/// TruncateMod
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TruncateMod>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TruncateMod {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TruncateMod {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl TruncateMod {
    /// Creates a new `TruncateMod`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute truncate_mod.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TruncateMod")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TruncateMod::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TruncateMod>
pub fn truncate_mod<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TruncateMod::new();
    op.call(ctx, x, y)
}

/// TruncatedNormal
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TruncatedNormal>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct TruncatedNormal {
    seed: ::std::option::Option<i64>,
    seed2: ::std::option::Option<i64>,
    dtype: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for TruncatedNormal {
    fn default() -> Self {
        Self {
            seed: Some(0i64),
            seed2: Some(0i64),
            dtype: None,
            target_device_name: None,
        }
    }
}
impl TruncatedNormal {
    /// Creates a new `TruncatedNormal`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `seed` attribute.
    pub fn seed<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed2` attribute.
    pub fn seed2<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute truncated_normal.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        shape: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "TruncatedNormal")?;

        // Required input arguments
        op.add_input(&shape.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.seed {
            op.set_attr_int("seed", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed2 {
            op.set_attr_int("seed2", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `TruncatedNormal::new().call(&ctx, &shape)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/TruncatedNormal>
pub fn truncated_normal<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    shape: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = TruncatedNormal::new();
    op.call(ctx, shape)
}

/// Unbatch
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Unbatch>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Unbatch {
    timeout_micros: ::std::option::Option<i64>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Unbatch {
    fn default() -> Self {
        Self {
            timeout_micros: None,
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl Unbatch {
    /// Creates a new `Unbatch`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `timeout_micros` attribute.
    pub fn timeout_micros<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.timeout_micros = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute unbatch.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        batched_tensor: &T0,
        batch_index: &T1,
        id: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Unbatch")?;

        // Required input arguments
        op.add_input(&batched_tensor.to_handle(ctx)?)?;
        op.add_input(&batch_index.to_handle(ctx)?)?;
        op.add_input(&id.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.timeout_micros {
            op.set_attr_int("timeout_micros", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Unbatch::new().call(&ctx, &batched_tensor, &batch_index, &id)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Unbatch>
pub fn unbatch<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    batched_tensor: &T0,
    batch_index: &T1,
    id: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Unbatch::new();
    op.call(ctx, batched_tensor, batch_index, id)
}

/// UnbatchDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UnbatchDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct UnbatchDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for UnbatchDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl UnbatchDataset {
    /// Creates a new `UnbatchDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute unbatch_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "UnbatchDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `UnbatchDataset::new().call(&ctx, &input_dataset)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UnbatchDataset>
pub fn unbatch_dataset<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = UnbatchDataset::new();
    op.call(ctx, input_dataset)
}

/// UnbatchGrad
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UnbatchGrad>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct UnbatchGrad {
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for UnbatchGrad {
    fn default() -> Self {
        Self {
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl UnbatchGrad {
    /// Creates a new `UnbatchGrad`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute unbatch_grad.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        original_input: &T0,
        batch_index: &T1,
        grad: &T2,
        id: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "UnbatchGrad")?;

        // Required input arguments
        op.add_input(&original_input.to_handle(ctx)?)?;
        op.add_input(&batch_index.to_handle(ctx)?)?;
        op.add_input(&grad.to_handle(ctx)?)?;
        op.add_input(&id.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `UnbatchGrad::new().call(&ctx, &original_input, &batch_index, &grad, &id)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UnbatchGrad>
pub fn unbatch_grad<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    original_input: &T0,
    batch_index: &T1,
    grad: &T2,
    id: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = UnbatchGrad::new();
    op.call(ctx, original_input, batch_index, grad, id)
}

/// UncompressElement
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UncompressElement>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct UncompressElement {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for UncompressElement {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl UncompressElement {
    /// Creates a new `UncompressElement`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute uncompress_element.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        compressed: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "UncompressElement")?;

        // Required input arguments
        op.add_input(&compressed.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `UncompressElement::new().call(&ctx, &compressed)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UncompressElement>
pub fn uncompress_element<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    compressed: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = UncompressElement::new();
    op.call(ctx, compressed)
}

/// UnicodeDecode
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UnicodeDecode>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct UnicodeDecode {
    input_encoding: ::std::option::Option<::std::string::String>,
    errors: ::std::option::Option<::std::string::String>,
    replacement_char: ::std::option::Option<i64>,
    replace_control_characters: ::std::option::Option<bool>,
    Tsplits: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for UnicodeDecode {
    fn default() -> Self {
        Self {
            input_encoding: None,
            errors: Some(::std::string::String::from("replace")),
            replacement_char: Some(65533i64),
            replace_control_characters: Some(false),
            Tsplits: Some(crate::DataType::Int64),
            target_device_name: None,
        }
    }
}
impl UnicodeDecode {
    /// Creates a new `UnicodeDecode`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `input_encoding` attribute.
    pub fn input_encoding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.input_encoding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `errors` attribute.
    pub fn errors<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.errors = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `replacement_char` attribute.
    pub fn replacement_char<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.replacement_char = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `replace_control_characters` attribute.
    pub fn replace_control_characters<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.replace_control_characters = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `Tsplits` attribute.
    pub fn Tsplits<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Tsplits = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute unicode_decode.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "UnicodeDecode")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.input_encoding {
            op.set_attr_string("input_encoding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.errors {
            op.set_attr_string("errors", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.replacement_char {
            op.set_attr_int("replacement_char", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.replace_control_characters {
            op.set_attr_bool("replace_control_characters", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.Tsplits {
            op.set_attr_type("Tsplits", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `UnicodeDecode::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UnicodeDecode>
pub fn unicode_decode<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = UnicodeDecode::new();
    op.call(ctx, input)
}

/// UnicodeDecodeWithOffsets
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UnicodeDecodeWithOffsets>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct UnicodeDecodeWithOffsets {
    input_encoding: ::std::option::Option<::std::string::String>,
    errors: ::std::option::Option<::std::string::String>,
    replacement_char: ::std::option::Option<i64>,
    replace_control_characters: ::std::option::Option<bool>,
    Tsplits: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for UnicodeDecodeWithOffsets {
    fn default() -> Self {
        Self {
            input_encoding: None,
            errors: Some(::std::string::String::from("replace")),
            replacement_char: Some(65533i64),
            replace_control_characters: Some(false),
            Tsplits: Some(crate::DataType::Int64),
            target_device_name: None,
        }
    }
}
impl UnicodeDecodeWithOffsets {
    /// Creates a new `UnicodeDecodeWithOffsets`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `input_encoding` attribute.
    pub fn input_encoding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.input_encoding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `errors` attribute.
    pub fn errors<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.errors = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `replacement_char` attribute.
    pub fn replacement_char<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.replacement_char = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `replace_control_characters` attribute.
    pub fn replace_control_characters<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.replace_control_characters = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `Tsplits` attribute.
    pub fn Tsplits<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Tsplits = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute unicode_decode_with_offsets.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "UnicodeDecodeWithOffsets")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.input_encoding {
            op.set_attr_string("input_encoding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.errors {
            op.set_attr_string("errors", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.replacement_char {
            op.set_attr_int("replacement_char", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.replace_control_characters {
            op.set_attr_bool("replace_control_characters", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.Tsplits {
            op.set_attr_type("Tsplits", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `UnicodeDecodeWithOffsets::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UnicodeDecodeWithOffsets>
pub fn unicode_decode_with_offsets<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = UnicodeDecodeWithOffsets::new();
    op.call(ctx, input)
}

/// UnicodeEncode
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UnicodeEncode>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct UnicodeEncode {
    errors: ::std::option::Option<::std::string::String>,
    output_encoding: ::std::option::Option<::std::string::String>,
    replacement_char: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for UnicodeEncode {
    fn default() -> Self {
        Self {
            errors: Some(::std::string::String::from("replace")),
            output_encoding: None,
            replacement_char: Some(65533i64),
            target_device_name: None,
        }
    }
}
impl UnicodeEncode {
    /// Creates a new `UnicodeEncode`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `errors` attribute.
    pub fn errors<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.errors = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_encoding` attribute.
    pub fn output_encoding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_encoding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `replacement_char` attribute.
    pub fn replacement_char<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.replacement_char = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute unicode_encode.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_values: &T0,
        input_splits: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "UnicodeEncode")?;

        // Required input arguments
        op.add_input(&input_values.to_handle(ctx)?)?;
        op.add_input(&input_splits.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.errors {
            op.set_attr_string("errors", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_encoding {
            op.set_attr_string("output_encoding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.replacement_char {
            op.set_attr_int("replacement_char", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `UnicodeEncode::new().call(&ctx, &input_values, &input_splits)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UnicodeEncode>
pub fn unicode_encode<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_values: &T0,
    input_splits: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = UnicodeEncode::new();
    op.call(ctx, input_values, input_splits)
}

/// UnicodeScript
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UnicodeScript>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct UnicodeScript {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for UnicodeScript {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl UnicodeScript {
    /// Creates a new `UnicodeScript`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute unicode_script.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "UnicodeScript")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `UnicodeScript::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UnicodeScript>
pub fn unicode_script<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = UnicodeScript::new();
    op.call(ctx, input)
}

/// UnicodeTranscode
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UnicodeTranscode>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct UnicodeTranscode {
    input_encoding: ::std::option::Option<::std::string::String>,
    output_encoding: ::std::option::Option<::std::string::String>,
    errors: ::std::option::Option<::std::string::String>,
    replacement_char: ::std::option::Option<i64>,
    replace_control_characters: ::std::option::Option<bool>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for UnicodeTranscode {
    fn default() -> Self {
        Self {
            input_encoding: None,
            output_encoding: None,
            errors: Some(::std::string::String::from("replace")),
            replacement_char: Some(65533i64),
            replace_control_characters: Some(false),
            target_device_name: None,
        }
    }
}
impl UnicodeTranscode {
    /// Creates a new `UnicodeTranscode`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `input_encoding` attribute.
    pub fn input_encoding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.input_encoding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_encoding` attribute.
    pub fn output_encoding<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_encoding = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `errors` attribute.
    pub fn errors<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.errors = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `replacement_char` attribute.
    pub fn replacement_char<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.replacement_char = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `replace_control_characters` attribute.
    pub fn replace_control_characters<ArgType: ::std::convert::Into<bool>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.replace_control_characters = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute unicode_transcode.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "UnicodeTranscode")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.input_encoding {
            op.set_attr_string("input_encoding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_encoding {
            op.set_attr_string("output_encoding", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.errors {
            op.set_attr_string("errors", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.replacement_char {
            op.set_attr_int("replacement_char", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.replace_control_characters {
            op.set_attr_bool("replace_control_characters", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `UnicodeTranscode::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UnicodeTranscode>
pub fn unicode_transcode<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = UnicodeTranscode::new();
    op.call(ctx, input)
}

/// UniformCandidateSampler
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UniformCandidateSampler>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct UniformCandidateSampler {
    num_true: ::std::option::Option<i64>,
    num_sampled: ::std::option::Option<i64>,
    unique: ::std::option::Option<bool>,
    range_max: ::std::option::Option<i64>,
    seed: ::std::option::Option<i64>,
    seed2: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for UniformCandidateSampler {
    fn default() -> Self {
        Self {
            num_true: None,
            num_sampled: None,
            unique: None,
            range_max: None,
            seed: Some(0i64),
            seed2: Some(0i64),
            target_device_name: None,
        }
    }
}
impl UniformCandidateSampler {
    /// Creates a new `UniformCandidateSampler`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_true` attribute.
    pub fn num_true<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_true = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_sampled` attribute.
    pub fn num_sampled<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_sampled = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `unique` attribute.
    pub fn unique<ArgType: ::std::convert::Into<bool>>(mut self, value: ArgType) -> Self {
        self.unique = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `range_max` attribute.
    pub fn range_max<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.range_max = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed` attribute.
    pub fn seed<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `seed2` attribute.
    pub fn seed2<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.seed2 = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute uniform_candidate_sampler.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        true_classes: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "UniformCandidateSampler")?;

        // Required input arguments
        op.add_input(&true_classes.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_true {
            op.set_attr_int("num_true", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_sampled {
            op.set_attr_int("num_sampled", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.unique {
            op.set_attr_bool("unique", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.range_max {
            op.set_attr_int("range_max", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed {
            op.set_attr_int("seed", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.seed2 {
            op.set_attr_int("seed2", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `UniformCandidateSampler::new().call(&ctx, &true_classes)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UniformCandidateSampler>
pub fn uniform_candidate_sampler<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    true_classes: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = UniformCandidateSampler::new();
    op.call(ctx, true_classes)
}

/// UniformDequantize
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UniformDequantize>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct UniformDequantize {
    Tout: ::std::option::Option<crate::DataType>,
    quantization_axis: ::std::option::Option<i64>,
    quantization_min_val: ::std::option::Option<i64>,
    quantization_max_val: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for UniformDequantize {
    fn default() -> Self {
        Self {
            Tout: None,
            quantization_axis: Some(-1i64),
            quantization_min_val: None,
            quantization_max_val: None,
            target_device_name: None,
        }
    }
}
impl UniformDequantize {
    /// Creates a new `UniformDequantize`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Tout` attribute.
    pub fn Tout<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.Tout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `quantization_axis` attribute.
    pub fn quantization_axis<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.quantization_axis = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `quantization_min_val` attribute.
    pub fn quantization_min_val<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.quantization_min_val = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `quantization_max_val` attribute.
    pub fn quantization_max_val<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.quantization_max_val = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute uniform_dequantize.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        scales: &T1,
        zero_points: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "UniformDequantize")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&scales.to_handle(ctx)?)?;
        op.add_input(&zero_points.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Tout {
            op.set_attr_type("Tout", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.quantization_axis {
            op.set_attr_int("quantization_axis", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.quantization_min_val {
            op.set_attr_int("quantization_min_val", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.quantization_max_val {
            op.set_attr_int("quantization_max_val", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `UniformDequantize::new().call(&ctx, &input, &scales, &zero_points)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UniformDequantize>
pub fn uniform_dequantize<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    scales: &T1,
    zero_points: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = UniformDequantize::new();
    op.call(ctx, input, scales, zero_points)
}

/// UniformQuantize
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UniformQuantize>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct UniformQuantize {
    Tout: ::std::option::Option<crate::DataType>,
    quantization_axis: ::std::option::Option<i64>,
    quantization_min_val: ::std::option::Option<i64>,
    quantization_max_val: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for UniformQuantize {
    fn default() -> Self {
        Self {
            Tout: None,
            quantization_axis: Some(-1i64),
            quantization_min_val: None,
            quantization_max_val: None,
            target_device_name: None,
        }
    }
}
impl UniformQuantize {
    /// Creates a new `UniformQuantize`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Tout` attribute.
    pub fn Tout<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.Tout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `quantization_axis` attribute.
    pub fn quantization_axis<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.quantization_axis = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `quantization_min_val` attribute.
    pub fn quantization_min_val<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.quantization_min_val = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `quantization_max_val` attribute.
    pub fn quantization_max_val<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.quantization_max_val = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute uniform_quantize.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        scales: &T1,
        zero_points: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "UniformQuantize")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&scales.to_handle(ctx)?)?;
        op.add_input(&zero_points.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Tout {
            op.set_attr_type("Tout", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.quantization_axis {
            op.set_attr_int("quantization_axis", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.quantization_min_val {
            op.set_attr_int("quantization_min_val", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.quantization_max_val {
            op.set_attr_int("quantization_max_val", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `UniformQuantize::new().call(&ctx, &input, &scales, &zero_points)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UniformQuantize>
pub fn uniform_quantize<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    scales: &T1,
    zero_points: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = UniformQuantize::new();
    op.call(ctx, input, scales, zero_points)
}

/// UniformQuantizedClipByValue
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UniformQuantizedClipByValue>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct UniformQuantizedClipByValue {
    quantization_axis: ::std::option::Option<i64>,
    quantization_min_val: ::std::option::Option<i64>,
    quantization_max_val: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for UniformQuantizedClipByValue {
    fn default() -> Self {
        Self {
            quantization_axis: Some(-1i64),
            quantization_min_val: None,
            quantization_max_val: None,
            target_device_name: None,
        }
    }
}
impl UniformQuantizedClipByValue {
    /// Creates a new `UniformQuantizedClipByValue`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `quantization_axis` attribute.
    pub fn quantization_axis<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.quantization_axis = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `quantization_min_val` attribute.
    pub fn quantization_min_val<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.quantization_min_val = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `quantization_max_val` attribute.
    pub fn quantization_max_val<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.quantization_max_val = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute uniform_quantized_clip_by_value.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        operand: &T0,
        min: &T1,
        max: &T2,
        scales: &T3,
        zero_points: &T4,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "UniformQuantizedClipByValue")?;

        // Required input arguments
        op.add_input(&operand.to_handle(ctx)?)?;
        op.add_input(&min.to_handle(ctx)?)?;
        op.add_input(&max.to_handle(ctx)?)?;
        op.add_input(&scales.to_handle(ctx)?)?;
        op.add_input(&zero_points.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.quantization_axis {
            op.set_attr_int("quantization_axis", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.quantization_min_val {
            op.set_attr_int("quantization_min_val", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.quantization_max_val {
            op.set_attr_int("quantization_max_val", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `UniformQuantizedClipByValue::new().call(&ctx, &operand, &min, &max, &scales, &zero_points)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UniformQuantizedClipByValue>
pub fn uniform_quantized_clip_by_value<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    operand: &T0,
    min: &T1,
    max: &T2,
    scales: &T3,
    zero_points: &T4,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = UniformQuantizedClipByValue::new();
    op.call(ctx, operand, min, max, scales, zero_points)
}

/// UniformQuantizedDot
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UniformQuantizedDot>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct UniformQuantizedDot {
    Tout: ::std::option::Option<crate::DataType>,
    lhs_quantization_axis: ::std::option::Option<i64>,
    lhs_quantization_min_val: ::std::option::Option<i64>,
    lhs_quantization_max_val: ::std::option::Option<i64>,
    rhs_quantization_axis: ::std::option::Option<i64>,
    rhs_quantization_min_val: ::std::option::Option<i64>,
    rhs_quantization_max_val: ::std::option::Option<i64>,
    output_quantization_axis: ::std::option::Option<i64>,
    output_quantization_min_val: ::std::option::Option<i64>,
    output_quantization_max_val: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for UniformQuantizedDot {
    fn default() -> Self {
        Self {
            Tout: None,
            lhs_quantization_axis: Some(-1i64),
            lhs_quantization_min_val: None,
            lhs_quantization_max_val: None,
            rhs_quantization_axis: Some(-1i64),
            rhs_quantization_min_val: None,
            rhs_quantization_max_val: None,
            output_quantization_axis: Some(-1i64),
            output_quantization_min_val: None,
            output_quantization_max_val: None,
            target_device_name: None,
        }
    }
}
impl UniformQuantizedDot {
    /// Creates a new `UniformQuantizedDot`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Tout` attribute.
    pub fn Tout<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.Tout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `lhs_quantization_axis` attribute.
    pub fn lhs_quantization_axis<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.lhs_quantization_axis = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `lhs_quantization_min_val` attribute.
    pub fn lhs_quantization_min_val<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.lhs_quantization_min_val = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `lhs_quantization_max_val` attribute.
    pub fn lhs_quantization_max_val<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.lhs_quantization_max_val = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `rhs_quantization_axis` attribute.
    pub fn rhs_quantization_axis<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.rhs_quantization_axis = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `rhs_quantization_min_val` attribute.
    pub fn rhs_quantization_min_val<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.rhs_quantization_min_val = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `rhs_quantization_max_val` attribute.
    pub fn rhs_quantization_max_val<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.rhs_quantization_max_val = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_quantization_axis` attribute.
    pub fn output_quantization_axis<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_quantization_axis = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_quantization_min_val` attribute.
    pub fn output_quantization_min_val<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_quantization_min_val = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_quantization_max_val` attribute.
    pub fn output_quantization_max_val<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_quantization_max_val = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute uniform_quantized_dot.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
        T5: crate::eager::ToTensorHandle<'a>,
        T6: crate::eager::ToTensorHandle<'a>,
        T7: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        lhs: &T0,
        rhs: &T1,
        lhs_scales: &T2,
        lhs_zero_points: &T3,
        rhs_scales: &T4,
        rhs_zero_points: &T5,
        output_scales: &T6,
        output_zero_points: &T7,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "UniformQuantizedDot")?;

        // Required input arguments
        op.add_input(&lhs.to_handle(ctx)?)?;
        op.add_input(&rhs.to_handle(ctx)?)?;
        op.add_input(&lhs_scales.to_handle(ctx)?)?;
        op.add_input(&lhs_zero_points.to_handle(ctx)?)?;
        op.add_input(&rhs_scales.to_handle(ctx)?)?;
        op.add_input(&rhs_zero_points.to_handle(ctx)?)?;
        op.add_input(&output_scales.to_handle(ctx)?)?;
        op.add_input(&output_zero_points.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Tout {
            op.set_attr_type("Tout", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.lhs_quantization_axis {
            op.set_attr_int("lhs_quantization_axis", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.lhs_quantization_min_val {
            op.set_attr_int("lhs_quantization_min_val", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.lhs_quantization_max_val {
            op.set_attr_int("lhs_quantization_max_val", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.rhs_quantization_axis {
            op.set_attr_int("rhs_quantization_axis", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.rhs_quantization_min_val {
            op.set_attr_int("rhs_quantization_min_val", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.rhs_quantization_max_val {
            op.set_attr_int("rhs_quantization_max_val", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_quantization_axis {
            op.set_attr_int("output_quantization_axis", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_quantization_min_val {
            op.set_attr_int("output_quantization_min_val", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_quantization_max_val {
            op.set_attr_int("output_quantization_max_val", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `UniformQuantizedDot::new().call(&ctx, &lhs, &rhs, &lhs_scales, &lhs_zero_points, &rhs_scales, &rhs_zero_points, &output_scales, &output_zero_points)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UniformQuantizedDot>
pub fn uniform_quantized_dot<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
    T5: crate::eager::ToTensorHandle<'a>,
    T6: crate::eager::ToTensorHandle<'a>,
    T7: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    lhs: &T0,
    rhs: &T1,
    lhs_scales: &T2,
    lhs_zero_points: &T3,
    rhs_scales: &T4,
    rhs_zero_points: &T5,
    output_scales: &T6,
    output_zero_points: &T7,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = UniformQuantizedDot::new();
    op.call(
        ctx,
        lhs,
        rhs,
        lhs_scales,
        lhs_zero_points,
        rhs_scales,
        rhs_zero_points,
        output_scales,
        output_zero_points,
    )
}

/// UniformQuantizedDotHybrid
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UniformQuantizedDotHybrid>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct UniformQuantizedDotHybrid {
    Tout: ::std::option::Option<crate::DataType>,
    rhs_quantization_axis: ::std::option::Option<i64>,
    rhs_quantization_min_val: ::std::option::Option<i64>,
    rhs_quantization_max_val: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for UniformQuantizedDotHybrid {
    fn default() -> Self {
        Self {
            Tout: None,
            rhs_quantization_axis: Some(-1i64),
            rhs_quantization_min_val: None,
            rhs_quantization_max_val: None,
            target_device_name: None,
        }
    }
}
impl UniformQuantizedDotHybrid {
    /// Creates a new `UniformQuantizedDotHybrid`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Tout` attribute.
    pub fn Tout<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.Tout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `rhs_quantization_axis` attribute.
    pub fn rhs_quantization_axis<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.rhs_quantization_axis = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `rhs_quantization_min_val` attribute.
    pub fn rhs_quantization_min_val<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.rhs_quantization_min_val = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `rhs_quantization_max_val` attribute.
    pub fn rhs_quantization_max_val<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.rhs_quantization_max_val = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute uniform_quantized_dot_hybrid.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        lhs: &T0,
        rhs: &T1,
        rhs_scales: &T2,
        rhs_zero_points: &T3,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "UniformQuantizedDotHybrid")?;

        // Required input arguments
        op.add_input(&lhs.to_handle(ctx)?)?;
        op.add_input(&rhs.to_handle(ctx)?)?;
        op.add_input(&rhs_scales.to_handle(ctx)?)?;
        op.add_input(&rhs_zero_points.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Tout {
            op.set_attr_type("Tout", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.rhs_quantization_axis {
            op.set_attr_int("rhs_quantization_axis", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.rhs_quantization_min_val {
            op.set_attr_int("rhs_quantization_min_val", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.rhs_quantization_max_val {
            op.set_attr_int("rhs_quantization_max_val", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `UniformQuantizedDotHybrid::new().call(&ctx, &lhs, &rhs, &rhs_scales, &rhs_zero_points)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UniformQuantizedDotHybrid>
pub fn uniform_quantized_dot_hybrid<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    lhs: &T0,
    rhs: &T1,
    rhs_scales: &T2,
    rhs_zero_points: &T3,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = UniformQuantizedDotHybrid::new();
    op.call(ctx, lhs, rhs, rhs_scales, rhs_zero_points)
}

/// UniformRequantize
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UniformRequantize>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct UniformRequantize {
    Tout: ::std::option::Option<crate::DataType>,
    input_quantization_axis: ::std::option::Option<i64>,
    input_quantization_min_val: ::std::option::Option<i64>,
    input_quantization_max_val: ::std::option::Option<i64>,
    output_quantization_axis: ::std::option::Option<i64>,
    output_quantization_min_val: ::std::option::Option<i64>,
    output_quantization_max_val: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for UniformRequantize {
    fn default() -> Self {
        Self {
            Tout: None,
            input_quantization_axis: Some(-1i64),
            input_quantization_min_val: None,
            input_quantization_max_val: None,
            output_quantization_axis: Some(-1i64),
            output_quantization_min_val: None,
            output_quantization_max_val: None,
            target_device_name: None,
        }
    }
}
impl UniformRequantize {
    /// Creates a new `UniformRequantize`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Tout` attribute.
    pub fn Tout<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.Tout = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `input_quantization_axis` attribute.
    pub fn input_quantization_axis<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.input_quantization_axis = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `input_quantization_min_val` attribute.
    pub fn input_quantization_min_val<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.input_quantization_min_val = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `input_quantization_max_val` attribute.
    pub fn input_quantization_max_val<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.input_quantization_max_val = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_quantization_axis` attribute.
    pub fn output_quantization_axis<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_quantization_axis = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_quantization_min_val` attribute.
    pub fn output_quantization_min_val<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_quantization_min_val = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_quantization_max_val` attribute.
    pub fn output_quantization_max_val<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_quantization_max_val = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute uniform_requantize.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
        input_scales: &T1,
        input_zero_points: &T2,
        output_scales: &T3,
        output_zero_points: &T4,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "UniformRequantize")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;
        op.add_input(&input_scales.to_handle(ctx)?)?;
        op.add_input(&input_zero_points.to_handle(ctx)?)?;
        op.add_input(&output_scales.to_handle(ctx)?)?;
        op.add_input(&output_zero_points.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Tout {
            op.set_attr_type("Tout", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.input_quantization_axis {
            op.set_attr_int("input_quantization_axis", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.input_quantization_min_val {
            op.set_attr_int("input_quantization_min_val", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.input_quantization_max_val {
            op.set_attr_int("input_quantization_max_val", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_quantization_axis {
            op.set_attr_int("output_quantization_axis", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_quantization_min_val {
            op.set_attr_int("output_quantization_min_val", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_quantization_max_val {
            op.set_attr_int("output_quantization_max_val", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `UniformRequantize::new().call(&ctx, &input, &input_scales, &input_zero_points, &output_scales, &output_zero_points)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UniformRequantize>
pub fn uniform_requantize<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input: &T0,
    input_scales: &T1,
    input_zero_points: &T2,
    output_scales: &T3,
    output_zero_points: &T4,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = UniformRequantize::new();
    op.call(
        ctx,
        input,
        input_scales,
        input_zero_points,
        output_scales,
        output_zero_points,
    )
}

/// Unique
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Unique>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Unique {
    out_idx: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Unique {
    fn default() -> Self {
        Self {
            out_idx: Some(crate::DataType::Int32),
            target_device_name: None,
        }
    }
}
impl Unique {
    /// Creates a new `Unique`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_idx` attribute.
    pub fn out_idx<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_idx = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute unique.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "Unique")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_idx {
            op.set_attr_type("out_idx", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `Unique::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Unique>
pub fn unique<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = Unique::new();
    op.call(ctx, x)
}

/// UniqueDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UniqueDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct UniqueDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for UniqueDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl UniqueDataset {
    /// Creates a new `UniqueDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute unique_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "UniqueDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `UniqueDataset::new().call(&ctx, &input_dataset)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UniqueDataset>
pub fn unique_dataset<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = UniqueDataset::new();
    op.call(ctx, input_dataset)
}

/// UniqueV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UniqueV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct UniqueV2 {
    out_idx: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for UniqueV2 {
    fn default() -> Self {
        Self {
            out_idx: Some(crate::DataType::Int32),
            target_device_name: None,
        }
    }
}
impl UniqueV2 {
    /// Creates a new `UniqueV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_idx` attribute.
    pub fn out_idx<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_idx = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute unique_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        axis: &T1,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
        // Define Op
        let mut op = super::Op::new(ctx, "UniqueV2")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&axis.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_idx {
            op.set_attr_type("out_idx", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<2>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `UniqueV2::new().call(&ctx, &x, &axis)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UniqueV2>
pub fn unique_v2<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    axis: &T1,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 2]> {
    let op = UniqueV2::new();
    op.call(ctx, x, axis)
}

/// UniqueWithCounts
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UniqueWithCounts>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct UniqueWithCounts {
    out_idx: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for UniqueWithCounts {
    fn default() -> Self {
        Self {
            out_idx: Some(crate::DataType::Int32),
            target_device_name: None,
        }
    }
}
impl UniqueWithCounts {
    /// Creates a new `UniqueWithCounts`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_idx` attribute.
    pub fn out_idx<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_idx = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute unique_with_counts.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "UniqueWithCounts")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_idx {
            op.set_attr_type("out_idx", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `UniqueWithCounts::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UniqueWithCounts>
pub fn unique_with_counts<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = UniqueWithCounts::new();
    op.call(ctx, x)
}

/// UniqueWithCountsV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UniqueWithCountsV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct UniqueWithCountsV2 {
    out_idx: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for UniqueWithCountsV2 {
    fn default() -> Self {
        Self {
            out_idx: Some(crate::DataType::Int32),
            target_device_name: None,
        }
    }
}
impl UniqueWithCountsV2 {
    /// Creates a new `UniqueWithCountsV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_idx` attribute.
    pub fn out_idx<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_idx = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute unique_with_counts_v2.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        axis: &T1,
    ) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
        // Define Op
        let mut op = super::Op::new(ctx, "UniqueWithCountsV2")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&axis.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_idx {
            op.set_attr_type("out_idx", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let handles = op.execute::<3>(ctx)?;
        Ok(handles)
    }
}

/// Shorthand for `UniqueWithCountsV2::new().call(&ctx, &x, &axis)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UniqueWithCountsV2>
pub fn unique_with_counts_v2<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    axis: &T1,
) -> crate::Result<[crate::eager::TensorHandle<'a>; 3]> {
    let op = UniqueWithCountsV2::new();
    op.call(ctx, x, axis)
}

/// Unpack
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Unpack>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Unpack {
    num: ::std::option::Option<i64>,
    axis: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Unpack {
    fn default() -> Self {
        Self {
            num: None,
            axis: Some(0i64),
            target_device_name: None,
        }
    }
}
impl Unpack {
    /// Creates a new `Unpack`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num` attribute.
    pub fn num<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `axis` attribute.
    pub fn axis<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.axis = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute unpack.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        value: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Unpack")?;

        // Required input arguments
        op.add_input(&value.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num {
            op.set_attr_int("num", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.axis {
            op.set_attr_int("axis", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Unpack::new().call(&ctx, &value)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Unpack>
pub fn unpack<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    value: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Unpack::new();
    op.call(ctx, value)
}

/// UnravelIndex
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UnravelIndex>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct UnravelIndex {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for UnravelIndex {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl UnravelIndex {
    /// Creates a new `UnravelIndex`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute unravel_index.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        indices: &T0,
        dims: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "UnravelIndex")?;

        // Required input arguments
        op.add_input(&indices.to_handle(ctx)?)?;
        op.add_input(&dims.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `UnravelIndex::new().call(&ctx, &indices, &dims)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UnravelIndex>
pub fn unravel_index<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    indices: &T0,
    dims: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = UnravelIndex::new();
    op.call(ctx, indices, dims)
}

/// UnsortedSegmentJoin
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UnsortedSegmentJoin>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct UnsortedSegmentJoin {
    separator: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for UnsortedSegmentJoin {
    fn default() -> Self {
        Self {
            separator: None,
            target_device_name: None,
        }
    }
}
impl UnsortedSegmentJoin {
    /// Creates a new `UnsortedSegmentJoin`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `separator` attribute.
    pub fn separator<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.separator = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute unsorted_segment_join.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        inputs: &T0,
        segment_ids: &T1,
        num_segments: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "UnsortedSegmentJoin")?;

        // Required input arguments
        op.add_input(&inputs.to_handle(ctx)?)?;
        op.add_input(&segment_ids.to_handle(ctx)?)?;
        op.add_input(&num_segments.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.separator {
            op.set_attr_string("separator", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `UnsortedSegmentJoin::new().call(&ctx, &inputs, &segment_ids, &num_segments)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UnsortedSegmentJoin>
pub fn unsorted_segment_join<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    inputs: &T0,
    segment_ids: &T1,
    num_segments: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = UnsortedSegmentJoin::new();
    op.call(ctx, inputs, segment_ids, num_segments)
}

/// UnsortedSegmentMax
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UnsortedSegmentMax>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct UnsortedSegmentMax {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for UnsortedSegmentMax {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl UnsortedSegmentMax {
    /// Creates a new `UnsortedSegmentMax`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute unsorted_segment_max.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        data: &T0,
        segment_ids: &T1,
        num_segments: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "UnsortedSegmentMax")?;

        // Required input arguments
        op.add_input(&data.to_handle(ctx)?)?;
        op.add_input(&segment_ids.to_handle(ctx)?)?;
        op.add_input(&num_segments.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `UnsortedSegmentMax::new().call(&ctx, &data, &segment_ids, &num_segments)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UnsortedSegmentMax>
pub fn unsorted_segment_max<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    data: &T0,
    segment_ids: &T1,
    num_segments: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = UnsortedSegmentMax::new();
    op.call(ctx, data, segment_ids, num_segments)
}

/// UnsortedSegmentMin
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UnsortedSegmentMin>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct UnsortedSegmentMin {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for UnsortedSegmentMin {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl UnsortedSegmentMin {
    /// Creates a new `UnsortedSegmentMin`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute unsorted_segment_min.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        data: &T0,
        segment_ids: &T1,
        num_segments: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "UnsortedSegmentMin")?;

        // Required input arguments
        op.add_input(&data.to_handle(ctx)?)?;
        op.add_input(&segment_ids.to_handle(ctx)?)?;
        op.add_input(&num_segments.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `UnsortedSegmentMin::new().call(&ctx, &data, &segment_ids, &num_segments)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UnsortedSegmentMin>
pub fn unsorted_segment_min<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    data: &T0,
    segment_ids: &T1,
    num_segments: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = UnsortedSegmentMin::new();
    op.call(ctx, data, segment_ids, num_segments)
}

/// UnsortedSegmentProd
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UnsortedSegmentProd>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct UnsortedSegmentProd {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for UnsortedSegmentProd {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl UnsortedSegmentProd {
    /// Creates a new `UnsortedSegmentProd`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute unsorted_segment_prod.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        data: &T0,
        segment_ids: &T1,
        num_segments: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "UnsortedSegmentProd")?;

        // Required input arguments
        op.add_input(&data.to_handle(ctx)?)?;
        op.add_input(&segment_ids.to_handle(ctx)?)?;
        op.add_input(&num_segments.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `UnsortedSegmentProd::new().call(&ctx, &data, &segment_ids, &num_segments)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UnsortedSegmentProd>
pub fn unsorted_segment_prod<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    data: &T0,
    segment_ids: &T1,
    num_segments: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = UnsortedSegmentProd::new();
    op.call(ctx, data, segment_ids, num_segments)
}

/// UnsortedSegmentSum
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UnsortedSegmentSum>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct UnsortedSegmentSum {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for UnsortedSegmentSum {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl UnsortedSegmentSum {
    /// Creates a new `UnsortedSegmentSum`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute unsorted_segment_sum.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        data: &T0,
        segment_ids: &T1,
        num_segments: &T2,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "UnsortedSegmentSum")?;

        // Required input arguments
        op.add_input(&data.to_handle(ctx)?)?;
        op.add_input(&segment_ids.to_handle(ctx)?)?;
        op.add_input(&num_segments.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `UnsortedSegmentSum::new().call(&ctx, &data, &segment_ids, &num_segments)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UnsortedSegmentSum>
pub fn unsorted_segment_sum<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    data: &T0,
    segment_ids: &T1,
    num_segments: &T2,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = UnsortedSegmentSum::new();
    op.call(ctx, data, segment_ids, num_segments)
}

/// Unstage
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Unstage>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Unstage {
    capacity: ::std::option::Option<i64>,
    memory_limit: ::std::option::Option<i64>,
    dtypes: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Unstage {
    fn default() -> Self {
        Self {
            capacity: Some(0i64),
            memory_limit: Some(0i64),
            dtypes: None,
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl Unstage {
    /// Creates a new `Unstage`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `capacity` attribute.
    pub fn capacity<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.capacity = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `memory_limit` attribute.
    pub fn memory_limit<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.memory_limit = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dtypes` attribute.
    pub fn dtypes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.dtypes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute unstage.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Unstage")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.capacity {
            op.set_attr_int("capacity", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.memory_limit {
            op.set_attr_int("memory_limit", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dtypes {
            op.set_attr_type_list("dtypes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Unstage::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Unstage>
pub fn unstage<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Unstage::new();
    op.call(ctx)
}

/// UnwrapDatasetVariant
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UnwrapDatasetVariant>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct UnwrapDatasetVariant {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for UnwrapDatasetVariant {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl UnwrapDatasetVariant {
    /// Creates a new `UnwrapDatasetVariant`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute unwrap_dataset_variant.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_handle: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "UnwrapDatasetVariant")?;

        // Required input arguments
        op.add_input(&input_handle.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `UnwrapDatasetVariant::new().call(&ctx, &input_handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UnwrapDatasetVariant>
pub fn unwrap_dataset_variant<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input_handle: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = UnwrapDatasetVariant::new();
    op.call(ctx, input_handle)
}

/// UpperBound
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UpperBound>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct UpperBound {
    out_type: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for UpperBound {
    fn default() -> Self {
        Self {
            out_type: Some(crate::DataType::Int32),
            target_device_name: None,
        }
    }
}
impl UpperBound {
    /// Creates a new `UpperBound`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_type` attribute.
    pub fn out_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute upper_bound.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        sorted_inputs: &T0,
        values: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "UpperBound")?;

        // Required input arguments
        op.add_input(&sorted_inputs.to_handle(ctx)?)?;
        op.add_input(&values.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_type {
            op.set_attr_type("out_type", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `UpperBound::new().call(&ctx, &sorted_inputs, &values)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/UpperBound>
pub fn upper_bound<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    sorted_inputs: &T0,
    values: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = UpperBound::new();
    op.call(ctx, sorted_inputs, values)
}

/// VarHandleOp
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/VarHandleOp>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct VarHandleOp {
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    dtype: ::std::option::Option<crate::DataType>,
    shape: ::std::option::Option<crate::Shape>,
    allowed_devices: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for VarHandleOp {
    fn default() -> Self {
        Self {
            container: None,
            shared_name: None,
            dtype: None,
            shape: None,
            allowed_devices: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl VarHandleOp {
    /// Creates a new `VarHandleOp`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shape` attribute.
    pub fn shape<ArgType: ::std::convert::Into<crate::Shape>>(mut self, value: ArgType) -> Self {
        self.shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `allowed_devices` attribute.
    pub fn allowed_devices<
        ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>,
    >(
        mut self,
        value: ArgType,
    ) -> Self {
        self.allowed_devices = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute var_handle_op.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "VarHandleOp")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shape {
            op.set_attr_shape("shape", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.allowed_devices {
            op.set_attr_string_list("allowed_devices", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `VarHandleOp::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/VarHandleOp>
pub fn var_handle_op<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = VarHandleOp::new();
    op.call(ctx)
}

/// VarIsInitializedOp
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/VarIsInitializedOp>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct VarIsInitializedOp {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for VarIsInitializedOp {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl VarIsInitializedOp {
    /// Creates a new `VarIsInitializedOp`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute var_is_initialized_op.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        resource: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "VarIsInitializedOp")?;

        // Required input arguments
        op.add_input(&resource.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `VarIsInitializedOp::new().call(&ctx, &resource)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/VarIsInitializedOp>
pub fn var_is_initialized_op<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    resource: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = VarIsInitializedOp::new();
    op.call(ctx, resource)
}

/// Variable
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Variable>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Variable {
    shape: ::std::option::Option<crate::Shape>,
    dtype: ::std::option::Option<crate::DataType>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Variable {
    fn default() -> Self {
        Self {
            shape: None,
            dtype: None,
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl Variable {
    /// Creates a new `Variable`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `shape` attribute.
    pub fn shape<ArgType: ::std::convert::Into<crate::Shape>>(mut self, value: ArgType) -> Self {
        self.shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute variable.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Variable")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.shape {
            op.set_attr_shape("shape", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Variable::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Variable>
pub fn variable<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Variable::new();
    op.call(ctx)
}

/// VariableShape
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/VariableShape>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct VariableShape {
    out_type: ::std::option::Option<crate::DataType>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for VariableShape {
    fn default() -> Self {
        Self {
            out_type: Some(crate::DataType::Int32),
            target_device_name: None,
        }
    }
}
impl VariableShape {
    /// Creates a new `VariableShape`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `out_type` attribute.
    pub fn out_type<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.out_type = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute variable_shape.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "VariableShape")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.out_type {
            op.set_attr_type("out_type", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `VariableShape::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/VariableShape>
pub fn variable_shape<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = VariableShape::new();
    op.call(ctx, input)
}

/// VariableV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/VariableV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct VariableV2 {
    shape: ::std::option::Option<crate::Shape>,
    dtype: ::std::option::Option<crate::DataType>,
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for VariableV2 {
    fn default() -> Self {
        Self {
            shape: None,
            dtype: None,
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl VariableV2 {
    /// Creates a new `VariableV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `shape` attribute.
    pub fn shape<ArgType: ::std::convert::Into<crate::Shape>>(mut self, value: ArgType) -> Self {
        self.shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `dtype` attribute.
    pub fn dtype<ArgType: ::std::convert::Into<crate::DataType>>(mut self, value: ArgType) -> Self {
        self.dtype = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute variable_v2.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "VariableV2")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.shape {
            op.set_attr_shape("shape", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.dtype {
            op.set_attr_type("dtype", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `VariableV2::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/VariableV2>
pub fn variable_v2<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = VariableV2::new();
    op.call(ctx)
}

/// Where
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Where>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Where {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Where {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Where {
    /// Creates a new `Where`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute where_.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Where")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Where::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Where>
pub fn where_<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Where::new();
    op.call(ctx, input)
}

/// While
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/While>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct While {
    cond: ::std::option::Option<::std::string::String>,
    body: ::std::option::Option<::std::string::String>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    parallel_iterations: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for While {
    fn default() -> Self {
        Self {
            cond: None,
            body: None,
            output_shapes: Some(vec![]),
            parallel_iterations: Some(10i64),
            target_device_name: None,
        }
    }
}
impl While {
    /// Creates a new `While`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `cond` attribute.
    pub fn cond<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.cond = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `body` attribute.
    pub fn body<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.body = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `parallel_iterations` attribute.
    pub fn parallel_iterations<ArgType: ::std::convert::Into<i64>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.parallel_iterations = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute while_.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "While")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.cond {
            op.set_attr_string("cond", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.body {
            op.set_attr_string("body", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.parallel_iterations {
            op.set_attr_int("parallel_iterations", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `While::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/While>
pub fn while_<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = While::new();
    op.call(ctx, input)
}

/// WholeFileReader
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/WholeFileReader>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct WholeFileReader {
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for WholeFileReader {
    fn default() -> Self {
        Self {
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl WholeFileReader {
    /// Creates a new `WholeFileReader`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute whole_file_reader.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "WholeFileReader")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `WholeFileReader::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/WholeFileReader>
pub fn whole_file_reader<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = WholeFileReader::new();
    op.call(ctx)
}

/// WholeFileReaderV2
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/WholeFileReaderV2>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct WholeFileReaderV2 {
    container: ::std::option::Option<::std::string::String>,
    shared_name: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for WholeFileReaderV2 {
    fn default() -> Self {
        Self {
            container: None,
            shared_name: None,
            target_device_name: None,
        }
    }
}
impl WholeFileReaderV2 {
    /// Creates a new `WholeFileReaderV2`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `container` attribute.
    pub fn container<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.container = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shared_name` attribute.
    pub fn shared_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shared_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute whole_file_reader_v2.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "WholeFileReaderV2")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.container {
            op.set_attr_string("container", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shared_name {
            op.set_attr_string("shared_name", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `WholeFileReaderV2::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/WholeFileReaderV2>
pub fn whole_file_reader_v2<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = WholeFileReaderV2::new();
    op.call(ctx)
}

/// WindowDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/WindowDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct WindowDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for WindowDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl WindowDataset {
    /// Creates a new `WindowDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute window_dataset.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        input_dataset: &T0,
        size: &T1,
        shift: &T2,
        stride: &T3,
        drop_remainder: &T4,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "WindowDataset")?;

        // Required input arguments
        op.add_input(&input_dataset.to_handle(ctx)?)?;
        op.add_input(&size.to_handle(ctx)?)?;
        op.add_input(&shift.to_handle(ctx)?)?;
        op.add_input(&stride.to_handle(ctx)?)?;
        op.add_input(&drop_remainder.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `WindowDataset::new().call(&ctx, &input_dataset, &size, &shift, &stride, &drop_remainder)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/WindowDataset>
pub fn window_dataset<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    input_dataset: &T0,
    size: &T1,
    shift: &T2,
    stride: &T3,
    drop_remainder: &T4,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = WindowDataset::new();
    op.call(ctx, input_dataset, size, shift, stride, drop_remainder)
}

/// WindowOp
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/WindowOp>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct WindowOp {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for WindowOp {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            target_device_name: None,
        }
    }
}
impl WindowOp {
    /// Creates a new `WindowOp`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute window_op.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        inputs: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "WindowOp")?;

        // Required input arguments
        op.add_input(&inputs.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `WindowOp::new().call(&ctx, &inputs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/WindowOp>
pub fn window_op<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    inputs: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = WindowOp::new();
    op.call(ctx, inputs)
}

/// WorkerHeartbeat
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/WorkerHeartbeat>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct WorkerHeartbeat {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for WorkerHeartbeat {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl WorkerHeartbeat {
    /// Creates a new `WorkerHeartbeat`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute worker_heartbeat.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        request: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "WorkerHeartbeat")?;

        // Required input arguments
        op.add_input(&request.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `WorkerHeartbeat::new().call(&ctx, &request)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/WorkerHeartbeat>
pub fn worker_heartbeat<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    request: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = WorkerHeartbeat::new();
    op.call(ctx, request)
}

/// WrapDatasetVariant
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/WrapDatasetVariant>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct WrapDatasetVariant {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for WrapDatasetVariant {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl WrapDatasetVariant {
    /// Creates a new `WrapDatasetVariant`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute wrap_dataset_variant.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_handle: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "WrapDatasetVariant")?;

        // Required input arguments
        op.add_input(&input_handle.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `WrapDatasetVariant::new().call(&ctx, &input_handle)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/WrapDatasetVariant>
pub fn wrap_dataset_variant<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input_handle: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = WrapDatasetVariant::new();
    op.call(ctx, input_handle)
}

/// WriteAudioSummary
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/WriteAudioSummary>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct WriteAudioSummary {
    max_outputs: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for WriteAudioSummary {
    fn default() -> Self {
        Self {
            max_outputs: Some(3i64),
            target_device_name: None,
        }
    }
}
impl WriteAudioSummary {
    /// Creates a new `WriteAudioSummary`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `max_outputs` attribute.
    pub fn max_outputs<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.max_outputs = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute write_audio_summary.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        writer: &T0,
        step: &T1,
        tag: &T2,
        tensor: &T3,
        sample_rate: &T4,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "WriteAudioSummary")?;

        // Required input arguments
        op.add_input(&writer.to_handle(ctx)?)?;
        op.add_input(&step.to_handle(ctx)?)?;
        op.add_input(&tag.to_handle(ctx)?)?;
        op.add_input(&tensor.to_handle(ctx)?)?;
        op.add_input(&sample_rate.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.max_outputs {
            op.set_attr_int("max_outputs", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `WriteAudioSummary::new().call(&ctx, &writer, &step, &tag, &tensor, &sample_rate)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/WriteAudioSummary>
pub fn write_audio_summary<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    writer: &T0,
    step: &T1,
    tag: &T2,
    tensor: &T3,
    sample_rate: &T4,
) -> crate::Result<()> {
    let op = WriteAudioSummary::new();
    op.call(ctx, writer, step, tag, tensor, sample_rate)
}

/// WriteFile
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/WriteFile>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct WriteFile {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for WriteFile {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl WriteFile {
    /// Creates a new `WriteFile`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute write_file.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        filename: &T0,
        contents: &T1,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "WriteFile")?;

        // Required input arguments
        op.add_input(&filename.to_handle(ctx)?)?;
        op.add_input(&contents.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `WriteFile::new().call(&ctx, &filename, &contents)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/WriteFile>
pub fn write_file<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    filename: &T0,
    contents: &T1,
) -> crate::Result<()> {
    let op = WriteFile::new();
    op.call(ctx, filename, contents)
}

/// WriteGraphSummary
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/WriteGraphSummary>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct WriteGraphSummary {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for WriteGraphSummary {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl WriteGraphSummary {
    /// Creates a new `WriteGraphSummary`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute write_graph_summary.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        writer: &T0,
        step: &T1,
        tensor: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "WriteGraphSummary")?;

        // Required input arguments
        op.add_input(&writer.to_handle(ctx)?)?;
        op.add_input(&step.to_handle(ctx)?)?;
        op.add_input(&tensor.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `WriteGraphSummary::new().call(&ctx, &writer, &step, &tensor)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/WriteGraphSummary>
pub fn write_graph_summary<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    writer: &T0,
    step: &T1,
    tensor: &T2,
) -> crate::Result<()> {
    let op = WriteGraphSummary::new();
    op.call(ctx, writer, step, tensor)
}

/// WriteHistogramSummary
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/WriteHistogramSummary>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct WriteHistogramSummary {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for WriteHistogramSummary {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl WriteHistogramSummary {
    /// Creates a new `WriteHistogramSummary`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute write_histogram_summary.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        writer: &T0,
        step: &T1,
        tag: &T2,
        values: &T3,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "WriteHistogramSummary")?;

        // Required input arguments
        op.add_input(&writer.to_handle(ctx)?)?;
        op.add_input(&step.to_handle(ctx)?)?;
        op.add_input(&tag.to_handle(ctx)?)?;
        op.add_input(&values.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `WriteHistogramSummary::new().call(&ctx, &writer, &step, &tag, &values)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/WriteHistogramSummary>
pub fn write_histogram_summary<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    writer: &T0,
    step: &T1,
    tag: &T2,
    values: &T3,
) -> crate::Result<()> {
    let op = WriteHistogramSummary::new();
    op.call(ctx, writer, step, tag, values)
}

/// WriteImageSummary
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/WriteImageSummary>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct WriteImageSummary {
    max_images: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for WriteImageSummary {
    fn default() -> Self {
        Self {
            max_images: Some(3i64),
            target_device_name: None,
        }
    }
}
impl WriteImageSummary {
    /// Creates a new `WriteImageSummary`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `max_images` attribute.
    pub fn max_images<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.max_images = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute write_image_summary.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        writer: &T0,
        step: &T1,
        tag: &T2,
        tensor: &T3,
        bad_color: &T4,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "WriteImageSummary")?;

        // Required input arguments
        op.add_input(&writer.to_handle(ctx)?)?;
        op.add_input(&step.to_handle(ctx)?)?;
        op.add_input(&tag.to_handle(ctx)?)?;
        op.add_input(&tensor.to_handle(ctx)?)?;
        op.add_input(&bad_color.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.max_images {
            op.set_attr_int("max_images", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `WriteImageSummary::new().call(&ctx, &writer, &step, &tag, &tensor, &bad_color)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/WriteImageSummary>
pub fn write_image_summary<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    writer: &T0,
    step: &T1,
    tag: &T2,
    tensor: &T3,
    bad_color: &T4,
) -> crate::Result<()> {
    let op = WriteImageSummary::new();
    op.call(ctx, writer, step, tag, tensor, bad_color)
}

/// WriteRawProtoSummary
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/WriteRawProtoSummary>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct WriteRawProtoSummary {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for WriteRawProtoSummary {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl WriteRawProtoSummary {
    /// Creates a new `WriteRawProtoSummary`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute write_raw_proto_summary.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        writer: &T0,
        step: &T1,
        tensor: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "WriteRawProtoSummary")?;

        // Required input arguments
        op.add_input(&writer.to_handle(ctx)?)?;
        op.add_input(&step.to_handle(ctx)?)?;
        op.add_input(&tensor.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `WriteRawProtoSummary::new().call(&ctx, &writer, &step, &tensor)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/WriteRawProtoSummary>
pub fn write_raw_proto_summary<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    writer: &T0,
    step: &T1,
    tensor: &T2,
) -> crate::Result<()> {
    let op = WriteRawProtoSummary::new();
    op.call(ctx, writer, step, tensor)
}

/// WriteScalarSummary
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/WriteScalarSummary>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct WriteScalarSummary {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for WriteScalarSummary {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl WriteScalarSummary {
    /// Creates a new `WriteScalarSummary`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute write_scalar_summary.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        writer: &T0,
        step: &T1,
        tag: &T2,
        value: &T3,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "WriteScalarSummary")?;

        // Required input arguments
        op.add_input(&writer.to_handle(ctx)?)?;
        op.add_input(&step.to_handle(ctx)?)?;
        op.add_input(&tag.to_handle(ctx)?)?;
        op.add_input(&value.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `WriteScalarSummary::new().call(&ctx, &writer, &step, &tag, &value)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/WriteScalarSummary>
pub fn write_scalar_summary<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    writer: &T0,
    step: &T1,
    tag: &T2,
    value: &T3,
) -> crate::Result<()> {
    let op = WriteScalarSummary::new();
    op.call(ctx, writer, step, tag, value)
}

/// WriteSummary
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/WriteSummary>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct WriteSummary {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for WriteSummary {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl WriteSummary {
    /// Creates a new `WriteSummary`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute write_summary.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
        T3: crate::eager::ToTensorHandle<'a>,
        T4: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        writer: &T0,
        step: &T1,
        tensor: &T2,
        tag: &T3,
        summary_metadata: &T4,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "WriteSummary")?;

        // Required input arguments
        op.add_input(&writer.to_handle(ctx)?)?;
        op.add_input(&step.to_handle(ctx)?)?;
        op.add_input(&tensor.to_handle(ctx)?)?;
        op.add_input(&tag.to_handle(ctx)?)?;
        op.add_input(&summary_metadata.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `WriteSummary::new().call(&ctx, &writer, &step, &tensor, &tag, &summary_metadata)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/WriteSummary>
pub fn write_summary<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
    T3: crate::eager::ToTensorHandle<'a>,
    T4: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    writer: &T0,
    step: &T1,
    tensor: &T2,
    tag: &T3,
    summary_metadata: &T4,
) -> crate::Result<()> {
    let op = WriteSummary::new();
    op.call(ctx, writer, step, tensor, tag, summary_metadata)
}

/// Xdivy
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Xdivy>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Xdivy {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Xdivy {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Xdivy {
    /// Creates a new `Xdivy`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute xdivy.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Xdivy")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Xdivy::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Xdivy>
pub fn xdivy<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Xdivy::new();
    op.call(ctx, x, y)
}

/// XlaConcatND
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/XlaConcatND>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct XlaConcatND {
    num_concats: ::std::option::Option<::std::vec::Vec<i64>>,
    paddings: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for XlaConcatND {
    fn default() -> Self {
        Self {
            num_concats: None,
            paddings: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl XlaConcatND {
    /// Creates a new `XlaConcatND`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_concats` attribute.
    pub fn num_concats<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.num_concats = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `paddings` attribute.
    pub fn paddings<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.paddings = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute xla_concat_nd.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        inputs: &[&T0],
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "XlaConcatND")?;

        // Required input arguments
        let mut inputs_list = Vec::new();

        for t in inputs {
            inputs_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&inputs_list)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_concats {
            op.set_attr_int_list("num_concats", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.paddings {
            op.set_attr_int_list("paddings", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `XlaConcatND::new().call(&ctx, &inputs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/XlaConcatND>
pub fn xla_concat_nd<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    inputs: &[&T0],
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = XlaConcatND::new();
    op.call(ctx, inputs)
}

/// XlaHostCompute
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/XlaHostCompute>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct XlaHostCompute {
    Toutputs: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    ancestors: ::std::option::Option<::std::vec::Vec<::std::string::String>>,
    shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    shape_inference_graph: ::std::option::Option<::std::string::String>,
    key: ::std::option::Option<::std::string::String>,
    send_key: ::std::option::Option<::std::string::String>,
    recv_key: ::std::option::Option<::std::string::String>,
    cost_estimate_ns: ::std::option::Option<i64>,
    tpu_core: ::std::option::Option<i64>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for XlaHostCompute {
    fn default() -> Self {
        Self {
            Toutputs: None,
            ancestors: None,
            shapes: None,
            shape_inference_graph: None,
            key: None,
            send_key: None,
            recv_key: None,
            cost_estimate_ns: Some(1000000i64),
            tpu_core: Some(0i64),
            target_device_name: None,
        }
    }
}
impl XlaHostCompute {
    /// Creates a new `XlaHostCompute`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Toutputs` attribute.
    pub fn Toutputs<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Toutputs = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `ancestors` attribute.
    pub fn ancestors<ArgType: ::std::convert::Into<::std::vec::Vec<::std::string::String>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.ancestors = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shapes` attribute.
    pub fn shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shape_inference_graph` attribute.
    pub fn shape_inference_graph<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.shape_inference_graph = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `key` attribute.
    pub fn key<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.key = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `send_key` attribute.
    pub fn send_key<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.send_key = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `recv_key` attribute.
    pub fn recv_key<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.recv_key = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `cost_estimate_ns` attribute.
    pub fn cost_estimate_ns<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.cost_estimate_ns = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `tpu_core` attribute.
    pub fn tpu_core<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.tpu_core = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute xla_host_compute.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        inputs: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "XlaHostCompute")?;

        // Required input arguments
        op.add_input(&inputs.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Toutputs {
            op.set_attr_type_list("Toutputs", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.ancestors {
            op.set_attr_string_list("ancestors", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shapes {
            op.set_attr_shape_list("shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shape_inference_graph {
            op.set_attr_string("shape_inference_graph", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.key {
            op.set_attr_string("key", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.send_key {
            op.set_attr_string("send_key", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.recv_key {
            op.set_attr_string("recv_key", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.cost_estimate_ns {
            op.set_attr_int("cost_estimate_ns", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.tpu_core {
            op.set_attr_int("tpu_core", *value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `XlaHostCompute::new().call(&ctx, &inputs)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/XlaHostCompute>
pub fn xla_host_compute<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    inputs: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = XlaHostCompute::new();
    op.call(ctx, inputs)
}

/// XlaRecvFromHost
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/XlaRecvFromHost>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct XlaRecvFromHost {
    Toutput: ::std::option::Option<crate::DataType>,
    shape: ::std::option::Option<crate::Shape>,
    key: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for XlaRecvFromHost {
    fn default() -> Self {
        Self {
            Toutput: None,
            shape: None,
            key: None,
            target_device_name: None,
        }
    }
}
impl XlaRecvFromHost {
    /// Creates a new `XlaRecvFromHost`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `Toutput` attribute.
    pub fn Toutput<ArgType: ::std::convert::Into<crate::DataType>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.Toutput = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `shape` attribute.
    pub fn shape<ArgType: ::std::convert::Into<crate::Shape>>(mut self, value: ArgType) -> Self {
        self.shape = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `key` attribute.
    pub fn key<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.key = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute xla_recv_from_host.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "XlaRecvFromHost")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.Toutput {
            op.set_attr_type("Toutput", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.shape {
            op.set_attr_shape("shape", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.key {
            op.set_attr_string("key", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `XlaRecvFromHost::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/XlaRecvFromHost>
pub fn xla_recv_from_host<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = XlaRecvFromHost::new();
    op.call(ctx)
}

/// XlaRecvTPUEmbeddingActivations
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/XlaRecvTPUEmbeddingActivations>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct XlaRecvTPUEmbeddingActivations {
    num_tables: ::std::option::Option<i64>,
    config: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for XlaRecvTPUEmbeddingActivations {
    fn default() -> Self {
        Self {
            num_tables: None,
            config: None,
            target_device_name: None,
        }
    }
}
impl XlaRecvTPUEmbeddingActivations {
    /// Creates a new `XlaRecvTPUEmbeddingActivations`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `num_tables` attribute.
    pub fn num_tables<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.num_tables = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute xla_recv_tpuembedding_activations.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        deduplication_data: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "XlaRecvTPUEmbeddingActivations")?;

        // Required input arguments
        op.add_input(&deduplication_data.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.num_tables {
            op.set_attr_int("num_tables", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `XlaRecvTPUEmbeddingActivations::new().call(&ctx, &deduplication_data)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/XlaRecvTPUEmbeddingActivations>
pub fn xla_recv_tpuembedding_activations<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    deduplication_data: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = XlaRecvTPUEmbeddingActivations::new();
    op.call(ctx, deduplication_data)
}

/// XlaRecvTPUEmbeddingDeduplicationData
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/XlaRecvTPUEmbeddingDeduplicationData>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct XlaRecvTPUEmbeddingDeduplicationData {
    config: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for XlaRecvTPUEmbeddingDeduplicationData {
    fn default() -> Self {
        Self {
            config: None,
            target_device_name: None,
        }
    }
}
impl XlaRecvTPUEmbeddingDeduplicationData {
    /// Creates a new `XlaRecvTPUEmbeddingDeduplicationData`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute xla_recv_tpuembedding_deduplication_data.
    pub fn call<'a>(
        &self,
        ctx: &'a crate::eager::Context,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "XlaRecvTPUEmbeddingDeduplicationData")?;

        // Required input arguments

        // Attributes
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `XlaRecvTPUEmbeddingDeduplicationData::new().call(&ctx)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/XlaRecvTPUEmbeddingDeduplicationData>
pub fn xla_recv_tpuembedding_deduplication_data<'a>(
    ctx: &'a crate::eager::Context,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = XlaRecvTPUEmbeddingDeduplicationData::new();
    op.call(ctx)
}

/// XlaSendTPUEmbeddingGradients
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/XlaSendTPUEmbeddingGradients>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct XlaSendTPUEmbeddingGradients {
    config: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for XlaSendTPUEmbeddingGradients {
    fn default() -> Self {
        Self {
            config: None,
            target_device_name: None,
        }
    }
}
impl XlaSendTPUEmbeddingGradients {
    /// Creates a new `XlaSendTPUEmbeddingGradients`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `config` attribute.
    pub fn config<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.config = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute xla_send_tpuembedding_gradients.
    pub fn call<
        'a,
        T0: crate::eager::ToTensorHandle<'a>,
        T1: crate::eager::ToTensorHandle<'a>,
        T2: crate::eager::ToTensorHandle<'a>,
    >(
        &self,
        ctx: &'a crate::eager::Context,
        gradients: &[&T0],
        learning_rates: &[&T1],
        deduplication_data: &T2,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "XlaSendTPUEmbeddingGradients")?;

        // Required input arguments
        let mut gradients_list = Vec::new();

        for t in gradients {
            gradients_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&gradients_list)?;
        let mut learning_rates_list = Vec::new();

        for t in learning_rates {
            learning_rates_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&learning_rates_list)?;
        op.add_input(&deduplication_data.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.config {
            op.set_attr_string("config", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `XlaSendTPUEmbeddingGradients::new().call(&ctx, &gradients, &learning_rates, &deduplication_data)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/XlaSendTPUEmbeddingGradients>
pub fn xla_send_tpuembedding_gradients<
    'a,
    T0: crate::eager::ToTensorHandle<'a>,
    T1: crate::eager::ToTensorHandle<'a>,
    T2: crate::eager::ToTensorHandle<'a>,
>(
    ctx: &'a crate::eager::Context,
    gradients: &[&T0],
    learning_rates: &[&T1],
    deduplication_data: &T2,
) -> crate::Result<()> {
    let op = XlaSendTPUEmbeddingGradients::new();
    op.call(ctx, gradients, learning_rates, deduplication_data)
}

/// XlaSendToHost
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/XlaSendToHost>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct XlaSendToHost {
    key: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for XlaSendToHost {
    fn default() -> Self {
        Self {
            key: None,
            target_device_name: None,
        }
    }
}
impl XlaSendToHost {
    /// Creates a new `XlaSendToHost`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `key` attribute.
    pub fn key<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.key = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute xla_send_to_host.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<()> {
        // Define Op
        let mut op = super::Op::new(ctx, "XlaSendToHost")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.key {
            op.set_attr_string("key", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let _ = op.execute::<0>(ctx)?;
        Ok(())
    }
}

/// Shorthand for `XlaSendToHost::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/XlaSendToHost>
pub fn xla_send_to_host<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<()> {
    let op = XlaSendToHost::new();
    op.call(ctx, input)
}

/// XlaSplitND
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/XlaSplitND>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct XlaSplitND {
    N: ::std::option::Option<i64>,
    num_splits: ::std::option::Option<::std::vec::Vec<i64>>,
    paddings: ::std::option::Option<::std::vec::Vec<i64>>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for XlaSplitND {
    fn default() -> Self {
        Self {
            N: None,
            num_splits: None,
            paddings: Some(vec![]),
            target_device_name: None,
        }
    }
}
impl XlaSplitND {
    /// Creates a new `XlaSplitND`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `N` attribute.
    pub fn N<ArgType: ::std::convert::Into<i64>>(mut self, value: ArgType) -> Self {
        self.N = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `num_splits` attribute.
    pub fn num_splits<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.num_splits = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `paddings` attribute.
    pub fn paddings<ArgType: ::std::convert::Into<::std::vec::Vec<i64>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.paddings = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute xla_split_nd.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "XlaSplitND")?;

        // Required input arguments
        op.add_input(&input.to_handle(ctx)?)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.N {
            op.set_attr_int("N", *value)?;
        }
        if let ::std::option::Option::Some(value) = &self.num_splits {
            op.set_attr_int_list("num_splits", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.paddings {
            op.set_attr_int_list("paddings", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `XlaSplitND::new().call(&ctx, &input)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/XlaSplitND>
pub fn xla_split_nd<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = XlaSplitND::new();
    op.call(ctx, input)
}

/// Xlog1py
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Xlog1py>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Xlog1py {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Xlog1py {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Xlog1py {
    /// Creates a new `Xlog1py`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute xlog1py.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Xlog1py")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Xlog1py::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Xlog1py>
pub fn xlog1py<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Xlog1py::new();
    op.call(ctx, x, y)
}

/// Xlogy
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Xlogy>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Xlogy {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Xlogy {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Xlogy {
    /// Creates a new `Xlogy`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute xlogy.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        y: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Xlogy")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&y.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Xlogy::new().call(&ctx, &x, &y)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Xlogy>
pub fn xlogy<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    y: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Xlogy::new();
    op.call(ctx, x, y)
}

/// ZerosLike
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ZerosLike>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ZerosLike {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ZerosLike {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl ZerosLike {
    /// Creates a new `ZerosLike`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute zeros_like.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ZerosLike")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ZerosLike::new().call(&ctx, &x)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ZerosLike>
pub fn zeros_like<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ZerosLike::new();
    op.call(ctx, x)
}

/// Zeta
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Zeta>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct Zeta {
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for Zeta {
    fn default() -> Self {
        Self {
            target_device_name: None,
        }
    }
}
impl Zeta {
    /// Creates a new `Zeta`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute zeta.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        x: &T0,
        q: &T1,
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "Zeta")?;

        // Required input arguments
        op.add_input(&x.to_handle(ctx)?)?;
        op.add_input(&q.to_handle(ctx)?)?;

        // Attributes

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `Zeta::new().call(&ctx, &x, &q)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/Zeta>
pub fn zeta<'a, T0: crate::eager::ToTensorHandle<'a>, T1: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    x: &T0,
    q: &T1,
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = Zeta::new();
    op.call(ctx, x, q)
}

/// ZipDataset
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ZipDataset>
#[derive(::std::fmt::Debug, ::std::clone::Clone)]
pub struct ZipDataset {
    output_types: ::std::option::Option<::std::vec::Vec<crate::DataType>>,
    output_shapes: ::std::option::Option<::std::vec::Vec<crate::Shape>>,
    metadata: ::std::option::Option<::std::string::String>,
    /// (Rust wrapper specific) A device name where this op will be executed
    target_device_name: ::std::option::Option<::std::string::String>,
}
impl ::std::default::Default for ZipDataset {
    fn default() -> Self {
        Self {
            output_types: None,
            output_shapes: None,
            metadata: None,
            target_device_name: None,
        }
    }
}
impl ZipDataset {
    /// Creates a new `ZipDataset`.
    pub fn new() -> Self {
        Self::default()
    }

    /// Sets the `output_types` attribute.
    pub fn output_types<ArgType: ::std::convert::Into<::std::vec::Vec<crate::DataType>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_types = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `output_shapes` attribute.
    pub fn output_shapes<ArgType: ::std::convert::Into<::std::vec::Vec<crate::Shape>>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.output_shapes = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `metadata` attribute.
    pub fn metadata<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.metadata = ::std::option::Option::Some(value.into());
        self
    }

    /// Sets the `` attribute.
    pub fn target_device_name<ArgType: ::std::convert::Into<::std::string::String>>(
        mut self,
        value: ArgType,
    ) -> Self {
        self.target_device_name = ::std::option::Option::Some(value.into());
        self
    }

    /// Execute zip_dataset.
    pub fn call<'a, T0: crate::eager::ToTensorHandle<'a>>(
        &self,
        ctx: &'a crate::eager::Context,
        input_datasets: &[&T0],
    ) -> crate::Result<crate::eager::TensorHandle<'a>> {
        // Define Op
        let mut op = super::Op::new(ctx, "ZipDataset")?;

        // Required input arguments
        let mut input_datasets_list = Vec::new();

        for t in input_datasets {
            input_datasets_list.push(t.to_handle(ctx)?);
        }

        op.add_input_list(&input_datasets_list)?;

        // Attributes
        if let ::std::option::Option::Some(value) = &self.output_types {
            op.set_attr_type_list("output_types", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.output_shapes {
            op.set_attr_shape_list("output_shapes", value)?;
        }
        if let ::std::option::Option::Some(value) = &self.metadata {
            op.set_attr_string("metadata", value)?;
        }

        // Set the device name where this Op will be executed
        if let ::std::option::Option::Some(value) = &self.target_device_name {
            op.set_device(value)?;
        }
        // Execute Op
        let [h] = op.execute::<1>(ctx)?;
        Ok(h)
    }
}

/// Shorthand for `ZipDataset::new().call(&ctx, &input_datasets)`.
///
/// See : <https://www.tensorflow.org/api_docs/python/tf/raw_ops/ZipDataset>
pub fn zip_dataset<'a, T0: crate::eager::ToTensorHandle<'a>>(
    ctx: &'a crate::eager::Context,
    input_datasets: &[&T0],
) -> crate::Result<crate::eager::TensorHandle<'a>> {
    let op = ZipDataset::new();
    op.call(ctx, input_datasets)
}
